/* Color.c generated by valac 0.56.17, the Vala compiler
 * generated from Color.vala, do not modify */

/*
 * Copyright 2019-2021 elementary, Inc. (https://elementary.io)
 * Copyright 2011–2013 Robert Dyer
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "gala.h"
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_DRAWING_COLOR_0_PROPERTY,
	GALA_DRAWING_COLOR_NUM_PROPERTIES
};
static GParamSpec* gala_drawing_color_properties[GALA_DRAWING_COLOR_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

static gpointer gala_drawing_color_parent_class = NULL;
static GraniteServicesSettingsSerializableIface * gala_drawing_color_granite_services_settings_serializable_parent_iface = NULL;

static void gala_drawing_color_set_from_rgba (GalaDrawingColor* self,
                                       GdkRGBA* color);
static void gala_drawing_color_rgb_to_hsv (GalaDrawingColor* self,
                                    gdouble r,
                                    gdouble g,
                                    gdouble b,
                                    gdouble* h,
                                    gdouble* s,
                                    gdouble* v);
static void gala_drawing_color_hsv_to_rgb (GalaDrawingColor* self,
                                    gdouble h,
                                    gdouble s,
                                    gdouble v,
                                    gdouble* r,
                                    gdouble* g,
                                    gdouble* b);
static gchar* gala_drawing_color_real_settings_serialize (GraniteServicesSettingsSerializable* base);
static void gala_drawing_color_real_settings_deserialize (GraniteServicesSettingsSerializable* base,
                                                   const gchar* s);
static void gala_drawing_color_finalize (GObject * obj);
static GType gala_drawing_color_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
        * Extracts the alpha value from the integer value
        * serialized by {@link Gala.Drawing.Color.to_int}.
        *
        * @return the alpha channel value as a uint8 ranging from 0 - 255.
        */
guint8
gala_drawing_color_alpha_from_int (gint color)
{
	guint8 result;
#line 43 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 24) & 0xFF);
#line 43 "../lib/Drawing/Color.vala"
	return result;
#line 86 "Color.c"
}

/**
        * Extracts the red value from the integer value
        * serialized by {@link Gala.Drawing.Color.to_int}.
        *
        * @return the red channel value as a uint8 ranging from 0 - 255.
        */
guint8
gala_drawing_color_red_from_int (gint color)
{
	guint8 result;
#line 53 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 16) & 0xFF);
#line 53 "../lib/Drawing/Color.vala"
	return result;
#line 103 "Color.c"
}

/**
        * Extracts the green value from the integer value
        * serialized by {@link Gala.Drawing.Color.to_int}.
        *
        * @return the green channel value as a uint8 ranging from 0 - 255.
        */
guint8
gala_drawing_color_green_from_int (gint color)
{
	guint8 result;
#line 63 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 8) & 0xFF);
#line 63 "../lib/Drawing/Color.vala"
	return result;
#line 120 "Color.c"
}

/**
        * Extracts the blue value from the integer value
        * serialized by {@link Gala.Drawing.Color.to_int}.
        *
        * @return the blue channel value as a uint8 ranging from 0 - 255.
        */
guint8
gala_drawing_color_blue_from_int (gint color)
{
	guint8 result;
#line 73 "../lib/Drawing/Color.vala"
	result = (guint8) (color & 0xFF);
#line 73 "../lib/Drawing/Color.vala"
	return result;
#line 137 "Color.c"
}

/**
        * Constructs a new {@link Gala.Drawing.Color} with the supplied values.
        *
        * @param R the value of the red channel as a double
        * @param G the value of the green channel as a double
        * @param B the value of the blue channel as a double
        * @param A the value of the alpha channel as a double
        */
GalaDrawingColor*
gala_drawing_color_construct (GType object_type,
                              gdouble R,
                              gdouble G,
                              gdouble B,
                              gdouble A)
{
	GalaDrawingColor * self = NULL;
#line 84 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) g_object_new (object_type, NULL);
#line 85 "../lib/Drawing/Color.vala"
	self->R = R;
#line 86 "../lib/Drawing/Color.vala"
	self->G = G;
#line 87 "../lib/Drawing/Color.vala"
	self->B = B;
#line 88 "../lib/Drawing/Color.vala"
	self->A = A;
#line 84 "../lib/Drawing/Color.vala"
	return self;
#line 168 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_new (gdouble R,
                        gdouble G,
                        gdouble B,
                        gdouble A)
{
#line 84 "../lib/Drawing/Color.vala"
	return gala_drawing_color_construct (GALA_DRAWING_TYPE_COLOR, R, G, B, A);
#line 179 "Color.c"
}

/**
        * Constructs a new {@link Gala.Drawing.Color} from a {@link Gdk.RGBA}.
        *
        * @param color the {@link Gdk.RGBA}
        */
GalaDrawingColor*
gala_drawing_color_construct_from_rgba (GType object_type,
                                        GdkRGBA* color)
{
	GalaDrawingColor * self = NULL;
	GdkRGBA _tmp0_;
#line 96 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 96 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) g_object_new (object_type, NULL);
#line 97 "../lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 97 "../lib/Drawing/Color.vala"
	gala_drawing_color_set_from_rgba (self, &_tmp0_);
#line 96 "../lib/Drawing/Color.vala"
	return self;
#line 203 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_new_from_rgba (GdkRGBA* color)
{
#line 96 "../lib/Drawing/Color.vala"
	return gala_drawing_color_construct_from_rgba (GALA_DRAWING_TYPE_COLOR, color);
#line 211 "Color.c"
}

/**
        * Constructs a new {@link Gala.Drawing.Color} from a string.
        *
        * The string can be either one of:
        *
        * * A standard name (Taken from the X11 rgb.txt file).
        * * A hexadecimal value in the form “#rgb”, “#rrggbb”, “#rrrgggbbb” or ”#rrrrggggbbbb”
        * * A RGB color in the form “rgb(r,g,b)” (In this case the color will have full opacity)
        * * A RGBA color in the form “rgba(r,g,b,a)”
        *
        * For more details on formatting and how this function works see {@link Gdk.RGBA.parse}
        *
        * @param color the string specifying the color
        */
GalaDrawingColor*
gala_drawing_color_construct_from_string (GType object_type,
                                          const gchar* color)
{
	GalaDrawingColor * self = NULL;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_;
#line 114 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 114 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) g_object_new (object_type, NULL);
#line 115 "../lib/Drawing/Color.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 116 "../lib/Drawing/Color.vala"
	gdk_rgba_parse (&rgba, color);
#line 117 "../lib/Drawing/Color.vala"
	_tmp0_ = rgba;
#line 117 "../lib/Drawing/Color.vala"
	gala_drawing_color_set_from_rgba (self, &_tmp0_);
#line 114 "../lib/Drawing/Color.vala"
	return self;
#line 249 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_new_from_string (const gchar* color)
{
#line 114 "../lib/Drawing/Color.vala"
	return gala_drawing_color_construct_from_string (GALA_DRAWING_TYPE_COLOR, color);
#line 257 "Color.c"
}

/**
        * Constructs a new {@link Gala.Drawing.Color} from an integer.
        *
        * This constructor should be used when deserializing the previously serialized
        * color by {@link Gala.Drawing.Color.to_int}.
        *
        * For more details on what format the color integer representation has, see {@link Gala.Drawing.Color.to_int}.
        *
        * If you would like to deserialize the A, R, G and B values from the integer without
        * creating a new instance of {@link Gala.Drawing.Color}, you can use the available
        * //*_from_int// static method collection such as {@link Gala.Drawing.Color.alpha_from_int}.
        *
        * @param color the integer specyfying the color
        */
GalaDrawingColor*
gala_drawing_color_construct_from_int (GType object_type,
                                       gint color)
{
	GalaDrawingColor * self = NULL;
#line 134 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) g_object_new (object_type, NULL);
#line 135 "../lib/Drawing/Color.vala"
	self->R = ((gdouble) gala_drawing_color_red_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 136 "../lib/Drawing/Color.vala"
	self->G = ((gdouble) gala_drawing_color_green_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 137 "../lib/Drawing/Color.vala"
	self->B = ((gdouble) gala_drawing_color_blue_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 138 "../lib/Drawing/Color.vala"
	self->A = ((gdouble) gala_drawing_color_alpha_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 134 "../lib/Drawing/Color.vala"
	return self;
#line 291 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_new_from_int (gint color)
{
#line 134 "../lib/Drawing/Color.vala"
	return gala_drawing_color_construct_from_int (GALA_DRAWING_TYPE_COLOR, color);
#line 299 "Color.c"
}

/**
        * Changes the hue of this color to the supplied one.
        *
        * @param hue the hue to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 154 "../lib/Drawing/Color.vala"
	return self ? g_object_ref (self) : NULL;
#line 314 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_set_hue (GalaDrawingColor* self,
                            gdouble hue)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 148 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((hue >= ((gdouble) 0)) && (hue <= ((gdouble) 360)), "hue >= 0 && hue <= 360", NULL);
#line 150 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 150 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 150 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 150 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 151 "../lib/Drawing/Color.vala"
	h = hue;
#line 152 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 152 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 152 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 152 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 154 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 154 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 154 "../lib/Drawing/Color.vala"
	return result;
#line 360 "Color.c"
}

/**
        * Changes the saturation of this color to the supplied one.
        *
        * @param sat the saturation to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_sat (GalaDrawingColor* self,
                            gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 164 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 166 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 166 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 166 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 166 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 167 "../lib/Drawing/Color.vala"
	s = sat;
#line 168 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 168 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 168 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 168 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 170 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 170 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 170 "../lib/Drawing/Color.vala"
	return result;
#line 413 "Color.c"
}

/**
        * Changes the value of this color to the supplied one.
        *
        * @param val the value to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_val (GalaDrawingColor* self,
                            gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 180 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 180 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 182 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 182 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 182 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 182 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 183 "../lib/Drawing/Color.vala"
	v = val;
#line 184 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 184 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 184 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 184 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 186 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 186 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 186 "../lib/Drawing/Color.vala"
	return result;
#line 466 "Color.c"
}

/**
        * Changes the value of the alpha channel.
        *
        * @param alpha the value of the alpha channel
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_alpha (GalaDrawingColor* self,
                              gdouble alpha)
{
	GalaDrawingColor* _tmp0_;
	GalaDrawingColor* result;
#line 196 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 196 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((alpha >= ((gdouble) 0)) && (alpha <= ((gdouble) 1)), "alpha >= 0 && alpha <= 1", NULL);
#line 197 "../lib/Drawing/Color.vala"
	self->A = alpha;
#line 198 "../lib/Drawing/Color.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 198 "../lib/Drawing/Color.vala"
	result = _tmp0_;
#line 198 "../lib/Drawing/Color.vala"
	return result;
#line 494 "Color.c"
}

/**
        * Get the value.
        * @return the hue of this color, as a double value
        */
gdouble
gala_drawing_color_get_hue (GalaDrawingColor* self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 205 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 207 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 207 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 207 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 207 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 208 "../lib/Drawing/Color.vala"
	result = h;
#line 208 "../lib/Drawing/Color.vala"
	return result;
#line 525 "Color.c"
}

/**
        * Get the value.
        * @return the saturation of this color, as a double value
        */
gdouble
gala_drawing_color_get_sat (GalaDrawingColor* self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 215 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 217 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 217 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 217 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 217 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 218 "../lib/Drawing/Color.vala"
	result = s;
#line 218 "../lib/Drawing/Color.vala"
	return result;
#line 556 "Color.c"
}

/**
        * Get the value.
        *
        * @return the value of this color, as a double value
        */
gdouble
gala_drawing_color_get_val (GalaDrawingColor* self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 226 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 228 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 228 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 228 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 228 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 229 "../lib/Drawing/Color.vala"
	result = v;
#line 229 "../lib/Drawing/Color.vala"
	return result;
#line 588 "Color.c"
}

/**
        * Adds the supplied hue value to this color's hue value.
        *
        * @param val the hue to add to this color's hue
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_add_hue (GalaDrawingColor* self,
                            gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 239 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 241 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 241 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 241 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 242 "../lib/Drawing/Color.vala"
	h = fmod (fmod (h + val, 360) + 360, 360);
#line 243 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 243 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 243 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 243 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 245 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 245 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 245 "../lib/Drawing/Color.vala"
	return result;
#line 639 "Color.c"
}

/**
        * Changes this color's saturation to the supplied saturation, if it is greater than this color's saturation.
        *
        * @param sat the saturation to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_min_sat (GalaDrawingColor* self,
                                gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 255 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 255 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 257 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 257 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 257 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 257 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 258 "../lib/Drawing/Color.vala"
	s = MAX (s, sat);
#line 259 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 259 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 259 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 259 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 261 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 261 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 261 "../lib/Drawing/Color.vala"
	return result;
#line 692 "Color.c"
}

/**
        * Changes this color's value to the supplied value, if it is greater than this color's value.
        *
        * @param val the value to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_min_value (GalaDrawingColor* self,
                                  gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 271 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 271 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 273 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 273 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 273 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 273 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 274 "../lib/Drawing/Color.vala"
	v = MAX (v, val);
#line 275 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 275 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 275 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 275 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 277 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 277 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 277 "../lib/Drawing/Color.vala"
	return result;
#line 745 "Color.c"
}

/**
        * Changes this color's saturation to the supplied saturation, if it is smaller than this color's saturation.
        *
        * @param sat the hue to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_max_sat (GalaDrawingColor* self,
                                gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 287 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 287 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 289 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 289 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 289 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 289 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 290 "../lib/Drawing/Color.vala"
	s = MIN (s, sat);
#line 291 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 291 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 291 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 291 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 293 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 293 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 293 "../lib/Drawing/Color.vala"
	return result;
#line 798 "Color.c"
}

/**
        * Changes this color's value to the supplied value, if it is smaller than this color's value.
        *
        * @param val the value to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_max_val (GalaDrawingColor* self,
                                gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 303 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 303 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 305 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 305 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 305 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 305 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 306 "../lib/Drawing/Color.vala"
	v = MIN (v, val);
#line 307 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 307 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 307 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 307 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 309 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 309 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 309 "../lib/Drawing/Color.vala"
	return result;
#line 851 "Color.c"
}

/**
        * Multiplies this color's saturation by the supplied amount.
        *
        * @param amount the amount to multiply the saturation by
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_multiply_sat (GalaDrawingColor* self,
                                 gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 319 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 319 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail (amount >= ((gdouble) 0), "amount >= 0", NULL);
#line 321 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 321 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 321 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 321 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 322 "../lib/Drawing/Color.vala"
	s = MIN ((gdouble) 1, s * amount);
#line 323 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 323 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 323 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 323 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 325 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 325 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 325 "../lib/Drawing/Color.vala"
	return result;
#line 904 "Color.c"
}

/**
        * Brightens this color's value by the supplied amount.
        *
        * @param amount the amount to brighten the value by
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_brighten_val (GalaDrawingColor* self,
                                 gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 335 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 335 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 337 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 337 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 337 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 337 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 338 "../lib/Drawing/Color.vala"
	v = MIN ((gdouble) 1, v + ((1 - v) * amount));
#line 339 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 339 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 339 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 339 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 341 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 341 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 341 "../lib/Drawing/Color.vala"
	return result;
#line 957 "Color.c"
}

/**
        * Darkens this color's value by the supplied amount.
        *
        * @param amount the amount to darken the value by
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_darken_val (GalaDrawingColor* self,
                               gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 351 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 351 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 353 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 353 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 353 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 353 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 354 "../lib/Drawing/Color.vala"
	v = MAX ((gdouble) 0, v - ((1 - v) * amount));
#line 355 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 355 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 355 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 355 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 357 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 357 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 357 "../lib/Drawing/Color.vala"
	return result;
#line 1010 "Color.c"
}

/**
        * Darkens this color's value by the supplied amount * color's saturation.
        *
        * @param amount the amount to darken the value by
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_darken_by_sat (GalaDrawingColor* self,
                                  gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 367 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 367 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 369 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 369 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 369 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 369 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 370 "../lib/Drawing/Color.vala"
	v = MAX ((gdouble) 0, v - (amount * s));
#line 371 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 371 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 371 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 371 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 373 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 373 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 373 "../lib/Drawing/Color.vala"
	return result;
#line 1063 "Color.c"
}

static void
gala_drawing_color_rgb_to_hsv (GalaDrawingColor* self,
                               gdouble r,
                               gdouble g,
                               gdouble b,
                               gdouble* h,
                               gdouble* s,
                               gdouble* v)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble min = 0.0;
	gdouble max = 0.0;
	gdouble delta = 0.0;
#line 376 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 376 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((r >= ((gdouble) 0)) && (r <= ((gdouble) 1)), "r >= 0 && r <= 1");
#line 376 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((g >= ((gdouble) 0)) && (g <= ((gdouble) 1)), "g >= 0 && g <= 1");
#line 376 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((b >= ((gdouble) 0)) && (b <= ((gdouble) 1)), "b >= 0 && b <= 1");
#line 379 "../lib/Drawing/Color.vala"
	min = MIN (r, MIN (g, b));
#line 380 "../lib/Drawing/Color.vala"
	max = MAX (r, MAX (g, b));
#line 382 "../lib/Drawing/Color.vala"
	_vala_v = max;
#line 383 "../lib/Drawing/Color.vala"
	if (_vala_v == ((gdouble) 0)) {
#line 384 "../lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 385 "../lib/Drawing/Color.vala"
		_vala_s = (gdouble) 0;
#line 386 "../lib/Drawing/Color.vala"
		if (h) {
#line 386 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1105 "Color.c"
		}
#line 386 "../lib/Drawing/Color.vala"
		if (s) {
#line 386 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1111 "Color.c"
		}
#line 386 "../lib/Drawing/Color.vala"
		if (v) {
#line 386 "../lib/Drawing/Color.vala"
			*v = _vala_v;
#line 1117 "Color.c"
		}
#line 386 "../lib/Drawing/Color.vala"
		return;
#line 1121 "Color.c"
	}
#line 390 "../lib/Drawing/Color.vala"
	r = r / _vala_v;
#line 391 "../lib/Drawing/Color.vala"
	g = g / _vala_v;
#line 392 "../lib/Drawing/Color.vala"
	b = b / _vala_v;
#line 394 "../lib/Drawing/Color.vala"
	min = MIN (r, MIN (g, b));
#line 395 "../lib/Drawing/Color.vala"
	max = MAX (r, MAX (g, b));
#line 397 "../lib/Drawing/Color.vala"
	delta = max - min;
#line 398 "../lib/Drawing/Color.vala"
	_vala_s = delta;
#line 399 "../lib/Drawing/Color.vala"
	if (_vala_s == ((gdouble) 0)) {
#line 400 "../lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 401 "../lib/Drawing/Color.vala"
		if (h) {
#line 401 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1145 "Color.c"
		}
#line 401 "../lib/Drawing/Color.vala"
		if (s) {
#line 401 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1151 "Color.c"
		}
#line 401 "../lib/Drawing/Color.vala"
		if (v) {
#line 401 "../lib/Drawing/Color.vala"
			*v = _vala_v;
#line 1157 "Color.c"
		}
#line 401 "../lib/Drawing/Color.vala"
		return;
#line 1161 "Color.c"
	}
#line 405 "../lib/Drawing/Color.vala"
	r = (r - min) / delta;
#line 406 "../lib/Drawing/Color.vala"
	g = (g - min) / delta;
#line 407 "../lib/Drawing/Color.vala"
	b = (b - min) / delta;
#line 409 "../lib/Drawing/Color.vala"
	if (max == r) {
#line 410 "../lib/Drawing/Color.vala"
		_vala_h = 0 + (60 * (g - b));
#line 411 "../lib/Drawing/Color.vala"
		if (_vala_h < ((gdouble) 0)) {
#line 412 "../lib/Drawing/Color.vala"
			_vala_h = _vala_h + 360;
#line 1177 "Color.c"
		}
	} else {
#line 413 "../lib/Drawing/Color.vala"
		if (max == g) {
#line 414 "../lib/Drawing/Color.vala"
			_vala_h = 120 + (60 * (b - r));
#line 1184 "Color.c"
		} else {
#line 416 "../lib/Drawing/Color.vala"
			_vala_h = 240 + (60 * (r - g));
#line 1188 "Color.c"
		}
	}
#line 376 "../lib/Drawing/Color.vala"
	if (h) {
#line 376 "../lib/Drawing/Color.vala"
		*h = _vala_h;
#line 1195 "Color.c"
	}
#line 376 "../lib/Drawing/Color.vala"
	if (s) {
#line 376 "../lib/Drawing/Color.vala"
		*s = _vala_s;
#line 1201 "Color.c"
	}
#line 376 "../lib/Drawing/Color.vala"
	if (v) {
#line 376 "../lib/Drawing/Color.vala"
		*v = _vala_v;
#line 1207 "Color.c"
	}
}

static void
gala_drawing_color_hsv_to_rgb (GalaDrawingColor* self,
                               gdouble h,
                               gdouble s,
                               gdouble v,
                               gdouble* r,
                               gdouble* g,
                               gdouble* b)
{
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
#line 420 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 420 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((h >= ((gdouble) 0)) && (h <= ((gdouble) 360)), "h >= 0 && h <= 360");
#line 420 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((s >= ((gdouble) 0)) && (s <= ((gdouble) 1)), "s >= 0 && s <= 1");
#line 420 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((v >= ((gdouble) 0)) && (v <= ((gdouble) 1)), "v >= 0 && v <= 1");
#line 423 "../lib/Drawing/Color.vala"
	_vala_r = (gdouble) 0;
#line 424 "../lib/Drawing/Color.vala"
	_vala_g = (gdouble) 0;
#line 425 "../lib/Drawing/Color.vala"
	_vala_b = (gdouble) 0;
#line 427 "../lib/Drawing/Color.vala"
	if (s == ((gdouble) 0)) {
#line 428 "../lib/Drawing/Color.vala"
		_vala_r = v;
#line 429 "../lib/Drawing/Color.vala"
		_vala_g = v;
#line 430 "../lib/Drawing/Color.vala"
		_vala_b = v;
#line 1245 "Color.c"
	} else {
		gint sec_num = 0;
		gdouble frac_sec = 0.0;
		gdouble p = 0.0;
		gdouble q = 0.0;
		gdouble t = 0.0;
#line 432 "../lib/Drawing/Color.vala"
		sec_num = (gint) floor (h / 60);
#line 433 "../lib/Drawing/Color.vala"
		frac_sec = (h / 60.0) - sec_num;
#line 435 "../lib/Drawing/Color.vala"
		p = v * (1 - s);
#line 436 "../lib/Drawing/Color.vala"
		q = v * (1 - (s * frac_sec));
#line 437 "../lib/Drawing/Color.vala"
		t = v * (1 - (s * (1 - frac_sec)));
#line 439 "../lib/Drawing/Color.vala"
		switch (sec_num) {
#line 439 "../lib/Drawing/Color.vala"
			case 0:
#line 1266 "Color.c"
			{
#line 441 "../lib/Drawing/Color.vala"
				_vala_r = v;
#line 442 "../lib/Drawing/Color.vala"
				_vala_g = t;
#line 443 "../lib/Drawing/Color.vala"
				_vala_b = p;
#line 444 "../lib/Drawing/Color.vala"
				break;
#line 1276 "Color.c"
			}
#line 439 "../lib/Drawing/Color.vala"
			case 1:
#line 1280 "Color.c"
			{
#line 446 "../lib/Drawing/Color.vala"
				_vala_r = q;
#line 447 "../lib/Drawing/Color.vala"
				_vala_g = v;
#line 448 "../lib/Drawing/Color.vala"
				_vala_b = p;
#line 449 "../lib/Drawing/Color.vala"
				break;
#line 1290 "Color.c"
			}
#line 439 "../lib/Drawing/Color.vala"
			case 2:
#line 1294 "Color.c"
			{
#line 451 "../lib/Drawing/Color.vala"
				_vala_r = p;
#line 452 "../lib/Drawing/Color.vala"
				_vala_g = v;
#line 453 "../lib/Drawing/Color.vala"
				_vala_b = t;
#line 454 "../lib/Drawing/Color.vala"
				break;
#line 1304 "Color.c"
			}
#line 439 "../lib/Drawing/Color.vala"
			case 3:
#line 1308 "Color.c"
			{
#line 456 "../lib/Drawing/Color.vala"
				_vala_r = p;
#line 457 "../lib/Drawing/Color.vala"
				_vala_g = q;
#line 458 "../lib/Drawing/Color.vala"
				_vala_b = v;
#line 459 "../lib/Drawing/Color.vala"
				break;
#line 1318 "Color.c"
			}
#line 439 "../lib/Drawing/Color.vala"
			case 4:
#line 1322 "Color.c"
			{
#line 461 "../lib/Drawing/Color.vala"
				_vala_r = t;
#line 462 "../lib/Drawing/Color.vala"
				_vala_g = p;
#line 463 "../lib/Drawing/Color.vala"
				_vala_b = v;
#line 464 "../lib/Drawing/Color.vala"
				break;
#line 1332 "Color.c"
			}
#line 439 "../lib/Drawing/Color.vala"
			case 5:
#line 1336 "Color.c"
			{
#line 466 "../lib/Drawing/Color.vala"
				_vala_r = v;
#line 467 "../lib/Drawing/Color.vala"
				_vala_g = p;
#line 468 "../lib/Drawing/Color.vala"
				_vala_b = q;
#line 469 "../lib/Drawing/Color.vala"
				break;
#line 1346 "Color.c"
			}
			default:
#line 439 "../lib/Drawing/Color.vala"
			break;
#line 1351 "Color.c"
		}
	}
#line 420 "../lib/Drawing/Color.vala"
	if (r) {
#line 420 "../lib/Drawing/Color.vala"
		*r = _vala_r;
#line 1358 "Color.c"
	}
#line 420 "../lib/Drawing/Color.vala"
	if (g) {
#line 420 "../lib/Drawing/Color.vala"
		*g = _vala_g;
#line 1364 "Color.c"
	}
#line 420 "../lib/Drawing/Color.vala"
	if (b) {
#line 420 "../lib/Drawing/Color.vala"
		*b = _vala_b;
#line 1370 "Color.c"
	}
}

/**
        * {@inheritDoc}
        */
static gchar*
gala_drawing_color_real_settings_serialize (GraniteServicesSettingsSerializable* base)
{
	GalaDrawingColor * self;
	gchar* _tmp0_;
	gchar* result;
#line 477 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) base;
#line 478 "../lib/Drawing/Color.vala"
	_tmp0_ = g_strdup_printf ("%d;;%d;;%d;;%d", (gint) (self->R * G_MAXUINT8), (gint) (self->G * G_MAXUINT8), (gint) (self->B * G_MAXUINT8), (gint) (self->A * G_MAXUINT8));
#line 478 "../lib/Drawing/Color.vala"
	result = _tmp0_;
#line 478 "../lib/Drawing/Color.vala"
	return result;
#line 1391 "Color.c"
}

/**
        * {@inheritDoc}
        */
static void
gala_drawing_color_real_settings_deserialize (GraniteServicesSettingsSerializable* base,
                                              const gchar* s)
{
	GalaDrawingColor * self;
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 487 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) base;
#line 487 "../lib/Drawing/Color.vala"
	g_return_if_fail (s != NULL);
#line 488 "../lib/Drawing/Color.vala"
	_tmp1_ = _tmp0_ = g_strsplit (s, ";;", 0);
#line 488 "../lib/Drawing/Color.vala"
	parts = _tmp1_;
#line 488 "../lib/Drawing/Color.vala"
	parts_length1 = _vala_array_length (_tmp0_);
#line 488 "../lib/Drawing/Color.vala"
	_parts_size_ = parts_length1;
#line 490 "../lib/Drawing/Color.vala"
	_tmp2_ = parts[0];
#line 490 "../lib/Drawing/Color.vala"
	self->R = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp2_))) / G_MAXUINT8;
#line 491 "../lib/Drawing/Color.vala"
	_tmp3_ = parts[1];
#line 491 "../lib/Drawing/Color.vala"
	self->G = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp3_))) / G_MAXUINT8;
#line 492 "../lib/Drawing/Color.vala"
	_tmp4_ = parts[2];
#line 492 "../lib/Drawing/Color.vala"
	self->B = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp4_))) / G_MAXUINT8;
#line 493 "../lib/Drawing/Color.vala"
	_tmp5_ = parts[3];
#line 493 "../lib/Drawing/Color.vala"
	self->A = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp5_))) / G_MAXUINT8;
#line 487 "../lib/Drawing/Color.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1441 "Color.c"
}

/**
        * Returns a textual specification of this in the form `rgb (r, g, b)` or `rgba (r, g, b, a)`,
        * where “r”, “g”, “b” and “a” represent the red, green, blue and alpha values respectively.
        *
        * r, g, and b are represented as integers in the range 0 to 255, and a is represented as
        * floating point value in the range 0 to 1.
        *
        * Note: that this string representation may lose some precision, since r, g and b are represented
        * as 8-bit integers. If this is a concern, you should use a different representation.
        *
        * This returns the same string as a {@link Gdk.RGBA} would return in {@link Gdk.RGBA.to_string}
        *
        * @return the text string
        */
gchar*
gala_drawing_color_to_string (GalaDrawingColor* self)
{
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_ = {0};
	gchar* _tmp1_;
	gchar* result;
#line 510 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 511 "../lib/Drawing/Color.vala"
	_tmp0_.red = (gdouble) ((gfloat) self->R);
#line 511 "../lib/Drawing/Color.vala"
	_tmp0_.green = (gdouble) ((gfloat) self->G);
#line 511 "../lib/Drawing/Color.vala"
	_tmp0_.blue = (gdouble) ((gfloat) self->B);
#line 511 "../lib/Drawing/Color.vala"
	_tmp0_.alpha = (gdouble) ((gfloat) self->A);
#line 511 "../lib/Drawing/Color.vala"
	rgba = _tmp0_;
#line 512 "../lib/Drawing/Color.vala"
	_tmp1_ = gdk_rgba_to_string (&rgba);
#line 512 "../lib/Drawing/Color.vala"
	result = _tmp1_;
#line 512 "../lib/Drawing/Color.vala"
	return result;
#line 1483 "Color.c"
}

/**
        * Converts this to a 32 bit integer.
        *
        * This function can be useful for serializing the color so that it can be stored
        * and retrieved easily with hash tables and lists.
        *
        * The returned integer will contain the four channels
        * that define the {@link Gala.Drawing.Color} class: alpha, red, green and blue.
        *
        * Each channel is represented by 8 bits.
        * The first 8 bits of the integer conatin the alpha channel while all other 24 bits represent
        * red, green and blue channels respectively.
        *
        * The format written as a string would look like this:
        *
        * //AAAAAAAA RRRRRRRR GGGGGGGG BBBBBBBB//
        *
        * where //A// is one bit of alpha chnnel, //R// of red channel, //G// of green channel and //B// of blue channel.
        *
        * @return a 32 bit integer representing this
        */
gint
gala_drawing_color_to_int (GalaDrawingColor* self)
{
	guint8 red = 0U;
	guint8 green = 0U;
	guint8 blue = 0U;
	guint8 alpha = 0U;
	gint result;
#line 536 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 537 "../lib/Drawing/Color.vala"
	red = (guint8) (self->R * G_MAXUINT8);
#line 538 "../lib/Drawing/Color.vala"
	green = (guint8) (self->G * G_MAXUINT8);
#line 539 "../lib/Drawing/Color.vala"
	blue = (guint8) (self->B * G_MAXUINT8);
#line 540 "../lib/Drawing/Color.vala"
	alpha = (guint8) (self->A * G_MAXUINT8);
#line 542 "../lib/Drawing/Color.vala"
	result = (((alpha << 24) | (red << 16)) | (green << 8)) | blue;
#line 542 "../lib/Drawing/Color.vala"
	return result;
#line 1529 "Color.c"
}

static void
gala_drawing_color_set_from_rgba (GalaDrawingColor* self,
                                  GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
#line 545 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 545 "../lib/Drawing/Color.vala"
	g_return_if_fail (color != NULL);
#line 546 "../lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 546 "../lib/Drawing/Color.vala"
	self->R = _tmp0_.red;
#line 547 "../lib/Drawing/Color.vala"
	_tmp1_ = *color;
#line 547 "../lib/Drawing/Color.vala"
	self->G = _tmp1_.green;
#line 548 "../lib/Drawing/Color.vala"
	_tmp2_ = *color;
#line 548 "../lib/Drawing/Color.vala"
	self->B = _tmp2_.blue;
#line 549 "../lib/Drawing/Color.vala"
	_tmp3_ = *color;
#line 549 "../lib/Drawing/Color.vala"
	self->A = _tmp3_.alpha;
#line 1560 "Color.c"
}

static void
gala_drawing_color_class_init (GalaDrawingColorClass * klass,
                               gpointer klass_data)
{
#line 15 "../lib/Drawing/Color.vala"
	gala_drawing_color_parent_class = g_type_class_peek_parent (klass);
#line 15 "../lib/Drawing/Color.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_drawing_color_finalize;
#line 1571 "Color.c"
}

static void
gala_drawing_color_granite_services_settings_serializable_interface_init (GraniteServicesSettingsSerializableIface * iface,
                                                                          gpointer iface_data)
{
#line 15 "../lib/Drawing/Color.vala"
	gala_drawing_color_granite_services_settings_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 15 "../lib/Drawing/Color.vala"
	iface->settings_serialize = (gchar* (*) (GraniteServicesSettingsSerializable*)) gala_drawing_color_real_settings_serialize;
#line 15 "../lib/Drawing/Color.vala"
	iface->settings_deserialize = (void (*) (GraniteServicesSettingsSerializable*, const gchar*)) gala_drawing_color_real_settings_deserialize;
#line 1584 "Color.c"
}

static void
gala_drawing_color_instance_init (GalaDrawingColor * self,
                                  gpointer klass)
{
}

static void
gala_drawing_color_finalize (GObject * obj)
{
	GalaDrawingColor * self;
#line 15 "../lib/Drawing/Color.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_DRAWING_TYPE_COLOR, GalaDrawingColor);
#line 15 "../lib/Drawing/Color.vala"
	G_OBJECT_CLASS (gala_drawing_color_parent_class)->finalize (obj);
#line 1601 "Color.c"
}

/**
    * A class containing an RGBA color and methods for more powerful color manipulation.
    */
static GType
gala_drawing_color_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaDrawingColorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_drawing_color_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDrawingColor), 0, (GInstanceInitFunc) gala_drawing_color_instance_init, NULL };
	static const GInterfaceInfo granite_services_settings_serializable_info = { (GInterfaceInitFunc) gala_drawing_color_granite_services_settings_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_drawing_color_type_id;
	gala_drawing_color_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaDrawingColor", &g_define_type_info, 0);
	g_type_add_interface_static (gala_drawing_color_type_id, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE, &granite_services_settings_serializable_info);
	return gala_drawing_color_type_id;
}

GType
gala_drawing_color_get_type (void)
{
	static volatile gsize gala_drawing_color_type_id__once = 0;
	if (g_once_init_enter (&gala_drawing_color_type_id__once)) {
		GType gala_drawing_color_type_id;
		gala_drawing_color_type_id = gala_drawing_color_get_type_once ();
		g_once_init_leave (&gala_drawing_color_type_id__once, gala_drawing_color_type_id);
	}
	return gala_drawing_color_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

