/* ColorExtractor.c generated by valac 0.56.17, the Vala compiler
 * generated from ColorExtractor.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Marius Meisenzahl <mariusmeisenzahl@gmail.com>
 */

#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "gala.h"
#include <gee.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>

#define GALA_COLOR_EXTRACTOR_PERCENTAGE_SAMPLE_PIXELS 0.01
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_COLOR_EXTRACTOR (gala_color_extractor_get_type ())
#define GALA_COLOR_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_COLOR_EXTRACTOR, GalaColorExtractor))
#define GALA_COLOR_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_COLOR_EXTRACTOR, GalaColorExtractorClass))
#define GALA_IS_COLOR_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_COLOR_EXTRACTOR))
#define GALA_IS_COLOR_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_COLOR_EXTRACTOR))
#define GALA_COLOR_EXTRACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_COLOR_EXTRACTOR, GalaColorExtractorClass))

typedef struct _GalaColorExtractor GalaColorExtractor;
typedef struct _GalaColorExtractorClass GalaColorExtractorClass;
typedef struct _GalaColorExtractorPrivate GalaColorExtractorPrivate;
enum  {
	GALA_COLOR_EXTRACTOR_0_PROPERTY,
	GALA_COLOR_EXTRACTOR_PIXBUF_PROPERTY,
	GALA_COLOR_EXTRACTOR_PRIMARY_COLOR_PROPERTY,
	GALA_COLOR_EXTRACTOR_NUM_PROPERTIES
};
static GParamSpec* gala_color_extractor_properties[GALA_COLOR_EXTRACTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block37Data Block37Data;

struct _GalaColorExtractor {
	GObject parent_instance;
	GalaColorExtractorPrivate * priv;
};

struct _GalaColorExtractorClass {
	GObjectClass parent_class;
};

struct _GalaColorExtractorPrivate {
	GdkPixbuf* _pixbuf;
	GalaDrawingColor* _primary_color;
	GeeList* pixels;
};

struct _Block37Data {
	int _ref_count_;
	GalaColorExtractor* self;
	gdouble* matches;
	gint matches_length1;
	gint _matches_size_;
	GeeList* palette;
};

static gint GalaColorExtractor_private_offset;
static gpointer gala_color_extractor_parent_class = NULL;

VALA_EXTERN GType gala_color_extractor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaColorExtractor, g_object_unref)
VALA_EXTERN GalaColorExtractor* gala_color_extractor_new_from_pixbuf (GdkPixbuf* pixbuf);
VALA_EXTERN GalaColorExtractor* gala_color_extractor_construct_from_pixbuf (GType object_type,
                                                                GdkPixbuf* pixbuf);
static GeeArrayList* gala_color_extractor_convert_pixels_to_rgb (GalaColorExtractor* self,
                                                          guint8* pixels,
                                                          gint pixels_length1,
                                                          gboolean has_alpha);
VALA_EXTERN GalaColorExtractor* gala_color_extractor_new_from_primary_color (GalaDrawingColor* primary_color);
VALA_EXTERN GalaColorExtractor* gala_color_extractor_construct_from_primary_color (GType object_type,
                                                                       GalaDrawingColor* primary_color);
VALA_EXTERN gint gala_color_extractor_get_dominant_color_index (GalaColorExtractor* self,
                                                    GeeList* palette);
static Block37Data* block37_data_ref (Block37Data* _data37_);
static void block37_data_unref (void * _userdata_);
static gboolean __lambda98_ (Block37Data* _data37_,
                      GalaDrawingColor* pixel);
static gboolean ___lambda98__gee_forall_func (gpointer g,
                                       gpointer self);
VALA_EXTERN GalaColorExtractor* gala_color_extractor_new (void);
VALA_EXTERN GalaColorExtractor* gala_color_extractor_construct (GType object_type);
VALA_EXTERN GdkPixbuf* gala_color_extractor_get_pixbuf (GalaColorExtractor* self);
VALA_EXTERN void gala_color_extractor_set_pixbuf (GalaColorExtractor* self,
                                      GdkPixbuf* value);
VALA_EXTERN GalaDrawingColor* gala_color_extractor_get_primary_color (GalaColorExtractor* self);
VALA_EXTERN void gala_color_extractor_set_primary_color (GalaColorExtractor* self,
                                             GalaDrawingColor* value);
static void gala_color_extractor_finalize (GObject * obj);
static GType gala_color_extractor_get_type_once (void);
static void _vala_gala_color_extractor_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_color_extractor_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_color_extractor_get_instance_private (GalaColorExtractor* self)
{
	return G_STRUCT_MEMBER_P (self, GalaColorExtractor_private_offset);
}

GalaColorExtractor*
gala_color_extractor_construct_from_pixbuf (GType object_type,
                                            GdkPixbuf* pixbuf)
{
	GalaColorExtractor * self = NULL;
	guint _tmp0_ = 0;
	guint8* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeArrayList* _tmp4_;
#line 30 "../src/AccentColor/ColorExtractor.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 31 "../src/AccentColor/ColorExtractor.vala"
	self = (GalaColorExtractor*) g_object_new (object_type, "pixbuf", pixbuf, NULL);
#line 33 "../src/AccentColor/ColorExtractor.vala"
	_tmp1_ = gdk_pixbuf_get_pixels_with_length (pixbuf, &_tmp0_);
#line 33 "../src/AccentColor/ColorExtractor.vala"
	_tmp2_ = gdk_pixbuf_get_has_alpha (pixbuf);
#line 33 "../src/AccentColor/ColorExtractor.vala"
	_tmp3_ = _tmp2_;
#line 33 "../src/AccentColor/ColorExtractor.vala"
	_tmp4_ = gala_color_extractor_convert_pixels_to_rgb (self, _tmp1_, (gint) _tmp0_, _tmp3_);
#line 33 "../src/AccentColor/ColorExtractor.vala"
	_g_object_unref0 (self->priv->pixels);
#line 33 "../src/AccentColor/ColorExtractor.vala"
	self->priv->pixels = (GeeList*) _tmp4_;
#line 30 "../src/AccentColor/ColorExtractor.vala"
	return self;
#line 176 "ColorExtractor.c"
}

GalaColorExtractor*
gala_color_extractor_new_from_pixbuf (GdkPixbuf* pixbuf)
{
#line 30 "../src/AccentColor/ColorExtractor.vala"
	return gala_color_extractor_construct_from_pixbuf (GALA_TYPE_COLOR_EXTRACTOR, pixbuf);
#line 184 "ColorExtractor.c"
}

GalaColorExtractor*
gala_color_extractor_construct_from_primary_color (GType object_type,
                                                   GalaDrawingColor* primary_color)
{
	GalaColorExtractor * self = NULL;
	GeeArrayList* _tmp0_;
	GeeList* _tmp1_;
#line 36 "../src/AccentColor/ColorExtractor.vala"
	g_return_val_if_fail (primary_color != NULL, NULL);
#line 37 "../src/AccentColor/ColorExtractor.vala"
	self = (GalaColorExtractor*) g_object_new (object_type, "primary-color", primary_color, NULL);
#line 39 "../src/AccentColor/ColorExtractor.vala"
	_tmp0_ = gee_array_list_new (GALA_DRAWING_TYPE_COLOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 39 "../src/AccentColor/ColorExtractor.vala"
	_g_object_unref0 (self->priv->pixels);
#line 39 "../src/AccentColor/ColorExtractor.vala"
	self->priv->pixels = (GeeList*) _tmp0_;
#line 40 "../src/AccentColor/ColorExtractor.vala"
	_tmp1_ = self->priv->pixels;
#line 40 "../src/AccentColor/ColorExtractor.vala"
	gee_collection_add ((GeeCollection*) _tmp1_, primary_color);
#line 36 "../src/AccentColor/ColorExtractor.vala"
	return self;
#line 210 "ColorExtractor.c"
}

GalaColorExtractor*
gala_color_extractor_new_from_primary_color (GalaDrawingColor* primary_color)
{
#line 36 "../src/AccentColor/ColorExtractor.vala"
	return gala_color_extractor_construct_from_primary_color (GALA_TYPE_COLOR_EXTRACTOR, primary_color);
#line 218 "ColorExtractor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../src/AccentColor/ColorExtractor.vala"
	return self ? g_object_ref (self) : NULL;
#line 226 "ColorExtractor.c"
}

static Block37Data*
block37_data_ref (Block37Data* _data37_)
{
#line 43 "../src/AccentColor/ColorExtractor.vala"
	g_atomic_int_inc (&_data37_->_ref_count_);
#line 43 "../src/AccentColor/ColorExtractor.vala"
	return _data37_;
#line 236 "ColorExtractor.c"
}

static void
block37_data_unref (void * _userdata_)
{
	Block37Data* _data37_;
	_data37_ = (Block37Data*) _userdata_;
#line 43 "../src/AccentColor/ColorExtractor.vala"
	if (g_atomic_int_dec_and_test (&_data37_->_ref_count_)) {
#line 246 "ColorExtractor.c"
		GalaColorExtractor* self;
#line 43 "../src/AccentColor/ColorExtractor.vala"
		self = _data37_->self;
#line 43 "../src/AccentColor/ColorExtractor.vala"
		_data37_->matches = (g_free (_data37_->matches), NULL);
#line 43 "../src/AccentColor/ColorExtractor.vala"
		_g_object_unref0 (_data37_->palette);
#line 43 "../src/AccentColor/ColorExtractor.vala"
		_g_object_unref0 (self);
#line 43 "../src/AccentColor/ColorExtractor.vala"
		g_slice_free (Block37Data, _data37_);
#line 258 "ColorExtractor.c"
	}
}

static gboolean
__lambda98_ (Block37Data* _data37_,
             GalaDrawingColor* pixel)
{
	GalaColorExtractor* self;
	gboolean result;
#line 47 "../src/AccentColor/ColorExtractor.vala"
	self = _data37_->self;
#line 47 "../src/AccentColor/ColorExtractor.vala"
	g_return_val_if_fail (pixel != NULL, FALSE);
#line 272 "ColorExtractor.c"
	{
		gint i = 0;
#line 48 "../src/AccentColor/ColorExtractor.vala"
		i = 0;
#line 277 "ColorExtractor.c"
		{
			gboolean _tmp0_ = FALSE;
#line 48 "../src/AccentColor/ColorExtractor.vala"
			_tmp0_ = TRUE;
#line 48 "../src/AccentColor/ColorExtractor.vala"
			while (TRUE) {
#line 284 "ColorExtractor.c"
				gint _tmp2_;
				gint _tmp3_;
				GalaDrawingColor* color = NULL;
				gpointer _tmp4_;
				gdouble distance = 0.0;
				GalaDrawingColor* _tmp5_;
				GalaDrawingColor* _tmp6_;
				GalaDrawingColor* _tmp7_;
				gdouble* _tmp8_;
				gint _tmp8__length1;
#line 48 "../src/AccentColor/ColorExtractor.vala"
				if (!_tmp0_) {
#line 297 "ColorExtractor.c"
					gint _tmp1_;
#line 48 "../src/AccentColor/ColorExtractor.vala"
					_tmp1_ = i;
#line 48 "../src/AccentColor/ColorExtractor.vala"
					i = _tmp1_ + 1;
#line 303 "ColorExtractor.c"
				}
#line 48 "../src/AccentColor/ColorExtractor.vala"
				_tmp0_ = FALSE;
#line 48 "../src/AccentColor/ColorExtractor.vala"
				_tmp2_ = gee_collection_get_size ((GeeCollection*) _data37_->palette);
#line 48 "../src/AccentColor/ColorExtractor.vala"
				_tmp3_ = _tmp2_;
#line 48 "../src/AccentColor/ColorExtractor.vala"
				if (!(i < _tmp3_)) {
#line 48 "../src/AccentColor/ColorExtractor.vala"
					break;
#line 315 "ColorExtractor.c"
				}
#line 49 "../src/AccentColor/ColorExtractor.vala"
				_tmp4_ = gee_list_get (_data37_->palette, i);
#line 49 "../src/AccentColor/ColorExtractor.vala"
				color = (GalaDrawingColor*) _tmp4_;
#line 51 "../src/AccentColor/ColorExtractor.vala"
				_tmp5_ = color;
#line 51 "../src/AccentColor/ColorExtractor.vala"
				_tmp6_ = color;
#line 51 "../src/AccentColor/ColorExtractor.vala"
				_tmp7_ = color;
#line 51 "../src/AccentColor/ColorExtractor.vala"
				distance = sqrt ((pow (pixel->R - _tmp5_->R, (gdouble) 2) + pow (pixel->G - _tmp6_->G, (gdouble) 2)) + pow (pixel->B - _tmp7_->B, (gdouble) 2));
#line 57 "../src/AccentColor/ColorExtractor.vala"
				if (distance > 0.25) {
#line 58 "../src/AccentColor/ColorExtractor.vala"
					_g_object_unref0 (color);
#line 58 "../src/AccentColor/ColorExtractor.vala"
					continue;
#line 335 "ColorExtractor.c"
				}
#line 61 "../src/AccentColor/ColorExtractor.vala"
				_tmp8_ = _data37_->matches;
#line 61 "../src/AccentColor/ColorExtractor.vala"
				_tmp8__length1 = _data37_->matches_length1;
#line 61 "../src/AccentColor/ColorExtractor.vala"
				_tmp8_[i] += 1.0 - distance;
#line 48 "../src/AccentColor/ColorExtractor.vala"
				_g_object_unref0 (color);
#line 345 "ColorExtractor.c"
			}
		}
	}
#line 64 "../src/AccentColor/ColorExtractor.vala"
	result = TRUE;
#line 64 "../src/AccentColor/ColorExtractor.vala"
	_g_object_unref0 (pixel);
#line 64 "../src/AccentColor/ColorExtractor.vala"
	return result;
#line 355 "ColorExtractor.c"
}

static gboolean
___lambda98__gee_forall_func (gpointer g,
                              gpointer self)
{
	gboolean result;
	result = __lambda98_ (self, (GalaDrawingColor*) g);
#line 47 "../src/AccentColor/ColorExtractor.vala"
	return result;
#line 366 "ColorExtractor.c"
}

gint
gala_color_extractor_get_dominant_color_index (GalaColorExtractor* self,
                                               GeeList* palette)
{
	Block37Data* _data37_;
	GeeList* _tmp0_;
	gint index = 0;
	gint _tmp1_;
	gint _tmp2_;
	gdouble* _tmp3_;
	GeeList* _tmp4_;
	gdouble best_match = 0.0;
	gint result;
#line 43 "../src/AccentColor/ColorExtractor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/AccentColor/ColorExtractor.vala"
	g_return_val_if_fail (palette != NULL, 0);
#line 43 "../src/AccentColor/ColorExtractor.vala"
	_data37_ = g_slice_new0 (Block37Data);
#line 43 "../src/AccentColor/ColorExtractor.vala"
	_data37_->_ref_count_ = 1;
#line 43 "../src/AccentColor/ColorExtractor.vala"
	_data37_->self = g_object_ref (self);
#line 43 "../src/AccentColor/ColorExtractor.vala"
	_tmp0_ = _g_object_ref0 (palette);
#line 43 "../src/AccentColor/ColorExtractor.vala"
	_g_object_unref0 (_data37_->palette);
#line 43 "../src/AccentColor/ColorExtractor.vala"
	_data37_->palette = _tmp0_;
#line 44 "../src/AccentColor/ColorExtractor.vala"
	index = 0;
#line 45 "../src/AccentColor/ColorExtractor.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _data37_->palette);
#line 45 "../src/AccentColor/ColorExtractor.vala"
	_tmp2_ = _tmp1_;
#line 45 "../src/AccentColor/ColorExtractor.vala"
	_tmp3_ = g_new0 (gdouble, _tmp2_);
#line 45 "../src/AccentColor/ColorExtractor.vala"
	_data37_->matches = _tmp3_;
#line 45 "../src/AccentColor/ColorExtractor.vala"
	_data37_->matches_length1 = _tmp2_;
#line 45 "../src/AccentColor/ColorExtractor.vala"
	_data37_->_matches_size_ = _data37_->matches_length1;
#line 47 "../src/AccentColor/ColorExtractor.vala"
	_tmp4_ = self->priv->pixels;
#line 47 "../src/AccentColor/ColorExtractor.vala"
	gee_traversable_foreach ((GeeTraversable*) _tmp4_, ___lambda98__gee_forall_func, _data37_);
#line 67 "../src/AccentColor/ColorExtractor.vala"
	best_match = DBL_MIN;
#line 418 "ColorExtractor.c"
	{
		gint i = 0;
#line 68 "../src/AccentColor/ColorExtractor.vala"
		i = 0;
#line 423 "ColorExtractor.c"
		{
			gboolean _tmp5_ = FALSE;
#line 68 "../src/AccentColor/ColorExtractor.vala"
			_tmp5_ = TRUE;
#line 68 "../src/AccentColor/ColorExtractor.vala"
			while (TRUE) {
#line 430 "ColorExtractor.c"
				gdouble* _tmp7_;
				gint _tmp7__length1;
				gdouble* _tmp8_;
				gint _tmp8__length1;
				gdouble _tmp9_;
#line 68 "../src/AccentColor/ColorExtractor.vala"
				if (!_tmp5_) {
#line 438 "ColorExtractor.c"
					gint _tmp6_;
#line 68 "../src/AccentColor/ColorExtractor.vala"
					_tmp6_ = i;
#line 68 "../src/AccentColor/ColorExtractor.vala"
					i = _tmp6_ + 1;
#line 444 "ColorExtractor.c"
				}
#line 68 "../src/AccentColor/ColorExtractor.vala"
				_tmp5_ = FALSE;
#line 68 "../src/AccentColor/ColorExtractor.vala"
				_tmp7_ = _data37_->matches;
#line 68 "../src/AccentColor/ColorExtractor.vala"
				_tmp7__length1 = _data37_->matches_length1;
#line 68 "../src/AccentColor/ColorExtractor.vala"
				if (!(i < _tmp7__length1)) {
#line 68 "../src/AccentColor/ColorExtractor.vala"
					break;
#line 456 "ColorExtractor.c"
				}
#line 69 "../src/AccentColor/ColorExtractor.vala"
				_tmp8_ = _data37_->matches;
#line 69 "../src/AccentColor/ColorExtractor.vala"
				_tmp8__length1 = _data37_->matches_length1;
#line 69 "../src/AccentColor/ColorExtractor.vala"
				_tmp9_ = _tmp8_[i];
#line 69 "../src/AccentColor/ColorExtractor.vala"
				if (_tmp9_ > best_match) {
#line 466 "ColorExtractor.c"
					gdouble* _tmp10_;
					gint _tmp10__length1;
					gdouble _tmp11_;
#line 70 "../src/AccentColor/ColorExtractor.vala"
					_tmp10_ = _data37_->matches;
#line 70 "../src/AccentColor/ColorExtractor.vala"
					_tmp10__length1 = _data37_->matches_length1;
#line 70 "../src/AccentColor/ColorExtractor.vala"
					_tmp11_ = _tmp10_[i];
#line 70 "../src/AccentColor/ColorExtractor.vala"
					best_match = _tmp11_;
#line 71 "../src/AccentColor/ColorExtractor.vala"
					index = i;
#line 480 "ColorExtractor.c"
				}
			}
		}
	}
#line 75 "../src/AccentColor/ColorExtractor.vala"
	result = index;
#line 75 "../src/AccentColor/ColorExtractor.vala"
	block37_data_unref (_data37_);
#line 75 "../src/AccentColor/ColorExtractor.vala"
	_data37_ = NULL;
#line 75 "../src/AccentColor/ColorExtractor.vala"
	return result;
#line 493 "ColorExtractor.c"
}

static GeeArrayList*
gala_color_extractor_convert_pixels_to_rgb (GalaColorExtractor* self,
                                            guint8* pixels,
                                            gint pixels_length1,
                                            gboolean has_alpha)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gint factor = 0;
	gint step_size = 0;
	GeeArrayList* result;
#line 78 "../src/AccentColor/ColorExtractor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../src/AccentColor/ColorExtractor.vala"
	_tmp0_ = gee_array_list_new (GALA_DRAWING_TYPE_COLOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 79 "../src/AccentColor/ColorExtractor.vala"
	list = _tmp0_;
#line 81 "../src/AccentColor/ColorExtractor.vala"
	factor = 3 + ((gint) has_alpha);
#line 82 "../src/AccentColor/ColorExtractor.vala"
	step_size = (gint) ((pixels_length1 / factor) * GALA_COLOR_EXTRACTOR_PERCENTAGE_SAMPLE_PIXELS);
#line 517 "ColorExtractor.c"
	{
		gint i = 0;
#line 84 "../src/AccentColor/ColorExtractor.vala"
		i = 0;
#line 522 "ColorExtractor.c"
		{
			gboolean _tmp1_ = FALSE;
#line 84 "../src/AccentColor/ColorExtractor.vala"
			_tmp1_ = TRUE;
#line 84 "../src/AccentColor/ColorExtractor.vala"
			while (TRUE) {
#line 529 "ColorExtractor.c"
				gint offset = 0;
				gdouble red = 0.0;
				guint8 _tmp2_;
				gdouble green = 0.0;
				guint8 _tmp3_;
				gdouble blue = 0.0;
				guint8 _tmp4_;
				GeeArrayList* _tmp5_;
				GalaDrawingColor* _tmp6_;
				GalaDrawingColor* _tmp7_;
#line 84 "../src/AccentColor/ColorExtractor.vala"
				if (!_tmp1_) {
#line 84 "../src/AccentColor/ColorExtractor.vala"
					i += step_size;
#line 544 "ColorExtractor.c"
				}
#line 84 "../src/AccentColor/ColorExtractor.vala"
				_tmp1_ = FALSE;
#line 84 "../src/AccentColor/ColorExtractor.vala"
				if (!(i < (pixels_length1 / factor))) {
#line 84 "../src/AccentColor/ColorExtractor.vala"
					break;
#line 552 "ColorExtractor.c"
				}
#line 85 "../src/AccentColor/ColorExtractor.vala"
				offset = i * factor;
#line 86 "../src/AccentColor/ColorExtractor.vala"
				_tmp2_ = pixels[offset];
#line 86 "../src/AccentColor/ColorExtractor.vala"
				red = _tmp2_ / 255.0;
#line 87 "../src/AccentColor/ColorExtractor.vala"
				_tmp3_ = pixels[offset + 1];
#line 87 "../src/AccentColor/ColorExtractor.vala"
				green = _tmp3_ / 255.0;
#line 88 "../src/AccentColor/ColorExtractor.vala"
				_tmp4_ = pixels[offset + 2];
#line 88 "../src/AccentColor/ColorExtractor.vala"
				blue = _tmp4_ / 255.0;
#line 90 "../src/AccentColor/ColorExtractor.vala"
				_tmp5_ = list;
#line 90 "../src/AccentColor/ColorExtractor.vala"
				_tmp6_ = gala_drawing_color_new (red, green, blue, 0.0);
#line 90 "../src/AccentColor/ColorExtractor.vala"
				_tmp7_ = _tmp6_;
#line 90 "../src/AccentColor/ColorExtractor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp7_);
#line 90 "../src/AccentColor/ColorExtractor.vala"
				_g_object_unref0 (_tmp7_);
#line 578 "ColorExtractor.c"
			}
		}
	}
#line 93 "../src/AccentColor/ColorExtractor.vala"
	result = list;
#line 93 "../src/AccentColor/ColorExtractor.vala"
	return result;
#line 586 "ColorExtractor.c"
}

GalaColorExtractor*
gala_color_extractor_construct (GType object_type)
{
	GalaColorExtractor * self = NULL;
#line 22 "../src/AccentColor/ColorExtractor.vala"
	self = (GalaColorExtractor*) g_object_new (object_type, NULL);
#line 22 "../src/AccentColor/ColorExtractor.vala"
	return self;
#line 597 "ColorExtractor.c"
}

GalaColorExtractor*
gala_color_extractor_new (void)
{
#line 22 "../src/AccentColor/ColorExtractor.vala"
	return gala_color_extractor_construct (GALA_TYPE_COLOR_EXTRACTOR);
#line 605 "ColorExtractor.c"
}

GdkPixbuf*
gala_color_extractor_get_pixbuf (GalaColorExtractor* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 25 "../src/AccentColor/ColorExtractor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/AccentColor/ColorExtractor.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 25 "../src/AccentColor/ColorExtractor.vala"
	result = _tmp0_;
#line 25 "../src/AccentColor/ColorExtractor.vala"
	return result;
#line 621 "ColorExtractor.c"
}

void
gala_color_extractor_set_pixbuf (GalaColorExtractor* self,
                                 GdkPixbuf* value)
{
	GdkPixbuf* old_value;
#line 25 "../src/AccentColor/ColorExtractor.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/AccentColor/ColorExtractor.vala"
	old_value = gala_color_extractor_get_pixbuf (self);
#line 25 "../src/AccentColor/ColorExtractor.vala"
	if (old_value != value) {
#line 635 "ColorExtractor.c"
		GdkPixbuf* _tmp0_;
#line 25 "../src/AccentColor/ColorExtractor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/AccentColor/ColorExtractor.vala"
		_g_object_unref0 (self->priv->_pixbuf);
#line 25 "../src/AccentColor/ColorExtractor.vala"
		self->priv->_pixbuf = _tmp0_;
#line 25 "../src/AccentColor/ColorExtractor.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_color_extractor_properties[GALA_COLOR_EXTRACTOR_PIXBUF_PROPERTY]);
#line 645 "ColorExtractor.c"
	}
}

GalaDrawingColor*
gala_color_extractor_get_primary_color (GalaColorExtractor* self)
{
	GalaDrawingColor* result;
	GalaDrawingColor* _tmp0_;
#line 26 "../src/AccentColor/ColorExtractor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/AccentColor/ColorExtractor.vala"
	_tmp0_ = self->priv->_primary_color;
#line 26 "../src/AccentColor/ColorExtractor.vala"
	result = _tmp0_;
#line 26 "../src/AccentColor/ColorExtractor.vala"
	return result;
#line 662 "ColorExtractor.c"
}

void
gala_color_extractor_set_primary_color (GalaColorExtractor* self,
                                        GalaDrawingColor* value)
{
	GalaDrawingColor* old_value;
#line 26 "../src/AccentColor/ColorExtractor.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/AccentColor/ColorExtractor.vala"
	old_value = gala_color_extractor_get_primary_color (self);
#line 26 "../src/AccentColor/ColorExtractor.vala"
	if (old_value != value) {
#line 676 "ColorExtractor.c"
		GalaDrawingColor* _tmp0_;
#line 26 "../src/AccentColor/ColorExtractor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/AccentColor/ColorExtractor.vala"
		_g_object_unref0 (self->priv->_primary_color);
#line 26 "../src/AccentColor/ColorExtractor.vala"
		self->priv->_primary_color = _tmp0_;
#line 26 "../src/AccentColor/ColorExtractor.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_color_extractor_properties[GALA_COLOR_EXTRACTOR_PRIMARY_COLOR_PROPERTY]);
#line 686 "ColorExtractor.c"
	}
}

static void
gala_color_extractor_class_init (GalaColorExtractorClass * klass,
                                 gpointer klass_data)
{
#line 22 "../src/AccentColor/ColorExtractor.vala"
	gala_color_extractor_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/AccentColor/ColorExtractor.vala"
	g_type_class_adjust_private_offset (klass, &GalaColorExtractor_private_offset);
#line 22 "../src/AccentColor/ColorExtractor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_color_extractor_get_property;
#line 22 "../src/AccentColor/ColorExtractor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_color_extractor_set_property;
#line 22 "../src/AccentColor/ColorExtractor.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_color_extractor_finalize;
#line 22 "../src/AccentColor/ColorExtractor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_COLOR_EXTRACTOR_PIXBUF_PROPERTY, gala_color_extractor_properties[GALA_COLOR_EXTRACTOR_PIXBUF_PROPERTY] = g_param_spec_object ("pixbuf", "pixbuf", "pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "../src/AccentColor/ColorExtractor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_COLOR_EXTRACTOR_PRIMARY_COLOR_PROPERTY, gala_color_extractor_properties[GALA_COLOR_EXTRACTOR_PRIMARY_COLOR_PROPERTY] = g_param_spec_object ("primary-color", "primary-color", "primary-color", GALA_DRAWING_TYPE_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 708 "ColorExtractor.c"
}

static void
gala_color_extractor_instance_init (GalaColorExtractor * self,
                                    gpointer klass)
{
#line 22 "../src/AccentColor/ColorExtractor.vala"
	self->priv = gala_color_extractor_get_instance_private (self);
#line 717 "ColorExtractor.c"
}

static void
gala_color_extractor_finalize (GObject * obj)
{
	GalaColorExtractor * self;
#line 22 "../src/AccentColor/ColorExtractor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_COLOR_EXTRACTOR, GalaColorExtractor);
#line 25 "../src/AccentColor/ColorExtractor.vala"
	_g_object_unref0 (self->priv->_pixbuf);
#line 26 "../src/AccentColor/ColorExtractor.vala"
	_g_object_unref0 (self->priv->_primary_color);
#line 28 "../src/AccentColor/ColorExtractor.vala"
	_g_object_unref0 (self->priv->pixels);
#line 22 "../src/AccentColor/ColorExtractor.vala"
	G_OBJECT_CLASS (gala_color_extractor_parent_class)->finalize (obj);
#line 734 "ColorExtractor.c"
}

static GType
gala_color_extractor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaColorExtractorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_color_extractor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaColorExtractor), 0, (GInstanceInitFunc) gala_color_extractor_instance_init, NULL };
	GType gala_color_extractor_type_id;
	gala_color_extractor_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaColorExtractor", &g_define_type_info, 0);
	GalaColorExtractor_private_offset = g_type_add_instance_private (gala_color_extractor_type_id, sizeof (GalaColorExtractorPrivate));
	return gala_color_extractor_type_id;
}

GType
gala_color_extractor_get_type (void)
{
	static volatile gsize gala_color_extractor_type_id__once = 0;
	if (g_once_init_enter (&gala_color_extractor_type_id__once)) {
		GType gala_color_extractor_type_id;
		gala_color_extractor_type_id = gala_color_extractor_get_type_once ();
		g_once_init_leave (&gala_color_extractor_type_id__once, gala_color_extractor_type_id);
	}
	return gala_color_extractor_type_id__once;
}

static void
_vala_gala_color_extractor_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaColorExtractor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_COLOR_EXTRACTOR, GalaColorExtractor);
#line 22 "../src/AccentColor/ColorExtractor.vala"
	switch (property_id) {
#line 22 "../src/AccentColor/ColorExtractor.vala"
		case GALA_COLOR_EXTRACTOR_PIXBUF_PROPERTY:
#line 22 "../src/AccentColor/ColorExtractor.vala"
		g_value_set_object (value, gala_color_extractor_get_pixbuf (self));
#line 22 "../src/AccentColor/ColorExtractor.vala"
		break;
#line 22 "../src/AccentColor/ColorExtractor.vala"
		case GALA_COLOR_EXTRACTOR_PRIMARY_COLOR_PROPERTY:
#line 22 "../src/AccentColor/ColorExtractor.vala"
		g_value_set_object (value, gala_color_extractor_get_primary_color (self));
#line 22 "../src/AccentColor/ColorExtractor.vala"
		break;
#line 781 "ColorExtractor.c"
		default:
#line 22 "../src/AccentColor/ColorExtractor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/AccentColor/ColorExtractor.vala"
		break;
#line 787 "ColorExtractor.c"
	}
}

static void
_vala_gala_color_extractor_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaColorExtractor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_COLOR_EXTRACTOR, GalaColorExtractor);
#line 22 "../src/AccentColor/ColorExtractor.vala"
	switch (property_id) {
#line 22 "../src/AccentColor/ColorExtractor.vala"
		case GALA_COLOR_EXTRACTOR_PIXBUF_PROPERTY:
#line 22 "../src/AccentColor/ColorExtractor.vala"
		gala_color_extractor_set_pixbuf (self, g_value_get_object (value));
#line 22 "../src/AccentColor/ColorExtractor.vala"
		break;
#line 22 "../src/AccentColor/ColorExtractor.vala"
		case GALA_COLOR_EXTRACTOR_PRIMARY_COLOR_PROPERTY:
#line 22 "../src/AccentColor/ColorExtractor.vala"
		gala_color_extractor_set_primary_color (self, g_value_get_object (value));
#line 22 "../src/AccentColor/ColorExtractor.vala"
		break;
#line 813 "ColorExtractor.c"
		default:
#line 22 "../src/AccentColor/ColorExtractor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/AccentColor/ColorExtractor.vala"
		break;
#line 819 "ColorExtractor.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 834 "ColorExtractor.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 838 "ColorExtractor.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 842 "ColorExtractor.c"
}

