/* NotificationStack.c generated by valac 0.56.17, the Vala compiler
 * generated from NotificationStack.vala, do not modify */

/*
 * Copyright 2020 elementary, Inc (https://elementary.io)
 *           2014 Tom Beckmann
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <meta/display.h>
#include <gee.h>
#include <meta/meta-window-actor.h>
#include <stdlib.h>
#include <string.h>
#include <clutter/clutter.h>
#include <meta/window.h>
#include <mtk/mtk.h>
#include <float.h>
#include <math.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#define GALA_NOTIFICATION_STACK_TRANSITION_ENTRY_NAME "entry"
#define GALA_NOTIFICATION_STACK_TRANSITION_MOVE_STACK_ID "move-stack"
#define GALA_NOTIFICATION_STACK_TOP_OFFSET 2
#define GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN 12
#define GALA_NOTIFICATION_STACK_MARGIN 12
#define GALA_NOTIFICATION_STACK_WIDTH 300
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_NOTIFICATION_STACK (gala_notification_stack_get_type ())
#define GALA_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack))
#define GALA_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))
#define GALA_IS_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_IS_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_NOTIFICATION_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))

typedef struct _GalaNotificationStack GalaNotificationStack;
typedef struct _GalaNotificationStackClass GalaNotificationStackClass;
typedef struct _GalaNotificationStackPrivate GalaNotificationStackPrivate;
enum  {
	GALA_NOTIFICATION_STACK_0_PROPERTY,
	GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY,
	GALA_NOTIFICATION_STACK_NUM_PROPERTIES
};
static GParamSpec* gala_notification_stack_properties[GALA_NOTIFICATION_STACK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaNotificationStack {
	GObject parent_instance;
	GalaNotificationStackPrivate * priv;
};

struct _GalaNotificationStackClass {
	GObjectClass parent_class;
};

struct _GalaNotificationStackPrivate {
	gint stack_y;
	gint stack_width;
	MetaDisplay* _display;
	GeeArrayList* notifications;
};

struct _Block4Data {
	int _ref_count_;
	GalaNotificationStack* self;
	MetaWindowActor* notification;
};

static gint GalaNotificationStack_private_offset;
static gpointer gala_notification_stack_parent_class = NULL;

VALA_EXTERN GType gala_notification_stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaNotificationStack, g_object_unref)
VALA_EXTERN GalaNotificationStack* gala_notification_stack_new (MetaDisplay* display);
VALA_EXTERN GalaNotificationStack* gala_notification_stack_construct (GType object_type,
                                                          MetaDisplay* display);
VALA_EXTERN void gala_notification_stack_show_notification (GalaNotificationStack* self,
                                                MetaWindowActor* notification,
                                                gboolean animate);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _vala_GValue_array_free (GValue * array,
                              gssize array_length);
static void ___lambda100_ (Block4Data* _data4_);
static void ____lambda100__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
VALA_EXTERN MetaDisplay* gala_notification_stack_get_display (GalaNotificationStack* self);
static void gala_notification_stack_update_positions (GalaNotificationStack* self,
                                               gboolean animate,
                                               gfloat scale,
                                               gfloat add_y);
static void gala_notification_stack_move_window (MetaWindowActor* actor,
                                          gint x,
                                          gint y);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static void gala_notification_stack_update_stack_allocation (GalaNotificationStack* self);
VALA_EXTERN void gala_notification_stack_destroy_notification (GalaNotificationStack* self,
                                                   MetaWindowActor* notification,
                                                   gboolean animate);
static void gala_notification_stack_set_display (GalaNotificationStack* self,
                                          MetaDisplay* value);
static GObject * gala_notification_stack_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _gala_notification_stack_update_stack_allocation_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                                      gpointer self);
static void _gala_notification_stack_update_stack_allocation_meta_display_workareas_changed (MetaDisplay* _sender,
                                                                                      gpointer self);
static void gala_notification_stack_finalize (GObject * obj);
static GType gala_notification_stack_get_type_once (void);
static void _vala_gala_notification_stack_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_gala_notification_stack_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
gala_notification_stack_get_instance_private (GalaNotificationStack* self)
{
	return G_STRUCT_MEMBER_P (self, GalaNotificationStack_private_offset);
}

GalaNotificationStack*
gala_notification_stack_construct (GType object_type,
                                   MetaDisplay* display)
{
	GalaNotificationStack * self = NULL;
#line 38 "../src/NotificationStack.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 39 "../src/NotificationStack.vala"
	self = (GalaNotificationStack*) g_object_new (object_type, "display", display, NULL);
#line 38 "../src/NotificationStack.vala"
	return self;
#line 179 "NotificationStack.c"
}

GalaNotificationStack*
gala_notification_stack_new (MetaDisplay* display)
{
#line 38 "../src/NotificationStack.vala"
	return gala_notification_stack_construct (GALA_TYPE_NOTIFICATION_STACK, display);
#line 187 "NotificationStack.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 51 "../src/NotificationStack.vala"
	return self ? g_object_ref (self) : NULL;
#line 195 "NotificationStack.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 51 "../src/NotificationStack.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 51 "../src/NotificationStack.vala"
	return _data4_;
#line 205 "NotificationStack.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 51 "../src/NotificationStack.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 215 "NotificationStack.c"
		GalaNotificationStack* self;
#line 51 "../src/NotificationStack.vala"
		self = _data4_->self;
#line 51 "../src/NotificationStack.vala"
		_g_object_unref0 (_data4_->notification);
#line 51 "../src/NotificationStack.vala"
		_g_object_unref0 (self);
#line 51 "../src/NotificationStack.vala"
		g_slice_free (Block4Data, _data4_);
#line 225 "NotificationStack.c"
	}
}

static void
_vala_GValue_array_free (GValue * array,
                         gssize array_length)
{
#line 67 "../src/NotificationStack.vala"
	if (array != NULL) {
#line 235 "NotificationStack.c"
		gssize i;
#line 67 "../src/NotificationStack.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 67 "../src/NotificationStack.vala"
			g_value_unset (&array[i]);
#line 241 "NotificationStack.c"
		}
	}
#line 67 "../src/NotificationStack.vala"
	g_free (array);
#line 246 "NotificationStack.c"
}

static void
___lambda100_ (Block4Data* _data4_)
{
	GalaNotificationStack* self;
#line 75 "../src/NotificationStack.vala"
	self = _data4_->self;
#line 75 "../src/NotificationStack.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) _data4_->notification);
#line 257 "NotificationStack.c"
}

static void
____lambda100__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 75 "../src/NotificationStack.vala"
	___lambda100_ (self);
#line 266 "NotificationStack.c"
}

void
gala_notification_stack_show_notification (GalaNotificationStack* self,
                                           MetaWindowActor* notification,
                                           gboolean animate)
{
	GeeArrayList* _tmp0_;
	Block4Data* _data4_;
	MetaWindowActor* _tmp1_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp2_;
	MtkRectangle window_rect = {0};
	MetaWindow* _tmp3_;
	MtkRectangle _tmp4_ = {0};
	MetaWindow* _tmp5_;
	gint primary = 0;
	MetaDisplay* _tmp29_;
	MtkRectangle area = {0};
	MetaDisplay* _tmp30_;
	MetaWorkspaceManager* _tmp31_;
	MetaWorkspace* _tmp32_;
	MtkRectangle _tmp33_ = {0};
	gfloat scale = 0.0F;
	MetaDisplay* _tmp34_;
	MtkRectangle _tmp35_;
	gint notification_x_pos = 0;
	MtkRectangle _tmp36_;
	MtkRectangle _tmp37_;
	MtkRectangle _tmp38_;
	GeeArrayList* _tmp39_;
#line 51 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/NotificationStack.vala"
	g_return_if_fail (notification != NULL);
#line 51 "../src/NotificationStack.vala"
	_tmp0_ = self->priv->notifications;
#line 51 "../src/NotificationStack.vala"
	_vala_return_if_fail (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, notification), "!notifications.contains (notification)");
#line 51 "../src/NotificationStack.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 51 "../src/NotificationStack.vala"
	_data4_->_ref_count_ = 1;
#line 51 "../src/NotificationStack.vala"
	_data4_->self = g_object_ref (self);
#line 51 "../src/NotificationStack.vala"
	_tmp1_ = _g_object_ref0 (notification);
#line 51 "../src/NotificationStack.vala"
	_g_object_unref0 (_data4_->notification);
#line 51 "../src/NotificationStack.vala"
	_data4_->notification = _tmp1_;
#line 52 "../src/NotificationStack.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) _data4_->notification, 0.5f, 0.5f);
#line 54 "../src/NotificationStack.vala"
	_tmp2_ = meta_window_actor_get_meta_window (_data4_->notification);
#line 54 "../src/NotificationStack.vala"
	window = _tmp2_;
#line 55 "../src/NotificationStack.vala"
	_tmp3_ = window;
#line 55 "../src/NotificationStack.vala"
	meta_window_get_frame_rect (_tmp3_, &_tmp4_);
#line 55 "../src/NotificationStack.vala"
	window_rect = _tmp4_;
#line 56 "../src/NotificationStack.vala"
	_tmp5_ = window;
#line 56 "../src/NotificationStack.vala"
	meta_window_stick (_tmp5_);
#line 58 "../src/NotificationStack.vala"
	if (animate) {
#line 336 "NotificationStack.c"
		ClutterPropertyTransition* opacity_transition = NULL;
		ClutterPropertyTransition* _tmp6_;
		ClutterPropertyTransition* _tmp7_;
		GValue _tmp8_ = {0};
		ClutterPropertyTransition* _tmp9_;
		GValue _tmp10_ = {0};
		ClutterKeyframeTransition* flip_transition = NULL;
		ClutterKeyframeTransition* _tmp11_;
		ClutterKeyframeTransition* _tmp12_;
		GValue _tmp13_ = {0};
		ClutterKeyframeTransition* _tmp14_;
		GValue _tmp15_ = {0};
		ClutterKeyframeTransition* _tmp16_;
		gdouble* _tmp17_;
		gdouble* _tmp18_;
		gint _tmp18__length1;
		ClutterKeyframeTransition* _tmp19_;
		GValue _tmp20_ = {0};
		GValue* _tmp21_;
		GValue* _tmp22_;
		gint _tmp22__length1;
		ClutterTransitionGroup* entry = NULL;
		ClutterTransitionGroup* _tmp23_ = NULL;
		ClutterTransitionGroup* _tmp24_;
		ClutterPropertyTransition* _tmp25_;
		ClutterTransitionGroup* _tmp26_;
		ClutterKeyframeTransition* _tmp27_;
		ClutterTransitionGroup* _tmp28_;
#line 59 "../src/NotificationStack.vala"
		_tmp6_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
#line 59 "../src/NotificationStack.vala"
		opacity_transition = _tmp6_;
#line 60 "../src/NotificationStack.vala"
		_tmp7_ = opacity_transition;
#line 60 "../src/NotificationStack.vala"
		g_value_init (&_tmp8_, G_TYPE_INT);
#line 60 "../src/NotificationStack.vala"
		g_value_set_int (&_tmp8_, 0);
#line 60 "../src/NotificationStack.vala"
		clutter_transition_set_from_value ((ClutterTransition*) _tmp7_, &_tmp8_);
#line 60 "../src/NotificationStack.vala"
		G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
#line 61 "../src/NotificationStack.vala"
		_tmp9_ = opacity_transition;
#line 61 "../src/NotificationStack.vala"
		g_value_init (&_tmp10_, G_TYPE_INT);
#line 61 "../src/NotificationStack.vala"
		g_value_set_int (&_tmp10_, 255);
#line 61 "../src/NotificationStack.vala"
		clutter_transition_set_to_value ((ClutterTransition*) _tmp9_, &_tmp10_);
#line 61 "../src/NotificationStack.vala"
		G_IS_VALUE (&_tmp10_) ? (g_value_unset (&_tmp10_), NULL) : NULL;
#line 63 "../src/NotificationStack.vala"
		_tmp11_ = (ClutterKeyframeTransition*) clutter_keyframe_transition_new ("rotation-angle-x");
#line 63 "../src/NotificationStack.vala"
		flip_transition = _tmp11_;
#line 64 "../src/NotificationStack.vala"
		_tmp12_ = flip_transition;
#line 64 "../src/NotificationStack.vala"
		g_value_init (&_tmp13_, G_TYPE_DOUBLE);
#line 64 "../src/NotificationStack.vala"
		g_value_set_double (&_tmp13_, 90.0);
#line 64 "../src/NotificationStack.vala"
		clutter_transition_set_from_value ((ClutterTransition*) _tmp12_, &_tmp13_);
#line 64 "../src/NotificationStack.vala"
		G_IS_VALUE (&_tmp13_) ? (g_value_unset (&_tmp13_), NULL) : NULL;
#line 65 "../src/NotificationStack.vala"
		_tmp14_ = flip_transition;
#line 65 "../src/NotificationStack.vala"
		g_value_init (&_tmp15_, G_TYPE_DOUBLE);
#line 65 "../src/NotificationStack.vala"
		g_value_set_double (&_tmp15_, 0.0);
#line 65 "../src/NotificationStack.vala"
		clutter_transition_set_to_value ((ClutterTransition*) _tmp14_, &_tmp15_);
#line 65 "../src/NotificationStack.vala"
		G_IS_VALUE (&_tmp15_) ? (g_value_unset (&_tmp15_), NULL) : NULL;
#line 66 "../src/NotificationStack.vala"
		_tmp16_ = flip_transition;
#line 66 "../src/NotificationStack.vala"
		_tmp17_ = g_new0 (gdouble, 1);
#line 66 "../src/NotificationStack.vala"
		_tmp17_[0] = 0.6;
#line 66 "../src/NotificationStack.vala"
		_tmp18_ = _tmp17_;
#line 66 "../src/NotificationStack.vala"
		_tmp18__length1 = 1;
#line 66 "../src/NotificationStack.vala"
		clutter_keyframe_transition_set_key_frames (_tmp16_, (guint) 1, _tmp18_);
#line 66 "../src/NotificationStack.vala"
		_tmp18_ = (g_free (_tmp18_), NULL);
#line 67 "../src/NotificationStack.vala"
		_tmp19_ = flip_transition;
#line 67 "../src/NotificationStack.vala"
		g_value_init (&_tmp20_, G_TYPE_DOUBLE);
#line 67 "../src/NotificationStack.vala"
		g_value_set_double (&_tmp20_, -10.0);
#line 67 "../src/NotificationStack.vala"
		_tmp21_ = g_new0 (GValue, 1);
#line 67 "../src/NotificationStack.vala"
		_tmp21_[0] = _tmp20_;
#line 67 "../src/NotificationStack.vala"
		_tmp22_ = _tmp21_;
#line 67 "../src/NotificationStack.vala"
		_tmp22__length1 = 1;
#line 67 "../src/NotificationStack.vala"
		clutter_keyframe_transition_set_values (_tmp19_, (guint) 1, _tmp22_);
#line 67 "../src/NotificationStack.vala"
		_tmp22_ = (_vala_GValue_array_free (_tmp22_, _tmp22__length1), NULL);
#line 69 "../src/NotificationStack.vala"
		_tmp23_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
#line 69 "../src/NotificationStack.vala"
		clutter_timeline_set_duration ((ClutterTimeline*) _tmp23_, (guint) 400);
#line 69 "../src/NotificationStack.vala"
		entry = _tmp23_;
#line 72 "../src/NotificationStack.vala"
		_tmp24_ = entry;
#line 72 "../src/NotificationStack.vala"
		_tmp25_ = opacity_transition;
#line 72 "../src/NotificationStack.vala"
		clutter_transition_group_add_transition (_tmp24_, (ClutterTransition*) _tmp25_);
#line 73 "../src/NotificationStack.vala"
		_tmp26_ = entry;
#line 73 "../src/NotificationStack.vala"
		_tmp27_ = flip_transition;
#line 73 "../src/NotificationStack.vala"
		clutter_transition_group_add_transition (_tmp26_, (ClutterTransition*) _tmp27_);
#line 75 "../src/NotificationStack.vala"
		g_signal_connect_data ((ClutterActor*) _data4_->notification, "transitions-completed", (GCallback) ____lambda100__clutter_actor_transitions_completed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 76 "../src/NotificationStack.vala"
		_tmp28_ = entry;
#line 76 "../src/NotificationStack.vala"
		clutter_actor_add_transition ((ClutterActor*) _data4_->notification, GALA_NOTIFICATION_STACK_TRANSITION_ENTRY_NAME, (ClutterTransition*) _tmp28_);
#line 58 "../src/NotificationStack.vala"
		_g_object_unref0 (entry);
#line 58 "../src/NotificationStack.vala"
		_g_object_unref0 (flip_transition);
#line 58 "../src/NotificationStack.vala"
		_g_object_unref0 (opacity_transition);
#line 475 "NotificationStack.c"
	}
#line 79 "../src/NotificationStack.vala"
	_tmp29_ = self->priv->_display;
#line 79 "../src/NotificationStack.vala"
	primary = meta_display_get_primary_monitor (_tmp29_);
#line 80 "../src/NotificationStack.vala"
	_tmp30_ = self->priv->_display;
#line 80 "../src/NotificationStack.vala"
	_tmp31_ = meta_display_get_workspace_manager (_tmp30_);
#line 80 "../src/NotificationStack.vala"
	_tmp32_ = meta_workspace_manager_get_active_workspace (_tmp31_);
#line 80 "../src/NotificationStack.vala"
	meta_workspace_get_work_area_for_monitor (_tmp32_, primary, &_tmp33_);
#line 80 "../src/NotificationStack.vala"
	area = _tmp33_;
#line 81 "../src/NotificationStack.vala"
	_tmp34_ = self->priv->_display;
#line 81 "../src/NotificationStack.vala"
	scale = meta_display_get_monitor_scale (_tmp34_, primary);
#line 88 "../src/NotificationStack.vala"
	_tmp35_ = window_rect;
#line 88 "../src/NotificationStack.vala"
	gala_notification_stack_update_positions (self, animate, scale, (gfloat) _tmp35_.height);
#line 90 "../src/NotificationStack.vala"
	_tmp36_ = area;
#line 90 "../src/NotificationStack.vala"
	_tmp37_ = area;
#line 90 "../src/NotificationStack.vala"
	_tmp38_ = window_rect;
#line 90 "../src/NotificationStack.vala"
	notification_x_pos = (_tmp36_.x + _tmp37_.width) - _tmp38_.width;
#line 92 "../src/NotificationStack.vala"
	gala_notification_stack_move_window (_data4_->notification, notification_x_pos, (self->priv->stack_y + GALA_NOTIFICATION_STACK_TOP_OFFSET) + gala_internal_utils_scale_to_int (GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN, scale));
#line 93 "../src/NotificationStack.vala"
	_tmp39_ = self->priv->notifications;
#line 93 "../src/NotificationStack.vala"
	gee_abstract_list_insert ((GeeAbstractList*) _tmp39_, 0, _data4_->notification);
#line 51 "../src/NotificationStack.vala"
	block4_data_unref (_data4_);
#line 51 "../src/NotificationStack.vala"
	_data4_ = NULL;
#line 517 "NotificationStack.c"
}

static void
gala_notification_stack_update_stack_allocation (GalaNotificationStack* self)
{
	gint primary = 0;
	MetaDisplay* _tmp0_;
	MtkRectangle area = {0};
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspace* _tmp3_;
	MtkRectangle _tmp4_ = {0};
	gfloat scale = 0.0F;
	MetaDisplay* _tmp5_;
	MtkRectangle _tmp6_;
#line 96 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/NotificationStack.vala"
	_tmp0_ = self->priv->_display;
#line 97 "../src/NotificationStack.vala"
	primary = meta_display_get_primary_monitor (_tmp0_);
#line 98 "../src/NotificationStack.vala"
	_tmp1_ = self->priv->_display;
#line 98 "../src/NotificationStack.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 98 "../src/NotificationStack.vala"
	_tmp3_ = meta_workspace_manager_get_active_workspace (_tmp2_);
#line 98 "../src/NotificationStack.vala"
	meta_workspace_get_work_area_for_monitor (_tmp3_, primary, &_tmp4_);
#line 98 "../src/NotificationStack.vala"
	area = _tmp4_;
#line 100 "../src/NotificationStack.vala"
	_tmp5_ = self->priv->_display;
#line 100 "../src/NotificationStack.vala"
	scale = meta_display_get_monitor_scale (_tmp5_, primary);
#line 101 "../src/NotificationStack.vala"
	self->priv->stack_width = gala_internal_utils_scale_to_int (GALA_NOTIFICATION_STACK_WIDTH + GALA_NOTIFICATION_STACK_MARGIN, scale);
#line 103 "../src/NotificationStack.vala"
	_tmp6_ = area;
#line 103 "../src/NotificationStack.vala"
	self->priv->stack_y = _tmp6_.y;
#line 559 "NotificationStack.c"
}

static void
gala_notification_stack_update_positions (GalaNotificationStack* self,
                                          gboolean animate,
                                          gfloat scale,
                                          gfloat add_y)
{
	gfloat y = 0.0F;
	gint i = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_ = 0;
	gint delay_step = 0;
	gint iterator = 0;
#line 106 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/NotificationStack.vala"
	y = ((self->priv->stack_y + GALA_NOTIFICATION_STACK_TOP_OFFSET) + add_y) + gala_internal_utils_scale_to_int (GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN, scale);
#line 108 "../src/NotificationStack.vala"
	_tmp0_ = self->priv->notifications;
#line 108 "../src/NotificationStack.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 108 "../src/NotificationStack.vala"
	_tmp2_ = _tmp1_;
#line 108 "../src/NotificationStack.vala"
	i = _tmp2_;
#line 109 "../src/NotificationStack.vala"
	if (i > 0) {
#line 109 "../src/NotificationStack.vala"
		_tmp3_ = 150 / i;
#line 592 "NotificationStack.c"
	} else {
#line 109 "../src/NotificationStack.vala"
		_tmp3_ = 0;
#line 596 "NotificationStack.c"
	}
#line 109 "../src/NotificationStack.vala"
	delay_step = _tmp3_;
#line 110 "../src/NotificationStack.vala"
	iterator = 0;
#line 112 "../src/NotificationStack.vala"
	while (TRUE) {
#line 604 "NotificationStack.c"
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		MetaWindowActor* actor = NULL;
		GeeArrayList* _tmp7_;
		gpointer _tmp8_;
		MetaWindowActor* _tmp9_;
		MetaWindowActor* _tmp16_;
		ClutterTransition* transition = NULL;
		MetaWindowActor* _tmp18_;
		ClutterTransition* _tmp19_;
		MetaWindowActor* _tmp20_;
		ClutterTransition* _tmp21_;
		ClutterTransition* _tmp22_;
		MetaWindow* window = NULL;
		MetaWindowActor* _tmp23_;
		MetaWindow* _tmp24_;
		MetaWindow* _tmp25_;
		MetaWindow* _tmp28_;
		MtkRectangle _tmp29_ = {0};
		gint _tmp30_;
#line 112 "../src/NotificationStack.vala"
		_tmp4_ = self->priv->notifications;
#line 112 "../src/NotificationStack.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 112 "../src/NotificationStack.vala"
		_tmp6_ = _tmp5_;
#line 112 "../src/NotificationStack.vala"
		if (!(_tmp6_ > iterator)) {
#line 112 "../src/NotificationStack.vala"
			break;
#line 636 "NotificationStack.c"
		}
#line 113 "../src/NotificationStack.vala"
		_tmp7_ = self->priv->notifications;
#line 113 "../src/NotificationStack.vala"
		_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, iterator);
#line 113 "../src/NotificationStack.vala"
		_tmp9_ = _g_object_ref0 ((MetaWindowActor*) _tmp8_);
#line 113 "../src/NotificationStack.vala"
		actor = _tmp9_;
#line 114 "../src/NotificationStack.vala"
		if (animate) {
#line 648 "NotificationStack.c"
			MetaWindowActor* _tmp10_;
			MetaWindowActor* _tmp11_;
			MetaWindowActor* _tmp12_;
			MetaWindowActor* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 115 "../src/NotificationStack.vala"
			_tmp10_ = actor;
#line 115 "../src/NotificationStack.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _tmp10_);
#line 116 "../src/NotificationStack.vala"
			_tmp11_ = actor;
#line 116 "../src/NotificationStack.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _tmp11_, CLUTTER_EASE_OUT_BACK);
#line 117 "../src/NotificationStack.vala"
			_tmp12_ = actor;
#line 117 "../src/NotificationStack.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _tmp12_, (guint) 200);
#line 118 "../src/NotificationStack.vala"
			_tmp13_ = actor;
#line 118 "../src/NotificationStack.vala"
			_tmp14_ = i;
#line 118 "../src/NotificationStack.vala"
			i = _tmp14_ - 1;
#line 118 "../src/NotificationStack.vala"
			_tmp15_ = delay_step;
#line 118 "../src/NotificationStack.vala"
			clutter_actor_set_easing_delay ((ClutterActor*) _tmp13_, (guint) (_tmp14_ * _tmp15_));
#line 677 "NotificationStack.c"
		}
#line 121 "../src/NotificationStack.vala"
		_tmp16_ = actor;
#line 121 "../src/NotificationStack.vala"
		gala_notification_stack_move_window (_tmp16_, -1, (gint) y);
#line 123 "../src/NotificationStack.vala"
		if (animate) {
#line 685 "NotificationStack.c"
			MetaWindowActor* _tmp17_;
#line 124 "../src/NotificationStack.vala"
			_tmp17_ = actor;
#line 124 "../src/NotificationStack.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _tmp17_);
#line 691 "NotificationStack.c"
		}
#line 128 "../src/NotificationStack.vala"
		_tmp18_ = actor;
#line 128 "../src/NotificationStack.vala"
		_tmp19_ = clutter_actor_get_transition ((ClutterActor*) _tmp18_, "position");
#line 128 "../src/NotificationStack.vala"
		transition = _tmp19_;
#line 129 "../src/NotificationStack.vala"
		_tmp20_ = actor;
#line 129 "../src/NotificationStack.vala"
		_tmp21_ = transition;
#line 129 "../src/NotificationStack.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 129 "../src/NotificationStack.vala"
		g_object_set_data_full ((GObject*) _tmp20_, GALA_NOTIFICATION_STACK_TRANSITION_MOVE_STACK_ID, _tmp22_, g_object_unref);
#line 131 "../src/NotificationStack.vala"
		_tmp23_ = actor;
#line 131 "../src/NotificationStack.vala"
		_tmp24_ = meta_window_actor_get_meta_window (_tmp23_);
#line 131 "../src/NotificationStack.vala"
		window = _tmp24_;
#line 132 "../src/NotificationStack.vala"
		_tmp25_ = window;
#line 132 "../src/NotificationStack.vala"
		if (_tmp25_ == NULL) {
#line 717 "NotificationStack.c"
			GeeArrayList* _tmp26_;
			MetaWindowActor* _tmp27_;
#line 138 "../src/NotificationStack.vala"
			_tmp26_ = self->priv->notifications;
#line 138 "../src/NotificationStack.vala"
			_tmp27_ = actor;
#line 138 "../src/NotificationStack.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 139 "../src/NotificationStack.vala"
			g_warning ("NotificationStack.vala:139: NotificationStack: Notification window was" \
" null (probably removed during workspace transition?)");
#line 140 "../src/NotificationStack.vala"
			_g_object_unref0 (actor);
#line 140 "../src/NotificationStack.vala"
			continue;
#line 732 "NotificationStack.c"
		}
#line 143 "../src/NotificationStack.vala"
		_tmp28_ = window;
#line 143 "../src/NotificationStack.vala"
		meta_window_get_frame_rect (_tmp28_, &_tmp29_);
#line 143 "../src/NotificationStack.vala"
		y += (gfloat) _tmp29_.height;
#line 144 "../src/NotificationStack.vala"
		_tmp30_ = iterator;
#line 144 "../src/NotificationStack.vala"
		iterator = _tmp30_ + 1;
#line 112 "../src/NotificationStack.vala"
		_g_object_unref0 (actor);
#line 746 "NotificationStack.c"
	}
}

void
gala_notification_stack_destroy_notification (GalaNotificationStack* self,
                                              MetaWindowActor* notification,
                                              gboolean animate)
{
	gint primary = 0;
	MetaDisplay* _tmp4_;
	gfloat scale = 0.0F;
	MetaDisplay* _tmp5_;
	GeeArrayList* _tmp6_;
#line 148 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/NotificationStack.vala"
	g_return_if_fail (notification != NULL);
#line 149 "../src/NotificationStack.vala"
	if (animate) {
#line 766 "NotificationStack.c"
		gfloat _tmp0_;
		gfloat _tmp1_;
#line 150 "../src/NotificationStack.vala"
		clutter_actor_save_easing_state ((ClutterActor*) notification);
#line 151 "../src/NotificationStack.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) notification, (guint) 100);
#line 152 "../src/NotificationStack.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) notification, CLUTTER_EASE_IN_QUAD);
#line 153 "../src/NotificationStack.vala"
		clutter_actor_set_opacity ((ClutterActor*) notification, (guint) 0);
#line 155 "../src/NotificationStack.vala"
		_tmp0_ = clutter_actor_get_x ((ClutterActor*) notification);
#line 155 "../src/NotificationStack.vala"
		_tmp1_ = _tmp0_;
#line 155 "../src/NotificationStack.vala"
		clutter_actor_set_x ((ClutterActor*) notification, _tmp1_ + self->priv->stack_width);
#line 156 "../src/NotificationStack.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) notification);
#line 785 "NotificationStack.c"
	} else {
		gfloat _tmp2_;
		gfloat _tmp3_;
#line 158 "../src/NotificationStack.vala"
		clutter_actor_set_opacity ((ClutterActor*) notification, (guint) 0);
#line 159 "../src/NotificationStack.vala"
		_tmp2_ = clutter_actor_get_x ((ClutterActor*) notification);
#line 159 "../src/NotificationStack.vala"
		_tmp3_ = _tmp2_;
#line 159 "../src/NotificationStack.vala"
		clutter_actor_set_x ((ClutterActor*) notification, _tmp3_ + self->priv->stack_width);
#line 797 "NotificationStack.c"
	}
#line 162 "../src/NotificationStack.vala"
	_tmp4_ = self->priv->_display;
#line 162 "../src/NotificationStack.vala"
	primary = meta_display_get_primary_monitor (_tmp4_);
#line 163 "../src/NotificationStack.vala"
	_tmp5_ = self->priv->_display;
#line 163 "../src/NotificationStack.vala"
	scale = meta_display_get_monitor_scale (_tmp5_, primary);
#line 165 "../src/NotificationStack.vala"
	_tmp6_ = self->priv->notifications;
#line 165 "../src/NotificationStack.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, notification);
#line 166 "../src/NotificationStack.vala"
	gala_notification_stack_update_positions (self, animate, scale, 0.0f);
#line 813 "NotificationStack.c"
}

/**
     * This function takes care of properly updating both the actor
     * position and the actual window position.
     *
     * To enable animations for a window we first need to move it's frame
     * in the compositor and then calculate & apply the coordinates for the window
     * actor.
     */
static void
gala_notification_stack_move_window (MetaWindowActor* actor,
                                     gint x,
                                     gint y)
{
	MetaWindow* window = NULL;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MtkRectangle rect = {0};
	MetaWindow* _tmp2_;
	MtkRectangle _tmp3_ = {0};
	gint _tmp4_ = 0;
	gint _tmp6_ = 0;
	MetaWindow* _tmp8_;
	MetaWindow* _tmp9_;
	MtkRectangle _tmp10_ = {0};
	MtkRectangle _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	MtkRectangle _tmp14_;
	MtkRectangle _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	MtkRectangle _tmp18_;
#line 177 "../src/NotificationStack.vala"
	g_return_if_fail (actor != NULL);
#line 178 "../src/NotificationStack.vala"
	if (meta_window_actor_is_destroyed (actor)) {
#line 179 "../src/NotificationStack.vala"
		return;
#line 854 "NotificationStack.c"
	}
#line 182 "../src/NotificationStack.vala"
	_tmp0_ = meta_window_actor_get_meta_window (actor);
#line 182 "../src/NotificationStack.vala"
	window = _tmp0_;
#line 183 "../src/NotificationStack.vala"
	_tmp1_ = window;
#line 183 "../src/NotificationStack.vala"
	if (_tmp1_ == NULL) {
#line 184 "../src/NotificationStack.vala"
		return;
#line 866 "NotificationStack.c"
	}
#line 187 "../src/NotificationStack.vala"
	_tmp2_ = window;
#line 187 "../src/NotificationStack.vala"
	meta_window_get_frame_rect (_tmp2_, &_tmp3_);
#line 187 "../src/NotificationStack.vala"
	rect = _tmp3_;
#line 189 "../src/NotificationStack.vala"
	if (x != -1) {
#line 189 "../src/NotificationStack.vala"
		_tmp4_ = x;
#line 878 "NotificationStack.c"
	} else {
		MtkRectangle _tmp5_;
#line 189 "../src/NotificationStack.vala"
		_tmp5_ = rect;
#line 189 "../src/NotificationStack.vala"
		_tmp4_ = _tmp5_.x;
#line 885 "NotificationStack.c"
	}
#line 189 "../src/NotificationStack.vala"
	if (y != -1) {
#line 189 "../src/NotificationStack.vala"
		_tmp6_ = y;
#line 891 "NotificationStack.c"
	} else {
		MtkRectangle _tmp7_;
#line 189 "../src/NotificationStack.vala"
		_tmp7_ = rect;
#line 189 "../src/NotificationStack.vala"
		_tmp6_ = _tmp7_.y;
#line 898 "NotificationStack.c"
	}
#line 189 "../src/NotificationStack.vala"
	_tmp8_ = window;
#line 189 "../src/NotificationStack.vala"
	meta_window_move_frame (_tmp8_, FALSE, _tmp4_, _tmp6_);
#line 195 "../src/NotificationStack.vala"
	_tmp9_ = window;
#line 195 "../src/NotificationStack.vala"
	meta_window_get_buffer_rect (_tmp9_, &_tmp10_);
#line 195 "../src/NotificationStack.vala"
	rect = _tmp10_;
#line 196 "../src/NotificationStack.vala"
	_tmp11_ = rect;
#line 196 "../src/NotificationStack.vala"
	_tmp12_ = clutter_actor_get_width ((ClutterActor*) actor);
#line 196 "../src/NotificationStack.vala"
	_tmp13_ = _tmp12_;
#line 196 "../src/NotificationStack.vala"
	_tmp14_ = rect;
#line 196 "../src/NotificationStack.vala"
	_tmp15_ = rect;
#line 196 "../src/NotificationStack.vala"
	_tmp16_ = clutter_actor_get_height ((ClutterActor*) actor);
#line 196 "../src/NotificationStack.vala"
	_tmp17_ = _tmp16_;
#line 196 "../src/NotificationStack.vala"
	_tmp18_ = rect;
#line 196 "../src/NotificationStack.vala"
	clutter_actor_set_position ((ClutterActor*) actor, _tmp11_.x - ((_tmp13_ - _tmp14_.width) / 2), _tmp15_.y - ((_tmp17_ - _tmp18_.height) / 2));
#line 928 "NotificationStack.c"
}

MetaDisplay*
gala_notification_stack_get_display (GalaNotificationStack* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 34 "../src/NotificationStack.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/NotificationStack.vala"
	_tmp0_ = self->priv->_display;
#line 34 "../src/NotificationStack.vala"
	result = _tmp0_;
#line 34 "../src/NotificationStack.vala"
	return result;
#line 944 "NotificationStack.c"
}

static void
gala_notification_stack_set_display (GalaNotificationStack* self,
                                     MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 34 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/NotificationStack.vala"
	old_value = gala_notification_stack_get_display (self);
#line 34 "../src/NotificationStack.vala"
	if (old_value != value) {
#line 958 "NotificationStack.c"
		MetaDisplay* _tmp0_;
#line 34 "../src/NotificationStack.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/NotificationStack.vala"
		_g_object_unref0 (self->priv->_display);
#line 34 "../src/NotificationStack.vala"
		self->priv->_display = _tmp0_;
#line 34 "../src/NotificationStack.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_notification_stack_properties[GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY]);
#line 968 "NotificationStack.c"
	}
}

static void
_gala_notification_stack_update_stack_allocation_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                                 gpointer self)
{
#line 46 "../src/NotificationStack.vala"
	gala_notification_stack_update_stack_allocation ((GalaNotificationStack*) self);
#line 978 "NotificationStack.c"
}

static void
_gala_notification_stack_update_stack_allocation_meta_display_workareas_changed (MetaDisplay* _sender,
                                                                                 gpointer self)
{
#line 47 "../src/NotificationStack.vala"
	gala_notification_stack_update_stack_allocation ((GalaNotificationStack*) self);
#line 987 "NotificationStack.c"
}

static GObject *
gala_notification_stack_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaNotificationStack * self;
	GeeArrayList* _tmp0_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaDisplay* _tmp1_;
	MetaContext* _tmp2_;
	MetaBackend* _tmp3_;
	MetaMonitorManager* _tmp4_;
	MetaMonitorManager* _tmp5_;
	MetaDisplay* _tmp6_;
#line 42 "../src/NotificationStack.vala"
	parent_class = G_OBJECT_CLASS (gala_notification_stack_parent_class);
#line 42 "../src/NotificationStack.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 42 "../src/NotificationStack.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
#line 43 "../src/NotificationStack.vala"
	_tmp0_ = gee_array_list_new (meta_window_actor_get_type (), NULL, NULL, NULL, NULL, NULL);
#line 43 "../src/NotificationStack.vala"
	_g_object_unref0 (self->priv->notifications);
#line 43 "../src/NotificationStack.vala"
	self->priv->notifications = _tmp0_;
#line 45 "../src/NotificationStack.vala"
	_tmp1_ = self->priv->_display;
#line 45 "../src/NotificationStack.vala"
	_tmp2_ = meta_display_get_context (_tmp1_);
#line 45 "../src/NotificationStack.vala"
	_tmp3_ = meta_context_get_backend (_tmp2_);
#line 45 "../src/NotificationStack.vala"
	_tmp4_ = meta_backend_get_monitor_manager (_tmp3_);
#line 45 "../src/NotificationStack.vala"
	monitor_manager = _tmp4_;
#line 46 "../src/NotificationStack.vala"
	_tmp5_ = monitor_manager;
#line 46 "../src/NotificationStack.vala"
	g_signal_connect_object (_tmp5_, "monitors-changed-internal", (GCallback) _gala_notification_stack_update_stack_allocation_meta_monitor_manager_monitors_changed_internal, self, 0);
#line 47 "../src/NotificationStack.vala"
	_tmp6_ = self->priv->_display;
#line 47 "../src/NotificationStack.vala"
	g_signal_connect_object (_tmp6_, "workareas-changed", (GCallback) _gala_notification_stack_update_stack_allocation_meta_display_workareas_changed, self, 0);
#line 48 "../src/NotificationStack.vala"
	gala_notification_stack_update_stack_allocation (self);
#line 42 "../src/NotificationStack.vala"
	return obj;
#line 1040 "NotificationStack.c"
}

static void
gala_notification_stack_class_init (GalaNotificationStackClass * klass,
                                    gpointer klass_data)
{
#line 19 "../src/NotificationStack.vala"
	gala_notification_stack_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/NotificationStack.vala"
	g_type_class_adjust_private_offset (klass, &GalaNotificationStack_private_offset);
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_notification_stack_get_property;
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_notification_stack_set_property;
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_notification_stack_constructor;
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_notification_stack_finalize;
#line 19 "../src/NotificationStack.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY, gala_notification_stack_properties[GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1061 "NotificationStack.c"
}

static void
gala_notification_stack_instance_init (GalaNotificationStack * self,
                                       gpointer klass)
{
#line 19 "../src/NotificationStack.vala"
	self->priv = gala_notification_stack_get_instance_private (self);
#line 1070 "NotificationStack.c"
}

static void
gala_notification_stack_finalize (GObject * obj)
{
	GalaNotificationStack * self;
#line 19 "../src/NotificationStack.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
#line 34 "../src/NotificationStack.vala"
	_g_object_unref0 (self->priv->_display);
#line 36 "../src/NotificationStack.vala"
	_g_object_unref0 (self->priv->notifications);
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (gala_notification_stack_parent_class)->finalize (obj);
#line 1085 "NotificationStack.c"
}

static GType
gala_notification_stack_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaNotificationStackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_notification_stack_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaNotificationStack), 0, (GInstanceInitFunc) gala_notification_stack_instance_init, NULL };
	GType gala_notification_stack_type_id;
	gala_notification_stack_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaNotificationStack", &g_define_type_info, 0);
	GalaNotificationStack_private_offset = g_type_add_instance_private (gala_notification_stack_type_id, sizeof (GalaNotificationStackPrivate));
	return gala_notification_stack_type_id;
}

GType
gala_notification_stack_get_type (void)
{
	static volatile gsize gala_notification_stack_type_id__once = 0;
	if (g_once_init_enter (&gala_notification_stack_type_id__once)) {
		GType gala_notification_stack_type_id;
		gala_notification_stack_type_id = gala_notification_stack_get_type_once ();
		g_once_init_leave (&gala_notification_stack_type_id__once, gala_notification_stack_type_id);
	}
	return gala_notification_stack_type_id__once;
}

static void
_vala_gala_notification_stack_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	GalaNotificationStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
#line 19 "../src/NotificationStack.vala"
	switch (property_id) {
#line 19 "../src/NotificationStack.vala"
		case GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY:
#line 19 "../src/NotificationStack.vala"
		g_value_set_object (value, gala_notification_stack_get_display (self));
#line 19 "../src/NotificationStack.vala"
		break;
#line 1126 "NotificationStack.c"
		default:
#line 19 "../src/NotificationStack.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/NotificationStack.vala"
		break;
#line 1132 "NotificationStack.c"
	}
}

static void
_vala_gala_notification_stack_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	GalaNotificationStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
#line 19 "../src/NotificationStack.vala"
	switch (property_id) {
#line 19 "../src/NotificationStack.vala"
		case GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY:
#line 19 "../src/NotificationStack.vala"
		gala_notification_stack_set_display (self, g_value_get_object (value));
#line 19 "../src/NotificationStack.vala"
		break;
#line 1152 "NotificationStack.c"
		default:
#line 19 "../src/NotificationStack.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/NotificationStack.vala"
		break;
#line 1158 "NotificationStack.c"
	}
}

