/* PointerLocator.c generated by valac 0.56.17, the Vala compiler
 * generated from PointerLocator.vala, do not modify */

/**/
/*  Copyright 2020 elementary, Inc. (https://elementary.io)*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <clutter/clutter.h>
#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <cogl/cogl.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <meta/display.h>
#include <meta/meta-plugin.h>
#include <meta/meta-cursor-tracker.h>
#include <graphene-gobject.h>
#include <string.h>

#define GALA_POINTER_LOCATOR_WIDTH_PX 300
#define GALA_POINTER_LOCATOR_HEIGHT_PX 300
#define GALA_POINTER_LOCATOR_ANIMATION_TIME_MS 300
#define GALA_POINTER_LOCATOR_BORDER_WIDTH_PX 1
#define GALA_POINTER_LOCATOR_BACKGROUND_OPACITY 0.7
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_POINTER_LOCATOR (gala_pointer_locator_get_type ())
#define GALA_POINTER_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator))
#define GALA_POINTER_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocatorClass))
#define GALA_IS_POINTER_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_POINTER_LOCATOR))
#define GALA_IS_POINTER_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_POINTER_LOCATOR))
#define GALA_POINTER_LOCATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocatorClass))

typedef struct _GalaPointerLocator GalaPointerLocator;
typedef struct _GalaPointerLocatorClass GalaPointerLocatorClass;
typedef struct _GalaPointerLocatorPrivate GalaPointerLocatorPrivate;
enum  {
	GALA_POINTER_LOCATOR_0_PROPERTY,
	GALA_POINTER_LOCATOR_WM_PROPERTY,
	GALA_POINTER_LOCATOR_NUM_PROPERTIES
};
static GParamSpec* gala_pointer_locator_properties[GALA_POINTER_LOCATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cogl_object_unref0(var) ((var == NULL) ? NULL : (var = (cogl_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _GalaPointerLocator {
	ClutterActor parent_instance;
	GalaPointerLocatorPrivate * priv;
};

struct _GalaPointerLocatorClass {
	ClutterActorClass parent_class;
};

struct _GalaPointerLocatorPrivate {
	GalaWindowManager* _wm;
	gfloat scaling_factor;
	gint surface_width;
	gint surface_height;
	GSettings* settings;
	CoglPipeline* pipeline;
	cairo_surface_t* surface;
	cairo_pattern_t* stroke_color;
	cairo_pattern_t* fill_color;
};

static gint GalaPointerLocator_private_offset;
static gpointer gala_pointer_locator_parent_class = NULL;
static ClutterAnimatableInterface * gala_pointer_locator_clutter_animatable_parent_iface = NULL;

VALA_EXTERN GType gala_pointer_locator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPointerLocator, g_object_unref)
VALA_EXTERN GalaPointerLocator* gala_pointer_locator_new (GalaWindowManager* wm);
VALA_EXTERN GalaPointerLocator* gala_pointer_locator_construct (GType object_type,
                                                    GalaWindowManager* wm);
static void gala_pointer_locator_update_surface (GalaPointerLocator* self,
                                          gfloat cur_scale);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static void gala_pointer_locator_real_paint (ClutterActor* base,
                                      ClutterPaintContext* context);
VALA_EXTERN void gala_pointer_locator_show_ripple (GalaPointerLocator* self);
static void __lambda81_ (GalaPointerLocator* self);
static void ___lambda81__clutter_timeline_stopped (ClutterTimeline* _sender,
                                            gboolean is_finished,
                                            gpointer self);
static void __lambda82_ (GalaPointerLocator* self);
static void ___lambda82__clutter_timeline_started (ClutterTimeline* _sender,
                                            gpointer self);
VALA_EXTERN void gala_internal_utils_get_theme_accent_color (GdkRGBA* result);
VALA_EXTERN GalaWindowManager* gala_pointer_locator_get_wm (GalaPointerLocator* self);
static void gala_pointer_locator_set_wm (GalaPointerLocator* self,
                                  GalaWindowManager* value);
static GObject * gala_pointer_locator_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void gala_pointer_locator_finalize (GObject * obj);
static GType gala_pointer_locator_get_type_once (void);
static void _vala_gala_pointer_locator_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_pointer_locator_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_pointer_locator_get_instance_private (GalaPointerLocator* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPointerLocator_private_offset);
}

GalaPointerLocator*
gala_pointer_locator_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaPointerLocator * self = NULL;
#line 40 "../src/Widgets/PointerLocator.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 41 "../src/Widgets/PointerLocator.vala"
	self = (GalaPointerLocator*) g_object_new (object_type, "wm", wm, NULL);
#line 40 "../src/Widgets/PointerLocator.vala"
	return self;
#line 164 "PointerLocator.c"
}

GalaPointerLocator*
gala_pointer_locator_new (GalaWindowManager* wm)
{
#line 40 "../src/Widgets/PointerLocator.vala"
	return gala_pointer_locator_construct (GALA_TYPE_POINTER_LOCATOR, wm);
#line 172 "PointerLocator.c"
}

static void
gala_pointer_locator_update_surface (GalaPointerLocator* self,
                                     gfloat cur_scale)
{
	gboolean _tmp0_ = FALSE;
	cairo_surface_t* _tmp1_;
#line 56 "../src/Widgets/PointerLocator.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/Widgets/PointerLocator.vala"
	_tmp1_ = self->priv->surface;
#line 57 "../src/Widgets/PointerLocator.vala"
	if (_tmp1_ == NULL) {
#line 57 "../src/Widgets/PointerLocator.vala"
		_tmp0_ = TRUE;
#line 189 "PointerLocator.c"
	} else {
#line 57 "../src/Widgets/PointerLocator.vala"
		_tmp0_ = cur_scale != self->priv->scaling_factor;
#line 193 "PointerLocator.c"
	}
#line 57 "../src/Widgets/PointerLocator.vala"
	if (_tmp0_) {
#line 197 "PointerLocator.c"
		cairo_surface_t* _tmp2_;
#line 58 "../src/Widgets/PointerLocator.vala"
		self->priv->scaling_factor = cur_scale;
#line 59 "../src/Widgets/PointerLocator.vala"
		self->priv->surface_width = gala_internal_utils_scale_to_int (GALA_POINTER_LOCATOR_WIDTH_PX, self->priv->scaling_factor);
#line 60 "../src/Widgets/PointerLocator.vala"
		self->priv->surface_height = gala_internal_utils_scale_to_int (GALA_POINTER_LOCATOR_HEIGHT_PX, self->priv->scaling_factor);
#line 62 "../src/Widgets/PointerLocator.vala"
		_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, self->priv->surface_width, self->priv->surface_height);
#line 62 "../src/Widgets/PointerLocator.vala"
		_cairo_surface_destroy0 (self->priv->surface);
#line 62 "../src/Widgets/PointerLocator.vala"
		self->priv->surface = _tmp2_;
#line 64 "../src/Widgets/PointerLocator.vala"
		clutter_actor_set_size ((ClutterActor*) self, (gfloat) self->priv->surface_width, (gfloat) self->priv->surface_height);
#line 213 "PointerLocator.c"
	}
}

static gpointer
_cogl_object_ref0 (gpointer self)
{
#line 97 "../src/Widgets/PointerLocator.vala"
	return self ? cogl_object_ref (self) : NULL;
#line 222 "PointerLocator.c"
}

static void
gala_pointer_locator_real_paint (ClutterActor* base,
                                 ClutterPaintContext* context)
{
	GalaPointerLocator * self;
	gint radius = 0;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	gint border_width = 0;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	CoglContext* cogl_context = NULL;
	CoglFramebuffer* _tmp4_;
	CoglContext* _tmp5_;
	CoglContext* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 68 "../src/Widgets/PointerLocator.vala"
	self = (GalaPointerLocator*) base;
#line 68 "../src/Widgets/PointerLocator.vala"
	g_return_if_fail (context != NULL);
#line 69 "../src/Widgets/PointerLocator.vala"
	radius = MIN (self->priv->surface_width / 2, self->priv->surface_height / 2);
#line 71 "../src/Widgets/PointerLocator.vala"
	_tmp0_ = self->priv->surface;
#line 71 "../src/Widgets/PointerLocator.vala"
	_tmp1_ = cairo_create (_tmp0_);
#line 71 "../src/Widgets/PointerLocator.vala"
	cr = _tmp1_;
#line 72 "../src/Widgets/PointerLocator.vala"
	border_width = gala_internal_utils_scale_to_int (GALA_POINTER_LOCATOR_BORDER_WIDTH_PX, self->priv->scaling_factor);
#line 75 "../src/Widgets/PointerLocator.vala"
	cairo_save (cr);
#line 76 "../src/Widgets/PointerLocator.vala"
	cairo_set_source_rgba (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 77 "../src/Widgets/PointerLocator.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
#line 78 "../src/Widgets/PointerLocator.vala"
	cairo_paint (cr);
#line 79 "../src/Widgets/PointerLocator.vala"
	cairo_restore (cr);
#line 81 "../src/Widgets/PointerLocator.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 82 "../src/Widgets/PointerLocator.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 83 "../src/Widgets/PointerLocator.vala"
	cairo_translate (cr, (gdouble) (self->priv->surface_width / 2), (gdouble) (self->priv->surface_height / 2));
#line 85 "../src/Widgets/PointerLocator.vala"
	cairo_move_to (cr, (gdouble) (radius - GALA_POINTER_LOCATOR_BORDER_WIDTH_PX), (gdouble) 0);
#line 86 "../src/Widgets/PointerLocator.vala"
	cairo_arc (cr, (gdouble) 0, (gdouble) 0, (gdouble) (radius - border_width), (gdouble) 0, 2 * G_PI);
#line 87 "../src/Widgets/PointerLocator.vala"
	cairo_close_path (cr);
#line 89 "../src/Widgets/PointerLocator.vala"
	cairo_set_line_width (cr, (gdouble) 0);
#line 90 "../src/Widgets/PointerLocator.vala"
	_tmp2_ = self->priv->fill_color;
#line 90 "../src/Widgets/PointerLocator.vala"
	cairo_set_source (cr, _tmp2_);
#line 91 "../src/Widgets/PointerLocator.vala"
	cairo_fill_preserve (cr);
#line 93 "../src/Widgets/PointerLocator.vala"
	cairo_set_line_width (cr, (gdouble) border_width);
#line 94 "../src/Widgets/PointerLocator.vala"
	_tmp3_ = self->priv->stroke_color;
#line 94 "../src/Widgets/PointerLocator.vala"
	cairo_set_source (cr, _tmp3_);
#line 95 "../src/Widgets/PointerLocator.vala"
	cairo_stroke (cr);
#line 97 "../src/Widgets/PointerLocator.vala"
	_tmp4_ = clutter_paint_context_get_framebuffer (context);
#line 97 "../src/Widgets/PointerLocator.vala"
	_tmp5_ = cogl_framebuffer_get_context (_tmp4_);
#line 97 "../src/Widgets/PointerLocator.vala"
	_tmp6_ = _cogl_object_ref0 (_tmp5_);
#line 97 "../src/Widgets/PointerLocator.vala"
	cogl_context = _tmp6_;
#line 302 "PointerLocator.c"
	{
		CoglTexture2D* texture = NULL;
		cairo_surface_t* _tmp7_;
		cairo_surface_t* _tmp8_;
		guchar* _tmp9_;
		CoglTexture2D* _tmp10_;
		CoglPipeline* _tmp11_;
		CoglFramebuffer* _tmp12_;
		CoglPipeline* _tmp13_;
#line 100 "../src/Widgets/PointerLocator.vala"
		_tmp7_ = self->priv->surface;
#line 100 "../src/Widgets/PointerLocator.vala"
		_tmp8_ = self->priv->surface;
#line 100 "../src/Widgets/PointerLocator.vala"
		_tmp9_ = cairo_image_surface_get_data (_tmp8_);
#line 100 "../src/Widgets/PointerLocator.vala"
		_tmp10_ = cogl_texture_2d_new_from_data (cogl_context, self->priv->surface_width, self->priv->surface_height, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp7_), (const uint8_t*) _tmp9_, &_inner_error0_);
#line 100 "../src/Widgets/PointerLocator.vala"
		texture = _tmp10_;
#line 100 "../src/Widgets/PointerLocator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 324 "PointerLocator.c"
			goto __catch0_g_error;
		}
#line 103 "../src/Widgets/PointerLocator.vala"
		_tmp11_ = self->priv->pipeline;
#line 103 "../src/Widgets/PointerLocator.vala"
		cogl_pipeline_set_layer_texture (_tmp11_, 0, (CoglTexture*) texture);
#line 105 "../src/Widgets/PointerLocator.vala"
		_tmp12_ = clutter_paint_context_get_framebuffer (context);
#line 105 "../src/Widgets/PointerLocator.vala"
		_tmp13_ = self->priv->pipeline;
#line 105 "../src/Widgets/PointerLocator.vala"
		cogl_framebuffer_draw_rectangle (_tmp12_, _tmp13_, (gfloat) 0, (gfloat) 0, (gfloat) self->priv->surface_width, (gfloat) self->priv->surface_height);
#line 99 "../src/Widgets/PointerLocator.vala"
		_cogl_object_unref0 (texture);
#line 339 "PointerLocator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 99 "../src/Widgets/PointerLocator.vala"
		g_clear_error (&_inner_error0_);
#line 346 "PointerLocator.c"
	}
	__finally0:
#line 99 "../src/Widgets/PointerLocator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/Widgets/PointerLocator.vala"
		_cogl_object_unref0 (cogl_context);
#line 99 "../src/Widgets/PointerLocator.vala"
		_cairo_destroy0 (cr);
#line 99 "../src/Widgets/PointerLocator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/Widgets/PointerLocator.vala"
		g_clear_error (&_inner_error0_);
#line 99 "../src/Widgets/PointerLocator.vala"
		return;
#line 361 "PointerLocator.c"
	}
#line 108 "../src/Widgets/PointerLocator.vala"
	CLUTTER_ACTOR_CLASS (gala_pointer_locator_parent_class)->paint (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor), context);
#line 68 "../src/Widgets/PointerLocator.vala"
	_cogl_object_unref0 (cogl_context);
#line 68 "../src/Widgets/PointerLocator.vala"
	_cairo_destroy0 (cr);
#line 369 "PointerLocator.c"
}

static void
__lambda81_ (GalaPointerLocator* self)
{
#line 137 "../src/Widgets/PointerLocator.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 377 "PointerLocator.c"
}

static void
___lambda81__clutter_timeline_stopped (ClutterTimeline* _sender,
                                       gboolean is_finished,
                                       gpointer self)
{
#line 137 "../src/Widgets/PointerLocator.vala"
	__lambda81_ ((GalaPointerLocator*) self);
#line 387 "PointerLocator.c"
}

static void
__lambda82_ (GalaPointerLocator* self)
{
#line 138 "../src/Widgets/PointerLocator.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 395 "PointerLocator.c"
}

static void
___lambda82__clutter_timeline_started (ClutterTimeline* _sender,
                                       gpointer self)
{
#line 138 "../src/Widgets/PointerLocator.vala"
	__lambda82_ ((GalaPointerLocator*) self);
#line 404 "PointerLocator.c"
}

void
gala_pointer_locator_show_ripple (GalaPointerLocator* self)
{
	GSettings* _tmp0_;
	ClutterTransition* old_transition = NULL;
	ClutterTransition* _tmp1_;
	ClutterTransition* _tmp2_;
	ClutterTransitionGroup* transition = NULL;
	ClutterTransitionGroup* _tmp4_;
	ClutterTransitionGroup* _tmp5_;
	ClutterPropertyTransition* transition_x = NULL;
	ClutterPropertyTransition* _tmp6_;
	ClutterPropertyTransition* transition_y = NULL;
	ClutterPropertyTransition* _tmp7_;
	GValue start_val = {0};
	GValue _tmp8_ = {0};
	GValue stop_val = {0};
	GValue _tmp9_ = {0};
	ClutterPropertyTransition* _tmp10_;
	GValue _tmp11_;
	ClutterPropertyTransition* _tmp12_;
	GValue _tmp13_;
	ClutterPropertyTransition* _tmp14_;
	GValue _tmp15_;
	ClutterPropertyTransition* _tmp16_;
	GValue _tmp17_;
	ClutterTransitionGroup* _tmp18_;
	ClutterTransitionGroup* _tmp19_;
	ClutterTransitionGroup* _tmp20_;
	ClutterPropertyTransition* _tmp21_;
	ClutterTransitionGroup* _tmp22_;
	ClutterPropertyTransition* _tmp23_;
	ClutterTransitionGroup* _tmp24_;
	ClutterTransitionGroup* _tmp25_;
	ClutterTransitionGroup* _tmp26_;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp27_ = {0};
	GdkRGBA _tmp28_;
	GdkRGBA _tmp29_;
	GdkRGBA _tmp30_;
	cairo_pattern_t* _tmp31_;
	GdkRGBA _tmp32_;
	GdkRGBA _tmp33_;
	GdkRGBA _tmp34_;
	cairo_pattern_t* _tmp35_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp36_;
	MetaDisplay* _tmp37_;
	MetaCursorTracker* tracker = NULL;
	MetaDisplay* _tmp38_;
	MetaCursorTracker* _tmp39_;
	graphene_point_t coords = {0};
	graphene_point_t _tmp40_ = {0};
	MetaCursorTracker* _tmp41_;
	graphene_point_t _tmp42_ = {0};
	MetaDisplay* _tmp43_;
	MetaDisplay* _tmp44_;
	graphene_point_t _tmp45_;
	gfloat _tmp46_;
	gfloat _tmp47_;
	graphene_point_t _tmp48_;
	gfloat _tmp49_;
	gfloat _tmp50_;
	ClutterTransitionGroup* _tmp51_;
#line 111 "../src/Widgets/PointerLocator.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/Widgets/PointerLocator.vala"
	_tmp0_ = self->priv->settings;
#line 112 "../src/Widgets/PointerLocator.vala"
	if (!g_settings_get_boolean (_tmp0_, "locate-pointer")) {
#line 113 "../src/Widgets/PointerLocator.vala"
		return;
#line 479 "PointerLocator.c"
	}
#line 116 "../src/Widgets/PointerLocator.vala"
	_tmp1_ = clutter_actor_get_transition ((ClutterActor*) self, "circle");
#line 116 "../src/Widgets/PointerLocator.vala"
	old_transition = _tmp1_;
#line 117 "../src/Widgets/PointerLocator.vala"
	_tmp2_ = old_transition;
#line 117 "../src/Widgets/PointerLocator.vala"
	if (_tmp2_ != NULL) {
#line 489 "PointerLocator.c"
		ClutterTransition* _tmp3_;
#line 118 "../src/Widgets/PointerLocator.vala"
		_tmp3_ = old_transition;
#line 118 "../src/Widgets/PointerLocator.vala"
		clutter_timeline_stop ((ClutterTimeline*) _tmp3_);
#line 495 "PointerLocator.c"
	}
#line 121 "../src/Widgets/PointerLocator.vala"
	_tmp4_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
#line 121 "../src/Widgets/PointerLocator.vala"
	transition = _tmp4_;
#line 122 "../src/Widgets/PointerLocator.vala"
	_tmp5_ = transition;
#line 122 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp5_, TRUE);
#line 123 "../src/Widgets/PointerLocator.vala"
	_tmp6_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-x");
#line 123 "../src/Widgets/PointerLocator.vala"
	transition_x = _tmp6_;
#line 124 "../src/Widgets/PointerLocator.vala"
	_tmp7_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-y");
#line 124 "../src/Widgets/PointerLocator.vala"
	transition_y = _tmp7_;
#line 125 "../src/Widgets/PointerLocator.vala"
	g_value_init (&_tmp8_, G_TYPE_DOUBLE);
#line 125 "../src/Widgets/PointerLocator.vala"
	start_val = _tmp8_;
#line 126 "../src/Widgets/PointerLocator.vala"
	g_value_set_double (&start_val, (gdouble) 1);
#line 127 "../src/Widgets/PointerLocator.vala"
	g_value_init (&_tmp9_, G_TYPE_DOUBLE);
#line 127 "../src/Widgets/PointerLocator.vala"
	stop_val = _tmp9_;
#line 128 "../src/Widgets/PointerLocator.vala"
	g_value_set_double (&stop_val, (gdouble) 0);
#line 129 "../src/Widgets/PointerLocator.vala"
	_tmp10_ = transition_x;
#line 129 "../src/Widgets/PointerLocator.vala"
	_tmp11_ = start_val;
#line 129 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp10_, &_tmp11_);
#line 130 "../src/Widgets/PointerLocator.vala"
	_tmp12_ = transition_y;
#line 130 "../src/Widgets/PointerLocator.vala"
	_tmp13_ = start_val;
#line 130 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp12_, &_tmp13_);
#line 131 "../src/Widgets/PointerLocator.vala"
	_tmp14_ = transition_x;
#line 131 "../src/Widgets/PointerLocator.vala"
	_tmp15_ = stop_val;
#line 131 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp14_, &_tmp15_);
#line 132 "../src/Widgets/PointerLocator.vala"
	_tmp16_ = transition_y;
#line 132 "../src/Widgets/PointerLocator.vala"
	_tmp17_ = stop_val;
#line 132 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp16_, &_tmp17_);
#line 133 "../src/Widgets/PointerLocator.vala"
	_tmp18_ = transition;
#line 133 "../src/Widgets/PointerLocator.vala"
	clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp18_, CLUTTER_EASE_OUT_QUAD);
#line 134 "../src/Widgets/PointerLocator.vala"
	_tmp19_ = transition;
#line 134 "../src/Widgets/PointerLocator.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp19_, (guint) GALA_POINTER_LOCATOR_ANIMATION_TIME_MS);
#line 135 "../src/Widgets/PointerLocator.vala"
	_tmp20_ = transition;
#line 135 "../src/Widgets/PointerLocator.vala"
	_tmp21_ = transition_x;
#line 135 "../src/Widgets/PointerLocator.vala"
	clutter_transition_group_add_transition (_tmp20_, (ClutterTransition*) _tmp21_);
#line 136 "../src/Widgets/PointerLocator.vala"
	_tmp22_ = transition;
#line 136 "../src/Widgets/PointerLocator.vala"
	_tmp23_ = transition_y;
#line 136 "../src/Widgets/PointerLocator.vala"
	clutter_transition_group_add_transition (_tmp22_, (ClutterTransition*) _tmp23_);
#line 137 "../src/Widgets/PointerLocator.vala"
	_tmp24_ = transition;
#line 137 "../src/Widgets/PointerLocator.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp24_, "stopped", (GCallback) ___lambda81__clutter_timeline_stopped, self, 0);
#line 138 "../src/Widgets/PointerLocator.vala"
	_tmp25_ = transition;
#line 138 "../src/Widgets/PointerLocator.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp25_, "started", (GCallback) ___lambda82__clutter_timeline_started, self, 0);
#line 139 "../src/Widgets/PointerLocator.vala"
	_tmp26_ = transition;
#line 139 "../src/Widgets/PointerLocator.vala"
	clutter_actor_add_transition ((ClutterActor*) self, "circle", (ClutterTransition*) _tmp26_);
#line 141 "../src/Widgets/PointerLocator.vala"
	gala_internal_utils_get_theme_accent_color (&_tmp27_);
#line 141 "../src/Widgets/PointerLocator.vala"
	rgba = _tmp27_;
#line 144 "../src/Widgets/PointerLocator.vala"
	_tmp28_ = rgba;
#line 144 "../src/Widgets/PointerLocator.vala"
	_tmp29_ = rgba;
#line 144 "../src/Widgets/PointerLocator.vala"
	_tmp30_ = rgba;
#line 144 "../src/Widgets/PointerLocator.vala"
	_tmp31_ = cairo_pattern_create_rgb (_tmp28_.red, _tmp29_.green, _tmp30_.blue);
#line 144 "../src/Widgets/PointerLocator.vala"
	_cairo_pattern_destroy0 (self->priv->stroke_color);
#line 144 "../src/Widgets/PointerLocator.vala"
	self->priv->stroke_color = _tmp31_;
#line 145 "../src/Widgets/PointerLocator.vala"
	_tmp32_ = rgba;
#line 145 "../src/Widgets/PointerLocator.vala"
	_tmp33_ = rgba;
#line 145 "../src/Widgets/PointerLocator.vala"
	_tmp34_ = rgba;
#line 145 "../src/Widgets/PointerLocator.vala"
	_tmp35_ = cairo_pattern_create_rgba (_tmp32_.red, _tmp33_.green, _tmp34_.blue, GALA_POINTER_LOCATOR_BACKGROUND_OPACITY);
#line 145 "../src/Widgets/PointerLocator.vala"
	_cairo_pattern_destroy0 (self->priv->fill_color);
#line 145 "../src/Widgets/PointerLocator.vala"
	self->priv->fill_color = _tmp35_;
#line 147 "../src/Widgets/PointerLocator.vala"
	_tmp36_ = self->priv->_wm;
#line 147 "../src/Widgets/PointerLocator.vala"
	_tmp37_ = meta_plugin_get_display ((MetaPlugin*) _tmp36_);
#line 147 "../src/Widgets/PointerLocator.vala"
	display = _tmp37_;
#line 148 "../src/Widgets/PointerLocator.vala"
	_tmp38_ = display;
#line 148 "../src/Widgets/PointerLocator.vala"
	_tmp39_ = meta_cursor_tracker_get_for_display (_tmp38_);
#line 148 "../src/Widgets/PointerLocator.vala"
	tracker = _tmp39_;
#line 149 "../src/Widgets/PointerLocator.vala"
	coords = _tmp40_;
#line 150 "../src/Widgets/PointerLocator.vala"
	_tmp41_ = tracker;
#line 150 "../src/Widgets/PointerLocator.vala"
	meta_cursor_tracker_get_pointer (_tmp41_, &_tmp42_, NULL);
#line 150 "../src/Widgets/PointerLocator.vala"
	coords = _tmp42_;
#line 152 "../src/Widgets/PointerLocator.vala"
	_tmp43_ = display;
#line 152 "../src/Widgets/PointerLocator.vala"
	_tmp44_ = display;
#line 152 "../src/Widgets/PointerLocator.vala"
	gala_pointer_locator_update_surface (self, meta_display_get_monitor_scale (_tmp43_, meta_display_get_current_monitor (_tmp44_)));
#line 154 "../src/Widgets/PointerLocator.vala"
	_tmp45_ = coords;
#line 154 "../src/Widgets/PointerLocator.vala"
	_tmp46_ = clutter_actor_get_width ((ClutterActor*) self);
#line 154 "../src/Widgets/PointerLocator.vala"
	_tmp47_ = _tmp46_;
#line 154 "../src/Widgets/PointerLocator.vala"
	clutter_actor_set_x ((ClutterActor*) self, _tmp45_.x - (_tmp47_ / 2));
#line 155 "../src/Widgets/PointerLocator.vala"
	_tmp48_ = coords;
#line 155 "../src/Widgets/PointerLocator.vala"
	_tmp49_ = clutter_actor_get_width ((ClutterActor*) self);
#line 155 "../src/Widgets/PointerLocator.vala"
	_tmp50_ = _tmp49_;
#line 155 "../src/Widgets/PointerLocator.vala"
	clutter_actor_set_y ((ClutterActor*) self, _tmp48_.y - (_tmp50_ / 2));
#line 157 "../src/Widgets/PointerLocator.vala"
	_tmp51_ = transition;
#line 157 "../src/Widgets/PointerLocator.vala"
	clutter_timeline_start ((ClutterTimeline*) _tmp51_);
#line 111 "../src/Widgets/PointerLocator.vala"
	G_IS_VALUE (&stop_val) ? (g_value_unset (&stop_val), NULL) : NULL;
#line 111 "../src/Widgets/PointerLocator.vala"
	G_IS_VALUE (&start_val) ? (g_value_unset (&start_val), NULL) : NULL;
#line 111 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (transition_y);
#line 111 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (transition_x);
#line 111 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (transition);
#line 665 "PointerLocator.c"
}

GalaWindowManager*
gala_pointer_locator_get_wm (GalaPointerLocator* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 28 "../src/Widgets/PointerLocator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Widgets/PointerLocator.vala"
	_tmp0_ = self->priv->_wm;
#line 28 "../src/Widgets/PointerLocator.vala"
	result = _tmp0_;
#line 28 "../src/Widgets/PointerLocator.vala"
	return result;
#line 681 "PointerLocator.c"
}

static void
gala_pointer_locator_set_wm (GalaPointerLocator* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 28 "../src/Widgets/PointerLocator.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/PointerLocator.vala"
	old_value = gala_pointer_locator_get_wm (self);
#line 28 "../src/Widgets/PointerLocator.vala"
	if (old_value != value) {
#line 28 "../src/Widgets/PointerLocator.vala"
		self->priv->_wm = value;
#line 28 "../src/Widgets/PointerLocator.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_pointer_locator_properties[GALA_POINTER_LOCATOR_WM_PROPERTY]);
#line 699 "PointerLocator.c"
	}
}

static GObject *
gala_pointer_locator_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaPointerLocator * self;
	GSettings* _tmp0_;
	ClutterBackend* _tmp1_;
	CoglContext* _tmp2_;
	CoglPipeline* _tmp3_;
	graphene_point_t pivot = {0};
	graphene_point_t _tmp4_;
#line 44 "../src/Widgets/PointerLocator.vala"
	parent_class = G_OBJECT_CLASS (gala_pointer_locator_parent_class);
#line 44 "../src/Widgets/PointerLocator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../src/Widgets/PointerLocator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator);
#line 45 "../src/Widgets/PointerLocator.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 46 "../src/Widgets/PointerLocator.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, FALSE);
#line 48 "../src/Widgets/PointerLocator.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
#line 48 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (self->priv->settings);
#line 48 "../src/Widgets/PointerLocator.vala"
	self->priv->settings = _tmp0_;
#line 49 "../src/Widgets/PointerLocator.vala"
	_tmp1_ = clutter_get_default_backend ();
#line 49 "../src/Widgets/PointerLocator.vala"
	_tmp2_ = clutter_backend_get_cogl_context (_tmp1_);
#line 49 "../src/Widgets/PointerLocator.vala"
	_tmp3_ = cogl_pipeline_new (_tmp2_);
#line 49 "../src/Widgets/PointerLocator.vala"
	_cogl_object_unref0 (self->priv->pipeline);
#line 49 "../src/Widgets/PointerLocator.vala"
	self->priv->pipeline = _tmp3_;
#line 51 "../src/Widgets/PointerLocator.vala"
	memset (&pivot, 0, sizeof (graphene_point_t));
#line 52 "../src/Widgets/PointerLocator.vala"
	graphene_point_init (&pivot, 0.5f, 0.5f);
#line 53 "../src/Widgets/PointerLocator.vala"
	_tmp4_ = pivot;
#line 53 "../src/Widgets/PointerLocator.vala"
	g_object_set ((ClutterActor*) self, "pivot-point", &_tmp4_, NULL);
#line 44 "../src/Widgets/PointerLocator.vala"
	return obj;
#line 753 "PointerLocator.c"
}

static void
gala_pointer_locator_class_init (GalaPointerLocatorClass * klass,
                                 gpointer klass_data)
{
#line 19 "../src/Widgets/PointerLocator.vala"
	gala_pointer_locator_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/Widgets/PointerLocator.vala"
	g_type_class_adjust_private_offset (klass, &GalaPointerLocator_private_offset);
#line 19 "../src/Widgets/PointerLocator.vala"
	((ClutterActorClass *) klass)->paint = (void (*) (ClutterActor*, ClutterPaintContext*)) gala_pointer_locator_real_paint;
#line 19 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_pointer_locator_get_property;
#line 19 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_pointer_locator_set_property;
#line 19 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_pointer_locator_constructor;
#line 19 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_pointer_locator_finalize;
#line 19 "../src/Widgets/PointerLocator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_POINTER_LOCATOR_WM_PROPERTY, gala_pointer_locator_properties[GALA_POINTER_LOCATOR_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 776 "PointerLocator.c"
}

static void
gala_pointer_locator_clutter_animatable_interface_init (ClutterAnimatableInterface * iface,
                                                        gpointer iface_data)
{
#line 19 "../src/Widgets/PointerLocator.vala"
	gala_pointer_locator_clutter_animatable_parent_iface = g_type_interface_peek_parent (iface);
#line 785 "PointerLocator.c"
}

static void
gala_pointer_locator_instance_init (GalaPointerLocator * self,
                                    gpointer klass)
{
#line 19 "../src/Widgets/PointerLocator.vala"
	self->priv = gala_pointer_locator_get_instance_private (self);
#line 30 "../src/Widgets/PointerLocator.vala"
	self->priv->scaling_factor = 1.0f;
#line 31 "../src/Widgets/PointerLocator.vala"
	self->priv->surface_width = GALA_POINTER_LOCATOR_WIDTH_PX;
#line 32 "../src/Widgets/PointerLocator.vala"
	self->priv->surface_height = GALA_POINTER_LOCATOR_HEIGHT_PX;
#line 800 "PointerLocator.c"
}

static void
gala_pointer_locator_finalize (GObject * obj)
{
	GalaPointerLocator * self;
#line 19 "../src/Widgets/PointerLocator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator);
#line 34 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (self->priv->settings);
#line 35 "../src/Widgets/PointerLocator.vala"
	_cogl_object_unref0 (self->priv->pipeline);
#line 36 "../src/Widgets/PointerLocator.vala"
	_cairo_surface_destroy0 (self->priv->surface);
#line 37 "../src/Widgets/PointerLocator.vala"
	_cairo_pattern_destroy0 (self->priv->stroke_color);
#line 38 "../src/Widgets/PointerLocator.vala"
	_cairo_pattern_destroy0 (self->priv->fill_color);
#line 19 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (gala_pointer_locator_parent_class)->finalize (obj);
#line 821 "PointerLocator.c"
}

static GType
gala_pointer_locator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPointerLocatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_pointer_locator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPointerLocator), 0, (GInstanceInitFunc) gala_pointer_locator_instance_init, NULL };
	static const GInterfaceInfo clutter_animatable_info = { (GInterfaceInitFunc) gala_pointer_locator_clutter_animatable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_pointer_locator_type_id;
	gala_pointer_locator_type_id = g_type_register_static (clutter_actor_get_type (), "GalaPointerLocator", &g_define_type_info, 0);
	g_type_add_interface_static (gala_pointer_locator_type_id, clutter_animatable_get_type (), &clutter_animatable_info);
	GalaPointerLocator_private_offset = g_type_add_instance_private (gala_pointer_locator_type_id, sizeof (GalaPointerLocatorPrivate));
	return gala_pointer_locator_type_id;
}

GType
gala_pointer_locator_get_type (void)
{
	static volatile gsize gala_pointer_locator_type_id__once = 0;
	if (g_once_init_enter (&gala_pointer_locator_type_id__once)) {
		GType gala_pointer_locator_type_id;
		gala_pointer_locator_type_id = gala_pointer_locator_get_type_once ();
		g_once_init_leave (&gala_pointer_locator_type_id__once, gala_pointer_locator_type_id);
	}
	return gala_pointer_locator_type_id__once;
}

static void
_vala_gala_pointer_locator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaPointerLocator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator);
#line 19 "../src/Widgets/PointerLocator.vala"
	switch (property_id) {
#line 19 "../src/Widgets/PointerLocator.vala"
		case GALA_POINTER_LOCATOR_WM_PROPERTY:
#line 19 "../src/Widgets/PointerLocator.vala"
		g_value_set_object (value, gala_pointer_locator_get_wm (self));
#line 19 "../src/Widgets/PointerLocator.vala"
		break;
#line 864 "PointerLocator.c"
		default:
#line 19 "../src/Widgets/PointerLocator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Widgets/PointerLocator.vala"
		break;
#line 870 "PointerLocator.c"
	}
}

static void
_vala_gala_pointer_locator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaPointerLocator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator);
#line 19 "../src/Widgets/PointerLocator.vala"
	switch (property_id) {
#line 19 "../src/Widgets/PointerLocator.vala"
		case GALA_POINTER_LOCATOR_WM_PROPERTY:
#line 19 "../src/Widgets/PointerLocator.vala"
		gala_pointer_locator_set_wm (self, g_value_get_object (value));
#line 19 "../src/Widgets/PointerLocator.vala"
		break;
#line 890 "PointerLocator.c"
		default:
#line 19 "../src/Widgets/PointerLocator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Widgets/PointerLocator.vala"
		break;
#line 896 "PointerLocator.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 911 "PointerLocator.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 915 "PointerLocator.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 919 "PointerLocator.c"
}

