/* WindowOverview.c generated by valac 0.56.17, the Vala compiler
 * generated from WindowOverview.vala, do not modify */

/*
 * Copyright 2012 Tom Beckmann
 * Copyright 2012 Rico Tzschichholz
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <clutter/clutter.h>
#include "gala.h"
#include <glib-object.h>
#include <glib.h>
#include <meta/workspace.h>
#include <stdlib.h>
#include <string.h>
#include <meta/meta-workspace-manager.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>
#include <meta/keybindings.h>
#include <mtk/mtk.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>

#define GALA_WINDOW_OVERVIEW_BORDER 10
#define GALA_WINDOW_OVERVIEW_TOP_GAP 30
#define GALA_WINDOW_OVERVIEW_BOTTOM_GAP 100
#define GALA_MULTITASKING_VIEW_ANIMATION_DURATION 250
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_OVERVIEW (gala_window_overview_get_type ())
#define GALA_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview))
#define GALA_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))
#define GALA_IS_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_IS_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_WINDOW_OVERVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))

typedef struct _GalaWindowOverview GalaWindowOverview;
typedef struct _GalaWindowOverviewClass GalaWindowOverviewClass;
typedef struct _GalaWindowOverviewPrivate GalaWindowOverviewPrivate;
enum  {
	GALA_WINDOW_OVERVIEW_0_PROPERTY,
	GALA_WINDOW_OVERVIEW_WM_PROPERTY,
	GALA_WINDOW_OVERVIEW_NUM_PROPERTIES
};
static GParamSpec* gala_window_overview_properties[GALA_WINDOW_OVERVIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GALA_TYPE_WINDOW_CLONE_CONTAINER (gala_window_clone_container_get_type ())
#define GALA_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer))
#define GALA_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))
#define GALA_IS_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_IS_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_WINDOW_CLONE_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))

typedef struct _GalaWindowCloneContainer GalaWindowCloneContainer;
typedef struct _GalaWindowCloneContainerClass GalaWindowCloneContainerClass;

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;
typedef struct _Block72Data Block72Data;

struct _GalaWindowOverview {
	ClutterActor parent_instance;
	GalaWindowOverviewPrivate * priv;
};

struct _GalaWindowOverviewClass {
	ClutterActorClass parent_class;
};

struct _GalaWindowOverviewPrivate {
	GalaWindowManager* _wm;
	GalaModalProxy* modal_proxy;
	GList* workspaces;
};

struct _Block72Data {
	int _ref_count_;
	GalaWindowOverview* self;
	MetaWindow* window;
};

static gint GalaWindowOverview_private_offset;
static gpointer gala_window_overview_parent_class = NULL;
static GalaActivatableComponentIface * gala_window_overview_gala_activatable_component_parent_iface = NULL;

VALA_EXTERN GType gala_window_overview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowOverview, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN GalaWindowOverview* gala_window_overview_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowOverview* gala_window_overview_construct (GType object_type,
                                                    GalaWindowManager* wm);
static gboolean gala_window_overview_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static void gala_window_overview_real_key_focus_out (ClutterActor* base);
static gboolean gala_window_overview_real_button_release_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_window_overview_real_is_opened (GalaActivatableComponent* base);
static void gala_window_overview_real_open (GalaActivatableComponent* base,
                                     GHashTable* hints);
VALA_EXTERN GalaWindowManager* gala_window_overview_get_wm (GalaWindowOverview* self);
static void gala_window_overview_add_window (GalaWindowOverview* self,
                                      MetaWindow* window);
static void _gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self);
static void gala_window_overview_remove_window (GalaWindowOverview* self,
                                         MetaWindow* window);
static void _gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                        MetaWindow* object,
                                                                        gpointer self);
static void gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                               gint num,
                                               MetaWindow* window);
static void _gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                                 gint object,
                                                                                 MetaWindow* p0,
                                                                                 gpointer self);
static gboolean gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                                 MetaKeyBinding* binding);
static gboolean _gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                         gpointer self);
VALA_EXTERN GType gala_window_clone_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowCloneContainer, g_object_unref)
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_new (GalaWindowManager* wm,
                                                           GalaGestureTracker* gesture_tracker,
                                                           gfloat scale,
                                                           gboolean overview_mode);
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_construct (GType object_type,
                                                                 GalaWindowManager* wm,
                                                                 GalaGestureTracker* gesture_tracker,
                                                                 gfloat scale,
                                                                 gboolean overview_mode);
VALA_EXTERN void gala_window_clone_container_set_padding_top (GalaWindowCloneContainer* self,
                                                  gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_left (GalaWindowCloneContainer* self,
                                                   gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_right (GalaWindowCloneContainer* self,
                                                    gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_bottom (GalaWindowCloneContainer* self,
                                                     gint value);
static void gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                          MetaWindow* window);
static void _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                       MetaWindow* window,
                                                                                       gpointer self);
VALA_EXTERN void gala_window_clone_container_add_window (GalaWindowCloneContainer* self,
                                             MetaWindow* window);
VALA_EXTERN void gala_window_clone_container_open (GalaWindowCloneContainer* self,
                                       MetaWindow* selected_window,
                                       gboolean with_gesture,
                                       gboolean is_cancel_animation);
static void gala_window_overview_restack_windows (GalaWindowOverview* self);
VALA_EXTERN void gala_window_clone_container_restack_windows (GalaWindowCloneContainer* self);
VALA_EXTERN void gala_window_clone_container_remove_window (GalaWindowCloneContainer* self,
                                                MetaWindow* window);
static Block72Data* block72_data_ref (Block72Data* _data72_);
static void block72_data_unref (void * _userdata_);
static gboolean ___lambda128_ (Block72Data* _data72_);
static gboolean ____lambda128__gsource_func (gpointer self);
static void gala_window_overview_real_close (GalaActivatableComponent* base,
                                      GHashTable* hints);
VALA_EXTERN void gala_window_clone_container_close (GalaWindowCloneContainer* self,
                                        gboolean with_gesture,
                                        gboolean is_cancel_animation);
static gboolean __lambda127_ (GalaWindowOverview* self);
static void gala_window_overview_cleanup (GalaWindowOverview* self);
static gboolean ___lambda127__gsource_func (gpointer self);
static void gala_window_overview_set_wm (GalaWindowOverview* self,
                                  GalaWindowManager* value);
static GObject * gala_window_overview_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void gala_window_overview_finalize (GObject * obj);
static GType gala_window_overview_get_type_once (void);
static void _vala_gala_window_overview_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_overview_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_window_overview_get_instance_private (GalaWindowOverview* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowOverview_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 18 "../src/Widgets/WindowOverview.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 230 "WindowOverview.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 18 "../src/Widgets/WindowOverview.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 238 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaWindowOverview * self = NULL;
#line 20 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 21 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) g_object_new (object_type, "wm", wm, NULL);
#line 20 "../src/Widgets/WindowOverview.vala"
	return self;
#line 252 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_new (GalaWindowManager* wm)
{
#line 20 "../src/Widgets/WindowOverview.vala"
	return gala_window_overview_construct (GALA_TYPE_WINDOW_OVERVIEW, wm);
#line 260 "WindowOverview.c"
}

static gboolean
gala_window_overview_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowOverview * self;
	gboolean result;
#line 30 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 30 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 34 "../src/Widgets/WindowOverview.vala"
	if (clutter_event_get_key_symbol (event) == CLUTTER_KEY_Escape) {
#line 35 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 37 "../src/Widgets/WindowOverview.vala"
		result = CLUTTER_EVENT_STOP;
#line 37 "../src/Widgets/WindowOverview.vala"
		return result;
#line 281 "WindowOverview.c"
	}
#line 40 "../src/Widgets/WindowOverview.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 40 "../src/Widgets/WindowOverview.vala"
	return result;
#line 287 "WindowOverview.c"
}

static void
gala_window_overview_real_key_focus_out (ClutterActor* base)
{
	GalaWindowOverview * self;
	ClutterStage* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
#line 43 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 44 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_stage ((ClutterActor*) self);
#line 44 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = clutter_stage_get_key_focus (_tmp0_);
#line 44 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = _tmp1_;
#line 44 "../src/Widgets/WindowOverview.vala"
	if (!clutter_actor_contains ((ClutterActor*) self, _tmp2_)) {
#line 45 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 309 "WindowOverview.c"
	}
}

static gboolean
gala_window_overview_real_button_release_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaWindowOverview * self;
	gboolean result;
#line 50 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 50 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 54 "../src/Widgets/WindowOverview.vala"
	if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 55 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 327 "WindowOverview.c"
	}
#line 58 "../src/Widgets/WindowOverview.vala"
	result = CLUTTER_EVENT_STOP;
#line 58 "../src/Widgets/WindowOverview.vala"
	return result;
#line 333 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
gala_window_overview_real_is_opened (GalaActivatableComponent* base)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 64 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 65 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 65 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/Widgets/WindowOverview.vala"
	result = _tmp1_;
#line 65 "../src/Widgets/WindowOverview.vala"
	return result;
#line 356 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     * You may specify 'all-windows' in hints to expose all windows
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 79 "../src/Widgets/WindowOverview.vala"
	return self ? g_object_ref (self) : NULL;
#line 368 "WindowOverview.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5297 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5297 "glib-2.0.vapi"
	return result;
#line 379 "WindowOverview.c"
}

static void
_gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                              MetaWindow* object,
                                                              gpointer self)
{
#line 117 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_add_window ((GalaWindowOverview*) self, object);
#line 389 "WindowOverview.c"
}

static void
_gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self)
{
#line 118 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_remove_window ((GalaWindowOverview*) self, object);
#line 399 "WindowOverview.c"
}

static void
_gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                            gint object,
                                                                            MetaWindow* p0,
                                                                            gpointer self)
{
#line 121 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_window_left_monitor ((GalaWindowOverview*) self, object, p0);
#line 410 "WindowOverview.c"
}

static gboolean
_gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                gpointer self)
{
	gboolean result;
	result = gala_window_overview_keybinding_filter ((GalaWindowOverview*) self, binding);
#line 126 "../src/Widgets/WindowOverview.vala"
	return result;
#line 421 "WindowOverview.c"
}

static void
_gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                  MetaWindow* window,
                                                                                  gpointer self)
{
#line 142 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_thumb_selected ((GalaWindowOverview*) self, window);
#line 431 "WindowOverview.c"
}

static void
gala_window_overview_real_open (GalaActivatableComponent* base,
                                GHashTable* hints)
{
	GalaWindowOverview * self;
	gboolean _tmp0_ = FALSE;
	gboolean all_windows = FALSE;
	MetaWorkspaceManager* manager = NULL;
	GalaWindowManager* _tmp1_;
	MetaDisplay* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	GList* windows = NULL;
	GList* _tmp11_;
	GList* _tmp43_;
	GList* _tmp44_;
	GalaWindowManager* _tmp48_;
	MetaDisplay* _tmp49_;
	GalaWindowManager* _tmp50_;
	GalaModalProxy* _tmp51_;
	GalaModalProxy* _tmp52_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp53_;
	MetaDisplay* _tmp54_;
	GList* _tmp71_;
#line 72 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 73 "../src/Widgets/WindowOverview.vala"
	if (hints != NULL) {
#line 73 "../src/Widgets/WindowOverview.vala"
		_tmp0_ = g_hash_table_contains (hints, "all-windows");
#line 464 "WindowOverview.c"
	} else {
#line 73 "../src/Widgets/WindowOverview.vala"
		_tmp0_ = FALSE;
#line 468 "WindowOverview.c"
	}
#line 73 "../src/Widgets/WindowOverview.vala"
	all_windows = _tmp0_;
#line 75 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 75 "../src/Widgets/WindowOverview.vala"
	self->priv->workspaces = NULL;
#line 76 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = self->priv->_wm;
#line 76 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = meta_plugin_get_display ((MetaPlugin*) _tmp1_);
#line 76 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_display_get_workspace_manager (_tmp2_);
#line 76 "../src/Widgets/WindowOverview.vala"
	manager = _tmp3_;
#line 77 "../src/Widgets/WindowOverview.vala"
	if (all_windows) {
#line 486 "WindowOverview.c"
		MetaWorkspaceManager* _tmp4_;
		GList* _tmp5_;
#line 78 "../src/Widgets/WindowOverview.vala"
		_tmp4_ = manager;
#line 78 "../src/Widgets/WindowOverview.vala"
		_tmp5_ = meta_workspace_manager_get_workspaces (_tmp4_);
#line 493 "WindowOverview.c"
		{
			GList* workspace_collection = NULL;
			GList* workspace_it = NULL;
#line 78 "../src/Widgets/WindowOverview.vala"
			workspace_collection = _tmp5_;
#line 78 "../src/Widgets/WindowOverview.vala"
			for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 501 "WindowOverview.c"
				MetaWorkspace* workspace = NULL;
#line 78 "../src/Widgets/WindowOverview.vala"
				workspace = (MetaWorkspace*) workspace_it->data;
#line 505 "WindowOverview.c"
				{
					MetaWorkspace* _tmp6_;
					MetaWorkspace* _tmp7_;
#line 79 "../src/Widgets/WindowOverview.vala"
					_tmp6_ = workspace;
#line 79 "../src/Widgets/WindowOverview.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 79 "../src/Widgets/WindowOverview.vala"
					self->priv->workspaces = g_list_append (self->priv->workspaces, _tmp7_);
#line 515 "WindowOverview.c"
				}
			}
		}
	} else {
		MetaWorkspaceManager* _tmp8_;
		MetaWorkspace* _tmp9_;
		MetaWorkspace* _tmp10_;
#line 82 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = manager;
#line 82 "../src/Widgets/WindowOverview.vala"
		_tmp9_ = meta_workspace_manager_get_active_workspace (_tmp8_);
#line 82 "../src/Widgets/WindowOverview.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 82 "../src/Widgets/WindowOverview.vala"
		self->priv->workspaces = g_list_append (self->priv->workspaces, _tmp10_);
#line 531 "WindowOverview.c"
	}
#line 85 "../src/Widgets/WindowOverview.vala"
	windows = NULL;
#line 86 "../src/Widgets/WindowOverview.vala"
	_tmp11_ = self->priv->workspaces;
#line 537 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 86 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp11_;
#line 86 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 545 "WindowOverview.c"
			MetaWorkspace* _tmp12_;
			MetaWorkspace* workspace = NULL;
#line 86 "../src/Widgets/WindowOverview.vala"
			_tmp12_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 86 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp12_;
#line 552 "WindowOverview.c"
			{
				MetaWorkspace* _tmp13_;
				GList* _tmp14_;
#line 87 "../src/Widgets/WindowOverview.vala"
				_tmp13_ = workspace;
#line 87 "../src/Widgets/WindowOverview.vala"
				_tmp14_ = meta_workspace_list_windows (_tmp13_);
#line 560 "WindowOverview.c"
				{
					GList* window_collection = NULL;
					GList* window_it = NULL;
#line 87 "../src/Widgets/WindowOverview.vala"
					window_collection = _tmp14_;
#line 87 "../src/Widgets/WindowOverview.vala"
					for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 568 "WindowOverview.c"
						MetaWindow* window = NULL;
#line 87 "../src/Widgets/WindowOverview.vala"
						window = (MetaWindow*) window_it->data;
#line 572 "WindowOverview.c"
						{
							gboolean _tmp15_ = FALSE;
							MetaWindow* _tmp16_;
							MetaWindowType _tmp17_;
							MetaWindowType _tmp18_;
							gboolean _tmp22_ = FALSE;
							gboolean _tmp23_ = FALSE;
							MetaWindow* _tmp24_;
							MetaWindowType _tmp25_;
							MetaWindowType _tmp26_;
							gboolean _tmp34_ = FALSE;
							MetaWindow* _tmp35_;
							gboolean _tmp36_;
							gboolean _tmp37_;
							MetaWindow* _tmp41_;
							MetaWindow* _tmp42_;
#line 88 "../src/Widgets/WindowOverview.vala"
							_tmp16_ = window;
#line 88 "../src/Widgets/WindowOverview.vala"
							_tmp17_ = meta_window_get_window_type (_tmp16_);
#line 88 "../src/Widgets/WindowOverview.vala"
							_tmp18_ = _tmp17_;
#line 88 "../src/Widgets/WindowOverview.vala"
							if (_tmp18_ == META_WINDOW_DOCK) {
#line 88 "../src/Widgets/WindowOverview.vala"
								_tmp15_ = TRUE;
#line 599 "WindowOverview.c"
							} else {
								MetaWindow* _tmp19_;
								MetaWindowType _tmp20_;
								MetaWindowType _tmp21_;
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp19_ = window;
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp20_ = meta_window_get_window_type (_tmp19_);
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp21_ = _tmp20_;
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp15_ = _tmp21_ == META_WINDOW_NOTIFICATION;
#line 612 "WindowOverview.c"
							}
#line 88 "../src/Widgets/WindowOverview.vala"
							if (_tmp15_) {
#line 90 "../src/Widgets/WindowOverview.vala"
								continue;
#line 618 "WindowOverview.c"
							}
#line 93 "../src/Widgets/WindowOverview.vala"
							_tmp24_ = window;
#line 93 "../src/Widgets/WindowOverview.vala"
							_tmp25_ = meta_window_get_window_type (_tmp24_);
#line 93 "../src/Widgets/WindowOverview.vala"
							_tmp26_ = _tmp25_;
#line 93 "../src/Widgets/WindowOverview.vala"
							if (_tmp26_ != META_WINDOW_NORMAL) {
#line 628 "WindowOverview.c"
								MetaWindow* _tmp27_;
								MetaWindowType _tmp28_;
								MetaWindowType _tmp29_;
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp27_ = window;
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp28_ = meta_window_get_window_type (_tmp27_);
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp29_ = _tmp28_;
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp23_ = _tmp29_ != META_WINDOW_DIALOG;
#line 640 "WindowOverview.c"
							} else {
#line 93 "../src/Widgets/WindowOverview.vala"
								_tmp23_ = FALSE;
#line 644 "WindowOverview.c"
							}
#line 93 "../src/Widgets/WindowOverview.vala"
							if (_tmp23_) {
#line 93 "../src/Widgets/WindowOverview.vala"
								_tmp22_ = TRUE;
#line 650 "WindowOverview.c"
							} else {
								MetaWindow* _tmp30_;
#line 95 "../src/Widgets/WindowOverview.vala"
								_tmp30_ = window;
#line 95 "../src/Widgets/WindowOverview.vala"
								_tmp22_ = meta_window_is_attached_dialog (_tmp30_);
#line 657 "WindowOverview.c"
							}
#line 93 "../src/Widgets/WindowOverview.vala"
							if (_tmp22_) {
#line 661 "WindowOverview.c"
								MetaWindowActor* actor = NULL;
								MetaWindow* _tmp31_;
								GObject* _tmp32_;
								MetaWindowActor* _tmp33_;
#line 96 "../src/Widgets/WindowOverview.vala"
								_tmp31_ = window;
#line 96 "../src/Widgets/WindowOverview.vala"
								_tmp32_ = meta_window_get_compositor_private (_tmp31_);
#line 96 "../src/Widgets/WindowOverview.vala"
								actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, meta_window_actor_get_type (), MetaWindowActor);
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp33_ = actor;
#line 97 "../src/Widgets/WindowOverview.vala"
								clutter_actor_hide ((ClutterActor*) _tmp33_);
#line 99 "../src/Widgets/WindowOverview.vala"
								continue;
#line 678 "WindowOverview.c"
							}
#line 104 "../src/Widgets/WindowOverview.vala"
							_tmp35_ = window;
#line 104 "../src/Widgets/WindowOverview.vala"
							g_object_get (_tmp35_, "on-all-workspaces", &_tmp36_, NULL);
#line 104 "../src/Widgets/WindowOverview.vala"
							_tmp37_ = _tmp36_;
#line 104 "../src/Widgets/WindowOverview.vala"
							if (_tmp37_) {
#line 688 "WindowOverview.c"
								MetaWindow* _tmp38_;
								MetaWorkspace* _tmp39_;
								MetaWorkspace* _tmp40_;
#line 104 "../src/Widgets/WindowOverview.vala"
								_tmp38_ = window;
#line 104 "../src/Widgets/WindowOverview.vala"
								_tmp39_ = meta_window_get_workspace (_tmp38_);
#line 104 "../src/Widgets/WindowOverview.vala"
								_tmp40_ = workspace;
#line 104 "../src/Widgets/WindowOverview.vala"
								_tmp34_ = _tmp39_ != _tmp40_;
#line 700 "WindowOverview.c"
							} else {
#line 104 "../src/Widgets/WindowOverview.vala"
								_tmp34_ = FALSE;
#line 704 "WindowOverview.c"
							}
#line 104 "../src/Widgets/WindowOverview.vala"
							if (_tmp34_) {
#line 105 "../src/Widgets/WindowOverview.vala"
								continue;
#line 710 "WindowOverview.c"
							}
#line 108 "../src/Widgets/WindowOverview.vala"
							_tmp41_ = window;
#line 108 "../src/Widgets/WindowOverview.vala"
							_tmp42_ = _g_object_ref0 (_tmp41_);
#line 108 "../src/Widgets/WindowOverview.vala"
							windows = g_list_append (windows, _tmp42_);
#line 718 "WindowOverview.c"
						}
					}
#line 87 "../src/Widgets/WindowOverview.vala"
					(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 723 "WindowOverview.c"
				}
#line 86 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 727 "WindowOverview.c"
			}
		}
	}
#line 112 "../src/Widgets/WindowOverview.vala"
	_tmp43_ = windows;
#line 112 "../src/Widgets/WindowOverview.vala"
	if (vala_g_list_is_empty (_tmp43_)) {
#line 113 "../src/Widgets/WindowOverview.vala"
		(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 113 "../src/Widgets/WindowOverview.vala"
		return;
#line 739 "WindowOverview.c"
	}
#line 116 "../src/Widgets/WindowOverview.vala"
	_tmp44_ = self->priv->workspaces;
#line 743 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 116 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp44_;
#line 116 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 751 "WindowOverview.c"
			MetaWorkspace* _tmp45_;
			MetaWorkspace* workspace = NULL;
#line 116 "../src/Widgets/WindowOverview.vala"
			_tmp45_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 116 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp45_;
#line 758 "WindowOverview.c"
			{
				MetaWorkspace* _tmp46_;
				MetaWorkspace* _tmp47_;
#line 117 "../src/Widgets/WindowOverview.vala"
				_tmp46_ = workspace;
#line 117 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp46_, "window-added", (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self, 0);
#line 118 "../src/Widgets/WindowOverview.vala"
				_tmp47_ = workspace;
#line 118 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp47_, "window-removed", (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self, 0);
#line 116 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 772 "WindowOverview.c"
			}
		}
	}
#line 121 "../src/Widgets/WindowOverview.vala"
	_tmp48_ = self->priv->_wm;
#line 121 "../src/Widgets/WindowOverview.vala"
	_tmp49_ = meta_plugin_get_display ((MetaPlugin*) _tmp48_);
#line 121 "../src/Widgets/WindowOverview.vala"
	g_signal_connect_object (_tmp49_, "window-left-monitor", (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self, 0);
#line 123 "../src/Widgets/WindowOverview.vala"
	clutter_actor_grab_key_focus ((ClutterActor*) self);
#line 125 "../src/Widgets/WindowOverview.vala"
	_tmp50_ = self->priv->_wm;
#line 125 "../src/Widgets/WindowOverview.vala"
	_tmp51_ = gala_window_manager_push_modal (_tmp50_, (ClutterActor*) self);
#line 125 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 125 "../src/Widgets/WindowOverview.vala"
	self->priv->modal_proxy = _tmp51_;
#line 126 "../src/Widgets/WindowOverview.vala"
	_tmp52_ = self->priv->modal_proxy;
#line 126 "../src/Widgets/WindowOverview.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp52_, _gala_window_overview_keybinding_filter_gala_keybinding_filter, self);
#line 128 "../src/Widgets/WindowOverview.vala"
	_tmp53_ = self->priv->_wm;
#line 128 "../src/Widgets/WindowOverview.vala"
	_tmp54_ = meta_plugin_get_display ((MetaPlugin*) _tmp53_);
#line 128 "../src/Widgets/WindowOverview.vala"
	display = _tmp54_;
#line 802 "WindowOverview.c"
	{
		gint i = 0;
#line 130 "../src/Widgets/WindowOverview.vala"
		i = 0;
#line 807 "WindowOverview.c"
		{
			gboolean _tmp55_ = FALSE;
#line 130 "../src/Widgets/WindowOverview.vala"
			_tmp55_ = TRUE;
#line 130 "../src/Widgets/WindowOverview.vala"
			while (TRUE) {
#line 814 "WindowOverview.c"
				MetaDisplay* _tmp57_;
				MtkRectangle geometry = {0};
				MetaDisplay* _tmp58_;
				MtkRectangle _tmp59_ = {0};
				gfloat scale = 0.0F;
				MetaDisplay* _tmp60_;
				GalaWindowCloneContainer* container = NULL;
				GalaWindowManager* _tmp61_;
				GalaWindowCloneContainer* _tmp62_ = NULL;
				GalaWindowCloneContainer* _tmp63_;
				MtkRectangle _tmp64_;
				MtkRectangle _tmp65_;
				GalaWindowCloneContainer* _tmp66_;
				MtkRectangle _tmp67_;
				MtkRectangle _tmp68_;
				GalaWindowCloneContainer* _tmp69_;
				GalaWindowCloneContainer* _tmp70_;
#line 130 "../src/Widgets/WindowOverview.vala"
				if (!_tmp55_) {
#line 834 "WindowOverview.c"
					gint _tmp56_;
#line 130 "../src/Widgets/WindowOverview.vala"
					_tmp56_ = i;
#line 130 "../src/Widgets/WindowOverview.vala"
					i = _tmp56_ + 1;
#line 840 "WindowOverview.c"
				}
#line 130 "../src/Widgets/WindowOverview.vala"
				_tmp55_ = FALSE;
#line 130 "../src/Widgets/WindowOverview.vala"
				_tmp57_ = display;
#line 130 "../src/Widgets/WindowOverview.vala"
				if (!(i < meta_display_get_n_monitors (_tmp57_))) {
#line 130 "../src/Widgets/WindowOverview.vala"
					break;
#line 850 "WindowOverview.c"
				}
#line 131 "../src/Widgets/WindowOverview.vala"
				_tmp58_ = display;
#line 131 "../src/Widgets/WindowOverview.vala"
				meta_display_get_monitor_geometry (_tmp58_, i, &_tmp59_);
#line 131 "../src/Widgets/WindowOverview.vala"
				geometry = _tmp59_;
#line 132 "../src/Widgets/WindowOverview.vala"
				_tmp60_ = display;
#line 132 "../src/Widgets/WindowOverview.vala"
				scale = meta_display_get_monitor_scale (_tmp60_, i);
#line 134 "../src/Widgets/WindowOverview.vala"
				_tmp61_ = self->priv->_wm;
#line 134 "../src/Widgets/WindowOverview.vala"
				_tmp62_ = gala_window_clone_container_new (_tmp61_, NULL, scale, TRUE);
#line 134 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_top (_tmp62_, GALA_WINDOW_OVERVIEW_TOP_GAP);
#line 134 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_left (_tmp62_, GALA_WINDOW_OVERVIEW_BORDER);
#line 134 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_right (_tmp62_, GALA_WINDOW_OVERVIEW_BORDER);
#line 134 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_bottom (_tmp62_, GALA_WINDOW_OVERVIEW_BOTTOM_GAP);
#line 134 "../src/Widgets/WindowOverview.vala"
				g_object_ref_sink (_tmp62_);
#line 134 "../src/Widgets/WindowOverview.vala"
				container = _tmp62_;
#line 140 "../src/Widgets/WindowOverview.vala"
				_tmp63_ = container;
#line 140 "../src/Widgets/WindowOverview.vala"
				_tmp64_ = geometry;
#line 140 "../src/Widgets/WindowOverview.vala"
				_tmp65_ = geometry;
#line 140 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_position ((ClutterActor*) _tmp63_, (gfloat) _tmp64_.x, (gfloat) _tmp65_.y);
#line 141 "../src/Widgets/WindowOverview.vala"
				_tmp66_ = container;
#line 141 "../src/Widgets/WindowOverview.vala"
				_tmp67_ = geometry;
#line 141 "../src/Widgets/WindowOverview.vala"
				_tmp68_ = geometry;
#line 141 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_size ((ClutterActor*) _tmp66_, (gfloat) _tmp67_.width, (gfloat) _tmp68_.height);
#line 142 "../src/Widgets/WindowOverview.vala"
				_tmp69_ = container;
#line 142 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp69_, "window-selected", (GCallback) _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected, self, 0);
#line 144 "../src/Widgets/WindowOverview.vala"
				_tmp70_ = container;
#line 144 "../src/Widgets/WindowOverview.vala"
				clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp70_);
#line 130 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (container);
#line 904 "WindowOverview.c"
			}
		}
	}
#line 147 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 149 "../src/Widgets/WindowOverview.vala"
	_tmp71_ = windows;
#line 912 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 149 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp71_;
#line 149 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 920 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 149 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 924 "WindowOverview.c"
			{
				MetaWindowActor* actor = NULL;
				MetaWindow* _tmp72_;
				GObject* _tmp73_;
				MetaWindowActor* _tmp74_;
				GalaWindowCloneContainer* container = NULL;
				MetaWindow* _tmp75_;
				ClutterActor* _tmp76_;
				GalaWindowCloneContainer* _tmp77_;
				GalaWindowCloneContainer* _tmp78_;
				MetaWindow* _tmp79_;
				GalaWindowCloneContainer* _tmp80_;
#line 150 "../src/Widgets/WindowOverview.vala"
				_tmp72_ = window;
#line 150 "../src/Widgets/WindowOverview.vala"
				_tmp73_ = meta_window_get_compositor_private (_tmp72_);
#line 150 "../src/Widgets/WindowOverview.vala"
				actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, meta_window_actor_get_type (), MetaWindowActor);
#line 151 "../src/Widgets/WindowOverview.vala"
				_tmp74_ = actor;
#line 151 "../src/Widgets/WindowOverview.vala"
				clutter_actor_hide ((ClutterActor*) _tmp74_);
#line 153 "../src/Widgets/WindowOverview.vala"
				_tmp75_ = window;
#line 153 "../src/Widgets/WindowOverview.vala"
				_tmp76_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (_tmp75_));
#line 153 "../src/Widgets/WindowOverview.vala"
				container = G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 154 "../src/Widgets/WindowOverview.vala"
				_tmp77_ = container;
#line 154 "../src/Widgets/WindowOverview.vala"
				if (_tmp77_ == NULL) {
#line 155 "../src/Widgets/WindowOverview.vala"
					continue;
#line 959 "WindowOverview.c"
				}
#line 158 "../src/Widgets/WindowOverview.vala"
				_tmp78_ = container;
#line 158 "../src/Widgets/WindowOverview.vala"
				_tmp79_ = window;
#line 158 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_add_window (_tmp78_, _tmp79_);
#line 159 "../src/Widgets/WindowOverview.vala"
				_tmp80_ = container;
#line 159 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_open (_tmp80_, NULL, FALSE, FALSE);
#line 971 "WindowOverview.c"
			}
		}
	}
#line 72 "../src/Widgets/WindowOverview.vala"
	(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 977 "WindowOverview.c"
}

static gboolean
gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                        MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 174 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label0 = 0;
#line 174 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label1 = 0;
#line 174 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label2 = 0;
#line 174 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label3 = 0;
#line 997 "WindowOverview.c"
	gboolean result;
#line 163 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 164 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 164 "../src/Widgets/WindowOverview.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 166 "../src/Widgets/WindowOverview.vala"
	switch (action) {
#line 166 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 166 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 1013 "WindowOverview.c"
		{
#line 169 "../src/Widgets/WindowOverview.vala"
			result = FALSE;
#line 169 "../src/Widgets/WindowOverview.vala"
			return result;
#line 1019 "WindowOverview.c"
		}
		default:
		{
#line 171 "../src/Widgets/WindowOverview.vala"
			break;
#line 1025 "WindowOverview.c"
		}
	}
#line 174 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 174 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = _tmp1_;
#line 174 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 174 "../src/Widgets/WindowOverview.vala"
	if ((((_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("expose-windows")))) || (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("expose-all-windows"))))) || (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("zoom-in"))))) || (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("zoom-out"))))) {
#line 174 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1038 "WindowOverview.c"
			default:
			{
#line 179 "../src/Widgets/WindowOverview.vala"
				result = FALSE;
#line 179 "../src/Widgets/WindowOverview.vala"
				return result;
#line 1045 "WindowOverview.c"
			}
		}
	} else {
#line 174 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1051 "WindowOverview.c"
			default:
			{
#line 181 "../src/Widgets/WindowOverview.vala"
				break;
#line 1056 "WindowOverview.c"
			}
		}
	}
#line 184 "../src/Widgets/WindowOverview.vala"
	result = TRUE;
#line 184 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1064 "WindowOverview.c"
}

static void
gala_window_overview_restack_windows (GalaWindowOverview* self)
{
	GList* _tmp0_;
#line 187 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_children ((ClutterActor*) self);
#line 1075 "WindowOverview.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 188 "../src/Widgets/WindowOverview.vala"
		child_collection = _tmp0_;
#line 188 "../src/Widgets/WindowOverview.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1083 "WindowOverview.c"
			ClutterActor* child = NULL;
#line 188 "../src/Widgets/WindowOverview.vala"
			child = (ClutterActor*) child_it->data;
#line 1087 "WindowOverview.c"
			{
				ClutterActor* _tmp1_;
#line 189 "../src/Widgets/WindowOverview.vala"
				_tmp1_ = child;
#line 189 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_restack_windows (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer));
#line 1094 "WindowOverview.c"
			}
		}
#line 188 "../src/Widgets/WindowOverview.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1099 "WindowOverview.c"
	}
}

static void
gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                          gint num,
                                          MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GList* _tmp2_;
#line 193 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 194 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, num);
#line 194 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 195 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 195 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 196 "../src/Widgets/WindowOverview.vala"
		return;
#line 1126 "WindowOverview.c"
	}
#line 200 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1130 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 200 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 200 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1138 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 200 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 200 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1145 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
#line 201 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 201 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp4_)) {
#line 1152 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp5_;
#line 202 "../src/Widgets/WindowOverview.vala"
					_tmp5_ = container;
#line 202 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_remove_window (_tmp5_, window);
#line 203 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 203 "../src/Widgets/WindowOverview.vala"
					break;
#line 1162 "WindowOverview.c"
				}
#line 200 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1166 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_add_window (GalaWindowOverview* self,
                                 MetaWindow* window)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWindowType _tmp3_;
	MetaWindowType _tmp4_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	MetaWindowType _tmp9_;
	MetaWindowType _tmp10_;
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp15_;
	GalaWindowCloneContainer* _tmp16_;
	GList* _tmp17_;
#line 208 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 209 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 209 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 209 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 210 "../src/Widgets/WindowOverview.vala"
		return;
#line 1201 "WindowOverview.c"
	}
#line 212 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_window_get_window_type (window);
#line 212 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = _tmp3_;
#line 212 "../src/Widgets/WindowOverview.vala"
	if (_tmp4_ == META_WINDOW_DOCK) {
#line 212 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = TRUE;
#line 1211 "WindowOverview.c"
	} else {
		MetaWindowType _tmp5_;
		MetaWindowType _tmp6_;
#line 213 "../src/Widgets/WindowOverview.vala"
		_tmp5_ = meta_window_get_window_type (window);
#line 213 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = _tmp5_;
#line 213 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = _tmp6_ == META_WINDOW_NOTIFICATION;
#line 1221 "WindowOverview.c"
	}
#line 212 "../src/Widgets/WindowOverview.vala"
	if (_tmp2_) {
#line 214 "../src/Widgets/WindowOverview.vala"
		return;
#line 1227 "WindowOverview.c"
	}
#line 216 "../src/Widgets/WindowOverview.vala"
	_tmp9_ = meta_window_get_window_type (window);
#line 216 "../src/Widgets/WindowOverview.vala"
	_tmp10_ = _tmp9_;
#line 216 "../src/Widgets/WindowOverview.vala"
	if (_tmp10_ != META_WINDOW_NORMAL) {
#line 1235 "WindowOverview.c"
		MetaWindowType _tmp11_;
		MetaWindowType _tmp12_;
#line 217 "../src/Widgets/WindowOverview.vala"
		_tmp11_ = meta_window_get_window_type (window);
#line 217 "../src/Widgets/WindowOverview.vala"
		_tmp12_ = _tmp11_;
#line 217 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = _tmp12_ != META_WINDOW_DIALOG;
#line 1244 "WindowOverview.c"
	} else {
#line 216 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = FALSE;
#line 1248 "WindowOverview.c"
	}
#line 216 "../src/Widgets/WindowOverview.vala"
	if (_tmp8_) {
#line 216 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = TRUE;
#line 1254 "WindowOverview.c"
	} else {
#line 218 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = meta_window_is_attached_dialog (window);
#line 1258 "WindowOverview.c"
	}
#line 216 "../src/Widgets/WindowOverview.vala"
	if (_tmp7_) {
#line 1262 "WindowOverview.c"
		MetaWindowActor* actor = NULL;
		GObject* _tmp13_;
		MetaWindowActor* _tmp14_;
#line 219 "../src/Widgets/WindowOverview.vala"
		_tmp13_ = meta_window_get_compositor_private (window);
#line 219 "../src/Widgets/WindowOverview.vala"
		actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, meta_window_actor_get_type (), MetaWindowActor);
#line 220 "../src/Widgets/WindowOverview.vala"
		_tmp14_ = actor;
#line 220 "../src/Widgets/WindowOverview.vala"
		clutter_actor_hide ((ClutterActor*) _tmp14_);
#line 222 "../src/Widgets/WindowOverview.vala"
		return;
#line 1276 "WindowOverview.c"
	}
#line 225 "../src/Widgets/WindowOverview.vala"
	_tmp15_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 225 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 226 "../src/Widgets/WindowOverview.vala"
	_tmp16_ = container;
#line 226 "../src/Widgets/WindowOverview.vala"
	if (_tmp16_ == NULL) {
#line 227 "../src/Widgets/WindowOverview.vala"
		return;
#line 1288 "WindowOverview.c"
	}
#line 231 "../src/Widgets/WindowOverview.vala"
	_tmp17_ = self->priv->workspaces;
#line 1292 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 231 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp17_;
#line 231 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1300 "WindowOverview.c"
			MetaWorkspace* _tmp18_;
			MetaWorkspace* workspace = NULL;
#line 231 "../src/Widgets/WindowOverview.vala"
			_tmp18_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 231 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp18_;
#line 1307 "WindowOverview.c"
			{
				MetaWorkspace* _tmp19_;
#line 232 "../src/Widgets/WindowOverview.vala"
				_tmp19_ = workspace;
#line 232 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp19_)) {
#line 1314 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp20_;
#line 233 "../src/Widgets/WindowOverview.vala"
					_tmp20_ = container;
#line 233 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_add_window (_tmp20_, window);
#line 234 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 234 "../src/Widgets/WindowOverview.vala"
					break;
#line 1324 "WindowOverview.c"
				}
#line 231 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1328 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_remove_window (GalaWindowOverview* self,
                                    MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GalaWindowCloneContainer* _tmp2_;
#line 239 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 240 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 240 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 241 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 241 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 242 "../src/Widgets/WindowOverview.vala"
		return;
#line 1356 "WindowOverview.c"
	}
#line 245 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = container;
#line 245 "../src/Widgets/WindowOverview.vala"
	gala_window_clone_container_remove_window (_tmp2_, window);
#line 1362 "WindowOverview.c"
}

static Block72Data*
block72_data_ref (Block72Data* _data72_)
{
#line 248 "../src/Widgets/WindowOverview.vala"
	g_atomic_int_inc (&_data72_->_ref_count_);
#line 248 "../src/Widgets/WindowOverview.vala"
	return _data72_;
#line 1372 "WindowOverview.c"
}

static void
block72_data_unref (void * _userdata_)
{
	Block72Data* _data72_;
	_data72_ = (Block72Data*) _userdata_;
#line 248 "../src/Widgets/WindowOverview.vala"
	if (g_atomic_int_dec_and_test (&_data72_->_ref_count_)) {
#line 1382 "WindowOverview.c"
		GalaWindowOverview* self;
#line 248 "../src/Widgets/WindowOverview.vala"
		self = _data72_->self;
#line 248 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (_data72_->window);
#line 248 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self);
#line 248 "../src/Widgets/WindowOverview.vala"
		g_slice_free (Block72Data, _data72_);
#line 1392 "WindowOverview.c"
	}
}

static gboolean
___lambda128_ (Block72Data* _data72_)
{
	GalaWindowOverview* self;
	MetaWorkspace* _tmp0_;
	MetaDisplay* _tmp1_;
	gboolean result;
#line 256 "../src/Widgets/WindowOverview.vala"
	self = _data72_->self;
#line 257 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_window_get_workspace (_data72_->window);
#line 257 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_display (_data72_->window);
#line 257 "../src/Widgets/WindowOverview.vala"
	meta_workspace_activate_with_focus (_tmp0_, _data72_->window, meta_display_get_current_time (_tmp1_));
#line 258 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 258 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1415 "WindowOverview.c"
}

static gboolean
____lambda128__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda128_ (self);
#line 256 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1425 "WindowOverview.c"
}

static void
gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                     MetaWindow* window)
{
	Block72Data* _data72_;
	MetaWindow* _tmp0_;
	MetaWorkspace* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
#line 248 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 248 "../src/Widgets/WindowOverview.vala"
	_data72_ = g_slice_new0 (Block72Data);
#line 248 "../src/Widgets/WindowOverview.vala"
	_data72_->_ref_count_ = 1;
#line 248 "../src/Widgets/WindowOverview.vala"
	_data72_->self = g_object_ref (self);
#line 248 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 248 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (_data72_->window);
#line 248 "../src/Widgets/WindowOverview.vala"
	_data72_->window = _tmp0_;
#line 249 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_workspace (_data72_->window);
#line 249 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 249 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 249 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 249 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 249 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == _tmp5_) {
#line 1467 "WindowOverview.c"
		MetaDisplay* _tmp6_;
#line 250 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = meta_window_get_display (_data72_->window);
#line 250 "../src/Widgets/WindowOverview.vala"
		meta_window_activate (_data72_->window, meta_display_get_current_time (_tmp6_));
#line 251 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 1475 "WindowOverview.c"
	} else {
#line 253 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 256 "../src/Widgets/WindowOverview.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ____lambda128__gsource_func, block72_data_ref (_data72_), block72_data_unref);
#line 1481 "WindowOverview.c"
	}
#line 248 "../src/Widgets/WindowOverview.vala"
	block72_data_unref (_data72_);
#line 248 "../src/Widgets/WindowOverview.vala"
	_data72_ = NULL;
#line 1487 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
__lambda127_ (GalaWindowOverview* self)
{
	gboolean result;
#line 284 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_cleanup (self);
#line 286 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 286 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1503 "WindowOverview.c"
}

static gboolean
___lambda127__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda127_ ((GalaWindowOverview*) self);
#line 283 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1513 "WindowOverview.c"
}

static void
gala_window_overview_real_close (GalaActivatableComponent* base,
                                 GHashTable* hints)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GList* _tmp2_;
	GalaWindowManager* _tmp8_;
	MetaDisplay* _tmp9_;
	guint _tmp10_;
	GList* _tmp11_;
#line 266 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 267 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 267 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 267 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 268 "../src/Widgets/WindowOverview.vala"
		return;
#line 1538 "WindowOverview.c"
	}
#line 271 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_restack_windows (self);
#line 273 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1544 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 273 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 273 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1552 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 273 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 273 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1559 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
				guint _tmp5_;
				MetaWorkspace* _tmp6_;
				guint _tmp7_;
#line 274 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 274 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp5_, NULL, FALSE);
#line 274 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self);
#line 275 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = workspace;
#line 275 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp7_, NULL, FALSE);
#line 275 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self);
#line 273 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1579 "WindowOverview.c"
			}
		}
	}
#line 277 "../src/Widgets/WindowOverview.vala"
	_tmp8_ = self->priv->_wm;
#line 277 "../src/Widgets/WindowOverview.vala"
	_tmp9_ = meta_plugin_get_display ((MetaPlugin*) _tmp8_);
#line 277 "../src/Widgets/WindowOverview.vala"
	g_signal_parse_name ("window-left-monitor", meta_display_get_type (), &_tmp10_, NULL, FALSE);
#line 277 "../src/Widgets/WindowOverview.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self);
#line 279 "../src/Widgets/WindowOverview.vala"
	_tmp11_ = clutter_actor_get_children ((ClutterActor*) self);
#line 1593 "WindowOverview.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 279 "../src/Widgets/WindowOverview.vala"
		child_collection = _tmp11_;
#line 279 "../src/Widgets/WindowOverview.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1601 "WindowOverview.c"
			ClutterActor* child = NULL;
#line 279 "../src/Widgets/WindowOverview.vala"
			child = (ClutterActor*) child_it->data;
#line 1605 "WindowOverview.c"
			{
				ClutterActor* _tmp12_;
#line 280 "../src/Widgets/WindowOverview.vala"
				_tmp12_ = child;
#line 280 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_close (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer), FALSE, FALSE);
#line 1612 "WindowOverview.c"
			}
		}
#line 279 "../src/Widgets/WindowOverview.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1617 "WindowOverview.c"
	}
#line 283 "../src/Widgets/WindowOverview.vala"
	clutter_threads_add_timeout ((guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ___lambda127__gsource_func, self);
#line 1621 "WindowOverview.c"
}

static void
gala_window_overview_cleanup (GalaWindowOverview* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	GList* _tmp6_;
#line 290 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 291 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 293 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 293 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = self->priv->modal_proxy;
#line 293 "../src/Widgets/WindowOverview.vala"
	gala_window_manager_pop_modal (_tmp0_, _tmp1_);
#line 295 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 295 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 295 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 295 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 295 "../src/Widgets/WindowOverview.vala"
	_tmp6_ = meta_workspace_list_windows (_tmp5_);
#line 1654 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 295 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp6_;
#line 295 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1662 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 295 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 1666 "WindowOverview.c"
			{
				MetaWindow* _tmp7_;
#line 296 "../src/Widgets/WindowOverview.vala"
				_tmp7_ = window;
#line 296 "../src/Widgets/WindowOverview.vala"
				if (meta_window_showing_on_its_workspace (_tmp7_)) {
#line 1673 "WindowOverview.c"
					MetaWindow* _tmp8_;
					GObject* _tmp9_;
#line 297 "../src/Widgets/WindowOverview.vala"
					_tmp8_ = window;
#line 297 "../src/Widgets/WindowOverview.vala"
					_tmp9_ = meta_window_get_compositor_private (_tmp8_);
#line 297 "../src/Widgets/WindowOverview.vala"
					clutter_actor_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, clutter_actor_get_type (), ClutterActor));
#line 1682 "WindowOverview.c"
				}
			}
		}
#line 295 "../src/Widgets/WindowOverview.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1688 "WindowOverview.c"
	}
#line 301 "../src/Widgets/WindowOverview.vala"
	clutter_actor_destroy_all_children ((ClutterActor*) self);
#line 1692 "WindowOverview.c"
}

GalaWindowManager*
gala_window_overview_get_wm (GalaWindowOverview* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 13 "../src/Widgets/WindowOverview.vala"
	result = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1708 "WindowOverview.c"
}

static void
gala_window_overview_set_wm (GalaWindowOverview* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	old_value = gala_window_overview_get_wm (self);
#line 13 "../src/Widgets/WindowOverview.vala"
	if (old_value != value) {
#line 1722 "WindowOverview.c"
		GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 13 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self->priv->_wm);
#line 13 "../src/Widgets/WindowOverview.vala"
		self->priv->_wm = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY]);
#line 1732 "WindowOverview.c"
	}
}

static GObject *
gala_window_overview_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowOverview * self;
#line 24 "../src/Widgets/WindowOverview.vala"
	parent_class = G_OBJECT_CLASS (gala_window_overview_parent_class);
#line 24 "../src/Widgets/WindowOverview.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 24 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 25 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 26 "../src/Widgets/WindowOverview.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 24 "../src/Widgets/WindowOverview.vala"
	return obj;
#line 1756 "WindowOverview.c"
}

static void
gala_window_overview_class_init (GalaWindowOverviewClass * klass,
                                 gpointer klass_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Widgets/WindowOverview.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowOverview_private_offset);
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_key_press_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor*)) gala_window_overview_real_key_focus_out;
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->button_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_button_release_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_overview_get_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_overview_set_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_overview_constructor;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_overview_finalize;
#line 8 "../src/Widgets/WindowOverview.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_OVERVIEW_WM_PROPERTY, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1783 "WindowOverview.c"
}

static void
gala_window_overview_gala_activatable_component_interface_init (GalaActivatableComponentIface * iface,
                                                                gpointer iface_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_gala_activatable_component_parent_iface = g_type_interface_peek_parent (iface);
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->is_opened = (gboolean (*) (GalaActivatableComponent*)) gala_window_overview_real_is_opened;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->open = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_open;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->close = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_close;
#line 1798 "WindowOverview.c"
}

static void
gala_window_overview_instance_init (GalaWindowOverview * self,
                                    gpointer klass)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	self->priv = gala_window_overview_get_instance_private (self);
#line 1807 "WindowOverview.c"
}

static void
gala_window_overview_finalize (GObject * obj)
{
	GalaWindowOverview * self;
#line 8 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 13 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->_wm);
#line 15 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 18 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (gala_window_overview_parent_class)->finalize (obj);
#line 1824 "WindowOverview.c"
}

static GType
gala_window_overview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowOverviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_overview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowOverview), 0, (GInstanceInitFunc) gala_window_overview_instance_init, NULL };
	static const GInterfaceInfo gala_activatable_component_info = { (GInterfaceInitFunc) gala_window_overview_gala_activatable_component_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_window_overview_type_id;
	gala_window_overview_type_id = g_type_register_static (clutter_actor_get_type (), "GalaWindowOverview", &g_define_type_info, 0);
	g_type_add_interface_static (gala_window_overview_type_id, GALA_TYPE_ACTIVATABLE_COMPONENT, &gala_activatable_component_info);
	GalaWindowOverview_private_offset = g_type_add_instance_private (gala_window_overview_type_id, sizeof (GalaWindowOverviewPrivate));
	return gala_window_overview_type_id;
}

GType
gala_window_overview_get_type (void)
{
	static volatile gsize gala_window_overview_type_id__once = 0;
	if (g_once_init_enter (&gala_window_overview_type_id__once)) {
		GType gala_window_overview_type_id;
		gala_window_overview_type_id = gala_window_overview_get_type_once ();
		g_once_init_leave (&gala_window_overview_type_id__once, gala_window_overview_type_id);
	}
	return gala_window_overview_type_id__once;
}

static void
_vala_gala_window_overview_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		g_value_set_object (value, gala_window_overview_get_wm (self));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1867 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1873 "WindowOverview.c"
	}
}

static void
_vala_gala_window_overview_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		gala_window_overview_set_wm (self, g_value_get_object (value));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1893 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1899 "WindowOverview.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 1914 "WindowOverview.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 1918 "WindowOverview.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 1922 "WindowOverview.c"
}

