/* WorkspaceManager.c generated by valac 0.56.17, the Vala compiler
 * generated from WorkspaceManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include "gala.h"
#include <gee.h>
#include <meta/workspace.h>
#include <glib.h>
#include <meta/prefs.h>
#include <meta/display.h>
#include <meta/meta-plugin.h>
#include <meta/meta-workspace-manager.h>
#include <meta/common.h>
#include <meta/window.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WORKSPACE_MANAGER (gala_workspace_manager_get_type ())
#define GALA_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager))
#define GALA_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))
#define GALA_IS_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_IS_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_WORKSPACE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))

typedef struct _GalaWorkspaceManager GalaWorkspaceManager;
typedef struct _GalaWorkspaceManagerClass GalaWorkspaceManagerClass;
typedef struct _GalaWorkspaceManagerPrivate GalaWorkspaceManagerPrivate;
enum  {
	GALA_WORKSPACE_MANAGER_0_PROPERTY,
	GALA_WORKSPACE_MANAGER_WM_PROPERTY,
	GALA_WORKSPACE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWorkspaceManager {
	GObject parent_instance;
	GalaWorkspaceManagerPrivate * priv;
};

struct _GalaWorkspaceManagerClass {
	GObjectClass parent_class;
};

struct _GalaWorkspaceManagerPrivate {
	GalaWindowManager* _wm;
	GeeLinkedList* workspaces_marked_removed;
	gint remove_freeze_count;
};

static gint GalaWorkspaceManager_private_offset;
static gpointer gala_workspace_manager_parent_class = NULL;
static GalaWorkspaceManager* gala_workspace_manager_instance;
static GalaWorkspaceManager* gala_workspace_manager_instance = NULL;

VALA_EXTERN GType gala_workspace_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWorkspaceManager, g_object_unref)
static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                            MetaPreference pref);
static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                     gpointer self);
VALA_EXTERN GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self);
static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                             MetaWorkspaceManager* manager,
                                             gint index);
static void _gala_workspace_manager_workspace_added_meta_workspace_manager_workspace_added (MetaWorkspaceManager* _sender,
                                                                                     gint object,
                                                                                     gpointer self);
static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                                MetaWorkspaceManager* manager,
                                                gint from,
                                                gint to,
                                                MetaMotionDirection direction);
static void _gala_workspace_manager_workspace_switched_meta_workspace_manager_workspace_switched (MetaWorkspaceManager* _sender,
                                                                                           gint object,
                                                                                           gint p0,
                                                                                           MetaMotionDirection p1,
                                                                                           gpointer self);
static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                               MetaWorkspaceManager* manager,
                                               gint index);
static void _gala_workspace_manager_workspace_removed_meta_workspace_manager_workspace_removed (MetaWorkspaceManager* _sender,
                                                                                         gint object,
                                                                                         gpointer self);
static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                                    MetaDisplay* display,
                                                    gint monitor,
                                                    MetaWindow* window);
static void _gala_workspace_manager_window_entered_monitor_meta_display_window_entered_monitor (MetaDisplay* _sender,
                                                                                         gint object,
                                                                                         MetaWindow* p0,
                                                                                         gpointer self);
static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                                 MetaDisplay* display,
                                                 gint monitor,
                                                 MetaWindow* window);
static void _gala_workspace_manager_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                                   gint object,
                                                                                   MetaWindow* p0,
                                                                                   gpointer self);
VALA_EXTERN void gala_workspace_manager_init (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type,
                                                        GalaWindowManager* wm);
VALA_EXTERN GalaWorkspaceManager* gala_workspace_manager_get_default (void);
static void gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                          MetaWorkspace* workspace,
                                          MetaWindow* window);
static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                       MetaWindow* object,
                                                                       gpointer self);
static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                            MetaWorkspace* workspace,
                                            MetaWindow* window);
static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                           MetaWindow* object,
                                                                           gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                              MetaWorkspace* workspace);
static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self);
VALA_EXTERN gboolean gala_internal_utils_workspaces_only_on_primary (void);
VALA_EXTERN void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self);
VALA_EXTERN void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self);
VALA_EXTERN void gala_workspace_manager_cleanup (GalaWorkspaceManager* self);
static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                                    GalaWindowManager* value);
static GObject * gala_workspace_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void gala_workspace_manager_finalize (GObject * obj);
static GType gala_workspace_manager_get_type_once (void);
static void _vala_gala_workspace_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_workspace_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_workspace_manager_get_instance_private (GalaWorkspaceManager* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWorkspaceManager_private_offset);
}

static void
_gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                gpointer self)
{
#line 68 "../src/WorkspaceManager.vala"
	gala_workspace_manager_prefs_listener ((GalaWorkspaceManager*) self, pref);
#line 196 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_added_meta_workspace_manager_workspace_added (MetaWorkspaceManager* _sender,
                                                                                gint object,
                                                                                gpointer self)
{
#line 72 "../src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_added ((GalaWorkspaceManager*) self, _sender, object);
#line 206 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_switched_meta_workspace_manager_workspace_switched (MetaWorkspaceManager* _sender,
                                                                                      gint object,
                                                                                      gint p0,
                                                                                      MetaMotionDirection p1,
                                                                                      gpointer self)
{
#line 73 "../src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_switched ((GalaWorkspaceManager*) self, _sender, object, p0, p1);
#line 218 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_removed_meta_workspace_manager_workspace_removed (MetaWorkspaceManager* _sender,
                                                                                    gint object,
                                                                                    gpointer self)
{
#line 74 "../src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 228 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_entered_monitor_meta_display_window_entered_monitor (MetaDisplay* _sender,
                                                                                    gint object,
                                                                                    MetaWindow* p0,
                                                                                    gpointer self)
{
#line 75 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_entered_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 239 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                              gint object,
                                                                              MetaWindow* p0,
                                                                              gpointer self)
{
#line 76 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_left_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 250 "WorkspaceManager.c"
}

void
gala_workspace_manager_init (GalaWindowManager* wm)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
#line 20 "../src/WorkspaceManager.vala"
	g_return_if_fail (wm != NULL);
#line 20 "../src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 20 "../src/WorkspaceManager.vala"
	_vala_return_if_fail (_tmp0_ == NULL, "instance == null");
#line 21 "../src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_new (wm);
#line 21 "../src/WorkspaceManager.vala"
	_g_object_unref0 (gala_workspace_manager_instance);
#line 21 "../src/WorkspaceManager.vala"
	gala_workspace_manager_instance = _tmp1_;
#line 270 "WorkspaceManager.c"
}

GalaWorkspaceManager*
gala_workspace_manager_get_default (void)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
	GalaWorkspaceManager* result;
#line 24 "../src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 24 "../src/WorkspaceManager.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
#line 25 "../src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_instance;
#line 25 "../src/WorkspaceManager.vala"
	result = _tmp1_;
#line 25 "../src/WorkspaceManager.vala"
	return result;
#line 289 "WorkspaceManager.c"
}

static GalaWorkspaceManager*
gala_workspace_manager_construct (GType object_type,
                                  GalaWindowManager* wm)
{
	GalaWorkspaceManager * self = NULL;
#line 35 "../src/WorkspaceManager.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 36 "../src/WorkspaceManager.vala"
	self = (GalaWorkspaceManager*) g_object_new (object_type, "wm", wm, NULL);
#line 35 "../src/WorkspaceManager.vala"
	return self;
#line 303 "WorkspaceManager.c"
}

static GalaWorkspaceManager*
gala_workspace_manager_new (GalaWindowManager* wm)
{
#line 35 "../src/WorkspaceManager.vala"
	return gala_workspace_manager_construct (GALA_TYPE_WORKSPACE_MANAGER, wm);
#line 311 "WorkspaceManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../src/WorkspaceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 319 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                  MetaWindow* object,
                                                                  gpointer self)
{
#line 84 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_added ((GalaWorkspaceManager*) self, _sender, object);
#line 329 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                      MetaWindow* object,
                                                                      gpointer self)
{
#line 85 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 339 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                        MetaWorkspaceManager* manager,
                                        gint index)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
#line 79 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/WorkspaceManager.vala"
	g_return_if_fail (manager != NULL);
#line 80 "../src/WorkspaceManager.vala"
	_tmp0_ = meta_workspace_manager_get_workspace_by_index (manager, index);
#line 80 "../src/WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 80 "../src/WorkspaceManager.vala"
	workspace = _tmp1_;
#line 81 "../src/WorkspaceManager.vala"
	_tmp2_ = workspace;
#line 81 "../src/WorkspaceManager.vala"
	if (_tmp2_ == NULL) {
#line 82 "../src/WorkspaceManager.vala"
		_g_object_unref0 (workspace);
#line 82 "../src/WorkspaceManager.vala"
		return;
#line 371 "WorkspaceManager.c"
	}
#line 84 "../src/WorkspaceManager.vala"
	_tmp3_ = workspace;
#line 84 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp3_, "window-added", (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self, 0);
#line 85 "../src/WorkspaceManager.vala"
	_tmp4_ = workspace;
#line 85 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp4_, "window-removed", (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self, 0);
#line 79 "../src/WorkspaceManager.vala"
	_g_object_unref0 (workspace);
#line 383 "WorkspaceManager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 88 "../src/WorkspaceManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 391 "WorkspaceManager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 88 "../src/WorkspaceManager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 399 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                          MetaWorkspaceManager* manager,
                                          gint index)
{
	GList* existing_workspaces = NULL;
	GeeIterator* it = NULL;
	GeeLinkedList* _tmp4_;
	GeeIterator* _tmp5_;
#line 88 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/WorkspaceManager.vala"
	g_return_if_fail (manager != NULL);
#line 89 "../src/WorkspaceManager.vala"
	existing_workspaces = NULL;
#line 417 "WorkspaceManager.c"
	{
		gint i = 0;
#line 90 "../src/WorkspaceManager.vala"
		i = 0;
#line 422 "WorkspaceManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 90 "../src/WorkspaceManager.vala"
			_tmp0_ = TRUE;
#line 90 "../src/WorkspaceManager.vala"
			while (TRUE) {
#line 429 "WorkspaceManager.c"
				MetaWorkspace* _tmp2_;
				MetaWorkspace* _tmp3_;
#line 90 "../src/WorkspaceManager.vala"
				if (!_tmp0_) {
#line 434 "WorkspaceManager.c"
					gint _tmp1_;
#line 90 "../src/WorkspaceManager.vala"
					_tmp1_ = i;
#line 90 "../src/WorkspaceManager.vala"
					i = _tmp1_ + 1;
#line 440 "WorkspaceManager.c"
				}
#line 90 "../src/WorkspaceManager.vala"
				_tmp0_ = FALSE;
#line 90 "../src/WorkspaceManager.vala"
				if (!(i < meta_workspace_manager_get_n_workspaces (manager))) {
#line 90 "../src/WorkspaceManager.vala"
					break;
#line 448 "WorkspaceManager.c"
				}
#line 91 "../src/WorkspaceManager.vala"
				_tmp2_ = meta_workspace_manager_get_workspace_by_index (manager, i);
#line 91 "../src/WorkspaceManager.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 91 "../src/WorkspaceManager.vala"
				existing_workspaces = g_list_append (existing_workspaces, _tmp3_);
#line 456 "WorkspaceManager.c"
			}
		}
	}
#line 94 "../src/WorkspaceManager.vala"
	_tmp4_ = self->priv->workspaces_marked_removed;
#line 94 "../src/WorkspaceManager.vala"
	_tmp5_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp4_);
#line 94 "../src/WorkspaceManager.vala"
	it = _tmp5_;
#line 95 "../src/WorkspaceManager.vala"
	while (TRUE) {
#line 468 "WorkspaceManager.c"
		GeeIterator* _tmp6_;
		MetaWorkspace* workspace = NULL;
		GeeIterator* _tmp7_;
		gpointer _tmp8_;
		GList* _tmp9_;
		MetaWorkspace* _tmp10_;
#line 95 "../src/WorkspaceManager.vala"
		_tmp6_ = it;
#line 95 "../src/WorkspaceManager.vala"
		if (!gee_iterator_next (_tmp6_)) {
#line 95 "../src/WorkspaceManager.vala"
			break;
#line 481 "WorkspaceManager.c"
		}
#line 96 "../src/WorkspaceManager.vala"
		_tmp7_ = it;
#line 96 "../src/WorkspaceManager.vala"
		_tmp8_ = gee_iterator_get (_tmp7_);
#line 96 "../src/WorkspaceManager.vala"
		workspace = (MetaWorkspace*) _tmp8_;
#line 98 "../src/WorkspaceManager.vala"
		_tmp9_ = existing_workspaces;
#line 98 "../src/WorkspaceManager.vala"
		_tmp10_ = workspace;
#line 98 "../src/WorkspaceManager.vala"
		if (g_list_index (_tmp9_, _tmp10_) < 0) {
#line 495 "WorkspaceManager.c"
			GeeIterator* _tmp11_;
#line 99 "../src/WorkspaceManager.vala"
			_tmp11_ = it;
#line 99 "../src/WorkspaceManager.vala"
			gee_iterator_remove (_tmp11_);
#line 501 "WorkspaceManager.c"
		}
#line 95 "../src/WorkspaceManager.vala"
		_g_object_unref0 (workspace);
#line 505 "WorkspaceManager.c"
	}
#line 88 "../src/WorkspaceManager.vala"
	_g_object_unref0 (it);
#line 88 "../src/WorkspaceManager.vala"
	(existing_workspaces == NULL) ? NULL : (existing_workspaces = (_g_list_free__g_object_unref0_ (existing_workspaces), NULL));
#line 511 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                           MetaWorkspaceManager* manager,
                                           gint from,
                                           gint to,
                                           MetaMotionDirection direction)
{
	MetaWorkspace* prev_workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWorkspace* _tmp3_;
#line 103 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/WorkspaceManager.vala"
	g_return_if_fail (manager != NULL);
#line 104 "../src/WorkspaceManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 105 "../src/WorkspaceManager.vala"
		return;
#line 534 "WorkspaceManager.c"
	}
#line 108 "../src/WorkspaceManager.vala"
	_tmp0_ = meta_workspace_manager_get_workspace_by_index (manager, from);
#line 108 "../src/WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 108 "../src/WorkspaceManager.vala"
	prev_workspace = _tmp1_;
#line 109 "../src/WorkspaceManager.vala"
	_tmp3_ = prev_workspace;
#line 109 "../src/WorkspaceManager.vala"
	if (gala_utils_get_n_windows (_tmp3_, FALSE) < ((guint) 1)) {
#line 110 "../src/WorkspaceManager.vala"
		_tmp2_ = from != (meta_workspace_manager_get_n_workspaces (manager) - 1);
#line 548 "WorkspaceManager.c"
	} else {
#line 109 "../src/WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 552 "WorkspaceManager.c"
	}
#line 109 "../src/WorkspaceManager.vala"
	if (_tmp2_) {
#line 556 "WorkspaceManager.c"
		MetaWorkspace* _tmp4_;
#line 114 "../src/WorkspaceManager.vala"
		gala_drag_drop_action_cancel_all_by_id ("multitaskingview-window");
#line 116 "../src/WorkspaceManager.vala"
		_tmp4_ = prev_workspace;
#line 116 "../src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, _tmp4_);
#line 564 "WorkspaceManager.c"
	}
#line 103 "../src/WorkspaceManager.vala"
	_g_object_unref0 (prev_workspace);
#line 568 "WorkspaceManager.c"
}

static void
gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                     MetaWorkspace* workspace,
                                     MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp4_;
	MetaWorkspaceManager* _tmp5_;
	gint last_workspace = 0;
	MetaWorkspaceManager* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	MetaWindowType _tmp10_;
	MetaWindowType _tmp11_;
#line 120 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 121 "../src/WorkspaceManager.vala"
	if (workspace == NULL) {
#line 121 "../src/WorkspaceManager.vala"
		_tmp1_ = TRUE;
#line 596 "WorkspaceManager.c"
	} else {
#line 121 "../src/WorkspaceManager.vala"
		_tmp1_ = !meta_prefs_get_dynamic_workspaces ();
#line 600 "WorkspaceManager.c"
	}
#line 121 "../src/WorkspaceManager.vala"
	if (_tmp1_) {
#line 121 "../src/WorkspaceManager.vala"
		_tmp0_ = TRUE;
#line 606 "WorkspaceManager.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 121 "../src/WorkspaceManager.vala"
		g_object_get (window, "on-all-workspaces", &_tmp2_, NULL);
#line 121 "../src/WorkspaceManager.vala"
		_tmp3_ = _tmp2_;
#line 121 "../src/WorkspaceManager.vala"
		_tmp0_ = _tmp3_;
#line 616 "WorkspaceManager.c"
	}
#line 121 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 122 "../src/WorkspaceManager.vala"
		return;
#line 622 "WorkspaceManager.c"
	}
#line 125 "../src/WorkspaceManager.vala"
	_tmp4_ = meta_workspace_get_display (workspace);
#line 125 "../src/WorkspaceManager.vala"
	_tmp5_ = meta_display_get_workspace_manager (_tmp4_);
#line 125 "../src/WorkspaceManager.vala"
	manager = _tmp5_;
#line 126 "../src/WorkspaceManager.vala"
	_tmp6_ = manager;
#line 126 "../src/WorkspaceManager.vala"
	last_workspace = meta_workspace_manager_get_n_workspaces (_tmp6_) - 1;
#line 128 "../src/WorkspaceManager.vala"
	_tmp10_ = meta_window_get_window_type (window);
#line 128 "../src/WorkspaceManager.vala"
	_tmp11_ = _tmp10_;
#line 128 "../src/WorkspaceManager.vala"
	if (_tmp11_ == META_WINDOW_NORMAL) {
#line 128 "../src/WorkspaceManager.vala"
		_tmp9_ = TRUE;
#line 642 "WorkspaceManager.c"
	} else {
		MetaWindowType _tmp12_;
		MetaWindowType _tmp13_;
#line 129 "../src/WorkspaceManager.vala"
		_tmp12_ = meta_window_get_window_type (window);
#line 129 "../src/WorkspaceManager.vala"
		_tmp13_ = _tmp12_;
#line 129 "../src/WorkspaceManager.vala"
		_tmp9_ = _tmp13_ == META_WINDOW_DIALOG;
#line 652 "WorkspaceManager.c"
	}
#line 128 "../src/WorkspaceManager.vala"
	if (_tmp9_) {
#line 128 "../src/WorkspaceManager.vala"
		_tmp8_ = TRUE;
#line 658 "WorkspaceManager.c"
	} else {
		MetaWindowType _tmp14_;
		MetaWindowType _tmp15_;
#line 130 "../src/WorkspaceManager.vala"
		_tmp14_ = meta_window_get_window_type (window);
#line 130 "../src/WorkspaceManager.vala"
		_tmp15_ = _tmp14_;
#line 130 "../src/WorkspaceManager.vala"
		_tmp8_ = _tmp15_ == META_WINDOW_MODAL_DIALOG;
#line 668 "WorkspaceManager.c"
	}
#line 128 "../src/WorkspaceManager.vala"
	if (_tmp8_) {
#line 131 "../src/WorkspaceManager.vala"
		_tmp7_ = meta_workspace_index (workspace) == last_workspace;
#line 674 "WorkspaceManager.c"
	} else {
#line 128 "../src/WorkspaceManager.vala"
		_tmp7_ = FALSE;
#line 678 "WorkspaceManager.c"
	}
#line 128 "../src/WorkspaceManager.vala"
	if (_tmp7_) {
#line 132 "../src/WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 684 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                       MetaWorkspace* workspace,
                                       MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp4_;
	MetaWorkspaceManager* _tmp5_;
	gboolean is_active_workspace = FALSE;
	MetaWorkspaceManager* _tmp6_;
	MetaWorkspace* _tmp7_;
	gint last_workspace_index = 0;
	MetaWorkspaceManager* _tmp8_;
	MetaWorkspace* last_workspace = NULL;
	MetaWorkspaceManager* _tmp9_;
	MetaWorkspace* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	MetaWindowType _tmp13_;
	MetaWindowType _tmp14_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
#line 135 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 136 "../src/WorkspaceManager.vala"
	if (workspace == NULL) {
#line 136 "../src/WorkspaceManager.vala"
		_tmp1_ = TRUE;
#line 725 "WorkspaceManager.c"
	} else {
#line 136 "../src/WorkspaceManager.vala"
		_tmp1_ = !meta_prefs_get_dynamic_workspaces ();
#line 729 "WorkspaceManager.c"
	}
#line 136 "../src/WorkspaceManager.vala"
	if (_tmp1_) {
#line 136 "../src/WorkspaceManager.vala"
		_tmp0_ = TRUE;
#line 735 "WorkspaceManager.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 136 "../src/WorkspaceManager.vala"
		g_object_get (window, "on-all-workspaces", &_tmp2_, NULL);
#line 136 "../src/WorkspaceManager.vala"
		_tmp3_ = _tmp2_;
#line 136 "../src/WorkspaceManager.vala"
		_tmp0_ = _tmp3_;
#line 745 "WorkspaceManager.c"
	}
#line 136 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 137 "../src/WorkspaceManager.vala"
		return;
#line 751 "WorkspaceManager.c"
	}
#line 140 "../src/WorkspaceManager.vala"
	_tmp4_ = meta_workspace_get_display (workspace);
#line 140 "../src/WorkspaceManager.vala"
	_tmp5_ = meta_display_get_workspace_manager (_tmp4_);
#line 140 "../src/WorkspaceManager.vala"
	manager = _tmp5_;
#line 141 "../src/WorkspaceManager.vala"
	_tmp6_ = manager;
#line 141 "../src/WorkspaceManager.vala"
	_tmp7_ = meta_workspace_manager_get_active_workspace (_tmp6_);
#line 141 "../src/WorkspaceManager.vala"
	is_active_workspace = workspace == _tmp7_;
#line 142 "../src/WorkspaceManager.vala"
	_tmp8_ = manager;
#line 142 "../src/WorkspaceManager.vala"
	last_workspace_index = meta_workspace_manager_get_n_workspaces (_tmp8_) - 1;
#line 143 "../src/WorkspaceManager.vala"
	_tmp9_ = manager;
#line 143 "../src/WorkspaceManager.vala"
	_tmp10_ = meta_workspace_manager_get_workspace_by_index (_tmp9_, last_workspace_index);
#line 143 "../src/WorkspaceManager.vala"
	last_workspace = _tmp10_;
#line 145 "../src/WorkspaceManager.vala"
	_tmp13_ = meta_window_get_window_type (window);
#line 145 "../src/WorkspaceManager.vala"
	_tmp14_ = _tmp13_;
#line 145 "../src/WorkspaceManager.vala"
	if (_tmp14_ != META_WINDOW_NORMAL) {
#line 781 "WorkspaceManager.c"
		MetaWindowType _tmp15_;
		MetaWindowType _tmp16_;
#line 146 "../src/WorkspaceManager.vala"
		_tmp15_ = meta_window_get_window_type (window);
#line 146 "../src/WorkspaceManager.vala"
		_tmp16_ = _tmp15_;
#line 146 "../src/WorkspaceManager.vala"
		_tmp12_ = _tmp16_ != META_WINDOW_DIALOG;
#line 790 "WorkspaceManager.c"
	} else {
#line 145 "../src/WorkspaceManager.vala"
		_tmp12_ = FALSE;
#line 794 "WorkspaceManager.c"
	}
#line 145 "../src/WorkspaceManager.vala"
	if (_tmp12_) {
#line 798 "WorkspaceManager.c"
		MetaWindowType _tmp17_;
		MetaWindowType _tmp18_;
#line 147 "../src/WorkspaceManager.vala"
		_tmp17_ = meta_window_get_window_type (window);
#line 147 "../src/WorkspaceManager.vala"
		_tmp18_ = _tmp17_;
#line 147 "../src/WorkspaceManager.vala"
		_tmp11_ = _tmp18_ != META_WINDOW_MODAL_DIALOG;
#line 807 "WorkspaceManager.c"
	} else {
#line 145 "../src/WorkspaceManager.vala"
		_tmp11_ = FALSE;
#line 811 "WorkspaceManager.c"
	}
#line 145 "../src/WorkspaceManager.vala"
	if (_tmp11_) {
#line 148 "../src/WorkspaceManager.vala"
		return;
#line 817 "WorkspaceManager.c"
	}
#line 151 "../src/WorkspaceManager.vala"
	if (meta_workspace_index (workspace) < 0) {
#line 152 "../src/WorkspaceManager.vala"
		return;
#line 823 "WorkspaceManager.c"
	}
#line 157 "../src/WorkspaceManager.vala"
	if (!is_active_workspace) {
#line 157 "../src/WorkspaceManager.vala"
		_tmp22_ = TRUE;
#line 829 "WorkspaceManager.c"
	} else {
		GalaWindowManager* _tmp23_;
#line 157 "../src/WorkspaceManager.vala"
		_tmp23_ = self->priv->_wm;
#line 157 "../src/WorkspaceManager.vala"
		_tmp22_ = gala_window_manager_is_modal (_tmp23_);
#line 836 "WorkspaceManager.c"
	}
#line 157 "../src/WorkspaceManager.vala"
	if (_tmp22_) {
#line 158 "../src/WorkspaceManager.vala"
		_tmp21_ = self->priv->remove_freeze_count < 1;
#line 842 "WorkspaceManager.c"
	} else {
#line 157 "../src/WorkspaceManager.vala"
		_tmp21_ = FALSE;
#line 846 "WorkspaceManager.c"
	}
#line 157 "../src/WorkspaceManager.vala"
	if (_tmp21_) {
#line 159 "../src/WorkspaceManager.vala"
		_tmp20_ = gala_utils_get_n_windows (workspace, TRUE) == ((guint) 0);
#line 852 "WorkspaceManager.c"
	} else {
#line 157 "../src/WorkspaceManager.vala"
		_tmp20_ = FALSE;
#line 856 "WorkspaceManager.c"
	}
#line 157 "../src/WorkspaceManager.vala"
	if (_tmp20_) {
#line 860 "WorkspaceManager.c"
		MetaWorkspace* _tmp24_;
#line 160 "../src/WorkspaceManager.vala"
		_tmp24_ = last_workspace;
#line 160 "../src/WorkspaceManager.vala"
		_tmp19_ = workspace != _tmp24_;
#line 866 "WorkspaceManager.c"
	} else {
#line 157 "../src/WorkspaceManager.vala"
		_tmp19_ = FALSE;
#line 870 "WorkspaceManager.c"
	}
#line 157 "../src/WorkspaceManager.vala"
	if (_tmp19_) {
#line 161 "../src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, workspace);
#line 876 "WorkspaceManager.c"
	}
#line 165 "../src/WorkspaceManager.vala"
	if (is_active_workspace) {
#line 166 "../src/WorkspaceManager.vala"
		_tmp27_ = self->priv->remove_freeze_count < 1;
#line 882 "WorkspaceManager.c"
	} else {
#line 165 "../src/WorkspaceManager.vala"
		_tmp27_ = FALSE;
#line 886 "WorkspaceManager.c"
	}
#line 165 "../src/WorkspaceManager.vala"
	if (_tmp27_) {
#line 167 "../src/WorkspaceManager.vala"
		_tmp26_ = gala_utils_get_n_windows (workspace, TRUE) == ((guint) 0);
#line 892 "WorkspaceManager.c"
	} else {
#line 165 "../src/WorkspaceManager.vala"
		_tmp26_ = FALSE;
#line 896 "WorkspaceManager.c"
	}
#line 165 "../src/WorkspaceManager.vala"
	if (_tmp26_) {
#line 168 "../src/WorkspaceManager.vala"
		_tmp25_ = meta_workspace_index (workspace) == (last_workspace_index - 1);
#line 902 "WorkspaceManager.c"
	} else {
#line 165 "../src/WorkspaceManager.vala"
		_tmp25_ = FALSE;
#line 906 "WorkspaceManager.c"
	}
#line 165 "../src/WorkspaceManager.vala"
	if (_tmp25_) {
#line 910 "WorkspaceManager.c"
		MetaWorkspace* _tmp28_;
#line 169 "../src/WorkspaceManager.vala"
		_tmp28_ = last_workspace;
#line 169 "../src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, _tmp28_);
#line 916 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                               MetaDisplay* display,
                                               gint monitor,
                                               MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 173 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/WorkspaceManager.vala"
	g_return_if_fail (display != NULL);
#line 173 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 174 "../src/WorkspaceManager.vala"
	if (gala_internal_utils_workspaces_only_on_primary ()) {
#line 175 "../src/WorkspaceManager.vala"
		_tmp0_ = monitor == meta_display_get_primary_monitor (display);
#line 937 "WorkspaceManager.c"
	} else {
#line 174 "../src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 941 "WorkspaceManager.c"
	}
#line 174 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 945 "WorkspaceManager.c"
		MetaWorkspace* _tmp1_;
#line 176 "../src/WorkspaceManager.vala"
		_tmp1_ = meta_window_get_workspace (window);
#line 176 "../src/WorkspaceManager.vala"
		gala_workspace_manager_window_added (self, _tmp1_, window);
#line 951 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                            MetaDisplay* display,
                                            gint monitor,
                                            MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 179 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/WorkspaceManager.vala"
	g_return_if_fail (display != NULL);
#line 179 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 180 "../src/WorkspaceManager.vala"
	if (gala_internal_utils_workspaces_only_on_primary ()) {
#line 181 "../src/WorkspaceManager.vala"
		_tmp0_ = monitor == meta_display_get_primary_monitor (display);
#line 972 "WorkspaceManager.c"
	} else {
#line 180 "../src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 976 "WorkspaceManager.c"
	}
#line 180 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 980 "WorkspaceManager.c"
		MetaWorkspace* _tmp1_;
#line 182 "../src/WorkspaceManager.vala"
		_tmp1_ = meta_window_get_workspace (window);
#line 182 "../src/WorkspaceManager.vala"
		gala_workspace_manager_window_removed (self, _tmp1_, window);
#line 986 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                       MetaPreference pref)
{
	MetaWorkspaceManager* manager = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 185 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 186 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 186 "../src/WorkspaceManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 186 "../src/WorkspaceManager.vala"
	manager = _tmp2_;
#line 188 "../src/WorkspaceManager.vala"
	if (pref == META_PREF_DYNAMIC_WORKSPACES) {
#line 188 "../src/WorkspaceManager.vala"
		_tmp3_ = meta_prefs_get_dynamic_workspaces ();
#line 1013 "WorkspaceManager.c"
	} else {
#line 188 "../src/WorkspaceManager.vala"
		_tmp3_ = FALSE;
#line 1017 "WorkspaceManager.c"
	}
#line 188 "../src/WorkspaceManager.vala"
	if (_tmp3_) {
#line 1021 "WorkspaceManager.c"
		MetaWorkspaceManager* _tmp4_;
		MetaWorkspaceManager* _tmp5_;
		MetaWorkspace* _tmp6_;
#line 190 "../src/WorkspaceManager.vala"
		_tmp4_ = manager;
#line 190 "../src/WorkspaceManager.vala"
		_tmp5_ = manager;
#line 190 "../src/WorkspaceManager.vala"
		_tmp6_ = meta_workspace_manager_get_workspace_by_index (_tmp4_, meta_workspace_manager_get_n_workspaces (_tmp5_) - 1);
#line 190 "../src/WorkspaceManager.vala"
		if (gala_utils_get_n_windows (_tmp6_, FALSE) > ((guint) 0)) {
#line 191 "../src/WorkspaceManager.vala"
			gala_workspace_manager_append_workspace (self);
#line 1035 "WorkspaceManager.c"
		}
	}
}

static void
gala_workspace_manager_append_workspace (GalaWorkspaceManager* self)
{
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* manager = NULL;
	MetaWorkspaceManager* _tmp2_;
#line 195 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 196 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 196 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 196 "../src/WorkspaceManager.vala"
	display = _tmp1_;
#line 197 "../src/WorkspaceManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (display);
#line 197 "../src/WorkspaceManager.vala"
	manager = _tmp2_;
#line 199 "../src/WorkspaceManager.vala"
	meta_workspace_manager_append_new_workspace (manager, FALSE, meta_display_get_current_time (display));
#line 1062 "WorkspaceManager.c"
}

/**
         * Make sure we switch to a different workspace and remove the given one
         *
         * @param workspace The workspace to remove
         */
static void
gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                         MetaWorkspace* workspace)
{
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	guint32 time = 0U;
	MetaDisplay* _tmp3_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	MetaWorkspace* _tmp6_;
	GeeLinkedList* _tmp16_;
	guint _tmp17_;
	guint _tmp18_;
	GeeLinkedList* _tmp19_;
	MetaWorkspaceManager* _tmp20_;
#line 207 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/WorkspaceManager.vala"
	g_return_if_fail (workspace != NULL);
#line 208 "../src/WorkspaceManager.vala"
	_tmp0_ = meta_workspace_get_display (workspace);
#line 208 "../src/WorkspaceManager.vala"
	display = _tmp0_;
#line 209 "../src/WorkspaceManager.vala"
	_tmp1_ = display;
#line 209 "../src/WorkspaceManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 209 "../src/WorkspaceManager.vala"
	manager = _tmp2_;
#line 210 "../src/WorkspaceManager.vala"
	_tmp3_ = display;
#line 210 "../src/WorkspaceManager.vala"
	time = meta_display_get_current_time (_tmp3_);
#line 211 "../src/WorkspaceManager.vala"
	_tmp4_ = manager;
#line 211 "../src/WorkspaceManager.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 211 "../src/WorkspaceManager.vala"
	active_workspace = _tmp5_;
#line 213 "../src/WorkspaceManager.vala"
	_tmp6_ = active_workspace;
#line 213 "../src/WorkspaceManager.vala"
	if (workspace == _tmp6_) {
#line 1118 "WorkspaceManager.c"
		MetaWorkspace* next = NULL;
		MetaWorkspace* _tmp7_;
		MetaWorkspace* _tmp8_;
		gboolean _tmp9_ = FALSE;
		MetaWorkspace* _tmp10_;
		MetaWorkspace* _tmp14_;
#line 214 "../src/WorkspaceManager.vala"
		next = NULL;
#line 216 "../src/WorkspaceManager.vala"
		_tmp7_ = meta_workspace_get_neighbor (workspace, META_MOTION_LEFT);
#line 216 "../src/WorkspaceManager.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 216 "../src/WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 216 "../src/WorkspaceManager.vala"
		next = _tmp8_;
#line 218 "../src/WorkspaceManager.vala"
		_tmp10_ = next;
#line 218 "../src/WorkspaceManager.vala"
		if (_tmp10_ == workspace) {
#line 218 "../src/WorkspaceManager.vala"
			_tmp9_ = TRUE;
#line 1141 "WorkspaceManager.c"
		} else {
			MetaWorkspace* _tmp11_;
#line 218 "../src/WorkspaceManager.vala"
			_tmp11_ = next;
#line 218 "../src/WorkspaceManager.vala"
			_tmp9_ = _tmp11_ == NULL;
#line 1148 "WorkspaceManager.c"
		}
#line 218 "../src/WorkspaceManager.vala"
		if (_tmp9_) {
#line 1152 "WorkspaceManager.c"
			MetaWorkspace* _tmp12_;
			MetaWorkspace* _tmp13_;
#line 219 "../src/WorkspaceManager.vala"
			_tmp12_ = meta_workspace_get_neighbor (workspace, META_MOTION_RIGHT);
#line 219 "../src/WorkspaceManager.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 219 "../src/WorkspaceManager.vala"
			_g_object_unref0 (next);
#line 219 "../src/WorkspaceManager.vala"
			next = _tmp13_;
#line 1163 "WorkspaceManager.c"
		}
#line 221 "../src/WorkspaceManager.vala"
		_tmp14_ = next;
#line 221 "../src/WorkspaceManager.vala"
		if (_tmp14_ != NULL) {
#line 1169 "WorkspaceManager.c"
			MetaWorkspace* _tmp15_;
#line 222 "../src/WorkspaceManager.vala"
			_tmp15_ = next;
#line 222 "../src/WorkspaceManager.vala"
			meta_workspace_activate (_tmp15_, time);
#line 1175 "WorkspaceManager.c"
		}
#line 213 "../src/WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 1179 "WorkspaceManager.c"
	}
#line 226 "../src/WorkspaceManager.vala"
	_tmp16_ = self->priv->workspaces_marked_removed;
#line 226 "../src/WorkspaceManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp16_, workspace)) {
#line 227 "../src/WorkspaceManager.vala"
		return;
#line 1187 "WorkspaceManager.c"
	}
#line 230 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp17_, NULL, FALSE);
#line 230 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self);
#line 231 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp18_, NULL, FALSE);
#line 231 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp18_, 0, NULL, (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self);
#line 233 "../src/WorkspaceManager.vala"
	_tmp19_ = self->priv->workspaces_marked_removed;
#line 233 "../src/WorkspaceManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, workspace);
#line 235 "../src/WorkspaceManager.vala"
	_tmp20_ = manager;
#line 235 "../src/WorkspaceManager.vala"
	meta_workspace_manager_remove_workspace (_tmp20_, workspace, time);
#line 1205 "WorkspaceManager.c"
}

/**
         * Temporarily disables removing workspaces when they are empty
         */
void
gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
#line 241 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 242 "../src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ + 1;
#line 1221 "WorkspaceManager.c"
}

/**
         * Undo the effect of freeze_remove()
         */
void
gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
#line 248 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 249 "../src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ - 1;
#line 251 "../src/WorkspaceManager.vala"
	_vala_assert (self->priv->remove_freeze_count >= 0, "remove_freeze_count >= 0");
#line 1239 "WorkspaceManager.c"
}

/**
         * If workspaces are dynamic, checks if there are empty workspaces that should
         * be removed. Particularly useful in conjunction with freeze/thaw_remove to
         * cleanup after an operation that required stable workspace/window indices
         */
void
gala_workspace_manager_cleanup (GalaWorkspaceManager* self)
{
	MetaWorkspaceManager* manager = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	GList* _tmp4_;
#line 259 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/WorkspaceManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 261 "../src/WorkspaceManager.vala"
		return;
#line 1262 "WorkspaceManager.c"
	}
#line 264 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 264 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 264 "../src/WorkspaceManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 264 "../src/WorkspaceManager.vala"
	manager = _tmp2_;
#line 266 "../src/WorkspaceManager.vala"
	_tmp3_ = manager;
#line 266 "../src/WorkspaceManager.vala"
	_tmp4_ = meta_workspace_manager_get_workspaces (_tmp3_);
#line 1276 "WorkspaceManager.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 266 "../src/WorkspaceManager.vala"
		workspace_collection = _tmp4_;
#line 266 "../src/WorkspaceManager.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1284 "WorkspaceManager.c"
			MetaWorkspace* _tmp5_;
			MetaWorkspace* workspace = NULL;
#line 266 "../src/WorkspaceManager.vala"
			_tmp5_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 266 "../src/WorkspaceManager.vala"
			workspace = _tmp5_;
#line 1291 "WorkspaceManager.c"
			{
				gint last_index = 0;
				MetaWorkspaceManager* _tmp6_;
				gboolean _tmp7_ = FALSE;
				MetaWorkspace* _tmp8_;
#line 267 "../src/WorkspaceManager.vala"
				_tmp6_ = manager;
#line 267 "../src/WorkspaceManager.vala"
				last_index = meta_workspace_manager_get_n_workspaces (_tmp6_) - 1;
#line 268 "../src/WorkspaceManager.vala"
				_tmp8_ = workspace;
#line 268 "../src/WorkspaceManager.vala"
				if (gala_utils_get_n_windows (_tmp8_, FALSE) == ((guint) 0)) {
#line 1305 "WorkspaceManager.c"
					MetaWorkspace* _tmp9_;
#line 269 "../src/WorkspaceManager.vala"
					_tmp9_ = workspace;
#line 269 "../src/WorkspaceManager.vala"
					_tmp7_ = meta_workspace_index (_tmp9_) != last_index;
#line 1311 "WorkspaceManager.c"
				} else {
#line 268 "../src/WorkspaceManager.vala"
					_tmp7_ = FALSE;
#line 1315 "WorkspaceManager.c"
				}
#line 268 "../src/WorkspaceManager.vala"
				if (_tmp7_) {
#line 1319 "WorkspaceManager.c"
					MetaWorkspace* _tmp10_;
#line 270 "../src/WorkspaceManager.vala"
					_tmp10_ = workspace;
#line 270 "../src/WorkspaceManager.vala"
					gala_workspace_manager_remove_workspace (self, _tmp10_);
#line 1325 "WorkspaceManager.c"
				}
#line 266 "../src/WorkspaceManager.vala"
				_g_object_unref0 (workspace);
#line 1329 "WorkspaceManager.c"
			}
		}
	}
}

GalaWindowManager*
gala_workspace_manager_get_wm (GalaWorkspaceManager* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 30 "../src/WorkspaceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 30 "../src/WorkspaceManager.vala"
	result = _tmp0_;
#line 30 "../src/WorkspaceManager.vala"
	return result;
#line 1348 "WorkspaceManager.c"
}

static void
gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                               GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 30 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/WorkspaceManager.vala"
	old_value = gala_workspace_manager_get_wm (self);
#line 30 "../src/WorkspaceManager.vala"
	if (old_value != value) {
#line 1362 "WorkspaceManager.c"
		GalaWindowManager* _tmp0_;
#line 30 "../src/WorkspaceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/WorkspaceManager.vala"
		_g_object_unref0 (self->priv->_wm);
#line 30 "../src/WorkspaceManager.vala"
		self->priv->_wm = _tmp0_;
#line 30 "../src/WorkspaceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY]);
#line 1372 "WorkspaceManager.c"
	}
}

static GObject *
gala_workspace_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWorkspaceManager * self;
	GeeLinkedList* _tmp0_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp1_;
	MetaDisplay* _tmp2_;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspaceManager* _tmp10_;
	MetaWorkspaceManager* _tmp11_;
	MetaWorkspaceManager* _tmp12_;
	MetaDisplay* _tmp13_;
	MetaDisplay* _tmp14_;
	gboolean _tmp15_ = FALSE;
#line 39 "../src/WorkspaceManager.vala"
	parent_class = G_OBJECT_CLASS (gala_workspace_manager_parent_class);
#line 39 "../src/WorkspaceManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 40 "../src/WorkspaceManager.vala"
	_tmp0_ = gee_linked_list_new (meta_workspace_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 40 "../src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 40 "../src/WorkspaceManager.vala"
	self->priv->workspaces_marked_removed = _tmp0_;
#line 41 "../src/WorkspaceManager.vala"
	_tmp1_ = self->priv->_wm;
#line 41 "../src/WorkspaceManager.vala"
	_tmp2_ = meta_plugin_get_display ((MetaPlugin*) _tmp1_);
#line 41 "../src/WorkspaceManager.vala"
	display = _tmp2_;
#line 42 "../src/WorkspaceManager.vala"
	_tmp3_ = display;
#line 42 "../src/WorkspaceManager.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 42 "../src/WorkspaceManager.vala"
	manager = _tmp4_;
#line 45 "../src/WorkspaceManager.vala"
	gala_workspace_manager_cleanup (self);
#line 47 "../src/WorkspaceManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 1425 "WorkspaceManager.c"
		MetaWorkspaceManager* _tmp5_;
#line 48 "../src/WorkspaceManager.vala"
		_tmp5_ = manager;
#line 48 "../src/WorkspaceManager.vala"
		meta_workspace_manager_override_workspace_layout (_tmp5_, META_DISPLAY_TOPLEFT, FALSE, 1, -1);
#line 1431 "WorkspaceManager.c"
	}
	{
		gint i = 0;
#line 50 "../src/WorkspaceManager.vala"
		i = 0;
#line 1437 "WorkspaceManager.c"
		{
			gboolean _tmp6_ = FALSE;
#line 50 "../src/WorkspaceManager.vala"
			_tmp6_ = TRUE;
#line 50 "../src/WorkspaceManager.vala"
			while (TRUE) {
#line 1444 "WorkspaceManager.c"
				MetaWorkspaceManager* _tmp8_;
				MetaWorkspaceManager* _tmp9_;
#line 50 "../src/WorkspaceManager.vala"
				if (!_tmp6_) {
#line 1449 "WorkspaceManager.c"
					gint _tmp7_;
#line 50 "../src/WorkspaceManager.vala"
					_tmp7_ = i;
#line 50 "../src/WorkspaceManager.vala"
					i = _tmp7_ + 1;
#line 1455 "WorkspaceManager.c"
				}
#line 50 "../src/WorkspaceManager.vala"
				_tmp6_ = FALSE;
#line 50 "../src/WorkspaceManager.vala"
				_tmp8_ = manager;
#line 50 "../src/WorkspaceManager.vala"
				if (!(i < meta_workspace_manager_get_n_workspaces (_tmp8_))) {
#line 50 "../src/WorkspaceManager.vala"
					break;
#line 1465 "WorkspaceManager.c"
				}
#line 51 "../src/WorkspaceManager.vala"
				_tmp9_ = manager;
#line 51 "../src/WorkspaceManager.vala"
				gala_workspace_manager_workspace_added (self, _tmp9_, i);
#line 1471 "WorkspaceManager.c"
			}
		}
	}
#line 53 "../src/WorkspaceManager.vala"
	meta_prefs_add_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 55 "../src/WorkspaceManager.vala"
	_tmp10_ = manager;
#line 55 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp10_, "workspace-switched", (GCallback) _gala_workspace_manager_workspace_switched_meta_workspace_manager_workspace_switched, self, G_CONNECT_AFTER);
#line 56 "../src/WorkspaceManager.vala"
	_tmp11_ = manager;
#line 56 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp11_, "workspace-added", (GCallback) _gala_workspace_manager_workspace_added_meta_workspace_manager_workspace_added, self, 0);
#line 57 "../src/WorkspaceManager.vala"
	_tmp12_ = manager;
#line 57 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp12_, "workspace-removed", (GCallback) _gala_workspace_manager_workspace_removed_meta_workspace_manager_workspace_removed, self, G_CONNECT_AFTER);
#line 58 "../src/WorkspaceManager.vala"
	_tmp13_ = display;
#line 58 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp13_, "window-entered-monitor", (GCallback) _gala_workspace_manager_window_entered_monitor_meta_display_window_entered_monitor, self, 0);
#line 59 "../src/WorkspaceManager.vala"
	_tmp14_ = display;
#line 59 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp14_, "window-left-monitor", (GCallback) _gala_workspace_manager_window_left_monitor_meta_display_window_left_monitor, self, 0);
#line 62 "../src/WorkspaceManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 1499 "WorkspaceManager.c"
		MetaWorkspaceManager* _tmp16_;
		MetaWorkspaceManager* _tmp17_;
		MetaWorkspace* _tmp18_;
#line 63 "../src/WorkspaceManager.vala"
		_tmp16_ = manager;
#line 63 "../src/WorkspaceManager.vala"
		_tmp17_ = manager;
#line 63 "../src/WorkspaceManager.vala"
		_tmp18_ = meta_workspace_manager_get_workspace_by_index (_tmp16_, meta_workspace_manager_get_n_workspaces (_tmp17_) - 1);
#line 63 "../src/WorkspaceManager.vala"
		_tmp15_ = gala_utils_get_n_windows (_tmp18_, FALSE) > ((guint) 0);
#line 1511 "WorkspaceManager.c"
	} else {
#line 62 "../src/WorkspaceManager.vala"
		_tmp15_ = FALSE;
#line 1515 "WorkspaceManager.c"
	}
#line 62 "../src/WorkspaceManager.vala"
	if (_tmp15_) {
#line 64 "../src/WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 1521 "WorkspaceManager.c"
	}
#line 39 "../src/WorkspaceManager.vala"
	return obj;
#line 1525 "WorkspaceManager.c"
}

static void
gala_workspace_manager_class_init (GalaWorkspaceManagerClass * klass,
                                   gpointer klass_data)
{
#line 19 "../src/WorkspaceManager.vala"
	gala_workspace_manager_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/WorkspaceManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaWorkspaceManager_private_offset);
#line 19 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_workspace_manager_get_property;
#line 19 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_workspace_manager_set_property;
#line 19 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_workspace_manager_constructor;
#line 19 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_workspace_manager_finalize;
#line 19 "../src/WorkspaceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WORKSPACE_MANAGER_WM_PROPERTY, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1546 "WorkspaceManager.c"
}

static void
gala_workspace_manager_instance_init (GalaWorkspaceManager * self,
                                      gpointer klass)
{
#line 19 "../src/WorkspaceManager.vala"
	self->priv = gala_workspace_manager_get_instance_private (self);
#line 33 "../src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = 0;
#line 1557 "WorkspaceManager.c"
}

static void
gala_workspace_manager_finalize (GObject * obj)
{
	GalaWorkspaceManager * self;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	guint _tmp5_;
	MetaWorkspaceManager* _tmp6_;
	guint _tmp7_;
	MetaWorkspaceManager* _tmp8_;
	guint _tmp9_;
	MetaDisplay* _tmp10_;
	guint _tmp11_;
	MetaDisplay* _tmp12_;
	guint _tmp13_;
#line 19 "../src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 68 "../src/WorkspaceManager.vala"
	meta_prefs_remove_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 70 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 70 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 70 "../src/WorkspaceManager.vala"
	display = _tmp1_;
#line 71 "../src/WorkspaceManager.vala"
	_tmp2_ = display;
#line 71 "../src/WorkspaceManager.vala"
	_tmp3_ = meta_display_get_workspace_manager (_tmp2_);
#line 71 "../src/WorkspaceManager.vala"
	manager = _tmp3_;
#line 72 "../src/WorkspaceManager.vala"
	_tmp4_ = manager;
#line 72 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-added", meta_workspace_manager_get_type (), &_tmp5_, NULL, FALSE);
#line 72 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_added_meta_workspace_manager_workspace_added, self);
#line 73 "../src/WorkspaceManager.vala"
	_tmp6_ = manager;
#line 73 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-switched", meta_workspace_manager_get_type (), &_tmp7_, NULL, FALSE);
#line 73 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_switched_meta_workspace_manager_workspace_switched, self);
#line 74 "../src/WorkspaceManager.vala"
	_tmp8_ = manager;
#line 74 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-removed", meta_workspace_manager_get_type (), &_tmp9_, NULL, FALSE);
#line 74 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_removed_meta_workspace_manager_workspace_removed, self);
#line 75 "../src/WorkspaceManager.vala"
	_tmp10_ = display;
#line 75 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("window-entered-monitor", meta_display_get_type (), &_tmp11_, NULL, FALSE);
#line 75 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _gala_workspace_manager_window_entered_monitor_meta_display_window_entered_monitor, self);
#line 76 "../src/WorkspaceManager.vala"
	_tmp12_ = display;
#line 76 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("window-left-monitor", meta_display_get_type (), &_tmp13_, NULL, FALSE);
#line 76 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _gala_workspace_manager_window_left_monitor_meta_display_window_left_monitor, self);
#line 30 "../src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->_wm);
#line 32 "../src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 19 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (gala_workspace_manager_parent_class)->finalize (obj);
#line 1632 "WorkspaceManager.c"
}

static GType
gala_workspace_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWorkspaceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_workspace_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWorkspaceManager), 0, (GInstanceInitFunc) gala_workspace_manager_instance_init, NULL };
	GType gala_workspace_manager_type_id;
	gala_workspace_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWorkspaceManager", &g_define_type_info, 0);
	GalaWorkspaceManager_private_offset = g_type_add_instance_private (gala_workspace_manager_type_id, sizeof (GalaWorkspaceManagerPrivate));
	return gala_workspace_manager_type_id;
}

GType
gala_workspace_manager_get_type (void)
{
	static volatile gsize gala_workspace_manager_type_id__once = 0;
	if (g_once_init_enter (&gala_workspace_manager_type_id__once)) {
		GType gala_workspace_manager_type_id;
		gala_workspace_manager_type_id = gala_workspace_manager_get_type_once ();
		g_once_init_leave (&gala_workspace_manager_type_id__once, gala_workspace_manager_type_id);
	}
	return gala_workspace_manager_type_id__once;
}

static void
_vala_gala_workspace_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 19 "../src/WorkspaceManager.vala"
	switch (property_id) {
#line 19 "../src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 19 "../src/WorkspaceManager.vala"
		g_value_set_object (value, gala_workspace_manager_get_wm (self));
#line 19 "../src/WorkspaceManager.vala"
		break;
#line 1673 "WorkspaceManager.c"
		default:
#line 19 "../src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/WorkspaceManager.vala"
		break;
#line 1679 "WorkspaceManager.c"
	}
}

static void
_vala_gala_workspace_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 19 "../src/WorkspaceManager.vala"
	switch (property_id) {
#line 19 "../src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 19 "../src/WorkspaceManager.vala"
		gala_workspace_manager_set_wm (self, g_value_get_object (value));
#line 19 "../src/WorkspaceManager.vala"
		break;
#line 1699 "WorkspaceManager.c"
		default:
#line 19 "../src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/WorkspaceManager.vala"
		break;
#line 1705 "WorkspaceManager.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 1720 "WorkspaceManager.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 1724 "WorkspaceManager.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 1728 "WorkspaceManager.c"
}

