/* WindowManager.c generated by valac 0.56.17, the Vala compiler
 * generated from WindowManager.vala, do not modify */

/**/
/*  Copyright (C) 2012-2014 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "gala.h"
#include <meta/meta-plugin.h>
#include <clutter/clutter.h>
#include <meta/meta-background-group.h>
#include <meta/window.h>
#include <gee.h>
#include <meta/meta-window-actor.h>
#include <meta/compositor.h>
#include <mtk/mtk.h>
#include <meta/common.h>
#include <meta/keybindings.h>
#include <meta/meta-close-dialog.h>
#include <meta/display.h>
#include <meta/meta-background.h>
#include <meta/compositor-mutter.h>
#include <meta/types.h>
#include <meta/util.h>
#include <meta/meta-background-actor.h>
#include <float.h>
#include <math.h>
#include "config.h"
#include <meta/prefs.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>
#include <gtk/gtk.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#define GALA_DAEMON_DBUS_NAME "org.pantheon.gala.daemon"
#define GALA_DAEMON_DBUS_OBJECT_PATH "/org/pantheon/gala/daemon"
#define GALA_WINDOW_MANAGER_GALA_NUDGE_GAP 32
#define GALA_WINDOW_MANAGER_GALA_WORKSPACE_GAP 24
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_DAEMON (gala_daemon_get_type ())
#define GALA_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DAEMON, GalaDaemon))
#define GALA_IS_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DAEMON))
#define GALA_DAEMON_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_DAEMON, GalaDaemonIface))

typedef struct _GalaDaemon GalaDaemon;
typedef struct _GalaDaemonIface GalaDaemonIface;

#define GALA_TYPE_DAEMON_PROXY (gala_daemon_proxy_get_type ())
typedef GDBusProxy GalaDaemonProxy;
typedef GDBusProxyClass GalaDaemonProxyClass;
typedef struct _GalaDaemonShowWindowMenuReadyData GalaDaemonShowWindowMenuReadyData;
typedef struct _GalaDaemonShowDesktopMenuReadyData GalaDaemonShowDesktopMenuReadyData;

#define GALA_TYPE_WINDOW_MANAGER_GALA (gala_window_manager_gala_get_type ())
#define GALA_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala))
#define GALA_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))
#define GALA_IS_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_IS_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_WINDOW_MANAGER_GALA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))

typedef struct _GalaWindowManagerGala GalaWindowManagerGala;
typedef struct _GalaWindowManagerGalaClass GalaWindowManagerGalaClass;
typedef struct _GalaWindowManagerGalaPrivate GalaWindowManagerGalaPrivate;

#define GALA_TYPE_SCREEN_SHIELD (gala_screen_shield_get_type ())
#define GALA_SCREEN_SHIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SCREEN_SHIELD, GalaScreenShield))
#define GALA_SCREEN_SHIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SCREEN_SHIELD, GalaScreenShieldClass))
#define GALA_IS_SCREEN_SHIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SCREEN_SHIELD))
#define GALA_IS_SCREEN_SHIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SCREEN_SHIELD))
#define GALA_SCREEN_SHIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SCREEN_SHIELD, GalaScreenShieldClass))

typedef struct _GalaScreenShield GalaScreenShield;
typedef struct _GalaScreenShieldClass GalaScreenShieldClass;

#define GALA_TYPE_POINTER_LOCATOR (gala_pointer_locator_get_type ())
#define GALA_POINTER_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator))
#define GALA_POINTER_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocatorClass))
#define GALA_IS_POINTER_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_POINTER_LOCATOR))
#define GALA_IS_POINTER_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_POINTER_LOCATOR))
#define GALA_POINTER_LOCATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocatorClass))

typedef struct _GalaPointerLocator GalaPointerLocator;
typedef struct _GalaPointerLocatorClass GalaPointerLocatorClass;

#define GALA_TYPE_SYSTEM_BACKGROUND (gala_system_background_get_type ())
#define GALA_SYSTEM_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackground))
#define GALA_SYSTEM_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackgroundClass))
#define GALA_IS_SYSTEM_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SYSTEM_BACKGROUND))
#define GALA_IS_SYSTEM_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SYSTEM_BACKGROUND))
#define GALA_SYSTEM_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackgroundClass))

typedef struct _GalaSystemBackground GalaSystemBackground;
typedef struct _GalaSystemBackgroundClass GalaSystemBackgroundClass;

#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;

#define GALA_TYPE_SCREEN_SAVER_MANAGER (gala_screen_saver_manager_get_type ())
#define GALA_SCREEN_SAVER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SCREEN_SAVER_MANAGER, GalaScreenSaverManager))
#define GALA_SCREEN_SAVER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SCREEN_SAVER_MANAGER, GalaScreenSaverManagerClass))
#define GALA_IS_SCREEN_SAVER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SCREEN_SAVER_MANAGER))
#define GALA_IS_SCREEN_SAVER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SCREEN_SAVER_MANAGER))
#define GALA_SCREEN_SAVER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SCREEN_SAVER_MANAGER, GalaScreenSaverManagerClass))

typedef struct _GalaScreenSaverManager GalaScreenSaverManager;
typedef struct _GalaScreenSaverManagerClass GalaScreenSaverManagerClass;

#define GALA_TYPE_HOT_CORNER_MANAGER (gala_hot_corner_manager_get_type ())
#define GALA_HOT_CORNER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_HOT_CORNER_MANAGER, GalaHotCornerManager))
#define GALA_HOT_CORNER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_HOT_CORNER_MANAGER, GalaHotCornerManagerClass))
#define GALA_IS_HOT_CORNER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_HOT_CORNER_MANAGER))
#define GALA_IS_HOT_CORNER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_HOT_CORNER_MANAGER))
#define GALA_HOT_CORNER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_HOT_CORNER_MANAGER, GalaHotCornerManagerClass))

typedef struct _GalaHotCornerManager GalaHotCornerManager;
typedef struct _GalaHotCornerManagerClass GalaHotCornerManagerClass;

#define GALA_TYPE_WINDOW_TRACKER (gala_window_tracker_get_type ())
#define GALA_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker))
#define GALA_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))
#define GALA_IS_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_TRACKER))
#define GALA_IS_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_TRACKER))
#define GALA_WINDOW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))

typedef struct _GalaWindowTracker GalaWindowTracker;
typedef struct _GalaWindowTrackerClass GalaWindowTrackerClass;

#define GALA_TYPE_ZOOM (gala_zoom_get_type ())
#define GALA_ZOOM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ZOOM, GalaZoom))
#define GALA_ZOOM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_ZOOM, GalaZoomClass))
#define GALA_IS_ZOOM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ZOOM))
#define GALA_IS_ZOOM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_ZOOM))
#define GALA_ZOOM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_ZOOM, GalaZoomClass))

typedef struct _GalaZoom GalaZoom;
typedef struct _GalaZoomClass GalaZoomClass;

#define GALA_TYPE_ACCENT_COLOR_MANAGER (gala_accent_color_manager_get_type ())
#define GALA_ACCENT_COLOR_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ACCENT_COLOR_MANAGER, GalaAccentColorManager))
#define GALA_ACCENT_COLOR_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_ACCENT_COLOR_MANAGER, GalaAccentColorManagerClass))
#define GALA_IS_ACCENT_COLOR_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ACCENT_COLOR_MANAGER))
#define GALA_IS_ACCENT_COLOR_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_ACCENT_COLOR_MANAGER))
#define GALA_ACCENT_COLOR_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_ACCENT_COLOR_MANAGER, GalaAccentColorManagerClass))

typedef struct _GalaAccentColorManager GalaAccentColorManager;
typedef struct _GalaAccentColorManagerClass GalaAccentColorManagerClass;

#define GALA_TYPE_NOTIFICATION_STACK (gala_notification_stack_get_type ())
#define GALA_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack))
#define GALA_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))
#define GALA_IS_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_IS_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_NOTIFICATION_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))

typedef struct _GalaNotificationStack GalaNotificationStack;
typedef struct _GalaNotificationStackClass GalaNotificationStackClass;

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;
enum  {
	GALA_WINDOW_MANAGER_GALA_0_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_NOTIFICATION_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_WORKSPACE_VIEW_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_ENABLE_ANIMATIONS_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_SCREEN_SHIELD_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_NUM_PROPERTIES
};
static GParamSpec* gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block9Data Block9Data;

#define GALA_TYPE_DBUS_ACCELERATOR (gala_dbus_accelerator_get_type ())
#define GALA_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAccelerator))
#define GALA_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorClass))
#define GALA_IS_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DBUS_ACCELERATOR))
#define GALA_IS_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DBUS_ACCELERATOR))
#define GALA_DBUS_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorClass))

typedef struct _GalaDBusAccelerator GalaDBusAccelerator;
typedef struct _GalaDBusAcceleratorClass GalaDBusAcceleratorClass;
#define __vala_ClutterColor_free0(var) ((var == NULL) ? NULL : (var = (_vala_ClutterColor_free (var), NULL)))

#define GALA_TYPE_BACKGROUND_CONTAINER (gala_background_container_get_type ())
#define GALA_BACKGROUND_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BACKGROUND_CONTAINER, GalaBackgroundContainer))
#define GALA_BACKGROUND_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BACKGROUND_CONTAINER, GalaBackgroundContainerClass))
#define GALA_IS_BACKGROUND_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BACKGROUND_CONTAINER))
#define GALA_IS_BACKGROUND_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BACKGROUND_CONTAINER))
#define GALA_BACKGROUND_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BACKGROUND_CONTAINER, GalaBackgroundContainerClass))

typedef struct _GalaBackgroundContainer GalaBackgroundContainer;
typedef struct _GalaBackgroundContainerClass GalaBackgroundContainerClass;

#define GALA_TYPE_PLUGIN_MANAGER (gala_plugin_manager_get_type ())
#define GALA_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager))
#define GALA_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))
#define GALA_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))

typedef struct _GalaPluginManager GalaPluginManager;
typedef struct _GalaPluginManagerClass GalaPluginManagerClass;

#define GALA_TYPE_MULTITASKING_VIEW (gala_multitasking_view_get_type ())
#define GALA_MULTITASKING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_MULTITASKING_VIEW, GalaMultitaskingView))
#define GALA_MULTITASKING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_MULTITASKING_VIEW, GalaMultitaskingViewClass))
#define GALA_IS_MULTITASKING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_MULTITASKING_VIEW))
#define GALA_IS_MULTITASKING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_MULTITASKING_VIEW))
#define GALA_MULTITASKING_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_MULTITASKING_VIEW, GalaMultitaskingViewClass))

typedef struct _GalaMultitaskingView GalaMultitaskingView;
typedef struct _GalaMultitaskingViewClass GalaMultitaskingViewClass;

#define GALA_TYPE_WINDOW_OVERVIEW (gala_window_overview_get_type ())
#define GALA_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview))
#define GALA_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))
#define GALA_IS_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_IS_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_WINDOW_OVERVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))

typedef struct _GalaWindowOverview GalaWindowOverview;
typedef struct _GalaWindowOverviewClass GalaWindowOverviewClass;

#define GALA_TYPE_DWELL_CLICK_TIMER (gala_dwell_click_timer_get_type ())
#define GALA_DWELL_CLICK_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer))
#define GALA_DWELL_CLICK_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimerClass))
#define GALA_IS_DWELL_CLICK_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DWELL_CLICK_TIMER))
#define GALA_IS_DWELL_CLICK_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DWELL_CLICK_TIMER))
#define GALA_DWELL_CLICK_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimerClass))

typedef struct _GalaDwellClickTimer GalaDwellClickTimer;
typedef struct _GalaDwellClickTimerClass GalaDwellClickTimerClass;

#define GALA_TYPE_GESTURE (gala_gesture_get_type ())
#define GALA_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE, GalaGesture))
#define GALA_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE, GalaGestureClass))
#define GALA_IS_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE))
#define GALA_IS_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE))
#define GALA_GESTURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE, GalaGestureClass))

typedef struct _GalaGesture GalaGesture;
typedef struct _GalaGestureClass GalaGestureClass;
typedef struct _GalaGesturePrivate GalaGesturePrivate;
typedef enum  {
	GALA_GESTURE_DIRECTION_UNKNOWN = 0,
	GALA_GESTURE_DIRECTION_UP = 1,
	GALA_GESTURE_DIRECTION_DOWN = 2,
	GALA_GESTURE_DIRECTION_LEFT = 3,
	GALA_GESTURE_DIRECTION_RIGHT = 4,
	GALA_GESTURE_DIRECTION_IN = 5,
	GALA_GESTURE_DIRECTION_OUT = 6
} GalaGestureDirection;

#define GALA_TYPE_GESTURE_DIRECTION (gala_gesture_direction_get_type ())

#define GALA_TYPE_GESTURE_SETTINGS (gala_gesture_settings_get_type ())
#define GALA_GESTURE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettings))
#define GALA_GESTURE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettingsClass))
#define GALA_IS_GESTURE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_SETTINGS))
#define GALA_IS_GESTURE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_SETTINGS))
#define GALA_GESTURE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettingsClass))

typedef struct _GalaGestureSettings GalaGestureSettings;
typedef struct _GalaGestureSettingsClass GalaGestureSettingsClass;
typedef struct _Block10Data Block10Data;
typedef void (*GalaGestureTrackerOnUpdate) (gdouble percentage, gpointer user_data);
typedef void (*GalaGestureTrackerOnEnd) (gdouble percentage, gboolean cancel_action, gint calculated_duration, gpointer user_data);
typedef void (*GalaGestureTrackerOnBegin) (gdouble percentage, gpointer user_data);
typedef enum  {
	GALA_INPUT_AREA_NONE,
	GALA_INPUT_AREA_FULLSCREEN,
	GALA_INPUT_AREA_DEFAULT
} GalaInputArea;

#define GALA_TYPE_INPUT_AREA (gala_input_area_get_type ())
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
#define _clutter_grab_unref0(var) ((var == NULL) ? NULL : (var = (clutter_grab_unref (var), NULL)))
typedef struct _Block13Data Block13Data;
typedef struct _Block14Data Block14Data;
typedef struct _Block15Data Block15Data;
typedef struct _Block16Data Block16Data;
typedef struct _Block17Data Block17Data;
typedef struct _Block18Data Block18Data;
typedef struct _Block19Data Block19Data;
typedef struct _Block20Data Block20Data;
typedef struct _Block21Data Block21Data;
typedef struct _Block22Data Block22Data;
typedef struct _Block23Data Block23Data;
typedef struct _Block24Data Block24Data;
typedef struct _Block25Data Block25Data;
typedef struct _Block26Data Block26Data;
typedef struct _Block27Data Block27Data;
typedef struct _Block28Data Block28Data;
typedef struct _Block29Data Block29Data;
typedef struct _Block30Data Block30Data;

#define GALA_WINDOW_LISTENER_TYPE_WINDOW_GEOMETRY (gala_window_listener_window_geometry_get_type ())
typedef struct _GalaWindowListenerWindowGeometry GalaWindowListenerWindowGeometry;

#define GALA_TYPE_WINDOW_LISTENER (gala_window_listener_get_type ())
#define GALA_WINDOW_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_LISTENER, GalaWindowListener))
#define GALA_WINDOW_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerClass))
#define GALA_IS_WINDOW_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_LISTENER))
#define GALA_IS_WINDOW_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_LISTENER))
#define GALA_WINDOW_LISTENER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerClass))

typedef struct _GalaWindowListener GalaWindowListener;
typedef struct _GalaWindowListenerClass GalaWindowListenerClass;
#define _gala_window_listener_window_geometry_free0(var) ((var == NULL) ? NULL : (var = (gala_window_listener_window_geometry_free (var), NULL)))
typedef struct _Block31Data Block31Data;

#define GALA_TYPE_SAFE_WINDOW_CLONE (gala_safe_window_clone_get_type ())
#define GALA_SAFE_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone))
#define GALA_SAFE_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowCloneClass))
#define GALA_IS_SAFE_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SAFE_WINDOW_CLONE))
#define GALA_IS_SAFE_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SAFE_WINDOW_CLONE))
#define GALA_SAFE_WINDOW_CLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowCloneClass))

typedef struct _GalaSafeWindowClone GalaSafeWindowClone;
typedef struct _GalaSafeWindowCloneClass GalaSafeWindowCloneClass;
typedef struct _Block32Data Block32Data;

#define GALA_TYPE_ACCESS_DIALOG (gala_access_dialog_get_type ())
#define GALA_ACCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ACCESS_DIALOG, GalaAccessDialog))
#define GALA_ACCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_ACCESS_DIALOG, GalaAccessDialogClass))
#define GALA_IS_ACCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ACCESS_DIALOG))
#define GALA_IS_ACCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_ACCESS_DIALOG))
#define GALA_ACCESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_ACCESS_DIALOG, GalaAccessDialogClass))

typedef struct _GalaAccessDialog GalaAccessDialog;
typedef struct _GalaAccessDialogClass GalaAccessDialogClass;
typedef struct _Block33Data Block33Data;
typedef struct _Block34Data Block34Data;

#define GALA_TYPE_CLOSE_DIALOG (gala_close_dialog_get_type ())
#define GALA_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_CLOSE_DIALOG, GalaCloseDialog))
#define GALA_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_CLOSE_DIALOG, GalaCloseDialogClass))
#define GALA_IS_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_CLOSE_DIALOG))
#define GALA_IS_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_CLOSE_DIALOG))
#define GALA_CLOSE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_CLOSE_DIALOG, GalaCloseDialogClass))

typedef struct _GalaCloseDialog GalaCloseDialog;
typedef struct _GalaCloseDialogClass GalaCloseDialogClass;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define GALA_TYPE_SCREENSHOT_MANAGER (gala_screenshot_manager_get_type ())
#define GALA_SCREENSHOT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SCREENSHOT_MANAGER, GalaScreenshotManager))
#define GALA_SCREENSHOT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SCREENSHOT_MANAGER, GalaScreenshotManagerClass))
#define GALA_IS_SCREENSHOT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SCREENSHOT_MANAGER))
#define GALA_IS_SCREENSHOT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SCREENSHOT_MANAGER))
#define GALA_SCREENSHOT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SCREENSHOT_MANAGER, GalaScreenshotManagerClass))

typedef struct _GalaScreenshotManager GalaScreenshotManager;
typedef struct _GalaScreenshotManagerClass GalaScreenshotManagerClass;
typedef struct _GalaWindowManagerGalaScreenshotCurrentWindowData GalaWindowManagerGalaScreenshotCurrentWindowData;
typedef struct _GalaWindowManagerGalaScreenshotAreaData GalaWindowManagerGalaScreenshotAreaData;
typedef struct _GalaWindowManagerGalaScreenshotScreenData GalaWindowManagerGalaScreenshotScreenData;
enum  {
	GALA_WINDOW_MANAGER_GALA_WINDOW_CREATED_SIGNAL,
	GALA_WINDOW_MANAGER_GALA_NUM_SIGNALS
};
static guint gala_window_manager_gala_signals[GALA_WINDOW_MANAGER_GALA_NUM_SIGNALS] = {0};

struct _GalaDaemonIface {
	GTypeInterface parent_iface;
	void (*show_window_menu) (GalaDaemon* self, GalaWindowFlags flags, gint x, gint y, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*show_window_menu_finish) (GalaDaemon* self, GAsyncResult* _res_, GError** error);
	void (*show_desktop_menu) (GalaDaemon* self, gint x, gint y, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*show_desktop_menu_finish) (GalaDaemon* self, GAsyncResult* _res_, GError** error);
};

struct _GalaDaemonShowWindowMenuReadyData {
	GDBusMethodInvocation* _invocation_;
	GalaWindowFlags flags;
	gint x;
	gint y;
};

struct _GalaDaemonShowDesktopMenuReadyData {
	GDBusMethodInvocation* _invocation_;
	gint x;
	gint y;
};

struct _GalaWindowManagerGala {
	MetaPlugin parent_instance;
	GalaWindowManagerGalaPrivate * priv;
};

struct _GalaWindowManagerGalaClass {
	MetaPluginClass parent_class;
};

struct _GalaWindowManagerGalaPrivate {
	ClutterActor* _ui_group;
	ClutterStage* _stage;
	ClutterActor* _window_group;
	ClutterActor* _top_window_group;
	ClutterActor* _notification_group;
	MetaBackgroundGroup* _background_group;
	GalaActivatableComponent* _workspace_view;
	gboolean _enable_animations;
	GalaScreenShield* _screen_shield;
	GalaPointerLocator* _pointer_locator;
	GalaSystemBackground* system_background;
	MetaPluginInfo info;
	GalaWindowSwitcher* winswitcher;
	GalaActivatableComponent* window_overview;
	GalaScreenSaverManager* _screensaver;
	GalaHotCornerManager* hot_corner_manager;
	GalaWindowTracker* _window_tracker;
	GalaZoom* zoom;
	GalaAccentColorManager* accent_color_manager;
	ClutterActor* tile_preview;
	MetaWindow* moving;
	GalaDaemon* daemon_proxy;
	GalaNotificationStack* notification_stack;
	GeeLinkedList* modal_stack;
	GeeHashSet* minimizing;
	GeeHashSet* maximizing;
	GeeHashSet* unmaximizing;
	GeeHashSet* mapping;
	GeeHashSet* destroying;
	GeeHashSet* unminimizing;
	GHashTable* ws_assoc;
	MetaSizeChange* which_change;
	MtkRectangle old_rect_size_change;
	ClutterActor* latest_window_snapshot;
	GSettings* animations_settings;
	GSettings* behavior_settings;
	GalaGestureTracker* gesture_tracker;
	gboolean animating_switch_workspace;
	gboolean switch_workspace_with_gesture;
	GHashTable* dim_table;
	GList* windows;
	GList* parents;
	GList* tmp_actors;
	gulong switch_workspace_window_created_id;
};

struct _Block9Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaDisplay* display;
	GSettings* keybinding_settings;
};

struct _GalaGesture {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaGesturePrivate * priv;
	ClutterEventType type;
	GalaGestureDirection direction;
	gint fingers;
	ClutterInputDeviceType performed_on_device_type;
};

struct _GalaGestureClass {
	GTypeClass parent_class;
	void (*finalize) (GalaGesture *self);
};

struct _Block10Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	gint nudge_gap;
	gfloat dest;
};

struct _Block11Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	guint fade_out_duration;
	gdouble* op_keyframes;
	gint op_keyframes_length1;
	gint _op_keyframes_size_;
	GValue* opacity;
	gint opacity_length1;
	gint _opacity_size_;
	MetaWindow* bottom_window;
};

struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	MetaWindowActor* actor;
};

struct _Block13Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindowActor* actor;
};

struct _Block14Data {
	int _ref_count_;
	Block13Data * _data13_;
	gulong minimize_handler_id;
};

struct _Block15Data {
	int _ref_count_;
	Block13Data * _data13_;
	gulong minimize_handler_id;
};

struct _Block16Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindowActor* actor;
};

struct _Block17Data {
	int _ref_count_;
	Block16Data * _data16_;
	gulong maximize_old_handler_id;
	gulong handler_id;
};

struct _Block18Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindowActor* actor;
};

struct _Block19Data {
	int _ref_count_;
	Block18Data * _data18_;
	gulong unminimize_handler_id;
};

struct _Block20Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindow* window;
	MetaWindowActor* actor;
};

struct _Block21Data {
	int _ref_count_;
	Block20Data * _data20_;
	gulong map_handler_id;
};

struct _Block22Data {
	int _ref_count_;
	Block20Data * _data20_;
	gulong map_handler_id;
};

struct _Block23Data {
	int _ref_count_;
	Block20Data * _data20_;
	gulong map_handler_id;
};

struct _Block24Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindow* window;
	MetaWindowActor* actor;
};

struct _Block25Data {
	int _ref_count_;
	Block24Data * _data24_;
	gulong destroy_handler_id;
};

struct _Block26Data {
	int _ref_count_;
	Block24Data * _data24_;
	gulong destroy_handler_id;
};

struct _Block27Data {
	int _ref_count_;
	Block24Data * _data24_;
	gulong destroy_handler_id;
};

struct _Block28Data {
	int _ref_count_;
	Block24Data * _data24_;
	gulong destroy_handler_id;
};

struct _Block29Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindowActor* actor;
};

struct _Block30Data {
	int _ref_count_;
	Block29Data * _data29_;
	gulong unmaximize_old_handler_id;
	gulong handler_id;
};

struct _GalaWindowListenerWindowGeometry {
	MtkRectangle inner;
	MtkRectangle outer;
};

struct _Block31Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	ClutterActor* in_group;
	ClutterActor* out_group;
	ClutterActor* wallpaper;
	ClutterClone* wallpaper_clone;
	gfloat x2;
	ClutterAnimationMode animation_mode;
	MetaMotionDirection direction;
};

struct _Block32Data {
	int _ref_count_;
	Block31Data * _data31_;
	gboolean cancel_action;
};

struct _Block33Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	gint timeout;
	guint dialog_timeout_id;
	GalaAccessDialog* dialog;
};

struct _Block34Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindow* window;
};

struct _GalaWindowManagerGalaScreenshotCurrentWindowData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GalaWindowManagerGala* self;
	gboolean clipboard;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* filename;
	gchar* _tmp3_;
	gboolean success;
	gchar* filename_used;
	gchar* _tmp4_;
	GalaScreenshotManager* screenshot_manager;
	GalaScreenshotManager* _tmp5_;
	gboolean _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_;
};

struct _GalaWindowManagerGalaScreenshotAreaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GalaWindowManagerGala* self;
	gboolean clipboard;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* filename;
	gchar* _tmp3_;
	gboolean success;
	gchar* filename_used;
	gchar* _tmp4_;
	GalaScreenshotManager* screenshot_manager;
	GalaScreenshotManager* _tmp5_;
	gint x;
	gint y;
	gint w;
	gint h;
	GalaScreenshotManager* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GalaScreenshotManager* _tmp11_;
	const gchar* _tmp12_;
	gboolean _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_;
};

struct _GalaWindowManagerGalaScreenshotScreenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GalaWindowManagerGala* self;
	gboolean clipboard;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* filename;
	gchar* _tmp3_;
	gboolean success;
	gchar* filename_used;
	gchar* _tmp4_;
	GalaScreenshotManager* screenshot_manager;
	GalaScreenshotManager* _tmp5_;
	gboolean _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_;
};

static gint GalaWindowManagerGala_private_offset;
static gpointer gala_window_manager_gala_parent_class = NULL;
VALA_EXTERN GeeSet* gala_close_dialog_open_dialogs;
static GalaWindowManagerIface * gala_window_manager_gala_gala_window_manager_parent_iface = NULL;

VALA_EXTERN GType gala_daemon_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint gala_daemon_register_object (void* object,
                                   GDBusConnection* connection,
                                   const gchar* path,
                                   GError** error);
VALA_EXTERN GType gala_daemon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDaemon, g_object_unref)
VALA_EXTERN void gala_daemon_show_window_menu (GalaDaemon* self,
                                   GalaWindowFlags flags,
                                   gint x,
                                   gint y,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void gala_daemon_show_window_menu_finish (GalaDaemon* self,
                                          GAsyncResult* _res_,
                                          GError** error);
VALA_EXTERN void gala_daemon_show_desktop_menu (GalaDaemon* self,
                                    gint x,
                                    gint y,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
VALA_EXTERN void gala_daemon_show_desktop_menu_finish (GalaDaemon* self,
                                           GAsyncResult* _res_,
                                           GError** error);
static GType gala_daemon_get_type_once (void);
static void gala_daemon_proxy_g_signal (GDBusProxy* proxy,
                                 const gchar* sender_name,
                                 const gchar* signal_name,
                                 GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object,
                                   GAsyncResult *res,
                                   void *user_data);
static void gala_daemon_proxy_show_window_menu_async (GalaDaemon* self,
                                               GalaWindowFlags flags,
                                               gint x,
                                               gint y,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void gala_daemon_proxy_show_window_menu_finish (GalaDaemon* self,
                                                GAsyncResult* _res_,
                                                GError** error);
static void gala_daemon_proxy_show_desktop_menu_async (GalaDaemon* self,
                                                gint x,
                                                gint y,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void gala_daemon_proxy_show_desktop_menu_finish (GalaDaemon* self,
                                                 GAsyncResult* _res_,
                                                 GError** error);
static void gala_daemon_proxy_gala_daemon_interface_init (GalaDaemonIface* iface);
static void _dbus_gala_daemon_show_window_menu (GalaDaemon* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation);
static void _dbus_gala_daemon_show_window_menu_ready (GObject * source_object,
                                               GAsyncResult * _res_,
                                               gpointer _user_data_);
static void _dbus_gala_daemon_show_desktop_menu (GalaDaemon* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation);
static void _dbus_gala_daemon_show_desktop_menu_ready (GObject * source_object,
                                                GAsyncResult * _res_,
                                                gpointer _user_data_);
static void gala_daemon_dbus_interface_method_call (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* method_name,
                                             GVariant* parameters,
                                             GDBusMethodInvocation* invocation,
                                             gpointer user_data);
static GVariant* gala_daemon_dbus_interface_get_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GError** error,
                                                   gpointer user_data);
static gboolean gala_daemon_dbus_interface_set_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GVariant* value,
                                                  GError** error,
                                                  gpointer user_data);
static void _gala_daemon_unregister_object (gpointer user_data);
VALA_EXTERN GType gala_window_manager_gala_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowManagerGala, g_object_unref)
VALA_EXTERN GType gala_screen_shield_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaScreenShield, g_object_unref)
VALA_EXTERN GType gala_pointer_locator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPointerLocator, g_object_unref)
VALA_EXTERN GType gala_system_background_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSystemBackground, g_object_unref)
VALA_EXTERN GType gala_window_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcher, g_object_unref)
VALA_EXTERN GType gala_screen_saver_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaScreenSaverManager, g_object_unref)
VALA_EXTERN guint gala_screen_saver_manager_register_object (void* object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error);
VALA_EXTERN GType gala_hot_corner_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaHotCornerManager, g_object_unref)
VALA_EXTERN GType gala_window_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowTracker, g_object_unref)
VALA_EXTERN GType gala_zoom_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaZoom, g_object_unref)
VALA_EXTERN GType gala_accent_color_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaAccentColorManager, g_object_unref)
VALA_EXTERN GType gala_notification_stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaNotificationStack, g_object_unref)
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void gala_window_manager_gala_real_start (MetaPlugin* base);
static gboolean gala_window_manager_gala_show_stage (GalaWindowManagerGala* self);
static void gala_window_manager_gala_daemon_appeared (GalaWindowManagerGala* self);
static void _gala_window_manager_gala_daemon_appeared_gbus_name_appeared_callback (GDBusConnection* connection,
                                                                            const gchar* name,
                                                                            const gchar* name_owner,
                                                                            gpointer self);
static void gala_window_manager_gala_lost_daemon (GalaWindowManagerGala* self);
static void _gala_window_manager_gala_lost_daemon_gbus_name_vanished_callback (GDBusConnection* connection,
                                                                        const gchar* name,
                                                                        gpointer self);
VALA_EXTERN void gala_access_dialog_watch_portal (void);
static void __lambda141_ (GalaWindowManagerGala* self);
VALA_EXTERN void gala_system_background_refresh (void);
static void ___lambda141__meta_display_gl_video_memory_purged (MetaDisplay* _sender,
                                                        gpointer self);
static void ___lambda136_ (GalaWindowManagerGala* self,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda136__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
VALA_EXTERN GalaScreenShield* gala_screen_shield_new (GalaWindowManager* wm);
VALA_EXTERN GalaScreenShield* gala_screen_shield_construct (GType object_type,
                                                GalaWindowManager* wm);
static void gala_window_manager_gala_set_screen_shield (GalaWindowManagerGala* self,
                                                 GalaScreenShield* value);
VALA_EXTERN GalaScreenShield* gala_window_manager_gala_get_screen_shield (GalaWindowManagerGala* self);
VALA_EXTERN GalaScreenSaverManager* gala_screen_saver_manager_new (GalaScreenShield* shield);
VALA_EXTERN GalaScreenSaverManager* gala_screen_saver_manager_construct (GType object_type,
                                                             GalaScreenShield* shield);
static void gala_window_manager_gala_set_screensaver (GalaWindowManagerGala* self,
                                               GalaScreenSaverManager* value);
VALA_EXTERN void gala_dbus_init (GalaWindowManager* _wm);
VALA_EXTERN gpointer gala_dbus_accelerator_ref (gpointer instance);
VALA_EXTERN void gala_dbus_accelerator_unref (gpointer instance);
VALA_EXTERN GParamSpec* gala_param_spec_dbus_accelerator (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void gala_value_set_dbus_accelerator (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void gala_value_take_dbus_accelerator (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer gala_value_get_dbus_accelerator (const GValue* value);
VALA_EXTERN GType gala_dbus_accelerator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDBusAccelerator, gala_dbus_accelerator_unref)
VALA_EXTERN guint gala_dbus_accelerator_register_object (void* object,
                                             GDBusConnection* connection,
                                             const gchar* path,
                                             GError** error);
VALA_EXTERN GalaDBusAccelerator* gala_dbus_accelerator_init (GalaWindowManager* wm);
VALA_EXTERN void gala_media_feedback_init (void);
VALA_EXTERN void gala_window_listener_init (MetaDisplay* display);
VALA_EXTERN void gala_keyboard_manager_init (MetaDisplay* display);
VALA_EXTERN GalaWindowTracker* gala_window_tracker_new (void);
VALA_EXTERN GalaWindowTracker* gala_window_tracker_construct (GType object_type);
static void gala_window_manager_gala_set_window_tracker (GalaWindowManagerGala* self,
                                                  GalaWindowTracker* value);
VALA_EXTERN GalaWindowTracker* gala_window_manager_gala_get_window_tracker (GalaWindowManagerGala* self);
VALA_EXTERN void gala_window_tracker_init (GalaWindowTracker* self,
                               MetaDisplay* display);
VALA_EXTERN GalaNotificationStack* gala_notification_stack_new (MetaDisplay* display);
VALA_EXTERN GalaNotificationStack* gala_notification_stack_construct (GType object_type,
                                                          MetaDisplay* display);
VALA_EXTERN GalaScreenSaverManager* gala_window_manager_gala_get_screensaver (GalaWindowManagerGala* self);
static void gala_window_manager_gala_update_input_area (GalaWindowManagerGala* self);
static void _gala_window_manager_gala_update_input_area_gala_screen_saver_manager_active_changed (GalaScreenSaverManager* _sender,
                                                                                           gboolean new_value,
                                                                                           gpointer self);
static void _vala_ClutterColor_free (ClutterColor* self);
static gboolean __lambda103_ (GalaWindowManagerGala* self);
VALA_EXTERN void gala_workspace_manager_init (GalaWindowManager* wm);
static gboolean ___lambda103__gsource_func (gpointer self);
VALA_EXTERN GalaSystemBackground* gala_system_background_new (MetaDisplay* display);
VALA_EXTERN GalaSystemBackground* gala_system_background_construct (GType object_type,
                                                        MetaDisplay* display);
VALA_EXTERN MetaBackgroundActor* gala_system_background_get_background_actor (GalaSystemBackground* self);
VALA_EXTERN GalaBackgroundContainer* gala_background_container_new (GalaWindowManager* wm);
VALA_EXTERN GalaBackgroundContainer* gala_background_container_construct (GType object_type,
                                                              GalaWindowManager* wm);
VALA_EXTERN GType gala_background_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaBackgroundContainer, g_object_unref)
static void gala_window_manager_gala_on_show_background_menu (GalaWindowManagerGala* self,
                                                       gint x,
                                                       gint y);
static void _gala_window_manager_gala_on_show_background_menu_gala_background_container_show_background_menu (GalaBackgroundContainer* _sender,
                                                                                                       gint x,
                                                                                                       gint y,
                                                                                                       gpointer self);
VALA_EXTERN void gala_filter_manager_init (GalaWindowManager* wm);
static void gala_window_manager_gala_handle_switch_to_workspace_end (MetaDisplay* display,
                                                              MetaWindow* window,
                                                              ClutterKeyEvent* event,
                                                              MetaKeyBinding* binding,
                                                              GalaWindowManagerGala* self);
static void gala_window_manager_gala_handle_move_to_workspace_end (MetaDisplay* display,
                                                            MetaWindow* window,
                                                            ClutterKeyEvent* event,
                                                            MetaKeyBinding* binding,
                                                            GalaWindowManagerGala* self);
static void gala_window_manager_gala_handle_cycle_workspaces (MetaDisplay* display,
                                                       MetaWindow* window,
                                                       ClutterKeyEvent* event,
                                                       MetaKeyBinding* binding,
                                                       GalaWindowManagerGala* self);
static void gala_window_manager_gala_handle_applications_menu (MetaDisplay* display,
                                                        MetaWindow* window,
                                                        ClutterKeyEvent* event,
                                                        MetaKeyBinding* binding,
                                                        GalaWindowManagerGala* self);
static void gala_window_manager_gala_handle_switch_input_source (MetaDisplay* display,
                                                          MetaWindow* window,
                                                          ClutterKeyEvent* event,
                                                          MetaKeyBinding* binding,
                                                          GalaWindowManagerGala* self);
static void gala_window_manager_gala_handle_screenshot (MetaDisplay* display,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowManagerGala* self);
static void __lambda117_ (GalaWindowManagerGala* self);
static void gala_window_manager_gala_launch_action (GalaWindowManagerGala* self,
                                             const gchar* action_key);
static void ___lambda117__meta_display_overlay_key (MetaDisplay* _sender,
                                             gpointer self);
static void __lambda118_ (GalaWindowManagerGala* self);
static void ___lambda118__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          ClutterKeyEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda119_ (GalaWindowManagerGala* self);
static void ___lambda119__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          ClutterKeyEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda120_ (GalaWindowManagerGala* self);
static void ___lambda120__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          ClutterKeyEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void gala_window_manager_gala_handle_switch_to_workspace (MetaDisplay* display,
                                                          MetaWindow* window,
                                                          ClutterKeyEvent* event,
                                                          MetaKeyBinding* binding,
                                                          GalaWindowManagerGala* self);
static void __lambda123_ (GalaWindowManagerGala* self);
static void ___lambda123__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          ClutterKeyEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda124_ (GalaWindowManagerGala* self);
static void ___lambda124__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          ClutterKeyEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void gala_window_manager_gala_handle_move_to_workspace (MetaDisplay* display,
                                                        MetaWindow* window,
                                                        ClutterKeyEvent* event,
                                                        MetaKeyBinding* binding,
                                                        GalaWindowManagerGala* self);
static void gala_window_manager_gala_on_monitors_changed (GalaWindowManagerGala* self);
static void _gala_window_manager_gala_on_monitors_changed_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                                          gpointer self);
VALA_EXTERN GalaHotCornerManager* gala_hot_corner_manager_new (GalaWindowManager* wm,
                                                   GSettings* behavior_settings);
VALA_EXTERN GalaHotCornerManager* gala_hot_corner_manager_construct (GType object_type,
                                                         GalaWindowManager* wm,
                                                         GSettings* behavior_settings);
static void _gala_window_manager_gala_update_input_area_gala_hot_corner_manager_on_configured (GalaHotCornerManager* _sender,
                                                                                        gpointer self);
VALA_EXTERN void gala_hot_corner_manager_configure (GalaHotCornerManager* self);
VALA_EXTERN GalaZoom* gala_zoom_new (GalaWindowManager* wm);
VALA_EXTERN GalaZoom* gala_zoom_construct (GType object_type,
                               GalaWindowManager* wm);
static gboolean __lambda125_ (Block9Data* _data9_);
VALA_EXTERN GalaAccentColorManager* gala_accent_color_manager_new (void);
VALA_EXTERN GalaAccentColorManager* gala_accent_color_manager_construct (GType object_type);
VALA_EXTERN GType gala_plugin_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPluginManager, g_object_unref)
VALA_EXTERN GalaPluginManager* gala_plugin_manager_get_default (void);
VALA_EXTERN void gala_plugin_manager_initialize (GalaPluginManager* self,
                                     GalaWindowManager* _wm);
static void _gala_window_manager_gala_update_input_area_gala_plugin_manager_regions_changed (GalaPluginManager* _sender,
                                                                                      gpointer self);
VALA_EXTERN const gchar* gala_plugin_manager_get_workspace_view_provider (GalaPluginManager* self);
VALA_EXTERN GalaPlugin* gala_plugin_manager_get_plugin (GalaPluginManager* self,
                                            const gchar* id);
VALA_EXTERN GalaMultitaskingView* gala_multitasking_view_new (GalaWindowManager* wm);
VALA_EXTERN GalaMultitaskingView* gala_multitasking_view_construct (GType object_type,
                                                        GalaWindowManager* wm);
VALA_EXTERN GType gala_multitasking_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaMultitaskingView, g_object_unref)
static void __lambda126_ (GalaWindowManagerGala* self);
static void ___lambda126__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          ClutterKeyEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
VALA_EXTERN const gchar* gala_plugin_manager_get_window_switcher_provider (GalaPluginManager* self);
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_construct (GType object_type,
                                                    GalaWindowManager* wm);
VALA_EXTERN void gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowSwitcher* self);
VALA_EXTERN const gchar* gala_plugin_manager_get_window_overview_provider (GalaPluginManager* self);
VALA_EXTERN GalaWindowOverview* gala_window_overview_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowOverview* gala_window_overview_construct (GType object_type,
                                                    GalaWindowManager* wm);
VALA_EXTERN GType gala_window_overview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowOverview, g_object_unref)
VALA_EXTERN void gala_window_manager_gala_set_notification_group (GalaWindowManagerGala* self,
                                                      ClutterActor* value);
VALA_EXTERN ClutterActor* gala_window_manager_gala_get_notification_group (GalaWindowManagerGala* self);
VALA_EXTERN GalaPointerLocator* gala_pointer_locator_new (GalaWindowManager* wm);
VALA_EXTERN GalaPointerLocator* gala_pointer_locator_construct (GType object_type,
                                                    GalaWindowManager* wm);
static void gala_window_manager_gala_set_pointer_locator (GalaWindowManagerGala* self,
                                                   GalaPointerLocator* value);
VALA_EXTERN GalaPointerLocator* gala_window_manager_gala_get_pointer_locator (GalaWindowManagerGala* self);
VALA_EXTERN GalaDwellClickTimer* gala_dwell_click_timer_new (GalaWindowManager* wm);
VALA_EXTERN GalaDwellClickTimer* gala_dwell_click_timer_construct (GType object_type,
                                                       GalaWindowManager* wm);
VALA_EXTERN GType gala_dwell_click_timer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDwellClickTimer, g_object_unref)
static void __lambda132_ (GalaWindowManagerGala* self);
static void ___lambda132__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          ClutterKeyEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda133_ (GalaWindowManagerGala* self);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
static GVariant* _variant_new5 (gboolean value);
static void ___lambda133__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          ClutterKeyEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
VALA_EXTERN void gala_plugin_manager_load_waiting_plugins (GalaPluginManager* self);
static gboolean ___lambda125__gsource_func (gpointer self);
static void __lambda134_ (GalaWindowManagerGala* self,
                   MetaWindow* window);
static void ___lambda134__meta_display_window_created (MetaDisplay* _sender,
                                                MetaWindow* object,
                                                gpointer self);
static gboolean __lambda135_ (Block9Data* _data9_);
static gboolean ___lambda135__gsource_func (gpointer self);
static void __lambda105_ (GalaWindowManagerGala* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda105__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN void gala_screen_shield_expand_to_screen_size (GalaScreenShield* self);
VALA_EXTERN gboolean gala_keyboard_manager_handle_modifiers_accelerator_activated (MetaDisplay* display,
                                                                       gboolean backward);
static void gala_window_manager_gala_screenshot_screen (GalaWindowManagerGala* self,
                                                 gboolean clipboard,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void gala_window_manager_gala_screenshot_screen_finish (GalaWindowManagerGala* self,
                                                        GAsyncResult* _res_);
static void gala_window_manager_gala_screenshot_area (GalaWindowManagerGala* self,
                                               gboolean clipboard,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void gala_window_manager_gala_screenshot_area_finish (GalaWindowManagerGala* self,
                                                      GAsyncResult* _res_);
static void gala_window_manager_gala_screenshot_current_window (GalaWindowManagerGala* self,
                                                         gboolean clipboard,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
static void gala_window_manager_gala_screenshot_current_window_finish (GalaWindowManagerGala* self,
                                                                GAsyncResult* _res_);
VALA_EXTERN gpointer gala_gesture_ref (gpointer instance);
VALA_EXTERN void gala_gesture_unref (gpointer instance);
VALA_EXTERN GParamSpec* gala_param_spec_gesture (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void gala_value_set_gesture (GValue* value,
                             gpointer v_object);
VALA_EXTERN void gala_value_take_gesture (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer gala_value_get_gesture (const GValue* value);
VALA_EXTERN GType gala_gesture_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGesture, gala_gesture_unref)
static void gala_window_manager_gala_on_gesture_detected (GalaWindowManagerGala* self,
                                                   GalaGesture* gesture);
VALA_EXTERN GType gala_gesture_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* gala_gesture_settings_get_string (const gchar* setting_id);
VALA_EXTERN GType gala_gesture_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureSettings, g_object_unref)
VALA_EXTERN GalaGestureSettings* gala_gesture_tracker_get_settings (GalaGestureTracker* self);
VALA_EXTERN MetaMotionDirection* gala_gesture_settings_get_natural_scroll_direction (GalaGestureSettings* self,
                                                                         GalaGesture* gesture);
static void gala_window_manager_gala_real_switch_to_next_workspace (GalaWindowManager* base,
                                                             MetaMotionDirection direction);
VALA_EXTERN void gala_multitasking_view_play_nudge_animation (GalaMultitaskingView* self,
                                                  MetaMotionDirection direction);
static void gala_window_manager_gala_play_nudge_animation (GalaWindowManagerGala* self,
                                                    MetaMotionDirection direction);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
VALA_EXTERN void gala_internal_utils_get_workspaces_geometry (MetaDisplay* display,
                                                  MtkRectangle* result);
static void __lambda121_ (Block10Data* _data10_,
                   gdouble percentage);
VALA_EXTERN gfloat gala_gesture_tracker_animation_value (gfloat initial_value,
                                             gfloat target_value,
                                             gdouble percentage,
                                             gboolean rounded);
static void ___lambda121__gala_gesture_tracker_on_update (gdouble percentage,
                                                   gpointer self);
static void __lambda122_ (GalaWindowManagerGala* self,
                   gdouble percentage,
                   gboolean cancel_action);
static void ___lambda122__gala_gesture_tracker_on_end (gdouble percentage,
                                                gboolean cancel_action,
                                                gint calculated_duration,
                                                gpointer self);
static void _vala_GValue_array_free (GValue * array,
                              gssize array_length);
VALA_EXTERN void gala_gesture_tracker_connect_handlers (GalaGestureTracker* self,
                                            GalaGestureTrackerOnBegin on_begin_handler,
                                            gpointer on_begin_handler_target,
                                            GDestroyNotify on_begin_handler_target_destroy_notify,
                                            GalaGestureTrackerOnUpdate on_update_handler,
                                            gpointer on_update_handler_target,
                                            GDestroyNotify on_update_handler_target_destroy_notify,
                                            GalaGestureTrackerOnEnd on_end_handler,
                                            gpointer on_end_handler_target,
                                            GDestroyNotify on_end_handler_target_destroy_notify);
VALA_EXTERN gboolean gala_screen_saver_manager_get_active (GalaScreenSaverManager* self,
                                               GError** error);
VALA_EXTERN GType gala_input_area_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gala_internal_utils_set_input_area (MetaDisplay* display,
                                         GalaInputArea area);
static void gala_window_manager_gala_show_bottom_stack_window (GalaWindowManagerGala* self,
                                                        MetaWindow* bottom_window);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void gala_window_manager_gala_animate_bottom_window_scale (GalaWindowManagerGala* self,
                                                           MetaWindowActor* actor);
static void __lambda142_ (Block11Data* _data11_,
                   MetaWindow* window);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN gboolean gala_internal_utils_get_window_is_normal (MetaWindow* window);
static gboolean ___lambda143_ (Block12Data* _data12_);
static gboolean ____lambda143__gsource_func (gpointer self);
static gboolean ___lambda144_ (Block12Data* _data12_);
static gboolean ____lambda144__gsource_func (gpointer self);
static void ___lambda142__gfunc (gconstpointer data,
                          gpointer self);
static void gala_window_manager_gala_real_move_window (GalaWindowManager* base,
                                                MetaWindow* window,
                                                MetaWorkspace* workspace);
static GalaModalProxy* gala_window_manager_gala_real_push_modal (GalaWindowManager* base,
                                                          ClutterActor* actor);
static void gala_window_manager_gala_real_pop_modal (GalaWindowManager* base,
                                              GalaModalProxy* proxy);
static gboolean gala_window_manager_gala_real_is_modal (GalaWindowManager* base);
static gboolean gala_window_manager_gala_real_modal_proxy_valid (GalaWindowManager* base,
                                                          GalaModalProxy* proxy);
static void gala_window_manager_gala_dim_parent_window (GalaWindowManagerGala* self,
                                                 MetaWindow* window,
                                                 gboolean dim);
static void gala_window_manager_gala_real_perform_action (GalaWindowManager* base,
                                                   GalaActionType type);
static GVariant* _variant_new6 (gboolean value);
static void gala_window_manager_gala_real_show_window_menu (MetaPlugin* base,
                                                     MetaWindow* window,
                                                     MetaWindowMenuType menu,
                                                     gint x,
                                                     gint y);
static void ___lambda145_ (GalaWindowManagerGala* self,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda145__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void gala_window_manager_gala_real_show_tile_preview (MetaPlugin* base,
                                                      MetaWindow* window,
                                                      MtkRectangle* tile_rect,
                                                      gint tile_monitor_number);
VALA_EXTERN void gala_internal_utils_get_theme_accent_color (GdkRGBA* result);
static void gala_window_manager_gala_real_hide_tile_preview (MetaPlugin* base);
static void gala_window_manager_gala_real_show_window_menu_for_rect (MetaPlugin* base,
                                                              MetaWindow* window,
                                                              MetaWindowMenuType menu,
                                                              MtkRectangle* rect);
static void gala_window_manager_gala_handle_fullscreen_window (GalaWindowManagerGala* self,
                                                        MetaWindow* window,
                                                        MetaSizeChange which_change);
VALA_EXTERN void gala_internal_utils_insert_workspace_with_window (gint index,
                                                       MetaWindow* new_window);
static void gala_window_manager_gala_real_size_change (MetaPlugin* base,
                                                MetaWindowActor* actor,
                                                MetaSizeChange which_change_local,
                                                MtkRectangle* old_frame_rect,
                                                MtkRectangle* old_buffer_rect);
static MetaSizeChange* _meta_size_change_dup (MetaSizeChange* self);
static void gala_window_manager_gala_real_size_changed (MetaPlugin* base,
                                                 MetaWindowActor* actor);
static void gala_window_manager_gala_maximize (GalaWindowManagerGala* self,
                                        MetaWindowActor* actor,
                                        gint ex,
                                        gint ey,
                                        gint ew,
                                        gint eh);
static void gala_window_manager_gala_unmaximize (GalaWindowManagerGala* self,
                                          MetaWindowActor* actor,
                                          gint ex,
                                          gint ey,
                                          gint ew,
                                          gint eh);
static void gala_window_manager_gala_real_minimize (MetaPlugin* base,
                                             MetaWindowActor* actor);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void ___lambda151_ (Block14Data* _data14_);
static void ____lambda151__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static void ___lambda152_ (Block15Data* _data15_);
static void ____lambda152__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void gala_window_manager_gala_move_window_to_next_ws (GalaWindowManagerGala* self,
                                                      MetaWindow* window);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static gboolean ____lambda146_ (Block17Data* _data17_);
static gboolean _____lambda146__gsource_func (gpointer self);
static void ___lambda147_ (Block17Data* _data17_);
static void ____lambda147__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static void ___lambda148_ (Block17Data* _data17_);
static void ____lambda148__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static void gala_window_manager_gala_real_unminimize (MetaPlugin* base,
                                               MetaWindowActor* actor);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void ___lambda153_ (Block19Data* _data19_);
static void ____lambda153__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static void gala_window_manager_gala_real_map (MetaPlugin* base,
                                        MetaWindowActor* actor);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
static void ___lambda154_ (Block21Data* _data21_);
static void ____lambda154__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
static void ___lambda155_ (Block22Data* _data22_);
static void ____lambda155__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void ___lambda156_ (Block23Data* _data23_);
static void ____lambda156__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static void gala_window_manager_gala_clutter_actor_reparent (ClutterActor* actor,
                                                      ClutterActor* new_parent);
VALA_EXTERN void gala_notification_stack_show_notification (GalaNotificationStack* self,
                                                MetaWindowActor* notification,
                                                gboolean animate);
static void gala_window_manager_gala_real_destroy (MetaPlugin* base,
                                            MetaWindowActor* actor);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void ___lambda157_ (Block25Data* _data25_);
static void ____lambda157__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
static void ___lambda158_ (Block26Data* _data26_);
static void ____lambda158__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static void ___lambda159_ (Block27Data* _data27_);
static void ____lambda159__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
VALA_EXTERN void gala_notification_stack_destroy_notification (GalaNotificationStack* self,
                                                   MetaWindowActor* notification,
                                                   gboolean animate);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void ____lambda160_ (Block28Data* _data28_);
static void _____lambda160__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                          gpointer self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static void gala_window_manager_gala_move_window_to_old_ws (GalaWindowManagerGala* self,
                                                     MetaWindow* window);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
VALA_EXTERN GType gala_window_listener_window_geometry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GalaWindowListenerWindowGeometry* gala_window_listener_window_geometry_dup (const GalaWindowListenerWindowGeometry* self);
VALA_EXTERN void gala_window_listener_window_geometry_free (GalaWindowListenerWindowGeometry* self);
VALA_EXTERN GType gala_window_listener_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowListener, g_object_unref)
VALA_EXTERN GalaWindowListener* gala_window_listener_get_default (void);
VALA_EXTERN GalaWindowListenerWindowGeometry* gala_window_listener_get_unmaximized_state_geometry (GalaWindowListener* self,
                                                                                       MetaWindow* window);
static void ___lambda149_ (Block30Data* _data30_);
static void ____lambda149__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static void ___lambda150_ (Block30Data* _data30_);
static void ____lambda150__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static gboolean gala_window_manager_gala_end_animation (GalaWindowManagerGala* self,
                                                 GeeHashSet** list,
                                                 MetaWindowActor* actor);
static void gala_window_manager_gala_real_kill_window_effects (MetaPlugin* base,
                                                        MetaWindowActor* actor);
static void gala_window_manager_gala_real_switch_workspace (MetaPlugin* base,
                                                     gint from,
                                                     gint to,
                                                     MetaMotionDirection direction);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
VALA_EXTERN gboolean gala_internal_utils_workspaces_only_on_primary (void);
static void __lambda161_ (GalaWindowManagerGala* self,
                   MetaWindow* window);
static void ___lambda161__gala_window_manager_gala_window_created (GalaWindowManagerGala* _sender,
                                                            MetaWindow* window,
                                                            gpointer self);
VALA_EXTERN GType gala_safe_window_clone_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSafeWindowClone, g_object_unref)
VALA_EXTERN GalaSafeWindowClone* gala_safe_window_clone_new (MetaWindow* window,
                                                 gboolean destroy_on_unmanaged);
VALA_EXTERN GalaSafeWindowClone* gala_safe_window_clone_construct (GType object_type,
                                                       MetaWindow* window,
                                                       gboolean destroy_on_unmanaged);
static void __lambda162_ (Block31Data* _data31_,
                   gdouble percentage);
static void ___lambda162__gala_gesture_tracker_on_update (gdouble percentage,
                                                   gpointer self);
static void __lambda163_ (Block31Data* _data31_,
                   gdouble percentage,
                   gboolean cancel_action,
                   gint duration);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static void gala_window_manager_gala_switch_workspace_animation_finished (GalaWindowManagerGala* self,
                                                                   MetaMotionDirection animation_direction,
                                                                   gboolean cancel_action);
static void ___lambda164_ (Block32Data* _data32_);
static void ____lambda164__clutter_timeline_completed (ClutterTimeline* _sender,
                                                gpointer self);
static void ___lambda163__gala_gesture_tracker_on_end (gdouble percentage,
                                                gboolean cancel_action,
                                                gint calculated_duration,
                                                gpointer self);
static void gala_window_manager_gala_end_switch_workspace (GalaWindowManagerGala* self);
static void gala_window_manager_gala_real_kill_switch_workspace (MetaPlugin* base);
static void gala_window_manager_gala_real_locate_pointer (MetaPlugin* base);
VALA_EXTERN void gala_pointer_locator_show_ripple (GalaPointerLocator* self);
static gboolean gala_window_manager_gala_real_keybinding_filter (MetaPlugin* base,
                                                          MetaKeyBinding* binding);
static void gala_window_manager_gala_real_confirm_display_change (MetaPlugin* base);
VALA_EXTERN GType gala_access_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaAccessDialog, g_object_unref)
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
VALA_EXTERN GalaAccessDialog* gala_access_dialog_new (const gchar* title,
                                          const gchar* body,
                                          const gchar* icon);
VALA_EXTERN GalaAccessDialog* gala_access_dialog_construct (GType object_type,
                                                const gchar* title,
                                                const gchar* body,
                                                const gchar* icon);
VALA_EXTERN void gala_access_dialog_set_accept_label (GalaAccessDialog* self,
                                          const gchar* value);
VALA_EXTERN void gala_access_dialog_set_deny_label (GalaAccessDialog* self,
                                        const gchar* value);
static void __lambda165_ (Block33Data* _data33_);
static gboolean __lambda166_ (Block33Data* _data33_);
VALA_EXTERN void gala_access_dialog_close (GalaAccessDialog* self);
static gboolean ___lambda166__gsource_func (gpointer self);
static void ___lambda165__gala_access_dialog_show (GalaAccessDialog* _sender,
                                            gpointer self);
static void __lambda167_ (Block33Data* _data33_,
                   guint res);
static void ___lambda167__gala_access_dialog_response (GalaAccessDialog* _sender,
                                                guint response,
                                                gpointer self);
static MetaCloseDialog* gala_window_manager_gala_real_create_close_dialog (MetaPlugin* base,
                                                                    MetaWindow* window);
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
VALA_EXTERN GType gala_close_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaCloseDialog, g_object_unref)
static gboolean __lambda168_ (Block34Data* _data34_,
                       GalaCloseDialog* d);
static gboolean ___lambda168__gee_predicate (gconstpointer g,
                                      gpointer self);
VALA_EXTERN GalaCloseDialog* gala_close_dialog_new (MetaWindow* window);
VALA_EXTERN GalaCloseDialog* gala_close_dialog_construct (GType object_type,
                                              MetaWindow* window);
static MetaPluginInfo* gala_window_manager_gala_real_plugin_info (MetaPlugin* base);
static gchar* gala_window_manager_gala_generate_screenshot_filename (GalaWindowManagerGala* self);
static void gala_window_manager_gala_screenshot_current_window_data_free (gpointer _data);
static gboolean gala_window_manager_gala_screenshot_current_window_co (GalaWindowManagerGalaScreenshotCurrentWindowData* _data_);
VALA_EXTERN GType gala_screenshot_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaScreenshotManager, g_object_unref)
VALA_EXTERN guint gala_screenshot_manager_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GalaScreenshotManager* gala_screenshot_manager_init (GalaWindowManager* wm);
VALA_EXTERN void gala_screenshot_manager_screenshot_window (GalaScreenshotManager* self,
                                                gboolean include_frame,
                                                gboolean include_cursor,
                                                gboolean flash,
                                                const gchar* filename,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void gala_screenshot_manager_screenshot_window_finish (GalaScreenshotManager* self,
                                                       GAsyncResult* _res_,
                                                       gboolean* success,
                                                       gchar** filename_used,
                                                       GError** error);
static void gala_window_manager_gala_screenshot_current_window_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
static void gala_window_manager_gala_screenshot_area_data_free (gpointer _data);
static gboolean gala_window_manager_gala_screenshot_area_co (GalaWindowManagerGalaScreenshotAreaData* _data_);
VALA_EXTERN void gala_screenshot_manager_select_area (GalaScreenshotManager* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN void gala_screenshot_manager_select_area_finish (GalaScreenshotManager* self,
                                                 GAsyncResult* _res_,
                                                 gint* x,
                                                 gint* y,
                                                 gint* width,
                                                 gint* height,
                                                 GError** error);
static void gala_window_manager_gala_screenshot_area_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
VALA_EXTERN void gala_screenshot_manager_screenshot_area (GalaScreenshotManager* self,
                                              gint x,
                                              gint y,
                                              gint width,
                                              gint height,
                                              gboolean flash,
                                              const gchar* filename,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN void gala_screenshot_manager_screenshot_area_finish (GalaScreenshotManager* self,
                                                     GAsyncResult* _res_,
                                                     gboolean* success,
                                                     gchar** filename_used,
                                                     GError** error);
static void gala_window_manager_gala_screenshot_screen_data_free (gpointer _data);
static gboolean gala_window_manager_gala_screenshot_screen_co (GalaWindowManagerGalaScreenshotScreenData* _data_);
VALA_EXTERN void gala_screenshot_manager_screenshot (GalaScreenshotManager* self,
                                         gboolean include_cursor,
                                         gboolean flash,
                                         const gchar* filename,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN void gala_screenshot_manager_screenshot_finish (GalaScreenshotManager* self,
                                                GAsyncResult* _res_,
                                                gboolean* success,
                                                gchar** filename_used,
                                                GError** error);
static void gala_window_manager_gala_screenshot_screen_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
VALA_EXTERN GalaWindowManagerGala* gala_window_manager_gala_new (void);
VALA_EXTERN GalaWindowManagerGala* gala_window_manager_gala_construct (GType object_type);
static GObject * gala_window_manager_gala_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
VALA_EXTERN GalaGestureTracker* gala_gesture_tracker_new (gint min_animation_duration,
                                              gint max_animation_duration);
VALA_EXTERN GalaGestureTracker* gala_gesture_tracker_construct (GType object_type,
                                                    gint min_animation_duration,
                                                    gint max_animation_duration);
VALA_EXTERN void gala_gesture_tracker_enable_touchpad (GalaGestureTracker* self);
static void _gala_window_manager_gala_on_gesture_detected_gala_gesture_tracker_on_gesture_detected (GalaGestureTracker* _sender,
                                                                                             GalaGesture* gesture,
                                                                                             gpointer self);
static void gala_window_manager_gala_finalize (GObject * obj);
static GType gala_window_manager_gala_get_type_once (void);
static void _vala_gala_window_manager_gala_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_gala_window_manager_gala_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
Window clutter_x11_get_stage_window (ClutterActor* stage);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusArgInfo _gala_daemon_dbus_arg_info_show_window_menu_flags = {-1, "flags", "u", NULL};
static const GDBusArgInfo _gala_daemon_dbus_arg_info_show_window_menu_x = {-1, "x", "i", NULL};
static const GDBusArgInfo _gala_daemon_dbus_arg_info_show_window_menu_y = {-1, "y", "i", NULL};
static const GDBusArgInfo * const _gala_daemon_dbus_arg_info_show_window_menu_in[] = {&_gala_daemon_dbus_arg_info_show_window_menu_flags, &_gala_daemon_dbus_arg_info_show_window_menu_x, &_gala_daemon_dbus_arg_info_show_window_menu_y, NULL};
static const GDBusArgInfo * const _gala_daemon_dbus_arg_info_show_window_menu_out[] = {NULL};
static const GDBusMethodInfo _gala_daemon_dbus_method_info_show_window_menu = {-1, "ShowWindowMenu", (GDBusArgInfo **) (&_gala_daemon_dbus_arg_info_show_window_menu_in), (GDBusArgInfo **) (&_gala_daemon_dbus_arg_info_show_window_menu_out), NULL};
static const GDBusArgInfo _gala_daemon_dbus_arg_info_show_desktop_menu_x = {-1, "x", "i", NULL};
static const GDBusArgInfo _gala_daemon_dbus_arg_info_show_desktop_menu_y = {-1, "y", "i", NULL};
static const GDBusArgInfo * const _gala_daemon_dbus_arg_info_show_desktop_menu_in[] = {&_gala_daemon_dbus_arg_info_show_desktop_menu_x, &_gala_daemon_dbus_arg_info_show_desktop_menu_y, NULL};
static const GDBusArgInfo * const _gala_daemon_dbus_arg_info_show_desktop_menu_out[] = {NULL};
static const GDBusMethodInfo _gala_daemon_dbus_method_info_show_desktop_menu = {-1, "ShowDesktopMenu", (GDBusArgInfo **) (&_gala_daemon_dbus_arg_info_show_desktop_menu_in), (GDBusArgInfo **) (&_gala_daemon_dbus_arg_info_show_desktop_menu_out), NULL};
static const GDBusMethodInfo * const _gala_daemon_dbus_method_info[] = {&_gala_daemon_dbus_method_info_show_window_menu, &_gala_daemon_dbus_method_info_show_desktop_menu, NULL};
static const GDBusSignalInfo * const _gala_daemon_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _gala_daemon_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gala_daemon_dbus_interface_info = {-1, "org.pantheon.gala.daemon", (GDBusMethodInfo **) (&_gala_daemon_dbus_method_info), (GDBusSignalInfo **) (&_gala_daemon_dbus_signal_info), (GDBusPropertyInfo **) (&_gala_daemon_dbus_property_info), NULL};
static const GDBusInterfaceVTable _gala_daemon_dbus_interface_vtable = {gala_daemon_dbus_interface_method_call, gala_daemon_dbus_interface_get_property, gala_daemon_dbus_interface_set_property};

void
gala_daemon_show_window_menu (GalaDaemon* self,
                              GalaWindowFlags flags,
                              gint x,
                              gint y,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GalaDaemonIface* _iface_;
#line 23 "../src/WindowManager.vala"
	_iface_ = GALA_DAEMON_GET_INTERFACE (self);
#line 23 "../src/WindowManager.vala"
	if (_iface_->show_window_menu) {
#line 23 "../src/WindowManager.vala"
		_iface_->show_window_menu (self, flags, x, y, _callback_, _user_data_);
#line 1673 "WindowManager.c"
	}
}

void
gala_daemon_show_window_menu_finish (GalaDaemon* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	GalaDaemonIface* _iface_;
#line 23 "../src/WindowManager.vala"
	_iface_ = GALA_DAEMON_GET_INTERFACE (self);
#line 23 "../src/WindowManager.vala"
	if (_iface_->show_window_menu_finish) {
#line 23 "../src/WindowManager.vala"
		_iface_->show_window_menu_finish (self, _res_, error);
#line 1689 "WindowManager.c"
	}
}

void
gala_daemon_show_desktop_menu (GalaDaemon* self,
                               gint x,
                               gint y,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	GalaDaemonIface* _iface_;
#line 23 "../src/WindowManager.vala"
	_iface_ = GALA_DAEMON_GET_INTERFACE (self);
#line 23 "../src/WindowManager.vala"
	if (_iface_->show_desktop_menu) {
#line 23 "../src/WindowManager.vala"
		_iface_->show_desktop_menu (self, x, y, _callback_, _user_data_);
#line 1707 "WindowManager.c"
	}
}

void
gala_daemon_show_desktop_menu_finish (GalaDaemon* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	GalaDaemonIface* _iface_;
#line 23 "../src/WindowManager.vala"
	_iface_ = GALA_DAEMON_GET_INTERFACE (self);
#line 23 "../src/WindowManager.vala"
	if (_iface_->show_desktop_menu_finish) {
#line 23 "../src/WindowManager.vala"
		_iface_->show_desktop_menu_finish (self, _res_, error);
#line 1723 "WindowManager.c"
	}
}

static void
gala_daemon_default_init (GalaDaemonIface * iface,
                          gpointer iface_data)
{
}

static GType
gala_daemon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaDaemonIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_daemon_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gala_daemon_type_id;
	gala_daemon_type_id = g_type_register_static (G_TYPE_INTERFACE, "GalaDaemon", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gala_daemon_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (gala_daemon_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) gala_daemon_proxy_get_type);
	g_type_set_qdata (gala_daemon_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.pantheon.gala.daemon");
	g_type_set_qdata (gala_daemon_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_gala_daemon_dbus_interface_info));
	g_type_set_qdata (gala_daemon_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gala_daemon_register_object);
	return gala_daemon_type_id;
}

GType
gala_daemon_get_type (void)
{
	static volatile gsize gala_daemon_type_id__once = 0;
	if (g_once_init_enter (&gala_daemon_type_id__once)) {
		GType gala_daemon_type_id;
		gala_daemon_type_id = gala_daemon_get_type_once ();
		g_once_init_leave (&gala_daemon_type_id__once, gala_daemon_type_id);
	}
	return gala_daemon_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (GalaDaemonProxy, gala_daemon_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (GALA_TYPE_DAEMON, gala_daemon_proxy_gala_daemon_interface_init) )
static void
gala_daemon_proxy_class_init (GalaDaemonProxyClass* klass)
{
#line 21 "../src/PluginManager.vala"
	G_DBUS_PROXY_CLASS (klass)->g_signal = gala_daemon_proxy_g_signal;
#line 1765 "WindowManager.c"
}

static void
gala_daemon_proxy_g_signal (GDBusProxy* proxy,
                            const gchar* sender_name,
                            const gchar* signal_name,
                            GVariant* parameters)
{
}

static void
gala_daemon_proxy_init (GalaDaemonProxy* self)
{
#line 21 "../src/PluginManager.vala"
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_gala_daemon_dbus_interface_info));
#line 1781 "WindowManager.c"
}

static void
_vala_g_async_ready_callback (GObject *source_object,
                              GAsyncResult *res,
                              void *user_data)
{
#line 21 "../src/PluginManager.vala"
	g_task_return_pointer (user_data, g_object_ref (res), g_object_unref);
#line 21 "../src/PluginManager.vala"
	g_object_unref (user_data);
#line 1793 "WindowManager.c"
}

static void
gala_daemon_proxy_show_window_menu_async (GalaDaemon* self,
                                          GalaWindowFlags flags,
                                          gint x,
                                          gint y,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
#line 21 "../src/PluginManager.vala"
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.pantheon.gala.daemon", "ShowWindowMenu");
#line 21 "../src/PluginManager.vala"
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
#line 21 "../src/PluginManager.vala"
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (flags));
#line 21 "../src/PluginManager.vala"
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (x));
#line 21 "../src/PluginManager.vala"
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (y));
#line 21 "../src/PluginManager.vala"
	_arguments = g_variant_builder_end (&_arguments_builder);
#line 21 "../src/PluginManager.vala"
	g_dbus_message_set_body (_message, _arguments);
#line 21 "../src/PluginManager.vala"
	if (_callback_ != NULL) {
#line 21 "../src/PluginManager.vala"
		g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
#line 1825 "WindowManager.c"
	} else {
#line 21 "../src/PluginManager.vala"
		g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
#line 21 "../src/PluginManager.vala"
		g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 1831 "WindowManager.c"
	}
#line 21 "../src/PluginManager.vala"
	g_object_unref (_message);
#line 1835 "WindowManager.c"
}

static void
gala_daemon_proxy_show_window_menu_finish (GalaDaemon* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
#line 21 "../src/PluginManager.vala"
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
#line 21 "../src/PluginManager.vala"
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
#line 21 "../src/PluginManager.vala"
	g_object_unref (_inner_res);
#line 21 "../src/PluginManager.vala"
	if (!_reply_message) {
#line 21 "../src/PluginManager.vala"
		return;
#line 1855 "WindowManager.c"
	}
#line 21 "../src/PluginManager.vala"
	if (g_dbus_message_to_gerror (_reply_message, error)) {
#line 21 "../src/PluginManager.vala"
		g_object_unref (_reply_message);
#line 21 "../src/PluginManager.vala"
		return;
#line 1863 "WindowManager.c"
	}
#line 21 "../src/PluginManager.vala"
	g_object_unref (_reply_message);
#line 1867 "WindowManager.c"
}

static void
gala_daemon_proxy_show_desktop_menu_async (GalaDaemon* self,
                                           gint x,
                                           gint y,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
#line 21 "../src/PluginManager.vala"
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.pantheon.gala.daemon", "ShowDesktopMenu");
#line 21 "../src/PluginManager.vala"
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
#line 21 "../src/PluginManager.vala"
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (x));
#line 21 "../src/PluginManager.vala"
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (y));
#line 21 "../src/PluginManager.vala"
	_arguments = g_variant_builder_end (&_arguments_builder);
#line 21 "../src/PluginManager.vala"
	g_dbus_message_set_body (_message, _arguments);
#line 21 "../src/PluginManager.vala"
	if (_callback_ != NULL) {
#line 21 "../src/PluginManager.vala"
		g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
#line 1896 "WindowManager.c"
	} else {
#line 21 "../src/PluginManager.vala"
		g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
#line 21 "../src/PluginManager.vala"
		g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 1902 "WindowManager.c"
	}
#line 21 "../src/PluginManager.vala"
	g_object_unref (_message);
#line 1906 "WindowManager.c"
}

static void
gala_daemon_proxy_show_desktop_menu_finish (GalaDaemon* self,
                                            GAsyncResult* _res_,
                                            GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
#line 21 "../src/PluginManager.vala"
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
#line 21 "../src/PluginManager.vala"
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
#line 21 "../src/PluginManager.vala"
	g_object_unref (_inner_res);
#line 21 "../src/PluginManager.vala"
	if (!_reply_message) {
#line 21 "../src/PluginManager.vala"
		return;
#line 1926 "WindowManager.c"
	}
#line 21 "../src/PluginManager.vala"
	if (g_dbus_message_to_gerror (_reply_message, error)) {
#line 21 "../src/PluginManager.vala"
		g_object_unref (_reply_message);
#line 21 "../src/PluginManager.vala"
		return;
#line 1934 "WindowManager.c"
	}
#line 21 "../src/PluginManager.vala"
	g_object_unref (_reply_message);
#line 1938 "WindowManager.c"
}

static void
gala_daemon_proxy_gala_daemon_interface_init (GalaDaemonIface* iface)
{
#line 21 "../src/PluginManager.vala"
	iface->show_window_menu = gala_daemon_proxy_show_window_menu_async;
#line 21 "../src/PluginManager.vala"
	iface->show_window_menu_finish = gala_daemon_proxy_show_window_menu_finish;
#line 21 "../src/PluginManager.vala"
	iface->show_desktop_menu = gala_daemon_proxy_show_desktop_menu_async;
#line 21 "../src/PluginManager.vala"
	iface->show_desktop_menu_finish = gala_daemon_proxy_show_desktop_menu_finish;
#line 1952 "WindowManager.c"
}

static void
_dbus_gala_daemon_show_window_menu (GalaDaemon* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	GalaDaemonShowWindowMenuReadyData* _ready_data;
	GVariant* _tmp142_;
	GVariant* _tmp143_;
	GVariant* _tmp144_;
#line 21 "../src/PluginManager.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 21 "../src/PluginManager.vala"
	_ready_data = g_slice_new0 (GalaDaemonShowWindowMenuReadyData);
#line 21 "../src/PluginManager.vala"
	_ready_data->_invocation_ = invocation;
#line 21 "../src/PluginManager.vala"
	_tmp142_ = g_variant_iter_next_value (&_arguments_iter);
#line 21 "../src/PluginManager.vala"
	_ready_data->flags = g_variant_get_uint32 (_tmp142_);
#line 21 "../src/PluginManager.vala"
	g_variant_unref (_tmp142_);
#line 21 "../src/PluginManager.vala"
	_tmp143_ = g_variant_iter_next_value (&_arguments_iter);
#line 21 "../src/PluginManager.vala"
	_ready_data->x = g_variant_get_int32 (_tmp143_);
#line 21 "../src/PluginManager.vala"
	g_variant_unref (_tmp143_);
#line 21 "../src/PluginManager.vala"
	_tmp144_ = g_variant_iter_next_value (&_arguments_iter);
#line 21 "../src/PluginManager.vala"
	_ready_data->y = g_variant_get_int32 (_tmp144_);
#line 21 "../src/PluginManager.vala"
	g_variant_unref (_tmp144_);
#line 21 "../src/PluginManager.vala"
	gala_daemon_show_window_menu (self, _ready_data->flags, _ready_data->x, _ready_data->y, (GAsyncReadyCallback) _dbus_gala_daemon_show_window_menu_ready, _ready_data);
#line 1991 "WindowManager.c"
}

static void
_dbus_gala_daemon_show_window_menu_ready (GObject * source_object,
                                          GAsyncResult * _res_,
                                          gpointer _user_data_)
{
	GalaDaemonShowWindowMenuReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
#line 21 "../src/PluginManager.vala"
	gala_daemon_show_window_menu_finish ((GalaDaemon*) source_object, _res_, &error);
#line 21 "../src/PluginManager.vala"
	if (error) {
#line 21 "../src/PluginManager.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 2013 "WindowManager.c"
		goto _error;
	}
#line 21 "../src/PluginManager.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 21 "../src/PluginManager.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 21 "../src/PluginManager.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 21 "../src/PluginManager.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 21 "../src/PluginManager.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 21 "../src/PluginManager.vala"
	g_object_unref (invocation);
#line 21 "../src/PluginManager.vala"
	g_object_unref (_reply_message);
#line 2030 "WindowManager.c"
	_error:
#line 21 "../src/PluginManager.vala"
	g_slice_free (GalaDaemonShowWindowMenuReadyData, _ready_data);
#line 2034 "WindowManager.c"
}

static void
_dbus_gala_daemon_show_desktop_menu (GalaDaemon* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	GalaDaemonShowDesktopMenuReadyData* _ready_data;
	GVariant* _tmp145_;
	GVariant* _tmp146_;
#line 21 "../src/PluginManager.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 21 "../src/PluginManager.vala"
	_ready_data = g_slice_new0 (GalaDaemonShowDesktopMenuReadyData);
#line 21 "../src/PluginManager.vala"
	_ready_data->_invocation_ = invocation;
#line 21 "../src/PluginManager.vala"
	_tmp145_ = g_variant_iter_next_value (&_arguments_iter);
#line 21 "../src/PluginManager.vala"
	_ready_data->x = g_variant_get_int32 (_tmp145_);
#line 21 "../src/PluginManager.vala"
	g_variant_unref (_tmp145_);
#line 21 "../src/PluginManager.vala"
	_tmp146_ = g_variant_iter_next_value (&_arguments_iter);
#line 21 "../src/PluginManager.vala"
	_ready_data->y = g_variant_get_int32 (_tmp146_);
#line 21 "../src/PluginManager.vala"
	g_variant_unref (_tmp146_);
#line 21 "../src/PluginManager.vala"
	gala_daemon_show_desktop_menu (self, _ready_data->x, _ready_data->y, (GAsyncReadyCallback) _dbus_gala_daemon_show_desktop_menu_ready, _ready_data);
#line 2066 "WindowManager.c"
}

static void
_dbus_gala_daemon_show_desktop_menu_ready (GObject * source_object,
                                           GAsyncResult * _res_,
                                           gpointer _user_data_)
{
	GalaDaemonShowDesktopMenuReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
#line 21 "../src/PluginManager.vala"
	gala_daemon_show_desktop_menu_finish ((GalaDaemon*) source_object, _res_, &error);
#line 21 "../src/PluginManager.vala"
	if (error) {
#line 21 "../src/PluginManager.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 2088 "WindowManager.c"
		goto _error;
	}
#line 21 "../src/PluginManager.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 21 "../src/PluginManager.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 21 "../src/PluginManager.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 21 "../src/PluginManager.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 21 "../src/PluginManager.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 21 "../src/PluginManager.vala"
	g_object_unref (invocation);
#line 21 "../src/PluginManager.vala"
	g_object_unref (_reply_message);
#line 2105 "WindowManager.c"
	_error:
#line 21 "../src/PluginManager.vala"
	g_slice_free (GalaDaemonShowDesktopMenuReadyData, _ready_data);
#line 2109 "WindowManager.c"
}

static void
gala_daemon_dbus_interface_method_call (GDBusConnection* connection,
                                        const gchar* sender,
                                        const gchar* object_path,
                                        const gchar* interface_name,
                                        const gchar* method_name,
                                        GVariant* parameters,
                                        GDBusMethodInvocation* invocation,
                                        gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 21 "../src/PluginManager.vala"
	if (strcmp (method_name, "ShowWindowMenu") == 0) {
#line 21 "../src/PluginManager.vala"
		_dbus_gala_daemon_show_window_menu (object, parameters, invocation);
#line 2130 "WindowManager.c"
	} else if (strcmp (method_name, "ShowDesktopMenu") == 0) {
#line 21 "../src/PluginManager.vala"
		_dbus_gala_daemon_show_desktop_menu (object, parameters, invocation);
#line 2134 "WindowManager.c"
	} else {
#line 21 "../src/PluginManager.vala"
		g_object_unref (invocation);
#line 2138 "WindowManager.c"
	}
}

static GVariant*
gala_daemon_dbus_interface_get_property (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* property_name,
                                         GError** error,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 21 "../src/PluginManager.vala"
	return NULL;
#line 2157 "WindowManager.c"
}

static gboolean
gala_daemon_dbus_interface_set_property (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* property_name,
                                         GVariant* value,
                                         GError** error,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 21 "../src/PluginManager.vala"
	return FALSE;
#line 2176 "WindowManager.c"
}

guint
gala_daemon_register_object (gpointer object,
                             GDBusConnection* connection,
                             const gchar* path,
                             GError** error)
{
	guint result;
	gpointer *data;
#line 21 "../src/PluginManager.vala"
	data = g_new (gpointer, 3);
#line 21 "../src/PluginManager.vala"
	data[0] = g_object_ref (object);
#line 21 "../src/PluginManager.vala"
	data[1] = g_object_ref (connection);
#line 21 "../src/PluginManager.vala"
	data[2] = g_strdup (path);
#line 21 "../src/PluginManager.vala"
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gala_daemon_dbus_interface_info), &_gala_daemon_dbus_interface_vtable, data, _gala_daemon_unregister_object, error);
#line 21 "../src/PluginManager.vala"
	if (!result) {
#line 21 "../src/PluginManager.vala"
		return 0;
#line 2201 "WindowManager.c"
	}
#line 21 "../src/PluginManager.vala"
	return result;
#line 2205 "WindowManager.c"
}

static void
_gala_daemon_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
#line 21 "../src/PluginManager.vala"
	g_object_unref (data[0]);
#line 21 "../src/PluginManager.vala"
	g_object_unref (data[1]);
#line 21 "../src/PluginManager.vala"
	g_free (data[2]);
#line 21 "../src/PluginManager.vala"
	g_free (data);
#line 2221 "WindowManager.c"
}

static inline gpointer
gala_window_manager_gala_get_instance_private (GalaWindowManagerGala* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowManagerGala_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 106 "../src/WindowManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2235 "WindowManager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 1857 "../src/WindowManager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2243 "WindowManager.c"
}

static void
_gala_window_manager_gala_daemon_appeared_gbus_name_appeared_callback (GDBusConnection* connection,
                                                                       const gchar* name,
                                                                       const gchar* name_owner,
                                                                       gpointer self)
{
#line 151 "../src/WindowManager.vala"
	gala_window_manager_gala_daemon_appeared ((GalaWindowManagerGala*) self);
#line 2254 "WindowManager.c"
}

static void
_gala_window_manager_gala_lost_daemon_gbus_name_vanished_callback (GDBusConnection* connection,
                                                                   const gchar* name,
                                                                   gpointer self)
{
#line 151 "../src/WindowManager.vala"
	gala_window_manager_gala_lost_daemon ((GalaWindowManagerGala*) self);
#line 2264 "WindowManager.c"
}

static void
__lambda141_ (GalaWindowManagerGala* self)
{
#line 156 "../src/WindowManager.vala"
	meta_background_refresh_all ();
#line 157 "../src/WindowManager.vala"
	gala_system_background_refresh ();
#line 2274 "WindowManager.c"
}

static void
___lambda141__meta_display_gl_video_memory_purged (MetaDisplay* _sender,
                                                   gpointer self)
{
#line 155 "../src/WindowManager.vala"
	__lambda141_ ((GalaWindowManagerGala*) self);
#line 2283 "WindowManager.c"
}

static void
gala_window_manager_gala_real_start (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
#line 148 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 149 "../src/WindowManager.vala"
	gala_window_manager_gala_show_stage (self);
#line 151 "../src/WindowManager.vala"
	g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, GALA_DAEMON_DBUS_NAME, G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_gala_window_manager_gala_daemon_appeared_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _gala_window_manager_gala_daemon_appeared_gbus_name_appeared_callback, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((_gala_window_manager_gala_lost_daemon_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _gala_window_manager_gala_lost_daemon_gbus_name_vanished_callback, g_object_ref (self), (GClosureNotify) g_object_unref)));
#line 152 "../src/WindowManager.vala"
	gala_access_dialog_watch_portal ();
#line 154 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 154 "../src/WindowManager.vala"
	display = _tmp0_;
#line 155 "../src/WindowManager.vala"
	g_signal_connect_object (display, "gl-video-memory-purged", (GCallback) ___lambda141__meta_display_gl_video_memory_purged, self, 0);
#line 2306 "WindowManager.c"
}

static void
gala_window_manager_gala_lost_daemon (GalaWindowManagerGala* self)
{
#line 161 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->daemon_proxy);
#line 162 "../src/WindowManager.vala"
	self->priv->daemon_proxy = NULL;
#line 2318 "WindowManager.c"
}

static void
___lambda136_ (GalaWindowManagerGala* self,
               GObject* obj,
               GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 167 "../src/WindowManager.vala"
	g_return_if_fail (res != NULL);
#line 2329 "WindowManager.c"
	{
		GalaDaemon* _tmp0_ = NULL;
		GalaDaemon* _tmp1_;
		GalaDaemon* _tmp2_;
		GalaDaemon* _tmp3_;
#line 169 "../src/WindowManager.vala"
		_tmp1_ = g_async_result_get_source_object (res);
#line 169 "../src/WindowManager.vala"
		_tmp2_ = (GalaDaemon*) g_async_initable_new_finish ((GAsyncInitable *) _tmp1_, res, &_inner_error0_);
#line 169 "../src/WindowManager.vala"
		g_object_unref (_tmp1_);
#line 169 "../src/WindowManager.vala"
		_tmp0_ = (GalaDaemon*) _tmp2_;
#line 169 "../src/WindowManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2345 "WindowManager.c"
			goto __catch0_g_error;
		}
#line 169 "../src/WindowManager.vala"
		_tmp3_ = _tmp0_;
#line 169 "../src/WindowManager.vala"
		_tmp0_ = NULL;
#line 169 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->daemon_proxy);
#line 169 "../src/WindowManager.vala"
		self->priv->daemon_proxy = _tmp3_;
#line 168 "../src/WindowManager.vala"
		_g_object_unref0 (_tmp0_);
#line 2358 "WindowManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 168 "../src/WindowManager.vala"
		e = _inner_error0_;
#line 168 "../src/WindowManager.vala"
		_inner_error0_ = NULL;
#line 171 "../src/WindowManager.vala"
		_tmp4_ = e;
#line 171 "../src/WindowManager.vala"
		_tmp5_ = _tmp4_->message;
#line 171 "../src/WindowManager.vala"
		g_warning ("WindowManager.vala:171: Failed to get Menu proxy: %s", _tmp5_);
#line 168 "../src/WindowManager.vala"
		_g_error_free0 (e);
#line 2378 "WindowManager.c"
	}
	__finally0:
#line 168 "../src/WindowManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 168 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "../src/WindowManager.vala"
		g_clear_error (&_inner_error0_);
#line 168 "../src/WindowManager.vala"
		return;
#line 2389 "WindowManager.c"
	}
}

static void
____lambda136__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 167 "../src/WindowManager.vala"
	___lambda136_ ((GalaWindowManagerGala*) self, source_object, res);
#line 167 "../src/WindowManager.vala"
	g_object_unref (self);
#line 2402 "WindowManager.c"
}

static void
gala_window_manager_gala_daemon_appeared (GalaWindowManagerGala* self)
{
	GalaDaemon* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 165 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/WindowManager.vala"
	_tmp0_ = self->priv->daemon_proxy;
#line 166 "../src/WindowManager.vala"
	if (_tmp0_ == NULL) {
#line 167 "../src/WindowManager.vala"
		g_async_initable_new_async (GALA_TYPE_DAEMON_PROXY, 0, NULL, ____lambda136__gasync_ready_callback, g_object_ref (self), "g-flags", 0, "g-name", GALA_DAEMON_DBUS_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", GALA_DAEMON_DBUS_OBJECT_PATH, "g-interface-name", "org.pantheon.gala.daemon", NULL);
#line 2418 "WindowManager.c"
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 177 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 177 "../src/WindowManager.vala"
	return _data9_;
#line 2429 "WindowManager.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 177 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 2439 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 177 "../src/WindowManager.vala"
		self = _data9_->self;
#line 177 "../src/WindowManager.vala"
		_g_object_unref0 (_data9_->keybinding_settings);
#line 177 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 177 "../src/WindowManager.vala"
		g_slice_free (Block9Data, _data9_);
#line 2449 "WindowManager.c"
	}
}

static void
_gala_window_manager_gala_update_input_area_gala_screen_saver_manager_active_changed (GalaScreenSaverManager* _sender,
                                                                                      gboolean new_value,
                                                                                      gpointer self)
{
#line 197 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area ((GalaWindowManagerGala*) self);
#line 2460 "WindowManager.c"
}

static ClutterColor*
_vala_clutter_color_from_string (const gchar* str)
{
	ClutterColor* color = NULL;
	ClutterColor* _tmp0_;
	ClutterColor* result;
#line 7625 "mutter-clutter-13.vapi"
	g_return_val_if_fail (str != NULL, NULL);
#line 7626 "mutter-clutter-13.vapi"
	_tmp0_ = clutter_color_alloc ();
#line 7626 "mutter-clutter-13.vapi"
	color = _tmp0_;
#line 7627 "mutter-clutter-13.vapi"
	clutter_color_from_string (color, str);
#line 7628 "mutter-clutter-13.vapi"
	result = color;
#line 7628 "mutter-clutter-13.vapi"
	return result;
#line 2481 "WindowManager.c"
}

static void
_vala_ClutterColor_free (ClutterColor* self)
{
#line 202 "../src/WindowManager.vala"
	g_boxed_free (clutter_color_get_type (), self);
#line 2489 "WindowManager.c"
}

static gboolean
__lambda103_ (GalaWindowManagerGala* self)
{
	gboolean result;
#line 206 "../src/WindowManager.vala"
	gala_workspace_manager_init ((GalaWindowManager*) self);
#line 207 "../src/WindowManager.vala"
	result = FALSE;
#line 207 "../src/WindowManager.vala"
	return result;
#line 2502 "WindowManager.c"
}

static gboolean
___lambda103__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda103_ ((GalaWindowManagerGala*) self);
#line 205 "../src/WindowManager.vala"
	return result;
#line 2512 "WindowManager.c"
}

static void
_gala_window_manager_gala_on_show_background_menu_gala_background_container_show_background_menu (GalaBackgroundContainer* _sender,
                                                                                                  gint x,
                                                                                                  gint y,
                                                                                                  gpointer self)
{
#line 242 "../src/WindowManager.vala"
	gala_window_manager_gala_on_show_background_menu ((GalaWindowManagerGala*) self, x, y);
#line 2523 "WindowManager.c"
}

static void
__lambda117_ (GalaWindowManagerGala* self)
{
#line 273 "../src/WindowManager.vala"
	gala_window_manager_gala_launch_action (self, "overlay-action");
#line 2531 "WindowManager.c"
}

static void
___lambda117__meta_display_overlay_key (MetaDisplay* _sender,
                                        gpointer self)
{
#line 272 "../src/WindowManager.vala"
	__lambda117_ ((GalaWindowManagerGala*) self);
#line 2540 "WindowManager.c"
}

static void
__lambda118_ (GalaWindowManagerGala* self)
{
#line 277 "../src/WindowManager.vala"
	gala_window_manager_gala_launch_action (self, "toggle-recording-action");
#line 2548 "WindowManager.c"
}

static void
___lambda118__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     ClutterKeyEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 276 "../src/WindowManager.vala"
	__lambda118_ ((GalaWindowManagerGala*) self);
#line 2560 "WindowManager.c"
}

static void
__lambda119_ (GalaWindowManagerGala* self)
{
}

static void
___lambda119__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     ClutterKeyEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 280 "../src/WindowManager.vala"
	__lambda119_ ((GalaWindowManagerGala*) self);
#line 2577 "WindowManager.c"
}

static void
__lambda120_ (GalaWindowManagerGala* self)
{
}

static void
___lambda120__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     ClutterKeyEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 281 "../src/WindowManager.vala"
	__lambda120_ ((GalaWindowManagerGala*) self);
#line 2594 "WindowManager.c"
}

static void
__lambda123_ (GalaWindowManagerGala* self)
{
}

static void
___lambda123__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     ClutterKeyEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 285 "../src/WindowManager.vala"
	__lambda123_ ((GalaWindowManagerGala*) self);
#line 2611 "WindowManager.c"
}

static void
__lambda124_ (GalaWindowManagerGala* self)
{
}

static void
___lambda124__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     ClutterKeyEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 286 "../src/WindowManager.vala"
	__lambda124_ ((GalaWindowManagerGala*) self);
#line 2628 "WindowManager.c"
}

static void
_gala_window_manager_gala_on_monitors_changed_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                                     gpointer self)
{
#line 295 "../src/WindowManager.vala"
	gala_window_manager_gala_on_monitors_changed ((GalaWindowManagerGala*) self);
#line 2637 "WindowManager.c"
}

static void
_gala_window_manager_gala_update_input_area_gala_hot_corner_manager_on_configured (GalaHotCornerManager* _sender,
                                                                                   gpointer self)
{
#line 298 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area ((GalaWindowManagerGala*) self);
#line 2646 "WindowManager.c"
}

static void
_gala_window_manager_gala_update_input_area_gala_plugin_manager_regions_changed (GalaPluginManager* _sender,
                                                                                 gpointer self)
{
#line 318 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area ((GalaWindowManagerGala*) self);
#line 2655 "WindowManager.c"
}

static void
__lambda126_ (GalaWindowManagerGala* self)
{
	GalaActivatableComponent* _tmp0_;
	GalaActivatableComponent* _tmp1_;
#line 327 "../src/WindowManager.vala"
	_tmp0_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 327 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 327 "../src/WindowManager.vala"
	if (gala_activatable_component_is_opened (_tmp1_)) {
#line 2669 "WindowManager.c"
		GalaActivatableComponent* _tmp2_;
		GalaActivatableComponent* _tmp3_;
#line 328 "../src/WindowManager.vala"
		_tmp2_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 328 "../src/WindowManager.vala"
		_tmp3_ = _tmp2_;
#line 328 "../src/WindowManager.vala"
		gala_activatable_component_close (_tmp3_, NULL);
#line 2678 "WindowManager.c"
	} else {
		GalaActivatableComponent* _tmp4_;
		GalaActivatableComponent* _tmp5_;
#line 330 "../src/WindowManager.vala"
		_tmp4_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 330 "../src/WindowManager.vala"
		_tmp5_ = _tmp4_;
#line 330 "../src/WindowManager.vala"
		gala_activatable_component_open (_tmp5_, NULL);
#line 2688 "WindowManager.c"
	}
}

static void
___lambda126__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     ClutterKeyEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 326 "../src/WindowManager.vala"
	__lambda126_ ((GalaWindowManagerGala*) self);
#line 2701 "WindowManager.c"
}

static void
__lambda132_ (GalaWindowManagerGala* self)
{
	GalaActivatableComponent* _tmp0_;
#line 361 "../src/WindowManager.vala"
	_tmp0_ = self->priv->window_overview;
#line 361 "../src/WindowManager.vala"
	if (gala_activatable_component_is_opened (_tmp0_)) {
#line 2712 "WindowManager.c"
		GalaActivatableComponent* _tmp1_;
#line 362 "../src/WindowManager.vala"
		_tmp1_ = self->priv->window_overview;
#line 362 "../src/WindowManager.vala"
		gala_activatable_component_close (_tmp1_, NULL);
#line 2718 "WindowManager.c"
	} else {
		GalaActivatableComponent* _tmp2_;
#line 364 "../src/WindowManager.vala"
		_tmp2_ = self->priv->window_overview;
#line 364 "../src/WindowManager.vala"
		gala_activatable_component_open (_tmp2_, NULL);
#line 2725 "WindowManager.c"
	}
}

static void
___lambda132__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     ClutterKeyEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 360 "../src/WindowManager.vala"
	__lambda132_ ((GalaWindowManagerGala*) self);
#line 2738 "WindowManager.c"
}

static void
_g_free0_ (gpointer var)
{
#line 371 "../src/WindowManager.vala"
	var = (g_free (var), NULL);
#line 2746 "WindowManager.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 371 "../src/WindowManager.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 2754 "WindowManager.c"
}

static GVariant*
_variant_new5 (gboolean value)
{
#line 372 "../src/WindowManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2762 "WindowManager.c"
}

static void
__lambda133_ (GalaWindowManagerGala* self)
{
	GalaActivatableComponent* _tmp0_;
#line 368 "../src/WindowManager.vala"
	_tmp0_ = self->priv->window_overview;
#line 368 "../src/WindowManager.vala"
	if (gala_activatable_component_is_opened (_tmp0_)) {
#line 2773 "WindowManager.c"
		GalaActivatableComponent* _tmp1_;
#line 369 "../src/WindowManager.vala"
		_tmp1_ = self->priv->window_overview;
#line 369 "../src/WindowManager.vala"
		gala_activatable_component_close (_tmp1_, NULL);
#line 2779 "WindowManager.c"
	} else {
		GHashTable* hints = NULL;
		GHashFunc _tmp2_;
		GEqualFunc _tmp3_;
		GHashTable* _tmp4_;
		GHashTable* _tmp5_;
		gchar* _tmp6_;
		GVariant* _tmp7_;
		GalaActivatableComponent* _tmp8_;
		GHashTable* _tmp9_;
#line 371 "../src/WindowManager.vala"
		_tmp2_ = g_str_hash;
#line 371 "../src/WindowManager.vala"
		_tmp3_ = g_str_equal;
#line 371 "../src/WindowManager.vala"
		_tmp4_ = g_hash_table_new_full (_tmp2_, _tmp3_, _g_free0_, _g_variant_unref0_);
#line 371 "../src/WindowManager.vala"
		hints = _tmp4_;
#line 372 "../src/WindowManager.vala"
		_tmp5_ = hints;
#line 372 "../src/WindowManager.vala"
		_tmp6_ = g_strdup ("all-windows");
#line 372 "../src/WindowManager.vala"
		_tmp7_ = _variant_new5 (TRUE);
#line 372 "../src/WindowManager.vala"
		g_hash_table_insert (_tmp5_, _tmp6_, _tmp7_);
#line 373 "../src/WindowManager.vala"
		_tmp8_ = self->priv->window_overview;
#line 373 "../src/WindowManager.vala"
		_tmp9_ = hints;
#line 373 "../src/WindowManager.vala"
		gala_activatable_component_open (_tmp8_, _tmp9_);
#line 368 "../src/WindowManager.vala"
		_g_hash_table_unref0 (hints);
#line 2814 "WindowManager.c"
	}
}

static void
___lambda133__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     ClutterKeyEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 367 "../src/WindowManager.vala"
	__lambda133_ ((GalaWindowManagerGala*) self);
#line 2827 "WindowManager.c"
}

static gboolean
__lambda125_ (Block9Data* _data9_)
{
	GalaWindowManagerGala* self;
	const gchar* xdg_session_type = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GalaAccentColorManager* _tmp4_;
	GalaPluginManager* plugin_manager = NULL;
	GalaPluginManager* _tmp5_;
	GalaPluginManager* _tmp6_;
	GalaPluginManager* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GalaPluginManager* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GalaPluginManager* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gboolean _tmp38_ = FALSE;
	GalaPluginManager* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	ClutterActor* _tmp53_;
	ClutterActor* _tmp54_;
	ClutterActor* _tmp55_;
	ClutterActor* _tmp56_;
	ClutterActor* _tmp57_;
	GalaPointerLocator* _tmp58_;
	GalaPointerLocator* _tmp59_;
	ClutterActor* _tmp60_;
	ClutterActor* _tmp61_;
	GalaPointerLocator* _tmp62_;
	ClutterActor* _tmp63_;
	ClutterActor* _tmp64_;
	GalaDwellClickTimer* _tmp65_;
	GalaDwellClickTimer* _tmp66_;
	ClutterActor* _tmp67_;
	ClutterActor* _tmp68_;
	GalaScreenShield* _tmp69_;
	MetaDisplay* _tmp70_;
	GSettings* _tmp71_;
	MetaDisplay* _tmp72_;
	GSettings* _tmp73_;
	GalaPluginManager* _tmp74_;
	gboolean result;
#line 305 "../src/WindowManager.vala"
	self = _data9_->self;
#line 306 "../src/WindowManager.vala"
	_tmp0_ = g_getenv ("XDG_SESSION_TYPE");
#line 306 "../src/WindowManager.vala"
	xdg_session_type = _tmp0_;
#line 307 "../src/WindowManager.vala"
	_tmp1_ = xdg_session_type;
#line 307 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp1_, "x11") == 0) {
#line 2886 "WindowManager.c"
		gchar** args = NULL;
		gchar** _tmp2_;
		gint args_length1;
		gint _args_size_;
		gchar** _args = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gint _args_length1;
		gint __args_size_;
#line 308 "../src/WindowManager.vala"
		_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 308 "../src/WindowManager.vala"
		args = _tmp2_;
#line 308 "../src/WindowManager.vala"
		args_length1 = 0;
#line 308 "../src/WindowManager.vala"
		_args_size_ = args_length1;
#line 309 "../src/WindowManager.vala"
		_tmp3_ = args;
#line 309 "../src/WindowManager.vala"
		_tmp3__length1 = args_length1;
#line 309 "../src/WindowManager.vala"
		_args = _tmp3_;
#line 309 "../src/WindowManager.vala"
		_args_length1 = _tmp3__length1;
#line 309 "../src/WindowManager.vala"
		__args_size_ = _args_length1;
#line 310 "../src/WindowManager.vala"
		gtk_init ((gint*) (&_args_length1), &_args);
#line 310 "../src/WindowManager.vala"
		__args_size_ = _args_length1;
#line 307 "../src/WindowManager.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 2920 "WindowManager.c"
	}
#line 313 "../src/WindowManager.vala"
	_tmp4_ = gala_accent_color_manager_new ();
#line 313 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->accent_color_manager);
#line 313 "../src/WindowManager.vala"
	self->priv->accent_color_manager = _tmp4_;
#line 316 "../src/WindowManager.vala"
	_tmp5_ = gala_plugin_manager_get_default ();
#line 316 "../src/WindowManager.vala"
	plugin_manager = _tmp5_;
#line 317 "../src/WindowManager.vala"
	_tmp6_ = plugin_manager;
#line 317 "../src/WindowManager.vala"
	gala_plugin_manager_initialize (_tmp6_, (GalaWindowManager*) self);
#line 318 "../src/WindowManager.vala"
	_tmp7_ = plugin_manager;
#line 318 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp7_, "regions-changed", (GCallback) _gala_window_manager_gala_update_input_area_gala_plugin_manager_regions_changed, self, 0);
#line 320 "../src/WindowManager.vala"
	_tmp9_ = plugin_manager;
#line 320 "../src/WindowManager.vala"
	_tmp10_ = gala_plugin_manager_get_workspace_view_provider (_tmp9_);
#line 320 "../src/WindowManager.vala"
	_tmp11_ = _tmp10_;
#line 320 "../src/WindowManager.vala"
	if (_tmp11_ == NULL) {
#line 320 "../src/WindowManager.vala"
		_tmp8_ = TRUE;
#line 2950 "WindowManager.c"
	} else {
		GalaPluginManager* _tmp12_;
		GalaPluginManager* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		GalaPlugin* _tmp16_;
		GalaActivatableComponent* _tmp17_;
		GalaActivatableComponent* _tmp18_;
#line 321 "../src/WindowManager.vala"
		_tmp12_ = plugin_manager;
#line 321 "../src/WindowManager.vala"
		_tmp13_ = plugin_manager;
#line 321 "../src/WindowManager.vala"
		_tmp14_ = gala_plugin_manager_get_workspace_view_provider (_tmp13_);
#line 321 "../src/WindowManager.vala"
		_tmp15_ = _tmp14_;
#line 321 "../src/WindowManager.vala"
		_tmp16_ = gala_plugin_manager_get_plugin (_tmp12_, _tmp15_);
#line 321 "../src/WindowManager.vala"
		_tmp17_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, GALA_TYPE_ACTIVATABLE_COMPONENT) ? ((GalaActivatableComponent*) _tmp16_) : NULL;
#line 321 "../src/WindowManager.vala"
		if (_tmp17_ == NULL) {
#line 321 "../src/WindowManager.vala"
			_g_object_unref0 (_tmp16_);
#line 2975 "WindowManager.c"
		}
#line 321 "../src/WindowManager.vala"
		_tmp18_ = _tmp17_;
#line 321 "../src/WindowManager.vala"
		gala_window_manager_set_workspace_view ((GalaWindowManager*) self, _tmp18_);
#line 321 "../src/WindowManager.vala"
		_tmp8_ = _tmp18_ == NULL;
#line 321 "../src/WindowManager.vala"
		_g_object_unref0 (_tmp18_);
#line 2985 "WindowManager.c"
	}
#line 320 "../src/WindowManager.vala"
	if (_tmp8_) {
#line 2989 "WindowManager.c"
		GalaMultitaskingView* _tmp19_;
		GalaMultitaskingView* _tmp20_;
		ClutterActor* _tmp21_;
		ClutterActor* _tmp22_;
		GalaActivatableComponent* _tmp23_;
		GalaActivatableComponent* _tmp24_;
#line 322 "../src/WindowManager.vala"
		_tmp19_ = gala_multitasking_view_new ((GalaWindowManager*) self);
#line 322 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp19_);
#line 322 "../src/WindowManager.vala"
		_tmp20_ = _tmp19_;
#line 322 "../src/WindowManager.vala"
		gala_window_manager_set_workspace_view ((GalaWindowManager*) self, (GalaActivatableComponent*) _tmp20_);
#line 322 "../src/WindowManager.vala"
		_g_object_unref0 (_tmp20_);
#line 323 "../src/WindowManager.vala"
		_tmp21_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 323 "../src/WindowManager.vala"
		_tmp22_ = _tmp21_;
#line 323 "../src/WindowManager.vala"
		_tmp23_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 323 "../src/WindowManager.vala"
		_tmp24_ = _tmp23_;
#line 323 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, clutter_actor_get_type (), ClutterActor));
#line 3016 "WindowManager.c"
	}
#line 326 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("show-desktop", ___lambda126__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 333 "../src/WindowManager.vala"
	_tmp25_ = plugin_manager;
#line 333 "../src/WindowManager.vala"
	_tmp26_ = gala_plugin_manager_get_window_switcher_provider (_tmp25_);
#line 333 "../src/WindowManager.vala"
	_tmp27_ = _tmp26_;
#line 333 "../src/WindowManager.vala"
	if (_tmp27_ == NULL) {
#line 3028 "WindowManager.c"
		GalaWindowSwitcher* _tmp28_;
		ClutterActor* _tmp29_;
		ClutterActor* _tmp30_;
		GalaWindowSwitcher* _tmp31_;
		GalaWindowSwitcher* _tmp32_;
		GalaWindowSwitcher* _tmp33_;
		GalaWindowSwitcher* _tmp34_;
		GalaWindowSwitcher* _tmp35_;
		GalaWindowSwitcher* _tmp36_;
		GalaWindowSwitcher* _tmp37_;
#line 334 "../src/WindowManager.vala"
		_tmp28_ = gala_window_switcher_new ((GalaWindowManager*) self);
#line 334 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp28_);
#line 334 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->winswitcher);
#line 334 "../src/WindowManager.vala"
		self->priv->winswitcher = _tmp28_;
#line 335 "../src/WindowManager.vala"
		_tmp29_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 335 "../src/WindowManager.vala"
		_tmp30_ = _tmp29_;
#line 335 "../src/WindowManager.vala"
		_tmp31_ = self->priv->winswitcher;
#line 335 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp30_, (ClutterActor*) _tmp31_);
#line 337 "../src/WindowManager.vala"
		_tmp32_ = self->priv->winswitcher;
#line 337 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-applications", (MetaKeyHandlerFunc) gala_window_switcher_handle_switch_windows, g_object_ref (_tmp32_), g_object_unref);
#line 338 "../src/WindowManager.vala"
		_tmp33_ = self->priv->winswitcher;
#line 338 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-applications-backward", (MetaKeyHandlerFunc) gala_window_switcher_handle_switch_windows, g_object_ref (_tmp33_), g_object_unref);
#line 339 "../src/WindowManager.vala"
		_tmp34_ = self->priv->winswitcher;
#line 339 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-windows", (MetaKeyHandlerFunc) gala_window_switcher_handle_switch_windows, g_object_ref (_tmp34_), g_object_unref);
#line 340 "../src/WindowManager.vala"
		_tmp35_ = self->priv->winswitcher;
#line 340 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-windows-backward", (MetaKeyHandlerFunc) gala_window_switcher_handle_switch_windows, g_object_ref (_tmp35_), g_object_unref);
#line 341 "../src/WindowManager.vala"
		_tmp36_ = self->priv->winswitcher;
#line 341 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-group", (MetaKeyHandlerFunc) gala_window_switcher_handle_switch_windows, g_object_ref (_tmp36_), g_object_unref);
#line 342 "../src/WindowManager.vala"
		_tmp37_ = self->priv->winswitcher;
#line 342 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-group-backward", (MetaKeyHandlerFunc) gala_window_switcher_handle_switch_windows, g_object_ref (_tmp37_), g_object_unref);
#line 3079 "WindowManager.c"
	}
#line 345 "../src/WindowManager.vala"
	_tmp39_ = plugin_manager;
#line 345 "../src/WindowManager.vala"
	_tmp40_ = gala_plugin_manager_get_window_overview_provider (_tmp39_);
#line 345 "../src/WindowManager.vala"
	_tmp41_ = _tmp40_;
#line 345 "../src/WindowManager.vala"
	if (_tmp41_ == NULL) {
#line 345 "../src/WindowManager.vala"
		_tmp38_ = TRUE;
#line 3091 "WindowManager.c"
	} else {
		GalaPluginManager* _tmp42_;
		GalaPluginManager* _tmp43_;
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		GalaPlugin* _tmp46_;
		GalaActivatableComponent* _tmp47_;
		GalaActivatableComponent* _tmp48_;
#line 346 "../src/WindowManager.vala"
		_tmp42_ = plugin_manager;
#line 346 "../src/WindowManager.vala"
		_tmp43_ = plugin_manager;
#line 346 "../src/WindowManager.vala"
		_tmp44_ = gala_plugin_manager_get_window_overview_provider (_tmp43_);
#line 346 "../src/WindowManager.vala"
		_tmp45_ = _tmp44_;
#line 346 "../src/WindowManager.vala"
		_tmp46_ = gala_plugin_manager_get_plugin (_tmp42_, _tmp45_);
#line 346 "../src/WindowManager.vala"
		_tmp47_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp46_, GALA_TYPE_ACTIVATABLE_COMPONENT) ? ((GalaActivatableComponent*) _tmp46_) : NULL;
#line 346 "../src/WindowManager.vala"
		if (_tmp47_ == NULL) {
#line 346 "../src/WindowManager.vala"
			_g_object_unref0 (_tmp46_);
#line 3116 "WindowManager.c"
		}
#line 346 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->window_overview);
#line 346 "../src/WindowManager.vala"
		self->priv->window_overview = _tmp47_;
#line 346 "../src/WindowManager.vala"
		_tmp48_ = self->priv->window_overview;
#line 346 "../src/WindowManager.vala"
		_tmp38_ = _tmp48_ == NULL;
#line 3126 "WindowManager.c"
	}
#line 345 "../src/WindowManager.vala"
	if (_tmp38_) {
#line 3130 "WindowManager.c"
		GalaWindowOverview* _tmp49_;
		ClutterActor* _tmp50_;
		ClutterActor* _tmp51_;
		GalaActivatableComponent* _tmp52_;
#line 347 "../src/WindowManager.vala"
		_tmp49_ = gala_window_overview_new ((GalaWindowManager*) self);
#line 347 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp49_);
#line 347 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->window_overview);
#line 347 "../src/WindowManager.vala"
		self->priv->window_overview = (GalaActivatableComponent*) _tmp49_;
#line 348 "../src/WindowManager.vala"
		_tmp50_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 348 "../src/WindowManager.vala"
		_tmp51_ = _tmp50_;
#line 348 "../src/WindowManager.vala"
		_tmp52_ = self->priv->window_overview;
#line 348 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp51_, G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, clutter_actor_get_type (), ClutterActor));
#line 3151 "WindowManager.c"
	}
#line 351 "../src/WindowManager.vala"
	_tmp53_ = clutter_actor_new ();
#line 351 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp53_);
#line 351 "../src/WindowManager.vala"
	_tmp54_ = _tmp53_;
#line 351 "../src/WindowManager.vala"
	gala_window_manager_gala_set_notification_group (self, _tmp54_);
#line 351 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp54_);
#line 352 "../src/WindowManager.vala"
	_tmp55_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 352 "../src/WindowManager.vala"
	_tmp56_ = _tmp55_;
#line 352 "../src/WindowManager.vala"
	_tmp57_ = self->priv->_notification_group;
#line 352 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp56_, _tmp57_);
#line 354 "../src/WindowManager.vala"
	_tmp58_ = gala_pointer_locator_new ((GalaWindowManager*) self);
#line 354 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp58_);
#line 354 "../src/WindowManager.vala"
	_tmp59_ = _tmp58_;
#line 354 "../src/WindowManager.vala"
	gala_window_manager_gala_set_pointer_locator (self, _tmp59_);
#line 354 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp59_);
#line 355 "../src/WindowManager.vala"
	_tmp60_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 355 "../src/WindowManager.vala"
	_tmp61_ = _tmp60_;
#line 355 "../src/WindowManager.vala"
	_tmp62_ = self->priv->_pointer_locator;
#line 355 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp61_, (ClutterActor*) _tmp62_);
#line 356 "../src/WindowManager.vala"
	_tmp63_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 356 "../src/WindowManager.vala"
	_tmp64_ = _tmp63_;
#line 356 "../src/WindowManager.vala"
	_tmp65_ = gala_dwell_click_timer_new ((GalaWindowManager*) self);
#line 356 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp65_);
#line 356 "../src/WindowManager.vala"
	_tmp66_ = _tmp65_;
#line 356 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp64_, (ClutterActor*) _tmp66_);
#line 356 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp66_);
#line 358 "../src/WindowManager.vala"
	_tmp67_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 358 "../src/WindowManager.vala"
	_tmp68_ = _tmp67_;
#line 358 "../src/WindowManager.vala"
	_tmp69_ = self->priv->_screen_shield;
#line 358 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp68_, (ClutterActor*) _tmp69_);
#line 360 "../src/WindowManager.vala"
	_tmp70_ = _data9_->display;
#line 360 "../src/WindowManager.vala"
	_tmp71_ = _data9_->keybinding_settings;
#line 360 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp70_, "expose-windows", _tmp71_, META_KEY_BINDING_IGNORE_AUTOREPEAT, ___lambda132__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 367 "../src/WindowManager.vala"
	_tmp72_ = _data9_->display;
#line 367 "../src/WindowManager.vala"
	_tmp73_ = _data9_->keybinding_settings;
#line 367 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp72_, "expose-all-windows", _tmp73_, META_KEY_BINDING_IGNORE_AUTOREPEAT, ___lambda133__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 377 "../src/WindowManager.vala"
	_tmp74_ = plugin_manager;
#line 377 "../src/WindowManager.vala"
	gala_plugin_manager_load_waiting_plugins (_tmp74_);
#line 379 "../src/WindowManager.vala"
	result = FALSE;
#line 379 "../src/WindowManager.vala"
	return result;
#line 3231 "WindowManager.c"
}

static gboolean
___lambda125__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda125_ (self);
#line 305 "../src/WindowManager.vala"
	return result;
#line 3241 "WindowManager.c"
}

static void
__lambda134_ (GalaWindowManagerGala* self,
              MetaWindow* window)
{
#line 385 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 385 "../src/WindowManager.vala"
	g_signal_emit (self, gala_window_manager_gala_signals[GALA_WINDOW_MANAGER_GALA_WINDOW_CREATED_SIGNAL], 0, window);
#line 3252 "WindowManager.c"
}

static void
___lambda134__meta_display_window_created (MetaDisplay* _sender,
                                           MetaWindow* object,
                                           gpointer self)
{
#line 385 "../src/WindowManager.vala"
	__lambda134_ ((GalaWindowManagerGala*) self, object);
#line 3262 "WindowManager.c"
}

static gboolean
__lambda135_ (Block9Data* _data9_)
{
	GalaWindowManagerGala* self;
	MetaDisplay* _tmp0_;
	MetaContext* _tmp1_;
	gboolean result;
#line 389 "../src/WindowManager.vala"
	self = _data9_->self;
#line 394 "../src/WindowManager.vala"
	_tmp0_ = _data9_->display;
#line 394 "../src/WindowManager.vala"
	_tmp1_ = meta_display_get_context (_tmp0_);
#line 394 "../src/WindowManager.vala"
	meta_context_notify_ready (_tmp1_);
#line 395 "../src/WindowManager.vala"
	result = G_SOURCE_REMOVE;
#line 395 "../src/WindowManager.vala"
	return result;
#line 3284 "WindowManager.c"
}

static gboolean
___lambda135__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda135_ (self);
#line 389 "../src/WindowManager.vala"
	return result;
#line 3294 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_show_stage (GalaWindowManagerGala* self)
{
	Block9Data* _data9_;
	MetaDisplay* _tmp0_;
	GalaScreenShield* _tmp1_;
	GalaScreenShield* _tmp2_;
	GalaScreenShield* _tmp3_;
	GalaScreenSaverManager* _tmp4_;
	GalaScreenSaverManager* _tmp5_;
	MetaDisplay* _tmp6_;
	MetaDisplay* _tmp7_;
	GalaWindowTracker* _tmp8_;
	GalaWindowTracker* _tmp9_;
	GalaWindowTracker* _tmp10_;
	MetaDisplay* _tmp11_;
	MetaDisplay* _tmp12_;
	GalaNotificationStack* _tmp13_;
	GalaScreenSaverManager* _tmp14_;
	MetaDisplay* _tmp15_;
	ClutterActor* _tmp16_;
	GSettings* background_settings = NULL;
	GSettings* _tmp17_;
	gchar* color = NULL;
	GSettings* _tmp18_;
	gchar* _tmp19_;
	ClutterStage* _tmp20_;
	ClutterStage* _tmp21_;
	const gchar* _tmp22_;
	ClutterColor* _tmp23_;
	ClutterColor* _tmp24_;
	ClutterColor _tmp25_;
	MetaLaters* laters = NULL;
	MetaDisplay* _tmp26_;
	MetaCompositor* _tmp27_;
	MetaLaters* _tmp28_;
	MetaLaters* _tmp29_;
	MetaDisplay* _tmp30_;
	GalaSystemBackground* _tmp31_;
	GalaSystemBackground* _tmp32_;
	MetaBackgroundActor* _tmp33_;
	MetaBackgroundActor* _tmp34_;
	ClutterStage* _tmp35_;
	ClutterStage* _tmp36_;
	ClutterBindConstraint* _tmp37_;
	ClutterBindConstraint* _tmp38_;
	ClutterStage* _tmp39_;
	ClutterStage* _tmp40_;
	GalaSystemBackground* _tmp41_;
	MetaBackgroundActor* _tmp42_;
	MetaBackgroundActor* _tmp43_;
	ClutterActor* _tmp44_;
	ClutterActor* _tmp45_;
	ClutterActor* _tmp46_;
	ClutterActor* _tmp47_;
	ClutterStage* _tmp48_;
	ClutterStage* _tmp49_;
	ClutterActor* _tmp50_;
	ClutterActor* _tmp51_;
	MetaDisplay* _tmp52_;
	ClutterActor* _tmp53_;
	ClutterStage* _tmp54_;
	ClutterStage* _tmp55_;
	ClutterActor* _tmp56_;
	ClutterActor* _tmp57_;
	ClutterActor* _tmp58_;
	ClutterActor* _tmp59_;
	ClutterActor* _tmp60_;
	ClutterActor* _tmp61_;
	GalaBackgroundContainer* _tmp62_;
	GalaBackgroundContainer* _tmp63_;
	MetaBackgroundGroup* _tmp64_;
	MetaBackgroundGroup* _tmp65_;
	ClutterActor* _tmp66_;
	ClutterActor* _tmp67_;
	MetaBackgroundGroup* _tmp68_;
	MetaBackgroundGroup* _tmp69_;
	ClutterActor* _tmp70_;
	ClutterActor* _tmp71_;
	MetaBackgroundGroup* _tmp72_;
	MetaBackgroundGroup* _tmp73_;
	MetaDisplay* _tmp74_;
	ClutterActor* _tmp75_;
	ClutterStage* _tmp76_;
	ClutterStage* _tmp77_;
	ClutterActor* _tmp78_;
	ClutterActor* _tmp79_;
	ClutterActor* _tmp80_;
	ClutterActor* _tmp81_;
	ClutterActor* _tmp82_;
	ClutterActor* _tmp83_;
	GSettings* _tmp84_;
	MetaDisplay* _tmp85_;
	GSettings* _tmp86_;
	MetaDisplay* _tmp87_;
	GSettings* _tmp88_;
	MetaDisplay* _tmp89_;
	GSettings* _tmp90_;
	MetaDisplay* _tmp91_;
	GSettings* _tmp92_;
	MetaDisplay* _tmp93_;
	GSettings* _tmp94_;
	MetaDisplay* _tmp95_;
	GSettings* _tmp96_;
	MetaDisplay* _tmp97_;
	GSettings* _tmp98_;
	MetaDisplay* _tmp99_;
	GSettings* _tmp100_;
	MetaDisplay* _tmp101_;
	GSettings* _tmp102_;
	MetaDisplay* _tmp103_;
	GSettings* _tmp104_;
	MetaDisplay* _tmp105_;
	GSettings* _tmp106_;
	MetaDisplay* _tmp107_;
	GSettings* _tmp108_;
	MetaDisplay* _tmp109_;
	GSettings* _tmp110_;
	MetaDisplay* _tmp111_;
	GSettings* _tmp112_;
	MetaDisplay* _tmp113_;
	GSettings* _tmp114_;
	MetaDisplay* _tmp115_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaDisplay* _tmp120_;
	MetaContext* _tmp121_;
	MetaBackend* _tmp122_;
	MetaMonitorManager* _tmp123_;
	GSettings* _tmp124_;
	GalaHotCornerManager* _tmp125_;
	GalaHotCornerManager* _tmp126_;
	GalaHotCornerManager* _tmp127_;
	GalaZoom* _tmp128_;
	MetaLaters* _tmp129_;
	MetaDisplay* _tmp130_;
	ClutterStage* _tmp131_;
	ClutterStage* _tmp132_;
	gboolean result;
#line 177 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "../src/WindowManager.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 177 "../src/WindowManager.vala"
	_data9_->_ref_count_ = 1;
#line 177 "../src/WindowManager.vala"
	_data9_->self = g_object_ref (self);
#line 178 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 178 "../src/WindowManager.vala"
	_data9_->display = _tmp0_;
#line 180 "../src/WindowManager.vala"
	_tmp1_ = gala_screen_shield_new ((GalaWindowManager*) self);
#line 180 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp1_);
#line 180 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 180 "../src/WindowManager.vala"
	gala_window_manager_gala_set_screen_shield (self, _tmp2_);
#line 180 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp2_);
#line 181 "../src/WindowManager.vala"
	_tmp3_ = self->priv->_screen_shield;
#line 181 "../src/WindowManager.vala"
	_tmp4_ = gala_screen_saver_manager_new (_tmp3_);
#line 181 "../src/WindowManager.vala"
	_tmp5_ = _tmp4_;
#line 181 "../src/WindowManager.vala"
	gala_window_manager_gala_set_screensaver (self, _tmp5_);
#line 181 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp5_);
#line 183 "../src/WindowManager.vala"
	gala_dbus_init ((GalaWindowManager*) self);
#line 184 "../src/WindowManager.vala"
	gala_dbus_accelerator_init ((GalaWindowManager*) self);
#line 185 "../src/WindowManager.vala"
	gala_media_feedback_init ();
#line 187 "../src/WindowManager.vala"
	_tmp6_ = _data9_->display;
#line 187 "../src/WindowManager.vala"
	gala_window_listener_init (_tmp6_);
#line 188 "../src/WindowManager.vala"
	_tmp7_ = _data9_->display;
#line 188 "../src/WindowManager.vala"
	gala_keyboard_manager_init (_tmp7_);
#line 189 "../src/WindowManager.vala"
	_tmp8_ = gala_window_tracker_new ();
#line 189 "../src/WindowManager.vala"
	_tmp9_ = _tmp8_;
#line 189 "../src/WindowManager.vala"
	gala_window_manager_gala_set_window_tracker (self, _tmp9_);
#line 189 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp9_);
#line 190 "../src/WindowManager.vala"
	_tmp10_ = self->priv->_window_tracker;
#line 190 "../src/WindowManager.vala"
	_tmp11_ = _data9_->display;
#line 190 "../src/WindowManager.vala"
	gala_window_tracker_init (_tmp10_, _tmp11_);
#line 192 "../src/WindowManager.vala"
	_tmp12_ = _data9_->display;
#line 192 "../src/WindowManager.vala"
	_tmp13_ = gala_notification_stack_new (_tmp12_);
#line 192 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->notification_stack);
#line 192 "../src/WindowManager.vala"
	self->priv->notification_stack = _tmp13_;
#line 197 "../src/WindowManager.vala"
	_tmp14_ = self->priv->_screensaver;
#line 197 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp14_, "active-changed", (GCallback) _gala_window_manager_gala_update_input_area_gala_screen_saver_manager_active_changed, self, 0);
#line 199 "../src/WindowManager.vala"
	_tmp15_ = _data9_->display;
#line 199 "../src/WindowManager.vala"
	_tmp16_ = meta_get_stage_for_display (_tmp15_);
#line 199 "../src/WindowManager.vala"
	gala_window_manager_set_stage ((GalaWindowManager*) self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, clutter_stage_get_type ()) ? ((ClutterStage*) _tmp16_) : NULL);
#line 200 "../src/WindowManager.vala"
	_tmp17_ = g_settings_new ("org.gnome.desktop.background");
#line 200 "../src/WindowManager.vala"
	background_settings = _tmp17_;
#line 201 "../src/WindowManager.vala"
	_tmp18_ = background_settings;
#line 201 "../src/WindowManager.vala"
	_tmp19_ = g_settings_get_string (_tmp18_, "primary-color");
#line 201 "../src/WindowManager.vala"
	color = _tmp19_;
#line 202 "../src/WindowManager.vala"
	_tmp20_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 202 "../src/WindowManager.vala"
	_tmp21_ = _tmp20_;
#line 202 "../src/WindowManager.vala"
	_tmp22_ = color;
#line 202 "../src/WindowManager.vala"
	_tmp23_ = _vala_clutter_color_from_string (_tmp22_);
#line 202 "../src/WindowManager.vala"
	_tmp24_ = _tmp23_;
#line 202 "../src/WindowManager.vala"
	_tmp25_ = *_tmp24_;
#line 202 "../src/WindowManager.vala"
	clutter_actor_set_background_color ((ClutterActor*) _tmp21_, &_tmp25_);
#line 202 "../src/WindowManager.vala"
	__vala_ClutterColor_free0 (_tmp24_);
#line 204 "../src/WindowManager.vala"
	_tmp26_ = _data9_->display;
#line 204 "../src/WindowManager.vala"
	_tmp27_ = meta_display_get_compositor (_tmp26_);
#line 204 "../src/WindowManager.vala"
	_tmp28_ = meta_compositor_get_laters (_tmp27_);
#line 204 "../src/WindowManager.vala"
	laters = _tmp28_;
#line 205 "../src/WindowManager.vala"
	_tmp29_ = laters;
#line 205 "../src/WindowManager.vala"
	meta_laters_add (_tmp29_, META_LATER_BEFORE_REDRAW, ___lambda103__gsource_func, g_object_ref (self), g_object_unref);
#line 227 "../src/WindowManager.vala"
	_tmp30_ = _data9_->display;
#line 227 "../src/WindowManager.vala"
	_tmp31_ = gala_system_background_new (_tmp30_);
#line 227 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->system_background);
#line 227 "../src/WindowManager.vala"
	self->priv->system_background = _tmp31_;
#line 229 "../src/WindowManager.vala"
	_tmp32_ = self->priv->system_background;
#line 229 "../src/WindowManager.vala"
	_tmp33_ = gala_system_background_get_background_actor (_tmp32_);
#line 229 "../src/WindowManager.vala"
	_tmp34_ = _tmp33_;
#line 229 "../src/WindowManager.vala"
	_tmp35_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 229 "../src/WindowManager.vala"
	_tmp36_ = _tmp35_;
#line 229 "../src/WindowManager.vala"
	_tmp37_ = (ClutterBindConstraint*) clutter_bind_constraint_new ((ClutterActor*) _tmp36_, CLUTTER_BIND_ALL, (gfloat) 0);
#line 229 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp37_);
#line 229 "../src/WindowManager.vala"
	_tmp38_ = _tmp37_;
#line 229 "../src/WindowManager.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp34_, (ClutterConstraint*) _tmp38_);
#line 229 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp38_);
#line 231 "../src/WindowManager.vala"
	_tmp39_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 231 "../src/WindowManager.vala"
	_tmp40_ = _tmp39_;
#line 231 "../src/WindowManager.vala"
	_tmp41_ = self->priv->system_background;
#line 231 "../src/WindowManager.vala"
	_tmp42_ = gala_system_background_get_background_actor (_tmp41_);
#line 231 "../src/WindowManager.vala"
	_tmp43_ = _tmp42_;
#line 231 "../src/WindowManager.vala"
	clutter_actor_insert_child_below ((ClutterActor*) _tmp40_, (ClutterActor*) _tmp43_, NULL);
#line 233 "../src/WindowManager.vala"
	_tmp44_ = clutter_actor_new ();
#line 233 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp44_);
#line 233 "../src/WindowManager.vala"
	_tmp45_ = _tmp44_;
#line 233 "../src/WindowManager.vala"
	gala_window_manager_set_ui_group ((GalaWindowManager*) self, _tmp45_);
#line 233 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp45_);
#line 234 "../src/WindowManager.vala"
	_tmp46_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 234 "../src/WindowManager.vala"
	_tmp47_ = _tmp46_;
#line 234 "../src/WindowManager.vala"
	clutter_actor_set_reactive (_tmp47_, TRUE);
#line 235 "../src/WindowManager.vala"
	_tmp48_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 235 "../src/WindowManager.vala"
	_tmp49_ = _tmp48_;
#line 235 "../src/WindowManager.vala"
	_tmp50_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 235 "../src/WindowManager.vala"
	_tmp51_ = _tmp50_;
#line 235 "../src/WindowManager.vala"
	clutter_actor_add_child ((ClutterActor*) _tmp49_, _tmp51_);
#line 237 "../src/WindowManager.vala"
	_tmp52_ = _data9_->display;
#line 237 "../src/WindowManager.vala"
	_tmp53_ = meta_get_window_group_for_display (_tmp52_);
#line 237 "../src/WindowManager.vala"
	gala_window_manager_set_window_group ((GalaWindowManager*) self, _tmp53_);
#line 238 "../src/WindowManager.vala"
	_tmp54_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 238 "../src/WindowManager.vala"
	_tmp55_ = _tmp54_;
#line 238 "../src/WindowManager.vala"
	_tmp56_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 238 "../src/WindowManager.vala"
	_tmp57_ = _tmp56_;
#line 238 "../src/WindowManager.vala"
	clutter_actor_remove_child ((ClutterActor*) _tmp55_, _tmp57_);
#line 239 "../src/WindowManager.vala"
	_tmp58_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 239 "../src/WindowManager.vala"
	_tmp59_ = _tmp58_;
#line 239 "../src/WindowManager.vala"
	_tmp60_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 239 "../src/WindowManager.vala"
	_tmp61_ = _tmp60_;
#line 239 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp59_, _tmp61_);
#line 241 "../src/WindowManager.vala"
	_tmp62_ = gala_background_container_new ((GalaWindowManager*) self);
#line 241 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp62_);
#line 241 "../src/WindowManager.vala"
	_tmp63_ = _tmp62_;
#line 241 "../src/WindowManager.vala"
	gala_window_manager_set_background_group ((GalaWindowManager*) self, (MetaBackgroundGroup*) _tmp63_);
#line 241 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp63_);
#line 242 "../src/WindowManager.vala"
	_tmp64_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 242 "../src/WindowManager.vala"
	_tmp65_ = _tmp64_;
#line 242 "../src/WindowManager.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GALA_TYPE_BACKGROUND_CONTAINER, GalaBackgroundContainer), "show-background-menu", (GCallback) _gala_window_manager_gala_on_show_background_menu_gala_background_container_show_background_menu, self, 0);
#line 243 "../src/WindowManager.vala"
	_tmp66_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 243 "../src/WindowManager.vala"
	_tmp67_ = _tmp66_;
#line 243 "../src/WindowManager.vala"
	_tmp68_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 243 "../src/WindowManager.vala"
	_tmp69_ = _tmp68_;
#line 243 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp67_, (ClutterActor*) _tmp69_);
#line 244 "../src/WindowManager.vala"
	_tmp70_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 244 "../src/WindowManager.vala"
	_tmp71_ = _tmp70_;
#line 244 "../src/WindowManager.vala"
	_tmp72_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 244 "../src/WindowManager.vala"
	_tmp73_ = _tmp72_;
#line 244 "../src/WindowManager.vala"
	clutter_actor_set_child_below_sibling (_tmp71_, (ClutterActor*) _tmp73_, NULL);
#line 246 "../src/WindowManager.vala"
	_tmp74_ = _data9_->display;
#line 246 "../src/WindowManager.vala"
	_tmp75_ = meta_get_top_window_group_for_display (_tmp74_);
#line 246 "../src/WindowManager.vala"
	gala_window_manager_set_top_window_group ((GalaWindowManager*) self, _tmp75_);
#line 247 "../src/WindowManager.vala"
	_tmp76_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 247 "../src/WindowManager.vala"
	_tmp77_ = _tmp76_;
#line 247 "../src/WindowManager.vala"
	_tmp78_ = gala_window_manager_get_top_window_group ((GalaWindowManager*) self);
#line 247 "../src/WindowManager.vala"
	_tmp79_ = _tmp78_;
#line 247 "../src/WindowManager.vala"
	clutter_actor_remove_child ((ClutterActor*) _tmp77_, _tmp79_);
#line 248 "../src/WindowManager.vala"
	_tmp80_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 248 "../src/WindowManager.vala"
	_tmp81_ = _tmp80_;
#line 248 "../src/WindowManager.vala"
	_tmp82_ = gala_window_manager_get_top_window_group ((GalaWindowManager*) self);
#line 248 "../src/WindowManager.vala"
	_tmp83_ = _tmp82_;
#line 248 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp81_, _tmp83_);
#line 250 "../src/WindowManager.vala"
	gala_filter_manager_init ((GalaWindowManager*) self);
#line 253 "../src/WindowManager.vala"
	_tmp84_ = g_settings_new (SCHEMA ".keybindings");
#line 253 "../src/WindowManager.vala"
	_data9_->keybinding_settings = _tmp84_;
#line 255 "../src/WindowManager.vala"
	_tmp85_ = _data9_->display;
#line 255 "../src/WindowManager.vala"
	_tmp86_ = _data9_->keybinding_settings;
#line 255 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp85_, "switch-to-workspace-first", _tmp86_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_switch_to_workspace_end, g_object_ref (self), g_object_unref);
#line 256 "../src/WindowManager.vala"
	_tmp87_ = _data9_->display;
#line 256 "../src/WindowManager.vala"
	_tmp88_ = _data9_->keybinding_settings;
#line 256 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp87_, "switch-to-workspace-last", _tmp88_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_switch_to_workspace_end, g_object_ref (self), g_object_unref);
#line 257 "../src/WindowManager.vala"
	_tmp89_ = _data9_->display;
#line 257 "../src/WindowManager.vala"
	_tmp90_ = _data9_->keybinding_settings;
#line 257 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp89_, "move-to-workspace-first", _tmp90_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_move_to_workspace_end, g_object_ref (self), g_object_unref);
#line 258 "../src/WindowManager.vala"
	_tmp91_ = _data9_->display;
#line 258 "../src/WindowManager.vala"
	_tmp92_ = _data9_->keybinding_settings;
#line 258 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp91_, "move-to-workspace-last", _tmp92_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_move_to_workspace_end, g_object_ref (self), g_object_unref);
#line 259 "../src/WindowManager.vala"
	_tmp93_ = _data9_->display;
#line 259 "../src/WindowManager.vala"
	_tmp94_ = _data9_->keybinding_settings;
#line 259 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp93_, "cycle-workspaces-next", _tmp94_, META_KEY_BINDING_NONE, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_cycle_workspaces, g_object_ref (self), g_object_unref);
#line 260 "../src/WindowManager.vala"
	_tmp95_ = _data9_->display;
#line 260 "../src/WindowManager.vala"
	_tmp96_ = _data9_->keybinding_settings;
#line 260 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp95_, "cycle-workspaces-previous", _tmp96_, META_KEY_BINDING_NONE, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_cycle_workspaces, g_object_ref (self), g_object_unref);
#line 261 "../src/WindowManager.vala"
	_tmp97_ = _data9_->display;
#line 261 "../src/WindowManager.vala"
	_tmp98_ = _data9_->keybinding_settings;
#line 261 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp97_, "panel-main-menu", _tmp98_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_applications_menu, g_object_ref (self), g_object_unref);
#line 262 "../src/WindowManager.vala"
	_tmp99_ = _data9_->display;
#line 262 "../src/WindowManager.vala"
	_tmp100_ = _data9_->keybinding_settings;
#line 262 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp99_, "switch-input-source", _tmp100_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_switch_input_source, g_object_ref (self), g_object_unref);
#line 263 "../src/WindowManager.vala"
	_tmp101_ = _data9_->display;
#line 263 "../src/WindowManager.vala"
	_tmp102_ = _data9_->keybinding_settings;
#line 263 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp101_, "switch-input-source-backward", _tmp102_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_switch_input_source, g_object_ref (self), g_object_unref);
#line 265 "../src/WindowManager.vala"
	_tmp103_ = _data9_->display;
#line 265 "../src/WindowManager.vala"
	_tmp104_ = _data9_->keybinding_settings;
#line 265 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp103_, "screenshot", _tmp104_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_screenshot, g_object_ref (self), g_object_unref);
#line 266 "../src/WindowManager.vala"
	_tmp105_ = _data9_->display;
#line 266 "../src/WindowManager.vala"
	_tmp106_ = _data9_->keybinding_settings;
#line 266 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp105_, "window-screenshot", _tmp106_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_screenshot, g_object_ref (self), g_object_unref);
#line 267 "../src/WindowManager.vala"
	_tmp107_ = _data9_->display;
#line 267 "../src/WindowManager.vala"
	_tmp108_ = _data9_->keybinding_settings;
#line 267 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp107_, "area-screenshot", _tmp108_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_screenshot, g_object_ref (self), g_object_unref);
#line 268 "../src/WindowManager.vala"
	_tmp109_ = _data9_->display;
#line 268 "../src/WindowManager.vala"
	_tmp110_ = _data9_->keybinding_settings;
#line 268 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp109_, "screenshot-clip", _tmp110_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_screenshot, g_object_ref (self), g_object_unref);
#line 269 "../src/WindowManager.vala"
	_tmp111_ = _data9_->display;
#line 269 "../src/WindowManager.vala"
	_tmp112_ = _data9_->keybinding_settings;
#line 269 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp111_, "window-screenshot-clip", _tmp112_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_screenshot, g_object_ref (self), g_object_unref);
#line 270 "../src/WindowManager.vala"
	_tmp113_ = _data9_->display;
#line 270 "../src/WindowManager.vala"
	_tmp114_ = _data9_->keybinding_settings;
#line 270 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp113_, "area-screenshot-clip", _tmp114_, META_KEY_BINDING_IGNORE_AUTOREPEAT, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_screenshot, g_object_ref (self), g_object_unref);
#line 272 "../src/WindowManager.vala"
	_tmp115_ = _data9_->display;
#line 272 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp115_, "overlay-key", (GCallback) ___lambda117__meta_display_overlay_key, self, 0);
#line 276 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("toggle-recording", ___lambda118__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 280 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("switch-to-workspace-up", ___lambda119__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 281 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("switch-to-workspace-down", ___lambda120__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 282 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("switch-to-workspace-left", (MetaKeyHandlerFunc) gala_window_manager_gala_handle_switch_to_workspace, g_object_ref (self), g_object_unref);
#line 283 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("switch-to-workspace-right", (MetaKeyHandlerFunc) gala_window_manager_gala_handle_switch_to_workspace, g_object_ref (self), g_object_unref);
#line 285 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("move-to-workspace-up", ___lambda123__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 286 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("move-to-workspace-down", ___lambda124__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 287 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("move-to-workspace-left", (MetaKeyHandlerFunc) gala_window_manager_gala_handle_move_to_workspace, g_object_ref (self), g_object_unref);
#line 288 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("move-to-workspace-right", (MetaKeyHandlerFunc) gala_window_manager_gala_handle_move_to_workspace, g_object_ref (self), g_object_unref);
#line 3823 "WindowManager.c"
	{
		gint i = 0;
#line 290 "../src/WindowManager.vala"
		i = 1;
#line 3828 "WindowManager.c"
		{
			gboolean _tmp116_ = FALSE;
#line 290 "../src/WindowManager.vala"
			_tmp116_ = TRUE;
#line 290 "../src/WindowManager.vala"
			while (TRUE) {
#line 3835 "WindowManager.c"
				gchar* _tmp118_;
				gchar* _tmp119_;
#line 290 "../src/WindowManager.vala"
				if (!_tmp116_) {
#line 3840 "WindowManager.c"
					gint _tmp117_;
#line 290 "../src/WindowManager.vala"
					_tmp117_ = i;
#line 290 "../src/WindowManager.vala"
					i = _tmp117_ + 1;
#line 3846 "WindowManager.c"
				}
#line 290 "../src/WindowManager.vala"
				_tmp116_ = FALSE;
#line 290 "../src/WindowManager.vala"
				if (!(i < 13)) {
#line 290 "../src/WindowManager.vala"
					break;
#line 3854 "WindowManager.c"
				}
#line 291 "../src/WindowManager.vala"
				_tmp118_ = g_strdup_printf ("move-to-workspace-%d", i);
#line 291 "../src/WindowManager.vala"
				_tmp119_ = _tmp118_;
#line 291 "../src/WindowManager.vala"
				meta_keybindings_set_custom_handler (_tmp119_, (MetaKeyHandlerFunc) gala_window_manager_gala_handle_move_to_workspace, g_object_ref (self), g_object_unref);
#line 291 "../src/WindowManager.vala"
				_g_free0 (_tmp119_);
#line 3864 "WindowManager.c"
			}
		}
	}
#line 294 "../src/WindowManager.vala"
	_tmp120_ = _data9_->display;
#line 294 "../src/WindowManager.vala"
	_tmp121_ = meta_display_get_context (_tmp120_);
#line 294 "../src/WindowManager.vala"
	_tmp122_ = meta_context_get_backend (_tmp121_);
#line 294 "../src/WindowManager.vala"
	_tmp123_ = meta_backend_get_monitor_manager (_tmp122_);
#line 294 "../src/WindowManager.vala"
	monitor_manager = _tmp123_;
#line 295 "../src/WindowManager.vala"
	g_signal_connect_object (monitor_manager, "monitors-changed", (GCallback) _gala_window_manager_gala_on_monitors_changed_meta_monitor_manager_monitors_changed, self, 0);
#line 297 "../src/WindowManager.vala"
	_tmp124_ = self->priv->behavior_settings;
#line 297 "../src/WindowManager.vala"
	_tmp125_ = gala_hot_corner_manager_new ((GalaWindowManager*) self, _tmp124_);
#line 297 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->hot_corner_manager);
#line 297 "../src/WindowManager.vala"
	self->priv->hot_corner_manager = _tmp125_;
#line 298 "../src/WindowManager.vala"
	_tmp126_ = self->priv->hot_corner_manager;
#line 298 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp126_, "on-configured", (GCallback) _gala_window_manager_gala_update_input_area_gala_hot_corner_manager_on_configured, self, 0);
#line 299 "../src/WindowManager.vala"
	_tmp127_ = self->priv->hot_corner_manager;
#line 299 "../src/WindowManager.vala"
	gala_hot_corner_manager_configure (_tmp127_);
#line 301 "../src/WindowManager.vala"
	_tmp128_ = gala_zoom_new ((GalaWindowManager*) self);
#line 301 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->zoom);
#line 301 "../src/WindowManager.vala"
	self->priv->zoom = _tmp128_;
#line 305 "../src/WindowManager.vala"
	_tmp129_ = laters;
#line 305 "../src/WindowManager.vala"
	meta_laters_add (_tmp129_, META_LATER_BEFORE_REDRAW, ___lambda125__gsource_func, block9_data_ref (_data9_), block9_data_unref);
#line 382 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area (self);
#line 385 "../src/WindowManager.vala"
	_tmp130_ = _data9_->display;
#line 385 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp130_, "window-created", (GCallback) ___lambda134__meta_display_window_created, self, 0);
#line 387 "../src/WindowManager.vala"
	_tmp131_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 387 "../src/WindowManager.vala"
	_tmp132_ = _tmp131_;
#line 387 "../src/WindowManager.vala"
	clutter_actor_show ((ClutterActor*) _tmp132_);
#line 389 "../src/WindowManager.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda135__gsource_func, block9_data_ref (_data9_), block9_data_unref);
#line 398 "../src/WindowManager.vala"
	result = FALSE;
#line 398 "../src/WindowManager.vala"
	_g_free0 (color);
#line 398 "../src/WindowManager.vala"
	_g_object_unref0 (background_settings);
#line 398 "../src/WindowManager.vala"
	block9_data_unref (_data9_);
#line 398 "../src/WindowManager.vala"
	_data9_ = NULL;
#line 398 "../src/WindowManager.vala"
	return result;
#line 3932 "WindowManager.c"
}

static void
gala_window_manager_gala_launch_action (GalaWindowManagerGala* self,
                                        const gchar* action_key)
{
	GError* _inner_error0_ = NULL;
#line 401 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 401 "../src/WindowManager.vala"
	g_return_if_fail (action_key != NULL);
#line 3944 "WindowManager.c"
	{
		gchar* action = NULL;
		GSettings* _tmp0_;
		gchar* _tmp1_;
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp3_;
#line 403 "../src/WindowManager.vala"
		_tmp0_ = self->priv->behavior_settings;
#line 403 "../src/WindowManager.vala"
		_tmp1_ = g_settings_get_string (_tmp0_, action_key);
#line 403 "../src/WindowManager.vala"
		action = _tmp1_;
#line 404 "../src/WindowManager.vala"
		_tmp3_ = action;
#line 404 "../src/WindowManager.vala"
		if (_tmp3_ != NULL) {
#line 3961 "WindowManager.c"
			const gchar* _tmp4_;
#line 404 "../src/WindowManager.vala"
			_tmp4_ = action;
#line 404 "../src/WindowManager.vala"
			_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 3967 "WindowManager.c"
		} else {
#line 404 "../src/WindowManager.vala"
			_tmp2_ = FALSE;
#line 3971 "WindowManager.c"
		}
#line 404 "../src/WindowManager.vala"
		if (_tmp2_) {
#line 3975 "WindowManager.c"
			const gchar* _tmp5_;
#line 405 "../src/WindowManager.vala"
			_tmp5_ = action;
#line 405 "../src/WindowManager.vala"
			g_spawn_command_line_async (_tmp5_, &_inner_error0_);
#line 405 "../src/WindowManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 405 "../src/WindowManager.vala"
				_g_free0 (action);
#line 3985 "WindowManager.c"
				goto __catch0_g_error;
			}
		}
#line 402 "../src/WindowManager.vala"
		_g_free0 (action);
#line 3991 "WindowManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 402 "../src/WindowManager.vala"
		e = _inner_error0_;
#line 402 "../src/WindowManager.vala"
		_inner_error0_ = NULL;
#line 407 "../src/WindowManager.vala"
		_tmp6_ = e;
#line 407 "../src/WindowManager.vala"
		_tmp7_ = _tmp6_->message;
#line 407 "../src/WindowManager.vala"
		g_warning ("WindowManager.vala:407: %s", _tmp7_);
#line 402 "../src/WindowManager.vala"
		_g_error_free0 (e);
#line 4011 "WindowManager.c"
	}
	__finally0:
#line 402 "../src/WindowManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 402 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 402 "../src/WindowManager.vala"
		g_clear_error (&_inner_error0_);
#line 402 "../src/WindowManager.vala"
		return;
#line 4022 "WindowManager.c"
	}
}

static void
__lambda105_ (GalaWindowManagerGala* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 415 "../src/WindowManager.vala"
	g_return_if_fail (res != NULL);
#line 4034 "WindowManager.c"
	{
#line 417 "../src/WindowManager.vala"
		gala_daemon_show_desktop_menu_finish (G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DAEMON, GalaDaemon), res, &_inner_error0_);
#line 417 "../src/WindowManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4040 "WindowManager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 416 "../src/WindowManager.vala"
		e = _inner_error0_;
#line 416 "../src/WindowManager.vala"
		_inner_error0_ = NULL;
#line 419 "../src/WindowManager.vala"
		_tmp0_ = e;
#line 419 "../src/WindowManager.vala"
		_tmp1_ = _tmp0_->message;
#line 419 "../src/WindowManager.vala"
		g_message ("WindowManager.vala:419: Error invoking MenuManager: %s", _tmp1_);
#line 416 "../src/WindowManager.vala"
		_g_error_free0 (e);
#line 4062 "WindowManager.c"
	}
	__finally0:
#line 416 "../src/WindowManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 416 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 416 "../src/WindowManager.vala"
		g_clear_error (&_inner_error0_);
#line 416 "../src/WindowManager.vala"
		return;
#line 4073 "WindowManager.c"
	}
}

static void
___lambda105__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 415 "../src/WindowManager.vala"
	__lambda105_ ((GalaWindowManagerGala*) self, source_object, res);
#line 415 "../src/WindowManager.vala"
	g_object_unref (self);
#line 4086 "WindowManager.c"
}

static void
gala_window_manager_gala_on_show_background_menu (GalaWindowManagerGala* self,
                                                  gint x,
                                                  gint y)
{
	GalaDaemon* _tmp0_;
	GalaDaemon* _tmp1_;
#line 410 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 411 "../src/WindowManager.vala"
	_tmp0_ = self->priv->daemon_proxy;
#line 411 "../src/WindowManager.vala"
	if (_tmp0_ == NULL) {
#line 412 "../src/WindowManager.vala"
		return;
#line 4104 "WindowManager.c"
	}
#line 415 "../src/WindowManager.vala"
	_tmp1_ = self->priv->daemon_proxy;
#line 415 "../src/WindowManager.vala"
	gala_daemon_show_desktop_menu (_tmp1_, x, y, ___lambda105__gasync_ready_callback, g_object_ref (self));
#line 4110 "WindowManager.c"
}

static void
gala_window_manager_gala_on_monitors_changed (GalaWindowManagerGala* self)
{
	GalaScreenShield* _tmp0_;
#line 424 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_screen_shield;
#line 425 "../src/WindowManager.vala"
	gala_screen_shield_expand_to_screen_size (_tmp0_);
#line 4123 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_cycle_workspaces (MetaDisplay* display,
                                                  MetaWindow* window,
                                                  ClutterKeyEvent* event,
                                                  MetaKeyBinding* binding,
                                                  GalaWindowManagerGala* self)
{
	gint _tmp0_ = 0;
	const gchar* _tmp1_;
	gint direction = 0;
	MetaWorkspaceManager* manager = NULL;
	MetaWorkspaceManager* _tmp2_;
	gint index = 0;
	MetaWorkspaceManager* _tmp3_;
	gint _tmp4_ = 0;
	gint dynamic_offset = 0;
	MetaWorkspaceManager* _tmp7_;
	MetaWorkspace* _tmp8_;
#line 429 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 429 "../src/WindowManager.vala"
	g_return_if_fail (event != NULL);
#line 429 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 431 "../src/WindowManager.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 431 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp1_, "cycle-workspaces-next") == 0) {
#line 431 "../src/WindowManager.vala"
		_tmp0_ = 1;
#line 4158 "WindowManager.c"
	} else {
#line 431 "../src/WindowManager.vala"
		_tmp0_ = -1;
#line 4162 "WindowManager.c"
	}
#line 431 "../src/WindowManager.vala"
	direction = _tmp0_;
#line 432 "../src/WindowManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (display);
#line 432 "../src/WindowManager.vala"
	manager = _tmp2_;
#line 433 "../src/WindowManager.vala"
	_tmp3_ = manager;
#line 433 "../src/WindowManager.vala"
	index = meta_workspace_manager_get_active_workspace_index (_tmp3_) + direction;
#line 435 "../src/WindowManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 435 "../src/WindowManager.vala"
		_tmp4_ = 1;
#line 4178 "WindowManager.c"
	} else {
#line 435 "../src/WindowManager.vala"
		_tmp4_ = 0;
#line 4182 "WindowManager.c"
	}
#line 435 "../src/WindowManager.vala"
	dynamic_offset = _tmp4_;
#line 437 "../src/WindowManager.vala"
	if (index < 0) {
#line 4188 "WindowManager.c"
		MetaWorkspaceManager* _tmp5_;
#line 438 "../src/WindowManager.vala"
		_tmp5_ = manager;
#line 438 "../src/WindowManager.vala"
		index = (meta_workspace_manager_get_n_workspaces (_tmp5_) - 1) - dynamic_offset;
#line 4194 "WindowManager.c"
	} else {
		MetaWorkspaceManager* _tmp6_;
#line 439 "../src/WindowManager.vala"
		_tmp6_ = manager;
#line 439 "../src/WindowManager.vala"
		if (index > ((meta_workspace_manager_get_n_workspaces (_tmp6_) - 1) - dynamic_offset)) {
#line 440 "../src/WindowManager.vala"
			index = 0;
#line 4203 "WindowManager.c"
		}
	}
#line 442 "../src/WindowManager.vala"
	_tmp7_ = manager;
#line 442 "../src/WindowManager.vala"
	_tmp8_ = meta_workspace_manager_get_workspace_by_index (_tmp7_, index);
#line 442 "../src/WindowManager.vala"
	meta_workspace_activate (_tmp8_, meta_display_get_current_time (display));
#line 4212 "WindowManager.c"
}

static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result;
#line 1322 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1323 "glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1323 "glib-2.0.vapi"
	return result;
#line 4226 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_move_to_workspace (MetaDisplay* display,
                                                   MetaWindow* window,
                                                   ClutterKeyEvent* event,
                                                   MetaKeyBinding* binding,
                                                   GalaWindowManagerGala* self)
{
	const gchar* name = NULL;
	const gchar* _tmp0_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaWorkspaceManager* _tmp1_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* target_workspace = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	MetaWorkspace* _tmp17_;
#line 446 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 446 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 446 "../src/WindowManager.vala"
	g_return_if_fail (event != NULL);
#line 446 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 448 "../src/WindowManager.vala"
	if (window == NULL) {
#line 449 "../src/WindowManager.vala"
		return;
#line 4259 "WindowManager.c"
	}
#line 452 "../src/WindowManager.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 452 "../src/WindowManager.vala"
	name = _tmp0_;
#line 453 "../src/WindowManager.vala"
	_tmp1_ = meta_display_get_workspace_manager (display);
#line 453 "../src/WindowManager.vala"
	workspace_manager = _tmp1_;
#line 454 "../src/WindowManager.vala"
	_tmp2_ = workspace_manager;
#line 454 "../src/WindowManager.vala"
	_tmp3_ = meta_workspace_manager_get_active_workspace (_tmp2_);
#line 454 "../src/WindowManager.vala"
	active_workspace = _tmp3_;
#line 455 "../src/WindowManager.vala"
	target_workspace = NULL;
#line 457 "../src/WindowManager.vala"
	_tmp5_ = name;
#line 457 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp5_, "move-to-workspace-left") == 0) {
#line 457 "../src/WindowManager.vala"
		_tmp4_ = TRUE;
#line 4283 "WindowManager.c"
	} else {
		const gchar* _tmp6_;
#line 457 "../src/WindowManager.vala"
		_tmp6_ = name;
#line 457 "../src/WindowManager.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, "move-to-workspace-right") == 0;
#line 4290 "WindowManager.c"
	}
#line 457 "../src/WindowManager.vala"
	if (_tmp4_) {
#line 4294 "WindowManager.c"
		MetaMotionDirection _tmp7_ = 0;
		const gchar* _tmp8_;
		MetaMotionDirection direction = 0;
		MetaWorkspace* _tmp9_;
		MetaWorkspace* _tmp10_;
#line 458 "../src/WindowManager.vala"
		_tmp8_ = name;
#line 458 "../src/WindowManager.vala"
		if (g_strcmp0 (_tmp8_, "move-to-workspace-left") == 0) {
#line 458 "../src/WindowManager.vala"
			_tmp7_ = META_MOTION_LEFT;
#line 4306 "WindowManager.c"
		} else {
#line 458 "../src/WindowManager.vala"
			_tmp7_ = META_MOTION_RIGHT;
#line 4310 "WindowManager.c"
		}
#line 458 "../src/WindowManager.vala"
		direction = _tmp7_;
#line 459 "../src/WindowManager.vala"
		_tmp9_ = active_workspace;
#line 459 "../src/WindowManager.vala"
		_tmp10_ = meta_workspace_get_neighbor (_tmp9_, direction);
#line 459 "../src/WindowManager.vala"
		target_workspace = _tmp10_;
#line 4320 "WindowManager.c"
	} else {
		gint workspace_number = 0;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		const gchar* _tmp14_;
		gint workspace_index = 0;
		MetaWorkspaceManager* _tmp15_;
		MetaWorkspace* _tmp16_;
#line 461 "../src/WindowManager.vala"
		_tmp11_ = name;
#line 461 "../src/WindowManager.vala"
		_tmp12_ = strlen ("move-to-workspace-");
#line 461 "../src/WindowManager.vala"
		_tmp13_ = _tmp12_;
#line 461 "../src/WindowManager.vala"
		_tmp14_ = string_offset (_tmp11_, (glong) _tmp13_);
#line 461 "../src/WindowManager.vala"
		workspace_number = atoi (_tmp14_);
#line 462 "../src/WindowManager.vala"
		workspace_index = workspace_number - 1;
#line 463 "../src/WindowManager.vala"
		_tmp15_ = workspace_manager;
#line 463 "../src/WindowManager.vala"
		_tmp16_ = meta_workspace_manager_get_workspace_by_index (_tmp15_, workspace_index);
#line 463 "../src/WindowManager.vala"
		target_workspace = _tmp16_;
#line 4348 "WindowManager.c"
	}
#line 466 "../src/WindowManager.vala"
	_tmp17_ = target_workspace;
#line 466 "../src/WindowManager.vala"
	if (_tmp17_ != NULL) {
#line 4354 "WindowManager.c"
		MetaWorkspace* _tmp18_;
#line 467 "../src/WindowManager.vala"
		_tmp18_ = target_workspace;
#line 467 "../src/WindowManager.vala"
		gala_window_manager_move_window ((GalaWindowManager*) self, window, _tmp18_);
#line 4360 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_handle_move_to_workspace_end (MetaDisplay* display,
                                                       MetaWindow* window,
                                                       ClutterKeyEvent* event,
                                                       MetaKeyBinding* binding,
                                                       GalaWindowManagerGala* self)
{
	MetaWorkspaceManager* manager = NULL;
	MetaWorkspaceManager* _tmp0_;
	gint _tmp1_ = 0;
	const gchar* _tmp2_;
	gint index = 0;
	MetaWorkspace* workspace = NULL;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	MetaWorkspace* _tmp6_;
	MetaWorkspace* _tmp7_;
#line 472 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 472 "../src/WindowManager.vala"
	g_return_if_fail (event != NULL);
#line 472 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 474 "../src/WindowManager.vala"
	if (window == NULL) {
#line 475 "../src/WindowManager.vala"
		return;
#line 4393 "WindowManager.c"
	}
#line 477 "../src/WindowManager.vala"
	_tmp0_ = meta_display_get_workspace_manager (display);
#line 477 "../src/WindowManager.vala"
	manager = _tmp0_;
#line 478 "../src/WindowManager.vala"
	_tmp2_ = meta_key_binding_get_name (binding);
#line 478 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp2_, "move-to-workspace-first") == 0) {
#line 478 "../src/WindowManager.vala"
		_tmp1_ = 0;
#line 4405 "WindowManager.c"
	} else {
		MetaWorkspaceManager* _tmp3_;
#line 478 "../src/WindowManager.vala"
		_tmp3_ = manager;
#line 478 "../src/WindowManager.vala"
		_tmp1_ = meta_workspace_manager_get_n_workspaces (_tmp3_) - 1;
#line 4412 "WindowManager.c"
	}
#line 478 "../src/WindowManager.vala"
	index = _tmp1_;
#line 479 "../src/WindowManager.vala"
	_tmp4_ = manager;
#line 479 "../src/WindowManager.vala"
	_tmp5_ = meta_workspace_manager_get_workspace_by_index (_tmp4_, index);
#line 479 "../src/WindowManager.vala"
	workspace = _tmp5_;
#line 480 "../src/WindowManager.vala"
	_tmp6_ = workspace;
#line 480 "../src/WindowManager.vala"
	meta_window_change_workspace (window, _tmp6_);
#line 481 "../src/WindowManager.vala"
	_tmp7_ = workspace;
#line 481 "../src/WindowManager.vala"
	meta_workspace_activate_with_focus (_tmp7_, window, meta_display_get_current_time (display));
#line 4430 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_switch_to_workspace (MetaDisplay* display,
                                                     MetaWindow* window,
                                                     ClutterKeyEvent* event,
                                                     MetaKeyBinding* binding,
                                                     GalaWindowManagerGala* self)
{
	MetaMotionDirection _tmp0_ = 0;
	const gchar* _tmp1_;
	MetaMotionDirection direction = 0;
#line 485 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 485 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 485 "../src/WindowManager.vala"
	g_return_if_fail (event != NULL);
#line 485 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 487 "../src/WindowManager.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 487 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp1_, "switch-to-workspace-left") == 0) {
#line 487 "../src/WindowManager.vala"
		_tmp0_ = META_MOTION_LEFT;
#line 4457 "WindowManager.c"
	} else {
#line 487 "../src/WindowManager.vala"
		_tmp0_ = META_MOTION_RIGHT;
#line 4461 "WindowManager.c"
	}
#line 487 "../src/WindowManager.vala"
	direction = _tmp0_;
#line 488 "../src/WindowManager.vala"
	gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, direction);
#line 4467 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_switch_to_workspace_end (MetaDisplay* display,
                                                         MetaWindow* window,
                                                         ClutterKeyEvent* event,
                                                         MetaKeyBinding* binding,
                                                         GalaWindowManagerGala* self)
{
	MetaWorkspaceManager* manager = NULL;
	MetaWorkspaceManager* _tmp0_;
	gint _tmp1_ = 0;
	const gchar* _tmp2_;
	gint index = 0;
	MetaWorkspaceManager* _tmp6_;
	MetaWorkspace* _tmp7_;
#line 492 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 492 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 492 "../src/WindowManager.vala"
	g_return_if_fail (event != NULL);
#line 492 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 494 "../src/WindowManager.vala"
	_tmp0_ = meta_display_get_workspace_manager (display);
#line 494 "../src/WindowManager.vala"
	manager = _tmp0_;
#line 495 "../src/WindowManager.vala"
	_tmp2_ = meta_key_binding_get_name (binding);
#line 495 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp2_, "switch-to-workspace-first") == 0) {
#line 495 "../src/WindowManager.vala"
		_tmp1_ = 0;
#line 4502 "WindowManager.c"
	} else {
		MetaWorkspaceManager* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 495 "../src/WindowManager.vala"
		_tmp3_ = manager;
#line 495 "../src/WindowManager.vala"
		_tmp4_ = meta_workspace_manager_get_n_workspaces (_tmp3_);
#line 495 "../src/WindowManager.vala"
		_tmp5_ = _tmp4_;
#line 495 "../src/WindowManager.vala"
		_tmp1_ = _tmp5_ - 1;
#line 4515 "WindowManager.c"
	}
#line 495 "../src/WindowManager.vala"
	index = _tmp1_;
#line 496 "../src/WindowManager.vala"
	_tmp6_ = manager;
#line 496 "../src/WindowManager.vala"
	_tmp7_ = meta_workspace_manager_get_workspace_by_index (_tmp6_, index);
#line 496 "../src/WindowManager.vala"
	meta_workspace_activate (_tmp7_, meta_display_get_current_time (display));
#line 4525 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_applications_menu (MetaDisplay* display,
                                                   MetaWindow* window,
                                                   ClutterKeyEvent* event,
                                                   MetaKeyBinding* binding,
                                                   GalaWindowManagerGala* self)
{
#line 500 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 500 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 500 "../src/WindowManager.vala"
	g_return_if_fail (event != NULL);
#line 500 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 502 "../src/WindowManager.vala"
	gala_window_manager_gala_launch_action (self, "panel-main-menu-action");
#line 4545 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_switch_input_source (MetaDisplay* display,
                                                     MetaWindow* window,
                                                     ClutterKeyEvent* event,
                                                     MetaKeyBinding* binding,
                                                     GalaWindowManagerGala* self)
{
	const gchar* _tmp0_;
#line 506 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 506 "../src/WindowManager.vala"
	g_return_if_fail (event != NULL);
#line 506 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 508 "../src/WindowManager.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 508 "../src/WindowManager.vala"
	gala_keyboard_manager_handle_modifiers_accelerator_activated (display, g_str_has_suffix (_tmp0_, "-backward"));
#line 4568 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_screenshot (MetaDisplay* display,
                                            MetaWindow* window,
                                            ClutterKeyEvent* event,
                                            MetaKeyBinding* binding,
                                            GalaWindowManagerGala* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 514 "../src/WindowManager.vala"
	static GQuark _tmp2_label0 = 0;
#line 514 "../src/WindowManager.vala"
	static GQuark _tmp2_label1 = 0;
#line 514 "../src/WindowManager.vala"
	static GQuark _tmp2_label2 = 0;
#line 514 "../src/WindowManager.vala"
	static GQuark _tmp2_label3 = 0;
#line 514 "../src/WindowManager.vala"
	static GQuark _tmp2_label4 = 0;
#line 514 "../src/WindowManager.vala"
	static GQuark _tmp2_label5 = 0;
#line 512 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 512 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 512 "../src/WindowManager.vala"
	g_return_if_fail (event != NULL);
#line 512 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 514 "../src/WindowManager.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 514 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 514 "../src/WindowManager.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 514 "../src/WindowManager.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("screenshot")))) {
#line 514 "../src/WindowManager.vala"
		switch (0) {
#line 4611 "WindowManager.c"
			default:
			{
#line 516 "../src/WindowManager.vala"
				gala_window_manager_gala_screenshot_screen (self, FALSE, NULL, NULL);
#line 517 "../src/WindowManager.vala"
				break;
#line 4618 "WindowManager.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("area-screenshot")))) {
#line 514 "../src/WindowManager.vala"
		switch (0) {
#line 4624 "WindowManager.c"
			default:
			{
#line 519 "../src/WindowManager.vala"
				gala_window_manager_gala_screenshot_area (self, FALSE, NULL, NULL);
#line 520 "../src/WindowManager.vala"
				break;
#line 4631 "WindowManager.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("window-screenshot")))) {
#line 514 "../src/WindowManager.vala"
		switch (0) {
#line 4637 "WindowManager.c"
			default:
			{
#line 522 "../src/WindowManager.vala"
				gala_window_manager_gala_screenshot_current_window (self, FALSE, NULL, NULL);
#line 523 "../src/WindowManager.vala"
				break;
#line 4644 "WindowManager.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("screenshot-clip")))) {
#line 514 "../src/WindowManager.vala"
		switch (0) {
#line 4650 "WindowManager.c"
			default:
			{
#line 525 "../src/WindowManager.vala"
				gala_window_manager_gala_screenshot_screen (self, TRUE, NULL, NULL);
#line 526 "../src/WindowManager.vala"
				break;
#line 4657 "WindowManager.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("area-screenshot-clip")))) {
#line 514 "../src/WindowManager.vala"
		switch (0) {
#line 4663 "WindowManager.c"
			default:
			{
#line 528 "../src/WindowManager.vala"
				gala_window_manager_gala_screenshot_area (self, TRUE, NULL, NULL);
#line 529 "../src/WindowManager.vala"
				break;
#line 4670 "WindowManager.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("window-screenshot-clip")))) {
#line 514 "../src/WindowManager.vala"
		switch (0) {
#line 4676 "WindowManager.c"
			default:
			{
#line 531 "../src/WindowManager.vala"
				gala_window_manager_gala_screenshot_current_window (self, TRUE, NULL, NULL);
#line 532 "../src/WindowManager.vala"
				break;
#line 4683 "WindowManager.c"
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 575 "../src/WindowManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 4694 "WindowManager.c"
}

static void
gala_window_manager_gala_on_gesture_detected (GalaWindowManagerGala* self,
                                              GalaGesture* gesture)
{
	GalaActivatableComponent* _tmp0_;
	GalaActivatableComponent* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean can_handle_swipe = FALSE;
	gint fingers = 0;
	gchar* three_finger_swipe_horizontal = NULL;
	gchar* _tmp4_;
	gchar* four_finger_swipe_horizontal = NULL;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean three_fingers_switch_to_workspace = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean four_fingers_switch_to_workspace = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean three_fingers_move_to_workspace = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean four_fingers_move_to_workspace = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp20_ = FALSE;
#line 536 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 536 "../src/WindowManager.vala"
	g_return_if_fail (gesture != NULL);
#line 537 "../src/WindowManager.vala"
	_tmp0_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 537 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 537 "../src/WindowManager.vala"
	if (gala_activatable_component_is_opened (_tmp1_)) {
#line 538 "../src/WindowManager.vala"
		return;
#line 4732 "WindowManager.c"
	}
#line 541 "../src/WindowManager.vala"
	if (gesture->type == CLUTTER_TOUCHPAD_SWIPE) {
#line 4736 "WindowManager.c"
		gboolean _tmp3_ = FALSE;
#line 543 "../src/WindowManager.vala"
		if (gesture->direction == GALA_GESTURE_DIRECTION_LEFT) {
#line 543 "../src/WindowManager.vala"
			_tmp3_ = TRUE;
#line 4742 "WindowManager.c"
		} else {
#line 543 "../src/WindowManager.vala"
			_tmp3_ = gesture->direction == GALA_GESTURE_DIRECTION_RIGHT;
#line 4746 "WindowManager.c"
		}
#line 543 "../src/WindowManager.vala"
		_tmp2_ = _tmp3_;
#line 4750 "WindowManager.c"
	} else {
#line 542 "../src/WindowManager.vala"
		_tmp2_ = FALSE;
#line 4754 "WindowManager.c"
	}
#line 541 "../src/WindowManager.vala"
	can_handle_swipe = _tmp2_;
#line 546 "../src/WindowManager.vala"
	if (!can_handle_swipe) {
#line 547 "../src/WindowManager.vala"
		return;
#line 4762 "WindowManager.c"
	}
#line 550 "../src/WindowManager.vala"
	fingers = gesture->fingers;
#line 552 "../src/WindowManager.vala"
	_tmp4_ = gala_gesture_settings_get_string ("three-finger-swipe-horizontal");
#line 552 "../src/WindowManager.vala"
	three_finger_swipe_horizontal = _tmp4_;
#line 553 "../src/WindowManager.vala"
	_tmp5_ = gala_gesture_settings_get_string ("four-finger-swipe-horizontal");
#line 553 "../src/WindowManager.vala"
	four_finger_swipe_horizontal = _tmp5_;
#line 555 "../src/WindowManager.vala"
	if (fingers == 3) {
#line 4776 "WindowManager.c"
		const gchar* _tmp7_;
#line 555 "../src/WindowManager.vala"
		_tmp7_ = three_finger_swipe_horizontal;
#line 555 "../src/WindowManager.vala"
		_tmp6_ = g_strcmp0 (_tmp7_, "switch-to-workspace") == 0;
#line 4782 "WindowManager.c"
	} else {
#line 555 "../src/WindowManager.vala"
		_tmp6_ = FALSE;
#line 4786 "WindowManager.c"
	}
#line 555 "../src/WindowManager.vala"
	three_fingers_switch_to_workspace = _tmp6_;
#line 556 "../src/WindowManager.vala"
	if (fingers == 4) {
#line 4792 "WindowManager.c"
		const gchar* _tmp9_;
#line 556 "../src/WindowManager.vala"
		_tmp9_ = four_finger_swipe_horizontal;
#line 556 "../src/WindowManager.vala"
		_tmp8_ = g_strcmp0 (_tmp9_, "switch-to-workspace") == 0;
#line 4798 "WindowManager.c"
	} else {
#line 556 "../src/WindowManager.vala"
		_tmp8_ = FALSE;
#line 4802 "WindowManager.c"
	}
#line 556 "../src/WindowManager.vala"
	four_fingers_switch_to_workspace = _tmp8_;
#line 558 "../src/WindowManager.vala"
	if (fingers == 3) {
#line 4808 "WindowManager.c"
		const gchar* _tmp11_;
#line 558 "../src/WindowManager.vala"
		_tmp11_ = three_finger_swipe_horizontal;
#line 558 "../src/WindowManager.vala"
		_tmp10_ = g_strcmp0 (_tmp11_, "move-to-workspace") == 0;
#line 4814 "WindowManager.c"
	} else {
#line 558 "../src/WindowManager.vala"
		_tmp10_ = FALSE;
#line 4818 "WindowManager.c"
	}
#line 558 "../src/WindowManager.vala"
	three_fingers_move_to_workspace = _tmp10_;
#line 559 "../src/WindowManager.vala"
	if (fingers == 4) {
#line 4824 "WindowManager.c"
		const gchar* _tmp13_;
#line 559 "../src/WindowManager.vala"
		_tmp13_ = four_finger_swipe_horizontal;
#line 559 "../src/WindowManager.vala"
		_tmp12_ = g_strcmp0 (_tmp13_, "move-to-workspace") == 0;
#line 4830 "WindowManager.c"
	} else {
#line 559 "../src/WindowManager.vala"
		_tmp12_ = FALSE;
#line 4834 "WindowManager.c"
	}
#line 559 "../src/WindowManager.vala"
	four_fingers_move_to_workspace = _tmp12_;
#line 561 "../src/WindowManager.vala"
	if (three_fingers_switch_to_workspace) {
#line 561 "../src/WindowManager.vala"
		_tmp14_ = TRUE;
#line 4842 "WindowManager.c"
	} else {
#line 561 "../src/WindowManager.vala"
		_tmp14_ = four_fingers_switch_to_workspace;
#line 4846 "WindowManager.c"
	}
#line 561 "../src/WindowManager.vala"
	self->priv->switch_workspace_with_gesture = _tmp14_;
#line 562 "../src/WindowManager.vala"
	if (self->priv->switch_workspace_with_gesture) {
#line 4852 "WindowManager.c"
		MetaMotionDirection* direction = NULL;
		GalaGestureTracker* _tmp15_;
		GalaGestureSettings* _tmp16_;
		GalaGestureSettings* _tmp17_;
		MetaMotionDirection* _tmp18_;
		MetaMotionDirection* _tmp19_;
#line 563 "../src/WindowManager.vala"
		_tmp15_ = self->priv->gesture_tracker;
#line 563 "../src/WindowManager.vala"
		_tmp16_ = gala_gesture_tracker_get_settings (_tmp15_);
#line 563 "../src/WindowManager.vala"
		_tmp17_ = _tmp16_;
#line 563 "../src/WindowManager.vala"
		_tmp18_ = gala_gesture_settings_get_natural_scroll_direction (_tmp17_, gesture);
#line 563 "../src/WindowManager.vala"
		direction = _tmp18_;
#line 564 "../src/WindowManager.vala"
		_tmp19_ = direction;
#line 564 "../src/WindowManager.vala"
		gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, *_tmp19_);
#line 565 "../src/WindowManager.vala"
		_g_free0 (direction);
#line 565 "../src/WindowManager.vala"
		_g_free0 (four_finger_swipe_horizontal);
#line 565 "../src/WindowManager.vala"
		_g_free0 (three_finger_swipe_horizontal);
#line 565 "../src/WindowManager.vala"
		return;
#line 4881 "WindowManager.c"
	}
#line 568 "../src/WindowManager.vala"
	if (three_fingers_move_to_workspace) {
#line 568 "../src/WindowManager.vala"
		_tmp20_ = TRUE;
#line 4887 "WindowManager.c"
	} else {
#line 568 "../src/WindowManager.vala"
		_tmp20_ = four_fingers_move_to_workspace;
#line 4891 "WindowManager.c"
	}
#line 568 "../src/WindowManager.vala"
	self->priv->switch_workspace_with_gesture = _tmp20_;
#line 569 "../src/WindowManager.vala"
	if (self->priv->switch_workspace_with_gesture) {
#line 4897 "WindowManager.c"
		MetaDisplay* display = NULL;
		MetaDisplay* _tmp21_;
		MetaWorkspaceManager* manager = NULL;
		MetaDisplay* _tmp22_;
		MetaWorkspaceManager* _tmp23_;
		MetaMotionDirection* direction = NULL;
		GalaGestureTracker* _tmp24_;
		GalaGestureSettings* _tmp25_;
		GalaGestureSettings* _tmp26_;
		MetaMotionDirection* _tmp27_;
		MetaDisplay* _tmp28_;
		MetaWindow* _tmp29_;
		MetaWindow* _tmp30_;
		MetaWindow* _tmp31_;
		MetaWindow* _tmp32_;
		MetaMotionDirection* _tmp38_;
#line 570 "../src/WindowManager.vala"
		_tmp21_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 570 "../src/WindowManager.vala"
		display = _tmp21_;
#line 571 "../src/WindowManager.vala"
		_tmp22_ = display;
#line 571 "../src/WindowManager.vala"
		_tmp23_ = meta_display_get_workspace_manager (_tmp22_);
#line 571 "../src/WindowManager.vala"
		manager = _tmp23_;
#line 573 "../src/WindowManager.vala"
		_tmp24_ = self->priv->gesture_tracker;
#line 573 "../src/WindowManager.vala"
		_tmp25_ = gala_gesture_tracker_get_settings (_tmp24_);
#line 573 "../src/WindowManager.vala"
		_tmp26_ = _tmp25_;
#line 573 "../src/WindowManager.vala"
		_tmp27_ = gala_gesture_settings_get_natural_scroll_direction (_tmp26_, gesture);
#line 573 "../src/WindowManager.vala"
		direction = _tmp27_;
#line 575 "../src/WindowManager.vala"
		_tmp28_ = display;
#line 575 "../src/WindowManager.vala"
		_tmp29_ = meta_display_get_focus_window (_tmp28_);
#line 575 "../src/WindowManager.vala"
		_tmp30_ = _tmp29_;
#line 575 "../src/WindowManager.vala"
		_tmp31_ = _g_object_ref0 (_tmp30_);
#line 575 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->moving);
#line 575 "../src/WindowManager.vala"
		self->priv->moving = _tmp31_;
#line 576 "../src/WindowManager.vala"
		_tmp32_ = self->priv->moving;
#line 576 "../src/WindowManager.vala"
		if (_tmp32_ != NULL) {
#line 4950 "WindowManager.c"
			MetaWindow* _tmp33_;
			MetaWorkspaceManager* _tmp34_;
			MetaWorkspace* _tmp35_;
			MetaMotionDirection* _tmp36_;
			MetaWorkspace* _tmp37_;
#line 577 "../src/WindowManager.vala"
			_tmp33_ = self->priv->moving;
#line 577 "../src/WindowManager.vala"
			_tmp34_ = manager;
#line 577 "../src/WindowManager.vala"
			_tmp35_ = meta_workspace_manager_get_active_workspace (_tmp34_);
#line 577 "../src/WindowManager.vala"
			_tmp36_ = direction;
#line 577 "../src/WindowManager.vala"
			_tmp37_ = meta_workspace_get_neighbor (_tmp35_, *_tmp36_);
#line 577 "../src/WindowManager.vala"
			meta_window_change_workspace (_tmp33_, _tmp37_);
#line 4968 "WindowManager.c"
		}
#line 580 "../src/WindowManager.vala"
		_tmp38_ = direction;
#line 580 "../src/WindowManager.vala"
		gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, *_tmp38_);
#line 581 "../src/WindowManager.vala"
		_g_free0 (direction);
#line 581 "../src/WindowManager.vala"
		_g_free0 (four_finger_swipe_horizontal);
#line 581 "../src/WindowManager.vala"
		_g_free0 (three_finger_swipe_horizontal);
#line 581 "../src/WindowManager.vala"
		return;
#line 4982 "WindowManager.c"
	}
#line 536 "../src/WindowManager.vala"
	_g_free0 (four_finger_swipe_horizontal);
#line 536 "../src/WindowManager.vala"
	_g_free0 (three_finger_swipe_horizontal);
#line 4988 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static void
gala_window_manager_gala_real_switch_to_next_workspace (GalaWindowManager* base,
                                                        MetaMotionDirection direction)
{
	GalaWindowManagerGala * self;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	MetaWorkspace* active_workspace = NULL;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* neighbor = NULL;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	MetaWorkspace* _tmp6_;
	MetaWorkspace* _tmp7_;
#line 588 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 589 "../src/WindowManager.vala"
	if (self->priv->animating_switch_workspace) {
#line 590 "../src/WindowManager.vala"
		return;
#line 5016 "WindowManager.c"
	}
#line 593 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 593 "../src/WindowManager.vala"
	display = _tmp0_;
#line 594 "../src/WindowManager.vala"
	_tmp1_ = display;
#line 594 "../src/WindowManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 594 "../src/WindowManager.vala"
	_tmp3_ = meta_workspace_manager_get_active_workspace (_tmp2_);
#line 594 "../src/WindowManager.vala"
	active_workspace = _tmp3_;
#line 595 "../src/WindowManager.vala"
	_tmp4_ = active_workspace;
#line 595 "../src/WindowManager.vala"
	_tmp5_ = meta_workspace_get_neighbor (_tmp4_, direction);
#line 595 "../src/WindowManager.vala"
	neighbor = _tmp5_;
#line 597 "../src/WindowManager.vala"
	_tmp6_ = neighbor;
#line 597 "../src/WindowManager.vala"
	_tmp7_ = active_workspace;
#line 597 "../src/WindowManager.vala"
	if (_tmp6_ != _tmp7_) {
#line 5042 "WindowManager.c"
		MetaWorkspace* _tmp8_;
		MetaDisplay* _tmp9_;
#line 598 "../src/WindowManager.vala"
		_tmp8_ = neighbor;
#line 598 "../src/WindowManager.vala"
		_tmp9_ = display;
#line 598 "../src/WindowManager.vala"
		meta_workspace_activate (_tmp8_, meta_display_get_current_time (_tmp9_));
#line 5051 "WindowManager.c"
	} else {
		gboolean _tmp10_ = FALSE;
		GalaActivatableComponent* _tmp11_;
		GalaActivatableComponent* _tmp12_;
#line 601 "../src/WindowManager.vala"
		_tmp11_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 601 "../src/WindowManager.vala"
		_tmp12_ = _tmp11_;
#line 601 "../src/WindowManager.vala"
		if (gala_activatable_component_is_opened (_tmp12_)) {
#line 5062 "WindowManager.c"
			GalaActivatableComponent* _tmp13_;
			GalaActivatableComponent* _tmp14_;
#line 601 "../src/WindowManager.vala"
			_tmp13_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 601 "../src/WindowManager.vala"
			_tmp14_ = _tmp13_;
#line 601 "../src/WindowManager.vala"
			_tmp10_ = GALA_IS_MULTITASKING_VIEW (_tmp14_);
#line 5071 "WindowManager.c"
		} else {
#line 601 "../src/WindowManager.vala"
			_tmp10_ = FALSE;
#line 5075 "WindowManager.c"
		}
#line 601 "../src/WindowManager.vala"
		if (_tmp10_) {
#line 5079 "WindowManager.c"
			GalaActivatableComponent* _tmp15_;
			GalaActivatableComponent* _tmp16_;
#line 602 "../src/WindowManager.vala"
			_tmp15_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 602 "../src/WindowManager.vala"
			_tmp16_ = _tmp15_;
#line 602 "../src/WindowManager.vala"
			gala_multitasking_view_play_nudge_animation (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GALA_TYPE_MULTITASKING_VIEW, GalaMultitaskingView), direction);
#line 5088 "WindowManager.c"
		} else {
#line 604 "../src/WindowManager.vala"
			gala_window_manager_gala_play_nudge_animation (self, direction);
#line 5092 "WindowManager.c"
		}
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 609 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 609 "../src/WindowManager.vala"
	return _data10_;
#line 5104 "WindowManager.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 609 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 5114 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 609 "../src/WindowManager.vala"
		self = _data10_->self;
#line 609 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 609 "../src/WindowManager.vala"
		g_slice_free (Block10Data, _data10_);
#line 5122 "WindowManager.c"
	}
}

static void
__lambda121_ (Block10Data* _data10_,
              gdouble percentage)
{
	GalaWindowManagerGala* self;
	gfloat x = 0.0F;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 630 "../src/WindowManager.vala"
	self = _data10_->self;
#line 631 "../src/WindowManager.vala"
	x = gala_gesture_tracker_animation_value (0.0f, _data10_->dest, percentage, TRUE);
#line 632 "../src/WindowManager.vala"
	_tmp0_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 632 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 632 "../src/WindowManager.vala"
	g_object_set (_tmp1_, "translation-x", CLAMP (x, (gfloat) (-_data10_->nudge_gap), (gfloat) _data10_->nudge_gap), NULL);
#line 5144 "WindowManager.c"
}

static void
___lambda121__gala_gesture_tracker_on_update (gdouble percentage,
                                              gpointer self)
{
#line 630 "../src/WindowManager.vala"
	__lambda121_ (self, percentage);
#line 5153 "WindowManager.c"
}

static void
__lambda122_ (GalaWindowManagerGala* self,
              gdouble percentage,
              gboolean cancel_action)
{
	ClutterPropertyTransition* nudge_gesture = NULL;
	ClutterPropertyTransition* _tmp0_ = NULL;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	GValue _tmp5_ = {0};
	GValue _tmp6_ = {0};
	ClutterActor* _tmp7_;
	ClutterActor* _tmp8_;
#line 636 "../src/WindowManager.vala"
	_tmp0_ = (ClutterPropertyTransition*) clutter_property_transition_new ("translation-x");
#line 636 "../src/WindowManager.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp0_, (guint) (GALA_ANIMATION_DURATION_NUDGE / 2));
#line 636 "../src/WindowManager.vala"
	clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp0_, TRUE);
#line 636 "../src/WindowManager.vala"
	clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp0_, CLUTTER_LINEAR);
#line 636 "../src/WindowManager.vala"
	nudge_gesture = _tmp0_;
#line 641 "../src/WindowManager.vala"
	_tmp1_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 641 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 641 "../src/WindowManager.vala"
	g_object_get (_tmp2_, "translation-x", &_tmp3_, NULL);
#line 641 "../src/WindowManager.vala"
	_tmp4_ = _tmp3_;
#line 641 "../src/WindowManager.vala"
	g_value_init (&_tmp5_, G_TYPE_FLOAT);
#line 641 "../src/WindowManager.vala"
	g_value_set_float (&_tmp5_, _tmp4_);
#line 641 "../src/WindowManager.vala"
	clutter_transition_set_from_value ((ClutterTransition*) nudge_gesture, &_tmp5_);
#line 641 "../src/WindowManager.vala"
	G_IS_VALUE (&_tmp5_) ? (g_value_unset (&_tmp5_), NULL) : NULL;
#line 642 "../src/WindowManager.vala"
	g_value_init (&_tmp6_, G_TYPE_FLOAT);
#line 642 "../src/WindowManager.vala"
	g_value_set_float (&_tmp6_, 0.0f);
#line 642 "../src/WindowManager.vala"
	clutter_transition_set_to_value ((ClutterTransition*) nudge_gesture, &_tmp6_);
#line 642 "../src/WindowManager.vala"
	G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
#line 643 "../src/WindowManager.vala"
	_tmp7_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 643 "../src/WindowManager.vala"
	_tmp8_ = _tmp7_;
#line 643 "../src/WindowManager.vala"
	clutter_actor_add_transition (_tmp8_, "nudge", (ClutterTransition*) nudge_gesture);
#line 645 "../src/WindowManager.vala"
	self->priv->switch_workspace_with_gesture = FALSE;
#line 635 "../src/WindowManager.vala"
	_g_object_unref0 (nudge_gesture);
#line 5215 "WindowManager.c"
}

static void
___lambda122__gala_gesture_tracker_on_end (gdouble percentage,
                                           gboolean cancel_action,
                                           gint calculated_duration,
                                           gpointer self)
{
#line 635 "../src/WindowManager.vala"
	__lambda122_ ((GalaWindowManagerGala*) self, percentage, cancel_action);
#line 5226 "WindowManager.c"
}

static void
_vala_GValue_array_free (GValue * array,
                         gssize array_length)
{
#line 648 "../src/WindowManager.vala"
	if (array != NULL) {
#line 5235 "WindowManager.c"
		gssize i;
#line 648 "../src/WindowManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 648 "../src/WindowManager.vala"
			g_value_unset (&array[i]);
#line 5241 "WindowManager.c"
		}
	}
#line 648 "../src/WindowManager.vala"
	g_free (array);
#line 5246 "WindowManager.c"
}

static void
gala_window_manager_gala_play_nudge_animation (GalaWindowManagerGala* self,
                                               MetaMotionDirection direction)
{
	Block10Data* _data10_;
	gboolean _tmp0_;
	gboolean _tmp1_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp2_;
	gfloat scale = 0.0F;
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
	GalaGestureTrackerOnUpdate on_animation_update = NULL;
	gpointer on_animation_update_target;
	GDestroyNotify on_animation_update_target_destroy_notify;
	GalaGestureTrackerOnEnd on_animation_end = NULL;
	gpointer on_animation_end_target;
	GDestroyNotify on_animation_end_target_destroy_notify;
#line 609 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 609 "../src/WindowManager.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 609 "../src/WindowManager.vala"
	_data10_->_ref_count_ = 1;
#line 609 "../src/WindowManager.vala"
	_data10_->self = g_object_ref (self);
#line 610 "../src/WindowManager.vala"
	_tmp0_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 610 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 610 "../src/WindowManager.vala"
	if (!_tmp1_) {
#line 611 "../src/WindowManager.vala"
		block10_data_unref (_data10_);
#line 611 "../src/WindowManager.vala"
		_data10_ = NULL;
#line 611 "../src/WindowManager.vala"
		return;
#line 5287 "WindowManager.c"
	}
#line 614 "../src/WindowManager.vala"
	_tmp2_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 614 "../src/WindowManager.vala"
	display = _tmp2_;
#line 615 "../src/WindowManager.vala"
	_tmp3_ = display;
#line 615 "../src/WindowManager.vala"
	_tmp4_ = display;
#line 615 "../src/WindowManager.vala"
	scale = meta_display_get_monitor_scale (_tmp3_, meta_display_get_primary_monitor (_tmp4_));
#line 616 "../src/WindowManager.vala"
	_data10_->nudge_gap = gala_internal_utils_scale_to_int (GALA_WINDOW_MANAGER_GALA_NUDGE_GAP, scale);
#line 618 "../src/WindowManager.vala"
	_data10_->dest = (gfloat) 0;
#line 619 "../src/WindowManager.vala"
	if (!self->priv->switch_workspace_with_gesture) {
#line 620 "../src/WindowManager.vala"
		_data10_->dest = (gfloat) _data10_->nudge_gap;
#line 5307 "WindowManager.c"
	} else {
		MtkRectangle workspaces_geometry = {0};
		MetaDisplay* _tmp5_;
		MtkRectangle _tmp6_ = {0};
		MtkRectangle _tmp7_;
#line 622 "../src/WindowManager.vala"
		_tmp5_ = display;
#line 622 "../src/WindowManager.vala"
		gala_internal_utils_get_workspaces_geometry (_tmp5_, &_tmp6_);
#line 622 "../src/WindowManager.vala"
		workspaces_geometry = _tmp6_;
#line 623 "../src/WindowManager.vala"
		_tmp7_ = workspaces_geometry;
#line 623 "../src/WindowManager.vala"
		_data10_->dest = (gfloat) _tmp7_.width;
#line 5323 "WindowManager.c"
	}
#line 626 "../src/WindowManager.vala"
	if (direction == META_MOTION_RIGHT) {
#line 627 "../src/WindowManager.vala"
		_data10_->dest *= (gfloat) -1;
#line 5329 "WindowManager.c"
	}
#line 630 "../src/WindowManager.vala"
	on_animation_update = ___lambda121__gala_gesture_tracker_on_update;
#line 630 "../src/WindowManager.vala"
	on_animation_update_target = block10_data_ref (_data10_);
#line 630 "../src/WindowManager.vala"
	on_animation_update_target_destroy_notify = block10_data_unref;
#line 635 "../src/WindowManager.vala"
	on_animation_end = ___lambda122__gala_gesture_tracker_on_end;
#line 635 "../src/WindowManager.vala"
	on_animation_end_target = g_object_ref (self);
#line 635 "../src/WindowManager.vala"
	on_animation_end_target_destroy_notify = g_object_unref;
#line 648 "../src/WindowManager.vala"
	if (!self->priv->switch_workspace_with_gesture) {
#line 5345 "WindowManager.c"
		gdouble* keyframes = NULL;
		gdouble* _tmp8_;
		gint keyframes_length1;
		gint _keyframes_size_;
		GValue* x = NULL;
		GValue _tmp9_ = {0};
		GValue* _tmp10_;
		gint x_length1;
		gint _x_size_;
		ClutterKeyframeTransition* nudge = NULL;
		ClutterKeyframeTransition* _tmp11_ = NULL;
		ClutterKeyframeTransition* _tmp12_;
		GValue _tmp13_ = {0};
		ClutterKeyframeTransition* _tmp14_;
		GValue _tmp15_ = {0};
		ClutterKeyframeTransition* _tmp16_;
		gdouble* _tmp17_;
		gint _tmp17__length1;
		ClutterKeyframeTransition* _tmp18_;
		GValue* _tmp19_;
		gint _tmp19__length1;
		ClutterActor* _tmp20_;
		ClutterActor* _tmp21_;
		ClutterKeyframeTransition* _tmp22_;
#line 649 "../src/WindowManager.vala"
		_tmp8_ = g_new0 (gdouble, 1);
#line 649 "../src/WindowManager.vala"
		_tmp8_[0] = 0.5;
#line 649 "../src/WindowManager.vala"
		keyframes = _tmp8_;
#line 649 "../src/WindowManager.vala"
		keyframes_length1 = 1;
#line 649 "../src/WindowManager.vala"
		_keyframes_size_ = keyframes_length1;
#line 650 "../src/WindowManager.vala"
		g_value_init (&_tmp9_, G_TYPE_FLOAT);
#line 650 "../src/WindowManager.vala"
		g_value_set_float (&_tmp9_, _data10_->dest);
#line 650 "../src/WindowManager.vala"
		_tmp10_ = g_new0 (GValue, 1);
#line 650 "../src/WindowManager.vala"
		_tmp10_[0] = _tmp9_;
#line 650 "../src/WindowManager.vala"
		x = _tmp10_;
#line 650 "../src/WindowManager.vala"
		x_length1 = 1;
#line 650 "../src/WindowManager.vala"
		_x_size_ = x_length1;
#line 652 "../src/WindowManager.vala"
		_tmp11_ = (ClutterKeyframeTransition*) clutter_keyframe_transition_new ("translation-x");
#line 652 "../src/WindowManager.vala"
		clutter_timeline_set_duration ((ClutterTimeline*) _tmp11_, (guint) GALA_ANIMATION_DURATION_NUDGE);
#line 652 "../src/WindowManager.vala"
		clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp11_, TRUE);
#line 652 "../src/WindowManager.vala"
		clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp11_, CLUTTER_EASE_IN_QUAD);
#line 652 "../src/WindowManager.vala"
		nudge = _tmp11_;
#line 657 "../src/WindowManager.vala"
		_tmp12_ = nudge;
#line 657 "../src/WindowManager.vala"
		g_value_init (&_tmp13_, G_TYPE_FLOAT);
#line 657 "../src/WindowManager.vala"
		g_value_set_float (&_tmp13_, 0.0f);
#line 657 "../src/WindowManager.vala"
		clutter_transition_set_from_value ((ClutterTransition*) _tmp12_, &_tmp13_);
#line 657 "../src/WindowManager.vala"
		G_IS_VALUE (&_tmp13_) ? (g_value_unset (&_tmp13_), NULL) : NULL;
#line 658 "../src/WindowManager.vala"
		_tmp14_ = nudge;
#line 658 "../src/WindowManager.vala"
		g_value_init (&_tmp15_, G_TYPE_FLOAT);
#line 658 "../src/WindowManager.vala"
		g_value_set_float (&_tmp15_, 0.0f);
#line 658 "../src/WindowManager.vala"
		clutter_transition_set_to_value ((ClutterTransition*) _tmp14_, &_tmp15_);
#line 658 "../src/WindowManager.vala"
		G_IS_VALUE (&_tmp15_) ? (g_value_unset (&_tmp15_), NULL) : NULL;
#line 659 "../src/WindowManager.vala"
		_tmp16_ = nudge;
#line 659 "../src/WindowManager.vala"
		_tmp17_ = keyframes;
#line 659 "../src/WindowManager.vala"
		_tmp17__length1 = keyframes_length1;
#line 659 "../src/WindowManager.vala"
		clutter_keyframe_transition_set_key_frames (_tmp16_, (guint) _tmp17__length1, _tmp17_);
#line 660 "../src/WindowManager.vala"
		_tmp18_ = nudge;
#line 660 "../src/WindowManager.vala"
		_tmp19_ = x;
#line 660 "../src/WindowManager.vala"
		_tmp19__length1 = x_length1;
#line 660 "../src/WindowManager.vala"
		clutter_keyframe_transition_set_values (_tmp18_, (guint) _tmp19__length1, _tmp19_);
#line 662 "../src/WindowManager.vala"
		_tmp20_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 662 "../src/WindowManager.vala"
		_tmp21_ = _tmp20_;
#line 662 "../src/WindowManager.vala"
		_tmp22_ = nudge;
#line 662 "../src/WindowManager.vala"
		clutter_actor_add_transition (_tmp21_, "nudge", (ClutterTransition*) _tmp22_);
#line 648 "../src/WindowManager.vala"
		_g_object_unref0 (nudge);
#line 648 "../src/WindowManager.vala"
		x = (_vala_GValue_array_free (x, x_length1), NULL);
#line 648 "../src/WindowManager.vala"
		keyframes = (g_free (keyframes), NULL);
#line 5454 "WindowManager.c"
	} else {
		GalaGestureTracker* _tmp23_;
		GalaGestureTrackerOnUpdate _tmp24_;
		gpointer _tmp24__target;
		GDestroyNotify _tmp24__target_destroy_notify;
		GalaGestureTrackerOnEnd _tmp25_;
		gpointer _tmp25__target;
		GDestroyNotify _tmp25__target_destroy_notify;
#line 664 "../src/WindowManager.vala"
		_tmp23_ = self->priv->gesture_tracker;
#line 664 "../src/WindowManager.vala"
		_tmp24_ = on_animation_update;
#line 664 "../src/WindowManager.vala"
		_tmp24__target = on_animation_update_target;
#line 664 "../src/WindowManager.vala"
		_tmp24__target_destroy_notify = on_animation_update_target_destroy_notify;
#line 664 "../src/WindowManager.vala"
		on_animation_update = NULL;
#line 664 "../src/WindowManager.vala"
		on_animation_update_target = NULL;
#line 664 "../src/WindowManager.vala"
		on_animation_update_target_destroy_notify = NULL;
#line 664 "../src/WindowManager.vala"
		_tmp25_ = on_animation_end;
#line 664 "../src/WindowManager.vala"
		_tmp25__target = on_animation_end_target;
#line 664 "../src/WindowManager.vala"
		_tmp25__target_destroy_notify = on_animation_end_target_destroy_notify;
#line 664 "../src/WindowManager.vala"
		on_animation_end = NULL;
#line 664 "../src/WindowManager.vala"
		on_animation_end_target = NULL;
#line 664 "../src/WindowManager.vala"
		on_animation_end_target_destroy_notify = NULL;
#line 664 "../src/WindowManager.vala"
		gala_gesture_tracker_connect_handlers (_tmp23_, NULL, NULL, NULL, _tmp24_, _tmp24__target, _tmp24__target_destroy_notify, _tmp25_, _tmp25__target, _tmp25__target_destroy_notify);
#line 5491 "WindowManager.c"
	}
#line 609 "../src/WindowManager.vala"
	(on_animation_end_target_destroy_notify == NULL) ? NULL : (on_animation_end_target_destroy_notify (on_animation_end_target), NULL);
#line 609 "../src/WindowManager.vala"
	on_animation_end = NULL;
#line 609 "../src/WindowManager.vala"
	on_animation_end_target = NULL;
#line 609 "../src/WindowManager.vala"
	on_animation_end_target_destroy_notify = NULL;
#line 609 "../src/WindowManager.vala"
	(on_animation_update_target_destroy_notify == NULL) ? NULL : (on_animation_update_target_destroy_notify (on_animation_update_target), NULL);
#line 609 "../src/WindowManager.vala"
	on_animation_update = NULL;
#line 609 "../src/WindowManager.vala"
	on_animation_update_target = NULL;
#line 609 "../src/WindowManager.vala"
	on_animation_update_target_destroy_notify = NULL;
#line 609 "../src/WindowManager.vala"
	block10_data_unref (_data10_);
#line 609 "../src/WindowManager.vala"
	_data10_ = NULL;
#line 5513 "WindowManager.c"
}

static void
gala_window_manager_gala_update_input_area (GalaWindowManagerGala* self)
{
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	GalaScreenSaverManager* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 668 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 669 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 669 "../src/WindowManager.vala"
	display = _tmp0_;
#line 671 "../src/WindowManager.vala"
	_tmp1_ = self->priv->_screensaver;
#line 671 "../src/WindowManager.vala"
	if (_tmp1_ != NULL) {
#line 5533 "WindowManager.c"
		{
			gboolean _tmp2_ = FALSE;
			GalaScreenSaverManager* _tmp3_;
#line 673 "../src/WindowManager.vala"
			_tmp3_ = self->priv->_screensaver;
#line 673 "../src/WindowManager.vala"
			_tmp2_ = gala_screen_saver_manager_get_active (_tmp3_, &_inner_error0_);
#line 673 "../src/WindowManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5543 "WindowManager.c"
				goto __catch0_g_error;
			}
#line 673 "../src/WindowManager.vala"
			if (_tmp2_) {
#line 5548 "WindowManager.c"
				MetaDisplay* _tmp4_;
#line 674 "../src/WindowManager.vala"
				_tmp4_ = display;
#line 674 "../src/WindowManager.vala"
				gala_internal_utils_set_input_area (_tmp4_, GALA_INPUT_AREA_NONE);
#line 675 "../src/WindowManager.vala"
				return;
#line 5556 "WindowManager.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 672 "../src/WindowManager.vala"
			g_clear_error (&_inner_error0_);
#line 5564 "WindowManager.c"
		}
		__finally0:
#line 672 "../src/WindowManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 672 "../src/WindowManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 672 "../src/WindowManager.vala"
			g_clear_error (&_inner_error0_);
#line 672 "../src/WindowManager.vala"
			return;
#line 5575 "WindowManager.c"
		}
	}
#line 685 "../src/WindowManager.vala"
	if (gala_window_manager_is_modal ((GalaWindowManager*) self)) {
#line 5580 "WindowManager.c"
		MetaDisplay* _tmp5_;
#line 686 "../src/WindowManager.vala"
		_tmp5_ = display;
#line 686 "../src/WindowManager.vala"
		gala_internal_utils_set_input_area (_tmp5_, GALA_INPUT_AREA_FULLSCREEN);
#line 5586 "WindowManager.c"
	} else {
		MetaDisplay* _tmp6_;
#line 688 "../src/WindowManager.vala"
		_tmp6_ = display;
#line 688 "../src/WindowManager.vala"
		gala_internal_utils_set_input_area (_tmp6_, GALA_INPUT_AREA_DEFAULT);
#line 5593 "WindowManager.c"
	}
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 691 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 691 "../src/WindowManager.vala"
	return _data11_;
#line 5604 "WindowManager.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 691 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 5614 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 691 "../src/WindowManager.vala"
		self = _data11_->self;
#line 691 "../src/WindowManager.vala"
		_data11_->opacity = (_vala_GValue_array_free (_data11_->opacity, _data11_->opacity_length1), NULL);
#line 691 "../src/WindowManager.vala"
		_data11_->op_keyframes = (g_free (_data11_->op_keyframes), NULL);
#line 691 "../src/WindowManager.vala"
		_g_object_unref0 (_data11_->bottom_window);
#line 691 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 691 "../src/WindowManager.vala"
		g_slice_free (Block11Data, _data11_);
#line 5628 "WindowManager.c"
	}
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 706 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 706 "../src/WindowManager.vala"
	return _data12_;
#line 5639 "WindowManager.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 706 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 5649 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 706 "../src/WindowManager.vala"
		self = _data12_->_data11_->self;
#line 706 "../src/WindowManager.vala"
		block11_data_unref (_data12_->_data11_);
#line 706 "../src/WindowManager.vala"
		_data12_->_data11_ = NULL;
#line 706 "../src/WindowManager.vala"
		g_slice_free (Block12Data, _data12_);
#line 5659 "WindowManager.c"
	}
}

static gboolean
___lambda143_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	GalaWindowManagerGala* self;
	MetaWindowActor* _tmp0_;
	GValue* _tmp1_;
	gint _tmp1__length1;
	GValue _tmp2_;
	gboolean result;
#line 727 "../src/WindowManager.vala"
	_data11_ = _data12_->_data11_;
#line 727 "../src/WindowManager.vala"
	self = _data11_->self;
#line 728 "../src/WindowManager.vala"
	_tmp0_ = _data12_->actor;
#line 728 "../src/WindowManager.vala"
	_tmp1_ = _data11_->opacity;
#line 728 "../src/WindowManager.vala"
	_tmp1__length1 = _data11_->opacity_length1;
#line 728 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_[0];
#line 728 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp0_, g_value_get_uint (&_tmp2_));
#line 729 "../src/WindowManager.vala"
	result = G_SOURCE_REMOVE;
#line 729 "../src/WindowManager.vala"
	return result;
#line 5691 "WindowManager.c"
}

static gboolean
____lambda143__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda143_ (self);
#line 727 "../src/WindowManager.vala"
	return result;
#line 5701 "WindowManager.c"
}

static gboolean
___lambda144_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	GalaWindowManagerGala* self;
	MetaWindowActor* _tmp0_;
	gboolean result;
#line 732 "../src/WindowManager.vala"
	_data11_ = _data12_->_data11_;
#line 732 "../src/WindowManager.vala"
	self = _data11_->self;
#line 733 "../src/WindowManager.vala"
	_tmp0_ = _data12_->actor;
#line 733 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp0_, 255U);
#line 734 "../src/WindowManager.vala"
	result = G_SOURCE_REMOVE;
#line 734 "../src/WindowManager.vala"
	return result;
#line 5723 "WindowManager.c"
}

static gboolean
____lambda144__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda144_ (self);
#line 732 "../src/WindowManager.vala"
	return result;
#line 5733 "WindowManager.c"
}

static void
__lambda142_ (Block11Data* _data11_,
              MetaWindow* window)
{
	GalaWindowManagerGala* self;
	Block12Data* _data12_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GObject* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 706 "../src/WindowManager.vala"
	self = _data11_->self;
#line 706 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 706 "../src/WindowManager.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 706 "../src/WindowManager.vala"
	_data12_->_ref_count_ = 1;
#line 706 "../src/WindowManager.vala"
	_data12_->_data11_ = block11_data_ref (_data11_);
#line 707 "../src/WindowManager.vala"
	if (meta_window_get_xwindow (window) == meta_window_get_xwindow (_data11_->bottom_window)) {
#line 707 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 5761 "WindowManager.c"
	} else {
#line 708 "../src/WindowManager.vala"
		_tmp1_ = !gala_internal_utils_get_window_is_normal (window);
#line 5765 "WindowManager.c"
	}
#line 707 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 707 "../src/WindowManager.vala"
		_tmp0_ = TRUE;
#line 5771 "WindowManager.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 709 "../src/WindowManager.vala"
		g_object_get (window, "minimized", &_tmp2_, NULL);
#line 709 "../src/WindowManager.vala"
		_tmp3_ = _tmp2_;
#line 709 "../src/WindowManager.vala"
		_tmp0_ = _tmp3_;
#line 5781 "WindowManager.c"
	}
#line 707 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 710 "../src/WindowManager.vala"
		block12_data_unref (_data12_);
#line 710 "../src/WindowManager.vala"
		_data12_ = NULL;
#line 710 "../src/WindowManager.vala"
		return;
#line 5791 "WindowManager.c"
	}
#line 713 "../src/WindowManager.vala"
	_tmp4_ = meta_window_get_compositor_private (window);
#line 713 "../src/WindowManager.vala"
	_data12_->actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, meta_window_actor_get_type (), MetaWindowActor);
#line 714 "../src/WindowManager.vala"
	_tmp5_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 714 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 714 "../src/WindowManager.vala"
	if (_tmp6_) {
#line 5803 "WindowManager.c"
		ClutterKeyframeTransition* op_trans = NULL;
		ClutterKeyframeTransition* _tmp7_ = NULL;
		ClutterKeyframeTransition* _tmp8_;
		GValue _tmp9_ = {0};
		ClutterKeyframeTransition* _tmp10_;
		GValue _tmp11_ = {0};
		ClutterKeyframeTransition* _tmp12_;
		gdouble* _tmp13_;
		gint _tmp13__length1;
		ClutterKeyframeTransition* _tmp14_;
		GValue* _tmp15_;
		gint _tmp15__length1;
		MetaWindowActor* _tmp16_;
		ClutterKeyframeTransition* _tmp17_;
#line 715 "../src/WindowManager.vala"
		_tmp7_ = (ClutterKeyframeTransition*) clutter_keyframe_transition_new ("opacity");
#line 715 "../src/WindowManager.vala"
		clutter_timeline_set_duration ((ClutterTimeline*) _tmp7_, _data11_->fade_out_duration);
#line 715 "../src/WindowManager.vala"
		clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp7_, TRUE);
#line 715 "../src/WindowManager.vala"
		clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp7_, CLUTTER_EASE_IN_OUT_QUAD);
#line 715 "../src/WindowManager.vala"
		op_trans = _tmp7_;
#line 720 "../src/WindowManager.vala"
		_tmp8_ = op_trans;
#line 720 "../src/WindowManager.vala"
		g_value_init (&_tmp9_, G_TYPE_FLOAT);
#line 720 "../src/WindowManager.vala"
		g_value_set_float (&_tmp9_, 255.0f);
#line 720 "../src/WindowManager.vala"
		clutter_transition_set_from_value ((ClutterTransition*) _tmp8_, &_tmp9_);
#line 720 "../src/WindowManager.vala"
		G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 721 "../src/WindowManager.vala"
		_tmp10_ = op_trans;
#line 721 "../src/WindowManager.vala"
		g_value_init (&_tmp11_, G_TYPE_FLOAT);
#line 721 "../src/WindowManager.vala"
		g_value_set_float (&_tmp11_, 255.0f);
#line 721 "../src/WindowManager.vala"
		clutter_transition_set_to_value ((ClutterTransition*) _tmp10_, &_tmp11_);
#line 721 "../src/WindowManager.vala"
		G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
#line 722 "../src/WindowManager.vala"
		_tmp12_ = op_trans;
#line 722 "../src/WindowManager.vala"
		_tmp13_ = _data11_->op_keyframes;
#line 722 "../src/WindowManager.vala"
		_tmp13__length1 = _data11_->op_keyframes_length1;
#line 722 "../src/WindowManager.vala"
		clutter_keyframe_transition_set_key_frames (_tmp12_, (guint) _tmp13__length1, _tmp13_);
#line 723 "../src/WindowManager.vala"
		_tmp14_ = op_trans;
#line 723 "../src/WindowManager.vala"
		_tmp15_ = _data11_->opacity;
#line 723 "../src/WindowManager.vala"
		_tmp15__length1 = _data11_->opacity_length1;
#line 723 "../src/WindowManager.vala"
		clutter_keyframe_transition_set_values (_tmp14_, (guint) _tmp15__length1, _tmp15_);
#line 725 "../src/WindowManager.vala"
		_tmp16_ = _data12_->actor;
#line 725 "../src/WindowManager.vala"
		_tmp17_ = op_trans;
#line 725 "../src/WindowManager.vala"
		clutter_actor_add_transition ((ClutterActor*) _tmp16_, "opacity-hide", (ClutterTransition*) _tmp17_);
#line 714 "../src/WindowManager.vala"
		_g_object_unref0 (op_trans);
#line 5872 "WindowManager.c"
	} else {
		gdouble* _tmp18_;
		gint _tmp18__length1;
		gdouble _tmp19_;
		gdouble* _tmp20_;
		gint _tmp20__length1;
		gdouble _tmp21_;
#line 727 "../src/WindowManager.vala"
		_tmp18_ = _data11_->op_keyframes;
#line 727 "../src/WindowManager.vala"
		_tmp18__length1 = _data11_->op_keyframes_length1;
#line 727 "../src/WindowManager.vala"
		_tmp19_ = _tmp18_[0];
#line 727 "../src/WindowManager.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (_data11_->fade_out_duration * _tmp19_), ____lambda143__gsource_func, block12_data_ref (_data12_), block12_data_unref);
#line 732 "../src/WindowManager.vala"
		_tmp20_ = _data11_->op_keyframes;
#line 732 "../src/WindowManager.vala"
		_tmp20__length1 = _data11_->op_keyframes_length1;
#line 732 "../src/WindowManager.vala"
		_tmp21_ = _tmp20_[1];
#line 732 "../src/WindowManager.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (_data11_->fade_out_duration * _tmp21_), ____lambda144__gsource_func, block12_data_ref (_data12_), block12_data_unref);
#line 5896 "WindowManager.c"
	}
#line 706 "../src/WindowManager.vala"
	block12_data_unref (_data12_);
#line 706 "../src/WindowManager.vala"
	_data12_ = NULL;
#line 5902 "WindowManager.c"
}

static void
___lambda142__gfunc (gconstpointer data,
                     gpointer self)
{
#line 706 "../src/WindowManager.vala"
	__lambda142_ (self, (MetaWindow*) data);
#line 5911 "WindowManager.c"
}

static void
gala_window_manager_gala_show_bottom_stack_window (GalaWindowManagerGala* self,
                                                   MetaWindow* bottom_window)
{
	Block11Data* _data11_;
	MetaWindow* _tmp0_;
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWindowActor* bottom_actor = NULL;
	GObject* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gdouble* _tmp7_;
	GValue _tmp8_ = {0};
	GValue _tmp9_ = {0};
	GValue* _tmp10_;
	MetaWorkspace* _tmp11_;
	GList* _tmp12_;
	GList* _tmp13_;
#line 691 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 691 "../src/WindowManager.vala"
	g_return_if_fail (bottom_window != NULL);
#line 691 "../src/WindowManager.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 691 "../src/WindowManager.vala"
	_data11_->_ref_count_ = 1;
#line 691 "../src/WindowManager.vala"
	_data11_->self = g_object_ref (self);
#line 691 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (bottom_window);
#line 691 "../src/WindowManager.vala"
	_g_object_unref0 (_data11_->bottom_window);
#line 691 "../src/WindowManager.vala"
	_data11_->bottom_window = _tmp0_;
#line 692 "../src/WindowManager.vala"
	_tmp1_ = meta_window_get_workspace (_data11_->bottom_window);
#line 692 "../src/WindowManager.vala"
	workspace = _tmp1_;
#line 693 "../src/WindowManager.vala"
	_tmp2_ = workspace;
#line 693 "../src/WindowManager.vala"
	if (gala_utils_get_n_windows (_tmp2_, FALSE) == ((guint) 0)) {
#line 694 "../src/WindowManager.vala"
		block11_data_unref (_data11_);
#line 694 "../src/WindowManager.vala"
		_data11_ = NULL;
#line 694 "../src/WindowManager.vala"
		return;
#line 5964 "WindowManager.c"
	}
#line 697 "../src/WindowManager.vala"
	_tmp3_ = meta_window_get_compositor_private (_data11_->bottom_window);
#line 697 "../src/WindowManager.vala"
	bottom_actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, meta_window_actor_get_type (), MetaWindowActor);
#line 698 "../src/WindowManager.vala"
	_tmp4_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 698 "../src/WindowManager.vala"
	_tmp5_ = _tmp4_;
#line 698 "../src/WindowManager.vala"
	if (_tmp5_) {
#line 5976 "WindowManager.c"
		MetaWindowActor* _tmp6_;
#line 699 "../src/WindowManager.vala"
		_tmp6_ = bottom_actor;
#line 699 "../src/WindowManager.vala"
		gala_window_manager_gala_animate_bottom_window_scale (self, _tmp6_);
#line 5982 "WindowManager.c"
	}
#line 702 "../src/WindowManager.vala"
	_data11_->fade_out_duration = 900U;
#line 703 "../src/WindowManager.vala"
	_tmp7_ = g_new0 (gdouble, 2);
#line 703 "../src/WindowManager.vala"
	_tmp7_[0] = 0.1;
#line 703 "../src/WindowManager.vala"
	_tmp7_[1] = 0.9;
#line 703 "../src/WindowManager.vala"
	_data11_->op_keyframes = _tmp7_;
#line 703 "../src/WindowManager.vala"
	_data11_->op_keyframes_length1 = 2;
#line 703 "../src/WindowManager.vala"
	_data11_->_op_keyframes_size_ = _data11_->op_keyframes_length1;
#line 704 "../src/WindowManager.vala"
	g_value_init (&_tmp8_, G_TYPE_UINT);
#line 704 "../src/WindowManager.vala"
	g_value_set_uint (&_tmp8_, 20U);
#line 704 "../src/WindowManager.vala"
	g_value_init (&_tmp9_, G_TYPE_UINT);
#line 704 "../src/WindowManager.vala"
	g_value_set_uint (&_tmp9_, 20U);
#line 704 "../src/WindowManager.vala"
	_tmp10_ = g_new0 (GValue, 2);
#line 704 "../src/WindowManager.vala"
	_tmp10_[0] = _tmp8_;
#line 704 "../src/WindowManager.vala"
	_tmp10_[1] = _tmp9_;
#line 704 "../src/WindowManager.vala"
	_data11_->opacity = _tmp10_;
#line 704 "../src/WindowManager.vala"
	_data11_->opacity_length1 = 2;
#line 704 "../src/WindowManager.vala"
	_data11_->_opacity_size_ = _data11_->opacity_length1;
#line 706 "../src/WindowManager.vala"
	_tmp11_ = workspace;
#line 706 "../src/WindowManager.vala"
	_tmp12_ = meta_workspace_list_windows (_tmp11_);
#line 706 "../src/WindowManager.vala"
	_tmp13_ = _tmp12_;
#line 706 "../src/WindowManager.vala"
	g_list_foreach (_tmp13_, ___lambda142__gfunc, _data11_);
#line 706 "../src/WindowManager.vala"
	(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_list_free (_tmp13_), NULL));
#line 691 "../src/WindowManager.vala"
	block11_data_unref (_data11_);
#line 691 "../src/WindowManager.vala"
	_data11_ = NULL;
#line 6032 "WindowManager.c"
}

static void
gala_window_manager_gala_animate_bottom_window_scale (GalaWindowManagerGala* self,
                                                      MetaWindowActor* actor)
{
#line 741 "../src/WindowManager.vala"
	static const gchar* PROPS[2] = {"scale-x", "scale-y"};
#line 740 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 740 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 6045 "WindowManager.c"
	{
		const gchar** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
#line 743 "../src/WindowManager.vala"
		prop_collection = PROPS;
#line 743 "../src/WindowManager.vala"
		prop_collection_length1 = G_N_ELEMENTS (PROPS);
#line 743 "../src/WindowManager.vala"
		for (prop_it = 0; prop_it < prop_collection_length1; prop_it = prop_it + 1) {
#line 6057 "WindowManager.c"
			gchar* _tmp0_;
			gchar* prop = NULL;
#line 743 "../src/WindowManager.vala"
			_tmp0_ = g_strdup (prop_collection[prop_it]);
#line 743 "../src/WindowManager.vala"
			prop = _tmp0_;
#line 6064 "WindowManager.c"
			{
				gdouble* scale_keyframes = NULL;
				gdouble* _tmp1_;
				gint scale_keyframes_length1;
				gint _scale_keyframes_size_;
				GValue* scale = NULL;
				GValue _tmp2_ = {0};
				GValue _tmp3_ = {0};
				GValue _tmp4_ = {0};
				GValue* _tmp5_;
				gint scale_length1;
				gint _scale_size_;
				ClutterKeyframeTransition* scale_trans = NULL;
				const gchar* _tmp6_;
				ClutterKeyframeTransition* _tmp7_ = NULL;
				ClutterKeyframeTransition* _tmp8_;
				GValue _tmp9_ = {0};
				ClutterKeyframeTransition* _tmp10_;
				GValue _tmp11_ = {0};
				ClutterKeyframeTransition* _tmp12_;
				gdouble* _tmp13_;
				gint _tmp13__length1;
				ClutterKeyframeTransition* _tmp14_;
				GValue* _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				ClutterKeyframeTransition* _tmp19_;
#line 744 "../src/WindowManager.vala"
				_tmp1_ = g_new0 (gdouble, 3);
#line 744 "../src/WindowManager.vala"
				_tmp1_[0] = 0.2;
#line 744 "../src/WindowManager.vala"
				_tmp1_[1] = 0.3;
#line 744 "../src/WindowManager.vala"
				_tmp1_[2] = 0.8;
#line 744 "../src/WindowManager.vala"
				scale_keyframes = _tmp1_;
#line 744 "../src/WindowManager.vala"
				scale_keyframes_length1 = 3;
#line 744 "../src/WindowManager.vala"
				_scale_keyframes_size_ = scale_keyframes_length1;
#line 745 "../src/WindowManager.vala"
				g_value_init (&_tmp2_, G_TYPE_FLOAT);
#line 745 "../src/WindowManager.vala"
				g_value_set_float (&_tmp2_, 1.0f);
#line 745 "../src/WindowManager.vala"
				g_value_init (&_tmp3_, G_TYPE_FLOAT);
#line 745 "../src/WindowManager.vala"
				g_value_set_float (&_tmp3_, 1.07f);
#line 745 "../src/WindowManager.vala"
				g_value_init (&_tmp4_, G_TYPE_FLOAT);
#line 745 "../src/WindowManager.vala"
				g_value_set_float (&_tmp4_, 1.07f);
#line 745 "../src/WindowManager.vala"
				_tmp5_ = g_new0 (GValue, 3);
#line 745 "../src/WindowManager.vala"
				_tmp5_[0] = _tmp2_;
#line 745 "../src/WindowManager.vala"
				_tmp5_[1] = _tmp3_;
#line 745 "../src/WindowManager.vala"
				_tmp5_[2] = _tmp4_;
#line 745 "../src/WindowManager.vala"
				scale = _tmp5_;
#line 745 "../src/WindowManager.vala"
				scale_length1 = 3;
#line 745 "../src/WindowManager.vala"
				_scale_size_ = scale_length1;
#line 747 "../src/WindowManager.vala"
				_tmp6_ = prop;
#line 747 "../src/WindowManager.vala"
				_tmp7_ = (ClutterKeyframeTransition*) clutter_keyframe_transition_new (_tmp6_);
#line 747 "../src/WindowManager.vala"
				clutter_timeline_set_duration ((ClutterTimeline*) _tmp7_, (guint) 500);
#line 747 "../src/WindowManager.vala"
				clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp7_, TRUE);
#line 747 "../src/WindowManager.vala"
				clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp7_, CLUTTER_EASE_IN_QUAD);
#line 747 "../src/WindowManager.vala"
				scale_trans = _tmp7_;
#line 752 "../src/WindowManager.vala"
				_tmp8_ = scale_trans;
#line 752 "../src/WindowManager.vala"
				g_value_init (&_tmp9_, G_TYPE_FLOAT);
#line 752 "../src/WindowManager.vala"
				g_value_set_float (&_tmp9_, 1.0f);
#line 752 "../src/WindowManager.vala"
				clutter_transition_set_from_value ((ClutterTransition*) _tmp8_, &_tmp9_);
#line 752 "../src/WindowManager.vala"
				G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 753 "../src/WindowManager.vala"
				_tmp10_ = scale_trans;
#line 753 "../src/WindowManager.vala"
				g_value_init (&_tmp11_, G_TYPE_FLOAT);
#line 753 "../src/WindowManager.vala"
				g_value_set_float (&_tmp11_, 1.0f);
#line 753 "../src/WindowManager.vala"
				clutter_transition_set_to_value ((ClutterTransition*) _tmp10_, &_tmp11_);
#line 753 "../src/WindowManager.vala"
				G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
#line 754 "../src/WindowManager.vala"
				_tmp12_ = scale_trans;
#line 754 "../src/WindowManager.vala"
				_tmp13_ = scale_keyframes;
#line 754 "../src/WindowManager.vala"
				_tmp13__length1 = scale_keyframes_length1;
#line 754 "../src/WindowManager.vala"
				clutter_keyframe_transition_set_key_frames (_tmp12_, (guint) _tmp13__length1, _tmp13_);
#line 755 "../src/WindowManager.vala"
				_tmp14_ = scale_trans;
#line 755 "../src/WindowManager.vala"
				_tmp15_ = scale;
#line 755 "../src/WindowManager.vala"
				_tmp15__length1 = scale_length1;
#line 755 "../src/WindowManager.vala"
				clutter_keyframe_transition_set_values (_tmp14_, (guint) _tmp15__length1, _tmp15_);
#line 757 "../src/WindowManager.vala"
				_tmp16_ = prop;
#line 757 "../src/WindowManager.vala"
				_tmp17_ = g_strdup_printf ("magnify-%s", _tmp16_);
#line 757 "../src/WindowManager.vala"
				_tmp18_ = _tmp17_;
#line 757 "../src/WindowManager.vala"
				_tmp19_ = scale_trans;
#line 757 "../src/WindowManager.vala"
				clutter_actor_add_transition ((ClutterActor*) actor, _tmp18_, (ClutterTransition*) _tmp19_);
#line 757 "../src/WindowManager.vala"
				_g_free0 (_tmp18_);
#line 743 "../src/WindowManager.vala"
				_g_object_unref0 (scale_trans);
#line 743 "../src/WindowManager.vala"
				scale = (_vala_GValue_array_free (scale, scale_length1), NULL);
#line 743 "../src/WindowManager.vala"
				scale_keyframes = (g_free (scale_keyframes), NULL);
#line 743 "../src/WindowManager.vala"
				_g_free0 (prop);
#line 6202 "WindowManager.c"
			}
		}
	}
}

/**
         * {@inheritDoc}
         */
static void
gala_window_manager_gala_real_move_window (GalaWindowManager* base,
                                           MetaWindow* window,
                                           MetaWorkspace* workspace)
{
	GalaWindowManagerGala * self;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspace* active = NULL;
	MetaWorkspaceManager* _tmp3_;
	MetaWorkspace* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	MetaWorkspace* _tmp13_;
	MetaWindow* _tmp16_;
	MetaDisplay* _tmp17_;
#line 764 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 764 "../src/WindowManager.vala"
	g_return_if_fail (workspace != NULL);
#line 765 "../src/WindowManager.vala"
	if (window == NULL) {
#line 766 "../src/WindowManager.vala"
		return;
#line 6238 "WindowManager.c"
	}
#line 769 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 769 "../src/WindowManager.vala"
	display = _tmp0_;
#line 770 "../src/WindowManager.vala"
	_tmp1_ = display;
#line 770 "../src/WindowManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 770 "../src/WindowManager.vala"
	manager = _tmp2_;
#line 772 "../src/WindowManager.vala"
	_tmp3_ = manager;
#line 772 "../src/WindowManager.vala"
	_tmp4_ = meta_workspace_manager_get_active_workspace (_tmp3_);
#line 772 "../src/WindowManager.vala"
	active = _tmp4_;
#line 775 "../src/WindowManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 6258 "WindowManager.c"
		MetaWorkspace* _tmp7_;
#line 775 "../src/WindowManager.vala"
		_tmp7_ = active;
#line 775 "../src/WindowManager.vala"
		_tmp6_ = gala_utils_get_n_windows (_tmp7_, FALSE) == ((guint) 1);
#line 6264 "WindowManager.c"
	} else {
#line 775 "../src/WindowManager.vala"
		_tmp6_ = FALSE;
#line 6268 "WindowManager.c"
	}
#line 775 "../src/WindowManager.vala"
	if (_tmp6_) {
#line 6272 "WindowManager.c"
		MetaWorkspaceManager* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 775 "../src/WindowManager.vala"
		_tmp8_ = manager;
#line 775 "../src/WindowManager.vala"
		_tmp9_ = meta_workspace_manager_get_n_workspaces (_tmp8_);
#line 775 "../src/WindowManager.vala"
		_tmp10_ = _tmp9_;
#line 775 "../src/WindowManager.vala"
		_tmp5_ = meta_workspace_index (workspace) == (_tmp10_ - 1);
#line 6284 "WindowManager.c"
	} else {
#line 775 "../src/WindowManager.vala"
		_tmp5_ = FALSE;
#line 6288 "WindowManager.c"
	}
#line 775 "../src/WindowManager.vala"
	if (_tmp5_) {
#line 6292 "WindowManager.c"
		ClutterBackend* _tmp11_;
		ClutterSeat* _tmp12_;
#line 776 "../src/WindowManager.vala"
		_tmp11_ = clutter_get_default_backend ();
#line 776 "../src/WindowManager.vala"
		_tmp12_ = clutter_backend_get_default_seat (_tmp11_);
#line 776 "../src/WindowManager.vala"
		clutter_seat_bell_notify (_tmp12_);
#line 777 "../src/WindowManager.vala"
		return;
#line 6303 "WindowManager.c"
	}
#line 781 "../src/WindowManager.vala"
	_tmp13_ = active;
#line 781 "../src/WindowManager.vala"
	if (_tmp13_ == workspace) {
#line 6309 "WindowManager.c"
		ClutterBackend* _tmp14_;
		ClutterSeat* _tmp15_;
#line 782 "../src/WindowManager.vala"
		_tmp14_ = clutter_get_default_backend ();
#line 782 "../src/WindowManager.vala"
		_tmp15_ = clutter_backend_get_default_seat (_tmp14_);
#line 782 "../src/WindowManager.vala"
		clutter_seat_bell_notify (_tmp15_);
#line 783 "../src/WindowManager.vala"
		return;
#line 6320 "WindowManager.c"
	}
#line 786 "../src/WindowManager.vala"
	_tmp16_ = _g_object_ref0 (window);
#line 786 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->moving);
#line 786 "../src/WindowManager.vala"
	self->priv->moving = _tmp16_;
#line 788 "../src/WindowManager.vala"
	if (!meta_window_is_on_all_workspaces (window)) {
#line 789 "../src/WindowManager.vala"
		meta_window_change_workspace (window, workspace);
#line 6332 "WindowManager.c"
	}
#line 792 "../src/WindowManager.vala"
	_tmp17_ = display;
#line 792 "../src/WindowManager.vala"
	meta_workspace_activate_with_focus (workspace, window, meta_display_get_current_time (_tmp17_));
#line 6338 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static GalaModalProxy*
gala_window_manager_gala_real_push_modal (GalaWindowManager* base,
                                          ClutterActor* actor)
{
	GalaWindowManagerGala * self;
	GalaModalProxy* proxy = NULL;
	GalaModalProxy* _tmp0_;
	GeeLinkedList* _tmp1_;
	GalaModalProxy* _tmp2_;
	GeeLinkedList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp6_;
	GalaModalProxy* _tmp7_;
	ClutterStage* _tmp8_;
	ClutterStage* _tmp9_;
	ClutterGrab* _tmp10_;
	ClutterGrab* _tmp11_;
	GeeLinkedList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GalaModalProxy* result;
#line 798 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 798 "../src/WindowManager.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 799 "../src/WindowManager.vala"
	_tmp0_ = gala_modal_proxy_new ();
#line 799 "../src/WindowManager.vala"
	proxy = _tmp0_;
#line 801 "../src/WindowManager.vala"
	_tmp1_ = self->priv->modal_stack;
#line 801 "../src/WindowManager.vala"
	_tmp2_ = proxy;
#line 801 "../src/WindowManager.vala"
	gee_deque_offer_head ((GeeDeque*) _tmp1_, _tmp2_);
#line 804 "../src/WindowManager.vala"
	_tmp3_ = self->priv->modal_stack;
#line 804 "../src/WindowManager.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 804 "../src/WindowManager.vala"
	_tmp5_ = _tmp4_;
#line 804 "../src/WindowManager.vala"
	if (_tmp5_ >= 2) {
#line 805 "../src/WindowManager.vala"
		result = proxy;
#line 805 "../src/WindowManager.vala"
		return result;
#line 6393 "WindowManager.c"
	}
#line 807 "../src/WindowManager.vala"
	_tmp6_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 807 "../src/WindowManager.vala"
	display = _tmp6_;
#line 809 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area (self);
#line 810 "../src/WindowManager.vala"
	_tmp7_ = proxy;
#line 810 "../src/WindowManager.vala"
	_tmp8_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 810 "../src/WindowManager.vala"
	_tmp9_ = _tmp8_;
#line 810 "../src/WindowManager.vala"
	_tmp10_ = clutter_stage_grab (_tmp9_, actor);
#line 810 "../src/WindowManager.vala"
	_tmp11_ = _tmp10_;
#line 810 "../src/WindowManager.vala"
	gala_modal_proxy_set_grab (_tmp7_, _tmp11_);
#line 810 "../src/WindowManager.vala"
	_clutter_grab_unref0 (_tmp11_);
#line 812 "../src/WindowManager.vala"
	_tmp12_ = self->priv->modal_stack;
#line 812 "../src/WindowManager.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 812 "../src/WindowManager.vala"
	_tmp14_ = _tmp13_;
#line 812 "../src/WindowManager.vala"
	if (_tmp14_ == 1) {
#line 6423 "WindowManager.c"
		MetaDisplay* _tmp15_;
#line 813 "../src/WindowManager.vala"
		_tmp15_ = display;
#line 813 "../src/WindowManager.vala"
		meta_disable_unredirect_for_display (_tmp15_);
#line 6429 "WindowManager.c"
	}
#line 816 "../src/WindowManager.vala"
	result = proxy;
#line 816 "../src/WindowManager.vala"
	return result;
#line 6435 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static void
gala_window_manager_gala_real_pop_modal (GalaWindowManager* base,
                                         GalaModalProxy* proxy)
{
	GalaWindowManagerGala * self;
	GeeLinkedList* _tmp0_;
	ClutterGrab* _tmp1_;
	ClutterGrab* _tmp2_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
#line 822 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 822 "../src/WindowManager.vala"
	g_return_if_fail (proxy != NULL);
#line 823 "../src/WindowManager.vala"
	_tmp0_ = self->priv->modal_stack;
#line 823 "../src/WindowManager.vala"
	if (!gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, proxy)) {
#line 824 "../src/WindowManager.vala"
		g_warning ("WindowManager.vala:824: Attempted to remove a modal proxy that was not" \
" in the stack");
#line 825 "../src/WindowManager.vala"
		return;
#line 6464 "WindowManager.c"
	}
#line 828 "../src/WindowManager.vala"
	_tmp1_ = gala_modal_proxy_get_grab (proxy);
#line 828 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 828 "../src/WindowManager.vala"
	clutter_grab_dismiss (_tmp2_);
#line 830 "../src/WindowManager.vala"
	if (gala_window_manager_is_modal ((GalaWindowManager*) self)) {
#line 831 "../src/WindowManager.vala"
		return;
#line 6476 "WindowManager.c"
	}
#line 833 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area (self);
#line 835 "../src/WindowManager.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 835 "../src/WindowManager.vala"
	display = _tmp3_;
#line 837 "../src/WindowManager.vala"
	_tmp4_ = display;
#line 837 "../src/WindowManager.vala"
	meta_enable_unredirect_for_display (_tmp4_);
#line 6488 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
gala_window_manager_gala_real_is_modal (GalaWindowManager* base)
{
	GalaWindowManagerGala * self;
	GeeLinkedList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 843 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 844 "../src/WindowManager.vala"
	_tmp0_ = self->priv->modal_stack;
#line 844 "../src/WindowManager.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 844 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 844 "../src/WindowManager.vala"
	result = !_tmp2_;
#line 844 "../src/WindowManager.vala"
	return result;
#line 6514 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
gala_window_manager_gala_real_modal_proxy_valid (GalaWindowManager* base,
                                                 GalaModalProxy* proxy)
{
	GalaWindowManagerGala * self;
	GeeLinkedList* _tmp0_;
	gboolean result;
#line 850 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 850 "../src/WindowManager.vala"
	g_return_val_if_fail (proxy != NULL, FALSE);
#line 851 "../src/WindowManager.vala"
	_tmp0_ = self->priv->modal_stack;
#line 851 "../src/WindowManager.vala"
	result = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, proxy);
#line 851 "../src/WindowManager.vala"
	return result;
#line 6537 "WindowManager.c"
}

static gpointer
_vala_g_hash_table_take (GHashTable* self,
                         gconstpointer key,
                         gboolean* exists)
{
	gboolean _vala_exists = FALSE;
	GHashTable* ht = NULL;
	void** htp = NULL;
	gconstpointer _tmp0_;
	gpointer result;
#line 5652 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5653 "glib-2.0.vapi"
	ht = NULL;
#line 5654 "glib-2.0.vapi"
	htp = &ht;
#line 5655 "glib-2.0.vapi"
	_tmp0_ = g_hash_table_lookup (self, key);
#line 5655 "glib-2.0.vapi"
	*htp = _tmp0_;
#line 5656 "glib-2.0.vapi"
	_vala_exists = g_hash_table_steal (self, key);
#line 5657 "glib-2.0.vapi"
	result = ht;
#line 5657 "glib-2.0.vapi"
	if (exists) {
#line 5657 "glib-2.0.vapi"
		*exists = _vala_exists;
#line 6568 "WindowManager.c"
	}
#line 5657 "glib-2.0.vapi"
	return result;
#line 6572 "WindowManager.c"
}

static void
gala_window_manager_gala_dim_parent_window (GalaWindowManagerGala* self,
                                            MetaWindow* window,
                                            gboolean dim)
{
	MetaWindow* transient = NULL;
	MetaWindow* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MetaWindow* _tmp2_;
#line 857 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 857 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 858 "../src/WindowManager.vala"
	_tmp0_ = meta_window_get_transient_for (window);
#line 858 "../src/WindowManager.vala"
	transient = _tmp0_;
#line 859 "../src/WindowManager.vala"
	_tmp2_ = transient;
#line 859 "../src/WindowManager.vala"
	if (_tmp2_ != NULL) {
#line 6596 "WindowManager.c"
		MetaWindow* _tmp3_;
#line 859 "../src/WindowManager.vala"
		_tmp3_ = transient;
#line 859 "../src/WindowManager.vala"
		_tmp1_ = _tmp3_ != window;
#line 6602 "WindowManager.c"
	} else {
#line 859 "../src/WindowManager.vala"
		_tmp1_ = FALSE;
#line 6606 "WindowManager.c"
	}
#line 859 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 6610 "WindowManager.c"
		MetaWindowActor* transient_actor = NULL;
		MetaWindow* _tmp4_;
		GObject* _tmp5_;
#line 860 "../src/WindowManager.vala"
		_tmp4_ = transient;
#line 860 "../src/WindowManager.vala"
		_tmp5_ = meta_window_get_compositor_private (_tmp4_);
#line 860 "../src/WindowManager.vala"
		transient_actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, meta_window_actor_get_type (), MetaWindowActor);
#line 862 "../src/WindowManager.vala"
		if (dim) {
#line 6622 "WindowManager.c"
			MetaWindowType _tmp6_;
			MetaWindowType _tmp7_;
#line 863 "../src/WindowManager.vala"
			_tmp6_ = meta_window_get_window_type (window);
#line 863 "../src/WindowManager.vala"
			_tmp7_ = _tmp6_;
#line 863 "../src/WindowManager.vala"
			if (_tmp7_ == META_WINDOW_MODAL_DIALOG) {
#line 6631 "WindowManager.c"
				ClutterBrightnessContrastEffect* dark_effect = NULL;
				ClutterBrightnessContrastEffect* _tmp8_;
				ClutterBrightnessContrastEffect* _tmp9_;
				MetaWindowActor* _tmp10_;
				ClutterBrightnessContrastEffect* _tmp11_;
				GHashTable* _tmp12_;
				MetaWindow* _tmp13_;
				MetaWindowActor* _tmp14_;
#line 864 "../src/WindowManager.vala"
				_tmp8_ = (ClutterBrightnessContrastEffect*) clutter_brightness_contrast_effect_new ();
#line 864 "../src/WindowManager.vala"
				g_object_ref_sink (_tmp8_);
#line 864 "../src/WindowManager.vala"
				dark_effect = _tmp8_;
#line 865 "../src/WindowManager.vala"
				_tmp9_ = dark_effect;
#line 865 "../src/WindowManager.vala"
				clutter_brightness_contrast_effect_set_brightness (_tmp9_, -0.4f);
#line 866 "../src/WindowManager.vala"
				_tmp10_ = transient_actor;
#line 866 "../src/WindowManager.vala"
				_tmp11_ = dark_effect;
#line 866 "../src/WindowManager.vala"
				clutter_actor_add_effect_with_name ((ClutterActor*) _tmp10_, "dim-parent", (ClutterEffect*) _tmp11_);
#line 868 "../src/WindowManager.vala"
				_tmp12_ = self->priv->dim_table;
#line 868 "../src/WindowManager.vala"
				_tmp13_ = _g_object_ref0 (window);
#line 868 "../src/WindowManager.vala"
				_tmp14_ = transient_actor;
#line 868 "../src/WindowManager.vala"
				g_hash_table_insert (_tmp12_, _tmp13_, _tmp14_);
#line 863 "../src/WindowManager.vala"
				_g_object_unref0 (dark_effect);
#line 6666 "WindowManager.c"
			}
		} else {
			MetaWindowActor* _tmp15_;
			ClutterEffect* _tmp16_;
#line 870 "../src/WindowManager.vala"
			_tmp15_ = transient_actor;
#line 870 "../src/WindowManager.vala"
			_tmp16_ = clutter_actor_get_effect ((ClutterActor*) _tmp15_, "dim-parent");
#line 870 "../src/WindowManager.vala"
			if (_tmp16_ != NULL) {
#line 6677 "WindowManager.c"
				MetaWindowActor* _tmp17_;
				GHashTable* _tmp18_;
#line 871 "../src/WindowManager.vala"
				_tmp17_ = transient_actor;
#line 871 "../src/WindowManager.vala"
				clutter_actor_remove_effect_by_name ((ClutterActor*) _tmp17_, "dim-parent");
#line 872 "../src/WindowManager.vala"
				_tmp18_ = self->priv->dim_table;
#line 872 "../src/WindowManager.vala"
				g_hash_table_remove (_tmp18_, window);
#line 6688 "WindowManager.c"
			}
		}
#line 875 "../src/WindowManager.vala"
		return;
#line 6693 "WindowManager.c"
	}
#line 878 "../src/WindowManager.vala"
	if (!dim) {
#line 6697 "WindowManager.c"
		MetaWindowActor* transient_actor = NULL;
		GHashTable* _tmp19_;
		gpointer _tmp20_;
		MetaWindowActor* _tmp21_;
#line 880 "../src/WindowManager.vala"
		_tmp19_ = self->priv->dim_table;
#line 880 "../src/WindowManager.vala"
		_tmp20_ = _vala_g_hash_table_take (_tmp19_, window, NULL);
#line 880 "../src/WindowManager.vala"
		transient_actor = (MetaWindowActor*) _tmp20_;
#line 881 "../src/WindowManager.vala"
		_tmp21_ = transient_actor;
#line 881 "../src/WindowManager.vala"
		if (_tmp21_ != NULL) {
#line 6712 "WindowManager.c"
			MetaWindowActor* _tmp22_;
#line 882 "../src/WindowManager.vala"
			_tmp22_ = transient_actor;
#line 882 "../src/WindowManager.vala"
			clutter_actor_remove_effect_by_name ((ClutterActor*) _tmp22_, "dim-parent");
#line 883 "../src/WindowManager.vala"
			g_debug ("WindowManager.vala:883: Removed dim using dim_data");
#line 6720 "WindowManager.c"
		}
	}
}

/**
         * {@inheritDoc}
         */
static GVariant*
_variant_new6 (gboolean value)
{
#line 1001 "../src/WindowManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 6733 "WindowManager.c"
}

static void
gala_window_manager_gala_real_perform_action (GalaWindowManager* base,
                                              GalaActionType type)
{
	GalaWindowManagerGala * self;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	MetaWindow* current = NULL;
	MetaDisplay* _tmp1_;
	MetaWindow* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 891 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 892 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 892 "../src/WindowManager.vala"
	display = _tmp0_;
#line 893 "../src/WindowManager.vala"
	_tmp1_ = display;
#line 893 "../src/WindowManager.vala"
	_tmp2_ = meta_display_get_focus_window (_tmp1_);
#line 893 "../src/WindowManager.vala"
	current = _tmp2_;
#line 895 "../src/WindowManager.vala"
	switch (type) {
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SHOW_WORKSPACE_VIEW:
#line 6763 "WindowManager.c"
		{
			GalaActivatableComponent* _tmp3_;
			GalaActivatableComponent* _tmp4_;
			GalaActivatableComponent* _tmp5_;
			GalaActivatableComponent* _tmp6_;
#line 897 "../src/WindowManager.vala"
			_tmp3_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 897 "../src/WindowManager.vala"
			_tmp4_ = _tmp3_;
#line 897 "../src/WindowManager.vala"
			if (_tmp4_ == NULL) {
#line 898 "../src/WindowManager.vala"
				break;
#line 6777 "WindowManager.c"
			}
#line 900 "../src/WindowManager.vala"
			_tmp5_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 900 "../src/WindowManager.vala"
			_tmp6_ = _tmp5_;
#line 900 "../src/WindowManager.vala"
			if (gala_activatable_component_is_opened (_tmp6_)) {
#line 6785 "WindowManager.c"
				GalaActivatableComponent* _tmp7_;
				GalaActivatableComponent* _tmp8_;
#line 901 "../src/WindowManager.vala"
				_tmp7_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 901 "../src/WindowManager.vala"
				_tmp8_ = _tmp7_;
#line 901 "../src/WindowManager.vala"
				gala_activatable_component_close (_tmp8_, NULL);
#line 6794 "WindowManager.c"
			} else {
				GalaActivatableComponent* _tmp9_;
				GalaActivatableComponent* _tmp10_;
#line 903 "../src/WindowManager.vala"
				_tmp9_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 903 "../src/WindowManager.vala"
				_tmp10_ = _tmp9_;
#line 903 "../src/WindowManager.vala"
				gala_activatable_component_open (_tmp10_, NULL);
#line 6804 "WindowManager.c"
			}
#line 904 "../src/WindowManager.vala"
			break;
#line 6808 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_MAXIMIZE_CURRENT:
#line 6812 "WindowManager.c"
		{
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			MetaWindow* _tmp13_;
			MetaMaximizeFlags maximize_flags = 0U;
			MetaWindow* _tmp18_;
			gboolean _tmp19_ = FALSE;
#line 906 "../src/WindowManager.vala"
			_tmp13_ = current;
#line 906 "../src/WindowManager.vala"
			if (_tmp13_ == NULL) {
#line 906 "../src/WindowManager.vala"
				_tmp12_ = TRUE;
#line 6826 "WindowManager.c"
			} else {
				MetaWindow* _tmp14_;
				MetaWindowType _tmp15_;
				MetaWindowType _tmp16_;
#line 906 "../src/WindowManager.vala"
				_tmp14_ = current;
#line 906 "../src/WindowManager.vala"
				_tmp15_ = meta_window_get_window_type (_tmp14_);
#line 906 "../src/WindowManager.vala"
				_tmp16_ = _tmp15_;
#line 906 "../src/WindowManager.vala"
				_tmp12_ = _tmp16_ != META_WINDOW_NORMAL;
#line 6839 "WindowManager.c"
			}
#line 906 "../src/WindowManager.vala"
			if (_tmp12_) {
#line 906 "../src/WindowManager.vala"
				_tmp11_ = TRUE;
#line 6845 "WindowManager.c"
			} else {
				MetaWindow* _tmp17_;
#line 906 "../src/WindowManager.vala"
				_tmp17_ = current;
#line 906 "../src/WindowManager.vala"
				_tmp11_ = !meta_window_can_maximize (_tmp17_);
#line 6852 "WindowManager.c"
			}
#line 906 "../src/WindowManager.vala"
			if (_tmp11_) {
#line 907 "../src/WindowManager.vala"
				break;
#line 6858 "WindowManager.c"
			}
#line 909 "../src/WindowManager.vala"
			_tmp18_ = current;
#line 909 "../src/WindowManager.vala"
			maximize_flags = meta_window_get_maximized (_tmp18_);
#line 910 "../src/WindowManager.vala"
			if ((maximize_flags & META_MAXIMIZE_VERTICAL) == META_MAXIMIZE_VERTICAL) {
#line 910 "../src/WindowManager.vala"
				_tmp19_ = TRUE;
#line 6868 "WindowManager.c"
			} else {
#line 910 "../src/WindowManager.vala"
				_tmp19_ = (maximize_flags & META_MAXIMIZE_HORIZONTAL) == META_MAXIMIZE_HORIZONTAL;
#line 6872 "WindowManager.c"
			}
#line 910 "../src/WindowManager.vala"
			if (_tmp19_) {
#line 6876 "WindowManager.c"
				MetaWindow* _tmp20_;
#line 911 "../src/WindowManager.vala"
				_tmp20_ = current;
#line 911 "../src/WindowManager.vala"
				meta_window_unmaximize (_tmp20_, META_MAXIMIZE_HORIZONTAL | META_MAXIMIZE_VERTICAL);
#line 6882 "WindowManager.c"
			} else {
				MetaWindow* _tmp21_;
#line 913 "../src/WindowManager.vala"
				_tmp21_ = current;
#line 913 "../src/WindowManager.vala"
				meta_window_maximize (_tmp21_, META_MAXIMIZE_HORIZONTAL | META_MAXIMIZE_VERTICAL);
#line 6889 "WindowManager.c"
			}
#line 914 "../src/WindowManager.vala"
			break;
#line 6893 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_HIDE_CURRENT:
#line 6897 "WindowManager.c"
		{
			gboolean _tmp22_ = FALSE;
			MetaWindow* _tmp23_;
#line 916 "../src/WindowManager.vala"
			_tmp23_ = current;
#line 916 "../src/WindowManager.vala"
			if (_tmp23_ != NULL) {
#line 6905 "WindowManager.c"
				MetaWindow* _tmp24_;
				MetaWindowType _tmp25_;
				MetaWindowType _tmp26_;
#line 916 "../src/WindowManager.vala"
				_tmp24_ = current;
#line 916 "../src/WindowManager.vala"
				_tmp25_ = meta_window_get_window_type (_tmp24_);
#line 916 "../src/WindowManager.vala"
				_tmp26_ = _tmp25_;
#line 916 "../src/WindowManager.vala"
				_tmp22_ = _tmp26_ == META_WINDOW_NORMAL;
#line 6917 "WindowManager.c"
			} else {
#line 916 "../src/WindowManager.vala"
				_tmp22_ = FALSE;
#line 6921 "WindowManager.c"
			}
#line 916 "../src/WindowManager.vala"
			if (_tmp22_) {
#line 6925 "WindowManager.c"
				MetaWindow* _tmp27_;
#line 917 "../src/WindowManager.vala"
				_tmp27_ = current;
#line 917 "../src/WindowManager.vala"
				meta_window_minimize (_tmp27_);
#line 6931 "WindowManager.c"
			}
#line 918 "../src/WindowManager.vala"
			break;
#line 6935 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_START_MOVE_CURRENT:
#line 6939 "WindowManager.c"
		{
			gboolean _tmp28_ = FALSE;
			MetaWindow* _tmp29_;
#line 920 "../src/WindowManager.vala"
			_tmp29_ = current;
#line 920 "../src/WindowManager.vala"
			if (_tmp29_ != NULL) {
#line 6947 "WindowManager.c"
				MetaWindow* _tmp30_;
#line 920 "../src/WindowManager.vala"
				_tmp30_ = current;
#line 920 "../src/WindowManager.vala"
				_tmp28_ = meta_window_allows_move (_tmp30_);
#line 6953 "WindowManager.c"
			} else {
#line 920 "../src/WindowManager.vala"
				_tmp28_ = FALSE;
#line 6957 "WindowManager.c"
			}
#line 920 "../src/WindowManager.vala"
			if (_tmp28_) {
#line 6961 "WindowManager.c"
				MetaWindow* _tmp31_;
#line 922 "../src/WindowManager.vala"
				_tmp31_ = current;
#line 922 "../src/WindowManager.vala"
				meta_window_begin_grab_op (_tmp31_, META_GRAB_OP_KEYBOARD_MOVING, NULL, NULL, gtk_get_current_event_time ());
#line 6967 "WindowManager.c"
			}
#line 926 "../src/WindowManager.vala"
			break;
#line 6971 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_START_RESIZE_CURRENT:
#line 6975 "WindowManager.c"
		{
			gboolean _tmp32_ = FALSE;
			MetaWindow* _tmp33_;
#line 928 "../src/WindowManager.vala"
			_tmp33_ = current;
#line 928 "../src/WindowManager.vala"
			if (_tmp33_ != NULL) {
#line 6983 "WindowManager.c"
				MetaWindow* _tmp34_;
#line 928 "../src/WindowManager.vala"
				_tmp34_ = current;
#line 928 "../src/WindowManager.vala"
				_tmp32_ = meta_window_allows_resize (_tmp34_);
#line 6989 "WindowManager.c"
			} else {
#line 928 "../src/WindowManager.vala"
				_tmp32_ = FALSE;
#line 6993 "WindowManager.c"
			}
#line 928 "../src/WindowManager.vala"
			if (_tmp32_) {
#line 6997 "WindowManager.c"
				MetaWindow* _tmp35_;
#line 930 "../src/WindowManager.vala"
				_tmp35_ = current;
#line 930 "../src/WindowManager.vala"
				meta_window_begin_grab_op (_tmp35_, META_GRAB_OP_KEYBOARD_RESIZING_UNKNOWN, NULL, NULL, gtk_get_current_event_time ());
#line 7003 "WindowManager.c"
			}
#line 934 "../src/WindowManager.vala"
			break;
#line 7007 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_TOP_CURRENT:
#line 7011 "WindowManager.c"
		{
			MetaWindow* _tmp36_;
			MetaWindow* _tmp37_;
#line 936 "../src/WindowManager.vala"
			_tmp36_ = current;
#line 936 "../src/WindowManager.vala"
			if (_tmp36_ == NULL) {
#line 937 "../src/WindowManager.vala"
				break;
#line 7021 "WindowManager.c"
			}
#line 939 "../src/WindowManager.vala"
			_tmp37_ = current;
#line 939 "../src/WindowManager.vala"
			if (meta_window_is_above (_tmp37_)) {
#line 7027 "WindowManager.c"
				MetaWindow* _tmp38_;
#line 940 "../src/WindowManager.vala"
				_tmp38_ = current;
#line 940 "../src/WindowManager.vala"
				meta_window_unmake_above (_tmp38_);
#line 7033 "WindowManager.c"
			} else {
				MetaWindow* _tmp39_;
#line 942 "../src/WindowManager.vala"
				_tmp39_ = current;
#line 942 "../src/WindowManager.vala"
				meta_window_make_above (_tmp39_);
#line 7040 "WindowManager.c"
			}
#line 943 "../src/WindowManager.vala"
			break;
#line 7044 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_VISIBLE_WORKSPACE_CURRENT:
#line 7048 "WindowManager.c"
		{
			MetaWindow* _tmp40_;
			MetaWindow* _tmp41_;
			gboolean _tmp42_;
			gboolean _tmp43_;
#line 945 "../src/WindowManager.vala"
			_tmp40_ = current;
#line 945 "../src/WindowManager.vala"
			if (_tmp40_ == NULL) {
#line 946 "../src/WindowManager.vala"
				break;
#line 7060 "WindowManager.c"
			}
#line 948 "../src/WindowManager.vala"
			_tmp41_ = current;
#line 948 "../src/WindowManager.vala"
			g_object_get (_tmp41_, "on-all-workspaces", &_tmp42_, NULL);
#line 948 "../src/WindowManager.vala"
			_tmp43_ = _tmp42_;
#line 948 "../src/WindowManager.vala"
			if (_tmp43_) {
#line 7070 "WindowManager.c"
				MetaWindow* _tmp44_;
#line 949 "../src/WindowManager.vala"
				_tmp44_ = current;
#line 949 "../src/WindowManager.vala"
				meta_window_unstick (_tmp44_);
#line 7076 "WindowManager.c"
			} else {
				MetaWindow* _tmp45_;
#line 951 "../src/WindowManager.vala"
				_tmp45_ = current;
#line 951 "../src/WindowManager.vala"
				meta_window_stick (_tmp45_);
#line 7083 "WindowManager.c"
			}
#line 952 "../src/WindowManager.vala"
			break;
#line 7087 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_PREVIOUS:
#line 7091 "WindowManager.c"
		{
#line 954 "../src/WindowManager.vala"
			gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, META_MOTION_LEFT);
#line 955 "../src/WindowManager.vala"
			break;
#line 7097 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_NEXT:
#line 7101 "WindowManager.c"
		{
#line 957 "../src/WindowManager.vala"
			gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, META_MOTION_RIGHT);
#line 958 "../src/WindowManager.vala"
			break;
#line 7107 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_LEFT:
#line 7111 "WindowManager.c"
		{
			MetaWorkspaceManager* workspace_manager = NULL;
			MetaDisplay* _tmp46_;
			MetaWorkspaceManager* _tmp47_;
			MetaWorkspace* active_workspace = NULL;
			MetaWorkspaceManager* _tmp48_;
			MetaWorkspace* _tmp49_;
			MetaWorkspace* target_workspace = NULL;
			MetaWorkspace* _tmp50_;
			MetaWorkspace* _tmp51_;
			MetaWindow* _tmp52_;
			MetaWorkspace* _tmp53_;
#line 960 "../src/WindowManager.vala"
			_tmp46_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 960 "../src/WindowManager.vala"
			_tmp47_ = meta_display_get_workspace_manager (_tmp46_);
#line 960 "../src/WindowManager.vala"
			workspace_manager = _tmp47_;
#line 961 "../src/WindowManager.vala"
			_tmp48_ = workspace_manager;
#line 961 "../src/WindowManager.vala"
			_tmp49_ = meta_workspace_manager_get_active_workspace (_tmp48_);
#line 961 "../src/WindowManager.vala"
			active_workspace = _tmp49_;
#line 962 "../src/WindowManager.vala"
			_tmp50_ = active_workspace;
#line 962 "../src/WindowManager.vala"
			_tmp51_ = meta_workspace_get_neighbor (_tmp50_, META_MOTION_LEFT);
#line 962 "../src/WindowManager.vala"
			target_workspace = _tmp51_;
#line 963 "../src/WindowManager.vala"
			_tmp52_ = current;
#line 963 "../src/WindowManager.vala"
			_tmp53_ = target_workspace;
#line 963 "../src/WindowManager.vala"
			gala_window_manager_move_window ((GalaWindowManager*) self, _tmp52_, _tmp53_);
#line 964 "../src/WindowManager.vala"
			break;
#line 7150 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_RIGHT:
#line 7154 "WindowManager.c"
		{
			MetaWorkspaceManager* workspace_manager = NULL;
			MetaDisplay* _tmp54_;
			MetaWorkspaceManager* _tmp55_;
			MetaWorkspace* active_workspace = NULL;
			MetaWorkspaceManager* _tmp56_;
			MetaWorkspace* _tmp57_;
			MetaWorkspace* target_workspace = NULL;
			MetaWorkspace* _tmp58_;
			MetaWorkspace* _tmp59_;
			MetaWindow* _tmp60_;
			MetaWorkspace* _tmp61_;
#line 966 "../src/WindowManager.vala"
			_tmp54_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 966 "../src/WindowManager.vala"
			_tmp55_ = meta_display_get_workspace_manager (_tmp54_);
#line 966 "../src/WindowManager.vala"
			workspace_manager = _tmp55_;
#line 967 "../src/WindowManager.vala"
			_tmp56_ = workspace_manager;
#line 967 "../src/WindowManager.vala"
			_tmp57_ = meta_workspace_manager_get_active_workspace (_tmp56_);
#line 967 "../src/WindowManager.vala"
			active_workspace = _tmp57_;
#line 968 "../src/WindowManager.vala"
			_tmp58_ = active_workspace;
#line 968 "../src/WindowManager.vala"
			_tmp59_ = meta_workspace_get_neighbor (_tmp58_, META_MOTION_RIGHT);
#line 968 "../src/WindowManager.vala"
			target_workspace = _tmp59_;
#line 969 "../src/WindowManager.vala"
			_tmp60_ = current;
#line 969 "../src/WindowManager.vala"
			_tmp61_ = target_workspace;
#line 969 "../src/WindowManager.vala"
			gala_window_manager_move_window ((GalaWindowManager*) self, _tmp60_, _tmp61_);
#line 970 "../src/WindowManager.vala"
			break;
#line 7193 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_CLOSE_CURRENT:
#line 7197 "WindowManager.c"
		{
			gboolean _tmp62_ = FALSE;
			MetaWindow* _tmp63_;
#line 972 "../src/WindowManager.vala"
			_tmp63_ = current;
#line 972 "../src/WindowManager.vala"
			if (_tmp63_ != NULL) {
#line 7205 "WindowManager.c"
				MetaWindow* _tmp64_;
#line 972 "../src/WindowManager.vala"
				_tmp64_ = current;
#line 972 "../src/WindowManager.vala"
				_tmp62_ = meta_window_can_close (_tmp64_);
#line 7211 "WindowManager.c"
			} else {
#line 972 "../src/WindowManager.vala"
				_tmp62_ = FALSE;
#line 7215 "WindowManager.c"
			}
#line 972 "../src/WindowManager.vala"
			if (_tmp62_) {
#line 7219 "WindowManager.c"
				MetaWindow* _tmp65_;
#line 973 "../src/WindowManager.vala"
				_tmp65_ = current;
#line 973 "../src/WindowManager.vala"
				meta_window_delete (_tmp65_, gtk_get_current_event_time ());
#line 7225 "WindowManager.c"
			}
#line 974 "../src/WindowManager.vala"
			break;
#line 7229 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_OPEN_LAUNCHER:
#line 7233 "WindowManager.c"
		{
			{
				GSettings* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
#line 977 "../src/WindowManager.vala"
				_tmp66_ = self->priv->behavior_settings;
#line 977 "../src/WindowManager.vala"
				_tmp67_ = g_settings_get_string (_tmp66_, "panel-main-menu-action");
#line 977 "../src/WindowManager.vala"
				_tmp68_ = _tmp67_;
#line 977 "../src/WindowManager.vala"
				g_spawn_command_line_async (_tmp68_, &_inner_error0_);
#line 977 "../src/WindowManager.vala"
				_g_free0 (_tmp68_);
#line 977 "../src/WindowManager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7251 "WindowManager.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp69_;
				const gchar* _tmp70_;
#line 976 "../src/WindowManager.vala"
				e = _inner_error0_;
#line 976 "../src/WindowManager.vala"
				_inner_error0_ = NULL;
#line 981 "../src/WindowManager.vala"
				_tmp69_ = e;
#line 981 "../src/WindowManager.vala"
				_tmp70_ = _tmp69_->message;
#line 981 "../src/WindowManager.vala"
				g_warning ("WindowManager.vala:981: %s", _tmp70_);
#line 976 "../src/WindowManager.vala"
				_g_error_free0 (e);
#line 7273 "WindowManager.c"
			}
			__finally0:
#line 976 "../src/WindowManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 976 "../src/WindowManager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 976 "../src/WindowManager.vala"
				g_clear_error (&_inner_error0_);
#line 976 "../src/WindowManager.vala"
				return;
#line 7284 "WindowManager.c"
			}
#line 983 "../src/WindowManager.vala"
			break;
#line 7288 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_WINDOW_OVERVIEW:
#line 7292 "WindowManager.c"
		{
			GalaActivatableComponent* _tmp71_;
			GalaActivatableComponent* _tmp72_;
#line 985 "../src/WindowManager.vala"
			_tmp71_ = self->priv->window_overview;
#line 985 "../src/WindowManager.vala"
			if (_tmp71_ == NULL) {
#line 986 "../src/WindowManager.vala"
				break;
#line 7302 "WindowManager.c"
			}
#line 988 "../src/WindowManager.vala"
			_tmp72_ = self->priv->window_overview;
#line 988 "../src/WindowManager.vala"
			if (gala_activatable_component_is_opened (_tmp72_)) {
#line 7308 "WindowManager.c"
				GalaActivatableComponent* _tmp73_;
#line 989 "../src/WindowManager.vala"
				_tmp73_ = self->priv->window_overview;
#line 989 "../src/WindowManager.vala"
				gala_activatable_component_close (_tmp73_, NULL);
#line 7314 "WindowManager.c"
			} else {
				GalaActivatableComponent* _tmp74_;
#line 991 "../src/WindowManager.vala"
				_tmp74_ = self->priv->window_overview;
#line 991 "../src/WindowManager.vala"
				gala_activatable_component_open (_tmp74_, NULL);
#line 7321 "WindowManager.c"
			}
#line 992 "../src/WindowManager.vala"
			break;
#line 7325 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_WINDOW_OVERVIEW_ALL:
#line 7329 "WindowManager.c"
		{
			GalaActivatableComponent* _tmp75_;
			GalaActivatableComponent* _tmp76_;
#line 994 "../src/WindowManager.vala"
			_tmp75_ = self->priv->window_overview;
#line 994 "../src/WindowManager.vala"
			if (_tmp75_ == NULL) {
#line 995 "../src/WindowManager.vala"
				break;
#line 7339 "WindowManager.c"
			}
#line 997 "../src/WindowManager.vala"
			_tmp76_ = self->priv->window_overview;
#line 997 "../src/WindowManager.vala"
			if (gala_activatable_component_is_opened (_tmp76_)) {
#line 7345 "WindowManager.c"
				GalaActivatableComponent* _tmp77_;
#line 998 "../src/WindowManager.vala"
				_tmp77_ = self->priv->window_overview;
#line 998 "../src/WindowManager.vala"
				gala_activatable_component_close (_tmp77_, NULL);
#line 7351 "WindowManager.c"
			} else {
				GHashTable* hints = NULL;
				GHashFunc _tmp78_;
				GEqualFunc _tmp79_;
				GHashTable* _tmp80_;
				GHashTable* _tmp81_;
				gchar* _tmp82_;
				GVariant* _tmp83_;
				GalaActivatableComponent* _tmp84_;
				GHashTable* _tmp85_;
#line 1000 "../src/WindowManager.vala"
				_tmp78_ = g_str_hash;
#line 1000 "../src/WindowManager.vala"
				_tmp79_ = g_str_equal;
#line 1000 "../src/WindowManager.vala"
				_tmp80_ = g_hash_table_new_full (_tmp78_, _tmp79_, _g_free0_, _g_variant_unref0_);
#line 1000 "../src/WindowManager.vala"
				hints = _tmp80_;
#line 1001 "../src/WindowManager.vala"
				_tmp81_ = hints;
#line 1001 "../src/WindowManager.vala"
				_tmp82_ = g_strdup ("all-windows");
#line 1001 "../src/WindowManager.vala"
				_tmp83_ = _variant_new6 (TRUE);
#line 1001 "../src/WindowManager.vala"
				g_hash_table_insert (_tmp81_, _tmp82_, _tmp83_);
#line 1002 "../src/WindowManager.vala"
				_tmp84_ = self->priv->window_overview;
#line 1002 "../src/WindowManager.vala"
				_tmp85_ = hints;
#line 1002 "../src/WindowManager.vala"
				gala_activatable_component_open (_tmp84_, _tmp85_);
#line 997 "../src/WindowManager.vala"
				_g_hash_table_unref0 (hints);
#line 7386 "WindowManager.c"
			}
#line 1004 "../src/WindowManager.vala"
			break;
#line 7390 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_LAST:
#line 7394 "WindowManager.c"
		{
			MetaWorkspaceManager* manager = NULL;
			MetaDisplay* _tmp86_;
			MetaWorkspaceManager* _tmp87_;
			MetaWorkspace* workspace = NULL;
			MetaWorkspaceManager* _tmp88_;
			MetaWorkspaceManager* _tmp89_;
			MetaWorkspace* _tmp90_;
			MetaWorkspace* _tmp91_;
			MetaDisplay* _tmp92_;
#line 1006 "../src/WindowManager.vala"
			_tmp86_ = display;
#line 1006 "../src/WindowManager.vala"
			_tmp87_ = meta_display_get_workspace_manager (_tmp86_);
#line 1006 "../src/WindowManager.vala"
			manager = _tmp87_;
#line 1007 "../src/WindowManager.vala"
			_tmp88_ = manager;
#line 1007 "../src/WindowManager.vala"
			_tmp89_ = manager;
#line 1007 "../src/WindowManager.vala"
			_tmp90_ = meta_workspace_manager_get_workspace_by_index (_tmp88_, meta_workspace_manager_get_n_workspaces (_tmp89_) - 1);
#line 1007 "../src/WindowManager.vala"
			workspace = _tmp90_;
#line 1008 "../src/WindowManager.vala"
			_tmp91_ = workspace;
#line 1008 "../src/WindowManager.vala"
			_tmp92_ = display;
#line 1008 "../src/WindowManager.vala"
			meta_workspace_activate (_tmp91_, meta_display_get_current_time (_tmp92_));
#line 1009 "../src/WindowManager.vala"
			break;
#line 7427 "WindowManager.c"
		}
#line 895 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SCREENSHOT_CURRENT:
#line 7431 "WindowManager.c"
		{
#line 1011 "../src/WindowManager.vala"
			gala_window_manager_gala_screenshot_current_window (self, FALSE, NULL, NULL);
#line 1012 "../src/WindowManager.vala"
			break;
#line 7437 "WindowManager.c"
		}
		default:
		{
#line 1014 "../src/WindowManager.vala"
			g_warning ("WindowManager.vala:1014: Trying to run unknown action");
#line 1015 "../src/WindowManager.vala"
			break;
#line 7445 "WindowManager.c"
		}
	}
}

static void
___lambda145_ (GalaWindowManagerGala* self,
               GObject* obj,
               GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 1057 "../src/WindowManager.vala"
	g_return_if_fail (res != NULL);
#line 7458 "WindowManager.c"
	{
#line 1059 "../src/WindowManager.vala"
		gala_daemon_show_window_menu_finish (G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DAEMON, GalaDaemon), res, &_inner_error0_);
#line 1059 "../src/WindowManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7464 "WindowManager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 1058 "../src/WindowManager.vala"
		e = _inner_error0_;
#line 1058 "../src/WindowManager.vala"
		_inner_error0_ = NULL;
#line 1061 "../src/WindowManager.vala"
		_tmp0_ = e;
#line 1061 "../src/WindowManager.vala"
		_tmp1_ = _tmp0_->message;
#line 1061 "../src/WindowManager.vala"
		g_message ("WindowManager.vala:1061: Error invoking MenuManager: %s", _tmp1_);
#line 1058 "../src/WindowManager.vala"
		_g_error_free0 (e);
#line 7486 "WindowManager.c"
	}
	__finally0:
#line 1058 "../src/WindowManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1058 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1058 "../src/WindowManager.vala"
		g_clear_error (&_inner_error0_);
#line 1058 "../src/WindowManager.vala"
		return;
#line 7497 "WindowManager.c"
	}
}

static void
____lambda145__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1057 "../src/WindowManager.vala"
	___lambda145_ ((GalaWindowManagerGala*) self, source_object, res);
#line 1057 "../src/WindowManager.vala"
	g_object_unref (self);
#line 7510 "WindowManager.c"
}

static void
gala_window_manager_gala_real_show_window_menu (MetaPlugin* base,
                                                MetaWindow* window,
                                                MetaWindowMenuType menu,
                                                gint x,
                                                gint y)
{
	GalaWindowManagerGala * self;
#line 1019 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1019 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1020 "../src/WindowManager.vala"
	switch (menu) {
#line 1020 "../src/WindowManager.vala"
		case META_WINDOW_MENU_WM:
#line 7529 "WindowManager.c"
		{
			gboolean _tmp0_ = FALSE;
			GalaDaemon* _tmp1_;
			GalaWindowFlags flags = 0U;
			MetaMaximizeFlags maximize_flags = 0U;
			gboolean _tmp3_;
			gboolean _tmp4_;
			GalaDaemon* _tmp5_;
#line 1022 "../src/WindowManager.vala"
			_tmp1_ = self->priv->daemon_proxy;
#line 1022 "../src/WindowManager.vala"
			if (_tmp1_ == NULL) {
#line 1022 "../src/WindowManager.vala"
				_tmp0_ = TRUE;
#line 7544 "WindowManager.c"
			} else {
#line 1022 "../src/WindowManager.vala"
				_tmp0_ = meta_window_get_window_type (window) == META_WINDOW_NOTIFICATION;
#line 7548 "WindowManager.c"
			}
#line 1022 "../src/WindowManager.vala"
			if (_tmp0_) {
#line 1023 "../src/WindowManager.vala"
				return;
#line 7554 "WindowManager.c"
			}
#line 1026 "../src/WindowManager.vala"
			flags = GALA_WINDOW_FLAGS_NONE;
#line 1027 "../src/WindowManager.vala"
			if (meta_window_can_minimize (window)) {
#line 1028 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_CAN_HIDE;
#line 7562 "WindowManager.c"
			}
#line 1030 "../src/WindowManager.vala"
			if (meta_window_can_maximize (window)) {
#line 1031 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_CAN_MAXIMIZE;
#line 7568 "WindowManager.c"
			}
#line 1033 "../src/WindowManager.vala"
			maximize_flags = meta_window_get_maximized (window);
#line 1034 "../src/WindowManager.vala"
			if (maximize_flags > 0) {
#line 7574 "WindowManager.c"
				gboolean _tmp2_ = FALSE;
#line 1035 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_IS_MAXIMIZED;
#line 1037 "../src/WindowManager.vala"
				if ((maximize_flags & META_MAXIMIZE_VERTICAL) == META_MAXIMIZE_VERTICAL) {
#line 1037 "../src/WindowManager.vala"
					_tmp2_ = !((maximize_flags & META_MAXIMIZE_HORIZONTAL) == META_MAXIMIZE_HORIZONTAL);
#line 7582 "WindowManager.c"
				} else {
#line 1037 "../src/WindowManager.vala"
					_tmp2_ = FALSE;
#line 7586 "WindowManager.c"
				}
#line 1037 "../src/WindowManager.vala"
				if (_tmp2_) {
#line 1038 "../src/WindowManager.vala"
					flags |= GALA_WINDOW_FLAGS_IS_TILED;
#line 7592 "WindowManager.c"
				}
			}
#line 1042 "../src/WindowManager.vala"
			if (meta_window_allows_move (window)) {
#line 1043 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_ALLOWS_MOVE;
#line 7599 "WindowManager.c"
			}
#line 1045 "../src/WindowManager.vala"
			if (meta_window_allows_resize (window)) {
#line 1046 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_ALLOWS_RESIZE;
#line 7605 "WindowManager.c"
			}
#line 1048 "../src/WindowManager.vala"
			if (meta_window_is_above (window)) {
#line 1049 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_ALWAYS_ON_TOP;
#line 7611 "WindowManager.c"
			}
#line 1051 "../src/WindowManager.vala"
			g_object_get (window, "on-all-workspaces", &_tmp3_, NULL);
#line 1051 "../src/WindowManager.vala"
			_tmp4_ = _tmp3_;
#line 1051 "../src/WindowManager.vala"
			if (_tmp4_) {
#line 1052 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_ON_ALL_WORKSPACES;
#line 7621 "WindowManager.c"
			}
#line 1054 "../src/WindowManager.vala"
			if (meta_window_can_close (window)) {
#line 1055 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_CAN_CLOSE;
#line 7627 "WindowManager.c"
			}
#line 1057 "../src/WindowManager.vala"
			_tmp5_ = self->priv->daemon_proxy;
#line 1057 "../src/WindowManager.vala"
			gala_daemon_show_window_menu (_tmp5_, flags, x, y, ____lambda145__gasync_ready_callback, g_object_ref (self));
#line 1064 "../src/WindowManager.vala"
			break;
#line 7635 "WindowManager.c"
		}
#line 1020 "../src/WindowManager.vala"
		case META_WINDOW_MENU_APP:
#line 7639 "WindowManager.c"
		{
#line 1067 "../src/WindowManager.vala"
			break;
#line 7643 "WindowManager.c"
		}
		default:
#line 1020 "../src/WindowManager.vala"
		break;
#line 7648 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_real_show_tile_preview (MetaPlugin* base,
                                                 MetaWindow* window,
                                                 MtkRectangle* tile_rect,
                                                 gint tile_monitor_number)
{
	GalaWindowManagerGala * self;
	ClutterActor* _tmp0_;
	MetaWindowActor* window_actor = NULL;
	GObject* _tmp30_;
	ClutterActor* _tmp31_;
	ClutterActor* _tmp32_;
	ClutterActor* _tmp33_;
	MetaWindowActor* _tmp34_;
	guint duration = 0U;
	MtkRectangle rect = {0};
	MtkRectangle _tmp35_ = {0};
	ClutterActor* _tmp36_;
	MtkRectangle _tmp37_;
	MtkRectangle _tmp38_;
	ClutterActor* _tmp39_;
	MtkRectangle _tmp40_;
	MtkRectangle _tmp41_;
	ClutterActor* _tmp42_;
	gboolean _tmp43_;
	gboolean _tmp44_;
#line 1072 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1072 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1072 "../src/WindowManager.vala"
	g_return_if_fail (tile_rect != NULL);
#line 1076 "../src/WindowManager.vala"
	_tmp0_ = self->priv->tile_preview;
#line 1076 "../src/WindowManager.vala"
	if (_tmp0_ == NULL) {
#line 7688 "WindowManager.c"
		ClutterActor* _tmp1_;
		GdkRGBA rgba = {0};
		GdkRGBA _tmp2_ = {0};
		ClutterActor* _tmp3_;
		GdkRGBA _tmp4_;
		GdkRGBA _tmp5_;
		GdkRGBA _tmp6_;
		GdkRGBA _tmp7_;
		ClutterColor _tmp8_ = {0};
		ClutterActor* _tmp9_;
		ClutterActor* _tmp10_;
		ClutterActor* _tmp11_;
		ClutterActor* _tmp12_;
#line 1077 "../src/WindowManager.vala"
		_tmp1_ = clutter_actor_new ();
#line 1077 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp1_);
#line 1077 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->tile_preview);
#line 1077 "../src/WindowManager.vala"
		self->priv->tile_preview = _tmp1_;
#line 1078 "../src/WindowManager.vala"
		gala_internal_utils_get_theme_accent_color (&_tmp2_);
#line 1078 "../src/WindowManager.vala"
		rgba = _tmp2_;
#line 1079 "../src/WindowManager.vala"
		_tmp3_ = self->priv->tile_preview;
#line 1079 "../src/WindowManager.vala"
		_tmp4_ = rgba;
#line 1079 "../src/WindowManager.vala"
		_tmp5_ = rgba;
#line 1079 "../src/WindowManager.vala"
		_tmp6_ = rgba;
#line 1079 "../src/WindowManager.vala"
		_tmp7_ = rgba;
#line 1079 "../src/WindowManager.vala"
		_tmp8_.red = (guint8) (255.0 * _tmp4_.red);
#line 1079 "../src/WindowManager.vala"
		_tmp8_.green = (guint8) (255.0 * _tmp5_.green);
#line 1079 "../src/WindowManager.vala"
		_tmp8_.blue = (guint8) (255.0 * _tmp6_.blue);
#line 1079 "../src/WindowManager.vala"
		_tmp8_.alpha = (guint8) (255.0 * _tmp7_.alpha);
#line 1079 "../src/WindowManager.vala"
		clutter_actor_set_background_color (_tmp3_, &_tmp8_);
#line 1085 "../src/WindowManager.vala"
		_tmp9_ = self->priv->tile_preview;
#line 1085 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp9_, 0U);
#line 1087 "../src/WindowManager.vala"
		_tmp10_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 1087 "../src/WindowManager.vala"
		_tmp11_ = _tmp10_;
#line 1087 "../src/WindowManager.vala"
		_tmp12_ = self->priv->tile_preview;
#line 1087 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp11_, _tmp12_);
#line 7746 "WindowManager.c"
	} else {
		ClutterActor* _tmp13_;
#line 1088 "../src/WindowManager.vala"
		_tmp13_ = self->priv->tile_preview;
#line 1088 "../src/WindowManager.vala"
		if (clutter_actor_is_visible (_tmp13_)) {
#line 7753 "WindowManager.c"
			gfloat width = 0.0F;
			gfloat height = 0.0F;
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			ClutterActor* _tmp14_;
			gfloat _tmp15_ = 0.0F;
			gfloat _tmp16_ = 0.0F;
			ClutterActor* _tmp17_;
			gfloat _tmp18_ = 0.0F;
			gfloat _tmp19_ = 0.0F;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_ = FALSE;
			gboolean _tmp23_ = FALSE;
			MtkRectangle _tmp24_;
#line 1090 "../src/WindowManager.vala"
			_tmp14_ = self->priv->tile_preview;
#line 1090 "../src/WindowManager.vala"
			clutter_actor_get_position (_tmp14_, &_tmp15_, &_tmp16_);
#line 1090 "../src/WindowManager.vala"
			x = _tmp15_;
#line 1090 "../src/WindowManager.vala"
			y = _tmp16_;
#line 1091 "../src/WindowManager.vala"
			_tmp17_ = self->priv->tile_preview;
#line 1091 "../src/WindowManager.vala"
			clutter_actor_get_size (_tmp17_, &_tmp18_, &_tmp19_);
#line 1091 "../src/WindowManager.vala"
			width = _tmp18_;
#line 1091 "../src/WindowManager.vala"
			height = _tmp19_;
#line 1093 "../src/WindowManager.vala"
			_tmp24_ = *tile_rect;
#line 1093 "../src/WindowManager.vala"
			if (((gfloat) _tmp24_.width) == width) {
#line 7789 "WindowManager.c"
				MtkRectangle _tmp25_;
#line 1093 "../src/WindowManager.vala"
				_tmp25_ = *tile_rect;
#line 1093 "../src/WindowManager.vala"
				_tmp23_ = ((gfloat) _tmp25_.height) == height;
#line 7795 "WindowManager.c"
			} else {
#line 1093 "../src/WindowManager.vala"
				_tmp23_ = FALSE;
#line 7799 "WindowManager.c"
			}
#line 1093 "../src/WindowManager.vala"
			if (_tmp23_) {
#line 7803 "WindowManager.c"
				MtkRectangle _tmp26_;
#line 1093 "../src/WindowManager.vala"
				_tmp26_ = *tile_rect;
#line 1093 "../src/WindowManager.vala"
				_tmp22_ = ((gfloat) _tmp26_.x) == x;
#line 7809 "WindowManager.c"
			} else {
#line 1093 "../src/WindowManager.vala"
				_tmp22_ = FALSE;
#line 7813 "WindowManager.c"
			}
#line 1093 "../src/WindowManager.vala"
			if (_tmp22_) {
#line 7817 "WindowManager.c"
				MtkRectangle _tmp27_;
#line 1093 "../src/WindowManager.vala"
				_tmp27_ = *tile_rect;
#line 1093 "../src/WindowManager.vala"
				_tmp21_ = ((gfloat) _tmp27_.y) == y;
#line 7823 "WindowManager.c"
			} else {
#line 1093 "../src/WindowManager.vala"
				_tmp21_ = FALSE;
#line 7827 "WindowManager.c"
			}
#line 1093 "../src/WindowManager.vala"
			if (_tmp21_) {
#line 1093 "../src/WindowManager.vala"
				_tmp20_ = TRUE;
#line 7833 "WindowManager.c"
			} else {
				ClutterActor* _tmp28_;
				ClutterTransition* _tmp29_;
#line 1094 "../src/WindowManager.vala"
				_tmp28_ = self->priv->tile_preview;
#line 1094 "../src/WindowManager.vala"
				_tmp29_ = clutter_actor_get_transition (_tmp28_, "size");
#line 1094 "../src/WindowManager.vala"
				_tmp20_ = _tmp29_ != NULL;
#line 7843 "WindowManager.c"
			}
#line 1093 "../src/WindowManager.vala"
			if (_tmp20_) {
#line 1095 "../src/WindowManager.vala"
				return;
#line 7849 "WindowManager.c"
			}
		}
	}
#line 1099 "../src/WindowManager.vala"
	_tmp30_ = meta_window_get_compositor_private (window);
#line 1099 "../src/WindowManager.vala"
	window_actor = G_TYPE_CHECK_INSTANCE_TYPE (_tmp30_, meta_window_actor_get_type ()) ? ((MetaWindowActor*) _tmp30_) : NULL;
#line 1100 "../src/WindowManager.vala"
	_tmp31_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 1100 "../src/WindowManager.vala"
	_tmp32_ = _tmp31_;
#line 1100 "../src/WindowManager.vala"
	_tmp33_ = self->priv->tile_preview;
#line 1100 "../src/WindowManager.vala"
	_tmp34_ = window_actor;
#line 1100 "../src/WindowManager.vala"
	clutter_actor_set_child_below_sibling (_tmp32_, _tmp33_, (ClutterActor*) _tmp34_);
#line 1102 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_SNAP / 2U;
#line 1104 "../src/WindowManager.vala"
	meta_window_get_frame_rect (window, &_tmp35_);
#line 1104 "../src/WindowManager.vala"
	rect = _tmp35_;
#line 1105 "../src/WindowManager.vala"
	_tmp36_ = self->priv->tile_preview;
#line 1105 "../src/WindowManager.vala"
	_tmp37_ = rect;
#line 1105 "../src/WindowManager.vala"
	_tmp38_ = rect;
#line 1105 "../src/WindowManager.vala"
	clutter_actor_set_position (_tmp36_, (gfloat) _tmp37_.x, (gfloat) _tmp38_.y);
#line 1106 "../src/WindowManager.vala"
	_tmp39_ = self->priv->tile_preview;
#line 1106 "../src/WindowManager.vala"
	_tmp40_ = rect;
#line 1106 "../src/WindowManager.vala"
	_tmp41_ = rect;
#line 1106 "../src/WindowManager.vala"
	clutter_actor_set_size (_tmp39_, (gfloat) _tmp40_.width, (gfloat) _tmp41_.height);
#line 1107 "../src/WindowManager.vala"
	_tmp42_ = self->priv->tile_preview;
#line 1107 "../src/WindowManager.vala"
	clutter_actor_show (_tmp42_);
#line 1109 "../src/WindowManager.vala"
	_tmp43_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1109 "../src/WindowManager.vala"
	_tmp44_ = _tmp43_;
#line 1109 "../src/WindowManager.vala"
	if (_tmp44_) {
#line 7899 "WindowManager.c"
		ClutterActor* _tmp45_;
		ClutterActor* _tmp46_;
		ClutterActor* _tmp47_;
		ClutterActor* _tmp48_;
		ClutterActor* _tmp49_;
		MtkRectangle _tmp50_;
		MtkRectangle _tmp51_;
		ClutterActor* _tmp52_;
		MtkRectangle _tmp53_;
		MtkRectangle _tmp54_;
		ClutterActor* _tmp55_;
#line 1110 "../src/WindowManager.vala"
		_tmp45_ = self->priv->tile_preview;
#line 1110 "../src/WindowManager.vala"
		clutter_actor_save_easing_state (_tmp45_);
#line 1111 "../src/WindowManager.vala"
		_tmp46_ = self->priv->tile_preview;
#line 1111 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode (_tmp46_, CLUTTER_EASE_IN_OUT_QUAD);
#line 1112 "../src/WindowManager.vala"
		_tmp47_ = self->priv->tile_preview;
#line 1112 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration (_tmp47_, duration);
#line 1113 "../src/WindowManager.vala"
		_tmp48_ = self->priv->tile_preview;
#line 1113 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp48_, 255U);
#line 1114 "../src/WindowManager.vala"
		_tmp49_ = self->priv->tile_preview;
#line 1114 "../src/WindowManager.vala"
		_tmp50_ = *tile_rect;
#line 1114 "../src/WindowManager.vala"
		_tmp51_ = *tile_rect;
#line 1114 "../src/WindowManager.vala"
		clutter_actor_set_position (_tmp49_, (gfloat) _tmp50_.x, (gfloat) _tmp51_.y);
#line 1115 "../src/WindowManager.vala"
		_tmp52_ = self->priv->tile_preview;
#line 1115 "../src/WindowManager.vala"
		_tmp53_ = *tile_rect;
#line 1115 "../src/WindowManager.vala"
		_tmp54_ = *tile_rect;
#line 1115 "../src/WindowManager.vala"
		clutter_actor_set_size (_tmp52_, (gfloat) _tmp53_.width, (gfloat) _tmp54_.height);
#line 1116 "../src/WindowManager.vala"
		_tmp55_ = self->priv->tile_preview;
#line 1116 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state (_tmp55_);
#line 7947 "WindowManager.c"
	} else {
		ClutterActor* _tmp56_;
#line 1118 "../src/WindowManager.vala"
		_tmp56_ = self->priv->tile_preview;
#line 1118 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp56_, 255U);
#line 7954 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_real_hide_tile_preview (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	ClutterActor* _tmp0_;
#line 1122 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1123 "../src/WindowManager.vala"
	_tmp0_ = self->priv->tile_preview;
#line 1123 "../src/WindowManager.vala"
	if (_tmp0_ != NULL) {
#line 7969 "WindowManager.c"
		ClutterActor* _tmp1_;
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 1124 "../src/WindowManager.vala"
		_tmp1_ = self->priv->tile_preview;
#line 1124 "../src/WindowManager.vala"
		clutter_actor_remove_all_transitions (_tmp1_);
#line 1125 "../src/WindowManager.vala"
		_tmp2_ = self->priv->tile_preview;
#line 1125 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp2_, 0U);
#line 1126 "../src/WindowManager.vala"
		_tmp3_ = self->priv->tile_preview;
#line 1126 "../src/WindowManager.vala"
		clutter_actor_hide (_tmp3_);
#line 1127 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->tile_preview);
#line 1127 "../src/WindowManager.vala"
		self->priv->tile_preview = NULL;
#line 7989 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_real_show_window_menu_for_rect (MetaPlugin* base,
                                                         MetaWindow* window,
                                                         MetaWindowMenuType menu,
                                                         MtkRectangle* rect)
{
	GalaWindowManagerGala * self;
	MtkRectangle _tmp0_;
	MtkRectangle _tmp1_;
#line 1132 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1132 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1132 "../src/WindowManager.vala"
	g_return_if_fail (rect != NULL);
#line 1136 "../src/WindowManager.vala"
	_tmp0_ = *rect;
#line 1136 "../src/WindowManager.vala"
	_tmp1_ = *rect;
#line 1136 "../src/WindowManager.vala"
	G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->show_window_menu ((MetaPlugin*) self, window, menu, _tmp0_.x, _tmp1_.y);
#line 8014 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_fullscreen_window (GalaWindowManagerGala* self,
                                                   MetaWindow* window,
                                                   MetaSizeChange which_change)
{
	gboolean _tmp0_ = FALSE;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp2_;
	guint32 time = 0U;
	MetaDisplay* _tmp3_;
	MetaWorkspace* win_ws = NULL;
	MetaWorkspace* _tmp4_;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp5_;
	MetaWorkspaceManager* _tmp6_;
#line 1143 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1143 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1145 "../src/WindowManager.vala"
	if (!meta_window_is_on_primary_monitor (window)) {
#line 1145 "../src/WindowManager.vala"
		_tmp0_ = TRUE;
#line 8040 "WindowManager.c"
	} else {
		GSettings* _tmp1_;
#line 1145 "../src/WindowManager.vala"
		_tmp1_ = self->priv->behavior_settings;
#line 1145 "../src/WindowManager.vala"
		_tmp0_ = !g_settings_get_boolean (_tmp1_, "move-fullscreened-workspace");
#line 8047 "WindowManager.c"
	}
#line 1145 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 1146 "../src/WindowManager.vala"
		return;
#line 8053 "WindowManager.c"
	}
#line 1151 "../src/WindowManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 1152 "../src/WindowManager.vala"
		return;
#line 8059 "WindowManager.c"
	}
#line 1154 "../src/WindowManager.vala"
	_tmp2_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1154 "../src/WindowManager.vala"
	display = _tmp2_;
#line 1155 "../src/WindowManager.vala"
	_tmp3_ = display;
#line 1155 "../src/WindowManager.vala"
	time = meta_display_get_current_time (_tmp3_);
#line 1156 "../src/WindowManager.vala"
	_tmp4_ = meta_window_get_workspace (window);
#line 1156 "../src/WindowManager.vala"
	win_ws = _tmp4_;
#line 1157 "../src/WindowManager.vala"
	_tmp5_ = display;
#line 1157 "../src/WindowManager.vala"
	_tmp6_ = meta_display_get_workspace_manager (_tmp5_);
#line 1157 "../src/WindowManager.vala"
	manager = _tmp6_;
#line 1159 "../src/WindowManager.vala"
	if (which_change == META_SIZE_CHANGE_FULLSCREEN) {
#line 8081 "WindowManager.c"
		MetaWorkspace* _tmp7_;
		gint old_ws_index = 0;
		MetaWorkspace* _tmp8_;
		gint new_ws_index = 0;
		MetaWorkspace* new_ws = NULL;
		MetaWorkspaceManager* _tmp9_;
		MetaWorkspace* _tmp10_;
		MetaWorkspace* _tmp11_;
		MetaWorkspace* _tmp12_;
		GHashTable* _tmp13_;
		MetaWindow* _tmp14_;
#line 1161 "../src/WindowManager.vala"
		_tmp7_ = win_ws;
#line 1161 "../src/WindowManager.vala"
		if (gala_utils_get_n_windows (_tmp7_, FALSE) <= ((guint) 1)) {
#line 1162 "../src/WindowManager.vala"
			return;
#line 8099 "WindowManager.c"
		}
#line 1164 "../src/WindowManager.vala"
		_tmp8_ = win_ws;
#line 1164 "../src/WindowManager.vala"
		old_ws_index = meta_workspace_index (_tmp8_);
#line 1165 "../src/WindowManager.vala"
		new_ws_index = old_ws_index + 1;
#line 1166 "../src/WindowManager.vala"
		gala_internal_utils_insert_workspace_with_window (new_ws_index, window);
#line 1168 "../src/WindowManager.vala"
		_tmp9_ = manager;
#line 1168 "../src/WindowManager.vala"
		_tmp10_ = meta_workspace_manager_get_workspace_by_index (_tmp9_, new_ws_index);
#line 1168 "../src/WindowManager.vala"
		new_ws = _tmp10_;
#line 1169 "../src/WindowManager.vala"
		_tmp11_ = new_ws;
#line 1169 "../src/WindowManager.vala"
		meta_window_change_workspace (window, _tmp11_);
#line 1170 "../src/WindowManager.vala"
		_tmp12_ = new_ws;
#line 1170 "../src/WindowManager.vala"
		meta_workspace_activate_with_focus (_tmp12_, window, time);
#line 1172 "../src/WindowManager.vala"
		_tmp13_ = self->priv->ws_assoc;
#line 1172 "../src/WindowManager.vala"
		_tmp14_ = _g_object_ref0 (window);
#line 1172 "../src/WindowManager.vala"
		g_hash_table_insert (_tmp13_, _tmp14_, (gpointer) ((gintptr) old_ws_index));
#line 8129 "WindowManager.c"
	} else {
		GHashTable* _tmp15_;
#line 1173 "../src/WindowManager.vala"
		_tmp15_ = self->priv->ws_assoc;
#line 1173 "../src/WindowManager.vala"
		if (g_hash_table_contains (_tmp15_, window)) {
#line 8136 "WindowManager.c"
			gint old_ws_index = 0;
			GHashTable* _tmp16_;
			gconstpointer _tmp17_;
			gint new_ws_index = 0;
			MetaWorkspace* _tmp18_;
			gboolean _tmp19_ = FALSE;
			GHashTable* _tmp25_;
#line 1174 "../src/WindowManager.vala"
			_tmp16_ = self->priv->ws_assoc;
#line 1174 "../src/WindowManager.vala"
			_tmp17_ = g_hash_table_lookup (_tmp16_, window);
#line 1174 "../src/WindowManager.vala"
			old_ws_index = (gint) ((gintptr) _tmp17_);
#line 1175 "../src/WindowManager.vala"
			_tmp18_ = win_ws;
#line 1175 "../src/WindowManager.vala"
			new_ws_index = meta_workspace_index (_tmp18_);
#line 1177 "../src/WindowManager.vala"
			if (new_ws_index != old_ws_index) {
#line 8156 "WindowManager.c"
				MetaWorkspaceManager* _tmp20_;
#line 1177 "../src/WindowManager.vala"
				_tmp20_ = manager;
#line 1177 "../src/WindowManager.vala"
				_tmp19_ = old_ws_index < meta_workspace_manager_get_n_workspaces (_tmp20_);
#line 8162 "WindowManager.c"
			} else {
#line 1177 "../src/WindowManager.vala"
				_tmp19_ = FALSE;
#line 8166 "WindowManager.c"
			}
#line 1177 "../src/WindowManager.vala"
			if (_tmp19_) {
#line 8170 "WindowManager.c"
				MetaWorkspace* old_ws = NULL;
				MetaWorkspaceManager* _tmp21_;
				MetaWorkspace* _tmp22_;
				MetaWorkspace* _tmp23_;
				MetaWorkspace* _tmp24_;
#line 1178 "../src/WindowManager.vala"
				_tmp21_ = manager;
#line 1178 "../src/WindowManager.vala"
				_tmp22_ = meta_workspace_manager_get_workspace_by_index (_tmp21_, old_ws_index);
#line 1178 "../src/WindowManager.vala"
				old_ws = _tmp22_;
#line 1179 "../src/WindowManager.vala"
				_tmp23_ = old_ws;
#line 1179 "../src/WindowManager.vala"
				meta_window_change_workspace (window, _tmp23_);
#line 1180 "../src/WindowManager.vala"
				_tmp24_ = old_ws;
#line 1180 "../src/WindowManager.vala"
				meta_workspace_activate_with_focus (_tmp24_, window, time);
#line 8190 "WindowManager.c"
			}
#line 1183 "../src/WindowManager.vala"
			_tmp25_ = self->priv->ws_assoc;
#line 1183 "../src/WindowManager.vala"
			g_hash_table_remove (_tmp25_, window);
#line 8196 "WindowManager.c"
		}
	}
}

static MetaSizeChange*
_meta_size_change_dup (MetaSizeChange* self)
{
	MetaSizeChange* dup;
#line 1194 "../src/WindowManager.vala"
	dup = g_new0 (MetaSizeChange, 1);
#line 1194 "../src/WindowManager.vala"
	memcpy (dup, self, sizeof (MetaSizeChange));
#line 1194 "../src/WindowManager.vala"
	return dup;
#line 8211 "WindowManager.c"
}

static gpointer
__meta_size_change_dup0 (gpointer self)
{
#line 1194 "../src/WindowManager.vala"
	return self ? _meta_size_change_dup (self) : NULL;
#line 8219 "WindowManager.c"
}

static void
gala_window_manager_gala_real_size_change (MetaPlugin* base,
                                           MetaWindowActor* actor,
                                           MetaSizeChange which_change_local,
                                           MtkRectangle* old_frame_rect,
                                           MtkRectangle* old_buffer_rect)
{
	GalaWindowManagerGala * self;
	MetaSizeChange* _tmp0_;
	MtkRectangle _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 1190 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1190 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1190 "../src/WindowManager.vala"
	g_return_if_fail (old_frame_rect != NULL);
#line 1190 "../src/WindowManager.vala"
	g_return_if_fail (old_buffer_rect != NULL);
#line 1194 "../src/WindowManager.vala"
	_tmp0_ = __meta_size_change_dup0 (&which_change_local);
#line 1194 "../src/WindowManager.vala"
	_g_free0 (self->priv->which_change);
#line 1194 "../src/WindowManager.vala"
	self->priv->which_change = _tmp0_;
#line 1195 "../src/WindowManager.vala"
	_tmp1_ = *old_frame_rect;
#line 1195 "../src/WindowManager.vala"
	self->priv->old_rect_size_change = _tmp1_;
#line 1197 "../src/WindowManager.vala"
	_tmp2_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1197 "../src/WindowManager.vala"
	_tmp3_ = _tmp2_;
#line 1197 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 8258 "WindowManager.c"
		MtkRectangle _tmp4_;
		ClutterActor* _tmp5_;
#line 1198 "../src/WindowManager.vala"
		_tmp4_ = *old_frame_rect;
#line 1198 "../src/WindowManager.vala"
		_tmp5_ = gala_utils_get_window_actor_snapshot (actor, &_tmp4_);
#line 1198 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->latest_window_snapshot);
#line 1198 "../src/WindowManager.vala"
		self->priv->latest_window_snapshot = _tmp5_;
#line 8269 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_real_size_changed (MetaPlugin* base,
                                            MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	MetaSizeChange* _tmp0_;
	MetaSizeChange* which_change_local = NULL;
	MetaSizeChange* _tmp1_;
	MetaSizeChange* _tmp2_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp3_;
	MtkRectangle new_rect = {0};
	MetaWindow* _tmp4_;
	MtkRectangle _tmp5_ = {0};
	MetaSizeChange* _tmp6_;
#line 1203 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1203 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1204 "../src/WindowManager.vala"
	_tmp0_ = self->priv->which_change;
#line 1204 "../src/WindowManager.vala"
	if (_tmp0_ == NULL) {
#line 1205 "../src/WindowManager.vala"
		return;
#line 8298 "WindowManager.c"
	}
#line 1208 "../src/WindowManager.vala"
	_tmp1_ = self->priv->which_change;
#line 1208 "../src/WindowManager.vala"
	_tmp2_ = __meta_size_change_dup0 (_tmp1_);
#line 1208 "../src/WindowManager.vala"
	which_change_local = _tmp2_;
#line 1209 "../src/WindowManager.vala"
	_g_free0 (self->priv->which_change);
#line 1209 "../src/WindowManager.vala"
	self->priv->which_change = NULL;
#line 1211 "../src/WindowManager.vala"
	_tmp3_ = meta_window_actor_get_meta_window (actor);
#line 1211 "../src/WindowManager.vala"
	window = _tmp3_;
#line 1212 "../src/WindowManager.vala"
	_tmp4_ = window;
#line 1212 "../src/WindowManager.vala"
	meta_window_get_frame_rect (_tmp4_, &_tmp5_);
#line 1212 "../src/WindowManager.vala"
	new_rect = _tmp5_;
#line 1214 "../src/WindowManager.vala"
	_tmp6_ = which_change_local;
#line 1214 "../src/WindowManager.vala"
	switch (*_tmp6_) {
#line 1214 "../src/WindowManager.vala"
		case META_SIZE_CHANGE_MAXIMIZE:
#line 8326 "WindowManager.c"
		{
			gboolean _tmp7_ = FALSE;
			MetaWindow* _tmp8_;
			MetaWindow* _tmp9_;
			MtkRectangle _tmp20_;
			MtkRectangle _tmp21_;
			MtkRectangle _tmp22_;
			MtkRectangle _tmp23_;
#line 1217 "../src/WindowManager.vala"
			_tmp8_ = window;
#line 1217 "../src/WindowManager.vala"
			_tmp9_ = meta_window_get_tile_match (_tmp8_);
#line 1217 "../src/WindowManager.vala"
			if (_tmp9_ != NULL) {
#line 8341 "WindowManager.c"
				MetaWindow* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 1217 "../src/WindowManager.vala"
				_tmp10_ = window;
#line 1217 "../src/WindowManager.vala"
				g_object_get (_tmp10_, "maximized-horizontally", &_tmp11_, NULL);
#line 1217 "../src/WindowManager.vala"
				_tmp12_ = _tmp11_;
#line 1217 "../src/WindowManager.vala"
				_tmp7_ = !_tmp12_;
#line 8353 "WindowManager.c"
			} else {
#line 1217 "../src/WindowManager.vala"
				_tmp7_ = FALSE;
#line 8357 "WindowManager.c"
			}
#line 1217 "../src/WindowManager.vala"
			if (_tmp7_) {
#line 8361 "WindowManager.c"
				gint old_end = 0;
				MtkRectangle _tmp13_;
				MtkRectangle _tmp14_;
				gint new_end = 0;
				MtkRectangle _tmp15_;
				MtkRectangle _tmp16_;
				gboolean _tmp17_ = FALSE;
				MtkRectangle _tmp18_;
				MtkRectangle _tmp19_;
#line 1218 "../src/WindowManager.vala"
				_tmp13_ = self->priv->old_rect_size_change;
#line 1218 "../src/WindowManager.vala"
				_tmp14_ = self->priv->old_rect_size_change;
#line 1218 "../src/WindowManager.vala"
				old_end = _tmp13_.x + _tmp14_.width;
#line 1219 "../src/WindowManager.vala"
				_tmp15_ = new_rect;
#line 1219 "../src/WindowManager.vala"
				_tmp16_ = new_rect;
#line 1219 "../src/WindowManager.vala"
				new_end = _tmp15_.x + _tmp16_.width;
#line 1222 "../src/WindowManager.vala"
				_tmp18_ = self->priv->old_rect_size_change;
#line 1222 "../src/WindowManager.vala"
				_tmp19_ = new_rect;
#line 1222 "../src/WindowManager.vala"
				if (_tmp18_.x == _tmp19_.x) {
#line 1222 "../src/WindowManager.vala"
					_tmp17_ = TRUE;
#line 8391 "WindowManager.c"
				} else {
#line 1222 "../src/WindowManager.vala"
					_tmp17_ = old_end == new_end;
#line 8395 "WindowManager.c"
				}
#line 1222 "../src/WindowManager.vala"
				if (_tmp17_) {
#line 1223 "../src/WindowManager.vala"
					break;
#line 8401 "WindowManager.c"
				}
			}
#line 1226 "../src/WindowManager.vala"
			_tmp20_ = new_rect;
#line 1226 "../src/WindowManager.vala"
			_tmp21_ = new_rect;
#line 1226 "../src/WindowManager.vala"
			_tmp22_ = new_rect;
#line 1226 "../src/WindowManager.vala"
			_tmp23_ = new_rect;
#line 1226 "../src/WindowManager.vala"
			gala_window_manager_gala_maximize (self, actor, _tmp20_.x, _tmp21_.y, _tmp22_.width, _tmp23_.height);
#line 1227 "../src/WindowManager.vala"
			break;
#line 8416 "WindowManager.c"
		}
#line 1214 "../src/WindowManager.vala"
		case META_SIZE_CHANGE_UNMAXIMIZE:
#line 8420 "WindowManager.c"
		{
			MtkRectangle _tmp24_;
			MtkRectangle _tmp25_;
			MtkRectangle _tmp26_;
			MtkRectangle _tmp27_;
#line 1229 "../src/WindowManager.vala"
			_tmp24_ = new_rect;
#line 1229 "../src/WindowManager.vala"
			_tmp25_ = new_rect;
#line 1229 "../src/WindowManager.vala"
			_tmp26_ = new_rect;
#line 1229 "../src/WindowManager.vala"
			_tmp27_ = new_rect;
#line 1229 "../src/WindowManager.vala"
			gala_window_manager_gala_unmaximize (self, actor, _tmp24_.x, _tmp25_.y, _tmp26_.width, _tmp27_.height);
#line 1230 "../src/WindowManager.vala"
			break;
#line 8438 "WindowManager.c"
		}
#line 1214 "../src/WindowManager.vala"
		case META_SIZE_CHANGE_FULLSCREEN:
#line 1214 "../src/WindowManager.vala"
		case META_SIZE_CHANGE_UNFULLSCREEN:
#line 8444 "WindowManager.c"
		{
			MetaWindow* _tmp28_;
			MetaSizeChange* _tmp29_;
#line 1233 "../src/WindowManager.vala"
			_tmp28_ = window;
#line 1233 "../src/WindowManager.vala"
			_tmp29_ = which_change_local;
#line 1233 "../src/WindowManager.vala"
			gala_window_manager_gala_handle_fullscreen_window (self, _tmp28_, *_tmp29_);
#line 1234 "../src/WindowManager.vala"
			break;
#line 8456 "WindowManager.c"
		}
		default:
#line 1214 "../src/WindowManager.vala"
		break;
#line 8461 "WindowManager.c"
	}
#line 1237 "../src/WindowManager.vala"
	meta_plugin_size_change_completed ((MetaPlugin*) self, actor);
#line 1203 "../src/WindowManager.vala"
	_g_free0 (which_change_local);
#line 8467 "WindowManager.c"
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 1240 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 1240 "../src/WindowManager.vala"
	return _data13_;
#line 8477 "WindowManager.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 1240 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 8487 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1240 "../src/WindowManager.vala"
		self = _data13_->self;
#line 1240 "../src/WindowManager.vala"
		_g_object_unref0 (_data13_->actor);
#line 1240 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1240 "../src/WindowManager.vala"
		g_slice_free (Block13Data, _data13_);
#line 8497 "WindowManager.c"
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 1261 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 1261 "../src/WindowManager.vala"
	return _data14_;
#line 8508 "WindowManager.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 1261 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 8518 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1261 "../src/WindowManager.vala"
		self = _data14_->_data13_->self;
#line 1261 "../src/WindowManager.vala"
		block13_data_unref (_data14_->_data13_);
#line 1261 "../src/WindowManager.vala"
		_data14_->_data13_ = NULL;
#line 1261 "../src/WindowManager.vala"
		g_slice_free (Block14Data, _data14_);
#line 8528 "WindowManager.c"
	}
}

static void
___lambda151_ (Block14Data* _data14_)
{
	Block13Data* _data13_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1283 "../src/WindowManager.vala"
	_data13_ = _data14_->_data13_;
#line 1283 "../src/WindowManager.vala"
	self = _data13_->self;
#line 1284 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data13_->actor, _data14_->minimize_handler_id);
#line 1285 "../src/WindowManager.vala"
	meta_plugin_minimize_completed ((MetaPlugin*) self, _data13_->actor);
#line 1286 "../src/WindowManager.vala"
	_tmp0_ = self->priv->minimizing;
#line 1286 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data13_->actor);
#line 8550 "WindowManager.c"
}

static void
____lambda151__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1283 "../src/WindowManager.vala"
	___lambda151_ (self);
#line 8559 "WindowManager.c"
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 1261 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 1261 "../src/WindowManager.vala"
	return _data15_;
#line 8569 "WindowManager.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 1261 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 8579 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1261 "../src/WindowManager.vala"
		self = _data15_->_data13_->self;
#line 1261 "../src/WindowManager.vala"
		block13_data_unref (_data15_->_data13_);
#line 1261 "../src/WindowManager.vala"
		_data15_->_data13_ = NULL;
#line 1261 "../src/WindowManager.vala"
		g_slice_free (Block15Data, _data15_);
#line 8589 "WindowManager.c"
	}
}

static void
___lambda152_ (Block15Data* _data15_)
{
	Block13Data* _data13_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1300 "../src/WindowManager.vala"
	_data13_ = _data15_->_data13_;
#line 1300 "../src/WindowManager.vala"
	self = _data13_->self;
#line 1301 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data13_->actor, _data15_->minimize_handler_id);
#line 1302 "../src/WindowManager.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) _data13_->actor, 0.0f, 0.0f);
#line 1303 "../src/WindowManager.vala"
	clutter_actor_set_scale ((ClutterActor*) _data13_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1304 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) _data13_->actor, 255U);
#line 1305 "../src/WindowManager.vala"
	meta_plugin_minimize_completed ((MetaPlugin*) self, _data13_->actor);
#line 1306 "../src/WindowManager.vala"
	_tmp0_ = self->priv->minimizing;
#line 1306 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data13_->actor);
#line 8617 "WindowManager.c"
}

static void
____lambda152__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1300 "../src/WindowManager.vala"
	___lambda152_ (self);
#line 8626 "WindowManager.c"
}

static void
gala_window_manager_gala_real_minimize (MetaPlugin* base,
                                        MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	Block13Data* _data13_;
	MetaWindowActor* _tmp0_;
	GalaAnimationDuration duration = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeHashSet* _tmp8_;
	gint width = 0;
	gint height = 0;
	MetaDisplay* _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	MtkRectangle icon = {0};
	MtkRectangle _tmp12_ = {0};
	MetaWindow* _tmp13_;
	MtkRectangle _tmp14_ = {0};
	gboolean _tmp15_;
#line 1240 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1240 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1240 "../src/WindowManager.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 1240 "../src/WindowManager.vala"
	_data13_->_ref_count_ = 1;
#line 1240 "../src/WindowManager.vala"
	_data13_->self = g_object_ref (self);
#line 1240 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1240 "../src/WindowManager.vala"
	_g_object_unref0 (_data13_->actor);
#line 1240 "../src/WindowManager.vala"
	_data13_->actor = _tmp0_;
#line 1241 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_HIDE;
#line 1243 "../src/WindowManager.vala"
	_tmp3_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1243 "../src/WindowManager.vala"
	_tmp4_ = _tmp3_;
#line 1243 "../src/WindowManager.vala"
	if (!_tmp4_) {
#line 1243 "../src/WindowManager.vala"
		_tmp2_ = TRUE;
#line 8678 "WindowManager.c"
	} else {
#line 1244 "../src/WindowManager.vala"
		_tmp2_ = duration == 0;
#line 8682 "WindowManager.c"
	}
#line 1243 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 1243 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 8688 "WindowManager.c"
	} else {
		MetaWindow* _tmp5_;
		MetaWindowType _tmp6_;
		MetaWindowType _tmp7_;
#line 1245 "../src/WindowManager.vala"
		_tmp5_ = meta_window_actor_get_meta_window (_data13_->actor);
#line 1245 "../src/WindowManager.vala"
		_tmp6_ = meta_window_get_window_type (_tmp5_);
#line 1245 "../src/WindowManager.vala"
		_tmp7_ = _tmp6_;
#line 1245 "../src/WindowManager.vala"
		_tmp1_ = _tmp7_ != META_WINDOW_NORMAL;
#line 8701 "WindowManager.c"
	}
#line 1243 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 1246 "../src/WindowManager.vala"
		meta_plugin_minimize_completed ((MetaPlugin*) self, _data13_->actor);
#line 1247 "../src/WindowManager.vala"
		block13_data_unref (_data13_);
#line 1247 "../src/WindowManager.vala"
		_data13_ = NULL;
#line 1247 "../src/WindowManager.vala"
		return;
#line 8713 "WindowManager.c"
	}
#line 1250 "../src/WindowManager.vala"
	G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->kill_window_effects ((MetaPlugin*) self, _data13_->actor);
#line 1251 "../src/WindowManager.vala"
	_tmp8_ = self->priv->minimizing;
#line 1251 "../src/WindowManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _data13_->actor);
#line 1254 "../src/WindowManager.vala"
	_tmp9_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1254 "../src/WindowManager.vala"
	meta_display_get_size (_tmp9_, &_tmp10_, &_tmp11_);
#line 1254 "../src/WindowManager.vala"
	width = _tmp10_;
#line 1254 "../src/WindowManager.vala"
	height = _tmp11_;
#line 1257 "../src/WindowManager.vala"
	icon = _tmp12_;
#line 1261 "../src/WindowManager.vala"
	_tmp13_ = meta_window_actor_get_meta_window (_data13_->actor);
#line 1261 "../src/WindowManager.vala"
	_tmp15_ = meta_window_get_icon_geometry (_tmp13_, &_tmp14_);
#line 1261 "../src/WindowManager.vala"
	icon = _tmp14_;
#line 1261 "../src/WindowManager.vala"
	if (_tmp15_) {
#line 8739 "WindowManager.c"
		Block14Data* _data14_;
		gfloat ui_scale = 0.0F;
		MetaDisplay* _tmp16_;
		MetaDisplay* _tmp17_;
		MtkRectangle _tmp18_;
		MtkRectangle _tmp19_;
		MtkRectangle _tmp20_;
		MtkRectangle _tmp21_;
		MtkRectangle _tmp22_;
		gfloat scale_x = 0.0F;
		MtkRectangle _tmp23_;
		gfloat _tmp24_;
		gfloat _tmp25_;
		gfloat scale_y = 0.0F;
		MtkRectangle _tmp26_;
		gfloat _tmp27_;
		gfloat _tmp28_;
		gfloat anchor_x = 0.0F;
		gfloat _tmp29_;
		gfloat _tmp30_;
		MtkRectangle _tmp31_;
		MtkRectangle _tmp32_;
		gfloat _tmp33_;
		gfloat _tmp34_;
		gfloat anchor_y = 0.0F;
		gfloat _tmp35_;
		gfloat _tmp36_;
		MtkRectangle _tmp37_;
		MtkRectangle _tmp38_;
		gfloat _tmp39_;
		gfloat _tmp40_;
		gulong _tmp41_;
#line 1261 "../src/WindowManager.vala"
		_data14_ = g_slice_new0 (Block14Data);
#line 1261 "../src/WindowManager.vala"
		_data14_->_ref_count_ = 1;
#line 1261 "../src/WindowManager.vala"
		_data14_->_data13_ = block13_data_ref (_data13_);
#line 1263 "../src/WindowManager.vala"
		_tmp16_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1263 "../src/WindowManager.vala"
		_tmp17_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1263 "../src/WindowManager.vala"
		_tmp18_ = icon;
#line 1263 "../src/WindowManager.vala"
		ui_scale = meta_display_get_monitor_scale (_tmp16_, meta_display_get_monitor_index_for_rect (_tmp17_, &_tmp18_));
#line 1264 "../src/WindowManager.vala"
		_tmp19_ = icon;
#line 1264 "../src/WindowManager.vala"
		icon.x = gala_internal_utils_scale_to_int (_tmp19_.x, ui_scale);
#line 1265 "../src/WindowManager.vala"
		_tmp20_ = icon;
#line 1265 "../src/WindowManager.vala"
		icon.y = gala_internal_utils_scale_to_int (_tmp20_.y, ui_scale);
#line 1266 "../src/WindowManager.vala"
		_tmp21_ = icon;
#line 1266 "../src/WindowManager.vala"
		icon.width = gala_internal_utils_scale_to_int (_tmp21_.width, ui_scale);
#line 1267 "../src/WindowManager.vala"
		_tmp22_ = icon;
#line 1267 "../src/WindowManager.vala"
		icon.height = gala_internal_utils_scale_to_int (_tmp22_.height, ui_scale);
#line 1269 "../src/WindowManager.vala"
		_tmp23_ = icon;
#line 1269 "../src/WindowManager.vala"
		_tmp24_ = clutter_actor_get_width ((ClutterActor*) _data13_->actor);
#line 1269 "../src/WindowManager.vala"
		_tmp25_ = _tmp24_;
#line 1269 "../src/WindowManager.vala"
		scale_x = ((gfloat) _tmp23_.width) / _tmp25_;
#line 1270 "../src/WindowManager.vala"
		_tmp26_ = icon;
#line 1270 "../src/WindowManager.vala"
		_tmp27_ = clutter_actor_get_height ((ClutterActor*) _data13_->actor);
#line 1270 "../src/WindowManager.vala"
		_tmp28_ = _tmp27_;
#line 1270 "../src/WindowManager.vala"
		scale_y = ((gfloat) _tmp26_.height) / _tmp28_;
#line 1271 "../src/WindowManager.vala"
		_tmp29_ = clutter_actor_get_x ((ClutterActor*) _data13_->actor);
#line 1271 "../src/WindowManager.vala"
		_tmp30_ = _tmp29_;
#line 1271 "../src/WindowManager.vala"
		_tmp31_ = icon;
#line 1271 "../src/WindowManager.vala"
		_tmp32_ = icon;
#line 1271 "../src/WindowManager.vala"
		_tmp33_ = clutter_actor_get_width ((ClutterActor*) _data13_->actor);
#line 1271 "../src/WindowManager.vala"
		_tmp34_ = _tmp33_;
#line 1271 "../src/WindowManager.vala"
		anchor_x = ((gfloat) (_tmp30_ - _tmp31_.x)) / (_tmp32_.width - _tmp34_);
#line 1272 "../src/WindowManager.vala"
		_tmp35_ = clutter_actor_get_y ((ClutterActor*) _data13_->actor);
#line 1272 "../src/WindowManager.vala"
		_tmp36_ = _tmp35_;
#line 1272 "../src/WindowManager.vala"
		_tmp37_ = icon;
#line 1272 "../src/WindowManager.vala"
		_tmp38_ = icon;
#line 1272 "../src/WindowManager.vala"
		_tmp39_ = clutter_actor_get_height ((ClutterActor*) _data13_->actor);
#line 1272 "../src/WindowManager.vala"
		_tmp40_ = _tmp39_;
#line 1272 "../src/WindowManager.vala"
		anchor_y = ((gfloat) (_tmp36_ - _tmp37_.y)) / (_tmp38_.height - _tmp40_);
#line 1273 "../src/WindowManager.vala"
		clutter_actor_set_pivot_point ((ClutterActor*) _data13_->actor, anchor_x, anchor_y);
#line 1275 "../src/WindowManager.vala"
		clutter_actor_save_easing_state ((ClutterActor*) _data13_->actor);
#line 1276 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) _data13_->actor, CLUTTER_EASE_IN_EXPO);
#line 1277 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) _data13_->actor, (guint) duration);
#line 1278 "../src/WindowManager.vala"
		clutter_actor_set_scale ((ClutterActor*) _data13_->actor, (gdouble) scale_x, (gdouble) scale_y);
#line 1279 "../src/WindowManager.vala"
		clutter_actor_set_opacity ((ClutterActor*) _data13_->actor, 0U);
#line 1280 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) _data13_->actor);
#line 1282 "../src/WindowManager.vala"
		_data14_->minimize_handler_id = 0UL;
#line 1283 "../src/WindowManager.vala"
		_tmp41_ = g_signal_connect_data ((ClutterActor*) _data13_->actor, "transitions-completed", (GCallback) ____lambda151__clutter_actor_transitions_completed, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 1283 "../src/WindowManager.vala"
		_data14_->minimize_handler_id = _tmp41_;
#line 1261 "../src/WindowManager.vala"
		block14_data_unref (_data14_);
#line 1261 "../src/WindowManager.vala"
		_data14_ = NULL;
#line 8870 "WindowManager.c"
	} else {
		Block15Data* _data15_;
		gulong _tmp42_;
#line 1261 "../src/WindowManager.vala"
		_data15_ = g_slice_new0 (Block15Data);
#line 1261 "../src/WindowManager.vala"
		_data15_->_ref_count_ = 1;
#line 1261 "../src/WindowManager.vala"
		_data15_->_data13_ = block13_data_ref (_data13_);
#line 1290 "../src/WindowManager.vala"
		clutter_actor_set_pivot_point ((ClutterActor*) _data13_->actor, 0.5f, 1.0f);
#line 1292 "../src/WindowManager.vala"
		clutter_actor_save_easing_state ((ClutterActor*) _data13_->actor);
#line 1293 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) _data13_->actor, CLUTTER_EASE_IN_EXPO);
#line 1294 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) _data13_->actor, (guint) duration);
#line 1295 "../src/WindowManager.vala"
		clutter_actor_set_scale ((ClutterActor*) _data13_->actor, (gdouble) 0.0f, (gdouble) 0.0f);
#line 1296 "../src/WindowManager.vala"
		clutter_actor_set_opacity ((ClutterActor*) _data13_->actor, 0U);
#line 1297 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) _data13_->actor);
#line 1299 "../src/WindowManager.vala"
		_data15_->minimize_handler_id = 0UL;
#line 1300 "../src/WindowManager.vala"
		_tmp42_ = g_signal_connect_data ((ClutterActor*) _data13_->actor, "transitions-completed", (GCallback) ____lambda152__clutter_actor_transitions_completed, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
#line 1300 "../src/WindowManager.vala"
		_data15_->minimize_handler_id = _tmp42_;
#line 1261 "../src/WindowManager.vala"
		block15_data_unref (_data15_);
#line 1261 "../src/WindowManager.vala"
		_data15_ = NULL;
#line 8904 "WindowManager.c"
	}
#line 1240 "../src/WindowManager.vala"
	block13_data_unref (_data13_);
#line 1240 "../src/WindowManager.vala"
	_data13_ = NULL;
#line 8910 "WindowManager.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 1311 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 1311 "../src/WindowManager.vala"
	return _data16_;
#line 8920 "WindowManager.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 1311 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 8930 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1311 "../src/WindowManager.vala"
		self = _data16_->self;
#line 1311 "../src/WindowManager.vala"
		_g_object_unref0 (_data16_->actor);
#line 1311 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1311 "../src/WindowManager.vala"
		g_slice_free (Block16Data, _data16_);
#line 8940 "WindowManager.c"
	}
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 1326 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 1326 "../src/WindowManager.vala"
	return _data17_;
#line 8951 "WindowManager.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 1326 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 8961 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1326 "../src/WindowManager.vala"
		self = _data17_->_data16_->self;
#line 1326 "../src/WindowManager.vala"
		block16_data_unref (_data17_->_data16_);
#line 1326 "../src/WindowManager.vala"
		_data17_->_data16_ = NULL;
#line 1326 "../src/WindowManager.vala"
		g_slice_free (Block17Data, _data17_);
#line 8971 "WindowManager.c"
	}
}

static gboolean
____lambda146_ (Block17Data* _data17_)
{
	Block16Data* _data16_;
	GalaWindowManagerGala* self;
	gboolean result;
#line 1348 "../src/WindowManager.vala"
	_data16_ = _data17_->_data16_;
#line 1348 "../src/WindowManager.vala"
	self = _data16_->self;
#line 1349 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) _data16_->actor, (guint) 255);
#line 1350 "../src/WindowManager.vala"
	result = FALSE;
#line 1350 "../src/WindowManager.vala"
	return result;
#line 8991 "WindowManager.c"
}

static gboolean
_____lambda146__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda146_ (self);
#line 1348 "../src/WindowManager.vala"
	return result;
#line 9001 "WindowManager.c"
}

static void
___lambda147_ (Block17Data* _data17_)
{
	Block16Data* _data16_;
	GalaWindowManagerGala* self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 1372 "../src/WindowManager.vala"
	_data16_ = _data17_->_data16_;
#line 1372 "../src/WindowManager.vala"
	self = _data16_->self;
#line 1373 "../src/WindowManager.vala"
	_tmp0_ = self->priv->latest_window_snapshot;
#line 1373 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _data17_->maximize_old_handler_id);
#line 1374 "../src/WindowManager.vala"
	_tmp1_ = self->priv->latest_window_snapshot;
#line 1374 "../src/WindowManager.vala"
	clutter_actor_destroy (_tmp1_);
#line 1375 "../src/WindowManager.vala"
	clutter_actor_set_translation ((ClutterActor*) _data16_->actor, 0.0f, 0.0f, 0.0f);
#line 9025 "WindowManager.c"
}

static void
____lambda147__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1372 "../src/WindowManager.vala"
	___lambda147_ (self);
#line 9034 "WindowManager.c"
}

static void
___lambda148_ (Block17Data* _data17_)
{
	Block16Data* _data16_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1392 "../src/WindowManager.vala"
	_data16_ = _data17_->_data16_;
#line 1392 "../src/WindowManager.vala"
	self = _data16_->self;
#line 1393 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data16_->actor, _data17_->handler_id);
#line 1394 "../src/WindowManager.vala"
	_tmp0_ = self->priv->maximizing;
#line 1394 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data16_->actor);
#line 9053 "WindowManager.c"
}

static void
____lambda148__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1392 "../src/WindowManager.vala"
	___lambda148_ (self);
#line 9062 "WindowManager.c"
}

static void
gala_window_manager_gala_maximize (GalaWindowManagerGala* self,
                                   MetaWindowActor* actor,
                                   gint ex,
                                   gint ey,
                                   gint ew,
                                   gint eh)
{
	Block16Data* _data16_;
	MetaWindowActor* _tmp0_;
	GalaAnimationDuration duration = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp4_;
	gboolean _tmp5_ = FALSE;
	MetaWindow* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	MetaWindow* _tmp11_;
	MetaWindowType _tmp12_;
	MetaWindowType _tmp13_;
#line 1311 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1311 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1311 "../src/WindowManager.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 1311 "../src/WindowManager.vala"
	_data16_->_ref_count_ = 1;
#line 1311 "../src/WindowManager.vala"
	_data16_->self = g_object_ref (self);
#line 1311 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1311 "../src/WindowManager.vala"
	_g_object_unref0 (_data16_->actor);
#line 1311 "../src/WindowManager.vala"
	_data16_->actor = _tmp0_;
#line 1312 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_SNAP;
#line 1314 "../src/WindowManager.vala"
	_tmp2_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1314 "../src/WindowManager.vala"
	_tmp3_ = _tmp2_;
#line 1314 "../src/WindowManager.vala"
	if (!_tmp3_) {
#line 1314 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 9114 "WindowManager.c"
	} else {
#line 1315 "../src/WindowManager.vala"
		_tmp1_ = duration == 0;
#line 9118 "WindowManager.c"
	}
#line 1314 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 1316 "../src/WindowManager.vala"
		block16_data_unref (_data16_);
#line 1316 "../src/WindowManager.vala"
		_data16_ = NULL;
#line 1316 "../src/WindowManager.vala"
		return;
#line 9128 "WindowManager.c"
	}
#line 1319 "../src/WindowManager.vala"
	G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->kill_window_effects ((MetaPlugin*) self, _data16_->actor);
#line 1321 "../src/WindowManager.vala"
	_tmp4_ = meta_window_actor_get_meta_window (_data16_->actor);
#line 1321 "../src/WindowManager.vala"
	window = _tmp4_;
#line 1322 "../src/WindowManager.vala"
	_tmp6_ = window;
#line 1322 "../src/WindowManager.vala"
	g_object_get (_tmp6_, "maximized-horizontally", &_tmp7_, NULL);
#line 1322 "../src/WindowManager.vala"
	_tmp8_ = _tmp7_;
#line 1322 "../src/WindowManager.vala"
	if (_tmp8_) {
#line 9144 "WindowManager.c"
		GSettings* _tmp9_;
#line 1322 "../src/WindowManager.vala"
		_tmp9_ = self->priv->behavior_settings;
#line 1322 "../src/WindowManager.vala"
		_tmp5_ = g_settings_get_boolean (_tmp9_, "move-maximized-workspace");
#line 9150 "WindowManager.c"
	} else {
#line 1322 "../src/WindowManager.vala"
		_tmp5_ = FALSE;
#line 9154 "WindowManager.c"
	}
#line 1322 "../src/WindowManager.vala"
	if (_tmp5_) {
#line 9158 "WindowManager.c"
		MetaWindow* _tmp10_;
#line 1323 "../src/WindowManager.vala"
		_tmp10_ = window;
#line 1323 "../src/WindowManager.vala"
		gala_window_manager_gala_move_window_to_next_ws (self, _tmp10_);
#line 9164 "WindowManager.c"
	}
#line 1326 "../src/WindowManager.vala"
	_tmp11_ = window;
#line 1326 "../src/WindowManager.vala"
	_tmp12_ = meta_window_get_window_type (_tmp11_);
#line 1326 "../src/WindowManager.vala"
	_tmp13_ = _tmp12_;
#line 1326 "../src/WindowManager.vala"
	if (_tmp13_ == META_WINDOW_NORMAL) {
#line 9174 "WindowManager.c"
		Block17Data* _data17_;
		ClutterActor* _tmp14_;
		GeeHashSet* _tmp15_;
		ClutterActor* _tmp16_;
		MtkRectangle _tmp17_;
		MtkRectangle _tmp18_;
		ClutterActor* _tmp19_;
		ClutterActor* _tmp20_;
		ClutterActor* _tmp21_;
#line 1343 "../src/WindowManager.vala"
		static const gint FLASH_PREVENT_TIMEOUT = 80;
#line 9186 "WindowManager.c"
		gint delay = 0;
		gdouble scale_x = 0.0;
		MtkRectangle _tmp22_;
		gdouble scale_y = 0.0;
		MtkRectangle _tmp23_;
		ClutterActor* _tmp24_;
		ClutterActor* _tmp25_;
		ClutterActor* _tmp26_;
		ClutterActor* _tmp27_;
		ClutterActor* _tmp28_;
		ClutterActor* _tmp29_;
		ClutterActor* _tmp30_;
		ClutterActor* _tmp31_;
		ClutterActor* _tmp32_;
		ClutterActor* _tmp33_;
		ClutterActor* _tmp34_;
		gulong _tmp35_;
		ClutterActor* _tmp36_;
		MtkRectangle _tmp37_;
		MtkRectangle _tmp38_;
		gulong _tmp39_;
#line 1326 "../src/WindowManager.vala"
		_data17_ = g_slice_new0 (Block17Data);
#line 1326 "../src/WindowManager.vala"
		_data17_->_ref_count_ = 1;
#line 1326 "../src/WindowManager.vala"
		_data17_->_data16_ = block16_data_ref (_data16_);
#line 1327 "../src/WindowManager.vala"
		_tmp14_ = self->priv->latest_window_snapshot;
#line 1327 "../src/WindowManager.vala"
		if (_tmp14_ == NULL) {
#line 1328 "../src/WindowManager.vala"
			block17_data_unref (_data17_);
#line 1328 "../src/WindowManager.vala"
			_data17_ = NULL;
#line 1328 "../src/WindowManager.vala"
			block16_data_unref (_data16_);
#line 1328 "../src/WindowManager.vala"
			_data16_ = NULL;
#line 1328 "../src/WindowManager.vala"
			return;
#line 9228 "WindowManager.c"
		}
#line 1331 "../src/WindowManager.vala"
		_tmp15_ = self->priv->maximizing;
#line 1331 "../src/WindowManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _data16_->actor);
#line 1332 "../src/WindowManager.vala"
		_tmp16_ = self->priv->latest_window_snapshot;
#line 1332 "../src/WindowManager.vala"
		_tmp17_ = self->priv->old_rect_size_change;
#line 1332 "../src/WindowManager.vala"
		_tmp18_ = self->priv->old_rect_size_change;
#line 1332 "../src/WindowManager.vala"
		clutter_actor_set_position (_tmp16_, (gfloat) _tmp17_.x, (gfloat) _tmp18_.y);
#line 1334 "../src/WindowManager.vala"
		_tmp19_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 1334 "../src/WindowManager.vala"
		_tmp20_ = _tmp19_;
#line 1334 "../src/WindowManager.vala"
		_tmp21_ = self->priv->latest_window_snapshot;
#line 1334 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp20_, _tmp21_);
#line 1344 "../src/WindowManager.vala"
		delay = 0;
#line 1345 "../src/WindowManager.vala"
		if (FLASH_PREVENT_TIMEOUT <= ((gint) (duration / 3))) {
#line 1346 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data16_->actor, (guint) 0);
#line 1347 "../src/WindowManager.vala"
			delay = FLASH_PREVENT_TIMEOUT;
#line 1348 "../src/WindowManager.vala"
			g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) FLASH_PREVENT_TIMEOUT, _____lambda146__gsource_func, block17_data_ref (_data17_), block17_data_unref);
#line 9260 "WindowManager.c"
		}
#line 1354 "../src/WindowManager.vala"
		_tmp22_ = self->priv->old_rect_size_change;
#line 1354 "../src/WindowManager.vala"
		scale_x = ((gdouble) ew) / _tmp22_.width;
#line 1355 "../src/WindowManager.vala"
		_tmp23_ = self->priv->old_rect_size_change;
#line 1355 "../src/WindowManager.vala"
		scale_y = ((gdouble) eh) / _tmp23_.height;
#line 1357 "../src/WindowManager.vala"
		_tmp24_ = self->priv->latest_window_snapshot;
#line 1357 "../src/WindowManager.vala"
		clutter_actor_save_easing_state (_tmp24_);
#line 1358 "../src/WindowManager.vala"
		_tmp25_ = self->priv->latest_window_snapshot;
#line 1358 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode (_tmp25_, CLUTTER_EASE_IN_OUT_QUAD);
#line 1359 "../src/WindowManager.vala"
		_tmp26_ = self->priv->latest_window_snapshot;
#line 1359 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration (_tmp26_, (guint) duration);
#line 1360 "../src/WindowManager.vala"
		_tmp27_ = self->priv->latest_window_snapshot;
#line 1360 "../src/WindowManager.vala"
		clutter_actor_set_position (_tmp27_, (gfloat) ex, (gfloat) ey);
#line 1361 "../src/WindowManager.vala"
		_tmp28_ = self->priv->latest_window_snapshot;
#line 1361 "../src/WindowManager.vala"
		clutter_actor_set_scale (_tmp28_, scale_x, scale_y);
#line 1365 "../src/WindowManager.vala"
		_tmp29_ = self->priv->latest_window_snapshot;
#line 1365 "../src/WindowManager.vala"
		clutter_actor_save_easing_state (_tmp29_);
#line 1366 "../src/WindowManager.vala"
		_tmp30_ = self->priv->latest_window_snapshot;
#line 1366 "../src/WindowManager.vala"
		clutter_actor_set_easing_delay (_tmp30_, (guint) delay);
#line 1367 "../src/WindowManager.vala"
		_tmp31_ = self->priv->latest_window_snapshot;
#line 1367 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration (_tmp31_, (guint) (duration - delay));
#line 1368 "../src/WindowManager.vala"
		_tmp32_ = self->priv->latest_window_snapshot;
#line 1368 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp32_, (guint) 0);
#line 1369 "../src/WindowManager.vala"
		_tmp33_ = self->priv->latest_window_snapshot;
#line 1369 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state (_tmp33_);
#line 1371 "../src/WindowManager.vala"
		_data17_->maximize_old_handler_id = 0UL;
#line 1372 "../src/WindowManager.vala"
		_tmp34_ = self->priv->latest_window_snapshot;
#line 1372 "../src/WindowManager.vala"
		_tmp35_ = g_signal_connect_data (_tmp34_, "transitions-completed", (GCallback) ____lambda147__clutter_actor_transitions_completed, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 1372 "../src/WindowManager.vala"
		_data17_->maximize_old_handler_id = _tmp35_;
#line 1378 "../src/WindowManager.vala"
		_tmp36_ = self->priv->latest_window_snapshot;
#line 1378 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state (_tmp36_);
#line 1380 "../src/WindowManager.vala"
		clutter_actor_set_pivot_point ((ClutterActor*) _data16_->actor, 0.0f, 0.0f);
#line 1381 "../src/WindowManager.vala"
		_tmp37_ = self->priv->old_rect_size_change;
#line 1381 "../src/WindowManager.vala"
		_tmp38_ = self->priv->old_rect_size_change;
#line 1381 "../src/WindowManager.vala"
		clutter_actor_set_translation ((ClutterActor*) _data16_->actor, (gfloat) (_tmp37_.x - ex), (gfloat) (_tmp38_.y - ey), 0.0f);
#line 1382 "../src/WindowManager.vala"
		clutter_actor_set_scale ((ClutterActor*) _data16_->actor, 1.0f / scale_x, 1.0f / scale_y);
#line 1384 "../src/WindowManager.vala"
		clutter_actor_save_easing_state ((ClutterActor*) _data16_->actor);
#line 1385 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) _data16_->actor, CLUTTER_EASE_IN_OUT_QUAD);
#line 1386 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) _data16_->actor, (guint) duration);
#line 1387 "../src/WindowManager.vala"
		clutter_actor_set_scale ((ClutterActor*) _data16_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1388 "../src/WindowManager.vala"
		clutter_actor_set_translation ((ClutterActor*) _data16_->actor, 0.0f, 0.0f, 0.0f);
#line 1389 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) _data16_->actor);
#line 1391 "../src/WindowManager.vala"
		_data17_->handler_id = 0UL;
#line 1392 "../src/WindowManager.vala"
		_tmp39_ = g_signal_connect_data ((ClutterActor*) _data16_->actor, "transitions-completed", (GCallback) ____lambda148__clutter_actor_transitions_completed, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 1392 "../src/WindowManager.vala"
		_data17_->handler_id = _tmp39_;
#line 1326 "../src/WindowManager.vala"
		block17_data_unref (_data17_);
#line 1326 "../src/WindowManager.vala"
		_data17_ = NULL;
#line 9354 "WindowManager.c"
	}
#line 1311 "../src/WindowManager.vala"
	block16_data_unref (_data16_);
#line 1311 "../src/WindowManager.vala"
	_data16_ = NULL;
#line 9360 "WindowManager.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 1399 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 1399 "../src/WindowManager.vala"
	return _data18_;
#line 9370 "WindowManager.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 1399 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 9380 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1399 "../src/WindowManager.vala"
		self = _data18_->self;
#line 1399 "../src/WindowManager.vala"
		_g_object_unref0 (_data18_->actor);
#line 1399 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1399 "../src/WindowManager.vala"
		g_slice_free (Block18Data, _data18_);
#line 9390 "WindowManager.c"
	}
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 1414 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 1414 "../src/WindowManager.vala"
	return _data19_;
#line 9401 "WindowManager.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 1414 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 9411 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1414 "../src/WindowManager.vala"
		self = _data19_->_data18_->self;
#line 1414 "../src/WindowManager.vala"
		block18_data_unref (_data19_->_data18_);
#line 1414 "../src/WindowManager.vala"
		_data19_->_data18_ = NULL;
#line 1414 "../src/WindowManager.vala"
		g_slice_free (Block19Data, _data19_);
#line 9421 "WindowManager.c"
	}
}

static void
___lambda153_ (Block19Data* _data19_)
{
	Block18Data* _data18_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1430 "../src/WindowManager.vala"
	_data18_ = _data19_->_data18_;
#line 1430 "../src/WindowManager.vala"
	self = _data18_->self;
#line 1431 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data18_->actor, _data19_->unminimize_handler_id);
#line 1432 "../src/WindowManager.vala"
	_tmp0_ = self->priv->unminimizing;
#line 1432 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data18_->actor);
#line 1433 "../src/WindowManager.vala"
	meta_plugin_unminimize_completed ((MetaPlugin*) self, _data18_->actor);
#line 9443 "WindowManager.c"
}

static void
____lambda153__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1430 "../src/WindowManager.vala"
	___lambda153_ (self);
#line 9452 "WindowManager.c"
}

static void
gala_window_manager_gala_real_unminimize (MetaPlugin* base,
                                          MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	Block18Data* _data18_;
	MetaWindowActor* _tmp0_;
	GalaAnimationDuration duration = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp4_;
	MetaWindow* _tmp5_;
	MetaWindowType _tmp6_;
	MetaWindowType _tmp7_;
#line 1399 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1399 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1399 "../src/WindowManager.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 1399 "../src/WindowManager.vala"
	_data18_->_ref_count_ = 1;
#line 1399 "../src/WindowManager.vala"
	_data18_->self = g_object_ref (self);
#line 1399 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1399 "../src/WindowManager.vala"
	_g_object_unref0 (_data18_->actor);
#line 1399 "../src/WindowManager.vala"
	_data18_->actor = _tmp0_;
#line 1400 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_HIDE;
#line 1402 "../src/WindowManager.vala"
	_tmp2_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1402 "../src/WindowManager.vala"
	_tmp3_ = _tmp2_;
#line 1402 "../src/WindowManager.vala"
	if (!_tmp3_) {
#line 1402 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 9497 "WindowManager.c"
	} else {
#line 1403 "../src/WindowManager.vala"
		_tmp1_ = duration == 0;
#line 9501 "WindowManager.c"
	}
#line 1402 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 1404 "../src/WindowManager.vala"
		clutter_actor_show ((ClutterActor*) _data18_->actor);
#line 1405 "../src/WindowManager.vala"
		meta_plugin_unminimize_completed ((MetaPlugin*) self, _data18_->actor);
#line 1406 "../src/WindowManager.vala"
		block18_data_unref (_data18_);
#line 1406 "../src/WindowManager.vala"
		_data18_ = NULL;
#line 1406 "../src/WindowManager.vala"
		return;
#line 9515 "WindowManager.c"
	}
#line 1409 "../src/WindowManager.vala"
	_tmp4_ = meta_window_actor_get_meta_window (_data18_->actor);
#line 1409 "../src/WindowManager.vala"
	window = _tmp4_;
#line 1411 "../src/WindowManager.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) _data18_->actor);
#line 1412 "../src/WindowManager.vala"
	clutter_actor_show ((ClutterActor*) _data18_->actor);
#line 1414 "../src/WindowManager.vala"
	_tmp5_ = window;
#line 1414 "../src/WindowManager.vala"
	_tmp6_ = meta_window_get_window_type (_tmp5_);
#line 1414 "../src/WindowManager.vala"
	_tmp7_ = _tmp6_;
#line 1414 "../src/WindowManager.vala"
	switch (_tmp7_) {
#line 1414 "../src/WindowManager.vala"
		case META_WINDOW_NORMAL:
#line 9535 "WindowManager.c"
		{
			Block19Data* _data19_;
			GeeHashSet* _tmp8_;
			gulong _tmp9_;
#line 1414 "../src/WindowManager.vala"
			_data19_ = g_slice_new0 (Block19Data);
#line 1414 "../src/WindowManager.vala"
			_data19_->_ref_count_ = 1;
#line 1414 "../src/WindowManager.vala"
			_data19_->_data18_ = block18_data_ref (_data18_);
#line 1416 "../src/WindowManager.vala"
			_tmp8_ = self->priv->unminimizing;
#line 1416 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _data18_->actor);
#line 1418 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data18_->actor, 0.5f, 1.0f);
#line 1419 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data18_->actor, (gdouble) 0.01f, (gdouble) 0.1f);
#line 1420 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data18_->actor, 0U);
#line 1422 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data18_->actor);
#line 1423 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data18_->actor, CLUTTER_EASE_OUT_EXPO);
#line 1424 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data18_->actor, (guint) duration);
#line 1425 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data18_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1426 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data18_->actor, 255U);
#line 1427 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data18_->actor);
#line 1429 "../src/WindowManager.vala"
			_data19_->unminimize_handler_id = 0UL;
#line 1430 "../src/WindowManager.vala"
			_tmp9_ = g_signal_connect_data ((ClutterActor*) _data18_->actor, "transitions-completed", (GCallback) ____lambda153__clutter_actor_transitions_completed, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 1430 "../src/WindowManager.vala"
			_data19_->unminimize_handler_id = _tmp9_;
#line 1436 "../src/WindowManager.vala"
			block19_data_unref (_data19_);
#line 1436 "../src/WindowManager.vala"
			_data19_ = NULL;
#line 1436 "../src/WindowManager.vala"
			break;
#line 9580 "WindowManager.c"
		}
		default:
		{
#line 1438 "../src/WindowManager.vala"
			meta_plugin_unminimize_completed ((MetaPlugin*) self, _data18_->actor);
#line 1439 "../src/WindowManager.vala"
			break;
#line 9588 "WindowManager.c"
		}
	}
#line 1399 "../src/WindowManager.vala"
	block18_data_unref (_data18_);
#line 1399 "../src/WindowManager.vala"
	_data18_ = NULL;
#line 9595 "WindowManager.c"
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 1443 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 1443 "../src/WindowManager.vala"
	return _data20_;
#line 9605 "WindowManager.c"
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 1443 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 9615 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1443 "../src/WindowManager.vala"
		self = _data20_->self;
#line 1443 "../src/WindowManager.vala"
		_g_object_unref0 (_data20_->actor);
#line 1443 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1443 "../src/WindowManager.vala"
		g_slice_free (Block20Data, _data20_);
#line 9625 "WindowManager.c"
	}
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 1467 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 1467 "../src/WindowManager.vala"
	return _data21_;
#line 9636 "WindowManager.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 1467 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 9646 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1467 "../src/WindowManager.vala"
		self = _data21_->_data20_->self;
#line 1467 "../src/WindowManager.vala"
		block20_data_unref (_data21_->_data20_);
#line 1467 "../src/WindowManager.vala"
		_data21_->_data20_ = NULL;
#line 1467 "../src/WindowManager.vala"
		g_slice_free (Block21Data, _data21_);
#line 9656 "WindowManager.c"
	}
}

static void
___lambda154_ (Block21Data* _data21_)
{
	Block20Data* _data20_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
	MetaWindow* _tmp1_;
#line 1494 "../src/WindowManager.vala"
	_data20_ = _data21_->_data20_;
#line 1494 "../src/WindowManager.vala"
	self = _data20_->self;
#line 1495 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data20_->actor, _data21_->map_handler_id);
#line 1496 "../src/WindowManager.vala"
	_tmp0_ = self->priv->mapping;
#line 1496 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data20_->actor);
#line 1497 "../src/WindowManager.vala"
	meta_plugin_map_completed ((MetaPlugin*) self, _data20_->actor);
#line 1499 "../src/WindowManager.vala"
	_tmp1_ = _data20_->window;
#line 1499 "../src/WindowManager.vala"
	if (meta_window_get_layer (_tmp1_) == META_LAYER_BOTTOM) {
#line 9683 "WindowManager.c"
		MetaWindow* _tmp2_;
#line 1500 "../src/WindowManager.vala"
		_tmp2_ = _data20_->window;
#line 1500 "../src/WindowManager.vala"
		gala_window_manager_gala_show_bottom_stack_window (self, _tmp2_);
#line 9689 "WindowManager.c"
	}
}

static void
____lambda154__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1494 "../src/WindowManager.vala"
	___lambda154_ (self);
#line 9699 "WindowManager.c"
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
#line 1467 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data22_->_ref_count_);
#line 1467 "../src/WindowManager.vala"
	return _data22_;
#line 9709 "WindowManager.c"
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
#line 1467 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
#line 9719 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1467 "../src/WindowManager.vala"
		self = _data22_->_data20_->self;
#line 1467 "../src/WindowManager.vala"
		block20_data_unref (_data22_->_data20_);
#line 1467 "../src/WindowManager.vala"
		_data22_->_data20_ = NULL;
#line 1467 "../src/WindowManager.vala"
		g_slice_free (Block22Data, _data22_);
#line 9729 "WindowManager.c"
	}
}

static void
___lambda155_ (Block22Data* _data22_)
{
	Block20Data* _data20_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1528 "../src/WindowManager.vala"
	_data20_ = _data22_->_data20_;
#line 1528 "../src/WindowManager.vala"
	self = _data20_->self;
#line 1529 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data20_->actor, _data22_->map_handler_id);
#line 1530 "../src/WindowManager.vala"
	_tmp0_ = self->priv->mapping;
#line 1530 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data20_->actor);
#line 1531 "../src/WindowManager.vala"
	meta_plugin_map_completed ((MetaPlugin*) self, _data20_->actor);
#line 9751 "WindowManager.c"
}

static void
____lambda155__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1528 "../src/WindowManager.vala"
	___lambda155_ (self);
#line 9760 "WindowManager.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 1467 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 1467 "../src/WindowManager.vala"
	return _data23_;
#line 9770 "WindowManager.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 1467 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 9780 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1467 "../src/WindowManager.vala"
		self = _data23_->_data20_->self;
#line 1467 "../src/WindowManager.vala"
		block20_data_unref (_data23_->_data20_);
#line 1467 "../src/WindowManager.vala"
		_data23_->_data20_ = NULL;
#line 1467 "../src/WindowManager.vala"
		g_slice_free (Block23Data, _data23_);
#line 9790 "WindowManager.c"
	}
}

static void
___lambda156_ (Block23Data* _data23_)
{
	Block20Data* _data20_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
	MetaWindow* _tmp1_;
#line 1551 "../src/WindowManager.vala"
	_data20_ = _data23_->_data20_;
#line 1551 "../src/WindowManager.vala"
	self = _data20_->self;
#line 1552 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data20_->actor, _data23_->map_handler_id);
#line 1553 "../src/WindowManager.vala"
	_tmp0_ = self->priv->mapping;
#line 1553 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data20_->actor);
#line 1554 "../src/WindowManager.vala"
	meta_plugin_map_completed ((MetaPlugin*) self, _data20_->actor);
#line 1556 "../src/WindowManager.vala"
	_tmp1_ = _data20_->window;
#line 1556 "../src/WindowManager.vala"
	if (meta_window_get_layer (_tmp1_) == META_LAYER_BOTTOM) {
#line 9817 "WindowManager.c"
		MetaWindow* _tmp2_;
#line 1557 "../src/WindowManager.vala"
		_tmp2_ = _data20_->window;
#line 1557 "../src/WindowManager.vala"
		gala_window_manager_gala_show_bottom_stack_window (self, _tmp2_);
#line 9823 "WindowManager.c"
	}
}

static void
____lambda156__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1551 "../src/WindowManager.vala"
	___lambda156_ (self);
#line 9833 "WindowManager.c"
}

static void
gala_window_manager_gala_real_map (MetaPlugin* base,
                                   MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	Block20Data* _data20_;
	MetaWindowActor* _tmp0_;
	MetaWindow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	MetaWindow* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_;
	gboolean _tmp18_;
	MetaWindow* _tmp26_;
	MetaWindowType _tmp27_;
	MetaWindowType _tmp28_;
#line 1443 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1443 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1443 "../src/WindowManager.vala"
	_data20_ = g_slice_new0 (Block20Data);
#line 1443 "../src/WindowManager.vala"
	_data20_->_ref_count_ = 1;
#line 1443 "../src/WindowManager.vala"
	_data20_->self = g_object_ref (self);
#line 1443 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1443 "../src/WindowManager.vala"
	_g_object_unref0 (_data20_->actor);
#line 1443 "../src/WindowManager.vala"
	_data20_->actor = _tmp0_;
#line 1444 "../src/WindowManager.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_data20_->actor);
#line 1444 "../src/WindowManager.vala"
	_data20_->window = _tmp1_;
#line 1446 "../src/WindowManager.vala"
	_tmp4_ = _data20_->window;
#line 1446 "../src/WindowManager.vala"
	g_object_get (_tmp4_, "maximized-horizontally", &_tmp5_, NULL);
#line 1446 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 1446 "../src/WindowManager.vala"
	if (_tmp6_) {
#line 9883 "WindowManager.c"
		GSettings* _tmp7_;
#line 1446 "../src/WindowManager.vala"
		_tmp7_ = self->priv->behavior_settings;
#line 1446 "../src/WindowManager.vala"
		_tmp3_ = g_settings_get_boolean (_tmp7_, "move-maximized-workspace");
#line 9889 "WindowManager.c"
	} else {
#line 1446 "../src/WindowManager.vala"
		_tmp3_ = FALSE;
#line 9893 "WindowManager.c"
	}
#line 1446 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 1446 "../src/WindowManager.vala"
		_tmp2_ = TRUE;
#line 9899 "WindowManager.c"
	} else {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		MetaWindow* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 1447 "../src/WindowManager.vala"
		_tmp10_ = _data20_->window;
#line 1447 "../src/WindowManager.vala"
		g_object_get (_tmp10_, "fullscreen", &_tmp11_, NULL);
#line 1447 "../src/WindowManager.vala"
		_tmp12_ = _tmp11_;
#line 1447 "../src/WindowManager.vala"
		if (_tmp12_) {
#line 9914 "WindowManager.c"
			MetaWindow* _tmp13_;
#line 1447 "../src/WindowManager.vala"
			_tmp13_ = _data20_->window;
#line 1447 "../src/WindowManager.vala"
			_tmp9_ = meta_window_is_on_primary_monitor (_tmp13_);
#line 9920 "WindowManager.c"
		} else {
#line 1447 "../src/WindowManager.vala"
			_tmp9_ = FALSE;
#line 9924 "WindowManager.c"
		}
#line 1447 "../src/WindowManager.vala"
		if (_tmp9_) {
#line 9928 "WindowManager.c"
			GSettings* _tmp14_;
#line 1447 "../src/WindowManager.vala"
			_tmp14_ = self->priv->behavior_settings;
#line 1447 "../src/WindowManager.vala"
			_tmp8_ = g_settings_get_boolean (_tmp14_, "move-fullscreened-workspace");
#line 9934 "WindowManager.c"
		} else {
#line 1447 "../src/WindowManager.vala"
			_tmp8_ = FALSE;
#line 9938 "WindowManager.c"
		}
#line 1447 "../src/WindowManager.vala"
		_tmp2_ = _tmp8_;
#line 9942 "WindowManager.c"
	}
#line 1446 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 9946 "WindowManager.c"
		MetaWindow* _tmp15_;
#line 1448 "../src/WindowManager.vala"
		_tmp15_ = _data20_->window;
#line 1448 "../src/WindowManager.vala"
		gala_window_manager_gala_move_window_to_next_ws (self, _tmp15_);
#line 9952 "WindowManager.c"
	}
#line 1453 "../src/WindowManager.vala"
	_tmp17_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1453 "../src/WindowManager.vala"
	_tmp18_ = _tmp17_;
#line 1453 "../src/WindowManager.vala"
	if (!_tmp18_) {
#line 9960 "WindowManager.c"
		MetaWindow* _tmp19_;
		MetaWindowType _tmp20_;
		MetaWindowType _tmp21_;
#line 1453 "../src/WindowManager.vala"
		_tmp19_ = _data20_->window;
#line 1453 "../src/WindowManager.vala"
		_tmp20_ = meta_window_get_window_type (_tmp19_);
#line 1453 "../src/WindowManager.vala"
		_tmp21_ = _tmp20_;
#line 1453 "../src/WindowManager.vala"
		_tmp16_ = _tmp21_ != META_WINDOW_NOTIFICATION;
#line 9972 "WindowManager.c"
	} else {
#line 1453 "../src/WindowManager.vala"
		_tmp16_ = FALSE;
#line 9976 "WindowManager.c"
	}
#line 1453 "../src/WindowManager.vala"
	if (_tmp16_) {
#line 9980 "WindowManager.c"
		gboolean _tmp22_ = FALSE;
		MetaWindow* _tmp23_;
#line 1454 "../src/WindowManager.vala"
		clutter_actor_show ((ClutterActor*) _data20_->actor);
#line 1455 "../src/WindowManager.vala"
		meta_plugin_map_completed ((MetaPlugin*) self, _data20_->actor);
#line 1457 "../src/WindowManager.vala"
		_tmp23_ = _data20_->window;
#line 1457 "../src/WindowManager.vala"
		if (gala_internal_utils_get_window_is_normal (_tmp23_)) {
#line 9991 "WindowManager.c"
			MetaWindow* _tmp24_;
#line 1457 "../src/WindowManager.vala"
			_tmp24_ = _data20_->window;
#line 1457 "../src/WindowManager.vala"
			_tmp22_ = meta_window_get_layer (_tmp24_) == META_LAYER_BOTTOM;
#line 9997 "WindowManager.c"
		} else {
#line 1457 "../src/WindowManager.vala"
			_tmp22_ = FALSE;
#line 10001 "WindowManager.c"
		}
#line 1457 "../src/WindowManager.vala"
		if (_tmp22_) {
#line 10005 "WindowManager.c"
			MetaWindow* _tmp25_;
#line 1458 "../src/WindowManager.vala"
			_tmp25_ = _data20_->window;
#line 1458 "../src/WindowManager.vala"
			gala_window_manager_gala_show_bottom_stack_window (self, _tmp25_);
#line 10011 "WindowManager.c"
		}
#line 1461 "../src/WindowManager.vala"
		block20_data_unref (_data20_);
#line 1461 "../src/WindowManager.vala"
		_data20_ = NULL;
#line 1461 "../src/WindowManager.vala"
		return;
#line 10019 "WindowManager.c"
	}
#line 1464 "../src/WindowManager.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) _data20_->actor);
#line 1465 "../src/WindowManager.vala"
	clutter_actor_show ((ClutterActor*) _data20_->actor);
#line 1467 "../src/WindowManager.vala"
	_tmp26_ = _data20_->window;
#line 1467 "../src/WindowManager.vala"
	_tmp27_ = meta_window_get_window_type (_tmp26_);
#line 1467 "../src/WindowManager.vala"
	_tmp28_ = _tmp27_;
#line 1467 "../src/WindowManager.vala"
	switch (_tmp28_) {
#line 1467 "../src/WindowManager.vala"
		case META_WINDOW_NORMAL:
#line 10035 "WindowManager.c"
		{
			Block21Data* _data21_;
			GalaAnimationDuration duration = 0;
			GeeHashSet* _tmp29_;
			gboolean _tmp30_ = FALSE;
			MetaWindow* _tmp31_;
			gboolean _tmp32_;
			gboolean _tmp33_;
			gulong _tmp41_;
#line 1467 "../src/WindowManager.vala"
			_data21_ = g_slice_new0 (Block21Data);
#line 1467 "../src/WindowManager.vala"
			_data21_->_ref_count_ = 1;
#line 1467 "../src/WindowManager.vala"
			_data21_->_data20_ = block20_data_ref (_data20_);
#line 1469 "../src/WindowManager.vala"
			duration = GALA_ANIMATION_DURATION_HIDE;
#line 1470 "../src/WindowManager.vala"
			if (duration == 0) {
#line 1471 "../src/WindowManager.vala"
				meta_plugin_map_completed ((MetaPlugin*) self, _data20_->actor);
#line 1472 "../src/WindowManager.vala"
				block21_data_unref (_data21_);
#line 1472 "../src/WindowManager.vala"
				_data21_ = NULL;
#line 1472 "../src/WindowManager.vala"
				block20_data_unref (_data20_);
#line 1472 "../src/WindowManager.vala"
				_data20_ = NULL;
#line 1472 "../src/WindowManager.vala"
				return;
#line 10067 "WindowManager.c"
			}
#line 1475 "../src/WindowManager.vala"
			_tmp29_ = self->priv->mapping;
#line 1475 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _data20_->actor);
#line 1477 "../src/WindowManager.vala"
			_tmp31_ = _data20_->window;
#line 1477 "../src/WindowManager.vala"
			g_object_get (_tmp31_, "maximized-vertically", &_tmp32_, NULL);
#line 1477 "../src/WindowManager.vala"
			_tmp33_ = _tmp32_;
#line 1477 "../src/WindowManager.vala"
			if (_tmp33_) {
#line 1477 "../src/WindowManager.vala"
				_tmp30_ = TRUE;
#line 10083 "WindowManager.c"
			} else {
				MetaWindow* _tmp34_;
				gboolean _tmp35_;
				gboolean _tmp36_;
#line 1477 "../src/WindowManager.vala"
				_tmp34_ = _data20_->window;
#line 1477 "../src/WindowManager.vala"
				g_object_get (_tmp34_, "maximized-horizontally", &_tmp35_, NULL);
#line 1477 "../src/WindowManager.vala"
				_tmp36_ = _tmp35_;
#line 1477 "../src/WindowManager.vala"
				_tmp30_ = _tmp36_;
#line 10096 "WindowManager.c"
			}
#line 1477 "../src/WindowManager.vala"
			if (_tmp30_) {
#line 10100 "WindowManager.c"
				MtkRectangle outer_rect = {0};
				MetaWindow* _tmp37_;
				MtkRectangle _tmp38_ = {0};
				MtkRectangle _tmp39_;
				MtkRectangle _tmp40_;
#line 1478 "../src/WindowManager.vala"
				_tmp37_ = _data20_->window;
#line 1478 "../src/WindowManager.vala"
				meta_window_get_frame_rect (_tmp37_, &_tmp38_);
#line 1478 "../src/WindowManager.vala"
				outer_rect = _tmp38_;
#line 1479 "../src/WindowManager.vala"
				_tmp39_ = outer_rect;
#line 1479 "../src/WindowManager.vala"
				_tmp40_ = outer_rect;
#line 1479 "../src/WindowManager.vala"
				clutter_actor_set_position ((ClutterActor*) _data20_->actor, (gfloat) _tmp39_.x, (gfloat) _tmp40_.y);
#line 10118 "WindowManager.c"
			}
#line 1482 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data20_->actor, 0.5f, 1.0f);
#line 1483 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data20_->actor, (gdouble) 0.01f, (gdouble) 0.1f);
#line 1484 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data20_->actor, (guint) 0);
#line 1486 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data20_->actor);
#line 1487 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data20_->actor, CLUTTER_EASE_OUT_EXPO);
#line 1488 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data20_->actor, (guint) duration);
#line 1489 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data20_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1490 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data20_->actor, 255U);
#line 1491 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data20_->actor);
#line 1493 "../src/WindowManager.vala"
			_data21_->map_handler_id = 0UL;
#line 1494 "../src/WindowManager.vala"
			_tmp41_ = g_signal_connect_data ((ClutterActor*) _data20_->actor, "transitions-completed", (GCallback) ____lambda154__clutter_actor_transitions_completed, block21_data_ref (_data21_), (GClosureNotify) block21_data_unref, 0);
#line 1494 "../src/WindowManager.vala"
			_data21_->map_handler_id = _tmp41_;
#line 1503 "../src/WindowManager.vala"
			block21_data_unref (_data21_);
#line 1503 "../src/WindowManager.vala"
			_data21_ = NULL;
#line 1503 "../src/WindowManager.vala"
			break;
#line 10150 "WindowManager.c"
		}
#line 1467 "../src/WindowManager.vala"
		case META_WINDOW_MENU:
#line 1467 "../src/WindowManager.vala"
		case META_WINDOW_DROPDOWN_MENU:
#line 1467 "../src/WindowManager.vala"
		case META_WINDOW_POPUP_MENU:
#line 10158 "WindowManager.c"
		{
			Block22Data* _data22_;
			GalaAnimationDuration duration = 0;
			GeeHashSet* _tmp42_;
			gulong _tmp43_;
#line 1467 "../src/WindowManager.vala"
			_data22_ = g_slice_new0 (Block22Data);
#line 1467 "../src/WindowManager.vala"
			_data22_->_ref_count_ = 1;
#line 1467 "../src/WindowManager.vala"
			_data22_->_data20_ = block20_data_ref (_data20_);
#line 1507 "../src/WindowManager.vala"
			duration = GALA_ANIMATION_DURATION_MENU_MAP;
#line 1508 "../src/WindowManager.vala"
			if (duration == 0) {
#line 1509 "../src/WindowManager.vala"
				meta_plugin_map_completed ((MetaPlugin*) self, _data20_->actor);
#line 1510 "../src/WindowManager.vala"
				block22_data_unref (_data22_);
#line 1510 "../src/WindowManager.vala"
				_data22_ = NULL;
#line 1510 "../src/WindowManager.vala"
				block20_data_unref (_data20_);
#line 1510 "../src/WindowManager.vala"
				_data20_ = NULL;
#line 1510 "../src/WindowManager.vala"
				return;
#line 10186 "WindowManager.c"
			}
#line 1513 "../src/WindowManager.vala"
			_tmp42_ = self->priv->mapping;
#line 1513 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp42_, _data20_->actor);
#line 1515 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data20_->actor, 0.5f, 0.5f);
#line 1516 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point_z ((ClutterActor*) _data20_->actor, 0.2f);
#line 1517 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data20_->actor, (gdouble) 0.9f, (gdouble) 0.9f);
#line 1518 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data20_->actor, (guint) 0);
#line 1520 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data20_->actor);
#line 1521 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data20_->actor, CLUTTER_EASE_OUT_QUAD);
#line 1522 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data20_->actor, (guint) duration);
#line 1523 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data20_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1524 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data20_->actor, 255U);
#line 1525 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data20_->actor);
#line 1527 "../src/WindowManager.vala"
			_data22_->map_handler_id = 0UL;
#line 1528 "../src/WindowManager.vala"
			_tmp43_ = g_signal_connect_data ((ClutterActor*) _data20_->actor, "transitions-completed", (GCallback) ____lambda155__clutter_actor_transitions_completed, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
#line 1528 "../src/WindowManager.vala"
			_data22_->map_handler_id = _tmp43_;
#line 1533 "../src/WindowManager.vala"
			block22_data_unref (_data22_);
#line 1533 "../src/WindowManager.vala"
			_data22_ = NULL;
#line 1533 "../src/WindowManager.vala"
			break;
#line 10224 "WindowManager.c"
		}
#line 1467 "../src/WindowManager.vala"
		case META_WINDOW_MODAL_DIALOG:
#line 1467 "../src/WindowManager.vala"
		case META_WINDOW_DIALOG:
#line 10230 "WindowManager.c"
		{
			Block23Data* _data23_;
			GeeHashSet* _tmp44_;
			gulong _tmp45_;
			MetaWindow* _tmp46_;
#line 1467 "../src/WindowManager.vala"
			_data23_ = g_slice_new0 (Block23Data);
#line 1467 "../src/WindowManager.vala"
			_data23_->_ref_count_ = 1;
#line 1467 "../src/WindowManager.vala"
			_data23_->_data20_ = block20_data_ref (_data20_);
#line 1537 "../src/WindowManager.vala"
			_tmp44_ = self->priv->mapping;
#line 1537 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp44_, _data20_->actor);
#line 1539 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data20_->actor, 0.5f, 0.5f);
#line 1540 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data20_->actor, (gdouble) 1.05f, (gdouble) 1.05f);
#line 1541 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data20_->actor, (guint) 0);
#line 1543 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data20_->actor);
#line 1544 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data20_->actor, CLUTTER_EASE_OUT_QUAD);
#line 1545 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data20_->actor, (guint) 200);
#line 1546 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data20_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1547 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data20_->actor, 255U);
#line 1548 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data20_->actor);
#line 1550 "../src/WindowManager.vala"
			_data23_->map_handler_id = 0UL;
#line 1551 "../src/WindowManager.vala"
			_tmp45_ = g_signal_connect_data ((ClutterActor*) _data20_->actor, "transitions-completed", (GCallback) ____lambda156__clutter_actor_transitions_completed, block23_data_ref (_data23_), (GClosureNotify) block23_data_unref, 0);
#line 1551 "../src/WindowManager.vala"
			_data23_->map_handler_id = _tmp45_;
#line 1561 "../src/WindowManager.vala"
			_tmp46_ = _data20_->window;
#line 1561 "../src/WindowManager.vala"
			gala_window_manager_gala_dim_parent_window (self, _tmp46_, TRUE);
#line 1563 "../src/WindowManager.vala"
			block23_data_unref (_data23_);
#line 1563 "../src/WindowManager.vala"
			_data23_ = NULL;
#line 1563 "../src/WindowManager.vala"
			break;
#line 10280 "WindowManager.c"
		}
#line 1467 "../src/WindowManager.vala"
		case META_WINDOW_NOTIFICATION:
#line 10284 "WindowManager.c"
		{
			ClutterActor* _tmp47_;
			GalaNotificationStack* _tmp48_;
			gboolean _tmp49_;
			gboolean _tmp50_;
#line 1565 "../src/WindowManager.vala"
			_tmp47_ = self->priv->_notification_group;
#line 1565 "../src/WindowManager.vala"
			gala_window_manager_gala_clutter_actor_reparent ((ClutterActor*) _data20_->actor, _tmp47_);
#line 1566 "../src/WindowManager.vala"
			_tmp48_ = self->priv->notification_stack;
#line 1566 "../src/WindowManager.vala"
			_tmp49_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1566 "../src/WindowManager.vala"
			_tmp50_ = _tmp49_;
#line 1566 "../src/WindowManager.vala"
			gala_notification_stack_show_notification (_tmp48_, _data20_->actor, _tmp50_);
#line 1567 "../src/WindowManager.vala"
			meta_plugin_map_completed ((MetaPlugin*) self, _data20_->actor);
#line 1569 "../src/WindowManager.vala"
			break;
#line 10306 "WindowManager.c"
		}
		default:
		{
#line 1571 "../src/WindowManager.vala"
			meta_plugin_map_completed ((MetaPlugin*) self, _data20_->actor);
#line 1572 "../src/WindowManager.vala"
			break;
#line 10314 "WindowManager.c"
		}
	}
#line 1443 "../src/WindowManager.vala"
	block20_data_unref (_data20_);
#line 1443 "../src/WindowManager.vala"
	_data20_ = NULL;
#line 10321 "WindowManager.c"
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 1576 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 1576 "../src/WindowManager.vala"
	return _data24_;
#line 10331 "WindowManager.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 1576 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 10341 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1576 "../src/WindowManager.vala"
		self = _data24_->self;
#line 1576 "../src/WindowManager.vala"
		_g_object_unref0 (_data24_->actor);
#line 1576 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1576 "../src/WindowManager.vala"
		g_slice_free (Block24Data, _data24_);
#line 10351 "WindowManager.c"
	}
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 1593 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 1593 "../src/WindowManager.vala"
	return _data25_;
#line 10362 "WindowManager.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 1593 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 10372 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1593 "../src/WindowManager.vala"
		self = _data25_->_data24_->self;
#line 1593 "../src/WindowManager.vala"
		block24_data_unref (_data25_->_data24_);
#line 1593 "../src/WindowManager.vala"
		_data25_->_data24_ = NULL;
#line 1593 "../src/WindowManager.vala"
		g_slice_free (Block25Data, _data25_);
#line 10382 "WindowManager.c"
	}
}

static void
___lambda157_ (Block25Data* _data25_)
{
	Block24Data* _data24_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
	MetaWindow* _tmp1_;
#line 1614 "../src/WindowManager.vala"
	_data24_ = _data25_->_data24_;
#line 1614 "../src/WindowManager.vala"
	self = _data24_->self;
#line 1615 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data24_->actor, _data25_->destroy_handler_id);
#line 1616 "../src/WindowManager.vala"
	_tmp0_ = self->priv->destroying;
#line 1616 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data24_->actor);
#line 1617 "../src/WindowManager.vala"
	meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 1618 "../src/WindowManager.vala"
	_tmp1_ = _data24_->window;
#line 1618 "../src/WindowManager.vala"
	gala_utils_clear_window_cache (_tmp1_);
#line 10409 "WindowManager.c"
}

static void
____lambda157__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1614 "../src/WindowManager.vala"
	___lambda157_ (self);
#line 10418 "WindowManager.c"
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
#line 1593 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data26_->_ref_count_);
#line 1593 "../src/WindowManager.vala"
	return _data26_;
#line 10428 "WindowManager.c"
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
#line 1593 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
#line 10438 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1593 "../src/WindowManager.vala"
		self = _data26_->_data24_->self;
#line 1593 "../src/WindowManager.vala"
		block24_data_unref (_data26_->_data24_);
#line 1593 "../src/WindowManager.vala"
		_data26_->_data24_ = NULL;
#line 1593 "../src/WindowManager.vala"
		g_slice_free (Block26Data, _data26_);
#line 10448 "WindowManager.c"
	}
}

static void
___lambda158_ (Block26Data* _data26_)
{
	Block24Data* _data24_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1634 "../src/WindowManager.vala"
	_data24_ = _data26_->_data24_;
#line 1634 "../src/WindowManager.vala"
	self = _data24_->self;
#line 1635 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data24_->actor, _data26_->destroy_handler_id);
#line 1636 "../src/WindowManager.vala"
	_tmp0_ = self->priv->destroying;
#line 1636 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data24_->actor);
#line 1637 "../src/WindowManager.vala"
	meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 10470 "WindowManager.c"
}

static void
____lambda158__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1634 "../src/WindowManager.vala"
	___lambda158_ (self);
#line 10479 "WindowManager.c"
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 1593 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 1593 "../src/WindowManager.vala"
	return _data27_;
#line 10489 "WindowManager.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 1593 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 10499 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1593 "../src/WindowManager.vala"
		self = _data27_->_data24_->self;
#line 1593 "../src/WindowManager.vala"
		block24_data_unref (_data27_->_data24_);
#line 1593 "../src/WindowManager.vala"
		_data27_->_data24_ = NULL;
#line 1593 "../src/WindowManager.vala"
		g_slice_free (Block27Data, _data27_);
#line 10509 "WindowManager.c"
	}
}

static void
___lambda159_ (Block27Data* _data27_)
{
	Block24Data* _data24_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1661 "../src/WindowManager.vala"
	_data24_ = _data27_->_data24_;
#line 1661 "../src/WindowManager.vala"
	self = _data24_->self;
#line 1662 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data24_->actor, _data27_->destroy_handler_id);
#line 1663 "../src/WindowManager.vala"
	_tmp0_ = self->priv->destroying;
#line 1663 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data24_->actor);
#line 1664 "../src/WindowManager.vala"
	meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 10531 "WindowManager.c"
}

static void
____lambda159__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1661 "../src/WindowManager.vala"
	___lambda159_ (self);
#line 10540 "WindowManager.c"
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 1674 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 1674 "../src/WindowManager.vala"
	return _data28_;
#line 10550 "WindowManager.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 1674 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 10560 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1674 "../src/WindowManager.vala"
		self = _data28_->_data24_->self;
#line 1674 "../src/WindowManager.vala"
		block24_data_unref (_data28_->_data24_);
#line 1674 "../src/WindowManager.vala"
		_data28_->_data24_ = NULL;
#line 1674 "../src/WindowManager.vala"
		g_slice_free (Block28Data, _data28_);
#line 10570 "WindowManager.c"
	}
}

static void
____lambda160_ (Block28Data* _data28_)
{
	Block24Data* _data24_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1676 "../src/WindowManager.vala"
	_data24_ = _data28_->_data24_;
#line 1676 "../src/WindowManager.vala"
	self = _data24_->self;
#line 1677 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data24_->actor, _data28_->destroy_handler_id);
#line 1678 "../src/WindowManager.vala"
	_tmp0_ = self->priv->destroying;
#line 1678 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data24_->actor);
#line 1679 "../src/WindowManager.vala"
	meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 10592 "WindowManager.c"
}

static void
_____lambda160__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                     gpointer self)
{
#line 1676 "../src/WindowManager.vala"
	____lambda160_ (self);
#line 10601 "WindowManager.c"
}

static void
gala_window_manager_gala_real_destroy (MetaPlugin* base,
                                       MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	Block24Data* _data24_;
	MetaWindowActor* _tmp0_;
	MetaWindow* _tmp1_;
	GHashTable* _tmp2_;
	MetaWindow* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	MetaWindow* _tmp14_;
	MetaWindowType _tmp15_;
	MetaWindowType _tmp16_;
#line 1576 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1576 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1576 "../src/WindowManager.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 1576 "../src/WindowManager.vala"
	_data24_->_ref_count_ = 1;
#line 1576 "../src/WindowManager.vala"
	_data24_->self = g_object_ref (self);
#line 1576 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1576 "../src/WindowManager.vala"
	_g_object_unref0 (_data24_->actor);
#line 1576 "../src/WindowManager.vala"
	_data24_->actor = _tmp0_;
#line 1577 "../src/WindowManager.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_data24_->actor);
#line 1577 "../src/WindowManager.vala"
	_data24_->window = _tmp1_;
#line 1579 "../src/WindowManager.vala"
	_tmp2_ = self->priv->ws_assoc;
#line 1579 "../src/WindowManager.vala"
	_tmp3_ = _data24_->window;
#line 1579 "../src/WindowManager.vala"
	g_hash_table_remove (_tmp2_, _tmp3_);
#line 1581 "../src/WindowManager.vala"
	_tmp5_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1581 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 1581 "../src/WindowManager.vala"
	if (!_tmp6_) {
#line 10652 "WindowManager.c"
		MetaWindow* _tmp7_;
		MetaWindowType _tmp8_;
		MetaWindowType _tmp9_;
#line 1581 "../src/WindowManager.vala"
		_tmp7_ = _data24_->window;
#line 1581 "../src/WindowManager.vala"
		_tmp8_ = meta_window_get_window_type (_tmp7_);
#line 1581 "../src/WindowManager.vala"
		_tmp9_ = _tmp8_;
#line 1581 "../src/WindowManager.vala"
		_tmp4_ = _tmp9_ != META_WINDOW_NOTIFICATION;
#line 10664 "WindowManager.c"
	} else {
#line 1581 "../src/WindowManager.vala"
		_tmp4_ = FALSE;
#line 10668 "WindowManager.c"
	}
#line 1581 "../src/WindowManager.vala"
	if (_tmp4_) {
#line 10672 "WindowManager.c"
		MetaWindow* _tmp10_;
		MetaWindowType _tmp11_;
		MetaWindowType _tmp12_;
#line 1582 "../src/WindowManager.vala"
		meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 1584 "../src/WindowManager.vala"
		_tmp10_ = _data24_->window;
#line 1584 "../src/WindowManager.vala"
		_tmp11_ = meta_window_get_window_type (_tmp10_);
#line 1584 "../src/WindowManager.vala"
		_tmp12_ = _tmp11_;
#line 1584 "../src/WindowManager.vala"
		if (_tmp12_ == META_WINDOW_NORMAL) {
#line 10686 "WindowManager.c"
			MetaWindow* _tmp13_;
#line 1585 "../src/WindowManager.vala"
			_tmp13_ = _data24_->window;
#line 1585 "../src/WindowManager.vala"
			gala_utils_clear_window_cache (_tmp13_);
#line 10692 "WindowManager.c"
		}
#line 1588 "../src/WindowManager.vala"
		block24_data_unref (_data24_);
#line 1588 "../src/WindowManager.vala"
		_data24_ = NULL;
#line 1588 "../src/WindowManager.vala"
		return;
#line 10700 "WindowManager.c"
	}
#line 1591 "../src/WindowManager.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) _data24_->actor);
#line 1593 "../src/WindowManager.vala"
	_tmp14_ = _data24_->window;
#line 1593 "../src/WindowManager.vala"
	_tmp15_ = meta_window_get_window_type (_tmp14_);
#line 1593 "../src/WindowManager.vala"
	_tmp16_ = _tmp15_;
#line 1593 "../src/WindowManager.vala"
	switch (_tmp16_) {
#line 1593 "../src/WindowManager.vala"
		case META_WINDOW_NORMAL:
#line 10714 "WindowManager.c"
		{
			Block25Data* _data25_;
			GalaAnimationDuration duration = 0;
			GeeHashSet* _tmp17_;
			gulong _tmp18_;
#line 1593 "../src/WindowManager.vala"
			_data25_ = g_slice_new0 (Block25Data);
#line 1593 "../src/WindowManager.vala"
			_data25_->_ref_count_ = 1;
#line 1593 "../src/WindowManager.vala"
			_data25_->_data24_ = block24_data_ref (_data24_);
#line 1595 "../src/WindowManager.vala"
			duration = GALA_ANIMATION_DURATION_CLOSE;
#line 1596 "../src/WindowManager.vala"
			if (duration == 0) {
#line 1597 "../src/WindowManager.vala"
				meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 1598 "../src/WindowManager.vala"
				block25_data_unref (_data25_);
#line 1598 "../src/WindowManager.vala"
				_data25_ = NULL;
#line 1598 "../src/WindowManager.vala"
				block24_data_unref (_data24_);
#line 1598 "../src/WindowManager.vala"
				_data24_ = NULL;
#line 1598 "../src/WindowManager.vala"
				return;
#line 10742 "WindowManager.c"
			}
#line 1601 "../src/WindowManager.vala"
			_tmp17_ = self->priv->destroying;
#line 1601 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _data24_->actor);
#line 1603 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data24_->actor, 0.5f, 0.5f);
#line 1604 "../src/WindowManager.vala"
			clutter_actor_show ((ClutterActor*) _data24_->actor);
#line 1606 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data24_->actor);
#line 1607 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data24_->actor, CLUTTER_LINEAR);
#line 1608 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data24_->actor, (guint) duration);
#line 1609 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data24_->actor, (gdouble) 0.8f, (gdouble) 0.8f);
#line 1610 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data24_->actor, 0U);
#line 1611 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data24_->actor);
#line 1613 "../src/WindowManager.vala"
			_data25_->destroy_handler_id = 0UL;
#line 1614 "../src/WindowManager.vala"
			_tmp18_ = g_signal_connect_data ((ClutterActor*) _data24_->actor, "transitions-completed", (GCallback) ____lambda157__clutter_actor_transitions_completed, block25_data_ref (_data25_), (GClosureNotify) block25_data_unref, 0);
#line 1614 "../src/WindowManager.vala"
			_data25_->destroy_handler_id = _tmp18_;
#line 1620 "../src/WindowManager.vala"
			block25_data_unref (_data25_);
#line 1620 "../src/WindowManager.vala"
			_data25_ = NULL;
#line 1620 "../src/WindowManager.vala"
			break;
#line 10776 "WindowManager.c"
		}
#line 1593 "../src/WindowManager.vala"
		case META_WINDOW_MODAL_DIALOG:
#line 1593 "../src/WindowManager.vala"
		case META_WINDOW_DIALOG:
#line 10782 "WindowManager.c"
		{
			Block26Data* _data26_;
			GeeHashSet* _tmp19_;
			gulong _tmp20_;
			MetaWindow* _tmp21_;
#line 1593 "../src/WindowManager.vala"
			_data26_ = g_slice_new0 (Block26Data);
#line 1593 "../src/WindowManager.vala"
			_data26_->_ref_count_ = 1;
#line 1593 "../src/WindowManager.vala"
			_data26_->_data24_ = block24_data_ref (_data24_);
#line 1623 "../src/WindowManager.vala"
			_tmp19_ = self->priv->destroying;
#line 1623 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _data24_->actor);
#line 1625 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data24_->actor, 0.5f, 0.5f);
#line 1626 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data24_->actor);
#line 1627 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data24_->actor, CLUTTER_EASE_OUT_QUAD);
#line 1628 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data24_->actor, (guint) 150);
#line 1629 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data24_->actor, (gdouble) 1.05f, (gdouble) 1.05f);
#line 1630 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data24_->actor, 0U);
#line 1631 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data24_->actor);
#line 1633 "../src/WindowManager.vala"
			_data26_->destroy_handler_id = 0UL;
#line 1634 "../src/WindowManager.vala"
			_tmp20_ = g_signal_connect_data ((ClutterActor*) _data24_->actor, "transitions-completed", (GCallback) ____lambda158__clutter_actor_transitions_completed, block26_data_ref (_data26_), (GClosureNotify) block26_data_unref, 0);
#line 1634 "../src/WindowManager.vala"
			_data26_->destroy_handler_id = _tmp20_;
#line 1640 "../src/WindowManager.vala"
			_tmp21_ = _data24_->window;
#line 1640 "../src/WindowManager.vala"
			gala_window_manager_gala_dim_parent_window (self, _tmp21_, FALSE);
#line 1642 "../src/WindowManager.vala"
			block26_data_unref (_data26_);
#line 1642 "../src/WindowManager.vala"
			_data26_ = NULL;
#line 1642 "../src/WindowManager.vala"
			break;
#line 10828 "WindowManager.c"
		}
#line 1593 "../src/WindowManager.vala"
		case META_WINDOW_MENU:
#line 1593 "../src/WindowManager.vala"
		case META_WINDOW_DROPDOWN_MENU:
#line 1593 "../src/WindowManager.vala"
		case META_WINDOW_POPUP_MENU:
#line 10836 "WindowManager.c"
		{
			Block27Data* _data27_;
			GalaAnimationDuration duration = 0;
			GeeHashSet* _tmp22_;
			gulong _tmp23_;
#line 1593 "../src/WindowManager.vala"
			_data27_ = g_slice_new0 (Block27Data);
#line 1593 "../src/WindowManager.vala"
			_data27_->_ref_count_ = 1;
#line 1593 "../src/WindowManager.vala"
			_data27_->_data24_ = block24_data_ref (_data24_);
#line 1646 "../src/WindowManager.vala"
			duration = GALA_ANIMATION_DURATION_MENU_MAP;
#line 1647 "../src/WindowManager.vala"
			if (duration == 0) {
#line 1648 "../src/WindowManager.vala"
				meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 1649 "../src/WindowManager.vala"
				block27_data_unref (_data27_);
#line 1649 "../src/WindowManager.vala"
				_data27_ = NULL;
#line 1649 "../src/WindowManager.vala"
				block24_data_unref (_data24_);
#line 1649 "../src/WindowManager.vala"
				_data24_ = NULL;
#line 1649 "../src/WindowManager.vala"
				return;
#line 10864 "WindowManager.c"
			}
#line 1652 "../src/WindowManager.vala"
			_tmp22_ = self->priv->destroying;
#line 1652 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _data24_->actor);
#line 1653 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data24_->actor);
#line 1654 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data24_->actor, CLUTTER_EASE_OUT_QUAD);
#line 1655 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data24_->actor, (guint) duration);
#line 1656 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data24_->actor, (gdouble) 0.8f, (gdouble) 0.8f);
#line 1657 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data24_->actor, 0U);
#line 1658 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data24_->actor);
#line 1660 "../src/WindowManager.vala"
			_data27_->destroy_handler_id = 0UL;
#line 1661 "../src/WindowManager.vala"
			_tmp23_ = g_signal_connect_data ((ClutterActor*) _data24_->actor, "transitions-completed", (GCallback) ____lambda159__clutter_actor_transitions_completed, block27_data_ref (_data27_), (GClosureNotify) block27_data_unref, 0);
#line 1661 "../src/WindowManager.vala"
			_data27_->destroy_handler_id = _tmp23_;
#line 1666 "../src/WindowManager.vala"
			block27_data_unref (_data27_);
#line 1666 "../src/WindowManager.vala"
			_data27_ = NULL;
#line 1666 "../src/WindowManager.vala"
			break;
#line 10894 "WindowManager.c"
		}
#line 1593 "../src/WindowManager.vala"
		case META_WINDOW_NOTIFICATION:
#line 10898 "WindowManager.c"
		{
			gboolean _tmp24_;
			gboolean _tmp25_;
			GalaNotificationStack* _tmp27_;
			gboolean _tmp28_;
			gboolean _tmp29_;
			gboolean _tmp30_;
			gboolean _tmp31_;
#line 1668 "../src/WindowManager.vala"
			_tmp24_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1668 "../src/WindowManager.vala"
			_tmp25_ = _tmp24_;
#line 1668 "../src/WindowManager.vala"
			if (_tmp25_) {
#line 10913 "WindowManager.c"
				GeeHashSet* _tmp26_;
#line 1669 "../src/WindowManager.vala"
				_tmp26_ = self->priv->destroying;
#line 1669 "../src/WindowManager.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _data24_->actor);
#line 10919 "WindowManager.c"
			}
#line 1672 "../src/WindowManager.vala"
			_tmp27_ = self->priv->notification_stack;
#line 1672 "../src/WindowManager.vala"
			_tmp28_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1672 "../src/WindowManager.vala"
			_tmp29_ = _tmp28_;
#line 1672 "../src/WindowManager.vala"
			gala_notification_stack_destroy_notification (_tmp27_, _data24_->actor, _tmp29_);
#line 1674 "../src/WindowManager.vala"
			_tmp30_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1674 "../src/WindowManager.vala"
			_tmp31_ = _tmp30_;
#line 1674 "../src/WindowManager.vala"
			if (_tmp31_) {
#line 10935 "WindowManager.c"
				Block28Data* _data28_;
				gulong _tmp32_;
#line 1674 "../src/WindowManager.vala"
				_data28_ = g_slice_new0 (Block28Data);
#line 1674 "../src/WindowManager.vala"
				_data28_->_ref_count_ = 1;
#line 1674 "../src/WindowManager.vala"
				_data28_->_data24_ = block24_data_ref (_data24_);
#line 1675 "../src/WindowManager.vala"
				_data28_->destroy_handler_id = 0UL;
#line 1676 "../src/WindowManager.vala"
				_tmp32_ = g_signal_connect_data ((ClutterActor*) _data24_->actor, "transitions-completed", (GCallback) _____lambda160__clutter_actor_transitions_completed, block28_data_ref (_data28_), (GClosureNotify) block28_data_unref, 0);
#line 1676 "../src/WindowManager.vala"
				_data28_->destroy_handler_id = _tmp32_;
#line 1674 "../src/WindowManager.vala"
				block28_data_unref (_data28_);
#line 1674 "../src/WindowManager.vala"
				_data28_ = NULL;
#line 10954 "WindowManager.c"
			} else {
#line 1682 "../src/WindowManager.vala"
				meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 10958 "WindowManager.c"
			}
#line 1685 "../src/WindowManager.vala"
			break;
#line 10962 "WindowManager.c"
		}
		default:
		{
#line 1687 "../src/WindowManager.vala"
			meta_plugin_destroy_completed ((MetaPlugin*) self, _data24_->actor);
#line 1688 "../src/WindowManager.vala"
			break;
#line 10970 "WindowManager.c"
		}
	}
#line 1576 "../src/WindowManager.vala"
	block24_data_unref (_data24_);
#line 1576 "../src/WindowManager.vala"
	_data24_ = NULL;
#line 10977 "WindowManager.c"
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 1692 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 1692 "../src/WindowManager.vala"
	return _data29_;
#line 10987 "WindowManager.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 1692 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 10997 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1692 "../src/WindowManager.vala"
		self = _data29_->self;
#line 1692 "../src/WindowManager.vala"
		_g_object_unref0 (_data29_->actor);
#line 1692 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1692 "../src/WindowManager.vala"
		g_slice_free (Block29Data, _data29_);
#line 11007 "WindowManager.c"
	}
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 1706 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 1706 "../src/WindowManager.vala"
	return _data30_;
#line 11018 "WindowManager.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 1706 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 11028 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1706 "../src/WindowManager.vala"
		self = _data30_->_data29_->self;
#line 1706 "../src/WindowManager.vala"
		block29_data_unref (_data30_->_data29_);
#line 1706 "../src/WindowManager.vala"
		_data30_->_data29_ = NULL;
#line 1706 "../src/WindowManager.vala"
		g_slice_free (Block30Data, _data30_);
#line 11038 "WindowManager.c"
	}
}

static void
___lambda149_ (Block30Data* _data30_)
{
	Block29Data* _data29_;
	GalaWindowManagerGala* self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 1744 "../src/WindowManager.vala"
	_data29_ = _data30_->_data29_;
#line 1744 "../src/WindowManager.vala"
	self = _data29_->self;
#line 1745 "../src/WindowManager.vala"
	_tmp0_ = self->priv->latest_window_snapshot;
#line 1745 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _data30_->unmaximize_old_handler_id);
#line 1746 "../src/WindowManager.vala"
	_tmp1_ = self->priv->latest_window_snapshot;
#line 1746 "../src/WindowManager.vala"
	clutter_actor_destroy (_tmp1_);
#line 11061 "WindowManager.c"
}

static void
____lambda149__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1744 "../src/WindowManager.vala"
	___lambda149_ (self);
#line 11070 "WindowManager.c"
}

static void
___lambda150_ (Block30Data* _data30_)
{
	Block29Data* _data29_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1762 "../src/WindowManager.vala"
	_data29_ = _data30_->_data29_;
#line 1762 "../src/WindowManager.vala"
	self = _data29_->self;
#line 1763 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data29_->actor, _data30_->handler_id);
#line 1764 "../src/WindowManager.vala"
	_tmp0_ = self->priv->unmaximizing;
#line 1764 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data29_->actor);
#line 11089 "WindowManager.c"
}

static void
____lambda150__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1762 "../src/WindowManager.vala"
	___lambda150_ (self);
#line 11098 "WindowManager.c"
}

static void
gala_window_manager_gala_unmaximize (GalaWindowManagerGala* self,
                                     MetaWindowActor* actor,
                                     gint ex,
                                     gint ey,
                                     gint ew,
                                     gint eh)
{
	Block29Data* _data29_;
	MetaWindowActor* _tmp0_;
	GalaAnimationDuration duration = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp4_;
	GSettings* _tmp5_;
	MetaWindow* _tmp7_;
	MetaWindowType _tmp8_;
	MetaWindowType _tmp9_;
#line 1692 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1692 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1692 "../src/WindowManager.vala"
	_data29_ = g_slice_new0 (Block29Data);
#line 1692 "../src/WindowManager.vala"
	_data29_->_ref_count_ = 1;
#line 1692 "../src/WindowManager.vala"
	_data29_->self = g_object_ref (self);
#line 1692 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1692 "../src/WindowManager.vala"
	_g_object_unref0 (_data29_->actor);
#line 1692 "../src/WindowManager.vala"
	_data29_->actor = _tmp0_;
#line 1693 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_SNAP;
#line 1694 "../src/WindowManager.vala"
	_tmp2_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1694 "../src/WindowManager.vala"
	_tmp3_ = _tmp2_;
#line 1694 "../src/WindowManager.vala"
	if (!_tmp3_) {
#line 1694 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 11147 "WindowManager.c"
	} else {
#line 1695 "../src/WindowManager.vala"
		_tmp1_ = duration == 0;
#line 11151 "WindowManager.c"
	}
#line 1694 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 1696 "../src/WindowManager.vala"
		block29_data_unref (_data29_);
#line 1696 "../src/WindowManager.vala"
		_data29_ = NULL;
#line 1696 "../src/WindowManager.vala"
		return;
#line 11161 "WindowManager.c"
	}
#line 1699 "../src/WindowManager.vala"
	G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->kill_window_effects ((MetaPlugin*) self, _data29_->actor);
#line 1700 "../src/WindowManager.vala"
	_tmp4_ = meta_window_actor_get_meta_window (_data29_->actor);
#line 1700 "../src/WindowManager.vala"
	window = _tmp4_;
#line 1702 "../src/WindowManager.vala"
	_tmp5_ = self->priv->behavior_settings;
#line 1702 "../src/WindowManager.vala"
	if (g_settings_get_boolean (_tmp5_, "move-maximized-workspace")) {
#line 11173 "WindowManager.c"
		MetaWindow* _tmp6_;
#line 1703 "../src/WindowManager.vala"
		_tmp6_ = window;
#line 1703 "../src/WindowManager.vala"
		gala_window_manager_gala_move_window_to_old_ws (self, _tmp6_);
#line 11179 "WindowManager.c"
	}
#line 1706 "../src/WindowManager.vala"
	_tmp7_ = window;
#line 1706 "../src/WindowManager.vala"
	_tmp8_ = meta_window_get_window_type (_tmp7_);
#line 1706 "../src/WindowManager.vala"
	_tmp9_ = _tmp8_;
#line 1706 "../src/WindowManager.vala"
	if (_tmp9_ == META_WINDOW_NORMAL) {
#line 11189 "WindowManager.c"
		Block30Data* _data30_;
		gfloat offset_x = 0.0F;
		gfloat offset_y = 0.0F;
		GalaWindowListenerWindowGeometry* unmaximized_window_geometry = NULL;
		GalaWindowListener* _tmp10_;
		MetaWindow* _tmp11_;
		GalaWindowListenerWindowGeometry* _tmp12_;
		GalaWindowListenerWindowGeometry* _tmp13_;
		ClutterActor* _tmp22_;
		GeeHashSet* _tmp23_;
		MetaWindow* _tmp24_;
		ClutterActor* _tmp25_;
		MtkRectangle _tmp26_;
		MtkRectangle _tmp27_;
		ClutterActor* _tmp28_;
		ClutterActor* _tmp29_;
		ClutterActor* _tmp30_;
		gfloat scale_x = 0.0F;
		MtkRectangle _tmp31_;
		gfloat scale_y = 0.0F;
		MtkRectangle _tmp32_;
		ClutterActor* _tmp33_;
		ClutterActor* _tmp34_;
		ClutterActor* _tmp35_;
		ClutterActor* _tmp36_;
		ClutterActor* _tmp37_;
		ClutterActor* _tmp38_;
		ClutterActor* _tmp39_;
		ClutterActor* _tmp40_;
		gulong _tmp41_;
		MtkRectangle _tmp42_;
		MtkRectangle _tmp43_;
		gulong _tmp44_;
#line 1706 "../src/WindowManager.vala"
		_data30_ = g_slice_new0 (Block30Data);
#line 1706 "../src/WindowManager.vala"
		_data30_->_ref_count_ = 1;
#line 1706 "../src/WindowManager.vala"
		_data30_->_data29_ = block29_data_ref (_data29_);
#line 1708 "../src/WindowManager.vala"
		_tmp10_ = gala_window_listener_get_default ();
#line 1708 "../src/WindowManager.vala"
		_tmp11_ = window;
#line 1708 "../src/WindowManager.vala"
		_tmp12_ = gala_window_listener_get_unmaximized_state_geometry (_tmp10_, _tmp11_);
#line 1708 "../src/WindowManager.vala"
		unmaximized_window_geometry = _tmp12_;
#line 1710 "../src/WindowManager.vala"
		_tmp13_ = unmaximized_window_geometry;
#line 1710 "../src/WindowManager.vala"
		if (_tmp13_ != NULL) {
#line 11241 "WindowManager.c"
			GalaWindowListenerWindowGeometry* _tmp14_;
			MtkRectangle _tmp15_;
			GalaWindowListenerWindowGeometry* _tmp16_;
			MtkRectangle _tmp17_;
			GalaWindowListenerWindowGeometry* _tmp18_;
			MtkRectangle _tmp19_;
			GalaWindowListenerWindowGeometry* _tmp20_;
			MtkRectangle _tmp21_;
#line 1711 "../src/WindowManager.vala"
			_tmp14_ = unmaximized_window_geometry;
#line 1711 "../src/WindowManager.vala"
			_tmp15_ = (*_tmp14_).outer;
#line 1711 "../src/WindowManager.vala"
			_tmp16_ = unmaximized_window_geometry;
#line 1711 "../src/WindowManager.vala"
			_tmp17_ = (*_tmp16_).inner;
#line 1711 "../src/WindowManager.vala"
			offset_x = (gfloat) (_tmp15_.x - _tmp17_.x);
#line 1712 "../src/WindowManager.vala"
			_tmp18_ = unmaximized_window_geometry;
#line 1712 "../src/WindowManager.vala"
			_tmp19_ = (*_tmp18_).outer;
#line 1712 "../src/WindowManager.vala"
			_tmp20_ = unmaximized_window_geometry;
#line 1712 "../src/WindowManager.vala"
			_tmp21_ = (*_tmp20_).inner;
#line 1712 "../src/WindowManager.vala"
			offset_y = (gfloat) (_tmp19_.y - _tmp21_.y);
#line 11270 "WindowManager.c"
		} else {
#line 1714 "../src/WindowManager.vala"
			offset_x = (gfloat) 0;
#line 1715 "../src/WindowManager.vala"
			offset_y = (gfloat) 0;
#line 11276 "WindowManager.c"
		}
#line 1718 "../src/WindowManager.vala"
		_tmp22_ = self->priv->latest_window_snapshot;
#line 1718 "../src/WindowManager.vala"
		if (_tmp22_ == NULL) {
#line 1719 "../src/WindowManager.vala"
			_gala_window_listener_window_geometry_free0 (unmaximized_window_geometry);
#line 1719 "../src/WindowManager.vala"
			block30_data_unref (_data30_);
#line 1719 "../src/WindowManager.vala"
			_data30_ = NULL;
#line 1719 "../src/WindowManager.vala"
			block29_data_unref (_data29_);
#line 1719 "../src/WindowManager.vala"
			_data29_ = NULL;
#line 1719 "../src/WindowManager.vala"
			return;
#line 11294 "WindowManager.c"
		}
#line 1722 "../src/WindowManager.vala"
		_tmp23_ = self->priv->unmaximizing;
#line 1722 "../src/WindowManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _data29_->actor);
#line 1726 "../src/WindowManager.vala"
		_tmp24_ = window;
#line 1726 "../src/WindowManager.vala"
		meta_window_move_frame (_tmp24_, TRUE, ex, ey);
#line 1728 "../src/WindowManager.vala"
		_tmp25_ = self->priv->latest_window_snapshot;
#line 1728 "../src/WindowManager.vala"
		_tmp26_ = self->priv->old_rect_size_change;
#line 1728 "../src/WindowManager.vala"
		_tmp27_ = self->priv->old_rect_size_change;
#line 1728 "../src/WindowManager.vala"
		clutter_actor_set_position (_tmp25_, (gfloat) _tmp26_.x, (gfloat) _tmp27_.y);
#line 1730 "../src/WindowManager.vala"
		_tmp28_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 1730 "../src/WindowManager.vala"
		_tmp29_ = _tmp28_;
#line 1730 "../src/WindowManager.vala"
		_tmp30_ = self->priv->latest_window_snapshot;
#line 1730 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp29_, _tmp30_);
#line 1732 "../src/WindowManager.vala"
		_tmp31_ = self->priv->old_rect_size_change;
#line 1732 "../src/WindowManager.vala"
		scale_x = ((gfloat) ew) / _tmp31_.width;
#line 1733 "../src/WindowManager.vala"
		_tmp32_ = self->priv->old_rect_size_change;
#line 1733 "../src/WindowManager.vala"
		scale_y = ((gfloat) eh) / _tmp32_.height;
#line 1735 "../src/WindowManager.vala"
		_tmp33_ = self->priv->latest_window_snapshot;
#line 1735 "../src/WindowManager.vala"
		clutter_actor_save_easing_state (_tmp33_);
#line 1736 "../src/WindowManager.vala"
		_tmp34_ = self->priv->latest_window_snapshot;
#line 1736 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode (_tmp34_, CLUTTER_EASE_IN_OUT_QUAD);
#line 1737 "../src/WindowManager.vala"
		_tmp35_ = self->priv->latest_window_snapshot;
#line 1737 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration (_tmp35_, (guint) duration);
#line 1738 "../src/WindowManager.vala"
		_tmp36_ = self->priv->latest_window_snapshot;
#line 1738 "../src/WindowManager.vala"
		clutter_actor_set_position (_tmp36_, (gfloat) ex, (gfloat) ey);
#line 1739 "../src/WindowManager.vala"
		_tmp37_ = self->priv->latest_window_snapshot;
#line 1739 "../src/WindowManager.vala"
		clutter_actor_set_scale (_tmp37_, (gdouble) scale_x, (gdouble) scale_y);
#line 1740 "../src/WindowManager.vala"
		_tmp38_ = self->priv->latest_window_snapshot;
#line 1740 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp38_, 0U);
#line 1741 "../src/WindowManager.vala"
		_tmp39_ = self->priv->latest_window_snapshot;
#line 1741 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state (_tmp39_);
#line 1743 "../src/WindowManager.vala"
		_data30_->unmaximize_old_handler_id = 0UL;
#line 1744 "../src/WindowManager.vala"
		_tmp40_ = self->priv->latest_window_snapshot;
#line 1744 "../src/WindowManager.vala"
		_tmp41_ = g_signal_connect_data (_tmp40_, "transitions-completed", (GCallback) ____lambda149__clutter_actor_transitions_completed, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
#line 1744 "../src/WindowManager.vala"
		_data30_->unmaximize_old_handler_id = _tmp41_;
#line 1749 "../src/WindowManager.vala"
		clutter_actor_set_pivot_point ((ClutterActor*) _data29_->actor, 0.0f, 0.0f);
#line 1750 "../src/WindowManager.vala"
		clutter_actor_set_position ((ClutterActor*) _data29_->actor, (gfloat) ex, (gfloat) ey);
#line 1751 "../src/WindowManager.vala"
		_tmp42_ = self->priv->old_rect_size_change;
#line 1751 "../src/WindowManager.vala"
		_tmp43_ = self->priv->old_rect_size_change;
#line 1751 "../src/WindowManager.vala"
		clutter_actor_set_translation ((ClutterActor*) _data29_->actor, ((-ex) + (offset_x * ((1.0f / scale_x) - 1.0f))) + _tmp42_.x, ((-ey) + (offset_y * ((1.0f / scale_y) - 1.0f))) + _tmp43_.y, 0.0f);
#line 1752 "../src/WindowManager.vala"
		clutter_actor_set_scale ((ClutterActor*) _data29_->actor, (gdouble) (1.0f / scale_x), (gdouble) (1.0f / scale_y));
#line 1754 "../src/WindowManager.vala"
		clutter_actor_save_easing_state ((ClutterActor*) _data29_->actor);
#line 1755 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) _data29_->actor, CLUTTER_EASE_IN_OUT_QUAD);
#line 1756 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) _data29_->actor, (guint) duration);
#line 1757 "../src/WindowManager.vala"
		clutter_actor_set_scale ((ClutterActor*) _data29_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1758 "../src/WindowManager.vala"
		clutter_actor_set_translation ((ClutterActor*) _data29_->actor, 0.0f, 0.0f, 0.0f);
#line 1759 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) _data29_->actor);
#line 1761 "../src/WindowManager.vala"
		_data30_->handler_id = 0UL;
#line 1762 "../src/WindowManager.vala"
		_tmp44_ = g_signal_connect_data ((ClutterActor*) _data29_->actor, "transitions-completed", (GCallback) ____lambda150__clutter_actor_transitions_completed, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
#line 1762 "../src/WindowManager.vala"
		_data30_->handler_id = _tmp44_;
#line 1706 "../src/WindowManager.vala"
		_gala_window_listener_window_geometry_free0 (unmaximized_window_geometry);
#line 1706 "../src/WindowManager.vala"
		block30_data_unref (_data30_);
#line 1706 "../src/WindowManager.vala"
		_data30_ = NULL;
#line 11400 "WindowManager.c"
	}
#line 1692 "../src/WindowManager.vala"
	block29_data_unref (_data29_);
#line 1692 "../src/WindowManager.vala"
	_data29_ = NULL;
#line 11406 "WindowManager.c"
}

static void
gala_window_manager_gala_move_window_to_next_ws (GalaWindowManagerGala* self,
                                                 MetaWindow* window)
{
	MetaWorkspace* win_ws = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	gint old_ws_index = 0;
	MetaWorkspace* _tmp2_;
	gint new_ws_index = 0;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp3_;
	guint32 time = 0U;
	MetaDisplay* _tmp4_;
	MetaWorkspace* new_ws = NULL;
	MetaDisplay* _tmp5_;
	MetaWorkspaceManager* _tmp6_;
	MetaWorkspace* _tmp7_;
	MetaWorkspace* _tmp8_;
	MetaWorkspace* _tmp9_;
	GHashTable* _tmp10_;
	MetaWindow* _tmp11_;
#line 1769 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1769 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1770 "../src/WindowManager.vala"
	_tmp0_ = meta_window_get_workspace (window);
#line 1770 "../src/WindowManager.vala"
	win_ws = _tmp0_;
#line 1773 "../src/WindowManager.vala"
	_tmp1_ = win_ws;
#line 1773 "../src/WindowManager.vala"
	if (gala_utils_get_n_windows (_tmp1_, FALSE) <= ((guint) 1)) {
#line 1774 "../src/WindowManager.vala"
		return;
#line 11445 "WindowManager.c"
	}
#line 1778 "../src/WindowManager.vala"
	if (!meta_window_is_on_primary_monitor (window)) {
#line 1779 "../src/WindowManager.vala"
		return;
#line 11451 "WindowManager.c"
	}
#line 1782 "../src/WindowManager.vala"
	_tmp2_ = win_ws;
#line 1782 "../src/WindowManager.vala"
	old_ws_index = meta_workspace_index (_tmp2_);
#line 1783 "../src/WindowManager.vala"
	new_ws_index = old_ws_index + 1;
#line 1784 "../src/WindowManager.vala"
	gala_internal_utils_insert_workspace_with_window (new_ws_index, window);
#line 1786 "../src/WindowManager.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1786 "../src/WindowManager.vala"
	display = _tmp3_;
#line 1787 "../src/WindowManager.vala"
	_tmp4_ = display;
#line 1787 "../src/WindowManager.vala"
	time = meta_display_get_current_time (_tmp4_);
#line 1788 "../src/WindowManager.vala"
	_tmp5_ = display;
#line 1788 "../src/WindowManager.vala"
	_tmp6_ = meta_display_get_workspace_manager (_tmp5_);
#line 1788 "../src/WindowManager.vala"
	_tmp7_ = meta_workspace_manager_get_workspace_by_index (_tmp6_, new_ws_index);
#line 1788 "../src/WindowManager.vala"
	new_ws = _tmp7_;
#line 1789 "../src/WindowManager.vala"
	_tmp8_ = new_ws;
#line 1789 "../src/WindowManager.vala"
	meta_window_change_workspace (window, _tmp8_);
#line 1790 "../src/WindowManager.vala"
	_tmp9_ = new_ws;
#line 1790 "../src/WindowManager.vala"
	meta_workspace_activate_with_focus (_tmp9_, window, time);
#line 1792 "../src/WindowManager.vala"
	_tmp10_ = self->priv->ws_assoc;
#line 1792 "../src/WindowManager.vala"
	_tmp11_ = _g_object_ref0 (window);
#line 1792 "../src/WindowManager.vala"
	g_hash_table_insert (_tmp10_, _tmp11_, (gpointer) ((gintptr) old_ws_index));
#line 11491 "WindowManager.c"
}

static void
gala_window_manager_gala_move_window_to_old_ws (GalaWindowManagerGala* self,
                                                MetaWindow* window)
{
	MetaWorkspace* win_ws = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	GHashTable* _tmp2_;
	gint old_ws_index = 0;
	GHashTable* _tmp3_;
	gconstpointer _tmp4_;
	gint new_ws_index = 0;
	MetaWorkspace* _tmp5_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp6_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp7_;
	MetaWorkspaceManager* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GHashTable* _tmp16_;
#line 1795 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1795 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1796 "../src/WindowManager.vala"
	_tmp0_ = meta_window_get_workspace (window);
#line 1796 "../src/WindowManager.vala"
	win_ws = _tmp0_;
#line 1799 "../src/WindowManager.vala"
	_tmp1_ = win_ws;
#line 1799 "../src/WindowManager.vala"
	if (gala_utils_get_n_windows (_tmp1_, FALSE) > ((guint) 1)) {
#line 1800 "../src/WindowManager.vala"
		return;
#line 11528 "WindowManager.c"
	}
#line 1803 "../src/WindowManager.vala"
	_tmp2_ = self->priv->ws_assoc;
#line 1803 "../src/WindowManager.vala"
	if (!g_hash_table_contains (_tmp2_, window)) {
#line 1804 "../src/WindowManager.vala"
		return;
#line 11536 "WindowManager.c"
	}
#line 1807 "../src/WindowManager.vala"
	_tmp3_ = self->priv->ws_assoc;
#line 1807 "../src/WindowManager.vala"
	_tmp4_ = g_hash_table_lookup (_tmp3_, window);
#line 1807 "../src/WindowManager.vala"
	old_ws_index = (gint) ((gintptr) _tmp4_);
#line 1808 "../src/WindowManager.vala"
	_tmp5_ = win_ws;
#line 1808 "../src/WindowManager.vala"
	new_ws_index = meta_workspace_index (_tmp5_);
#line 1810 "../src/WindowManager.vala"
	_tmp6_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1810 "../src/WindowManager.vala"
	display = _tmp6_;
#line 1811 "../src/WindowManager.vala"
	_tmp7_ = display;
#line 1811 "../src/WindowManager.vala"
	_tmp8_ = meta_display_get_workspace_manager (_tmp7_);
#line 1811 "../src/WindowManager.vala"
	workspace_manager = _tmp8_;
#line 1812 "../src/WindowManager.vala"
	if (new_ws_index != old_ws_index) {
#line 11560 "WindowManager.c"
		MetaWorkspaceManager* _tmp10_;
#line 1812 "../src/WindowManager.vala"
		_tmp10_ = workspace_manager;
#line 1812 "../src/WindowManager.vala"
		_tmp9_ = old_ws_index < meta_workspace_manager_get_n_workspaces (_tmp10_);
#line 11566 "WindowManager.c"
	} else {
#line 1812 "../src/WindowManager.vala"
		_tmp9_ = FALSE;
#line 11570 "WindowManager.c"
	}
#line 1812 "../src/WindowManager.vala"
	if (_tmp9_) {
#line 11574 "WindowManager.c"
		guint time = 0U;
		MetaDisplay* _tmp11_;
		MetaWorkspace* old_ws = NULL;
		MetaWorkspaceManager* _tmp12_;
		MetaWorkspace* _tmp13_;
		MetaWorkspace* _tmp14_;
		MetaWorkspace* _tmp15_;
#line 1813 "../src/WindowManager.vala"
		_tmp11_ = display;
#line 1813 "../src/WindowManager.vala"
		time = (guint) meta_display_get_current_time (_tmp11_);
#line 1814 "../src/WindowManager.vala"
		_tmp12_ = workspace_manager;
#line 1814 "../src/WindowManager.vala"
		_tmp13_ = meta_workspace_manager_get_workspace_by_index (_tmp12_, old_ws_index);
#line 1814 "../src/WindowManager.vala"
		old_ws = _tmp13_;
#line 1815 "../src/WindowManager.vala"
		_tmp14_ = old_ws;
#line 1815 "../src/WindowManager.vala"
		meta_window_change_workspace (window, _tmp14_);
#line 1816 "../src/WindowManager.vala"
		_tmp15_ = old_ws;
#line 1816 "../src/WindowManager.vala"
		meta_workspace_activate_with_focus (_tmp15_, window, (guint32) time);
#line 11600 "WindowManager.c"
	}
#line 1819 "../src/WindowManager.vala"
	_tmp16_ = self->priv->ws_assoc;
#line 1819 "../src/WindowManager.vala"
	g_hash_table_remove (_tmp16_, window);
#line 11606 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_end_animation (GalaWindowManagerGala* self,
                                        GeeHashSet** list,
                                        MetaWindowActor* actor)
{
	gboolean result;
#line 1823 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1823 "../src/WindowManager.vala"
	g_return_val_if_fail (*list != NULL, FALSE);
#line 1823 "../src/WindowManager.vala"
	g_return_val_if_fail (actor != NULL, FALSE);
#line 1824 "../src/WindowManager.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) (*list), actor)) {
#line 1825 "../src/WindowManager.vala"
		result = FALSE;
#line 1825 "../src/WindowManager.vala"
		return result;
#line 11627 "WindowManager.c"
	}
#line 1827 "../src/WindowManager.vala"
	if (meta_window_actor_is_destroyed (actor)) {
#line 1828 "../src/WindowManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) (*list), actor);
#line 1829 "../src/WindowManager.vala"
		result = FALSE;
#line 1829 "../src/WindowManager.vala"
		return result;
#line 11637 "WindowManager.c"
	}
#line 1832 "../src/WindowManager.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) actor);
#line 1833 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) actor, 255U);
#line 1834 "../src/WindowManager.vala"
	clutter_actor_set_scale ((ClutterActor*) actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1835 "../src/WindowManager.vala"
	g_object_set ((ClutterActor*) actor, "rotation-angle-x", (gdouble) 0.0f, NULL);
#line 1836 "../src/WindowManager.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) actor, 0.0f, 0.0f);
#line 1838 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) (*list), actor);
#line 1839 "../src/WindowManager.vala"
	result = TRUE;
#line 1839 "../src/WindowManager.vala"
	return result;
#line 11655 "WindowManager.c"
}

static void
gala_window_manager_gala_real_kill_window_effects (MetaPlugin* base,
                                                   MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 1842 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1842 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1843 "../src/WindowManager.vala"
	_tmp0_ = gala_window_manager_gala_end_animation (self, &self->priv->mapping, actor);
#line 1843 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 1844 "../src/WindowManager.vala"
		meta_plugin_map_completed ((MetaPlugin*) self, actor);
#line 11677 "WindowManager.c"
	}
#line 1845 "../src/WindowManager.vala"
	_tmp1_ = gala_window_manager_gala_end_animation (self, &self->priv->unminimizing, actor);
#line 1845 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 1846 "../src/WindowManager.vala"
		meta_plugin_unminimize_completed ((MetaPlugin*) self, actor);
#line 11685 "WindowManager.c"
	}
#line 1847 "../src/WindowManager.vala"
	_tmp2_ = gala_window_manager_gala_end_animation (self, &self->priv->minimizing, actor);
#line 1847 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 1848 "../src/WindowManager.vala"
		meta_plugin_minimize_completed ((MetaPlugin*) self, actor);
#line 11693 "WindowManager.c"
	}
#line 1849 "../src/WindowManager.vala"
	_tmp3_ = gala_window_manager_gala_end_animation (self, &self->priv->destroying, actor);
#line 1849 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 1850 "../src/WindowManager.vala"
		meta_plugin_destroy_completed ((MetaPlugin*) self, actor);
#line 11701 "WindowManager.c"
	}
#line 1852 "../src/WindowManager.vala"
	gala_window_manager_gala_end_animation (self, &self->priv->unmaximizing, actor);
#line 1853 "../src/WindowManager.vala"
	gala_window_manager_gala_end_animation (self, &self->priv->maximizing, actor);
#line 11707 "WindowManager.c"
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 1862 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 1862 "../src/WindowManager.vala"
	return _data31_;
#line 11717 "WindowManager.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 1862 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 11727 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1862 "../src/WindowManager.vala"
		self = _data31_->self;
#line 1862 "../src/WindowManager.vala"
		_g_object_unref0 (_data31_->wallpaper_clone);
#line 1862 "../src/WindowManager.vala"
		_g_object_unref0 (_data31_->wallpaper);
#line 1862 "../src/WindowManager.vala"
		_g_object_unref0 (_data31_->out_group);
#line 1862 "../src/WindowManager.vala"
		_g_object_unref0 (_data31_->in_group);
#line 1862 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1862 "../src/WindowManager.vala"
		g_slice_free (Block31Data, _data31_);
#line 11743 "WindowManager.c"
	}
}

static void
__lambda161_ (GalaWindowManagerGala* self,
              MetaWindow* window)
{
	MetaWindowType _tmp0_;
	MetaWindowType _tmp1_;
#line 2005 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 2006 "../src/WindowManager.vala"
	_tmp0_ = meta_window_get_window_type (window);
#line 2006 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 2006 "../src/WindowManager.vala"
	if (_tmp1_ == META_WINDOW_NOTIFICATION) {
#line 11761 "WindowManager.c"
		MetaWindowActor* actor = NULL;
		GObject* _tmp2_;
		MetaWindowActor* _tmp3_;
		ClutterActor* _tmp4_;
		GalaNotificationStack* _tmp5_;
		MetaWindowActor* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 2007 "../src/WindowManager.vala"
		_tmp2_ = meta_window_get_compositor_private (window);
#line 2007 "../src/WindowManager.vala"
		actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, meta_window_actor_get_type (), MetaWindowActor);
#line 2008 "../src/WindowManager.vala"
		_tmp3_ = actor;
#line 2008 "../src/WindowManager.vala"
		_tmp4_ = self->priv->_notification_group;
#line 2008 "../src/WindowManager.vala"
		gala_window_manager_gala_clutter_actor_reparent ((ClutterActor*) _tmp3_, _tmp4_);
#line 2009 "../src/WindowManager.vala"
		_tmp5_ = self->priv->notification_stack;
#line 2009 "../src/WindowManager.vala"
		_tmp6_ = actor;
#line 2009 "../src/WindowManager.vala"
		_tmp7_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 2009 "../src/WindowManager.vala"
		_tmp8_ = _tmp7_;
#line 2009 "../src/WindowManager.vala"
		gala_notification_stack_show_notification (_tmp5_, _tmp6_, _tmp8_);
#line 11790 "WindowManager.c"
	}
}

static void
___lambda161__gala_window_manager_gala_window_created (GalaWindowManagerGala* _sender,
                                                       MetaWindow* window,
                                                       gpointer self)
{
#line 2005 "../src/WindowManager.vala"
	__lambda161_ ((GalaWindowManagerGala*) self, window);
#line 11801 "WindowManager.c"
}

static void
__lambda162_ (Block31Data* _data31_,
              gdouble percentage)
{
	GalaWindowManagerGala* self;
	gfloat x_out = 0.0F;
	gfloat x_in = 0.0F;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterClone* _tmp3_;
#line 2071 "../src/WindowManager.vala"
	self = _data31_->self;
#line 2072 "../src/WindowManager.vala"
	x_out = gala_gesture_tracker_animation_value (0.0f, _data31_->x2, percentage, TRUE);
#line 2073 "../src/WindowManager.vala"
	x_in = gala_gesture_tracker_animation_value (-_data31_->x2, 0.0f, percentage, TRUE);
#line 2075 "../src/WindowManager.vala"
	_tmp0_ = _data31_->out_group;
#line 2075 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp0_, x_out);
#line 2076 "../src/WindowManager.vala"
	_tmp1_ = _data31_->in_group;
#line 2076 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp1_, x_in);
#line 2078 "../src/WindowManager.vala"
	_tmp2_ = _data31_->wallpaper;
#line 2078 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp2_, x_out);
#line 2079 "../src/WindowManager.vala"
	_tmp3_ = _data31_->wallpaper_clone;
#line 2079 "../src/WindowManager.vala"
	clutter_actor_set_x ((ClutterActor*) _tmp3_, x_in);
#line 11837 "WindowManager.c"
}

static void
___lambda162__gala_gesture_tracker_on_update (gdouble percentage,
                                              gpointer self)
{
#line 2071 "../src/WindowManager.vala"
	__lambda162_ (self, percentage);
#line 11846 "WindowManager.c"
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 2082 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 2082 "../src/WindowManager.vala"
	return _data32_;
#line 11856 "WindowManager.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 2082 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 11866 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 2082 "../src/WindowManager.vala"
		self = _data32_->_data31_->self;
#line 2082 "../src/WindowManager.vala"
		block31_data_unref (_data32_->_data31_);
#line 2082 "../src/WindowManager.vala"
		_data32_->_data31_ = NULL;
#line 2082 "../src/WindowManager.vala"
		g_slice_free (Block32Data, _data32_);
#line 11876 "WindowManager.c"
	}
}

static void
___lambda164_ (Block32Data* _data32_)
{
	Block31Data* _data31_;
	GalaWindowManagerGala* self;
#line 2118 "../src/WindowManager.vala"
	_data31_ = _data32_->_data31_;
#line 2118 "../src/WindowManager.vala"
	self = _data31_->self;
#line 2119 "../src/WindowManager.vala"
	gala_window_manager_gala_switch_workspace_animation_finished (self, _data31_->direction, _data32_->cancel_action);
#line 11891 "WindowManager.c"
}

static void
____lambda164__clutter_timeline_completed (ClutterTimeline* _sender,
                                           gpointer self)
{
#line 2118 "../src/WindowManager.vala"
	___lambda164_ (self);
#line 11900 "WindowManager.c"
}

static void
__lambda163_ (Block31Data* _data31_,
              gdouble percentage,
              gboolean cancel_action,
              gint duration)
{
	GalaWindowManagerGala* self;
	Block32Data* _data32_;
	gboolean _tmp0_ = FALSE;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	ClutterClone* _tmp8_;
	ClutterClone* _tmp9_;
	ClutterClone* _tmp10_;
	ClutterActor* _tmp11_;
	ClutterActor* _tmp12_;
	ClutterActor* _tmp13_;
	gfloat _tmp14_ = 0.0F;
	ClutterActor* _tmp15_;
	ClutterActor* _tmp16_;
	gfloat _tmp17_ = 0.0F;
	ClutterActor* _tmp18_;
	ClutterActor* _tmp19_;
	gfloat _tmp20_ = 0.0F;
	ClutterActor* _tmp21_;
	ClutterActor* _tmp22_;
	gfloat _tmp23_ = 0.0F;
	ClutterClone* _tmp24_;
	ClutterClone* _tmp25_;
	ClutterTransition* transition = NULL;
	ClutterActor* _tmp26_;
	ClutterTransition* _tmp27_;
	ClutterTransition* _tmp28_;
	ClutterTransition* _tmp29_;
#line 2082 "../src/WindowManager.vala"
	self = _data31_->self;
#line 2082 "../src/WindowManager.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 2082 "../src/WindowManager.vala"
	_data32_->_ref_count_ = 1;
#line 2082 "../src/WindowManager.vala"
	_data32_->_data31_ = block31_data_ref (_data31_);
#line 2082 "../src/WindowManager.vala"
	_data32_->cancel_action = cancel_action;
#line 2083 "../src/WindowManager.vala"
	if (self->priv->switch_workspace_with_gesture) {
#line 11953 "WindowManager.c"
		gboolean _tmp1_ = FALSE;
#line 2083 "../src/WindowManager.vala"
		if (percentage == ((gdouble) 1)) {
#line 2083 "../src/WindowManager.vala"
			_tmp1_ = TRUE;
#line 11959 "WindowManager.c"
		} else {
#line 2083 "../src/WindowManager.vala"
			_tmp1_ = percentage == ((gdouble) 0);
#line 11963 "WindowManager.c"
		}
#line 2083 "../src/WindowManager.vala"
		_tmp0_ = _tmp1_;
#line 11967 "WindowManager.c"
	} else {
#line 2083 "../src/WindowManager.vala"
		_tmp0_ = FALSE;
#line 11971 "WindowManager.c"
	}
#line 2083 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 2084 "../src/WindowManager.vala"
		gala_window_manager_gala_switch_workspace_animation_finished (self, _data31_->direction, _data32_->cancel_action);
#line 2085 "../src/WindowManager.vala"
		block32_data_unref (_data32_);
#line 2085 "../src/WindowManager.vala"
		_data32_ = NULL;
#line 2085 "../src/WindowManager.vala"
		return;
#line 11983 "WindowManager.c"
	}
#line 2088 "../src/WindowManager.vala"
	_tmp2_ = _data31_->out_group;
#line 2088 "../src/WindowManager.vala"
	clutter_actor_save_easing_state (_tmp2_);
#line 2089 "../src/WindowManager.vala"
	_tmp3_ = _data31_->out_group;
#line 2089 "../src/WindowManager.vala"
	clutter_actor_set_easing_mode (_tmp3_, _data31_->animation_mode);
#line 2090 "../src/WindowManager.vala"
	_tmp4_ = _data31_->out_group;
#line 2090 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration (_tmp4_, (guint) duration);
#line 2092 "../src/WindowManager.vala"
	_tmp5_ = _data31_->in_group;
#line 2092 "../src/WindowManager.vala"
	clutter_actor_save_easing_state (_tmp5_);
#line 2093 "../src/WindowManager.vala"
	_tmp6_ = _data31_->in_group;
#line 2093 "../src/WindowManager.vala"
	clutter_actor_set_easing_mode (_tmp6_, _data31_->animation_mode);
#line 2094 "../src/WindowManager.vala"
	_tmp7_ = _data31_->in_group;
#line 2094 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration (_tmp7_, (guint) duration);
#line 2096 "../src/WindowManager.vala"
	_tmp8_ = _data31_->wallpaper_clone;
#line 2096 "../src/WindowManager.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp8_);
#line 2097 "../src/WindowManager.vala"
	_tmp9_ = _data31_->wallpaper_clone;
#line 2097 "../src/WindowManager.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) _tmp9_, _data31_->animation_mode);
#line 2098 "../src/WindowManager.vala"
	_tmp10_ = _data31_->wallpaper_clone;
#line 2098 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp10_, (guint) duration);
#line 2100 "../src/WindowManager.vala"
	_tmp11_ = _data31_->wallpaper;
#line 2100 "../src/WindowManager.vala"
	clutter_actor_save_easing_state (_tmp11_);
#line 2101 "../src/WindowManager.vala"
	_tmp12_ = _data31_->wallpaper;
#line 2101 "../src/WindowManager.vala"
	clutter_actor_set_easing_mode (_tmp12_, _data31_->animation_mode);
#line 2102 "../src/WindowManager.vala"
	_tmp13_ = _data31_->wallpaper;
#line 2102 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration (_tmp13_, (guint) duration);
#line 2104 "../src/WindowManager.vala"
	if (_data32_->cancel_action) {
#line 2104 "../src/WindowManager.vala"
		_tmp14_ = 0.0f;
#line 12037 "WindowManager.c"
	} else {
#line 2104 "../src/WindowManager.vala"
		_tmp14_ = _data31_->x2;
#line 12041 "WindowManager.c"
	}
#line 2104 "../src/WindowManager.vala"
	_tmp15_ = _data31_->out_group;
#line 2104 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp15_, _tmp14_);
#line 2105 "../src/WindowManager.vala"
	_tmp16_ = _data31_->out_group;
#line 2105 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state (_tmp16_);
#line 2107 "../src/WindowManager.vala"
	if (_data32_->cancel_action) {
#line 2107 "../src/WindowManager.vala"
		_tmp17_ = -_data31_->x2;
#line 12055 "WindowManager.c"
	} else {
#line 2107 "../src/WindowManager.vala"
		_tmp17_ = 0.0f;
#line 12059 "WindowManager.c"
	}
#line 2107 "../src/WindowManager.vala"
	_tmp18_ = _data31_->in_group;
#line 2107 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp18_, _tmp17_);
#line 2108 "../src/WindowManager.vala"
	_tmp19_ = _data31_->in_group;
#line 2108 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state (_tmp19_);
#line 2110 "../src/WindowManager.vala"
	if (_data32_->cancel_action) {
#line 2110 "../src/WindowManager.vala"
		_tmp20_ = 0.0f;
#line 12073 "WindowManager.c"
	} else {
#line 2110 "../src/WindowManager.vala"
		_tmp20_ = _data31_->x2;
#line 12077 "WindowManager.c"
	}
#line 2110 "../src/WindowManager.vala"
	_tmp21_ = _data31_->wallpaper;
#line 2110 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp21_, _tmp20_);
#line 2111 "../src/WindowManager.vala"
	_tmp22_ = _data31_->wallpaper;
#line 2111 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state (_tmp22_);
#line 2113 "../src/WindowManager.vala"
	if (_data32_->cancel_action) {
#line 2113 "../src/WindowManager.vala"
		_tmp23_ = -_data31_->x2;
#line 12091 "WindowManager.c"
	} else {
#line 2113 "../src/WindowManager.vala"
		_tmp23_ = 0.0f;
#line 12095 "WindowManager.c"
	}
#line 2113 "../src/WindowManager.vala"
	_tmp24_ = _data31_->wallpaper_clone;
#line 2113 "../src/WindowManager.vala"
	clutter_actor_set_x ((ClutterActor*) _tmp24_, _tmp23_);
#line 2114 "../src/WindowManager.vala"
	_tmp25_ = _data31_->wallpaper_clone;
#line 2114 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp25_);
#line 2116 "../src/WindowManager.vala"
	_tmp26_ = _data31_->in_group;
#line 2116 "../src/WindowManager.vala"
	_tmp27_ = clutter_actor_get_transition (_tmp26_, "x");
#line 2116 "../src/WindowManager.vala"
	_tmp28_ = _g_object_ref0 (_tmp27_);
#line 2116 "../src/WindowManager.vala"
	transition = _tmp28_;
#line 2117 "../src/WindowManager.vala"
	_tmp29_ = transition;
#line 2117 "../src/WindowManager.vala"
	if (_tmp29_ != NULL) {
#line 12117 "WindowManager.c"
		ClutterTransition* _tmp30_;
#line 2118 "../src/WindowManager.vala"
		_tmp30_ = transition;
#line 2118 "../src/WindowManager.vala"
		g_signal_connect_data ((ClutterTimeline*) _tmp30_, "completed", (GCallback) ____lambda164__clutter_timeline_completed, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 12123 "WindowManager.c"
	} else {
#line 2122 "../src/WindowManager.vala"
		gala_window_manager_gala_switch_workspace_animation_finished (self, _data31_->direction, _data32_->cancel_action);
#line 12127 "WindowManager.c"
	}
#line 2082 "../src/WindowManager.vala"
	_g_object_unref0 (transition);
#line 2082 "../src/WindowManager.vala"
	block32_data_unref (_data32_);
#line 2082 "../src/WindowManager.vala"
	_data32_ = NULL;
#line 12135 "WindowManager.c"
}

static void
___lambda163__gala_gesture_tracker_on_end (gdouble percentage,
                                           gboolean cancel_action,
                                           gint calculated_duration,
                                           gpointer self)
{
#line 2082 "../src/WindowManager.vala"
	__lambda163_ (self, percentage, cancel_action, calculated_duration);
#line 12146 "WindowManager.c"
}

static void
gala_window_manager_gala_real_switch_workspace (MetaPlugin* base,
                                                gint from,
                                                gint to,
                                                MetaMotionDirection direction)
{
	GalaWindowManagerGala * self;
	Block31Data* _data31_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gfloat screen_width = 0.0F;
	gfloat screen_height = 0.0F;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp11_;
	gint primary = 0;
	MetaDisplay* _tmp12_;
	gboolean move_primary_only = FALSE;
	MtkRectangle monitor_geom = {0};
	MetaDisplay* _tmp13_;
	MtkRectangle _tmp14_ = {0};
	gfloat _tmp15_ = 0.0F;
	gfloat clone_offset_x = 0.0F;
	gfloat _tmp17_ = 0.0F;
	gfloat clone_offset_y = 0.0F;
	MetaDisplay* _tmp19_;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp22_;
	MetaWorkspaceManager* _tmp23_;
	MetaWorkspace* workspace_from = NULL;
	MetaWorkspaceManager* _tmp24_;
	MetaWorkspace* _tmp25_;
	MetaWorkspace* workspace_to = NULL;
	MetaWorkspaceManager* _tmp26_;
	MetaWorkspace* _tmp27_;
	ClutterActor* main_container = NULL;
	ClutterActor* _tmp28_;
	ClutterClone* background_actor = NULL;
	GalaSystemBackground* _tmp29_;
	MetaBackgroundActor* _tmp30_;
	MetaBackgroundActor* _tmp31_;
	ClutterClone* _tmp32_;
	ClutterActor* static_windows = NULL;
	ClutterActor* _tmp33_;
	ClutterActor* _tmp34_;
	ClutterActor* _tmp35_;
	ClutterActor* _tmp36_;
	ClutterActor* _tmp37_;
	ClutterClone* _tmp38_;
	ClutterActor* _tmp39_;
	ClutterActor* _tmp40_;
	ClutterActor* _tmp41_;
	ClutterActor* _tmp42_;
	ClutterActor* _tmp43_;
	ClutterActor* _tmp44_;
	ClutterActor* _tmp45_;
	ClutterActor* _tmp46_;
	ClutterActor* _tmp47_;
	ClutterActor* _tmp48_;
	ClutterActor* _tmp60_;
	gchar* _tmp61_;
	GalaShadowEffect* _tmp62_ = NULL;
	GalaShadowEffect* _tmp63_;
	ClutterActor* _tmp64_;
	ClutterActor* _tmp65_;
	ClutterActor* _tmp66_;
	ClutterClone* _tmp67_;
	ClutterClone* _tmp68_;
	gchar* _tmp69_;
	GalaShadowEffect* _tmp70_ = NULL;
	GalaShadowEffect* _tmp71_;
	ClutterClone* _tmp72_;
	ClutterActor* _tmp73_;
	ClutterActor* _tmp74_;
	ClutterClone* _tmp75_;
	ClutterActor* _tmp76_;
	ClutterActor* _tmp77_;
	ClutterActor* _tmp78_;
	ClutterClone* _tmp79_;
	ClutterActor* _tmp80_;
	ClutterActor* _tmp81_;
	ClutterActor* _tmp82_;
	ClutterActor* _tmp83_;
	ClutterActor* _tmp84_;
	ClutterActor* _tmp85_;
	MetaWindow* _tmp86_;
	gboolean to_has_fullscreened = FALSE;
	gboolean from_has_fullscreened = FALSE;
	GList* docks = NULL;
	MetaDisplay* _tmp97_;
	GList* _tmp98_;
	gulong _tmp162_;
	GList* _tmp163_;
	ClutterActor* _tmp186_;
	gfloat _tmp187_ = 0.0F;
	ClutterActor* _tmp189_;
	gfloat _tmp190_ = 0.0F;
	ClutterActor* _tmp192_;
	gfloat _tmp193_ = 0.0F;
	ClutterActor* _tmp195_;
	gfloat _tmp196_ = 0.0F;
	ClutterActor* _tmp198_;
	gfloat monitor_scale = 0.0F;
	MetaDisplay* _tmp199_;
	gfloat _tmp200_ = 0.0F;
	ClutterActor* _tmp202_;
	ClutterActor* _tmp203_;
	ClutterActor* _tmp204_;
	ClutterActor* _tmp205_;
	gfloat _tmp206_;
	gfloat _tmp207_;
	ClutterActor* _tmp208_;
	ClutterClone* _tmp209_;
	ClutterClone* _tmp210_;
	ClutterClone* _tmp211_;
	gfloat _tmp212_;
	gfloat _tmp213_;
	ClutterActor* _tmp214_;
	ClutterClone* _tmp215_;
	ClutterActor* _tmp220_;
	ClutterActor* _tmp221_;
	gfloat _tmp222_ = 0.0F;
	ClutterActor* _tmp224_;
	ClutterActor* _tmp225_;
	gfloat _tmp226_ = 0.0F;
	ClutterActor* _tmp228_;
	ClutterActor* _tmp229_;
	GalaGestureTrackerOnUpdate on_animation_update = NULL;
	gpointer on_animation_update_target;
	GDestroyNotify on_animation_update_target_destroy_notify;
	GalaGestureTrackerOnEnd on_animation_end = NULL;
	gpointer on_animation_end_target;
	GDestroyNotify on_animation_end_target_destroy_notify;
#line 1862 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1862 "../src/WindowManager.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 1862 "../src/WindowManager.vala"
	_data31_->_ref_count_ = 1;
#line 1862 "../src/WindowManager.vala"
	_data31_->self = g_object_ref (self);
#line 1862 "../src/WindowManager.vala"
	_data31_->direction = direction;
#line 1863 "../src/WindowManager.vala"
	_tmp5_ = gala_window_manager_get_enable_animations ((GalaWindowManager*) self);
#line 1863 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 1863 "../src/WindowManager.vala"
	if (!_tmp6_) {
#line 1863 "../src/WindowManager.vala"
		_tmp4_ = TRUE;
#line 12306 "WindowManager.c"
	} else {
#line 1864 "../src/WindowManager.vala"
		_tmp4_ = GALA_ANIMATION_DURATION_WORKSPACE_SWITCH == 0;
#line 12310 "WindowManager.c"
	}
#line 1863 "../src/WindowManager.vala"
	if (_tmp4_) {
#line 1863 "../src/WindowManager.vala"
		_tmp3_ = TRUE;
#line 12316 "WindowManager.c"
	} else {
		gboolean _tmp7_ = FALSE;
#line 1865 "../src/WindowManager.vala"
		if (_data31_->direction != META_MOTION_LEFT) {
#line 1865 "../src/WindowManager.vala"
			_tmp7_ = _data31_->direction != META_MOTION_RIGHT;
#line 12323 "WindowManager.c"
		} else {
#line 1865 "../src/WindowManager.vala"
			_tmp7_ = FALSE;
#line 12327 "WindowManager.c"
		}
#line 1865 "../src/WindowManager.vala"
		_tmp3_ = _tmp7_;
#line 12331 "WindowManager.c"
	}
#line 1863 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 1863 "../src/WindowManager.vala"
		_tmp2_ = TRUE;
#line 12337 "WindowManager.c"
	} else {
#line 1866 "../src/WindowManager.vala"
		_tmp2_ = self->priv->animating_switch_workspace;
#line 12341 "WindowManager.c"
	}
#line 1863 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 1863 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 12347 "WindowManager.c"
	} else {
		GalaActivatableComponent* _tmp8_;
		GalaActivatableComponent* _tmp9_;
#line 1867 "../src/WindowManager.vala"
		_tmp8_ = gala_window_manager_get_workspace_view ((GalaWindowManager*) self);
#line 1867 "../src/WindowManager.vala"
		_tmp9_ = _tmp8_;
#line 1867 "../src/WindowManager.vala"
		_tmp1_ = gala_activatable_component_is_opened (_tmp9_);
#line 12357 "WindowManager.c"
	}
#line 1863 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 1863 "../src/WindowManager.vala"
		_tmp0_ = TRUE;
#line 12363 "WindowManager.c"
	} else {
		GalaActivatableComponent* _tmp10_;
#line 1868 "../src/WindowManager.vala"
		_tmp10_ = self->priv->window_overview;
#line 1868 "../src/WindowManager.vala"
		_tmp0_ = gala_activatable_component_is_opened (_tmp10_);
#line 12370 "WindowManager.c"
	}
#line 1863 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 1869 "../src/WindowManager.vala"
		self->priv->animating_switch_workspace = FALSE;
#line 1870 "../src/WindowManager.vala"
		meta_plugin_switch_workspace_completed ((MetaPlugin*) self);
#line 1871 "../src/WindowManager.vala"
		block31_data_unref (_data31_);
#line 1871 "../src/WindowManager.vala"
		_data31_ = NULL;
#line 1871 "../src/WindowManager.vala"
		return;
#line 12384 "WindowManager.c"
	}
#line 1874 "../src/WindowManager.vala"
	self->priv->animating_switch_workspace = TRUE;
#line 1877 "../src/WindowManager.vala"
	_tmp11_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1877 "../src/WindowManager.vala"
	display = _tmp11_;
#line 1878 "../src/WindowManager.vala"
	_tmp12_ = display;
#line 1878 "../src/WindowManager.vala"
	primary = meta_display_get_primary_monitor (_tmp12_);
#line 1879 "../src/WindowManager.vala"
	move_primary_only = gala_internal_utils_workspaces_only_on_primary ();
#line 1880 "../src/WindowManager.vala"
	_tmp13_ = display;
#line 1880 "../src/WindowManager.vala"
	meta_display_get_monitor_geometry (_tmp13_, primary, &_tmp14_);
#line 1880 "../src/WindowManager.vala"
	monitor_geom = _tmp14_;
#line 1881 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 12406 "WindowManager.c"
		MtkRectangle _tmp16_;
#line 1881 "../src/WindowManager.vala"
		_tmp16_ = monitor_geom;
#line 1881 "../src/WindowManager.vala"
		_tmp15_ = (gfloat) _tmp16_.x;
#line 12412 "WindowManager.c"
	} else {
#line 1881 "../src/WindowManager.vala"
		_tmp15_ = 0.0f;
#line 12416 "WindowManager.c"
	}
#line 1881 "../src/WindowManager.vala"
	clone_offset_x = _tmp15_;
#line 1882 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 12422 "WindowManager.c"
		MtkRectangle _tmp18_;
#line 1882 "../src/WindowManager.vala"
		_tmp18_ = monitor_geom;
#line 1882 "../src/WindowManager.vala"
		_tmp17_ = (gfloat) _tmp18_.y;
#line 12428 "WindowManager.c"
	} else {
#line 1882 "../src/WindowManager.vala"
		_tmp17_ = 0.0f;
#line 12432 "WindowManager.c"
	}
#line 1882 "../src/WindowManager.vala"
	clone_offset_y = _tmp17_;
#line 1884 "../src/WindowManager.vala"
	_tmp19_ = display;
#line 1884 "../src/WindowManager.vala"
	meta_display_get_size (_tmp19_, &_tmp20_, &_tmp21_);
#line 1884 "../src/WindowManager.vala"
	screen_width = (gfloat) _tmp20_;
#line 1884 "../src/WindowManager.vala"
	screen_height = (gfloat) _tmp21_;
#line 1886 "../src/WindowManager.vala"
	_tmp22_ = display;
#line 1886 "../src/WindowManager.vala"
	_tmp23_ = meta_display_get_workspace_manager (_tmp22_);
#line 1886 "../src/WindowManager.vala"
	manager = _tmp23_;
#line 1887 "../src/WindowManager.vala"
	_tmp24_ = manager;
#line 1887 "../src/WindowManager.vala"
	_tmp25_ = meta_workspace_manager_get_workspace_by_index (_tmp24_, from);
#line 1887 "../src/WindowManager.vala"
	workspace_from = _tmp25_;
#line 1888 "../src/WindowManager.vala"
	_tmp26_ = manager;
#line 1888 "../src/WindowManager.vala"
	_tmp27_ = meta_workspace_manager_get_workspace_by_index (_tmp26_, to);
#line 1888 "../src/WindowManager.vala"
	workspace_to = _tmp27_;
#line 1890 "../src/WindowManager.vala"
	_tmp28_ = clutter_actor_new ();
#line 1890 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp28_);
#line 1890 "../src/WindowManager.vala"
	main_container = _tmp28_;
#line 1891 "../src/WindowManager.vala"
	_tmp29_ = self->priv->system_background;
#line 1891 "../src/WindowManager.vala"
	_tmp30_ = gala_system_background_get_background_actor (_tmp29_);
#line 1891 "../src/WindowManager.vala"
	_tmp31_ = _tmp30_;
#line 1891 "../src/WindowManager.vala"
	_tmp32_ = (ClutterClone*) clutter_clone_new ((ClutterActor*) _tmp31_);
#line 1891 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp32_);
#line 1891 "../src/WindowManager.vala"
	background_actor = _tmp32_;
#line 1892 "../src/WindowManager.vala"
	_tmp33_ = clutter_actor_new ();
#line 1892 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp33_);
#line 1892 "../src/WindowManager.vala"
	static_windows = _tmp33_;
#line 1893 "../src/WindowManager.vala"
	_tmp34_ = clutter_actor_new ();
#line 1893 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp34_);
#line 1893 "../src/WindowManager.vala"
	_data31_->in_group = _tmp34_;
#line 1894 "../src/WindowManager.vala"
	_tmp35_ = clutter_actor_new ();
#line 1894 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp35_);
#line 1894 "../src/WindowManager.vala"
	_data31_->out_group = _tmp35_;
#line 1895 "../src/WindowManager.vala"
	(self->priv->windows == NULL) ? NULL : (self->priv->windows = (_g_list_free__g_object_unref0_ (self->priv->windows), NULL));
#line 1895 "../src/WindowManager.vala"
	self->priv->windows = NULL;
#line 1896 "../src/WindowManager.vala"
	(self->priv->parents == NULL) ? NULL : (self->priv->parents = (_g_list_free__g_object_unref0_ (self->priv->parents), NULL));
#line 1896 "../src/WindowManager.vala"
	self->priv->parents = NULL;
#line 1897 "../src/WindowManager.vala"
	(self->priv->tmp_actors == NULL) ? NULL : (self->priv->tmp_actors = (_g_list_free__g_object_unref0_ (self->priv->tmp_actors), NULL));
#line 1897 "../src/WindowManager.vala"
	self->priv->tmp_actors = NULL;
#line 1899 "../src/WindowManager.vala"
	_tmp36_ = main_container;
#line 1899 "../src/WindowManager.vala"
	_tmp37_ = _g_object_ref0 (_tmp36_);
#line 1899 "../src/WindowManager.vala"
	self->priv->tmp_actors = g_list_prepend (self->priv->tmp_actors, _tmp37_);
#line 1900 "../src/WindowManager.vala"
	_tmp38_ = background_actor;
#line 1900 "../src/WindowManager.vala"
	_tmp39_ = _g_object_ref0 ((ClutterActor*) _tmp38_);
#line 1900 "../src/WindowManager.vala"
	self->priv->tmp_actors = g_list_prepend (self->priv->tmp_actors, _tmp39_);
#line 1901 "../src/WindowManager.vala"
	_tmp40_ = _data31_->in_group;
#line 1901 "../src/WindowManager.vala"
	_tmp41_ = _g_object_ref0 (_tmp40_);
#line 1901 "../src/WindowManager.vala"
	self->priv->tmp_actors = g_list_prepend (self->priv->tmp_actors, _tmp41_);
#line 1902 "../src/WindowManager.vala"
	_tmp42_ = _data31_->out_group;
#line 1902 "../src/WindowManager.vala"
	_tmp43_ = _g_object_ref0 (_tmp42_);
#line 1902 "../src/WindowManager.vala"
	self->priv->tmp_actors = g_list_prepend (self->priv->tmp_actors, _tmp43_);
#line 1903 "../src/WindowManager.vala"
	_tmp44_ = static_windows;
#line 1903 "../src/WindowManager.vala"
	_tmp45_ = _g_object_ref0 (_tmp44_);
#line 1903 "../src/WindowManager.vala"
	self->priv->tmp_actors = g_list_prepend (self->priv->tmp_actors, _tmp45_);
#line 1905 "../src/WindowManager.vala"
	_tmp46_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 1905 "../src/WindowManager.vala"
	_tmp47_ = _tmp46_;
#line 1905 "../src/WindowManager.vala"
	_tmp48_ = main_container;
#line 1905 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp47_, _tmp48_);
#line 1909 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 12550 "WindowManager.c"
		ClutterActor* background = NULL;
		MetaBackgroundGroup* _tmp49_;
		MetaBackgroundGroup* _tmp50_;
		ClutterActor* _tmp51_;
		ClutterActor* _tmp52_;
		ClutterActor* _tmp53_;
		ClutterClone* _tmp54_;
#line 1910 "../src/WindowManager.vala"
		_tmp49_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 1910 "../src/WindowManager.vala"
		_tmp50_ = _tmp49_;
#line 1910 "../src/WindowManager.vala"
		_tmp51_ = clutter_actor_get_child_at_index ((ClutterActor*) _tmp50_, primary);
#line 1910 "../src/WindowManager.vala"
		background = _tmp51_;
#line 1911 "../src/WindowManager.vala"
		_tmp52_ = background;
#line 1911 "../src/WindowManager.vala"
		clutter_actor_hide (_tmp52_);
#line 1912 "../src/WindowManager.vala"
		_tmp53_ = background;
#line 1912 "../src/WindowManager.vala"
		_tmp54_ = (ClutterClone*) clutter_clone_new (_tmp53_);
#line 1912 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp54_);
#line 1912 "../src/WindowManager.vala"
		_g_object_unref0 (_data31_->wallpaper);
#line 1912 "../src/WindowManager.vala"
		_data31_->wallpaper = (ClutterActor*) _tmp54_;
#line 12580 "WindowManager.c"
	} else {
		MetaBackgroundGroup* _tmp55_;
		MetaBackgroundGroup* _tmp56_;
		MetaBackgroundGroup* _tmp57_;
		MetaBackgroundGroup* _tmp58_;
		ClutterClone* _tmp59_;
#line 1914 "../src/WindowManager.vala"
		_tmp55_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 1914 "../src/WindowManager.vala"
		_tmp56_ = _tmp55_;
#line 1914 "../src/WindowManager.vala"
		clutter_actor_hide ((ClutterActor*) _tmp56_);
#line 1915 "../src/WindowManager.vala"
		_tmp57_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 1915 "../src/WindowManager.vala"
		_tmp58_ = _tmp57_;
#line 1915 "../src/WindowManager.vala"
		_tmp59_ = (ClutterClone*) clutter_clone_new ((ClutterActor*) _tmp58_);
#line 1915 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp59_);
#line 1915 "../src/WindowManager.vala"
		_g_object_unref0 (_data31_->wallpaper);
#line 1915 "../src/WindowManager.vala"
		_data31_->wallpaper = (ClutterActor*) _tmp59_;
#line 12605 "WindowManager.c"
	}
#line 1917 "../src/WindowManager.vala"
	_tmp60_ = _data31_->wallpaper;
#line 1917 "../src/WindowManager.vala"
	_tmp61_ = g_strdup ("workspace");
#line 1917 "../src/WindowManager.vala"
	_tmp62_ = gala_shadow_effect_new (40);
#line 1917 "../src/WindowManager.vala"
	gala_shadow_effect_set_css_class (_tmp62_, _tmp61_);
#line 1917 "../src/WindowManager.vala"
	_g_free0 (_tmp61_);
#line 1917 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp62_);
#line 1917 "../src/WindowManager.vala"
	_tmp63_ = _tmp62_;
#line 1917 "../src/WindowManager.vala"
	clutter_actor_add_effect (_tmp60_, (ClutterEffect*) _tmp63_);
#line 1917 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp63_);
#line 1918 "../src/WindowManager.vala"
	_tmp64_ = _data31_->wallpaper;
#line 1918 "../src/WindowManager.vala"
	_tmp65_ = _g_object_ref0 (_tmp64_);
#line 1918 "../src/WindowManager.vala"
	self->priv->tmp_actors = g_list_prepend (self->priv->tmp_actors, _tmp65_);
#line 1920 "../src/WindowManager.vala"
	_tmp66_ = _data31_->wallpaper;
#line 1920 "../src/WindowManager.vala"
	_tmp67_ = (ClutterClone*) clutter_clone_new (_tmp66_);
#line 1920 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp67_);
#line 1920 "../src/WindowManager.vala"
	_data31_->wallpaper_clone = _tmp67_;
#line 1921 "../src/WindowManager.vala"
	_tmp68_ = _data31_->wallpaper_clone;
#line 1921 "../src/WindowManager.vala"
	_tmp69_ = g_strdup ("workspace");
#line 1921 "../src/WindowManager.vala"
	_tmp70_ = gala_shadow_effect_new (40);
#line 1921 "../src/WindowManager.vala"
	gala_shadow_effect_set_css_class (_tmp70_, _tmp69_);
#line 1921 "../src/WindowManager.vala"
	_g_free0 (_tmp69_);
#line 1921 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp70_);
#line 1921 "../src/WindowManager.vala"
	_tmp71_ = _tmp70_;
#line 1921 "../src/WindowManager.vala"
	clutter_actor_add_effect ((ClutterActor*) _tmp68_, (ClutterEffect*) _tmp71_);
#line 1921 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp71_);
#line 1922 "../src/WindowManager.vala"
	_tmp72_ = _data31_->wallpaper_clone;
#line 1922 "../src/WindowManager.vala"
	_tmp73_ = _g_object_ref0 ((ClutterActor*) _tmp72_);
#line 1922 "../src/WindowManager.vala"
	self->priv->tmp_actors = g_list_prepend (self->priv->tmp_actors, _tmp73_);
#line 1925 "../src/WindowManager.vala"
	_tmp74_ = main_container;
#line 1925 "../src/WindowManager.vala"
	_tmp75_ = background_actor;
#line 1925 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp74_, (ClutterActor*) _tmp75_);
#line 1926 "../src/WindowManager.vala"
	_tmp76_ = main_container;
#line 1926 "../src/WindowManager.vala"
	_tmp77_ = _data31_->wallpaper;
#line 1926 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp76_, _tmp77_);
#line 1927 "../src/WindowManager.vala"
	_tmp78_ = main_container;
#line 1927 "../src/WindowManager.vala"
	_tmp79_ = _data31_->wallpaper_clone;
#line 1927 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp78_, (ClutterActor*) _tmp79_);
#line 1928 "../src/WindowManager.vala"
	_tmp80_ = main_container;
#line 1928 "../src/WindowManager.vala"
	_tmp81_ = _data31_->out_group;
#line 1928 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp80_, _tmp81_);
#line 1929 "../src/WindowManager.vala"
	_tmp82_ = main_container;
#line 1929 "../src/WindowManager.vala"
	_tmp83_ = _data31_->in_group;
#line 1929 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp82_, _tmp83_);
#line 1930 "../src/WindowManager.vala"
	_tmp84_ = main_container;
#line 1930 "../src/WindowManager.vala"
	_tmp85_ = static_windows;
#line 1930 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp84_, _tmp85_);
#line 1933 "../src/WindowManager.vala"
	_tmp86_ = self->priv->moving;
#line 1933 "../src/WindowManager.vala"
	if (_tmp86_ != NULL) {
#line 12703 "WindowManager.c"
		MetaWindowActor* moving_actor = NULL;
		MetaWindow* _tmp87_;
		GObject* _tmp88_;
		MetaWindowActor* _tmp89_;
		ClutterActor* _tmp90_;
		MetaWindowActor* _tmp91_;
		ClutterActor* _tmp92_;
		ClutterActor* _tmp93_;
		MetaWindowActor* _tmp94_;
		MetaWindowActor* _tmp95_;
		ClutterActor* _tmp96_;
#line 1934 "../src/WindowManager.vala"
		_tmp87_ = self->priv->moving;
#line 1934 "../src/WindowManager.vala"
		_tmp88_ = meta_window_get_compositor_private (_tmp87_);
#line 1934 "../src/WindowManager.vala"
		moving_actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, meta_window_actor_get_type (), MetaWindowActor);
#line 1936 "../src/WindowManager.vala"
		_tmp89_ = moving_actor;
#line 1936 "../src/WindowManager.vala"
		_tmp90_ = _g_object_ref0 ((ClutterActor*) _tmp89_);
#line 1936 "../src/WindowManager.vala"
		self->priv->windows = g_list_prepend (self->priv->windows, _tmp90_);
#line 1937 "../src/WindowManager.vala"
		_tmp91_ = moving_actor;
#line 1937 "../src/WindowManager.vala"
		_tmp92_ = clutter_actor_get_parent ((ClutterActor*) _tmp91_);
#line 1937 "../src/WindowManager.vala"
		_tmp93_ = _g_object_ref0 (_tmp92_);
#line 1937 "../src/WindowManager.vala"
		self->priv->parents = g_list_prepend (self->priv->parents, _tmp93_);
#line 1939 "../src/WindowManager.vala"
		_tmp94_ = moving_actor;
#line 1939 "../src/WindowManager.vala"
		clutter_actor_set_translation ((ClutterActor*) _tmp94_, -clone_offset_x, -clone_offset_y, (gfloat) 0);
#line 1940 "../src/WindowManager.vala"
		_tmp95_ = moving_actor;
#line 1940 "../src/WindowManager.vala"
		_tmp96_ = static_windows;
#line 1940 "../src/WindowManager.vala"
		gala_window_manager_gala_clutter_actor_reparent ((ClutterActor*) _tmp95_, _tmp96_);
#line 12745 "WindowManager.c"
	}
#line 1943 "../src/WindowManager.vala"
	to_has_fullscreened = FALSE;
#line 1944 "../src/WindowManager.vala"
	from_has_fullscreened = FALSE;
#line 1945 "../src/WindowManager.vala"
	docks = NULL;
#line 1948 "../src/WindowManager.vala"
	_tmp97_ = display;
#line 1948 "../src/WindowManager.vala"
	_tmp98_ = meta_get_window_actors (_tmp97_);
#line 12757 "WindowManager.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 1948 "../src/WindowManager.vala"
		actor_collection = _tmp98_;
#line 1948 "../src/WindowManager.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 12765 "WindowManager.c"
			MetaWindowActor* actor = NULL;
#line 1948 "../src/WindowManager.vala"
			actor = (MetaWindowActor*) actor_it->data;
#line 12769 "WindowManager.c"
			{
				MetaWindowActor* _tmp99_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp100_;
				MetaWindow* _tmp101_;
				gboolean _tmp102_ = FALSE;
				gboolean _tmp103_ = FALSE;
				MetaWindow* _tmp104_;
				MetaWindow* _tmp111_;
				gboolean _tmp112_;
				gboolean _tmp113_;
				MetaWindow* _tmp134_;
				MetaWorkspace* _tmp135_;
				MetaWorkspace* _tmp136_;
#line 1949 "../src/WindowManager.vala"
				_tmp99_ = actor;
#line 1949 "../src/WindowManager.vala"
				if (meta_window_actor_is_destroyed (_tmp99_)) {
#line 1950 "../src/WindowManager.vala"
					continue;
#line 12790 "WindowManager.c"
				}
#line 1952 "../src/WindowManager.vala"
				_tmp100_ = actor;
#line 1952 "../src/WindowManager.vala"
				_tmp101_ = meta_window_actor_get_meta_window (_tmp100_);
#line 1952 "../src/WindowManager.vala"
				window = _tmp101_;
#line 1954 "../src/WindowManager.vala"
				_tmp104_ = window;
#line 1954 "../src/WindowManager.vala"
				if (!meta_window_showing_on_its_workspace (_tmp104_)) {
#line 1954 "../src/WindowManager.vala"
					_tmp103_ = TRUE;
#line 12804 "WindowManager.c"
				} else {
					gboolean _tmp105_ = FALSE;
#line 1955 "../src/WindowManager.vala"
					if (move_primary_only) {
#line 12809 "WindowManager.c"
						MetaWindow* _tmp106_;
#line 1955 "../src/WindowManager.vala"
						_tmp106_ = window;
#line 1955 "../src/WindowManager.vala"
						_tmp105_ = !meta_window_is_on_primary_monitor (_tmp106_);
#line 12815 "WindowManager.c"
					} else {
#line 1955 "../src/WindowManager.vala"
						_tmp105_ = FALSE;
#line 12819 "WindowManager.c"
					}
#line 1955 "../src/WindowManager.vala"
					_tmp103_ = _tmp105_;
#line 12823 "WindowManager.c"
				}
#line 1954 "../src/WindowManager.vala"
				if (_tmp103_) {
#line 1954 "../src/WindowManager.vala"
					_tmp102_ = TRUE;
#line 12829 "WindowManager.c"
				} else {
					gboolean _tmp107_ = FALSE;
					MetaWindow* _tmp108_;
#line 1956 "../src/WindowManager.vala"
					_tmp108_ = self->priv->moving;
#line 1956 "../src/WindowManager.vala"
					if (_tmp108_ != NULL) {
#line 12837 "WindowManager.c"
						MetaWindow* _tmp109_;
						MetaWindow* _tmp110_;
#line 1956 "../src/WindowManager.vala"
						_tmp109_ = window;
#line 1956 "../src/WindowManager.vala"
						_tmp110_ = self->priv->moving;
#line 1956 "../src/WindowManager.vala"
						_tmp107_ = _tmp109_ == _tmp110_;
#line 12846 "WindowManager.c"
					} else {
#line 1956 "../src/WindowManager.vala"
						_tmp107_ = FALSE;
#line 12850 "WindowManager.c"
					}
#line 1956 "../src/WindowManager.vala"
					_tmp102_ = _tmp107_;
#line 12854 "WindowManager.c"
				}
#line 1954 "../src/WindowManager.vala"
				if (_tmp102_) {
#line 1957 "../src/WindowManager.vala"
					continue;
#line 12860 "WindowManager.c"
				}
#line 1959 "../src/WindowManager.vala"
				_tmp111_ = window;
#line 1959 "../src/WindowManager.vala"
				g_object_get (_tmp111_, "on-all-workspaces", &_tmp112_, NULL);
#line 1959 "../src/WindowManager.vala"
				_tmp113_ = _tmp112_;
#line 1959 "../src/WindowManager.vala"
				if (_tmp113_) {
#line 12870 "WindowManager.c"
					MetaWindow* _tmp114_;
					MetaWindowType _tmp115_;
					MetaWindowType _tmp116_;
#line 1962 "../src/WindowManager.vala"
					_tmp114_ = window;
#line 1962 "../src/WindowManager.vala"
					_tmp115_ = meta_window_get_window_type (_tmp114_);
#line 1962 "../src/WindowManager.vala"
					_tmp116_ = _tmp115_;
#line 1962 "../src/WindowManager.vala"
					if (_tmp116_ == META_WINDOW_DOCK) {
#line 12882 "WindowManager.c"
						MetaWindowActor* _tmp117_;
						MetaWindowActor* _tmp118_;
#line 1963 "../src/WindowManager.vala"
						_tmp117_ = actor;
#line 1963 "../src/WindowManager.vala"
						_tmp118_ = _g_object_ref0 (_tmp117_);
#line 1963 "../src/WindowManager.vala"
						docks = g_list_prepend (docks, _tmp118_);
#line 12891 "WindowManager.c"
					} else {
						MetaWindow* _tmp119_;
						MetaWindowType _tmp120_;
						MetaWindowType _tmp121_;
#line 1964 "../src/WindowManager.vala"
						_tmp119_ = window;
#line 1964 "../src/WindowManager.vala"
						_tmp120_ = meta_window_get_window_type (_tmp119_);
#line 1964 "../src/WindowManager.vala"
						_tmp121_ = _tmp120_;
#line 1964 "../src/WindowManager.vala"
						if (_tmp121_ == META_WINDOW_NOTIFICATION) {
#line 12904 "WindowManager.c"
						} else {
							MetaWindowActor* _tmp122_;
							ClutterActor* _tmp123_;
							MetaWindowActor* _tmp124_;
							ClutterActor* _tmp125_;
							ClutterActor* _tmp126_;
							MetaWindowActor* _tmp127_;
							ClutterActor* _tmp128_;
							MetaWindowActor* _tmp129_;
							MetaWindowActor* _tmp130_;
							MetaWindowActor* _tmp131_;
							MetaWindowActor* _tmp132_;
							MetaWindowActor* _tmp133_;
#line 1968 "../src/WindowManager.vala"
							_tmp122_ = actor;
#line 1968 "../src/WindowManager.vala"
							_tmp123_ = _g_object_ref0 ((ClutterActor*) _tmp122_);
#line 1968 "../src/WindowManager.vala"
							self->priv->windows = g_list_prepend (self->priv->windows, _tmp123_);
#line 1969 "../src/WindowManager.vala"
							_tmp124_ = actor;
#line 1969 "../src/WindowManager.vala"
							_tmp125_ = clutter_actor_get_parent ((ClutterActor*) _tmp124_);
#line 1969 "../src/WindowManager.vala"
							_tmp126_ = _g_object_ref0 (_tmp125_);
#line 1969 "../src/WindowManager.vala"
							self->priv->parents = g_list_prepend (self->priv->parents, _tmp126_);
#line 1971 "../src/WindowManager.vala"
							_tmp127_ = actor;
#line 1971 "../src/WindowManager.vala"
							_tmp128_ = static_windows;
#line 1971 "../src/WindowManager.vala"
							gala_window_manager_gala_clutter_actor_reparent ((ClutterActor*) _tmp127_, _tmp128_);
#line 1972 "../src/WindowManager.vala"
							_tmp129_ = actor;
#line 1972 "../src/WindowManager.vala"
							clutter_actor_set_translation ((ClutterActor*) _tmp129_, -clone_offset_x, -clone_offset_y, (gfloat) 0);
#line 1973 "../src/WindowManager.vala"
							_tmp130_ = actor;
#line 1973 "../src/WindowManager.vala"
							clutter_actor_save_easing_state ((ClutterActor*) _tmp130_);
#line 1974 "../src/WindowManager.vala"
							_tmp131_ = actor;
#line 1974 "../src/WindowManager.vala"
							clutter_actor_set_easing_duration ((ClutterActor*) _tmp131_, (guint) 300);
#line 1975 "../src/WindowManager.vala"
							_tmp132_ = actor;
#line 1975 "../src/WindowManager.vala"
							clutter_actor_set_opacity ((ClutterActor*) _tmp132_, (guint) 0);
#line 1976 "../src/WindowManager.vala"
							_tmp133_ = actor;
#line 1976 "../src/WindowManager.vala"
							clutter_actor_restore_easing_state ((ClutterActor*) _tmp133_);
#line 12958 "WindowManager.c"
						}
					}
#line 1979 "../src/WindowManager.vala"
					continue;
#line 12963 "WindowManager.c"
				}
#line 1982 "../src/WindowManager.vala"
				_tmp134_ = window;
#line 1982 "../src/WindowManager.vala"
				_tmp135_ = meta_window_get_workspace (_tmp134_);
#line 1982 "../src/WindowManager.vala"
				_tmp136_ = workspace_from;
#line 1982 "../src/WindowManager.vala"
				if (_tmp135_ == _tmp136_) {
#line 12973 "WindowManager.c"
					MetaWindowActor* _tmp137_;
					ClutterActor* _tmp138_;
					MetaWindowActor* _tmp139_;
					ClutterActor* _tmp140_;
					ClutterActor* _tmp141_;
					MetaWindowActor* _tmp142_;
					MetaWindowActor* _tmp143_;
					ClutterActor* _tmp144_;
					MetaWindow* _tmp145_;
					gboolean _tmp146_;
					gboolean _tmp147_;
#line 1983 "../src/WindowManager.vala"
					_tmp137_ = actor;
#line 1983 "../src/WindowManager.vala"
					_tmp138_ = _g_object_ref0 ((ClutterActor*) _tmp137_);
#line 1983 "../src/WindowManager.vala"
					self->priv->windows = g_list_append (self->priv->windows, _tmp138_);
#line 1984 "../src/WindowManager.vala"
					_tmp139_ = actor;
#line 1984 "../src/WindowManager.vala"
					_tmp140_ = clutter_actor_get_parent ((ClutterActor*) _tmp139_);
#line 1984 "../src/WindowManager.vala"
					_tmp141_ = _g_object_ref0 (_tmp140_);
#line 1984 "../src/WindowManager.vala"
					self->priv->parents = g_list_append (self->priv->parents, _tmp141_);
#line 1985 "../src/WindowManager.vala"
					_tmp142_ = actor;
#line 1985 "../src/WindowManager.vala"
					clutter_actor_set_translation ((ClutterActor*) _tmp142_, -clone_offset_x, -clone_offset_y, (gfloat) 0);
#line 1986 "../src/WindowManager.vala"
					_tmp143_ = actor;
#line 1986 "../src/WindowManager.vala"
					_tmp144_ = _data31_->out_group;
#line 1986 "../src/WindowManager.vala"
					gala_window_manager_gala_clutter_actor_reparent ((ClutterActor*) _tmp143_, _tmp144_);
#line 1988 "../src/WindowManager.vala"
					_tmp145_ = window;
#line 1988 "../src/WindowManager.vala"
					g_object_get (_tmp145_, "fullscreen", &_tmp146_, NULL);
#line 1988 "../src/WindowManager.vala"
					_tmp147_ = _tmp146_;
#line 1988 "../src/WindowManager.vala"
					if (_tmp147_) {
#line 1989 "../src/WindowManager.vala"
						from_has_fullscreened = TRUE;
#line 13019 "WindowManager.c"
					}
				} else {
					MetaWindow* _tmp148_;
					MetaWorkspace* _tmp149_;
					MetaWorkspace* _tmp150_;
#line 1991 "../src/WindowManager.vala"
					_tmp148_ = window;
#line 1991 "../src/WindowManager.vala"
					_tmp149_ = meta_window_get_workspace (_tmp148_);
#line 1991 "../src/WindowManager.vala"
					_tmp150_ = workspace_to;
#line 1991 "../src/WindowManager.vala"
					if (_tmp149_ == _tmp150_) {
#line 13033 "WindowManager.c"
						MetaWindowActor* _tmp151_;
						ClutterActor* _tmp152_;
						MetaWindowActor* _tmp153_;
						ClutterActor* _tmp154_;
						ClutterActor* _tmp155_;
						MetaWindowActor* _tmp156_;
						MetaWindowActor* _tmp157_;
						ClutterActor* _tmp158_;
						MetaWindow* _tmp159_;
						gboolean _tmp160_;
						gboolean _tmp161_;
#line 1992 "../src/WindowManager.vala"
						_tmp151_ = actor;
#line 1992 "../src/WindowManager.vala"
						_tmp152_ = _g_object_ref0 ((ClutterActor*) _tmp151_);
#line 1992 "../src/WindowManager.vala"
						self->priv->windows = g_list_append (self->priv->windows, _tmp152_);
#line 1993 "../src/WindowManager.vala"
						_tmp153_ = actor;
#line 1993 "../src/WindowManager.vala"
						_tmp154_ = clutter_actor_get_parent ((ClutterActor*) _tmp153_);
#line 1993 "../src/WindowManager.vala"
						_tmp155_ = _g_object_ref0 (_tmp154_);
#line 1993 "../src/WindowManager.vala"
						self->priv->parents = g_list_append (self->priv->parents, _tmp155_);
#line 1994 "../src/WindowManager.vala"
						_tmp156_ = actor;
#line 1994 "../src/WindowManager.vala"
						clutter_actor_set_translation ((ClutterActor*) _tmp156_, -clone_offset_x, -clone_offset_y, (gfloat) 0);
#line 1995 "../src/WindowManager.vala"
						_tmp157_ = actor;
#line 1995 "../src/WindowManager.vala"
						_tmp158_ = _data31_->in_group;
#line 1995 "../src/WindowManager.vala"
						gala_window_manager_gala_clutter_actor_reparent ((ClutterActor*) _tmp157_, _tmp158_);
#line 1997 "../src/WindowManager.vala"
						_tmp159_ = window;
#line 1997 "../src/WindowManager.vala"
						g_object_get (_tmp159_, "fullscreen", &_tmp160_, NULL);
#line 1997 "../src/WindowManager.vala"
						_tmp161_ = _tmp160_;
#line 1997 "../src/WindowManager.vala"
						if (_tmp161_) {
#line 1998 "../src/WindowManager.vala"
							to_has_fullscreened = TRUE;
#line 13079 "WindowManager.c"
						}
					}
				}
			}
		}
	}
#line 2005 "../src/WindowManager.vala"
	_tmp162_ = g_signal_connect_object (self, "window-created", (GCallback) ___lambda161__gala_window_manager_gala_window_created, self, 0);
#line 2005 "../src/WindowManager.vala"
	self->priv->switch_workspace_window_created_id = _tmp162_;
#line 2017 "../src/WindowManager.vala"
	_tmp163_ = docks;
#line 13092 "WindowManager.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 2017 "../src/WindowManager.vala"
		window_collection = _tmp163_;
#line 2017 "../src/WindowManager.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 13100 "WindowManager.c"
			MetaWindowActor* _tmp164_;
			MetaWindowActor* window = NULL;
#line 2017 "../src/WindowManager.vala"
			_tmp164_ = _g_object_ref0 ((MetaWindowActor*) window_it->data);
#line 2017 "../src/WindowManager.vala"
			window = _tmp164_;
#line 13107 "WindowManager.c"
			{
#line 2018 "../src/WindowManager.vala"
				if (!to_has_fullscreened) {
#line 13111 "WindowManager.c"
					GalaSafeWindowClone* clone = NULL;
					MetaWindowActor* _tmp165_;
					MetaWindow* _tmp166_;
					MetaWindowActor* _tmp167_;
					gfloat _tmp168_;
					gfloat _tmp169_;
					MetaWindowActor* _tmp170_;
					gfloat _tmp171_;
					gfloat _tmp172_;
					GalaSafeWindowClone* _tmp173_ = NULL;
					ClutterActor* _tmp174_;
					GalaSafeWindowClone* _tmp175_;
					GalaSafeWindowClone* _tmp176_;
					ClutterActor* _tmp177_;
#line 2019 "../src/WindowManager.vala"
					_tmp165_ = window;
#line 2019 "../src/WindowManager.vala"
					_tmp166_ = meta_window_actor_get_meta_window (_tmp165_);
#line 2019 "../src/WindowManager.vala"
					_tmp167_ = window;
#line 2019 "../src/WindowManager.vala"
					_tmp168_ = clutter_actor_get_x ((ClutterActor*) _tmp167_);
#line 2019 "../src/WindowManager.vala"
					_tmp169_ = _tmp168_;
#line 2019 "../src/WindowManager.vala"
					_tmp170_ = window;
#line 2019 "../src/WindowManager.vala"
					_tmp171_ = clutter_actor_get_y ((ClutterActor*) _tmp170_);
#line 2019 "../src/WindowManager.vala"
					_tmp172_ = _tmp171_;
#line 2019 "../src/WindowManager.vala"
					_tmp173_ = gala_safe_window_clone_new (_tmp166_, FALSE);
#line 2019 "../src/WindowManager.vala"
					clutter_actor_set_x ((ClutterActor*) _tmp173_, _tmp169_ - clone_offset_x);
#line 2019 "../src/WindowManager.vala"
					clutter_actor_set_y ((ClutterActor*) _tmp173_, _tmp172_ - clone_offset_y);
#line 2019 "../src/WindowManager.vala"
					g_object_ref_sink (_tmp173_);
#line 2019 "../src/WindowManager.vala"
					clone = _tmp173_;
#line 2024 "../src/WindowManager.vala"
					_tmp174_ = _data31_->in_group;
#line 2024 "../src/WindowManager.vala"
					_tmp175_ = clone;
#line 2024 "../src/WindowManager.vala"
					clutter_actor_add_child (_tmp174_, (ClutterActor*) _tmp175_);
#line 2025 "../src/WindowManager.vala"
					_tmp176_ = clone;
#line 2025 "../src/WindowManager.vala"
					_tmp177_ = _g_object_ref0 ((ClutterActor*) _tmp176_);
#line 2025 "../src/WindowManager.vala"
					self->priv->tmp_actors = g_list_prepend (self->priv->tmp_actors, _tmp177_);
#line 2018 "../src/WindowManager.vala"
					_g_object_unref0 (clone);
#line 13166 "WindowManager.c"
				}
#line 2028 "../src/WindowManager.vala"
				if (!from_has_fullscreened) {
#line 13170 "WindowManager.c"
					MetaWindowActor* _tmp178_;
					ClutterActor* _tmp179_;
					MetaWindowActor* _tmp180_;
					ClutterActor* _tmp181_;
					ClutterActor* _tmp182_;
					MetaWindowActor* _tmp183_;
					MetaWindowActor* _tmp184_;
					ClutterActor* _tmp185_;
#line 2029 "../src/WindowManager.vala"
					_tmp178_ = window;
#line 2029 "../src/WindowManager.vala"
					_tmp179_ = _g_object_ref0 ((ClutterActor*) _tmp178_);
#line 2029 "../src/WindowManager.vala"
					self->priv->windows = g_list_prepend (self->priv->windows, _tmp179_);
#line 2030 "../src/WindowManager.vala"
					_tmp180_ = window;
#line 2030 "../src/WindowManager.vala"
					_tmp181_ = clutter_actor_get_parent ((ClutterActor*) _tmp180_);
#line 2030 "../src/WindowManager.vala"
					_tmp182_ = _g_object_ref0 (_tmp181_);
#line 2030 "../src/WindowManager.vala"
					self->priv->parents = g_list_prepend (self->priv->parents, _tmp182_);
#line 2031 "../src/WindowManager.vala"
					_tmp183_ = window;
#line 2031 "../src/WindowManager.vala"
					clutter_actor_set_translation ((ClutterActor*) _tmp183_, -clone_offset_x, -clone_offset_y, 0.0f);
#line 2033 "../src/WindowManager.vala"
					_tmp184_ = window;
#line 2033 "../src/WindowManager.vala"
					_tmp185_ = _data31_->out_group;
#line 2033 "../src/WindowManager.vala"
					gala_window_manager_gala_clutter_actor_reparent ((ClutterActor*) _tmp184_, _tmp185_);
#line 13203 "WindowManager.c"
				}
#line 2017 "../src/WindowManager.vala"
				_g_object_unref0 (window);
#line 13207 "WindowManager.c"
			}
		}
	}
#line 2037 "../src/WindowManager.vala"
	_tmp186_ = main_container;
#line 2037 "../src/WindowManager.vala"
	clutter_actor_set_clip_to_allocation (_tmp186_, TRUE);
#line 2038 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13217 "WindowManager.c"
		MtkRectangle _tmp188_;
#line 2038 "../src/WindowManager.vala"
		_tmp188_ = monitor_geom;
#line 2038 "../src/WindowManager.vala"
		_tmp187_ = (gfloat) _tmp188_.x;
#line 13223 "WindowManager.c"
	} else {
#line 2038 "../src/WindowManager.vala"
		_tmp187_ = 0.0f;
#line 13227 "WindowManager.c"
	}
#line 2038 "../src/WindowManager.vala"
	_tmp189_ = main_container;
#line 2038 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp189_, _tmp187_);
#line 2039 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13235 "WindowManager.c"
		MtkRectangle _tmp191_;
#line 2039 "../src/WindowManager.vala"
		_tmp191_ = monitor_geom;
#line 2039 "../src/WindowManager.vala"
		_tmp190_ = (gfloat) _tmp191_.y;
#line 13241 "WindowManager.c"
	} else {
#line 2039 "../src/WindowManager.vala"
		_tmp190_ = 0.0f;
#line 13245 "WindowManager.c"
	}
#line 2039 "../src/WindowManager.vala"
	_tmp192_ = main_container;
#line 2039 "../src/WindowManager.vala"
	clutter_actor_set_y (_tmp192_, _tmp190_);
#line 2040 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13253 "WindowManager.c"
		MtkRectangle _tmp194_;
#line 2040 "../src/WindowManager.vala"
		_tmp194_ = monitor_geom;
#line 2040 "../src/WindowManager.vala"
		_tmp193_ = (gfloat) _tmp194_.width;
#line 13259 "WindowManager.c"
	} else {
#line 2040 "../src/WindowManager.vala"
		_tmp193_ = screen_width;
#line 13263 "WindowManager.c"
	}
#line 2040 "../src/WindowManager.vala"
	_tmp195_ = main_container;
#line 2040 "../src/WindowManager.vala"
	clutter_actor_set_width (_tmp195_, _tmp193_);
#line 2041 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13271 "WindowManager.c"
		MtkRectangle _tmp197_;
#line 2041 "../src/WindowManager.vala"
		_tmp197_ = monitor_geom;
#line 2041 "../src/WindowManager.vala"
		_tmp196_ = (gfloat) _tmp197_.height;
#line 13277 "WindowManager.c"
	} else {
#line 2041 "../src/WindowManager.vala"
		_tmp196_ = screen_height;
#line 13281 "WindowManager.c"
	}
#line 2041 "../src/WindowManager.vala"
	_tmp198_ = main_container;
#line 2041 "../src/WindowManager.vala"
	clutter_actor_set_height (_tmp198_, _tmp196_);
#line 2043 "../src/WindowManager.vala"
	_tmp199_ = display;
#line 2043 "../src/WindowManager.vala"
	monitor_scale = meta_display_get_monitor_scale (_tmp199_, primary);
#line 2044 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13293 "WindowManager.c"
		MtkRectangle _tmp201_;
#line 2044 "../src/WindowManager.vala"
		_tmp201_ = monitor_geom;
#line 2044 "../src/WindowManager.vala"
		_tmp200_ = (gfloat) _tmp201_.width;
#line 13299 "WindowManager.c"
	} else {
#line 2044 "../src/WindowManager.vala"
		_tmp200_ = screen_width;
#line 13303 "WindowManager.c"
	}
#line 2044 "../src/WindowManager.vala"
	_data31_->x2 = _tmp200_;
#line 2045 "../src/WindowManager.vala"
	_data31_->x2 += GALA_WINDOW_MANAGER_GALA_WORKSPACE_GAP * monitor_scale;
#line 2046 "../src/WindowManager.vala"
	if (_data31_->direction == META_MOTION_RIGHT) {
#line 2047 "../src/WindowManager.vala"
		_data31_->x2 = -_data31_->x2;
#line 13313 "WindowManager.c"
	}
#line 2049 "../src/WindowManager.vala"
	_tmp202_ = _data31_->out_group;
#line 2049 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp202_, 0.0f);
#line 2050 "../src/WindowManager.vala"
	_tmp203_ = _data31_->wallpaper;
#line 2050 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp203_, 0.0f);
#line 2051 "../src/WindowManager.vala"
	_tmp204_ = _data31_->wallpaper;
#line 2051 "../src/WindowManager.vala"
	_tmp205_ = _data31_->wallpaper;
#line 2051 "../src/WindowManager.vala"
	_tmp206_ = clutter_actor_get_y (_tmp205_);
#line 2051 "../src/WindowManager.vala"
	_tmp207_ = _tmp206_;
#line 2051 "../src/WindowManager.vala"
	clutter_actor_set_y (_tmp205_, _tmp207_ + clone_offset_y);
#line 2052 "../src/WindowManager.vala"
	_tmp208_ = _data31_->in_group;
#line 2052 "../src/WindowManager.vala"
	clutter_actor_set_x (_tmp208_, -_data31_->x2);
#line 2053 "../src/WindowManager.vala"
	_tmp209_ = _data31_->wallpaper_clone;
#line 2053 "../src/WindowManager.vala"
	clutter_actor_set_x ((ClutterActor*) _tmp209_, -_data31_->x2);
#line 2054 "../src/WindowManager.vala"
	_tmp210_ = _data31_->wallpaper_clone;
#line 2054 "../src/WindowManager.vala"
	_tmp211_ = _data31_->wallpaper_clone;
#line 2054 "../src/WindowManager.vala"
	_tmp212_ = clutter_actor_get_y ((ClutterActor*) _tmp211_);
#line 2054 "../src/WindowManager.vala"
	_tmp213_ = _tmp212_;
#line 2054 "../src/WindowManager.vala"
	clutter_actor_set_y ((ClutterActor*) _tmp211_, _tmp213_ + clone_offset_y);
#line 2055 "../src/WindowManager.vala"
	_tmp214_ = _data31_->wallpaper;
#line 2055 "../src/WindowManager.vala"
	clutter_actor_set_translation (_tmp214_, -clone_offset_x, 0.0f, 0.0f);
#line 2056 "../src/WindowManager.vala"
	_tmp215_ = _data31_->wallpaper_clone;
#line 2056 "../src/WindowManager.vala"
	clutter_actor_set_translation ((ClutterActor*) _tmp215_, -clone_offset_x, 0.0f, 0.0f);
#line 2060 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13361 "WindowManager.c"
		ClutterActor* _tmp216_;
		MtkRectangle _tmp217_;
		ClutterClone* _tmp218_;
		MtkRectangle _tmp219_;
#line 2061 "../src/WindowManager.vala"
		_tmp216_ = _data31_->wallpaper;
#line 2061 "../src/WindowManager.vala"
		_tmp217_ = monitor_geom;
#line 2061 "../src/WindowManager.vala"
		clutter_actor_set_y (_tmp216_, (gfloat) (-_tmp217_.y));
#line 2062 "../src/WindowManager.vala"
		_tmp218_ = _data31_->wallpaper_clone;
#line 2062 "../src/WindowManager.vala"
		_tmp219_ = monitor_geom;
#line 2062 "../src/WindowManager.vala"
		clutter_actor_set_y ((ClutterActor*) _tmp218_, (gfloat) (-_tmp219_.y));
#line 13378 "WindowManager.c"
	}
#line 2065 "../src/WindowManager.vala"
	_tmp220_ = _data31_->in_group;
#line 2065 "../src/WindowManager.vala"
	_tmp221_ = _data31_->out_group;
#line 2065 "../src/WindowManager.vala"
	clutter_actor_set_clip_to_allocation (_tmp221_, TRUE);
#line 2065 "../src/WindowManager.vala"
	clutter_actor_set_clip_to_allocation (_tmp220_, TRUE);
#line 2066 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13390 "WindowManager.c"
		MtkRectangle _tmp223_;
#line 2066 "../src/WindowManager.vala"
		_tmp223_ = monitor_geom;
#line 2066 "../src/WindowManager.vala"
		_tmp222_ = (gfloat) _tmp223_.width;
#line 13396 "WindowManager.c"
	} else {
#line 2066 "../src/WindowManager.vala"
		_tmp222_ = screen_width;
#line 13400 "WindowManager.c"
	}
#line 2066 "../src/WindowManager.vala"
	_tmp224_ = _data31_->in_group;
#line 2066 "../src/WindowManager.vala"
	_tmp225_ = _data31_->out_group;
#line 2066 "../src/WindowManager.vala"
	clutter_actor_set_width (_tmp225_, _tmp222_);
#line 2066 "../src/WindowManager.vala"
	clutter_actor_set_width (_tmp224_, _tmp222_);
#line 2067 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13412 "WindowManager.c"
		MtkRectangle _tmp227_;
#line 2067 "../src/WindowManager.vala"
		_tmp227_ = monitor_geom;
#line 2067 "../src/WindowManager.vala"
		_tmp226_ = (gfloat) _tmp227_.height;
#line 13418 "WindowManager.c"
	} else {
#line 2067 "../src/WindowManager.vala"
		_tmp226_ = screen_height;
#line 13422 "WindowManager.c"
	}
#line 2067 "../src/WindowManager.vala"
	_tmp228_ = _data31_->in_group;
#line 2067 "../src/WindowManager.vala"
	_tmp229_ = _data31_->out_group;
#line 2067 "../src/WindowManager.vala"
	clutter_actor_set_height (_tmp229_, _tmp226_);
#line 2067 "../src/WindowManager.vala"
	clutter_actor_set_height (_tmp228_, _tmp226_);
#line 2069 "../src/WindowManager.vala"
	_data31_->animation_mode = CLUTTER_EASE_OUT_CUBIC;
#line 2071 "../src/WindowManager.vala"
	on_animation_update = ___lambda162__gala_gesture_tracker_on_update;
#line 2071 "../src/WindowManager.vala"
	on_animation_update_target = block31_data_ref (_data31_);
#line 2071 "../src/WindowManager.vala"
	on_animation_update_target_destroy_notify = block31_data_unref;
#line 2082 "../src/WindowManager.vala"
	on_animation_end = ___lambda163__gala_gesture_tracker_on_end;
#line 2082 "../src/WindowManager.vala"
	on_animation_end_target = block31_data_ref (_data31_);
#line 2082 "../src/WindowManager.vala"
	on_animation_end_target_destroy_notify = block31_data_unref;
#line 2126 "../src/WindowManager.vala"
	if (!self->priv->switch_workspace_with_gesture) {
#line 13448 "WindowManager.c"
		GalaGestureTrackerOnEnd _tmp230_;
		gpointer _tmp230__target;
#line 2127 "../src/WindowManager.vala"
		_tmp230_ = on_animation_end;
#line 2127 "../src/WindowManager.vala"
		_tmp230__target = on_animation_end_target;
#line 2127 "../src/WindowManager.vala"
		_tmp230_ ((gdouble) 1, FALSE, (gint) GALA_ANIMATION_DURATION_WORKSPACE_SWITCH_MIN, _tmp230__target);
#line 13457 "WindowManager.c"
	} else {
		GalaGestureTracker* _tmp231_;
		GalaGestureTrackerOnUpdate _tmp232_;
		gpointer _tmp232__target;
		GDestroyNotify _tmp232__target_destroy_notify;
		GalaGestureTrackerOnEnd _tmp233_;
		gpointer _tmp233__target;
		GDestroyNotify _tmp233__target_destroy_notify;
#line 2129 "../src/WindowManager.vala"
		_tmp231_ = self->priv->gesture_tracker;
#line 2129 "../src/WindowManager.vala"
		_tmp232_ = on_animation_update;
#line 2129 "../src/WindowManager.vala"
		_tmp232__target = on_animation_update_target;
#line 2129 "../src/WindowManager.vala"
		_tmp232__target_destroy_notify = on_animation_update_target_destroy_notify;
#line 2129 "../src/WindowManager.vala"
		on_animation_update = NULL;
#line 2129 "../src/WindowManager.vala"
		on_animation_update_target = NULL;
#line 2129 "../src/WindowManager.vala"
		on_animation_update_target_destroy_notify = NULL;
#line 2129 "../src/WindowManager.vala"
		_tmp233_ = on_animation_end;
#line 2129 "../src/WindowManager.vala"
		_tmp233__target = on_animation_end_target;
#line 2129 "../src/WindowManager.vala"
		_tmp233__target_destroy_notify = on_animation_end_target_destroy_notify;
#line 2129 "../src/WindowManager.vala"
		on_animation_end = NULL;
#line 2129 "../src/WindowManager.vala"
		on_animation_end_target = NULL;
#line 2129 "../src/WindowManager.vala"
		on_animation_end_target_destroy_notify = NULL;
#line 2129 "../src/WindowManager.vala"
		gala_gesture_tracker_connect_handlers (_tmp231_, NULL, NULL, NULL, _tmp232_, _tmp232__target, _tmp232__target_destroy_notify, _tmp233_, _tmp233__target, _tmp233__target_destroy_notify);
#line 13494 "WindowManager.c"
	}
#line 1862 "../src/WindowManager.vala"
	(on_animation_end_target_destroy_notify == NULL) ? NULL : (on_animation_end_target_destroy_notify (on_animation_end_target), NULL);
#line 1862 "../src/WindowManager.vala"
	on_animation_end = NULL;
#line 1862 "../src/WindowManager.vala"
	on_animation_end_target = NULL;
#line 1862 "../src/WindowManager.vala"
	on_animation_end_target_destroy_notify = NULL;
#line 1862 "../src/WindowManager.vala"
	(on_animation_update_target_destroy_notify == NULL) ? NULL : (on_animation_update_target_destroy_notify (on_animation_update_target), NULL);
#line 1862 "../src/WindowManager.vala"
	on_animation_update = NULL;
#line 1862 "../src/WindowManager.vala"
	on_animation_update_target = NULL;
#line 1862 "../src/WindowManager.vala"
	on_animation_update_target_destroy_notify = NULL;
#line 1862 "../src/WindowManager.vala"
	(docks == NULL) ? NULL : (docks = (_g_list_free__g_object_unref0_ (docks), NULL));
#line 1862 "../src/WindowManager.vala"
	_g_object_unref0 (static_windows);
#line 1862 "../src/WindowManager.vala"
	_g_object_unref0 (background_actor);
#line 1862 "../src/WindowManager.vala"
	_g_object_unref0 (main_container);
#line 1862 "../src/WindowManager.vala"
	block31_data_unref (_data31_);
#line 1862 "../src/WindowManager.vala"
	_data31_ = NULL;
#line 13524 "WindowManager.c"
}

static void
gala_window_manager_gala_switch_workspace_animation_finished (GalaWindowManagerGala* self,
                                                              MetaMotionDirection animation_direction,
                                                              gboolean cancel_action)
{
#line 2133 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 2135 "../src/WindowManager.vala"
	if (self->priv->switch_workspace_window_created_id > ((gulong) 0)) {
#line 2136 "../src/WindowManager.vala"
		g_signal_handler_disconnect ((GObject*) self, self->priv->switch_workspace_window_created_id);
#line 2137 "../src/WindowManager.vala"
		self->priv->switch_workspace_window_created_id = (gulong) 0;
#line 13540 "WindowManager.c"
	}
#line 2139 "../src/WindowManager.vala"
	gala_window_manager_gala_end_switch_workspace (self);
#line 2140 "../src/WindowManager.vala"
	self->priv->animating_switch_workspace = cancel_action;
#line 2142 "../src/WindowManager.vala"
	if (cancel_action) {
#line 13548 "WindowManager.c"
		MetaMotionDirection _tmp0_ = 0;
		MetaMotionDirection cancel_direction = 0;
		MetaDisplay* display = NULL;
		MetaDisplay* _tmp1_;
		MetaWorkspace* active_workspace = NULL;
		MetaDisplay* _tmp2_;
		MetaWorkspaceManager* _tmp3_;
		MetaWorkspace* _tmp4_;
		MetaWorkspace* neighbor = NULL;
		MetaWorkspace* _tmp5_;
		MetaWorkspace* _tmp6_;
		MetaWorkspace* _tmp7_;
		MetaDisplay* _tmp8_;
#line 2143 "../src/WindowManager.vala"
		if (animation_direction == META_MOTION_LEFT) {
#line 2144 "../src/WindowManager.vala"
			_tmp0_ = META_MOTION_RIGHT;
#line 13566 "WindowManager.c"
		} else {
#line 2145 "../src/WindowManager.vala"
			_tmp0_ = META_MOTION_LEFT;
#line 13570 "WindowManager.c"
		}
#line 2143 "../src/WindowManager.vala"
		cancel_direction = _tmp0_;
#line 2146 "../src/WindowManager.vala"
		_tmp1_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 2146 "../src/WindowManager.vala"
		display = _tmp1_;
#line 2147 "../src/WindowManager.vala"
		_tmp2_ = display;
#line 2147 "../src/WindowManager.vala"
		_tmp3_ = meta_display_get_workspace_manager (_tmp2_);
#line 2147 "../src/WindowManager.vala"
		_tmp4_ = meta_workspace_manager_get_active_workspace (_tmp3_);
#line 2147 "../src/WindowManager.vala"
		active_workspace = _tmp4_;
#line 2148 "../src/WindowManager.vala"
		_tmp5_ = active_workspace;
#line 2148 "../src/WindowManager.vala"
		_tmp6_ = meta_workspace_get_neighbor (_tmp5_, cancel_direction);
#line 2148 "../src/WindowManager.vala"
		neighbor = _tmp6_;
#line 2149 "../src/WindowManager.vala"
		_tmp7_ = neighbor;
#line 2149 "../src/WindowManager.vala"
		_tmp8_ = display;
#line 2149 "../src/WindowManager.vala"
		meta_workspace_activate (_tmp7_, meta_display_get_current_time (_tmp8_));
#line 13598 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_end_switch_workspace (GalaWindowManagerGala* self)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp3_;
	MetaWorkspace* active_workspace = NULL;
	MetaDisplay* _tmp4_;
	MetaWorkspaceManager* _tmp5_;
	MetaWorkspace* _tmp6_;
	gint primary = 0;
	MetaDisplay* _tmp7_;
	gboolean move_primary_only = FALSE;
	GList* _tmp47_;
#line 2153 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 2154 "../src/WindowManager.vala"
	_tmp1_ = self->priv->windows;
#line 2154 "../src/WindowManager.vala"
	if (_tmp1_ == NULL) {
#line 2154 "../src/WindowManager.vala"
		_tmp0_ = TRUE;
#line 13625 "WindowManager.c"
	} else {
		GList* _tmp2_;
#line 2154 "../src/WindowManager.vala"
		_tmp2_ = self->priv->parents;
#line 2154 "../src/WindowManager.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 13632 "WindowManager.c"
	}
#line 2154 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 2155 "../src/WindowManager.vala"
		return;
#line 13638 "WindowManager.c"
	}
#line 2157 "../src/WindowManager.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 2157 "../src/WindowManager.vala"
	display = _tmp3_;
#line 2158 "../src/WindowManager.vala"
	_tmp4_ = display;
#line 2158 "../src/WindowManager.vala"
	_tmp5_ = meta_display_get_workspace_manager (_tmp4_);
#line 2158 "../src/WindowManager.vala"
	_tmp6_ = meta_workspace_manager_get_active_workspace (_tmp5_);
#line 2158 "../src/WindowManager.vala"
	active_workspace = _tmp6_;
#line 2161 "../src/WindowManager.vala"
	_tmp7_ = display;
#line 2161 "../src/WindowManager.vala"
	primary = meta_display_get_primary_monitor (_tmp7_);
#line 2162 "../src/WindowManager.vala"
	move_primary_only = gala_internal_utils_workspaces_only_on_primary ();
#line 2163 "../src/WindowManager.vala"
	if (move_primary_only) {
#line 13660 "WindowManager.c"
		ClutterActor* background = NULL;
		MetaBackgroundGroup* _tmp8_;
		MetaBackgroundGroup* _tmp9_;
		ClutterActor* _tmp10_;
		ClutterActor* _tmp11_;
#line 2164 "../src/WindowManager.vala"
		_tmp8_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 2164 "../src/WindowManager.vala"
		_tmp9_ = _tmp8_;
#line 2164 "../src/WindowManager.vala"
		_tmp10_ = clutter_actor_get_child_at_index ((ClutterActor*) _tmp9_, primary);
#line 2164 "../src/WindowManager.vala"
		background = _tmp10_;
#line 2165 "../src/WindowManager.vala"
		_tmp11_ = background;
#line 2165 "../src/WindowManager.vala"
		clutter_actor_show (_tmp11_);
#line 13678 "WindowManager.c"
	} else {
		MetaBackgroundGroup* _tmp12_;
		MetaBackgroundGroup* _tmp13_;
#line 2167 "../src/WindowManager.vala"
		_tmp12_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 2167 "../src/WindowManager.vala"
		_tmp13_ = _tmp12_;
#line 2167 "../src/WindowManager.vala"
		clutter_actor_show ((ClutterActor*) _tmp13_);
#line 13688 "WindowManager.c"
	}
	{
		gint i = 0;
#line 2170 "../src/WindowManager.vala"
		i = 0;
#line 13694 "WindowManager.c"
		{
			gboolean _tmp14_ = FALSE;
#line 2170 "../src/WindowManager.vala"
			_tmp14_ = TRUE;
#line 2170 "../src/WindowManager.vala"
			while (TRUE) {
#line 13701 "WindowManager.c"
				GList* _tmp16_;
				ClutterActor* actor = NULL;
				GList* _tmp17_;
				gconstpointer _tmp18_;
				ClutterActor* _tmp19_;
				MetaWindowActor* window = NULL;
				ClutterActor* _tmp20_;
				MetaWindowActor* _tmp21_;
				MetaWindow* meta_window = NULL;
				MetaWindowActor* _tmp25_;
				MetaWindow* _tmp26_;
				MetaWindowActor* _tmp27_;
				MetaWindowActor* _tmp31_;
				gboolean _tmp32_ = FALSE;
				gboolean _tmp33_ = FALSE;
				MetaWindow* _tmp34_;
				ClutterActor* _tmp40_;
				guint _tmp41_;
				guint _tmp42_;
#line 2170 "../src/WindowManager.vala"
				if (!_tmp14_) {
#line 13723 "WindowManager.c"
					gint _tmp15_;
#line 2170 "../src/WindowManager.vala"
					_tmp15_ = i;
#line 2170 "../src/WindowManager.vala"
					i = _tmp15_ + 1;
#line 13729 "WindowManager.c"
				}
#line 2170 "../src/WindowManager.vala"
				_tmp14_ = FALSE;
#line 2170 "../src/WindowManager.vala"
				_tmp16_ = self->priv->windows;
#line 2170 "../src/WindowManager.vala"
				if (!(((guint) i) < g_list_length (_tmp16_))) {
#line 2170 "../src/WindowManager.vala"
					break;
#line 13739 "WindowManager.c"
				}
#line 2171 "../src/WindowManager.vala"
				_tmp17_ = self->priv->windows;
#line 2171 "../src/WindowManager.vala"
				_tmp18_ = g_list_nth_data (_tmp17_, (guint) i);
#line 2171 "../src/WindowManager.vala"
				actor = (ClutterActor*) _tmp18_;
#line 2172 "../src/WindowManager.vala"
				_tmp19_ = actor;
#line 2172 "../src/WindowManager.vala"
				clutter_actor_set_translation (_tmp19_, 0.0f, 0.0f, 0.0f);
#line 2174 "../src/WindowManager.vala"
				_tmp20_ = actor;
#line 2174 "../src/WindowManager.vala"
				window = G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, meta_window_actor_get_type ()) ? ((MetaWindowActor*) _tmp20_) : NULL;
#line 2175 "../src/WindowManager.vala"
				_tmp21_ = window;
#line 2175 "../src/WindowManager.vala"
				if (_tmp21_ == NULL) {
#line 13759 "WindowManager.c"
					ClutterActor* _tmp22_;
					GList* _tmp23_;
					gconstpointer _tmp24_;
#line 2176 "../src/WindowManager.vala"
					_tmp22_ = actor;
#line 2176 "../src/WindowManager.vala"
					_tmp23_ = self->priv->parents;
#line 2176 "../src/WindowManager.vala"
					_tmp24_ = g_list_nth_data (_tmp23_, (guint) i);
#line 2176 "../src/WindowManager.vala"
					gala_window_manager_gala_clutter_actor_reparent (_tmp22_, (ClutterActor*) _tmp24_);
#line 2177 "../src/WindowManager.vala"
					continue;
#line 13773 "WindowManager.c"
				}
#line 2180 "../src/WindowManager.vala"
				_tmp25_ = window;
#line 2180 "../src/WindowManager.vala"
				_tmp26_ = meta_window_actor_get_meta_window (_tmp25_);
#line 2180 "../src/WindowManager.vala"
				meta_window = _tmp26_;
#line 2181 "../src/WindowManager.vala"
				_tmp27_ = window;
#line 2181 "../src/WindowManager.vala"
				if (!meta_window_actor_is_destroyed (_tmp27_)) {
#line 13785 "WindowManager.c"
					ClutterActor* _tmp28_;
					GList* _tmp29_;
					gconstpointer _tmp30_;
#line 2182 "../src/WindowManager.vala"
					_tmp28_ = actor;
#line 2182 "../src/WindowManager.vala"
					_tmp29_ = self->priv->parents;
#line 2182 "../src/WindowManager.vala"
					_tmp30_ = g_list_nth_data (_tmp29_, (guint) i);
#line 2182 "../src/WindowManager.vala"
					gala_window_manager_gala_clutter_actor_reparent (_tmp28_, (ClutterActor*) _tmp30_);
#line 13797 "WindowManager.c"
				}
#line 2185 "../src/WindowManager.vala"
				_tmp31_ = window;
#line 2185 "../src/WindowManager.vala"
				G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->kill_window_effects ((MetaPlugin*) self, _tmp31_);
#line 2187 "../src/WindowManager.vala"
				_tmp34_ = meta_window;
#line 2187 "../src/WindowManager.vala"
				if (_tmp34_ != NULL) {
#line 13807 "WindowManager.c"
					MetaWindow* _tmp35_;
					MetaWorkspace* _tmp36_;
					MetaWorkspace* _tmp37_;
#line 2188 "../src/WindowManager.vala"
					_tmp35_ = meta_window;
#line 2188 "../src/WindowManager.vala"
					_tmp36_ = meta_window_get_workspace (_tmp35_);
#line 2188 "../src/WindowManager.vala"
					_tmp37_ = active_workspace;
#line 2188 "../src/WindowManager.vala"
					_tmp33_ = _tmp36_ != _tmp37_;
#line 13819 "WindowManager.c"
				} else {
#line 2187 "../src/WindowManager.vala"
					_tmp33_ = FALSE;
#line 13823 "WindowManager.c"
				}
#line 2187 "../src/WindowManager.vala"
				if (_tmp33_) {
#line 13827 "WindowManager.c"
					MetaWindow* _tmp38_;
#line 2189 "../src/WindowManager.vala"
					_tmp38_ = meta_window;
#line 2189 "../src/WindowManager.vala"
					_tmp32_ = !meta_window_is_on_all_workspaces (_tmp38_);
#line 13833 "WindowManager.c"
				} else {
#line 2187 "../src/WindowManager.vala"
					_tmp32_ = FALSE;
#line 13837 "WindowManager.c"
				}
#line 2187 "../src/WindowManager.vala"
				if (_tmp32_) {
#line 13841 "WindowManager.c"
					MetaWindowActor* _tmp39_;
#line 2190 "../src/WindowManager.vala"
					_tmp39_ = window;
#line 2190 "../src/WindowManager.vala"
					clutter_actor_hide ((ClutterActor*) _tmp39_);
#line 13847 "WindowManager.c"
				}
#line 2193 "../src/WindowManager.vala"
				_tmp40_ = actor;
#line 2193 "../src/WindowManager.vala"
				_tmp41_ = clutter_actor_get_opacity (_tmp40_);
#line 2193 "../src/WindowManager.vala"
				_tmp42_ = _tmp41_;
#line 2193 "../src/WindowManager.vala"
				if (_tmp42_ < 255U) {
#line 13857 "WindowManager.c"
					ClutterActor* _tmp43_;
					ClutterActor* _tmp44_;
					ClutterActor* _tmp45_;
					ClutterActor* _tmp46_;
#line 2194 "../src/WindowManager.vala"
					_tmp43_ = actor;
#line 2194 "../src/WindowManager.vala"
					clutter_actor_save_easing_state (_tmp43_);
#line 2195 "../src/WindowManager.vala"
					_tmp44_ = actor;
#line 2195 "../src/WindowManager.vala"
					clutter_actor_set_easing_duration (_tmp44_, (guint) 300);
#line 2196 "../src/WindowManager.vala"
					_tmp45_ = actor;
#line 2196 "../src/WindowManager.vala"
					clutter_actor_set_opacity (_tmp45_, 255U);
#line 2197 "../src/WindowManager.vala"
					_tmp46_ = actor;
#line 2197 "../src/WindowManager.vala"
					clutter_actor_restore_easing_state (_tmp46_);
#line 13878 "WindowManager.c"
				}
			}
		}
	}
#line 2201 "../src/WindowManager.vala"
	_tmp47_ = self->priv->tmp_actors;
#line 2201 "../src/WindowManager.vala"
	if (_tmp47_ != NULL) {
#line 13887 "WindowManager.c"
		GList* _tmp48_;
#line 2202 "../src/WindowManager.vala"
		_tmp48_ = self->priv->tmp_actors;
#line 13891 "WindowManager.c"
		{
			GList* actor_collection = NULL;
			GList* actor_it = NULL;
#line 2202 "../src/WindowManager.vala"
			actor_collection = _tmp48_;
#line 2202 "../src/WindowManager.vala"
			for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 13899 "WindowManager.c"
				ClutterActor* _tmp49_;
				ClutterActor* actor = NULL;
#line 2202 "../src/WindowManager.vala"
				_tmp49_ = _g_object_ref0 ((ClutterActor*) actor_it->data);
#line 2202 "../src/WindowManager.vala"
				actor = _tmp49_;
#line 13906 "WindowManager.c"
				{
					ClutterActor* _tmp50_;
#line 2203 "../src/WindowManager.vala"
					_tmp50_ = actor;
#line 2203 "../src/WindowManager.vala"
					clutter_actor_destroy (_tmp50_);
#line 2202 "../src/WindowManager.vala"
					_g_object_unref0 (actor);
#line 13915 "WindowManager.c"
				}
			}
		}
#line 2205 "../src/WindowManager.vala"
		(self->priv->tmp_actors == NULL) ? NULL : (self->priv->tmp_actors = (_g_list_free__g_object_unref0_ (self->priv->tmp_actors), NULL));
#line 2205 "../src/WindowManager.vala"
		self->priv->tmp_actors = NULL;
#line 13923 "WindowManager.c"
	}
#line 2208 "../src/WindowManager.vala"
	(self->priv->windows == NULL) ? NULL : (self->priv->windows = (_g_list_free__g_object_unref0_ (self->priv->windows), NULL));
#line 2208 "../src/WindowManager.vala"
	self->priv->windows = NULL;
#line 2209 "../src/WindowManager.vala"
	(self->priv->parents == NULL) ? NULL : (self->priv->parents = (_g_list_free__g_object_unref0_ (self->priv->parents), NULL));
#line 2209 "../src/WindowManager.vala"
	self->priv->parents = NULL;
#line 2210 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->moving);
#line 2210 "../src/WindowManager.vala"
	self->priv->moving = NULL;
#line 2212 "../src/WindowManager.vala"
	self->priv->switch_workspace_with_gesture = FALSE;
#line 2213 "../src/WindowManager.vala"
	self->priv->animating_switch_workspace = FALSE;
#line 2215 "../src/WindowManager.vala"
	meta_plugin_switch_workspace_completed ((MetaPlugin*) self);
#line 13943 "WindowManager.c"
}

static void
gala_window_manager_gala_real_kill_switch_workspace (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
#line 2218 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 2219 "../src/WindowManager.vala"
	gala_window_manager_gala_end_switch_workspace (self);
#line 13954 "WindowManager.c"
}

static void
gala_window_manager_gala_real_locate_pointer (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	GalaPointerLocator* _tmp0_;
#line 2222 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 2223 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_pointer_locator;
#line 2223 "../src/WindowManager.vala"
	gala_pointer_locator_show_ripple (_tmp0_);
#line 13968 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_real_keybinding_filter (MetaPlugin* base,
                                                 MetaKeyBinding* binding)
{
	GalaWindowManagerGala * self;
	GalaModalProxy* modal_proxy = NULL;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	GalaModalProxy* _tmp2_;
	GalaKeybindingFilter filter = NULL;
	GalaModalProxy* _tmp3_;
	gpointer _tmp4_ = NULL;
	GalaKeybindingFilter _tmp5_;
	gpointer filter_target;
	GalaKeybindingFilter _tmp6_;
	gpointer _tmp6__target;
	GalaKeybindingFilter _tmp7_;
	gpointer _tmp7__target;
	gboolean result;
#line 2226 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 2226 "../src/WindowManager.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 2227 "../src/WindowManager.vala"
	if (!gala_window_manager_is_modal ((GalaWindowManager*) self)) {
#line 2228 "../src/WindowManager.vala"
		result = FALSE;
#line 2228 "../src/WindowManager.vala"
		return result;
#line 14000 "WindowManager.c"
	}
#line 2230 "../src/WindowManager.vala"
	_tmp0_ = self->priv->modal_stack;
#line 2230 "../src/WindowManager.vala"
	_tmp1_ = gee_deque_peek_head ((GeeDeque*) _tmp0_);
#line 2230 "../src/WindowManager.vala"
	modal_proxy = (GalaModalProxy*) _tmp1_;
#line 2231 "../src/WindowManager.vala"
	_tmp2_ = modal_proxy;
#line 2231 "../src/WindowManager.vala"
	if (_tmp2_ == NULL) {
#line 2232 "../src/WindowManager.vala"
		result = FALSE;
#line 2232 "../src/WindowManager.vala"
		_g_object_unref0 (modal_proxy);
#line 2232 "../src/WindowManager.vala"
		return result;
#line 14018 "WindowManager.c"
	}
#line 2235 "../src/WindowManager.vala"
	_tmp3_ = modal_proxy;
#line 2235 "../src/WindowManager.vala"
	_tmp5_ = gala_modal_proxy_get_keybinding_filter (_tmp3_, &_tmp4_);
#line 2235 "../src/WindowManager.vala"
	filter = _tmp5_;
#line 2235 "../src/WindowManager.vala"
	filter_target = _tmp4_;
#line 2236 "../src/WindowManager.vala"
	_tmp6_ = filter;
#line 2236 "../src/WindowManager.vala"
	_tmp6__target = filter_target;
#line 2236 "../src/WindowManager.vala"
	if (_tmp6_ == NULL) {
#line 2237 "../src/WindowManager.vala"
		result = FALSE;
#line 2237 "../src/WindowManager.vala"
		_g_object_unref0 (modal_proxy);
#line 2237 "../src/WindowManager.vala"
		return result;
#line 14040 "WindowManager.c"
	}
#line 2240 "../src/WindowManager.vala"
	_tmp7_ = filter;
#line 2240 "../src/WindowManager.vala"
	_tmp7__target = filter_target;
#line 2240 "../src/WindowManager.vala"
	result = _tmp7_ (binding, _tmp7__target);
#line 2240 "../src/WindowManager.vala"
	_g_object_unref0 (modal_proxy);
#line 2240 "../src/WindowManager.vala"
	return result;
#line 14052 "WindowManager.c"
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
#line 2243 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data33_->_ref_count_);
#line 2243 "../src/WindowManager.vala"
	return _data33_;
#line 14062 "WindowManager.c"
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
#line 2243 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
#line 14072 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 2243 "../src/WindowManager.vala"
		self = _data33_->self;
#line 2243 "../src/WindowManager.vala"
		_g_object_unref0 (_data33_->dialog);
#line 2243 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 2243 "../src/WindowManager.vala"
		g_slice_free (Block33Data, _data33_);
#line 14082 "WindowManager.c"
	}
}

static gboolean
__lambda166_ (Block33Data* _data33_)
{
	GalaWindowManagerGala* self;
	gboolean result;
#line 2267 "../src/WindowManager.vala"
	self = _data33_->self;
#line 2268 "../src/WindowManager.vala"
	_data33_->dialog_timeout_id = (guint) 0;
#line 2269 "../src/WindowManager.vala"
	gala_access_dialog_close (_data33_->dialog);
#line 2271 "../src/WindowManager.vala"
	result = G_SOURCE_REMOVE;
#line 2271 "../src/WindowManager.vala"
	return result;
#line 14101 "WindowManager.c"
}

static gboolean
___lambda166__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda166_ (self);
#line 2267 "../src/WindowManager.vala"
	return result;
#line 14111 "WindowManager.c"
}

static void
__lambda165_ (Block33Data* _data33_)
{
	GalaWindowManagerGala* self;
#line 2266 "../src/WindowManager.vala"
	self = _data33_->self;
#line 2267 "../src/WindowManager.vala"
	_data33_->dialog_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) _data33_->timeout, ___lambda166__gsource_func, block33_data_ref (_data33_), block33_data_unref);
#line 14122 "WindowManager.c"
}

static void
___lambda165__gala_access_dialog_show (GalaAccessDialog* _sender,
                                       gpointer self)
{
#line 2266 "../src/WindowManager.vala"
	__lambda165_ (self);
#line 14131 "WindowManager.c"
}

static void
__lambda167_ (Block33Data* _data33_,
              guint res)
{
	GalaWindowManagerGala* self;
#line 2275 "../src/WindowManager.vala"
	self = _data33_->self;
#line 2276 "../src/WindowManager.vala"
	if (_data33_->dialog_timeout_id != ((guint) 0)) {
#line 2277 "../src/WindowManager.vala"
		g_source_remove (_data33_->dialog_timeout_id);
#line 2278 "../src/WindowManager.vala"
		_data33_->dialog_timeout_id = (guint) 0;
#line 14147 "WindowManager.c"
	}
#line 2281 "../src/WindowManager.vala"
	meta_plugin_complete_display_change ((MetaPlugin*) self, res == ((guint) 0));
#line 14151 "WindowManager.c"
}

static void
___lambda167__gala_access_dialog_response (GalaAccessDialog* _sender,
                                           guint response,
                                           gpointer self)
{
#line 2275 "../src/WindowManager.vala"
	__lambda167_ (self, response);
#line 14161 "WindowManager.c"
}

static void
gala_window_manager_gala_real_confirm_display_change (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	Block33Data* _data33_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaDisplay* _tmp0_;
	MetaContext* _tmp1_;
	MetaBackend* _tmp2_;
	MetaMonitorManager* _tmp3_;
	gchar* summary = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GalaAccessDialog* _tmp9_ = NULL;
	GalaAccessDialog* _tmp10_;
#line 2243 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 2243 "../src/WindowManager.vala"
	_data33_ = g_slice_new0 (Block33Data);
#line 2243 "../src/WindowManager.vala"
	_data33_->_ref_count_ = 1;
#line 2243 "../src/WindowManager.vala"
	_data33_->self = g_object_ref (self);
#line 2245 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 2245 "../src/WindowManager.vala"
	_tmp1_ = meta_display_get_context (_tmp0_);
#line 2245 "../src/WindowManager.vala"
	_tmp2_ = meta_context_get_backend (_tmp1_);
#line 2245 "../src/WindowManager.vala"
	_tmp3_ = meta_backend_get_monitor_manager (_tmp2_);
#line 2245 "../src/WindowManager.vala"
	monitor_manager = _tmp3_;
#line 2246 "../src/WindowManager.vala"
	_data33_->timeout = meta_monitor_manager_get_display_configuration_timeout (monitor_manager);
#line 2250 "../src/WindowManager.vala"
	_tmp4_ = g_strdup (ngettext ("Changes will automatically revert after %i second.", "Changes will automatically revert after %i seconds.", (gulong) _data33_->timeout));
#line 2250 "../src/WindowManager.vala"
	summary = _tmp4_;
#line 2255 "../src/WindowManager.vala"
	_data33_->dialog_timeout_id = (guint) 0;
#line 2257 "../src/WindowManager.vala"
	_tmp5_ = g_strdup_printf (summary, _data33_->timeout);
#line 2257 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 2257 "../src/WindowManager.vala"
	_tmp7_ = g_strdup (_ ("Keep Settings"));
#line 2257 "../src/WindowManager.vala"
	_tmp8_ = g_strdup (_ ("Use Previous Settings"));
#line 2257 "../src/WindowManager.vala"
	_tmp9_ = gala_access_dialog_new (_ ("Keep new display settings?"), _tmp6_, "preferences-desktop-display");
#line 2257 "../src/WindowManager.vala"
	gala_access_dialog_set_accept_label (_tmp9_, _tmp7_);
#line 2257 "../src/WindowManager.vala"
	_g_free0 (_tmp7_);
#line 2257 "../src/WindowManager.vala"
	gala_access_dialog_set_deny_label (_tmp9_, _tmp8_);
#line 2257 "../src/WindowManager.vala"
	_g_free0 (_tmp8_);
#line 2257 "../src/WindowManager.vala"
	_tmp10_ = _tmp9_;
#line 2257 "../src/WindowManager.vala"
	_g_free0 (_tmp6_);
#line 2257 "../src/WindowManager.vala"
	_data33_->dialog = _tmp10_;
#line 2266 "../src/WindowManager.vala"
	g_signal_connect_data (_data33_->dialog, "show", (GCallback) ___lambda165__gala_access_dialog_show, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
#line 2275 "../src/WindowManager.vala"
	g_signal_connect_data (_data33_->dialog, "response", (GCallback) ___lambda167__gala_access_dialog_response, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
#line 2284 "../src/WindowManager.vala"
	g_signal_emit_by_name (_data33_->dialog, "show");
#line 2243 "../src/WindowManager.vala"
	_g_free0 (summary);
#line 2243 "../src/WindowManager.vala"
	block33_data_unref (_data33_);
#line 2243 "../src/WindowManager.vala"
	_data33_ = NULL;
#line 14244 "WindowManager.c"
}

static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
#line 2287 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data34_->_ref_count_);
#line 2287 "../src/WindowManager.vala"
	return _data34_;
#line 14254 "WindowManager.c"
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
#line 2287 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
#line 14264 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 2287 "../src/WindowManager.vala"
		self = _data34_->self;
#line 2287 "../src/WindowManager.vala"
		_g_object_unref0 (_data34_->window);
#line 2287 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 2287 "../src/WindowManager.vala"
		g_slice_free (Block34Data, _data34_);
#line 14274 "WindowManager.c"
	}
}

static gboolean
__lambda168_ (Block34Data* _data34_,
              GalaCloseDialog* d)
{
	GalaWindowManagerGala* self;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 2288 "../src/WindowManager.vala"
	self = _data34_->self;
#line 2288 "../src/WindowManager.vala"
	g_return_val_if_fail (d != NULL, FALSE);
#line 2288 "../src/WindowManager.vala"
	g_object_get ((MetaCloseDialog*) d, "window", &_tmp0_, NULL);
#line 2288 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 2288 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 2288 "../src/WindowManager.vala"
	_tmp3_ = _tmp2_ == _data34_->window;
#line 2288 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp2_);
#line 2288 "../src/WindowManager.vala"
	result = _tmp3_;
#line 2288 "../src/WindowManager.vala"
	return result;
#line 14306 "WindowManager.c"
}

static gboolean
___lambda168__gee_predicate (gconstpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda168_ (self, (GalaCloseDialog*) g);
#line 2288 "../src/WindowManager.vala"
	return result;
#line 14317 "WindowManager.c"
}

static MetaCloseDialog*
gala_window_manager_gala_real_create_close_dialog (MetaPlugin* base,
                                                   MetaWindow* window)
{
	GalaWindowManagerGala * self;
	Block34Data* _data34_;
	MetaWindow* _tmp0_;
	GalaCloseDialog* new_dialog = NULL;
	GeeSet* _tmp1_;
	gpointer _tmp2_;
	GalaCloseDialog* _tmp3_;
	GalaCloseDialog* dialog = NULL;
	GalaCloseDialog* _tmp5_;
	MetaCloseDialog* result;
#line 2287 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 2287 "../src/WindowManager.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 2287 "../src/WindowManager.vala"
	_data34_ = g_slice_new0 (Block34Data);
#line 2287 "../src/WindowManager.vala"
	_data34_->_ref_count_ = 1;
#line 2287 "../src/WindowManager.vala"
	_data34_->self = g_object_ref (self);
#line 2287 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 2287 "../src/WindowManager.vala"
	_g_object_unref0 (_data34_->window);
#line 2287 "../src/WindowManager.vala"
	_data34_->window = _tmp0_;
#line 2288 "../src/WindowManager.vala"
	_tmp1_ = gala_close_dialog_open_dialogs;
#line 2288 "../src/WindowManager.vala"
	_tmp2_ = gee_traversable_first_match ((GeeTraversable*) _tmp1_, ___lambda168__gee_predicate, block34_data_ref (_data34_), block34_data_unref);
#line 2288 "../src/WindowManager.vala"
	new_dialog = (GalaCloseDialog*) _tmp2_;
#line 2290 "../src/WindowManager.vala"
	_tmp3_ = new_dialog;
#line 2290 "../src/WindowManager.vala"
	if (_tmp3_ == NULL) {
#line 14360 "WindowManager.c"
		GalaCloseDialog* _tmp4_;
#line 2291 "../src/WindowManager.vala"
		_tmp4_ = gala_close_dialog_new (_data34_->window);
#line 2291 "../src/WindowManager.vala"
		_g_object_unref0 (new_dialog);
#line 2291 "../src/WindowManager.vala"
		new_dialog = _tmp4_;
#line 14368 "WindowManager.c"
	}
#line 2294 "../src/WindowManager.vala"
	_tmp5_ = new_dialog;
#line 2294 "../src/WindowManager.vala"
	dialog = _tmp5_;
#line 2295 "../src/WindowManager.vala"
	result = (MetaCloseDialog*) dialog;
#line 2295 "../src/WindowManager.vala"
	_g_object_unref0 (new_dialog);
#line 2295 "../src/WindowManager.vala"
	block34_data_unref (_data34_);
#line 2295 "../src/WindowManager.vala"
	_data34_ = NULL;
#line 2295 "../src/WindowManager.vala"
	return result;
#line 14384 "WindowManager.c"
}

static MetaPluginInfo*
gala_window_manager_gala_real_plugin_info (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	MetaPluginInfo _tmp0_;
	MetaPluginInfo* result;
#line 2298 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 2299 "../src/WindowManager.vala"
	_tmp0_ = self->priv->info;
#line 2299 "../src/WindowManager.vala"
	result = &_tmp0_;
#line 2299 "../src/WindowManager.vala"
	return result;
#line 14401 "WindowManager.c"
}

static gchar*
gala_window_manager_gala_generate_screenshot_filename (GalaWindowManagerGala* self)
{
	gchar* date_time = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 2302 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2303 "../src/WindowManager.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 2303 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 2303 "../src/WindowManager.vala"
	_tmp2_ = g_date_time_format (_tmp1_, "%Y-%m-%d %H.%M.%S");
#line 2303 "../src/WindowManager.vala"
	_tmp3_ = _tmp2_;
#line 2303 "../src/WindowManager.vala"
	_g_date_time_unref0 (_tmp1_);
#line 2303 "../src/WindowManager.vala"
	date_time = _tmp3_;
#line 2305 "../src/WindowManager.vala"
	_tmp4_ = g_strdup_printf (_ ("Screenshot from %s"), date_time);
#line 2305 "../src/WindowManager.vala"
	result = _tmp4_;
#line 2305 "../src/WindowManager.vala"
	_g_free0 (date_time);
#line 2305 "../src/WindowManager.vala"
	return result;
#line 14436 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_current_window_data_free (gpointer _data)
{
	GalaWindowManagerGalaScreenshotCurrentWindowData* _data_;
	_data_ = _data;
#line 28 "../src/WindowManager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/WindowManager.vala"
	g_slice_free (GalaWindowManagerGalaScreenshotCurrentWindowData, _data_);
#line 14448 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_current_window (GalaWindowManagerGala* self,
                                                    gboolean clipboard,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	GalaWindowManagerGalaScreenshotCurrentWindowData* _data_;
	GalaWindowManagerGala* _tmp0_;
#line 28 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/WindowManager.vala"
	_data_ = g_slice_new0 (GalaWindowManagerGalaScreenshotCurrentWindowData);
#line 28 "../src/WindowManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/WindowManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gala_window_manager_gala_screenshot_current_window_data_free);
#line 28 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/WindowManager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/WindowManager.vala"
	_data_->clipboard = clipboard;
#line 28 "../src/WindowManager.vala"
	gala_window_manager_gala_screenshot_current_window_co (_data_);
#line 14475 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_current_window_finish (GalaWindowManagerGala* self,
                                                           GAsyncResult* _res_)
{
	GalaWindowManagerGalaScreenshotCurrentWindowData* _data_;
#line 28 "../src/WindowManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 14485 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_current_window_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	GalaWindowManagerGalaScreenshotCurrentWindowData* _data_;
#line 2314 "../src/WindowManager.vala"
	_data_ = _user_data_;
#line 2314 "../src/WindowManager.vala"
	_data_->_source_object_ = source_object;
#line 2314 "../src/WindowManager.vala"
	_data_->_res_ = _res_;
#line 2314 "../src/WindowManager.vala"
	gala_window_manager_gala_screenshot_current_window_co (_data_);
#line 14502 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_screenshot_current_window_co (GalaWindowManagerGalaScreenshotCurrentWindowData* _data_)
{
#line 2308 "../src/WindowManager.vala"
	switch (_data_->_state_) {
#line 2308 "../src/WindowManager.vala"
		case 0:
#line 14512 "WindowManager.c"
		goto _state_0;
#line 2308 "../src/WindowManager.vala"
		case 1:
#line 14516 "WindowManager.c"
		goto _state_1;
		default:
#line 2308 "../src/WindowManager.vala"
		g_assert_not_reached ();
#line 14521 "WindowManager.c"
	}
	_state_0:
	{
#line 2310 "../src/WindowManager.vala"
		if (_data_->clipboard) {
#line 2310 "../src/WindowManager.vala"
			_data_->_tmp1_ = g_strdup ("");
#line 2310 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 2310 "../src/WindowManager.vala"
			_data_->_tmp0_ = _data_->_tmp1_;
#line 14533 "WindowManager.c"
		} else {
#line 2310 "../src/WindowManager.vala"
			_data_->_tmp2_ = gala_window_manager_gala_generate_screenshot_filename (_data_->self);
#line 2310 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 2310 "../src/WindowManager.vala"
			_data_->_tmp0_ = _data_->_tmp2_;
#line 14541 "WindowManager.c"
		}
#line 2310 "../src/WindowManager.vala"
		_data_->_tmp3_ = g_strdup (_data_->_tmp0_);
#line 2310 "../src/WindowManager.vala"
		_data_->filename = _data_->_tmp3_;
#line 2311 "../src/WindowManager.vala"
		_data_->success = FALSE;
#line 2312 "../src/WindowManager.vala"
		_data_->_tmp4_ = g_strdup ("");
#line 2312 "../src/WindowManager.vala"
		_data_->filename_used = _data_->_tmp4_;
#line 2313 "../src/WindowManager.vala"
		_data_->_tmp5_ = gala_screenshot_manager_init ((GalaWindowManager*) _data_->self);
#line 2313 "../src/WindowManager.vala"
		_data_->screenshot_manager = _data_->_tmp5_;
#line 2314 "../src/WindowManager.vala"
		_data_->_tmp6_ = FALSE;
#line 2314 "../src/WindowManager.vala"
		_data_->_tmp7_ = NULL;
#line 2314 "../src/WindowManager.vala"
		_data_->_state_ = 1;
#line 2314 "../src/WindowManager.vala"
		gala_screenshot_manager_screenshot_window (_data_->screenshot_manager, TRUE, FALSE, TRUE, _data_->filename, gala_window_manager_gala_screenshot_current_window_ready, _data_);
#line 2314 "../src/WindowManager.vala"
		return FALSE;
#line 14567 "WindowManager.c"
		_state_1:
#line 2314 "../src/WindowManager.vala"
		gala_screenshot_manager_screenshot_window_finish (_data_->screenshot_manager, _data_->_res_, &_data_->_tmp6_, &_data_->_tmp7_, &_data_->_inner_error0_);
#line 2314 "../src/WindowManager.vala"
		_data_->success = _data_->_tmp6_;
#line 2314 "../src/WindowManager.vala"
		_g_free0 (_data_->filename_used);
#line 2314 "../src/WindowManager.vala"
		_data_->filename_used = _data_->_tmp7_;
#line 2314 "../src/WindowManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2314 "../src/WindowManager.vala"
			_g_free0 (_data_->filename_used);
#line 2314 "../src/WindowManager.vala"
			_g_free0 (_data_->filename);
#line 2314 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 14585 "WindowManager.c"
			goto __catch0_g_error;
		}
#line 2309 "../src/WindowManager.vala"
		_g_free0 (_data_->filename_used);
#line 2309 "../src/WindowManager.vala"
		_g_free0 (_data_->filename);
#line 2309 "../src/WindowManager.vala"
		_g_free0 (_data_->_tmp0_);
#line 14594 "WindowManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 2309 "../src/WindowManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 14601 "WindowManager.c"
	}
	__finally0:
#line 2309 "../src/WindowManager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2309 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2309 "../src/WindowManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 2309 "../src/WindowManager.vala"
		g_object_unref (_data_->_async_result);
#line 2309 "../src/WindowManager.vala"
		return FALSE;
#line 14614 "WindowManager.c"
	}
#line 2308 "../src/WindowManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2308 "../src/WindowManager.vala"
	if (_data_->_state_ != 0) {
#line 2308 "../src/WindowManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2308 "../src/WindowManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 14624 "WindowManager.c"
		}
	}
#line 2308 "../src/WindowManager.vala"
	g_object_unref (_data_->_async_result);
#line 2308 "../src/WindowManager.vala"
	return FALSE;
#line 14631 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_area_data_free (gpointer _data)
{
	GalaWindowManagerGalaScreenshotAreaData* _data_;
	_data_ = _data;
#line 28 "../src/WindowManager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/WindowManager.vala"
	g_slice_free (GalaWindowManagerGalaScreenshotAreaData, _data_);
#line 14643 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_area (GalaWindowManagerGala* self,
                                          gboolean clipboard,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GalaWindowManagerGalaScreenshotAreaData* _data_;
	GalaWindowManagerGala* _tmp0_;
#line 28 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/WindowManager.vala"
	_data_ = g_slice_new0 (GalaWindowManagerGalaScreenshotAreaData);
#line 28 "../src/WindowManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/WindowManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gala_window_manager_gala_screenshot_area_data_free);
#line 28 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/WindowManager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/WindowManager.vala"
	_data_->clipboard = clipboard;
#line 28 "../src/WindowManager.vala"
	gala_window_manager_gala_screenshot_area_co (_data_);
#line 14670 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_area_finish (GalaWindowManagerGala* self,
                                                 GAsyncResult* _res_)
{
	GalaWindowManagerGalaScreenshotAreaData* _data_;
#line 28 "../src/WindowManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 14680 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_area_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	GalaWindowManagerGalaScreenshotAreaData* _data_;
#line 2329 "../src/WindowManager.vala"
	_data_ = _user_data_;
#line 2329 "../src/WindowManager.vala"
	_data_->_source_object_ = source_object;
#line 2329 "../src/WindowManager.vala"
	_data_->_res_ = _res_;
#line 2329 "../src/WindowManager.vala"
	gala_window_manager_gala_screenshot_area_co (_data_);
#line 14697 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_screenshot_area_co (GalaWindowManagerGalaScreenshotAreaData* _data_)
{
#line 2320 "../src/WindowManager.vala"
	switch (_data_->_state_) {
#line 2320 "../src/WindowManager.vala"
		case 0:
#line 14707 "WindowManager.c"
		goto _state_0;
#line 2320 "../src/WindowManager.vala"
		case 1:
#line 14711 "WindowManager.c"
		goto _state_1;
#line 2320 "../src/WindowManager.vala"
		case 2:
#line 14715 "WindowManager.c"
		goto _state_2;
		default:
#line 2320 "../src/WindowManager.vala"
		g_assert_not_reached ();
#line 14720 "WindowManager.c"
	}
	_state_0:
	{
#line 2322 "../src/WindowManager.vala"
		if (_data_->clipboard) {
#line 2322 "../src/WindowManager.vala"
			_data_->_tmp1_ = g_strdup ("");
#line 2322 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 2322 "../src/WindowManager.vala"
			_data_->_tmp0_ = _data_->_tmp1_;
#line 14732 "WindowManager.c"
		} else {
#line 2322 "../src/WindowManager.vala"
			_data_->_tmp2_ = gala_window_manager_gala_generate_screenshot_filename (_data_->self);
#line 2322 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 2322 "../src/WindowManager.vala"
			_data_->_tmp0_ = _data_->_tmp2_;
#line 14740 "WindowManager.c"
		}
#line 2322 "../src/WindowManager.vala"
		_data_->_tmp3_ = g_strdup (_data_->_tmp0_);
#line 2322 "../src/WindowManager.vala"
		_data_->filename = _data_->_tmp3_;
#line 2323 "../src/WindowManager.vala"
		_data_->success = FALSE;
#line 2324 "../src/WindowManager.vala"
		_data_->_tmp4_ = g_strdup ("");
#line 2324 "../src/WindowManager.vala"
		_data_->filename_used = _data_->_tmp4_;
#line 2326 "../src/WindowManager.vala"
		_data_->_tmp5_ = gala_screenshot_manager_init ((GalaWindowManager*) _data_->self);
#line 2326 "../src/WindowManager.vala"
		_data_->screenshot_manager = _data_->_tmp5_;
#line 2329 "../src/WindowManager.vala"
		_data_->_tmp6_ = _data_->screenshot_manager;
#line 2329 "../src/WindowManager.vala"
		_data_->_tmp7_ = 0;
#line 2329 "../src/WindowManager.vala"
		_data_->_tmp8_ = 0;
#line 2329 "../src/WindowManager.vala"
		_data_->_tmp9_ = 0;
#line 2329 "../src/WindowManager.vala"
		_data_->_tmp10_ = 0;
#line 2329 "../src/WindowManager.vala"
		_data_->_state_ = 1;
#line 2329 "../src/WindowManager.vala"
		gala_screenshot_manager_select_area (_data_->_tmp6_, gala_window_manager_gala_screenshot_area_ready, _data_);
#line 2329 "../src/WindowManager.vala"
		return FALSE;
#line 14772 "WindowManager.c"
		_state_1:
#line 2329 "../src/WindowManager.vala"
		gala_screenshot_manager_select_area_finish (_data_->_tmp6_, _data_->_res_, &_data_->_tmp7_, &_data_->_tmp8_, &_data_->_tmp9_, &_data_->_tmp10_, &_data_->_inner_error0_);
#line 2329 "../src/WindowManager.vala"
		_data_->x = _data_->_tmp7_;
#line 2329 "../src/WindowManager.vala"
		_data_->y = _data_->_tmp8_;
#line 2329 "../src/WindowManager.vala"
		_data_->w = _data_->_tmp9_;
#line 2329 "../src/WindowManager.vala"
		_data_->h = _data_->_tmp10_;
#line 2329 "../src/WindowManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2329 "../src/WindowManager.vala"
			_g_free0 (_data_->filename_used);
#line 2329 "../src/WindowManager.vala"
			_g_free0 (_data_->filename);
#line 2329 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 14792 "WindowManager.c"
			goto __catch0_g_error;
		}
#line 2330 "../src/WindowManager.vala"
		_data_->_tmp11_ = _data_->screenshot_manager;
#line 2330 "../src/WindowManager.vala"
		_data_->_tmp12_ = _data_->filename;
#line 2330 "../src/WindowManager.vala"
		_data_->_tmp13_ = FALSE;
#line 2330 "../src/WindowManager.vala"
		_data_->_tmp14_ = NULL;
#line 2330 "../src/WindowManager.vala"
		_data_->_state_ = 2;
#line 2330 "../src/WindowManager.vala"
		gala_screenshot_manager_screenshot_area (_data_->_tmp11_, _data_->x, _data_->y, _data_->w, _data_->h, TRUE, _data_->_tmp12_, gala_window_manager_gala_screenshot_area_ready, _data_);
#line 2330 "../src/WindowManager.vala"
		return FALSE;
#line 14809 "WindowManager.c"
		_state_2:
#line 2330 "../src/WindowManager.vala"
		gala_screenshot_manager_screenshot_area_finish (_data_->_tmp11_, _data_->_res_, &_data_->_tmp13_, &_data_->_tmp14_, &_data_->_inner_error0_);
#line 2330 "../src/WindowManager.vala"
		_data_->success = _data_->_tmp13_;
#line 2330 "../src/WindowManager.vala"
		_g_free0 (_data_->filename_used);
#line 2330 "../src/WindowManager.vala"
		_data_->filename_used = _data_->_tmp14_;
#line 2330 "../src/WindowManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2330 "../src/WindowManager.vala"
			_g_free0 (_data_->filename_used);
#line 2330 "../src/WindowManager.vala"
			_g_free0 (_data_->filename);
#line 2330 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 14827 "WindowManager.c"
			goto __catch0_g_error;
		}
#line 2321 "../src/WindowManager.vala"
		_g_free0 (_data_->filename_used);
#line 2321 "../src/WindowManager.vala"
		_g_free0 (_data_->filename);
#line 2321 "../src/WindowManager.vala"
		_g_free0 (_data_->_tmp0_);
#line 14836 "WindowManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 2321 "../src/WindowManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 14843 "WindowManager.c"
	}
	__finally0:
#line 2321 "../src/WindowManager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2321 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2321 "../src/WindowManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 2321 "../src/WindowManager.vala"
		g_object_unref (_data_->_async_result);
#line 2321 "../src/WindowManager.vala"
		return FALSE;
#line 14856 "WindowManager.c"
	}
#line 2320 "../src/WindowManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2320 "../src/WindowManager.vala"
	if (_data_->_state_ != 0) {
#line 2320 "../src/WindowManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2320 "../src/WindowManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 14866 "WindowManager.c"
		}
	}
#line 2320 "../src/WindowManager.vala"
	g_object_unref (_data_->_async_result);
#line 2320 "../src/WindowManager.vala"
	return FALSE;
#line 14873 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_screen_data_free (gpointer _data)
{
	GalaWindowManagerGalaScreenshotScreenData* _data_;
	_data_ = _data;
#line 28 "../src/WindowManager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/WindowManager.vala"
	g_slice_free (GalaWindowManagerGalaScreenshotScreenData, _data_);
#line 14885 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_screen (GalaWindowManagerGala* self,
                                            gboolean clipboard,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GalaWindowManagerGalaScreenshotScreenData* _data_;
	GalaWindowManagerGala* _tmp0_;
#line 28 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/WindowManager.vala"
	_data_ = g_slice_new0 (GalaWindowManagerGalaScreenshotScreenData);
#line 28 "../src/WindowManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/WindowManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gala_window_manager_gala_screenshot_screen_data_free);
#line 28 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/WindowManager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/WindowManager.vala"
	_data_->clipboard = clipboard;
#line 28 "../src/WindowManager.vala"
	gala_window_manager_gala_screenshot_screen_co (_data_);
#line 14912 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_screen_finish (GalaWindowManagerGala* self,
                                                   GAsyncResult* _res_)
{
	GalaWindowManagerGalaScreenshotScreenData* _data_;
#line 28 "../src/WindowManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 14922 "WindowManager.c"
}

static void
gala_window_manager_gala_screenshot_screen_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GalaWindowManagerGalaScreenshotScreenData* _data_;
#line 2342 "../src/WindowManager.vala"
	_data_ = _user_data_;
#line 2342 "../src/WindowManager.vala"
	_data_->_source_object_ = source_object;
#line 2342 "../src/WindowManager.vala"
	_data_->_res_ = _res_;
#line 2342 "../src/WindowManager.vala"
	gala_window_manager_gala_screenshot_screen_co (_data_);
#line 14939 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_screenshot_screen_co (GalaWindowManagerGalaScreenshotScreenData* _data_)
{
#line 2336 "../src/WindowManager.vala"
	switch (_data_->_state_) {
#line 2336 "../src/WindowManager.vala"
		case 0:
#line 14949 "WindowManager.c"
		goto _state_0;
#line 2336 "../src/WindowManager.vala"
		case 1:
#line 14953 "WindowManager.c"
		goto _state_1;
		default:
#line 2336 "../src/WindowManager.vala"
		g_assert_not_reached ();
#line 14958 "WindowManager.c"
	}
	_state_0:
	{
#line 2338 "../src/WindowManager.vala"
		if (_data_->clipboard) {
#line 2338 "../src/WindowManager.vala"
			_data_->_tmp1_ = g_strdup ("");
#line 2338 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 2338 "../src/WindowManager.vala"
			_data_->_tmp0_ = _data_->_tmp1_;
#line 14970 "WindowManager.c"
		} else {
#line 2338 "../src/WindowManager.vala"
			_data_->_tmp2_ = gala_window_manager_gala_generate_screenshot_filename (_data_->self);
#line 2338 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 2338 "../src/WindowManager.vala"
			_data_->_tmp0_ = _data_->_tmp2_;
#line 14978 "WindowManager.c"
		}
#line 2338 "../src/WindowManager.vala"
		_data_->_tmp3_ = g_strdup (_data_->_tmp0_);
#line 2338 "../src/WindowManager.vala"
		_data_->filename = _data_->_tmp3_;
#line 2339 "../src/WindowManager.vala"
		_data_->success = FALSE;
#line 2340 "../src/WindowManager.vala"
		_data_->_tmp4_ = g_strdup ("");
#line 2340 "../src/WindowManager.vala"
		_data_->filename_used = _data_->_tmp4_;
#line 2341 "../src/WindowManager.vala"
		_data_->_tmp5_ = gala_screenshot_manager_init ((GalaWindowManager*) _data_->self);
#line 2341 "../src/WindowManager.vala"
		_data_->screenshot_manager = _data_->_tmp5_;
#line 2342 "../src/WindowManager.vala"
		_data_->_tmp6_ = FALSE;
#line 2342 "../src/WindowManager.vala"
		_data_->_tmp7_ = NULL;
#line 2342 "../src/WindowManager.vala"
		_data_->_state_ = 1;
#line 2342 "../src/WindowManager.vala"
		gala_screenshot_manager_screenshot (_data_->screenshot_manager, FALSE, TRUE, _data_->filename, gala_window_manager_gala_screenshot_screen_ready, _data_);
#line 2342 "../src/WindowManager.vala"
		return FALSE;
#line 15004 "WindowManager.c"
		_state_1:
#line 2342 "../src/WindowManager.vala"
		gala_screenshot_manager_screenshot_finish (_data_->screenshot_manager, _data_->_res_, &_data_->_tmp6_, &_data_->_tmp7_, &_data_->_inner_error0_);
#line 2342 "../src/WindowManager.vala"
		_data_->success = _data_->_tmp6_;
#line 2342 "../src/WindowManager.vala"
		_g_free0 (_data_->filename_used);
#line 2342 "../src/WindowManager.vala"
		_data_->filename_used = _data_->_tmp7_;
#line 2342 "../src/WindowManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2342 "../src/WindowManager.vala"
			_g_free0 (_data_->filename_used);
#line 2342 "../src/WindowManager.vala"
			_g_free0 (_data_->filename);
#line 2342 "../src/WindowManager.vala"
			_g_free0 (_data_->_tmp0_);
#line 15022 "WindowManager.c"
			goto __catch0_g_error;
		}
#line 2337 "../src/WindowManager.vala"
		_g_free0 (_data_->filename_used);
#line 2337 "../src/WindowManager.vala"
		_g_free0 (_data_->filename);
#line 2337 "../src/WindowManager.vala"
		_g_free0 (_data_->_tmp0_);
#line 15031 "WindowManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 2337 "../src/WindowManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 15038 "WindowManager.c"
	}
	__finally0:
#line 2337 "../src/WindowManager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2337 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2337 "../src/WindowManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 2337 "../src/WindowManager.vala"
		g_object_unref (_data_->_async_result);
#line 2337 "../src/WindowManager.vala"
		return FALSE;
#line 15051 "WindowManager.c"
	}
#line 2336 "../src/WindowManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2336 "../src/WindowManager.vala"
	if (_data_->_state_ != 0) {
#line 2336 "../src/WindowManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2336 "../src/WindowManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 15061 "WindowManager.c"
		}
	}
#line 2336 "../src/WindowManager.vala"
	g_object_unref (_data_->_async_result);
#line 2336 "../src/WindowManager.vala"
	return FALSE;
#line 15068 "WindowManager.c"
}

static void
gala_window_manager_gala_clutter_actor_reparent (ClutterActor* actor,
                                                 ClutterActor* new_parent)
{
	ClutterActor* _tmp0_;
#line 2348 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 2348 "../src/WindowManager.vala"
	g_return_if_fail (new_parent != NULL);
#line 2349 "../src/WindowManager.vala"
	if (actor == new_parent) {
#line 2350 "../src/WindowManager.vala"
		return;
#line 15084 "WindowManager.c"
	}
#line 2352 "../src/WindowManager.vala"
	g_object_ref ((GObject*) actor);
#line 2353 "../src/WindowManager.vala"
	_tmp0_ = clutter_actor_get_parent (actor);
#line 2353 "../src/WindowManager.vala"
	clutter_actor_remove_child (_tmp0_, actor);
#line 2354 "../src/WindowManager.vala"
	clutter_actor_add_child (new_parent, actor);
#line 2355 "../src/WindowManager.vala"
	g_object_unref ((GObject*) actor);
#line 15096 "WindowManager.c"
}

GalaWindowManagerGala*
gala_window_manager_gala_construct (GType object_type)
{
	GalaWindowManagerGala * self = NULL;
#line 28 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) g_object_new (object_type, NULL);
#line 28 "../src/WindowManager.vala"
	return self;
#line 15107 "WindowManager.c"
}

GalaWindowManagerGala*
gala_window_manager_gala_new (void)
{
#line 28 "../src/WindowManager.vala"
	return gala_window_manager_gala_construct (GALA_TYPE_WINDOW_MANAGER_GALA);
#line 15115 "WindowManager.c"
}

static ClutterActor*
gala_window_manager_gala_real_get_ui_group (GalaWindowManager* base)
{
	ClutterActor* result;
	GalaWindowManagerGala* self;
	ClutterActor* _tmp0_;
#line 32 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 32 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_ui_group;
#line 32 "../src/WindowManager.vala"
	result = _tmp0_;
#line 32 "../src/WindowManager.vala"
	return result;
#line 15132 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_ui_group (GalaWindowManager* base,
                                            ClutterActor* value)
{
	GalaWindowManagerGala* self;
	ClutterActor* old_value;
#line 32 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 32 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_ui_group (base);
#line 32 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15147 "WindowManager.c"
		ClutterActor* _tmp0_;
#line 32 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_ui_group);
#line 32 "../src/WindowManager.vala"
		self->priv->_ui_group = _tmp0_;
#line 32 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY]);
#line 15157 "WindowManager.c"
	}
}

static ClutterStage*
gala_window_manager_gala_real_get_stage (GalaWindowManager* base)
{
	ClutterStage* result;
	GalaWindowManagerGala* self;
	ClutterStage* _tmp0_;
#line 37 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 37 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_stage;
#line 37 "../src/WindowManager.vala"
	result = _tmp0_;
#line 37 "../src/WindowManager.vala"
	return result;
#line 15175 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_stage (GalaWindowManager* base,
                                         ClutterStage* value)
{
	GalaWindowManagerGala* self;
	ClutterStage* old_value;
#line 37 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 37 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_stage (base);
#line 37 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15190 "WindowManager.c"
		ClutterStage* _tmp0_;
#line 37 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_stage);
#line 37 "../src/WindowManager.vala"
		self->priv->_stage = _tmp0_;
#line 37 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY]);
#line 15200 "WindowManager.c"
	}
}

static ClutterActor*
gala_window_manager_gala_real_get_window_group (GalaWindowManager* base)
{
	ClutterActor* result;
	GalaWindowManagerGala* self;
	ClutterActor* _tmp0_;
#line 42 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 42 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_window_group;
#line 42 "../src/WindowManager.vala"
	result = _tmp0_;
#line 42 "../src/WindowManager.vala"
	return result;
#line 15218 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_window_group (GalaWindowManager* base,
                                                ClutterActor* value)
{
	GalaWindowManagerGala* self;
	ClutterActor* old_value;
#line 42 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 42 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_window_group (base);
#line 42 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15233 "WindowManager.c"
		ClutterActor* _tmp0_;
#line 42 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_window_group);
#line 42 "../src/WindowManager.vala"
		self->priv->_window_group = _tmp0_;
#line 42 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY]);
#line 15243 "WindowManager.c"
	}
}

static ClutterActor*
gala_window_manager_gala_real_get_top_window_group (GalaWindowManager* base)
{
	ClutterActor* result;
	GalaWindowManagerGala* self;
	ClutterActor* _tmp0_;
#line 47 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 47 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_top_window_group;
#line 47 "../src/WindowManager.vala"
	result = _tmp0_;
#line 47 "../src/WindowManager.vala"
	return result;
#line 15261 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_top_window_group (GalaWindowManager* base,
                                                    ClutterActor* value)
{
	GalaWindowManagerGala* self;
	ClutterActor* old_value;
#line 47 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 47 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_top_window_group (base);
#line 47 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15276 "WindowManager.c"
		ClutterActor* _tmp0_;
#line 47 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 47 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_top_window_group);
#line 47 "../src/WindowManager.vala"
		self->priv->_top_window_group = _tmp0_;
#line 47 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY]);
#line 15286 "WindowManager.c"
	}
}

ClutterActor*
gala_window_manager_gala_get_notification_group (GalaWindowManagerGala* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 49 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_notification_group;
#line 49 "../src/WindowManager.vala"
	result = _tmp0_;
#line 49 "../src/WindowManager.vala"
	return result;
#line 15303 "WindowManager.c"
}

void
gala_window_manager_gala_set_notification_group (GalaWindowManagerGala* self,
                                                 ClutterActor* value)
{
	ClutterActor* old_value;
#line 49 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_notification_group (self);
#line 49 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15317 "WindowManager.c"
		ClutterActor* _tmp0_;
#line 49 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 49 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_notification_group);
#line 49 "../src/WindowManager.vala"
		self->priv->_notification_group = _tmp0_;
#line 49 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_NOTIFICATION_GROUP_PROPERTY]);
#line 15327 "WindowManager.c"
	}
}

static MetaBackgroundGroup*
gala_window_manager_gala_real_get_background_group (GalaWindowManager* base)
{
	MetaBackgroundGroup* result;
	GalaWindowManagerGala* self;
	MetaBackgroundGroup* _tmp0_;
#line 54 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 54 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_background_group;
#line 54 "../src/WindowManager.vala"
	result = _tmp0_;
#line 54 "../src/WindowManager.vala"
	return result;
#line 15345 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_background_group (GalaWindowManager* base,
                                                    MetaBackgroundGroup* value)
{
	GalaWindowManagerGala* self;
	MetaBackgroundGroup* old_value;
#line 54 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 54 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_background_group (base);
#line 54 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15360 "WindowManager.c"
		MetaBackgroundGroup* _tmp0_;
#line 54 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 54 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_background_group);
#line 54 "../src/WindowManager.vala"
		self->priv->_background_group = _tmp0_;
#line 54 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY]);
#line 15370 "WindowManager.c"
	}
}

static GalaActivatableComponent*
gala_window_manager_gala_real_get_workspace_view (GalaWindowManager* base)
{
	GalaActivatableComponent* result;
	GalaWindowManagerGala* self;
	GalaActivatableComponent* _tmp0_;
#line 59 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 59 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_workspace_view;
#line 59 "../src/WindowManager.vala"
	result = _tmp0_;
#line 59 "../src/WindowManager.vala"
	return result;
#line 15388 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_workspace_view (GalaWindowManager* base,
                                                  GalaActivatableComponent* value)
{
	GalaWindowManagerGala* self;
	GalaActivatableComponent* old_value;
#line 59 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 59 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_workspace_view (base);
#line 59 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15403 "WindowManager.c"
		GalaActivatableComponent* _tmp0_;
#line 59 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 59 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_workspace_view);
#line 59 "../src/WindowManager.vala"
		self->priv->_workspace_view = _tmp0_;
#line 59 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WORKSPACE_VIEW_PROPERTY]);
#line 15413 "WindowManager.c"
	}
}

static gboolean
gala_window_manager_gala_real_get_enable_animations (GalaWindowManager* base)
{
	gboolean result;
	GalaWindowManagerGala* self;
#line 64 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 64 "../src/WindowManager.vala"
	result = self->priv->_enable_animations;
#line 64 "../src/WindowManager.vala"
	return result;
#line 15428 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_enable_animations (GalaWindowManager* base,
                                                     gboolean value)
{
	GalaWindowManagerGala* self;
	gboolean old_value;
#line 64 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 64 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_enable_animations (base);
#line 64 "../src/WindowManager.vala"
	if (old_value != value) {
#line 64 "../src/WindowManager.vala"
		self->priv->_enable_animations = value;
#line 64 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_ENABLE_ANIMATIONS_PROPERTY]);
#line 15447 "WindowManager.c"
	}
}

GalaScreenShield*
gala_window_manager_gala_get_screen_shield (GalaWindowManagerGala* self)
{
	GalaScreenShield* result;
	GalaScreenShield* _tmp0_;
#line 66 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_screen_shield;
#line 66 "../src/WindowManager.vala"
	result = _tmp0_;
#line 66 "../src/WindowManager.vala"
	return result;
#line 15464 "WindowManager.c"
}

static void
gala_window_manager_gala_set_screen_shield (GalaWindowManagerGala* self,
                                            GalaScreenShield* value)
{
	GalaScreenShield* old_value;
#line 66 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_screen_shield (self);
#line 66 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15478 "WindowManager.c"
		GalaScreenShield* _tmp0_;
#line 66 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 66 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_screen_shield);
#line 66 "../src/WindowManager.vala"
		self->priv->_screen_shield = _tmp0_;
#line 66 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_SCREEN_SHIELD_PROPERTY]);
#line 15488 "WindowManager.c"
	}
}

GalaPointerLocator*
gala_window_manager_gala_get_pointer_locator (GalaWindowManagerGala* self)
{
	GalaPointerLocator* result;
	GalaPointerLocator* _tmp0_;
#line 68 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_pointer_locator;
#line 68 "../src/WindowManager.vala"
	result = _tmp0_;
#line 68 "../src/WindowManager.vala"
	return result;
#line 15505 "WindowManager.c"
}

static void
gala_window_manager_gala_set_pointer_locator (GalaWindowManagerGala* self,
                                              GalaPointerLocator* value)
{
	GalaPointerLocator* old_value;
#line 68 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_pointer_locator (self);
#line 68 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15519 "WindowManager.c"
		GalaPointerLocator* _tmp0_;
#line 68 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 68 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_pointer_locator);
#line 68 "../src/WindowManager.vala"
		self->priv->_pointer_locator = _tmp0_;
#line 68 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY]);
#line 15529 "WindowManager.c"
	}
}

GalaScreenSaverManager*
gala_window_manager_gala_get_screensaver (GalaWindowManagerGala* self)
{
	GalaScreenSaverManager* result;
	GalaScreenSaverManager* _tmp0_;
#line 77 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_screensaver;
#line 77 "../src/WindowManager.vala"
	result = _tmp0_;
#line 77 "../src/WindowManager.vala"
	return result;
#line 15546 "WindowManager.c"
}

static void
gala_window_manager_gala_set_screensaver (GalaWindowManagerGala* self,
                                          GalaScreenSaverManager* value)
{
	GalaScreenSaverManager* old_value;
#line 77 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_screensaver (self);
#line 77 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15560 "WindowManager.c"
		GalaScreenSaverManager* _tmp0_;
#line 77 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 77 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_screensaver);
#line 77 "../src/WindowManager.vala"
		self->priv->_screensaver = _tmp0_;
#line 77 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY]);
#line 15570 "WindowManager.c"
	}
}

GalaWindowTracker*
gala_window_manager_gala_get_window_tracker (GalaWindowManagerGala* self)
{
	GalaWindowTracker* result;
	GalaWindowTracker* _tmp0_;
#line 81 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_window_tracker;
#line 81 "../src/WindowManager.vala"
	result = _tmp0_;
#line 81 "../src/WindowManager.vala"
	return result;
#line 15587 "WindowManager.c"
}

static void
gala_window_manager_gala_set_window_tracker (GalaWindowManagerGala* self,
                                             GalaWindowTracker* value)
{
	GalaWindowTracker* old_value;
#line 81 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_window_tracker (self);
#line 81 "../src/WindowManager.vala"
	if (old_value != value) {
#line 15601 "WindowManager.c"
		GalaWindowTracker* _tmp0_;
#line 81 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 81 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_window_tracker);
#line 81 "../src/WindowManager.vala"
		self->priv->_window_tracker = _tmp0_;
#line 81 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY]);
#line 15611 "WindowManager.c"
	}
}

static void
_gala_window_manager_gala_on_gesture_detected_gala_gesture_tracker_on_gesture_detected (GalaGestureTracker* _sender,
                                                                                        GalaGesture* gesture,
                                                                                        gpointer self)
{
#line 137 "../src/WindowManager.vala"
	gala_window_manager_gala_on_gesture_detected ((GalaWindowManagerGala*) self, gesture);
#line 15622 "WindowManager.c"
}

static GObject *
gala_window_manager_gala_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowManagerGala * self;
	GalaGestureTracker* _tmp0_;
	GalaGestureTracker* _tmp1_;
	GalaGestureTracker* _tmp2_;
	MetaPluginInfo _tmp3_ = {0};
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
#line 134 "../src/WindowManager.vala"
	parent_class = G_OBJECT_CLASS (gala_window_manager_gala_parent_class);
#line 134 "../src/WindowManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 134 "../src/WindowManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala);
#line 135 "../src/WindowManager.vala"
	_tmp0_ = gala_gesture_tracker_new ((gint) GALA_ANIMATION_DURATION_WORKSPACE_SWITCH_MIN, (gint) GALA_ANIMATION_DURATION_WORKSPACE_SWITCH);
#line 135 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->gesture_tracker);
#line 135 "../src/WindowManager.vala"
	self->priv->gesture_tracker = _tmp0_;
#line 136 "../src/WindowManager.vala"
	_tmp1_ = self->priv->gesture_tracker;
#line 136 "../src/WindowManager.vala"
	gala_gesture_tracker_enable_touchpad (_tmp1_);
#line 137 "../src/WindowManager.vala"
	_tmp2_ = self->priv->gesture_tracker;
#line 137 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp2_, "on-gesture-detected", (GCallback) _gala_window_manager_gala_on_gesture_detected_gala_gesture_tracker_on_gesture_detected, self, 0);
#line 139 "../src/WindowManager.vala"
	memset (&_tmp3_, 0, sizeof (MetaPluginInfo));
#line 139 "../src/WindowManager.vala"
	_tmp3_.name = "Gala";
#line 139 "../src/WindowManager.vala"
	_tmp3_.version = VERSION;
#line 139 "../src/WindowManager.vala"
	_tmp3_.author = "Gala Developers";
#line 139 "../src/WindowManager.vala"
	_tmp3_.license = "GPLv3";
#line 139 "../src/WindowManager.vala"
	_tmp3_.description = "A nice elementary window manager";
#line 139 "../src/WindowManager.vala"
	self->priv->info = _tmp3_;
#line 142 "../src/WindowManager.vala"
	_tmp4_ = g_settings_new (SCHEMA ".animations");
#line 142 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->animations_settings);
#line 142 "../src/WindowManager.vala"
	self->priv->animations_settings = _tmp4_;
#line 143 "../src/WindowManager.vala"
	_tmp5_ = self->priv->animations_settings;
#line 143 "../src/WindowManager.vala"
	g_settings_bind (_tmp5_, "enable-animations", (GObject*) self, "enable-animations", G_SETTINGS_BIND_GET);
#line 144 "../src/WindowManager.vala"
	_tmp6_ = g_settings_new (SCHEMA ".behavior");
#line 144 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->behavior_settings);
#line 144 "../src/WindowManager.vala"
	self->priv->behavior_settings = _tmp6_;
#line 145 "../src/WindowManager.vala"
	_tmp7_ = self->priv->animations_settings;
#line 145 "../src/WindowManager.vala"
	gala_window_manager_set_enable_animations ((GalaWindowManager*) self, g_settings_get_boolean (_tmp7_, "enable-animations"));
#line 134 "../src/WindowManager.vala"
	return obj;
#line 15697 "WindowManager.c"
}

static void
gala_window_manager_gala_class_init (GalaWindowManagerGalaClass * klass,
                                     gpointer klass_data)
{
#line 28 "../src/WindowManager.vala"
	gala_window_manager_gala_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/WindowManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowManagerGala_private_offset);
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->start = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_start;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->show_window_menu = (void (*) (MetaPlugin*, MetaWindow*, MetaWindowMenuType, gint, gint)) gala_window_manager_gala_real_show_window_menu;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->show_tile_preview = (void (*) (MetaPlugin*, MetaWindow*, MtkRectangle*, gint)) gala_window_manager_gala_real_show_tile_preview;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->hide_tile_preview = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_hide_tile_preview;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->show_window_menu_for_rect = (void (*) (MetaPlugin*, MetaWindow*, MetaWindowMenuType, MtkRectangle*)) gala_window_manager_gala_real_show_window_menu_for_rect;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->size_change = (void (*) (MetaPlugin*, MetaWindowActor*, MetaSizeChange, MtkRectangle*, MtkRectangle*)) gala_window_manager_gala_real_size_change;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->size_changed = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_size_changed;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->minimize = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_minimize;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->unminimize = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_unminimize;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->map = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_map;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->destroy = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_destroy;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->kill_window_effects = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_kill_window_effects;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->switch_workspace = (void (*) (MetaPlugin*, gint, gint, MetaMotionDirection)) gala_window_manager_gala_real_switch_workspace;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->kill_switch_workspace = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_kill_switch_workspace;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->locate_pointer = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_locate_pointer;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->keybinding_filter = (gboolean (*) (MetaPlugin*, MetaKeyBinding*)) gala_window_manager_gala_real_keybinding_filter;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->confirm_display_change = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_confirm_display_change;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->create_close_dialog = (MetaCloseDialog* (*) (MetaPlugin*, MetaWindow*)) gala_window_manager_gala_real_create_close_dialog;
#line 28 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->plugin_info = (MetaPluginInfo* (*) (MetaPlugin*)) gala_window_manager_gala_real_plugin_info;
#line 28 "../src/WindowManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_manager_gala_get_property;
#line 28 "../src/WindowManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_manager_gala_set_property;
#line 28 "../src/WindowManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_manager_gala_constructor;
#line 28 "../src/WindowManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_manager_gala_finalize;
#line 15754 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY] = g_param_spec_object ("ui-group", "ui-group", "ui-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15760 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY] = g_param_spec_object ("stage", "stage", "stage", clutter_stage_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15766 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY] = g_param_spec_object ("window-group", "window-group", "window-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15772 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY] = g_param_spec_object ("top-window-group", "top-window-group", "top-window-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_NOTIFICATION_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_NOTIFICATION_GROUP_PROPERTY] = g_param_spec_object ("notification-group", "notification-group", "notification-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15780 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY] = g_param_spec_object ("background-group", "background-group", "background-group", meta_background_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15786 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_WORKSPACE_VIEW_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WORKSPACE_VIEW_PROPERTY] = g_param_spec_object ("workspace-view", "workspace-view", "workspace-view", GALA_TYPE_ACTIVATABLE_COMPONENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15792 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_ENABLE_ANIMATIONS_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_ENABLE_ANIMATIONS_PROPERTY] = g_param_spec_boolean ("enable-animations", "enable-animations", "enable-animations", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_SCREEN_SHIELD_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_SCREEN_SHIELD_PROPERTY] = g_param_spec_object ("screen-shield", "screen-shield", "screen-shield", GALA_TYPE_SCREEN_SHIELD, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY] = g_param_spec_object ("pointer-locator", "pointer-locator", "pointer-locator", GALA_TYPE_POINTER_LOCATOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY] = g_param_spec_object ("screensaver", "screensaver", "screensaver", GALA_TYPE_SCREEN_SAVER_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY] = g_param_spec_object ("window-tracker", "window-tracker", "window-tracker", GALA_TYPE_WINDOW_TRACKER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/WindowManager.vala"
	gala_window_manager_gala_signals[GALA_WINDOW_MANAGER_GALA_WINDOW_CREATED_SIGNAL] = g_signal_new ("window-created", GALA_TYPE_WINDOW_MANAGER_GALA, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, meta_window_get_type ());
#line 15808 "WindowManager.c"
}

static void
gala_window_manager_gala_gala_window_manager_interface_init (GalaWindowManagerIface * iface,
                                                             gpointer iface_data)
{
#line 28 "../src/WindowManager.vala"
	gala_window_manager_gala_gala_window_manager_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "../src/WindowManager.vala"
	iface->switch_to_next_workspace = (void (*) (GalaWindowManager*, MetaMotionDirection)) gala_window_manager_gala_real_switch_to_next_workspace;
#line 28 "../src/WindowManager.vala"
	iface->move_window = (void (*) (GalaWindowManager*, MetaWindow*, MetaWorkspace*)) gala_window_manager_gala_real_move_window;
#line 28 "../src/WindowManager.vala"
	iface->push_modal = (GalaModalProxy* (*) (GalaWindowManager*, ClutterActor*)) gala_window_manager_gala_real_push_modal;
#line 28 "../src/WindowManager.vala"
	iface->pop_modal = (void (*) (GalaWindowManager*, GalaModalProxy*)) gala_window_manager_gala_real_pop_modal;
#line 28 "../src/WindowManager.vala"
	iface->is_modal = (gboolean (*) (GalaWindowManager*)) gala_window_manager_gala_real_is_modal;
#line 28 "../src/WindowManager.vala"
	iface->modal_proxy_valid = (gboolean (*) (GalaWindowManager*, GalaModalProxy*)) gala_window_manager_gala_real_modal_proxy_valid;
#line 28 "../src/WindowManager.vala"
	iface->perform_action = (void (*) (GalaWindowManager*, GalaActionType)) gala_window_manager_gala_real_perform_action;
#line 28 "../src/WindowManager.vala"
	iface->get_ui_group = gala_window_manager_gala_real_get_ui_group;
#line 28 "../src/WindowManager.vala"
	iface->set_ui_group = gala_window_manager_gala_real_set_ui_group;
#line 28 "../src/WindowManager.vala"
	iface->get_stage = gala_window_manager_gala_real_get_stage;
#line 28 "../src/WindowManager.vala"
	iface->set_stage = gala_window_manager_gala_real_set_stage;
#line 28 "../src/WindowManager.vala"
	iface->get_window_group = gala_window_manager_gala_real_get_window_group;
#line 28 "../src/WindowManager.vala"
	iface->set_window_group = gala_window_manager_gala_real_set_window_group;
#line 28 "../src/WindowManager.vala"
	iface->get_top_window_group = gala_window_manager_gala_real_get_top_window_group;
#line 28 "../src/WindowManager.vala"
	iface->set_top_window_group = gala_window_manager_gala_real_set_top_window_group;
#line 28 "../src/WindowManager.vala"
	iface->get_background_group = gala_window_manager_gala_real_get_background_group;
#line 28 "../src/WindowManager.vala"
	iface->set_background_group = gala_window_manager_gala_real_set_background_group;
#line 28 "../src/WindowManager.vala"
	iface->get_workspace_view = gala_window_manager_gala_real_get_workspace_view;
#line 28 "../src/WindowManager.vala"
	iface->set_workspace_view = gala_window_manager_gala_real_set_workspace_view;
#line 28 "../src/WindowManager.vala"
	iface->get_enable_animations = gala_window_manager_gala_real_get_enable_animations;
#line 28 "../src/WindowManager.vala"
	iface->set_enable_animations = gala_window_manager_gala_real_set_enable_animations;
#line 15859 "WindowManager.c"
}

static void
gala_window_manager_gala_instance_init (GalaWindowManagerGala * self,
                                        gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* _tmp2_;
	GeeHashSet* _tmp3_;
	GeeHashSet* _tmp4_;
	GeeHashSet* _tmp5_;
	GeeHashSet* _tmp6_;
	GHashFunc _tmp7_;
	GEqualFunc _tmp8_;
	GHashTable* _tmp9_;
	GHashFunc _tmp10_;
	GEqualFunc _tmp11_;
	GHashTable* _tmp12_;
#line 28 "../src/WindowManager.vala"
	self->priv = gala_window_manager_gala_get_instance_private (self);
#line 74 "../src/WindowManager.vala"
	self->priv->winswitcher = NULL;
#line 75 "../src/WindowManager.vala"
	self->priv->window_overview = NULL;
#line 79 "../src/WindowManager.vala"
	self->priv->hot_corner_manager = NULL;
#line 86 "../src/WindowManager.vala"
	self->priv->zoom = NULL;
#line 94 "../src/WindowManager.vala"
	self->priv->daemon_proxy = NULL;
#line 98 "../src/WindowManager.vala"
	_tmp0_ = gee_linked_list_new (GALA_TYPE_MODAL_PROXY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 98 "../src/WindowManager.vala"
	self->priv->modal_stack = _tmp0_;
#line 100 "../src/WindowManager.vala"
	_tmp1_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 100 "../src/WindowManager.vala"
	self->priv->minimizing = _tmp1_;
#line 101 "../src/WindowManager.vala"
	_tmp2_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 101 "../src/WindowManager.vala"
	self->priv->maximizing = _tmp2_;
#line 102 "../src/WindowManager.vala"
	_tmp3_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 102 "../src/WindowManager.vala"
	self->priv->unmaximizing = _tmp3_;
#line 103 "../src/WindowManager.vala"
	_tmp4_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 103 "../src/WindowManager.vala"
	self->priv->mapping = _tmp4_;
#line 104 "../src/WindowManager.vala"
	_tmp5_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 104 "../src/WindowManager.vala"
	self->priv->destroying = _tmp5_;
#line 105 "../src/WindowManager.vala"
	_tmp6_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 105 "../src/WindowManager.vala"
	self->priv->unminimizing = _tmp6_;
#line 106 "../src/WindowManager.vala"
	_tmp7_ = g_direct_hash;
#line 106 "../src/WindowManager.vala"
	_tmp8_ = g_direct_equal;
#line 106 "../src/WindowManager.vala"
	_tmp9_ = g_hash_table_new_full (_tmp7_, _tmp8_, _g_object_unref0_, NULL);
#line 106 "../src/WindowManager.vala"
	self->priv->ws_assoc = _tmp9_;
#line 107 "../src/WindowManager.vala"
	self->priv->which_change = NULL;
#line 119 "../src/WindowManager.vala"
	self->priv->animating_switch_workspace = FALSE;
#line 120 "../src/WindowManager.vala"
	self->priv->switch_workspace_with_gesture = FALSE;
#line 854 "../src/WindowManager.vala"
	_tmp10_ = g_direct_hash;
#line 854 "../src/WindowManager.vala"
	_tmp11_ = g_direct_equal;
#line 854 "../src/WindowManager.vala"
	_tmp12_ = g_hash_table_new_full (_tmp10_, _tmp11_, _g_object_unref0_, NULL);
#line 854 "../src/WindowManager.vala"
	self->priv->dim_table = _tmp12_;
#line 1860 "../src/WindowManager.vala"
	self->priv->switch_workspace_window_created_id = (gulong) 0;
#line 15943 "WindowManager.c"
}

static void
gala_window_manager_gala_finalize (GObject * obj)
{
	GalaWindowManagerGala * self;
#line 28 "../src/WindowManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala);
#line 32 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_ui_group);
#line 37 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_stage);
#line 42 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_window_group);
#line 47 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_top_window_group);
#line 49 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_notification_group);
#line 54 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_background_group);
#line 59 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_workspace_view);
#line 66 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_screen_shield);
#line 68 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_pointer_locator);
#line 70 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->system_background);
#line 74 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->winswitcher);
#line 75 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->window_overview);
#line 77 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_screensaver);
#line 79 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->hot_corner_manager);
#line 81 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_window_tracker);
#line 86 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->zoom);
#line 88 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->accent_color_manager);
#line 90 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->tile_preview);
#line 92 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->moving);
#line 94 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->daemon_proxy);
#line 96 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->notification_stack);
#line 98 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->modal_stack);
#line 100 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->minimizing);
#line 101 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->maximizing);
#line 102 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->unmaximizing);
#line 103 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->mapping);
#line 104 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->destroying);
#line 105 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->unminimizing);
#line 106 "../src/WindowManager.vala"
	_g_hash_table_unref0 (self->priv->ws_assoc);
#line 107 "../src/WindowManager.vala"
	_g_free0 (self->priv->which_change);
#line 113 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->latest_window_snapshot);
#line 115 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->animations_settings);
#line 116 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->behavior_settings);
#line 118 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->gesture_tracker);
#line 854 "../src/WindowManager.vala"
	_g_hash_table_unref0 (self->priv->dim_table);
#line 1857 "../src/WindowManager.vala"
	(self->priv->windows == NULL) ? NULL : (self->priv->windows = (_g_list_free__g_object_unref0_ (self->priv->windows), NULL));
#line 1858 "../src/WindowManager.vala"
	(self->priv->parents == NULL) ? NULL : (self->priv->parents = (_g_list_free__g_object_unref0_ (self->priv->parents), NULL));
#line 1859 "../src/WindowManager.vala"
	(self->priv->tmp_actors == NULL) ? NULL : (self->priv->tmp_actors = (_g_list_free__g_object_unref0_ (self->priv->tmp_actors), NULL));
#line 28 "../src/WindowManager.vala"
	G_OBJECT_CLASS (gala_window_manager_gala_parent_class)->finalize (obj);
#line 16030 "WindowManager.c"
}

static GType
gala_window_manager_gala_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowManagerGalaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_manager_gala_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowManagerGala), 0, (GInstanceInitFunc) gala_window_manager_gala_instance_init, NULL };
	static const GInterfaceInfo gala_window_manager_info = { (GInterfaceInitFunc) gala_window_manager_gala_gala_window_manager_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_window_manager_gala_type_id;
	gala_window_manager_gala_type_id = g_type_register_static (meta_plugin_get_type (), "GalaWindowManagerGala", &g_define_type_info, 0);
	g_type_add_interface_static (gala_window_manager_gala_type_id, GALA_TYPE_WINDOW_MANAGER, &gala_window_manager_info);
	GalaWindowManagerGala_private_offset = g_type_add_instance_private (gala_window_manager_gala_type_id, sizeof (GalaWindowManagerGalaPrivate));
	return gala_window_manager_gala_type_id;
}

GType
gala_window_manager_gala_get_type (void)
{
	static volatile gsize gala_window_manager_gala_type_id__once = 0;
	if (g_once_init_enter (&gala_window_manager_gala_type_id__once)) {
		GType gala_window_manager_gala_type_id;
		gala_window_manager_gala_type_id = gala_window_manager_gala_get_type_once ();
		g_once_init_leave (&gala_window_manager_gala_type_id__once, gala_window_manager_gala_type_id);
	}
	return gala_window_manager_gala_type_id__once;
}

static void
_vala_gala_window_manager_gala_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GalaWindowManagerGala * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala);
#line 28 "../src/WindowManager.vala"
	switch (property_id) {
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_ui_group ((GalaWindowManager*) self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_stage ((GalaWindowManager*) self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_window_group ((GalaWindowManager*) self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_top_window_group ((GalaWindowManager*) self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_NOTIFICATION_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_notification_group (self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_background_group ((GalaWindowManager*) self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WORKSPACE_VIEW_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_workspace_view ((GalaWindowManager*) self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_ENABLE_ANIMATIONS_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_boolean (value, gala_window_manager_get_enable_animations ((GalaWindowManager*) self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_SCREEN_SHIELD_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_screen_shield (self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_pointer_locator (self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_screensaver (self));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY:
#line 28 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_window_tracker (self));
#line 28 "../src/WindowManager.vala"
		break;
#line 16139 "WindowManager.c"
		default:
#line 28 "../src/WindowManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/WindowManager.vala"
		break;
#line 16145 "WindowManager.c"
	}
}

static void
_vala_gala_window_manager_gala_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GalaWindowManagerGala * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala);
#line 28 "../src/WindowManager.vala"
	switch (property_id) {
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_set_ui_group ((GalaWindowManager*) self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_set_stage ((GalaWindowManager*) self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_set_window_group ((GalaWindowManager*) self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_set_top_window_group ((GalaWindowManager*) self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_NOTIFICATION_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_gala_set_notification_group (self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_set_background_group ((GalaWindowManager*) self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WORKSPACE_VIEW_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_set_workspace_view ((GalaWindowManager*) self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_ENABLE_ANIMATIONS_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_set_enable_animations ((GalaWindowManager*) self, g_value_get_boolean (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_SCREEN_SHIELD_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_gala_set_screen_shield (self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_gala_set_pointer_locator (self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_gala_set_screensaver (self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 28 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY:
#line 28 "../src/WindowManager.vala"
		gala_window_manager_gala_set_window_tracker (self, g_value_get_object (value));
#line 28 "../src/WindowManager.vala"
		break;
#line 16231 "WindowManager.c"
		default:
#line 28 "../src/WindowManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/WindowManager.vala"
		break;
#line 16237 "WindowManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 21 "../src/PluginManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 16248 "WindowManager.c"
		gssize i;
#line 21 "../src/PluginManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 21 "../src/PluginManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 21 "../src/PluginManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 16256 "WindowManager.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 21 "../src/PluginManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 21 "../src/PluginManager.vala"
	g_free (array);
#line 16271 "WindowManager.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 16285 "WindowManager.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 16289 "WindowManager.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 16293 "WindowManager.c"
}

